/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: docfg.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/docfg.c,v $
 */

#define GLOBAL extern
#define EXTERN

#include <sys/types.h>
#include <sys/timeb.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <fcntl.h>

#ifdef DOS
#include <dos.h>
#include <dir.h>
#include <io.h>
#endif

#include "dodefs.h"
#include "doglobal.h"
#include "domem.h"
#include "dostring.h"
#include "dofiles.h"
#include "doscr.h"
#include "dotext.h"
#include "dostern.h"
#include "dostat.h"
#include "doframe.h"
#include "dochoose.h"
#include "dohist.h"
#include "docfg.h"

/**********************************************************************/
/**********************************************************************/

#define TITLE_SIZE	128
#define DATE_SIZE	32
#define TIME_SIZE	16
#define HEAD_SIZE	32

#define INT             sizeof(int)
#define title_block     256
#define color_block     256            /* size of color block */
#define	files_block     16             /* file count */
#define	win_block       256            /* windows coordinates */
#define	helpline_block  16             /* helpline viewed */

/***********************************************************************/
/*	edit options 						       */
/***********************************************************************/

void MY_setup (MY_cfg_T config) 
{
  struct frame_t  * f;
  struct input_t  * in;
  struct log_t    * lg;
  char
    auto_str[]   = " Autosave   : ";
  int
    width = min( 50, max_x),
    x     = (max_x-width) /2,
    y,
    down,
    opt_cnt = 0,
    log_cnt = 1,
    i,
    j,
    line;

  /* options count */
  for (opt_cnt=0; opt_txt[opt_cnt] != NULL; opt_cnt++);
  
  down = opt_cnt+log_cnt+4;
  y    = (max_y-down)/2;
  
  f  = make_frame (x, y, width, down, " Setup ", leer, F_B_UTIL_CLR, NOMODE);
  
  view_frame (f);
  
  in = make_input (f, opt_cnt+log_cnt, CUR_MODE | FIL_MODE | INS_MODE);
  
  for(i=0; i<opt_cnt-1; i++)
    {
      input_string (in, i,
		    strlen (opt_txt [0]) + 3,
		    i + 1,
		    config->options [i],
		    OPT_LEN-2, OPT_LEN-2);
    }
  
  line = 1;
  for( i=0; i<opt_cnt-1; i++)
    {
      f_putstr (f, 2, line++, opt_txt[i], f->color, NOMODE);
    }
  
  /******************************************************** screen saver */
  f_putline (f, line++, f->color);
  f_putstr  (f, 2, line, opt_txt[opt_cnt-1], f->color, NOMODE);
  i = opt_cnt-1;
  input_int (in, i, strlen (opt_txt [i]) + 3, line, config->options [i], 4, 4);
  sprintf   (in->str[i], "%i", config->stern_timeout);
  f_putstr  (f, in->x[i] + 6, in->y[i], "Seconds", f->color, NOMODE);
  line++;
  f_putline ( f, line++, f->color);
  
  /******************************************************* for auto save */
  f_putstr  ( f, 1, line, auto_str, f->color, NOMODE);
  lg = make_log( f, 2, F_B_UTIL_CHS);
  log_format (lg, "X", " ");
  log_xy     (lg, strlen(auto_str) + 3, line, strlen(auto_str) + 3, line);
  line++;
  lg->pos   = ( config->auto_save ? 0 : 1);
  
  input_log (in, opt_cnt, lg);
  
  /************************************************************* choose **/
  view_frame (f);
  
  if (f_getstr (in) != ESC)
    {
  
      config->stern_timeout = atoi (in->str[opt_cnt-1]);
      if (config->stern_timeout >= 0)		/* "< 0" means no screen saver */
       {
         config->stern_timeout = max (10, config->stern_timeout);
       }
      config->auto_save = ( lg->pos == 0 ? TRUE : FALSE);
    }
  
  del_log    (lg);
  del_input  (in);
  hide_frame (f, HIDE_MODE | DELETE_MODE);
}


void save_config (MY_cfg_T config) 
{
  char tmp[257];
  int
    file_h,
    i, j,
    pos;
  
  /************************************************************* windows */
  for( i=0; i<config->win_cnt && w_[i] != NULL; i++) 
    {
      config->def_x       [i] = w_[i]->f->x;
      config->def_y       [i] = w_[i]->f->y;
      config->def_width   [i] = w_[i]->f->width-1;
      config->def_deep    [i] = w_[i]->f->down+1;
      config->def_outbegin[i] = w_[i]->long_outbegin;
      config->def_view    [i] = w_[i]->view_mode;
      config->def_anf_pos [i] = w_[i]->anf_pos;
      config->def_mode    [i] = w_[i]->f->mode;  /* viewed/hidden */
      
#ifdef DOS
      config->def_drive   [i] = w_[i]->drive;
#endif
      strcpy( config->def_path[i], w_[i]->path);
      strcpy( config->def_file[i], w_[i]->dr[w_[i]->akt_pos]->f);
    }
  
  file_h = open (config->cfg_file,
		 O_RDWR|O_BINARY|O_CREAT|O_TRUNC,
		 (get_rights () | 0100) /* read/write must be possible */
		 );
  if( file_h < 0) 
    {
      sprintf (tmp, " Error by opening config file <%s> ", config->cfg_file);
      message (tmp, " Save configuration  ");
      return;
    }
  write (file_h, config, sizeof( struct MY_cfg_t));
  close (file_h);
}

void read_config (MY_cfg_T config)
{
  struct timeb t;
  struct tm * t_ch;
  int  file_h,
  i,
  cfg_from_line = FALSE;
  char tmp[ 255], * p;
  char * old_file;
  
  XDEBUG2(" docfg 2 &cfg=[%p]\n", config);
  XDEBUG2(" docfg 3 cfg.max_file_cnt=[%i]\n", config->max_file_cnt);

  /******************************************* configuration file name */
  /************************* if -c option is set, use this config file */
  if( ( p = arg_get( "-c", argc_, argv_)) != NULL)
    
    {
      strcpy ( config->cfg_file, p);
      cfg_from_line = TRUE;
    }
  else
    
    {
#ifdef UNIX		/* def. name of config-file is "$HOME/.$TERM.cfg" */
      char * h,		/* Home */
      * t,		/* Terminal */
      * ext = ".cfg";	/* extensition */
      h = getenv ("HOME");
      t = getenv ("TERM");
      sprintf( config->cfg_file, "%s/.%s%s", h, t, ext); /* in the home dir. */
#else
      sprintf( config->cfg_file, "%s%s", prog_path, CFG_FILE);
#endif
    }
  old_file = getmem ( strlen (config->cfg_file) + 1) ;
  strcpy (old_file, config->cfg_file);
  
  file_h = open( config->cfg_file, O_RDONLY|O_BINARY);
  if( file_h > 0)
    
    {
      read  (file_h, config, sizeof(struct MY_cfg_t) );
      close (file_h);
    }
  else
    
    {
      /******************************************** default values of frames */
      /********************** view the message only when a different file is */
      /******************************************* given as the default file */
      if( cfg_from_line)
	{
	  fprintf( stderr,
		  " Cannot find configuration-file <%s>,"
		  " default values loaded ",
		  config->cfg_file);
	  fflush_();
	}
      
      /************************** init default values ************************/
      
      /************************************************************** Colors */
      set_colors();                /* def. colors */
      
      /********************************************************** file count */
      config->max_file_cnt = MAX_FILE_CNT;
      
      /************************************************************* windows */
      for( i=0; i<MAX_WIN; i++)
	{
	  config->def_x       [i] = (int) i<2 ? (( i % 2 == 0) ? 0 : max_x/2) : i;
	  config->def_y       [i] = (int) ( i<2 ? 1 : i);
	  config->def_width   [i] = (int) max_x / 2 - 1;
	  config->def_deep    [i] = (int) 11;
	  config->def_outbegin[i] = (int) 0;
	  config->def_view    [i] = (int) SIMPLE;
	  config->def_mode    [i] = (int) VIEW_MODE;
	  
	  config->def_x       [i] = (int) min( max_x - 10, config->def_x[i]);
	  config->def_y       [i] = (int) min( max_y -  9, config->def_y[i]);
	  config->def_width   [i] = (int) min( max_x-1-config->def_x[i], config->def_width[i]);
	  config->def_deep    [i] = (int) min( config->def_deep[i], max_y-config->def_y[i]-5);
	  config->def_anf_pos [i] = (int) 0;
	  
#ifdef DOS
	  config->def_drive   [i] = getdisk();
#endif
	  strcpy (config->def_path[i], ".");
	  strcpy (config->def_file[i], "..");
	}
      config->win_cnt = 2;
      config->akt_w   = 0;

      XDEBUG3 ("docfg win_cnt=[%i], akt_w=[%i]\n", config->win_cnt, config->akt_w);
      
      config->help_line_hidden  = FALSE;        /* help line status */
      
      /**************************** options, written only at the end of file */
      /************************************************************ Options **/
      for(i=0; i<OPT_CNT; i++)
	strcpy( config->options[i], options[i]);
      
      config->stern_timeout  = 15 * 60;	/* screen saver 15 seconds */
      config->auto_save      = FALSE;
      config->akt_w          = 0;
      
#ifdef NDEBUG
      fprintf( stderr, "load default values \n"); getchar();
#endif
    }
  
  config->stern_active   = FALSE;	/* screen saver */
  strcpy ( config->def_path[config->akt_w], "." );
  getpath( config->def_path[config->akt_w]      );
#ifdef DOS
  config->def_drive[config->akt_w] = getdisk();
#endif
  
  /*******************************************************title *********/
  strcpy( config->title, "Khamis Directories configuration file");
  
#ifdef HAVE_FTIME
  ftime ( &t);
  t_ch = localtime (&t.time);
#else
  t.time = time (NULL);
  t_ch = localtime (&t.time);
#endif

  sprintf( config->date, "%02i/%02i/%04i",
	  t_ch->tm_mon+1,
	  t_ch->tm_mday,
	  t_ch->tm_year + 1900);
  sprintf( config->time, "%02i:%02i:%02i",
	  t_ch->tm_hour,
	  t_ch->tm_min,
	  t_ch->tm_sec
	  );

  strcpy (config->edit_file, "");
  
  strcpy (config->cfg_file, old_file);
  Free (old_file);
}

