/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: dochoose.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/dochoose.c,v $
 */

#define GLOBAL extern
#define EXTERN

#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

#include "dodefs.h"
#include "doglobal.h"
#include "domem.h"
#include "dostring.h"
#include "doscr.h"
#include "docfg.h"
#include "dohist.h"
#include "dochoose.h"


/*   ************************************************************** */
/*   *****************  choose functions       ********************* */
/*   ************************************************************** */

struct choose_t * make_choose( struct frame_t * f, int cnt, int color,
		int mode)
{
  int i;
  struct choose_t * ch = getcmem (sizeof( struct choose_t));

  ch->f         = f;
  ch->chs_f     = NULL;		  /* choose balken */
  ch->chs_color = color;
  ch->inp_color = F_B_INPUT_CLR;    /* color for input string */
  ch->mode      = mode;
  ch->pos       = 0;
  ch->prog      = NULL;	/** programm-name **/
  ch->help      = " Use MOVE-keys to scroll, ENTER to select, F12 to abort ";

  if( cnt == 0)
    {
      ch->cnt = f->down;
      ch->x   = NULL;
      ch->y   = NULL;
      ch->len = NULL;
    }
  else
    {
      ch->cnt = cnt;
      i       = cnt * sizeof( int *);
      ch->x   = getmem (i);
      ch->y   = getmem (i);
      ch->len = getmem (i);
      for( i=0; i<cnt; i++)
	{
	  ch->x   [i] = 0;
	  ch->y   [i] = 0;
	  ch->len [i] = 0;
	}
    }
  return( ch);
}

void del_choose( struct choose_t * ch)
{
  if (ch->chs_f != NULL) hide_frame (ch->chs_f, HIDE_MODE|DELETE_MODE);
  if( ch->x   != NULL) Free( ch->x);
  if( ch->y   != NULL) Free( ch->y);
  if( ch->len != NULL) Free( ch->len);
  Free (ch);
}
	 
int f_choose (struct choose_t * ch)
{
  /**mode = NOWAIT_MODE: do not wait for keys **/
  /**mode = AUTO_MODE  : auto choose from end to first and opposite */
  /**mode = TERM_MODE  : Terminate bei CUR_LEFT | CUR_RIGHT **/
  /**mode = VERT_MODE  : Vertikal choose **/
  /**mode = LET_MODE   : don't change the last choose to normal color*/
  /**mode = BREAK_MODE : break by pressed any unknown key */
/*
  struct frame_t * chs_f = NULL;
*/
  struct frame_t * hlp;
  int
    end_ = FALSE,
    lk   = -1,
    xx   = cur_x,
    yy   = cur_y,
    x,
    y,
    i,
    len,
    j,
    cnt       = ( ch->cnt > 0 ? ch->cnt : ch->f->down),
    fr_viewed = ch->f->mode & VIEW_MODE,   /* frame viewed/hidden */
    fak       = ( ch->f->type & NOBOX_MODE ? 0 : 1); /* faktor */

  hide_cursor();

  if (ch->help != NULL)
    {
      hlp = make_help (ch->help, 0, max_y-1, max_x-1);
      view_frame (hlp);
    }

  ch->pos = max(0, ch->pos);
  while( TRUE)
    {

      x   = ( ch->x   != NULL ? max( fak, ch->x  [ ch->pos]) : fak);
      y   = ( ch->y   != NULL
	     ? max( fak, ch->y  [ ch->pos])
	     : ch->pos + fak);
      len = ( ch->len != NULL && ch->len[ ch->pos] > 0
	     ? min( ch->f->width-x-fak, ch->len[ ch->pos])
	     : ch->f->width - x - fak);

      if( fr_viewed)
	{
	  if (ch->prog  != NULL) ch->prog   (ch->pos);  /* run akt. program */
	  if (ch->chs_f != NULL) hide_frame (ch->chs_f, HIDE_MODE|DELETE_MODE);
	  ch->chs_f = make_frame( ch->f->x+x,
				 ch->f->y+y,
				 len, 1,
				 leer, leer,
				 ch->chs_color,
				 NOBOX_MODE);
	  for ( i=0, j=f_pos(ch->f, x, y); i<len; i++, j++)
	    {
	      ch->chs_f->chr [i] = ch->f->chr [j];
	      ch->chs_f->attr[i] = ch->chs_color;
	    }
	  view_frame (ch->chs_f);
	}

      fflush_();

      if( ch->mode & NOWAIT_MODE) break;
      
      if (ch->mode & TYPE_STRING)
	{
	  gotoxy_( xx, yy);
	  lk = get_str(NULL,
		       xx,
		       yy,
		       ch->str, ch->strlen, ch->inplen, ' ',
		       NULL,
		       ch->inp_color,
		       ch->mode);
	  xx = cur_x, yy = cur_y;
	  end_ = TRUE;
	}
      else lk = getkey(-1);

      if( ! end_)
	switch( lk)
	  {
	  case ENTER:
	  case CTRL_M:
	  case ESC:
	    end_ = TRUE;
	    break;
	  case CUR_UP:
	  case CUR_LEFT:
	    if (lk == CUR_LEFT && ! ( ch->mode & VERT_MODE) ||
		lk == CUR_UP   && ch->mode & VERT_MODE
		) end_ = TRUE;
	    if (! end_)
	      {
		if( ch->pos == 0 &&
		   ! ( ch->mode & AUTO_MODE)) end_ = TRUE;
		else ch->pos = ( cnt + ch->pos - 1) % cnt;
	      }
	    break;
	  case CUR_DOWN:
		case CUR_RIGHT:
	  case ' ':
	    if (lk == CUR_RIGHT  && ! ( ch->mode & VERT_MODE) ||
		lk == CUR_DOWN   && ch->mode & VERT_MODE
		) end_ = TRUE;
	    if( ! end_)
	      {
		if ((ch->pos == cnt - 1) &&
		    ! (ch->mode & AUTO_MODE))
		  end_ = TRUE;
		else ch->pos = ( ch->pos + 1) % cnt;
	      }
	    break;
	  case PAGE_UP:
	    if (ch->pos == 0 &&
		! (ch->mode & AUTO_MODE)) end_ = TRUE;
	    else ch->pos  = 0;
	    break;
	  case PAGE_DOWN:
	    if ((ch->pos == cnt - 1) &&
		! (ch->mode & AUTO_MODE))
	      end_ = TRUE;
	    else ch->pos = cnt - 1;
	    break;
	  default:
	    if (ch->mode & TYPE_STRING) end_ = TRUE;
	    if (ch->mode & BREAK_MODE ) end_ = TRUE;
	    break;
	  }
      
      if( end_) break;
      
    }  /* while true **/
  
  if( ch->chs_f != NULL)
    {
      if ( (ch->mode & LET_MODE) == 0)
	{
	  hide_frame (ch->chs_f, HIDE_MODE | DELETE_MODE);
	  ch->chs_f = NULL ;
	}
    }

  if (ch->help != NULL) hide_frame (hlp, HIDE_MODE|DELETE_MODE);

  if( ch->mode & TYPE_STRING) gotoxy_( xx, yy);

  return( lk);
}

int ch_text( char * event[], int x, int y, int width, int down, int * pos,
	     char * t1, char * t2,
	     int color,
	     int chs_color,
	     int mode)
{

  /** mode = CENTER_MODE : middle of the window **/
  /** mode = CHOOSE_AUTO : auto scroll          **/

  struct frame_t  * f, * hlp;
  struct choose_t * ch;
  char 
    hlp_text [] = 
      "PgDn/Up:Next/Prev Page#CrDn/Up:Next/Prev Line#Esc/Enter:End";
  int
    lk = 0,
    i  = 0,
    end_ = FALSE,
    refr = TRUE,
    f_down,
    first_line = 0,
    ev_count = 0,
    ev_width = 0;

  for( i=0; event[ i] != NULL; i++)
    {
      ev_count++;
      ev_width = max( ev_width, strlen (event [i]));
    }

  ev_width = min (max (width,ev_width+2), max_x);
  f_down   = min (max_y-y-1, min (down+2, ev_count+2));
  * pos    = min (*pos, ev_count-1);

  if( mode & CENTER_MODE)     /* center the frame on the middle of window */
    {
      x = (max_x-ev_width) / 2;
      y = (max_y-  f_down) / 2;
    }

  hlp     = make_help  (hlp_text, 0, max_y-1, max_x-1);
  f       = make_frame (x, y, ev_width, f_down, t1, t2,
			color,
			SCROLL_RIGHT_MODE);
  view_frame (hlp);

  ch      = make_choose( f, 0, chs_color, NOMODE);
  choose_help (ch, NULL);			/* disable def. help line */
  ch->pos = min( f->down-1, * pos);

  while( lk != ENTER && lk != CTRL_M && lk != ESC)
    {
      if( refr)
	{
	  if( * pos < first_line) first_line = *pos;
	  else first_line = max ( 0 , * pos - f->down + 1);

	  for( i=0; i<f->down && event[ i] != NULL; i++)
	    {
	      f_putstr( f, 1, i+1, event[first_line+i], f->color, FILL_MODE);
	    }
	  view_frame( f);
	  refr = FALSE;
	}

      f_reposition (f, *pos, ev_count-1, SCROLL_RIGHT_MODE);

      *pos -= ch->pos;
      lk    = f_choose( ch);
      *pos += ch->pos;		/* selected position */

      switch( lk)
	{
	case CUR_DOWN:
	  if (*pos >= ev_count-1)
	    {
	      if( mode & AUTO_CHOOSE) *pos = 0, ch->pos =0;
	      else break;
	    }
	  else (* pos) ++;
	  refr = TRUE;
	  break;
	case CUR_UP:
	  if ( *pos <= 0)
	    {
	      if( mode & AUTO_CHOOSE) *pos = ev_count-1, ch->pos =f->down-1;
	      else break;
	    }
	  else (* pos) --;
	  refr = TRUE;
	  break;
	case PAGE_DOWN:
	  * pos = min (ev_count - 1, * pos + f->down - 1);
	  refr = TRUE;
	  break;
	case PAGE_UP:
	  * pos = max (0, * pos - f->down + 1);
	  refr = TRUE;
	  break;

	case HOME:
	  *pos = ch->pos = 0;	  
	  refr = TRUE;
	  break;
	  
	case END:
	  *pos = ev_count - 1;
	  ch->pos = f->down - 1;
	  refr = TRUE;
	  break;
	  
	case ENTER:
	case CTRL_M:
	case ESC:
	  end_ = TRUE;
	  break;
	}
      if( end_) break;
    }
  
  del_choose (ch);
  hide_frame (f, HIDE_MODE | DELETE_MODE);
  hide_frame (hlp, HIDE_MODE | DELETE_MODE);
  return( lk);
} /* ev-chs **/

/*   ************************************************************** */
/*   *****************  input/getstr functions ******************** */
/*   ************************************************************** */

struct input_t * make_input ( struct frame_t * f, int cnt, int mode)
{
  struct input_t * p;
  int
    sz     = cnt * sizeof(int),
    i;
  
  p          = getcmem (sizeof (struct input_t));
  p->f       = f;
  p->prog    = NULL;
  p->getfromlist = getmem( cnt * sizeof(void*));
  p->ptr     = (void**) getmem( cnt * sizeof(void*));
  p->cnt     = cnt;
  p->pos     = 0;
  p->x       = getmem (sz);
  p->y       = getmem (sz);
  p->color   = getmem (sz);
  p->type    = getmem (sz);
  p->str_len = getmem (sz);
  p->inp_len = getmem (sz);
  p->str     = p->save_str = getmem( cnt * sizeof(char *));
  p->mode    = mode | BREAK_MODE;
  p->help    = " Enter the data or press F12 to abort ";
  
  for(i=0; i<cnt; i++)
    {
      p->ptr    [i] = NULL;
      p->x      [i] = 0;
      p->y      [i] = 0;
      p->color  [i] = F_B_INPUT_CLR;
      p->type   [i] = TYPE_STRING;
      p->str_len[i] = 0;
      p->inp_len[i] = 0;
    }
  return( p);
}

void del_input ( struct input_t * in)
{
  Free( in->getfromlist);
  Free( in->ptr);
  Free( in->x);
  Free( in->y);
  Free( in->color);
  Free( in->type);
  Free( in->str_len);
  Free( in->inp_len);
  Free( in->save_str);
  Free( in);
}

input_T input_attributes (input_T in, int pos, int x, int y, 
			  char * str,
			  int str_len,
			  int inp_len,
			  int type
			  )
{
  in->type    [pos] = type;
  in->x	      [pos] = x;
  in->y       [pos] = y;
  in->inp_len [pos] = min (inp_len, in->f->width - in->x[pos] - 2);
  in->str_len [pos] = str_len;
  in->str     [pos] = str;
  return in;
}

input_T input_log (input_T in, int pos, log_T lg)
{
  in->type [pos] = TYPE_LOG;
  in->ptr  [pos] = (void *) lg;
  return in;
}

/*****************************************************************************/
/*		programs to get logical input-variables in the f_getstr     **/
/*****************************************************************************/

struct log_t * make_log( struct frame_t * f, int cnt, int chs_color)
{
  struct log_t * lg = getmem( sizeof(struct log_t));
  int i, size = cnt * sizeof(int);
  
  lg->f       = f;
  lg->cnt     = cnt;
  lg->fmt     = getmem(cnt * sizeof(char *));
  lg->x       = getmem(size);
  lg->y       = getmem(size);
  lg->color   = getmem(size);
  lg->chs_clr = chs_color;
  
  for(i=0; i<cnt; i++)
    {
      lg->fmt  [i]   = NULL;
      lg->x    [i]   = 1;
      lg->y    [i]   = 1;
      lg->color[i]   = f->color;
    }
  
  lg->fill_c = ' ';
  lg->pos    = 0;
  lg->mode   = NOMODE;
  
  return( lg);
}

void del_log( struct log_t * lg)
{
  Free( lg->fmt);
  Free( lg->x);
  Free( lg->y);
  Free( lg->color);
  Free( lg);
}

int log_format (log_T lg, ...)
{
  char * frmt;
  int i;
  va_list ap;
  va_start (ap, lg);
  for ( i=0; i<lg->cnt && (frmt = va_arg(ap, char *)) != 0; i++)
    {
      lg->fmt [i] = frmt;
    }
  va_end (ap);
  return TRUE;
}

/* x and y are together 
 */
int log_xy (log_T lg, ...)
{
  int x, y, i;
  va_list ap;
  va_start (ap, lg);
  for (i=0;
       i<lg->cnt
       && (x = va_arg(ap, int)) != 0
       && (y = va_arg(ap, int)) != 0;
       i++)
    {
      if (x >= 0)
	lg->x [i] = x;
      else 
	{
	  int j = lg->f->width / lg->cnt;
	  lg->x [i] = j * i + (j - strlen (lg->fmt [i]) ) / 2;
	}
      lg->y [i] = y;
    }
  return TRUE;
}

/* program to get the logical input */

int f_getlog (struct log_t * lg, int mode)
{

    /* NOWAIT_MODE : display the logical field and terminate */

    int end_ = mode & NOWAIT_MODE, /* terminate if nowait modus */
	lk   = -1,
	i,
	j;

    while( TRUE) {

	if( lg->cnt == 2 && lg->x[0] == lg->x[1]) i = lg->pos, j = i+1;
	else i=0, j = lg->cnt;

	for( ; i<j; i++) {
	    f_putstr( lg->f, lg->x[i]-1, lg->y[i],
		      i==lg->pos ? "[" : " ",
		      i==lg->pos && ! end_ ? lg->chs_clr : lg->f->color,
		      SCR_MODE);
	    f_putstr( lg->f,
		      lg->x[i],
		      lg->y[i],
		      lg->fmt[i],
		      i==lg->pos && ! end_ ? lg->chs_clr : lg->color[i],
		      SCR_MODE);
	    f_putstr( lg->f,
		      lg->x[i]+strlen(lg->fmt[i]),
		      lg->y[i],
		      i==lg->pos ? "]" : " ",
		      i == lg->pos && ! end_ ? lg->chs_clr : lg->f->color,
		      SCR_MODE);
	    }

	if( end_) break;

	lk = getkey(-1);

	switch( lk) {
	    case SPACE:
	    case CUR_RIGHT:
		lg->pos = (lg->pos+1) % lg->cnt;
		break;
	    case CUR_LEFT:
		lg->pos = (lg->pos + lg->cnt - 1) % lg->cnt;
		break;
	    case ENTER:
	    case CTRL_M:
		end_ = TRUE;
		break;
	    case ESC:
		lg->pos = 1;
		end_ = TRUE;
		break;
	    case TAB:
	    case BACK_TAB:
	    case CUR_UP:
	    case CUR_DOWN:
		end_ = TRUE;
		break;
	    }
	}
    return( lk);
}

/************************************************************************/
/*        global input program for strings, integer, logical and values */
/************************************************************************/

int f_getstr (struct input_t * in) {
  frame_T hlp;
  int i, j, lk = 0;

  if (in->help != NULL) 
    {
      hlp = make_help (in->help, 0, max_y-1, max_x-1);
      view_frame (hlp);
    }
  for(i=0; i<in->cnt; i++)
    {
      if( in->type[i] & TYPE_LOG)
	f_getlog( (struct log_t *) in->ptr[i], NOWAIT_MODE);
      else get_str(in->f,
		   in->x[i],
		   in->y[i],
		   in->str[ i], 
		   in->str_len[ i], 
		   in->inp_len[ i], 
		   '_',
		   in->getfromlist[in->pos],
		   in->color[i],
		   NOWAIT_MODE);
      
      if (in->prog != NULL) in->prog( i);
    }
  
  while( lk != ENTER && lk != CTRL_M && lk != ESC)
    {
	if( in->prog != NULL) in->prog( in->pos);
	
	/* from type logical */
	if( in->type[in->pos] & TYPE_LOG)
	  lk = f_getlog( (struct log_t *) in->ptr[ in->pos], NOMODE);
	
	else lk = get_str( 
			  in->f,
			  in->x[in->pos],
			  in->y[in->pos],
			  in->str[ in->pos],
			  in->str_len[ in->pos], in->inp_len[ in->pos],
			  '_',
			  in->getfromlist[in->pos],
			  in->color[in->pos],
			  in->mode | in->type[in->pos]
			  );
	
	switch( lk)
	  {
	  case CUR_UP:
	  case BACK_TAB:
	    in->pos = ( in->cnt + in->pos - 1) % in->cnt;
	    break;

	  case CUR_DOWN:
	  case TAB:
	    in->pos = ( in->pos + 1) % in->cnt;
	    break;

	  case ENTER:		/* end the input */
	  case CTRL_M:
/*
	    if( in->pos == in->cnt - 1) break;
	    else
	      {
	        in->pos ++;
	        lk = -1;
	      }
*/
	    break;
	  }
      }
  
  if (in->help != NULL) hide_frame (hlp, HIDE_MODE|DELETE_MODE);
  
  return( lk);
}

