/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: dochoose.h,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/dochoose.h,v $
 */

/***********************  choose functions *******************************/

#ifndef GLOBAL
#define GLOBAL
#endif

#ifndef DOCHOOSE_HH
#	define DOCHOOSE_HH

#include "doframe.h"

#define CENTER_MODE	0x0001				/* ch_text */
#define AUTO_CHOOSE	0x0002				/* ch_text */

struct input_t
{
  struct frame_t * f;
  void ** ptr;
  int
    pos,    		/* the position number at first time */
    cnt,    		/* count of inputs */
    * x,    		/* x-coord. for every string input */
    * y,    		/* y-coord. for every string input */
    * color, 		/* color for every input */
    * type, 		/* type of string */
    * str_len,  	/* the length for every string */
    * inp_len;  	/* the length of input for every string */
  void ( *         prog) ( int);          /* calls a program to run */
  int  ( ** getfromlist) ( char *);       /* to call a program to select */
						/* a string from list */
  char
    ** str,                            /* the strings to save */
    ** save_str,          /* to save the pointer for str to free str */
    *  help;		/* Help string to view on help line */
  int mode;                                                     /* mode */
};

typedef struct input_t * input_T;

struct choose_t
{
  struct frame_t * f;
  struct frame_t * chs_f;
  int
    pos,
    * x,
    * y,
    cnt,
    * len;
  int
    chs_color,                  /* choose color */
    inp_color,                  /* color for input */
    mode,
    strlen,
    inplen;
  char * str;
  void ( * prog) ( int);
  char * help;		/* help string to view on help line */
};

typedef struct choose_t * choose_T;

struct log_t
{
  struct frame_t * f;
  char ** fmt,          /* the text for the values */
  fill_c;          /* fill character to use   */
  int pos,
  cnt,              /* count of fields */
  * x    ,
  * y    ,
  * color,          /* colors for every box */
  chs_clr,
  mode;
  char * help; 		/* help string to view on help line */
};

typedef struct log_t * log_T;

GLOBAL struct choose_t * make_choose (struct frame_t * f,
				      int cnt,
				      int color,
				      int mode);
GLOBAL void   del_choose      ( struct choose_t * ch);
GLOBAL int    f_choose        ( struct choose_t * ch);
		               /* push choose forwardes or backwardes */
GLOBAL void   f_scroll_choose ( struct choose_t * ch, int n, int mode);  

GLOBAL int    ch_text	      (char * event[],
			       int x, int y,
			       int width, int down, 
			       int * pos,
			       char * t1, char * t2,
			       int color,
			       int chs_color,
			       int mode);

#define choose_help(ch, hlp) (ch)->help = (hlp)

/********************* input functions *************************/

struct input_t * make_input   (struct frame_t * f,
			       int cnt,
			       int mode);
void    del_input    (struct input_t * in);
int     f_getstr     (struct input_t * in);
input_T input_attributes (input_T in, int pos, int x, int y, 
			  char * str,
			  int str_len,
			  int inp_len,
			  int type
			  );
input_T input_int    (input_T in, int pos, int x, int y,
		      char * str,
		      int str_len,
		      int inp_len
		      );

#define input_string(in, p, x, y, s, sl, il) input_attributes \
		    (in, p, x, y, s, sl, il, TYPE_STRING)
#define input_int(in, p, x, y, s, sl, il) input_attributes \
		 (in, p, x, y, s, sl, il, TYPE_INT)
#define input_hexa(in, p, x, y, s, sl, il) input_attributes \
		  (in, p, x, y, s, sl, il, TYPE_HEXA)

#define input_help(in, hlp) (in)->help = (hlp)

input_T input_log (input_T in, int pos, log_T lg);
#define input_setpos(in, num) (in)->pos = (num)
#define input_pos(in) (in)->pos

/***************** logical functions */
struct log_t * make_log (struct frame_t * f,
			 int cnt,
			 int chs_color);
void   del_log      (struct log_t * lg);
int    f_getlog     (struct log_t * lg, int mode);
int    log_format   (log_T lg, ...);
int    log_xy       (log_T lg, ...);

#define log_setpos(lg, num) (lg)->pos = (num)
#define log_pos(lg) (lg)->pos

#endif    /*DOCHOOSE_HH*/

