/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: docopy.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/docopy.c,v $
 */

#ifdef UNIX		/* UNIX ONLY */

#define GLOBAL extern
#define EXTERN

#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <sys/timeb.h>
#include <fcntl.h>
#include <string.h>

#ifdef DOS
#include <process.h>
#include <io.h>
#include <conio.h>
#include <ctype.h>
#endif

#include "dodefs.h"
#include "doglobal.h"
#include "doerror.h"
#include "docfg.h"
#include "dotext.h"
#include "dostring.h"
#include "domem.h"
#include "domenu.h"
#include "dowin.h"
#include "doutil.h"
#include "dostat.h"
#include "dolib.h"
#include "dofiles.h"
#include "doscr.h"

#include "docopy.h"

#define ILEN    	128
#define STR_CNT    	2
#define INT_CNT		1
#define INT_BEG		2
#define LOG_CNT    	1
#define LOG_BEG    	3


int copy_device (char * src, char * dest, int buflen)
{
  struct frame_t * f; 
  int src_d, dest_d, len = 0, w_len = 0, wrt = 0;
  char * buf ;
  char tmp [64] ;
  int	width        = min(30, max_x),
	down	     = min(5, max_y),
	x	     = (max_x-width)/2,
	y	     = min ((max_y-down)/2 + 5, max_y-down-2);

  src_d  = open (src, O_RDONLY) ;
  if (src_d < 0)
    {
      message ("Cann't open source file", " Hard Copy ");
      return -1;
    }

  dest_d = open (dest, O_WRONLY|O_CREAT|O_TRUNC, get_rights ()) ;
  if (dest_d < 0) 
    {
      close (src_d) ;
      message ( "Cann't open destination", " Hard Copy ") ;
      return -1;
    }

  f = make_frame (x, y, width, down, 
		  " Coping by ",
		  leer,
		  F_B_UTIL_CLR, NOMODE
		  );
  view_frame (f); fflush_() ;

  buf = getmem (buflen); 
  for ( ; len = read (src_d, buf, buflen); )
    {
      if (len < 0) 
	{
	  message ("Error by reading from source file", " Hard Copy ");
	  break ;
	}
      if (len == 0) break ;
      
      w_len = write (dest_d, buf, len) ;
      if (w_len != len)
	{
	  message ("Error by writing to destination file", " Hard Copy ");
	  break ;
	}

      wrt += w_len ;
      sprintf (tmp, "Writen : [%i] Bytes", wrt);
      f_putstr (f, 2, 2, tmp, f->color, SCR_MODE); fflush_() ;
    }

  hide_frame (f, DELETE_MODE|HIDE_MODE);
  Free  (buf);
  close (src_d);
  close (dest_d);
}

void device_copy (void)
{
  struct frame_t *f;                      /* frame building */
  struct input_t * in;                    /* input struct */
  struct log_t   * lg [LOG_CNT];          /* logical input */

  int	end	     = FALSE,
	width        = min(60, max_x),
	down	     = min(6+STR_CNT+LOG_CNT+INT_CNT, max_y),
	x	     = (max_x-width)/2,
	y	     = (max_y-down)/2,
	i, l, j,
	ok_line,
	blocksize    = 1024;
  char
    src      [ILEN] = { 0 },
    dest     [ILEN] = { 0 },
    blockstr   [20] = { 0 };
  char	tmp  [100];

  f     = make_frame (x, y, width, down,
		      " Hard Copying <Devices> ",
		      leer,
		      F_B_UTIL_CLR,
		      NOMODE
		      );

  in = make_input (f,
		   STR_CNT+LOG_CNT+INT_CNT,
		   CUR_MODE | FIL_MODE | INS_MODE
		   );

  l = 2;   f_putstr ( f, 2, l, "Device     :", f->color, NOMODE);
  l += 2;  f_putstr ( f, 2, l, "Destination:", f->color, NOMODE);
  l += 2;  f_putstr ( f, 2, l, "Blocksize  :", f->color, NOMODE);
  l ++;    f_putline( f, l, f->color);
  l ++;

  ok_line = l;

				/* logical field to ask <break or continue>*/
  lg[0]       = make_log( f, 2, F_B_UTIL_CHS);
  log_format (lg[0], cont_break[0], cont_break[1]);
  log_xy     (lg[0], -1, ok_line, -1, ok_line);

  input_string (in, 0, 15, 2, src,      ILEN-2, ILEN-2);
  input_string (in, 1, 15, 4, dest,     ILEN-2, ILEN-2);

  input_int    (in, 2, 15, 6, blockstr, 12, 12);
  strcpy  (blockstr, "1024");

  for(i=0; i<LOG_CNT; i++)
    {
      input_log (in, i+LOG_BEG, lg [i]);
    }

  view_frame (f);		/* view the question frame */

  if (f_getstr (in) == ESC) end = TRUE;   /* choose the options */

  if (end != TRUE)
    {
      blocksize = atoi (blockstr) ;
      if (copy_device (src, dest, blocksize) == 0)
	{
	  message (" hard copying finished ", leer);
	}
    }

  hide_frame (f, DELETE_MODE|HIDE_MODE);
}

#endif /* UNIX */
