/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: dodefs.h,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/dodefs.h,v $
 */

#ifndef DODEFS_HH
#	define DODEFS_HH

#if defined (UNIX)

#ifdef SCO_UNIX
#include <tinfo.h>		/* KEY_NUMBER is defined in this file */
#include <sys/param.h>
#include <sys/stat.h>
#endif

#ifdef UnixWare
#include <limits.h>
#endif

#include <sys/param.h>

#endif

#include <fcntl.h>

#ifdef DOS
#include <dir.h>
#endif

/*+*/
#ifndef TRUE
#	define TRUE 1
#endif
#ifndef FALSE
#	define FALSE 0
#endif

#ifndef MAXPATH
#ifdef MAXPATHLEN
#	define MAXPATH MAXPATHLEN
#elif defined (PATH_MAX)
#	define MAXPATH PATH_MAX
#elif defined (PATHSIZE)
#	define MAXPATH PATHSIZE
#else
#error MAXPATH is undefined, seted to 1024
#	ifdef UNIX
#	   define	MAXPATH		1024
#	else
#	   define	MAXPATH		512
#	endif
#endif
#endif

#if defined( DOS) && ! defined( ushort)
#	define ushort          unsigned short
#endif

#ifndef O_BINARY
#	define O_BINARY        0x0000
#endif

#ifdef DEBUG_FREE
#define Free(p) { if (p == NULL) {\
		    fprintf (stderr, "Error in Free, Null Pointer\n"); \
		    getch();\
		    }\
		  else { free (p); p = NULL; }\
		}
#else
#define Free(p) free (p)
#endif

#ifdef  XDEBUG
#define XDEBUG1(x         ) fprintf(stderr, x)
#define XDEBUG2(x, y      ) fprintf(stderr, x, y)
#define XDEBUG3(x, y, z   ) fprintf(stderr, x, y, z)
#define XDEBUG4(a, b, c, d) fprintf(stderr, a, b, c, d)
#define XDEBUG5(a, b, c, d, e) fprintf(stderr, a, b, c, d, e)
#else
#define XDEBUG1(x         )
#define XDEBUG2(x, y      )
#define XDEBUG3(x, y, z   )
#define XDEBUG4(a, b, c, d)
#define XDEBUG5(a, b, c, d, e)
#endif

/*+*/

#define CFG_FILE 	"khdir.cfg"

#define NOMODE          0x0000

#define SELECT_MODE     0x0020  /* for select procedure */
#define UNSELECT_MODE   0x0040  /* for select procedure */

#define READ_MODE       0x4000
#define OUT_MODE        0x8000

#define VIEW_HELP_MODE  0x0100
#define VIEW_INS_MODE   0x0200

#define NO_NULL         0x0800
#define TE_NULL         0x1000

#define STATUS          0x0100
#define CHOOSE_MODE     0x0400

#define END_OF_FILE     0x0200

#define BREAK_MODE      0x0001
#define HIST_MODE       0x0002  /* History mode for get_str **/
#define CUR_MODE        0x0004
#define COM_MODE        0x0008
#define FIL_MODE        0x0010
#define NOWAIT_MODE     0x0020
#define EXTRA_MODE      0x0040
#define INS_MODE        0x0080
#define AUTO_MODE       0x0100
#define VERT_MODE       0x0200
#define TERM_MODE       0x0400
#define LET_MODE        0x0800

#define RECURSIVE_MODE  0x0010  /* recursive remove mode */
#define ABORT_MODE      0x0020  /* abortmode for recursive remover */
#define OVERWRITE_MODE  0x0010  /* for copy command to overwrite existing files */


#define FILE_NAME       0x0001  /* Sortmethode as name */
#define CREATE_TIME     0x0002  /* sort after create time */
#define MODIFY_TIME     0x0004  /* use mod time to sort */
#define ASSECC_TIME     0x0008  /* use assecc time to sort */
#define FILE_SIZE       0x0010
#define UNSORTED        0x0020
#define FILE_LINKS      0x0040
#define FILE_INODE      0x0080
#define FILE_USER       0x0100  /* sort after user id */
#define FILE_GROUP      0x0200  /* sort after group id */
#define FILE_USER_NAME  0x0400  /* sort after user name */
#define FILE_GROUP_NAME 0x0800  /* sort after group name */
#define DIR_FIRST       0x1000  /* move directories to the top of files */
#define DESCENDING      0x8000  /* descending or ascending */

#define SAVE_SCREEN     0x0001  /* to save the screen momery before runing */

#define STD_IN          0
#define STD_OUT         1

#ifdef UNIX
#       define MAX_FILE_CNT    400         /* max. files in one window */
#else
#       define MAX_FILE_CNT    250
#endif

#define MAX_WIN         10         /* the maximum of windows count */
#define ETC_KEY_NUM_LEN 5          /* the key number length */
#define M_SRCH_COL      19         /* max. width for search of files */
#define COMLINE_Y       (max_y-2)  /* the command-line-row **/
#define MENU_COUNT      4

#define ESC             0x1B
#define SPACE           ' '
#define ENTER           CTRL_J

/*+*/
#ifdef UNIX
#	define CTRL_A          0x0001
#	define CTRL_B          0x0002
#	define CTRL_C          0x0003
#	define CTRL_D          0x0004
#	define CTRL_E          0x0005
#	define CTRL_F          0x0006
#	define CTRL_G          0x0007
#	define CTRL_H          0x0008
#	define CTRL_I          0x0009
#	define CTRL_J          0x000A
#	define CTRL_K          0x000B
#	define CTRL_L          0x000C
#	define CTRL_M          0x000D
#	define CTRL_N          0x000E
#	define CTRL_O          0x000F
#	define CTRL_P          0x0010
#	define CTRL_Q          0x0011
#	define CTRL_R          0x0012
#	define CTRL_S          0x0013
#	define CTRL_T          0x0014
#	define CTRL_U          0x0015
#	define CTRL_V          0x0016
#	define CTRL_W          0x0017
#	define CTRL_X          0x0018
#	define CTRL_Y          0x0019
#	define CTRL_Z          0x001A

#	define TAB             CTRL_I
#	define BACKSPACE       CTRL_H

#	define DELETE          0x7f

#	define BACK_TAB        1001
#	define F1              1002
#	define F2              1003
#	define F3              1004
#	define F4              1005
#	define F5              1006
#	define F6              1007
#	define F7              1008
#	define F8              1009
#	define F9              1010
#	define F10             1011
#	define CUR_UP          1012
#	define CUR_DOWN        1013
#	define CUR_LEFT        1014
#	define CUR_RIGHT       1015
#	define PAGE_UP         1016
#	define PAGE_DOWN       1017
#	define END             1018
#	define INSERT          1019
#	define HOME            1020
#	define REMOVE          1021

#	define	ESC_a           7001
#	define	ESC_b           7002
#	define  ESC_c           7003
#	define  ESC_d           7004
#	define	ESC_e           7005
#	define  ESC_f           7006
#	define  ESC_g           7007
#	define	ESC_h           7008
#	define  ESC_i           7009
#	define  ESC_j           7010
#	define	ESC_k           7012
#	define  ESC_l           7013
#	define  ESC_m           7014
#	define	ESC_n           7015
#	define  ESC_o           7016
#	define  ESC_p           7017
#	define	ESC_q           7018
#	define  ESC_r           7019
#	define  ESC_s           7020
#	define	ESC_t           7021
#	define  ESC_u           7022
#	define  ESC_v           7023
#	define	ESC_w           7024
#	define  ESC_x           7025
#	define  ESC_y           7026
#	define	ESC_z           7027
#	define	ESC_A           7028
#	define  ESC_B           7029
#	define  ESC_C           7030
#	define	ESC_D           7031
#	define  ESC_E           7032
#	define  ESC_F           7033
#	define	ESC_G           7034
#	define  ESC_H           7035
#	define	ESC_I           7036
#	define	ESC_J           7037
#	define	ESC_K           7038
#	define	ESC_L           7039
#	define	ESC_M           7040
#	define	ESC_N           7041
#	define	ESC_O           7042
#	define	ESC_P           7043
#	define	ESC_Q           7044
#	define	ESC_R           7045
#	define	ESC_S           7046
#	define	ESC_T           7047
#	define	ESC_U           7048
#	define	ESC_V           7049
#	define	ESC_W           7050
#	define	ESC_X           7051
#	define	ESC_Y           7052
#	define	ESC_Z           7053
#else

/* DOS KEYS */

#	define  KEY_DC                 300
#	define  KEY                    300

#	define  REMOVE                 KEY_DC
#	define  TAB                    9
#	define  SPACE                  ' '
#	define  CTRL_A                 1
#	define  CTRL_B                 2
#	define  CTRL_C                 3
#	define  CTRL_D                 4
#	define  CTRL_E                 5
#	define  CTRL_F                 6
#	define  CTRL_G                 7
#	define  BACKSPACE              8
#	define  TAB                    9
#	define  CTRL_I                 9
#	define  CTRL_J                 10
#	define  CTRL_K                 11
#	define  CTRL_L                 12
#	define  CTRL_M                 13
#	define  CTRL_N                 14
#	define  CTRL_O                 15
#	define  CTRL_P                 16
#	define  CTRL_Q                 17
#	define  CTRL_R                 18
#	define  CTRL_S                 19
#	define  CTRL_T                 20
#	define  CTRL_U                 21
#	define  CTRL_V                 22
#	define  CTRL_W                 23
#	define  CTRL_X                 24
#	define  CTRL_Y                 25
#	define  CTRL_Z                 26
#	define  CTRL__                 31
#	define  SHIFT_TAB              (KEY+1 )
#	define  BACK_TAB               (KEY+2 )
#	define  ALT_W                  (KEY+3 )
#	define  ALT_E                  (KEY+4 )
#	define  ALT_R                  (KEY+5 )
#	define  ALT_T                  (KEY+6 )
#	define  ALT_Z                  (KEY+7 )
#	define  ALT_U                  (KEY+8 )
#	define  ALT_I                  (KEY+9 )
#	define  ALT_O                  (KEY+10)
#	define  ALT_P                  (KEY+11)
#	define  ALT_A                  (KEY+12)
#	define  ALT_S                  (KEY+13)
#	define  ALT_D                  (KEY+14)
#	define  ALT_F                  (KEY+15)
#	define  ALT_G                  (KEY+16)
#	define  ALT_H                  (KEY+17)
#	define  ALT_J                  (KEY+18)
#	define  ALT_K                  (KEY+19)
#	define  ALT_L                  (KEY+20)
#	define  ALT_Y                  (KEY+21)
#	define  ALT_X                  (KEY+22)
#	define  ALT_C                  (KEY+23)
#	define  ALT_V                  (KEY+24)
#	define  ALT_B                  (KEY+25)
#	define  ALT_N                  (KEY+26)
#	define  ALT_M                  (KEY+27)
#	define  F1                     (KEY+28)
#	define  F2                     (KEY+29)
#	define  F3                     (KEY+30)
#	define  F4                     (KEY+31)
#	define  F5                     (KEY+32)
#	define  F6                     (KEY+33)
#	define  F7                     (KEY+34)
#	define  F8                     (KEY+35)
#	define  F9                     (KEY+36)
#	define  F10                    (KEY+37)
#	define  HOME                   (KEY+38)
#	define  CUR_UP                 (KEY+39)
#	define  PAGE_UP                (KEY+40)
#	define  CUR_LEFT               (KEY+41)
#	define  CUR_RIGHT              (KEY+42)
#	define  END                    (KEY+43)
#	define  CUR_DOWN               (KEY+44)
#	define  PAGE_DOWN              (KEY+45)
#	define  INSERT                 (KEY+46)
#	define  DELETE                 (KEY+47)
#	define  CTRL_F1                (KEY+48)
#	define  CTRL_F2                (KEY+49)
#	define  CTRL_F3                (KEY+50)
#	define  CTRL_F4                (KEY+51)
#	define  CTRL_F5                (KEY+52)
#	define  CTRL_F6                (KEY+53)
#	define  CTRL_F7                (KEY+54)
#	define  CTRL_F8                (KEY+55)
#	define  CTRL_F9                (KEY+56)
#	define  CTRL_F10               (KEY+57)
#	define  ALT_F1                 (KEY+58)
#	define  ALT_F2                 (KEY+59)
#	define  ALT_F3                 (KEY+60)
#	define  ALT_F4                 (KEY+61)
#	define  ALT_F5                 (KEY+62)
#	define  ALT_F6                 (KEY+63)
#	define  ALT_F7                 (KEY+64)
#	define  ALT_F8                 (KEY+65)
#	define  ALT_F9                 (KEY+66)
#	define  ALT_F10                (KEY+67)
#	define  ALT_1                  (KEY+68)
#	define  ALT_2                  (KEY+69)
#	define  ALT_3                  (KEY+70)
#	define  ALT_4                  (KEY+71)
#	define  ALT_5                  (KEY+72)
#	define  ALT_6                  (KEY+73)
#	define  ALT_7                  (KEY+74)
#	define  ALT_8                  (KEY+75)
#	define  ALT_9                  (KEY+76)
#	define  ALT_0                  (KEY+77)
#	define  ALT_                   (KEY+78)
#	define  CTRL_CUR_LEFT          (KEY+79)
#	define  CTRL_CUR_RIGHT         (KEY+80)
#	define  F11                    (KEY+81)
#	define  F12                    (KEY+82)
#	define  ALT_F11                (KEY+83)
#	define  ALT_F12                (KEY+84)
#	define  CTRL_F11               (KEY+85)
#	define  CTRL_F12               (KEY+86)
#	define  ALT_CUR_RIGHT          (KEY+87)
#	define  ALT_CUR_UP             (KEY+88)
#	define  ALT_CUR_DOWN           (KEY+89)
#	define  ALT_CUR_LEFT           (KEY+90)
#	define  CTRL_CUR_UP            (KEY+91)
#	define  CTRL_CUR_DOWN          (KEY+92)
#	define  ALT_Q                  (KEY+93)
#	define  CTRL_END               (KEY+94)
#	define  CTRL_HOME              (KEY+95)
#	define  CTRL_INSERT            (KEY+96)
#	define  CTRL_DELETE            (KEY+97)
#	define  CTRL_PAGE_UP           (KEY+98)
#	define  CTRL_PAGE_DOWN         (KEY+99)
#endif

#ifdef DOS
#	define S_ISDIR(m)  ( m & S_IFDIR)
#	define S_ISREG(m)  ( m & S_IFREG)
#	define S_ISBLK(m)  ( m & S_IFBLK)
#	define S_ISCHR(m)  ( m & S_IFCHR)
#	define S_ISFIFO(m) ( m & S_IFIFO)
#	define S_ISNAM(m)  ( TRUE)
#	define S_ISLNK(m)  ( TRUE)
#else 		/* UNIX */

#ifndef S_ISLNK
#  define S_ISLNK(m)         ((m & S_IFLNK) == S_IFLNK)
#endif

#if ! defined (S_ISNAM) && defined (S_IFNAM)
#  define S_ISNAM(m)	   ((m & S_IFNAM) == S_IFNAM)
#endif
#if ! defined (S_ISNAM)
#  define S_ISNAM(m)         FALSE
#endif
#endif	/* DOS */

#ifdef UNIX
#	define MY_stat     	lstat
#else
#	define MY_stat		stat
#endif

/*+*/
/** mouse BUTTON **/

#define RT_KLICK        0700            /* one klick */
#define MD_KLICK        0701
#define LT_KLICK        0702
#define RT_D_KLICK      0703            /* double klick */
#define MD_D_KLICK      0704
#define LT_D_KLICK      0705

#define OPTION_KEY      8001            /* edit options of programm */
#define COLORS_KEY      8002            /* edit colours */
#define CHMOD_KEY       8003            /* change mode of files */
#define CHOWNGR_KEY     8004            /* change owner/group of files */

#define V_H_WIN(x)      (VIEWIN_KEY+x)       /* KEY for WIN number x */
#define VIEWIN_KEY	  8005            /* view/hide frame 1 */
#define VIEWIN6           8006            /* view/hide frame 1 */
#define VIEWIN7           8007            /* view/hide frame 1 */
#define VIEWIN8           8008            /* view/hide frame 1 */
#define VIEWIN9           8009            /* view/hide frame 1 */
#define VIEWIN10          8010            /* view/hide frame 1 */
#define VIEWIN11          8011            /* view/hide frame 1 */
#define VIEWIN12          8012            /* view/hide frame 1 */
#define VIEWIN13          8013            /* view/hide frame 1 */
#define VIEWIN14          8014            /* view/hide frame 1 */
#define VIEWIN15          8015            /* view/hide frame 1 */
#define VIEWIN16          8016            /* view/hide frame 1 */
#define VIEWIN17          8017            /* view/hide frame 1 */
#define VIEWIN18          8018            /* view/hide frame 1 */
#define VIEWIN19          8019            /* view/hide frame 1 */
#define VIEWIN20          8020            /* view/hide frame 1 */

#define HEXA_KEY        8021            /* hexa editor */
#define EDIT_KEY        8022		  /* Editor */
#define MKDIR_KEY       8023		  /* Editor */
#define CONFIG_KEY      8024		  /* ESave options and config */
#define FILTER_KEY      8025            /* Filter for DOS */
#define TAB_KEY         8026            /* tab block */
#define ELECTRIC_KEY    8027            /* tab block */
#define SIZE_KEY	8028            /* view size of directory */
#define VIEW_KEY	8030		 /* viewer */
#define SEARCH_KEY	8031		/* Search command */
#define COPY_KEY	8032
#define DELETE_KEY	8033
#define EXIT_KEY	8035
#define SORT_KEY	8036
#define LONGSHORT_KEY	8037
#define SELECT_KEY	8038
#define UNSELECT_KEY	8039
#define CHOOSE_KEY	8040
#define DIRONLY_KEY	8041
#define HELPLINE_KEY	8042
#define EDITMODE_KEY	8043
#define ALLWINS_KEY	8044
#define GREP_KEY	8045
#define ABOUT_KEY	8046
#define HELP_KEY	8047
#define TREE_KEY	8048
#define TEST_KEY	8049
#define MOVE_KEY	8050
#define DEVICE_COPY_KEY 8051
#define GETFILE_KEY	8052
#define UMENU_KEY	8053
#define SAVEMENU_KEY	8054
#define EDITMENU_KEY    8055
#define ENV_KEY		8056
#define CDROM_KEY	8057

#define CUR_RIGHT_OPEN  ETC_G1
#define CUR_LINK_OPEN   ETC_G2
#define CUR_LINK_DOWN   ETC_G3
#define CUR_RIGHT_DOWN  ETC_G4
#define VER_LINE        ETC_GV
#define HOR_LINE        ETC_GH
#define RIGHT_UP_DOWN   ETC_GR
#define LEFT_UP_DOWN    ETC_GL

#define INIT_LINE       ETC_GS
#define DESINIT_LINE    ETC_GE

#define NORMAL          ETC_me
#define INPUT           ETC_so

/*+*/
#ifdef UNIX
#	define F_WHITE         0x0001  /* colors */
#	define B_WHITE         0x0100
#	define F_BLUE          0x0002
#	define B_BLUE          0x0200
#	define F_GREEN         0x0003
#	define B_GREEN         0x0300
#	define F_CYAN          0x0004
#	define B_CYAN          0x0400
#	define F_BROWN         0x0005
#	define B_BROWN         0x0500
#	define F_YELLOW        0x0006
#	define B_YELLOW        0x0600
#	define F_RED           0x0007
#	define B_RED           0x0700
#	define F_BLACK         0x0008
#	define B_BLACK         0x0800
#	define F_VIOLET        0x0009
#	define B_VIOLET        0x0900
					       /* monochrome screens */
#	define F_NORMAL        0x000A
#	define B_NORMAL        0x0A00
#	define F_MESSAGE       0x000B
#	define B_MESSAGE       0x0B00
#	define F_INPUT         0x000C
#	define B_INPUT         0x0C00
#	define F_UNDERLINED    0x000D
#	define B_UNDERLINED    0x0D00

#else
				/* DOS colors */
				/* 0xF000 is for blanking */
#	define F_WHITE         0x000F  /* colors */
#	define B_WHITE         0x0700  /* Background only Lightgray */
#	define F_BLUE          0x0001
#	define B_BLUE          0x0100
#	define F_GREEN         0x0002
#	define B_GREEN         0x0200
#	define F_CYAN          0x0003
#	define B_CYAN          0x0300
#	define F_BROWN         0x0006
#	define B_BROWN         0x0600
#	define F_YELLOW        0x000E
#	define B_YELLOW        0x0E00
#	define F_RED           0x0004
#	define B_RED           0x0400
#	define F_BLACK         0x0000
#	define B_BLACK         0x0000
#	define F_VIOLET        0x0005  /* Magenta */
#	define B_VIOLET        0x0500

#	define F_DARKGRAY      0x0008 /* only forground */
#	define F_LIGHTBLUE     0x0009 /* only forground */
#	define F_LIGHTGREEN    0x000A /* only forground */
#	define F_LIGHTCYAN     0x000B /* only forground */
#	define F_LIGHTRED      0x000C /* only forground */
#	define F_LIGHTMAGENTA  0x000D /* only forground */

					       /* monochrome screens */
#	define F_NORMAL        0x000A
#	define B_NORMAL        0x0A00
#	define F_MESSAGE       0x000B
#	define B_MESSAGE       0x0B00
#	define F_INPUT         0x000C
#	define B_INPUT         0x0C00
#	define F_UNDERLINED    0x000D
#	define B_UNDERLINED    0x0D00

#endif

#define GRAPH_MODE      0x8000  /* graphic mode */

#ifdef UNIX
#       define G1       0
#       define G2       1
#       define G3       2
#       define G4       3
#       define GV       4
#       define GH       5
#       define GR       6
#       define GL       7
#       define MAX_GR_CHAR      8  /* max. count for graphic designer **/
#else
#       define    G1  '\273'    /* 0  G1+ */
#       define    G2  '\311'    /* 1  G2+ */
#       define    G3  '\310'    /* 2  G3+ */
#       define    G4  '\274'    /* 3  G4+ */
#       define    GV  '\272'    /* 4  GV| */
#       define    GH  '\315'    /* 5  GH- */
#       define    GR  '\271'    /* 6  GR -| */
#       define    GL  '\314'    /* 7  GL |- */
#       define    G5  '\313'    /* 8  G5 ^|^ */
#       define    G6  '\312'    /* 9  G6 _|_ */
#       define    G7  '\316'    /* 10 G7 -|- */
#       define    G8  '\274'    /* 11 G8 ? */
#endif

/*+*/
#ifdef UNIX
#define max( a, b) ( (a) > (b) ? (a) : (b))
#define min( a, b) ( (a) > (b) ? (b) : (a))
#endif

#ifdef UNIX
#       define C_G_X( m) ( ((m) & S_IXGRP))  /* group execute */
#       define C_G_W( m) ( ((m) & S_IWGRP))  /* group write */
#       define C_G_R( m) ( ((m) & S_IRGRP))  /* group read */

#       define C_O_X( m) ( ((m) & S_IXUSR))  /* user */
#       define C_O_W( m) ( ((m) & S_IWUSR))  /* user */
#       define C_O_R( m) ( ((m) & S_IRUSR))  /* user */

#       define C_A_X( m) ( ((m) & S_IXOTH))  /* other */
#       define C_A_W( m) ( ((m) & S_IWOTH))  /* other */
#       define C_A_R( m) ( ((m) & S_IROTH))  /* other */
#else
#       define C_G_X( m) (m|TRUE)
#       define C_G_W( m) (m|TRUE)
#       define C_G_R( m) (m|TRUE)

#       define C_O_X( m) (m|TRUE)
#       define C_O_W( m) (m|TRUE)
#       define C_O_R( m) (m|TRUE)

#       define C_A_X( m) (m|TRUE)
#       define C_A_W( m) (m|TRUE)
#       define C_A_R( m) (m|TRUE)
#endif

/*+*/
				/* options defines */
#define SH_		0	/* shell */
#define HIST            1       /* history file */
#define ERR_DEV		2	/* Error device */

#define OPT_CNT		4
#define OPT_LEN         50      /* length of options */

#define OUT( x, y, str) gotoXY(x,y); fflush_(); printf(str); fflush_();

#endif /*DODEFS_HH */
