/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: dodir.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/dodir.c,v $
 */

#	define GLOBAL extern
#	define EXTERN

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/stat.h>
#include <errno.h>
#include <dirent.h>

#include <time.h>
#include <sys/timeb.h>
#include <malloc.h>
#include <fcntl.h>

#ifdef UNIX
#include <termio.h>
#include <string.h>
#include <sys/types.h>
#include <grp.h>
#include <pwd.h>
#include <signal.h>
#include <sys/wait.h>
#include <sys/param.h>
#include <sys/sysmacros.h>

#if defined (SCO_UNIX)
#include <sys/page.h>
#include <sys/event.h>
#endif

#ifdef SCO_UNIX
#include <tinfo.h>		/* KEY_NUMBER is defined in this file */
#include <sys/console.h>
#include <mouse.h>
#endif

#include <curses.h>

#else
#include <dos.h>
#include <conio.h>
#include <io.h>
#include <dir.h>
#include <string.h>
#endif

#include "dodefs.h"
#include "doglobal.h"
#include "dolib.h"
#include "dowin.h"
#include "doscr.h"
#include "docfg.h"
#include "doabout.h"
#include "dochoose.h"
#include "docrypt.h"
#include "dodirent.h"
#include "doedit.h"
#include "dofiles.h"
#include "dofind.h"
#include "doframe.h"
#include "dogrep.h"
#include "dohexa.h"
#include "doinit.h"
#include "domem.h"
#include "domenu.h"
#include "domsg.h"
#include "dostat.h"
#include "dostern.h"
#include "dostring.h"
#include "dotcap.h"
#include "dotext.h"
#include "doutil.h"
#include "doqsort.h"
#include "doerror.h"
#include "dostern.h"
#include "dofiles.h"
#include "domem.h"
#include "dogrep.h"
#include "dotext.h"
#include "doabout.h"
#include "docfg.h"
#include "dohist.h"
#include "dofind.h"
#include "docopy.h"
#include "doenv.h"
#include "dodir.h"


#if defined ( DOS) && defined (MOUSE)
#include "mouse.h"
#endif

/************************************************************************/
/********************** keys for Khamis Directories *********************/
/************************************************************************/

int mn_keys[][15] = {
		{
		  EDIT_KEY,
		  HEXA_KEY,
		  VIEW_KEY,		/* viewer */
		  TREE_KEY,
		  SEARCH_KEY,		/* search */
		  GREP_KEY,		/* grep */
		  COPY_KEY,		/* copy */
		  DELETE_KEY,
		  CHMOD_KEY,
		  CHOWNGR_KEY,
		  MKDIR_KEY,
		  SIZE_KEY,          /* size of file/directory */
		  EXIT_KEY
		  },
		{
#ifdef HAVE_CDROM
		  CDROM_KEY,
#else
		  TREE_KEY,
#endif
		  0
		},
		{ 
		  SORT_KEY,
		  LONGSHORT_KEY,
		  SELECT_KEY,
		  UNSELECT_KEY,
		  CHOOSE_KEY,
		  DIRONLY_KEY,
		  HELPLINE_KEY,
		  SIZE_KEY,
		  EDITMODE_KEY,
		  ALLWINS_KEY,
		  ENV_KEY
		  },
		{
		  MOVE_KEY
		},
		{ 
		  V_H_WIN(0), V_H_WIN(1), V_H_WIN(2), V_H_WIN(3),
		  V_H_WIN(4), V_H_WIN(5), V_H_WIN(6), V_H_WIN(7),
		  V_H_WIN(8), V_H_WIN(9), V_H_WIN(10), 0, },
#ifdef DOS
		{
		  ALT_F1, ALT_F2, ALT_F3, ALT_F4, ALT_F5,
		  ALT_F6, ALT_F7, ALT_F8, ALT_F9, ALT_F10
		},
#endif
#ifdef UNIX
		{
		  ELECTRIC_KEY
		},
#endif
		{
		  OPTION_KEY,
		  COLORS_KEY,
		  FILTER_KEY,
		  TAB_KEY,
		  EDITMENU_KEY,
		  CONFIG_KEY,
		},
		{
		  F1,
		  ABOUT_KEY
		}
	      };

char * mn_line[] = {
		" Utils ",
		" Misc ",
		" Commands ",      	/* 1 */
		" Win ",
#	define VIEW_HIDE_MENU 4                /* for key functions */
		" View/Hide ",      	/* 3 dynamic menu */
#ifdef DOS
#	define DRIVE_MENU     4
		" Drive ",              /* dynamic menu */
#endif
#ifdef UNIX
		" COMM ",
#endif
		" Options ",      	/* 2 */
		" Help ",      		/* 4 */
		NULL
		},
     * mn_event[][15] = {
		{
		  " Editor                       Ctrl-E / F8 ",
		  " HEXA Editor                       Ctrl-T ",
		  " Viewer                            CTRL-V ",
#ifdef DOS
		  " Tree Manager                             ",
		  " Search                                   ",
		  " Grep                                     ",
#else
		  " Tree Manager                       Esc-t ",
		  " Search                             Esc-f ",
		  " Grep                               Esc-g ",
#endif
		  " Copy                         Ctrl-Y / F4 ",
		  " Delete                       Ctrl-R / F9 ",
		  " Change mode 'chmod'                Esc-m ",
#ifdef UNIX
		  " Owner/Group 'chown/chgrp'          Esc-o ",
#else
		  " Owner/Group modifikation     <UNIX only> ",
#endif
		  " Make Directory                        F2 ",
		  " Size of selected/cur. files <rec.> Esc-s ",
		  " Exit                              CTRL-C ",
		  NULL } ,
		{
#ifdef HAVE_CDROM
		  " CD-Player          ",
#else
		  " Tree Manager       Esc-t ",
#endif
		  NULL
		  },
		{ 
		  " Sort methode                    CTRL-O ",
		  " Long/Shurt Mode                     F3 ",
		  " Select                          CTRL_K ",
		  " Unselect                        CTRL_U ",
		  " Choose                          CTRL_W ",
		  " Directories only                CTRL_A ",
		  " View/hide help line             CTRL_B ",
		  " Size of selected entries <recursive>   ",
		  " Commandline/History (Edit mode) CTRL-X ",
		  " List of all Windows             CTRL-G ",
		  " Environments                           ",
		  NULL },
		{
		  " Move actual window  Esc-M ",
		  NULL
		  },
#ifdef UNIX
		{ "View/Hide",
		  NULL },
#endif
#ifdef DOS
		{ "Drive",
		  NULL },
#endif
		{
		  " Electric communication ",
		  NULL
		  },
		{ " Configuration         ",
		  " Colours               ",
		  " Filter                ",
		  " Tab Size              ",
		  " Edit user menu        ",
		  " Save Setup            ",
		  NULL },
		{ " Help              F1 ",
		  " About                ",
		  NULL }
	    };

char * KH_dir (char * path,		/* to change to */
	       char * filename,		/* to search for */
	       char * title,
	       int mode)		/* modes */
{
  /* mode: GETFILE_MODE, the user selects a filename for his application,
   *		      that will mean, that only one window will be opend
   *       NOMODE, the normal directory program
   */
  static char prompt_file [MAXPATH] ;  /* save selected file */
  struct frame_t * ffile   = NULL; /* to prompt the filename on the screen */
  struct win_t * w, * old_w;
  int
    key,		   /* the aktual key */
    i,
    j,
    l,
    h,
    m,
    n,
    old_akt_w,
    old_win_cnt,
    old_width,
    old_deep,
    old_x,
    old_y,
    old_color,
    old_choose,
    program_end = FALSE,
    save_akt_w,
    key_used = FALSE;
  char
    * q,
    c,
    * p,
    * s,
    * prog;
  
  if (mode & GETFILE_MODE)
    {
      old_w        = w_ [0] ;
      old_akt_w    = MY_cfg.akt_w ;
      old_win_cnt  = MY_cfg.win_cnt ;
      old_width    = MY_cfg.def_width [0];
      old_deep     = MY_cfg.def_deep  [0];
      old_x        = MY_cfg.def_x     [0];
      old_y        = MY_cfg.def_y     [0];

      MY_cfg.win_cnt  = 1 ;
      MY_cfg.akt_w    = 0 ;
      MY_cfg.def_width [0] = min (max_x-2, 39) ;
      MY_cfg.def_deep  [0] = min (max_y-5, 10) ;
      MY_cfg.def_x     [0] = (max_x - MY_cfg.def_width[0]) / 2 ;
      MY_cfg.def_y     [0] = min (8, (max_y - MY_cfg.def_deep [0]) / 2) ;

      strcpy (MY_cfg.def_path[0], path);
      strcpy (MY_cfg.def_file[0], filename);
      ffile = make_frame (MY_cfg.def_x [0],
			  MY_cfg.def_y [0] - 4,
			  MY_cfg.def_width [0] + 1,
			  4,
			  title,
			  leer,
			  F_B_UTIL_CLR,
			  NOMODE
			  );
      view_frame (ffile) ;
    }
  
  save_akt_w = min( MY_cfg.win_cnt-1, MY_cfg.akt_w);        /* aktual window */
  
  for (MY_cfg.akt_w=0; MY_cfg.akt_w<MY_cfg.win_cnt; MY_cfg.akt_w++)
    {
      w = w_[MY_cfg.akt_w] =
	make_win (MY_cfg.def_x[ MY_cfg.akt_w],
		  MY_cfg.def_y   [ MY_cfg.akt_w],
		  MY_cfg.def_x   [ MY_cfg.akt_w]+MY_cfg.def_width[ MY_cfg.akt_w],
		  MY_cfg.def_y   [ MY_cfg.akt_w]+MY_cfg.def_deep [ MY_cfg.akt_w],
		  MY_cfg.def_view[ MY_cfg.akt_w]           /* shurt/long mode */
		  );

      if (mode & GETFILE_MODE) w->f->color = F_B_UTIL_CLR ;

      /* beginig for long view
       */
      w->long_outbegin = MY_cfg.def_outbegin[MY_cfg.akt_w];
      w->f->mode       = MY_cfg.def_mode    [MY_cfg.akt_w];
      
#ifdef DOS
      w->drive = MY_cfg.def_drive[MY_cfg.akt_w];
#endif
      change_dir (w, MY_cfg.def_path[MY_cfg.akt_w]);
      get_path   (w);
      
      sprintf    (w->cur_dir, MY_cfg.def_file[MY_cfg.akt_w]);
      
      w_readdir  (w, ".", TRUE);
      
      				/* search for defualt prompted file */
      for (i=0;
	   i<w->d_files &&
	   strcmp (MY_cfg.def_file[MY_cfg.akt_w], w->dr[i]->f) != 0;
	   i++);
      if (i<w->d_files) w->akt_pos = w->old_pos = i;  /* file found */
      
      if (w->akt_pos > w->begin_at)
	w->anf_pos = max (0, w->akt_pos - w->f_maxfiles - 2);
      
      i = min (w->d_files, w->f_maxfiles);
      if (w->akt_pos >= w->anf_pos + i)
	{
	  w->anf_pos = max( w->anf_pos, w->akt_pos - i + 1);
	}
      view_win   (w, w, OUT_MODE);
    }			/* for */
  
  
  XDEBUG1("khdir 80\n");
  
  MY_cfg.akt_w = save_akt_w;
  w         = w_[ MY_cfg.akt_w];           /** aktual window **/
  view_win (w, w, OUT_MODE);
  
  if (! mode & GETFILE_MODE)
    {
      com_l         = com_akt = make_com ();
      com_l->com    = getmem (1);
      com_l->com[0] = 0;
      read_first_commands();
      view_com_line (w, TRUE);  	/* first viewing */
      ins_help_line (VIEW_HELP_MODE | VIEW_INS_MODE);   /* to make the frames*/
      MY_cfg.help_line_hidden = MY_cfg.help_line_hidden ? FALSE : TRUE;
      view_hide_help ();  
      view_about     ();			/* first call */
    }
  else
    {
      w->ch->inplen    = ffile->width - 11;		/* no input  */
      w->ch->inp_color = F_B_UTIL_CLR ;
      w->ch->chs_color = F_B_UTIL_CHS ;
      old_color	       = F_B_NORMAL   ;
      old_choose       = F_B_CHOOSE_CLR;
      F_B_CHOOSE_CLR   = F_B_UTIL_CHS ;
      F_B_NORMAL       = F_B_UTIL_CLR ;
      f_putstr (ffile, 1, 1, " File  :", ffile->color, SCR_MODE|FILL_MODE) ;
      f_putstr (ffile, 1, 2, " Filter:", ffile->color, SCR_MODE|FILL_MODE) ;
    }
  
  pr_to_run [0] = 0;
  
  do
    {
      if (mode & GETFILE_MODE)		/* for editor, choosing a file */
	{
          f_putstr (ffile, 10, 2,
		    w->filter,
		    ffile->color,
		    SCR_MODE|FILL_MODE) ;
	  strcpy   (pr_to_run, AKT_FILE(w)) ;
	  gotoXY   (ffile->x+10, ffile->y+1) ;
	}
      else				/* normal directory tool */
	{
	  view_com_line (w, TRUE);
	  w->ch->inplen = max_x -
	    strlen (cutpath (w->path, max_x / 2, NOMODE)) - 4;
      	}
      
      if (mode & GETFILE_MODE)
	{
	  /* pr_to_run [0] = 0 ;*/
	  key = find_file (w, ffile, pr_to_run, mode) ;
	}
      else
	{
	  /****** currect position **/
	  w->ch->pos  = w->akt_pos - w->anf_pos;
	  w->ch->mode = w->ch->mode & ~ NOWAIT_MODE; /* diable auto mode    **/
	  w->ch->mode = w->ch->mode | EXTRA_MODE | LET_MODE;

	  key = f_choose (w->ch);

	  w->akt_pos = w->anf_pos + w->ch->pos;
	  w->f_pos   = w->ch->pos;
	}

      prog = AKT_FILE(w);
      /* menu structure **/
      if (key == F10)
	{
	  char win_menu[12][40];
#ifdef DOS
	  char drive_menu[12][50];
#endif
	  /* dynamic menu for view/hide windows */
	  for (i=0; i<MY_cfg.win_cnt; i++)
	    {
	      mn_event[VIEW_HIDE_MENU][i] = win_menu[i];
	      sprintf( mn_event[VIEW_HIDE_MENU][i],
#ifdef DOS
		      " %s window # [%i]           Ctrl-F%i ",
#else
		      " %s window # [%i]     Esc-v ",
#endif
		      ( w_[i]->f->mode & VIEW_MODE ? "Hide" : "View"),
		      i+1
#ifdef DOS
		      , i+1		/* F1..10 */
#endif
		      );
	    }
	  mn_event[VIEW_HIDE_MENU][i] = NULL;
#ifdef DOS
	  /* dos only, to change the drives */
	  for (i=0; i<MY_cfg.win_cnt; i++)
	    {
	      mn_event[DRIVE_MENU][i] = drive_menu[i];
	      sprintf( mn_event[DRIVE_MENU][i],
		      " Change drive of window # [%i]       ALT-F%i ",
		      i+1,
		      i+1
		      );
	    }
	  mn_event[DRIVE_MENU][i] = NULL;
#endif

	  key = menu (mn_keys, mn_line, mn_event);
	  if (key == ESC) continue;
	}

#ifdef UNIX

      /* my be there are keys with same boundaries */
      key_used = FALSE;

#ifdef MOUSE
      switch( key)
	{
	  /* mouse klick */
	case  LT_KLICK:
	  if (ms_y == max_y)
	    {				/* command filter **/
	      int com = ms_x / 7;
	      if (ms_x % 7 == 0) continue;
	      switch( com)
		{
		case 0: key = F1; break;
		case 1: key = F2; break;
		case 2: key = F3; break;
		case 3: key = F4; break;
		case 4: key = F5; break;
		case 5: key = F6; break;
		case 6: key = F7; break;
		case 7: key = F8; break;
		case 8: key = F9; break;
		case 9: key = F10; break;
		case 10: key = CTRL_N; break;
		}
	      break;
	    }
	  /* out the range of the akt. window **/
	  if (ms_x < w->f->x + 1
	      || ms_x > w->f->to_x + 1 
	      || ms_y < w->f->y + 1 
	      || ms_y > w->f->to_y + 1 
	      )
	    {
	      int fnd = FALSE;
	      for (i=0; i<MY_cfg.win_cnt; i++)
		{
		  if (ms_x >= w_[i]->f->x + 1 
		      && ms_x <= w_[i]->f->to_x + 1 
		      && ms_y >= w_[i]->f->y + 1 
		      && ms_y <= w_[i]->f->to_y + 1
		      ) 
		    {
		      MY_cfg.akt_w = i;
		      fnd = TRUE;
		      break;
		    }
		}
	      if (fnd == TRUE)
		{
		  w = w_change_win (FALSE);
		}
	      else continue;
	    }
	  /* the left column of the window */
	  if (ms_x == w->f->to_x + 1) 
	    {
	      key = END;
	      break;
	    }
	  /* the right column of the window */
	  if (ms_x == w->f->x + 1)
	    {
	      key = HOME;
	      break;
	    }
	  
	  
	  i = ms_y - w->f->y - 2;		/* differenz betw. mouse & y**/
	  /* faktor */
	  j =  (w->view_mode & LONG_MODE
		? 0 	   
		: w->f->rows * ( ( ms_x - w->f->x - 2) / COL_WIDTH)
		);
	  
	  i += j;
	  
	  if (ms_y == w->f->y + 1)
	    { 				/* simulate the CUR_UP */
	      w->akt_pos = w->anf_pos;
	      key = CUR_UP;
	      break;
	    }
	  if (ms_y == w->f->to_y + 1)
	    { 	/* simulate the CUR_DOWN */
	      w->akt_pos = w->anf_pos + w->f_maxfiles;
	      key = CUR_DOWN;
	      break;
	    }
	  /* else set the choose to **/
	  /* current position ***/
	  w->akt_pos = max( 0, min( w->d_files, w->anf_pos + max( -1, i)));
	  break;
	} /* switch */
#endif
      
#endif
      
      /* commands on normal mode */
      if (! key_used)
      switch (key)
	{
	case FILTER_KEY:		/* Filter for dos */
	  w_filter (w, NULL);
	  key_used = TRUE;
	  break;
	  
	case CTRL_P:
	case HELP_KEY:
	case F1:
	  help();			/** view help and **/
	  key_used = TRUE;
	  break;
	  
	  /* change sort methode */
	case  F6:
	case CTRL_O:
	case SORT_KEY:
	  w_changesort( w);
	  key_used = TRUE;
	  break;

	  /* long or simple list */
	case F3:
	case CTRL_L:
	case LONGSHORT_KEY:
	  if (w->view_mode & LONG_MODE) 
	    {
	      w->view_mode = SIMPLE;
	      w->ch = w->ch1;        /* another choose record **/
	    }
	  else {
	    w->view_mode = LONG_MODE;
	    w->ch = w->ch2;        /* another choose record **/
	    while (w->akt_pos - w->anf_pos >= w->f->down) w->anf_pos++;
	  }
	  
	  w->f_pos  = 0;   /* set old position to 0, while rong memory cashe */
	  w->fr_out = TRUE;
#ifdef DOS
	  w->rahmen_out = TRUE;
#endif
	  key_used = TRUE;
	  break;
	  
	case CUR_RIGHT:
	  if (w->view_mode & LONG_MODE) 
	    {
	      w->long_outbegin ++;
	      w->fr_out = TRUE;
	    }
	  else
	    w->akt_pos = min( w->akt_pos + w->f->down, w->d_files - 1);
	  key_used = TRUE;
	  break;
	case  CUR_LEFT:
	  if (w->view_mode & LONG_MODE) 
	    {
	      if(w->long_outbegin == 0) continue;
	      w->long_outbegin--;
	      w->fr_out = TRUE;
	    }
	  else
	    {
	      if (w->akt_pos < 1) continue;
	      w->akt_pos = max( w->akt_pos - w->f->down, max(w->begin_at-1,0));
	    }
	  key_used = TRUE;
	  break;

	case  CUR_DOWN:
	  if (w->akt_pos == w->d_files - 1) continue;
	  
	  w->akt_pos = min( w->akt_pos + 1, w->d_files - 1);
	  key_used = TRUE;
	  break;

	case  CUR_UP:
	  if (w->akt_pos == 0) continue;
	  
	  w->akt_pos = max( w->akt_pos - 1, 0);
	  key_used = TRUE;
	  break;

	case  PAGE_UP:
	  w->akt_pos = max (max(w->begin_at-1,0),
			    w->akt_pos - w->f_maxfiles + 1);
	  key_used = TRUE;
	  break;

	case  PAGE_DOWN:
	  w->akt_pos = min( w->akt_pos + w->f_maxfiles-1, w->d_files - 1);
	  key_used = TRUE;
	  break;

	  /* the head of the list */
	case  HOME:
	  w->anf_pos = 0;
	  w->akt_pos = max(w->begin_at-1,0);
	  w->fr_out = TRUE;
	  key_used = TRUE;
	  break;

	  /* the last file */
	case  END:
	  w->akt_pos = w->d_files - 1;
	  w->fr_out = TRUE;
	  key_used = TRUE;
	  break;

#ifdef DOS
	case ALT_F1:
	  change_disk(0);
	  key_used = TRUE;
	  break;
	case ALT_F2:
	  change_disk(1);
	  key_used = TRUE;
	  break;
	case ALT_F3:
	  change_disk(2);
	  key_used = TRUE;
	  break;
	case ALT_F4:
	  change_disk(3);
	  key_used = TRUE;
	  break;
	case ALT_F5:
	  change_disk(4);
	  key_used = TRUE;
	  break;
	case ALT_F6:
	  change_disk(5);
	  key_used = TRUE;
	  break;
	case ALT_F7:
	  change_disk(6);
	  key_used = TRUE;
	  break;
	case ALT_F8:
	  change_disk(7);
	  key_used = TRUE;
	  break;
	case ALT_F9:
	  change_disk(8);
	  key_used = TRUE;
	  break;
	case ALT_F10:
	  change_disk(9);
	  key_used = TRUE;
	  break;
#endif

        case SEARCH_KEY: 
#ifdef UNIX
	case ESC_f:
#endif
	  w_search_file(w, SEARCH_FILE);
	  key_used = TRUE;
	  break;
	  
	case TREE_KEY:
#ifdef UNIX
	case ESC_t:
#endif
	  w_search_file (w, SEARCH_TREE);
	  key_used = TRUE;
	  break ;
	  
	  /* size of file/directory <recursive> */
	case SIZE_KEY:
#ifdef UNIX
	case ESC_s:
#endif
	  view_size( w);
	  key_used = TRUE;
	  break;
	  
	  /* view only the directorys */
	case  CTRL_A:
	case  DIRONLY_KEY:
	  view_dir_only (w, NOMODE);
	  key_used = TRUE;
	  break;

	  /* choose selected files */
	case CTRL_W:
	case CHOOSE_KEY:
	  chs_files( w);
	  key_used = TRUE;
	  break;
	  
	case CTRL_C: 
	case EXIT_KEY:
	  if (mode & GETFILE_MODE)
	    {
	      program_end = TRUE ;
	    }
	  else
	    {
#ifdef UNIX
	      want_quit (SIGINT);
#else
	      want_quit (-1);
#endif
	    }
	  key_used = TRUE;
	  break;
	  
	} /* switch */
      
      if (!mode & GETFILE_MODE && ! key_used)
      switch( key)
	{
	  /* search file */
	case CTRL_F:
	  key = find_file (w, NULL, NULL, mode);
	  if (mode & GETFILE_MODE) strcpy (pr_to_run, AKT_FILE(w)) ;
	  break;
	}

      if (! key_used)
      switch (key)
	{
	case ESC:
	  pr_to_run[ 0] = 0;
	  if (mode & GETFILE_MODE) program_end = TRUE ;
	  key_used = TRUE;
	  break;
	}

      if (! (mode & GETFILE_MODE) && ! key_used)
	switch( key)
	{
	case UMENU_KEY:
	  umenu_call () ;
	  key_used = TRUE;
	  break ;
	  
#ifdef UNIX
	case ESC_M:
#endif
	case MOVE_KEY:
	  if (w->f->mode & VIEW_MODE)
	    {
	      f_resize (w->f, 0, 1, max_x, max_y-3, MOVE_MODE);
	    }
	  else
	    {
	      f_resize (w->symbol, 0, 1, max_x, max_y-3, MOVE_MODE);
	    }
	  key_used = TRUE;
	  break;

	case EDITMENU_KEY:		/* edit user menu */
	  umenu_call ();
	  key_used = TRUE;
	  break ;

	case ENV_KEY:
	  environment();
	  key_used = TRUE;
	  break;

#ifdef HAVE_CDROM
	case CDROM_KEY:
	  cdrom_playing ();
	  key_used = TRUE;
	  break;
#endif

#if 1
	  /* Test function **/
#ifdef UNIX
	case  ESC_Z:
#endif
	case TEST_KEY:
	  key_used = TRUE;
	  {
	    int i, j;
	    struct frame_t * f;
	    for (j=1; j<4; j++)
		{
		f = make_frame (0, 1, j * 20, j * 5, 
					     leer, leer, 
					     F_B_NORMAL,
		SCROLL_RIGHT_MODE|SCROLL_BUTTOM_MODE);
		view_frame (f);
		for (i=0; i<=5; i++)
		{
			f_reposition (f, i, 5, f->type);
			view_frame (f);
		    	if (getkey (-1) == ESC) break;
		}
	        hide_frame (f, HIDE_MODE|DELETE_MODE);
		if (getkey(-1) == ESC) break;
		}
	  }
	  break;
#endif /* if 0 */

#ifdef UNIX
	case ESC_d:
	case DEVICE_COPY_KEY:
	    device_copy ();
	    key_used = TRUE;
	    break ;
#endif
				  /* hexa editor */
	case  CTRL_T:
	case  HEXA_KEY:
	  hexa_editor( AKT_FILE(w), HEXA_EDIT_MODE);
	  key_used = TRUE;
	  break;
	  
	  /* edit file */
	case  F8:
	case  CTRL_E:
	case  EDIT_KEY:
	  sprintf (prompt_file, "%s/%s", w->path, AKT_FILE(w));
	  KHA_editor (prompt_file);
	  change_dir (w, w->path) ;	/* change to current path */
	  w->new_read = TRUE ;		/* reset dir. entries */
	  key_used = TRUE;
	  break;
	  
	case  F7:
	case  CTRL_X:
	case  EDITMODE_KEY:
	  key = get_strxy (w, 0, max_y-5, pr_to_run,
			   MAX_COM_LEN-1,	/* String length */
			   max_x-3,		/* Frame width */
			   " Run <edit mode> PgUp/Dn:History CurUp/Dn:prev/next command ",
			   leer,
			   CUR_MODE  |
			   HIST_MODE |
			   COM_MODE  |
			   FIL_MODE  |
			   INS_MODE);
	  
	  if (key == ESC || strlen( pr_to_run) == 0)
	    {
	      pr_to_run[0] = 0;
	      continue;
	    }
	  break;
	} /* switch */
      
      /* simulate ENTER-KEY, wenn the mouse point to the current position **/
      /* of the choose mask */
      
#ifdef UNIX
      
#ifdef MOUSE
      if (! key_used)
      switch( key)
	{
	case LT_D_KLICK:
	  if (w->view_mode & SIMPLE) 
	    {	
	      i = w->ch->x[ w->akt_pos - w->anf_pos] + 1;
	      j = w->ch->y[ w->akt_pos - w->anf_pos] + 1;
	    }
	  else {
	    i = 1;
	    j = w->akt_pos-w->anf_pos;
	  }

	  if (ms_x >= i &&
	      ( ( (w->view_mode & LONG_MODE) && ms_x <= w->f->to_x - 1) ||
	       ( ms_x <= i + COL_WIDTH)
	       ) &&
	      j == ms_y) key = ENTER;
	  else continue;
	  break;
	}
#endif

#endif

#ifdef UNIX
#define	ACTPATH "./"
#else
#define ACTPATH ".\\"
#endif
      if (! key_used)
      switch( key)
	{ 			/* run the text */
	case CTRL_M:
	case ENTER:
	  {
	    int run_prog = FALSE;

	    if (! (mode & GETFILE_MODE) && strcmp (pr_to_run, "exit") == 0)
	      {
		program_end = TRUE ;
		break;
	      }
	    else		/* delete the current file from string */
	      {
		if (strcmp (pr_to_run, AKT_FILE(w)) == 0)
		  pr_to_run [0] = 0 ;
	      }

	    if (pr_to_run [0] != 0)
	      {
		if (begins( pr_to_run, "cd ") == 0)
		  {
		    q = strchr( pr_to_run, ' ') + 1;
		    if (change_dir( w, q) == -1) continue;
		    get_path( w);
		    w->anf_pos = 0;
		    w->old_pos = w->akt_pos = max(w->begin_at-1, 0);
		  }
		else run_prog = TRUE;

		w->new_read = TRUE;
	      }				/* if pr..[0] != 0 */
					/* run selected file or open dir */
	    else
	      {
		char tmp[MAXPATH] ;
		prog = AKT_FILE(w);

		/* change directory **/
		if (is_dir (AKT_FILE(w), NOMODE))
		  {
		    int m = TRUE;
#ifdef UNIX
		    if (   ! can_read (prog)
			|| ! can_exec (prog) )
		      {
			premission();
			continue;
		      }
#endif
		    if (change_dir (w, prog) == -1)
		      {
			message ("Can't open this directory", leer);
			continue;
		      }
		    w->akt_pos = w->old_pos = max(w->begin_at-1,0);
		    w->anf_pos = 0;
		    if (strcmp (prog, "..") == 0) m = m|LOCK_DIR_MODE;
		    w_readdir( w, ".", m);
		    get_path ( w);
		    w->fr_out     = TRUE;
		    w->rahmen_out = TRUE;
		  }  /* if S_ISDIR */
		else
		  {
		    char chs_act[] = " Choose your action ";
		    char chs_prg[] = " Edit ;;"
				     " View ;;"
				     " Hexa Edit ;;"
				     " Hexa View ;;"
				     " Execute ;;"
				     " Break ";
		    int
		      type  = file_type (prog),
		      pos   = 0,
		      width = max_x,
		      down  = max_y-2,
		      x     = 0,
		      y     = 1;

		    if (mode & GETFILE_MODE)	/* select the file only */
		      {
			strcpy (prompt_file,
				concat_path (w->path, AKT_FILE(w)));
			program_end = TRUE ;
			break ;
		      }

			 if (type & TEXT_FILE) pos = 0;
		    else if (type & DATA_FILE) pos = 3;
		    else
		      {
			sprintf (pr_to_run, concat_path (ACTPATH, prog));
			run_prog = TRUE;
		      }
		    if ( ! run_prog )
		      {
			pos = Getyesno (chs_act, chs_prg, " Action ", pos);
			switch (pos)
			  {
			  case 0:
			    sprintf (prompt_file, "%s/%s",
				     w->path,
				     AKT_FILE(w)
				     );
			    KHA_editor (prompt_file); /* ascii file to edit */
			    change_dir (w, w->path) ;
			    w->new_read = TRUE ;
			    break;

			  case 1:			/* big files to view */
			    view_file (prog,
				       prog,
				       x, y, width, down,
				       NULL,
				       1024,
				       NOMODE);
			    break;

			  case 2:
			    hexa_editor (prog, HEXA_EDIT_MODE); /* data file to see */
			    break;

			  case 3:
			    hexa_editor (prog, HEXA_VIEW_MODE); /* data file to see */
			    break;

			  case 4:
			    strcpy (pr_to_run, concat_path (ACTPATH, prog));
			    run_prog = TRUE;
			    break;

			  default:
			    break;
			  }
		      }
		  }
	      }  /** pr_to_run == 0 */

	    if (run_prog)
	      {
		if (mode & GETFILE_MODE)	/* select the file only */
		  {
		    sprintf (prompt_file, "%s/%s", w->path, pr_to_run) ;
		    if (mode & EXISTS_MODE && ! exist (prompt_file))
		      {
			message ( " File must be existing ", leer) ;
			break ;
		      }
		    program_end = TRUE ;
		    break ;
		  }

		run (pr_to_run, SAVE_SCREEN); /* save screen bevor runing */

#if 0		
#ifdef UNIX
		presskey();
		clrscr_();
#endif
		view_screen();
#endif

#ifdef DOS
		get_path( w);   /* the path for dos */
#endif
		w->new_read = TRUE;
	      }
	    pr_to_run [0] = 0;
	  }
	  key_used = TRUE;
	  break;

	case TAB:
	case RT_KLICK:
	  if (mode & GETFILE_MODE)
	    {
	      w_filter (w, ffile) ;	/* modify the filter */
	    }
	  else
	    {
	      w = w_change_win( NEXTWIN_MODE);
	    }
	  key_used = TRUE;
	  break;
	}
      
					/* command's in normal mode
					 */
      if (! (mode & GETFILE_MODE) && ! key_used)
	switch (key)
	{
	case F2:
	case MKDIR_KEY:
	  if (! new_dir()) w->new_read = TRUE;
	  key_used = TRUE;
	  break;
	  
#ifdef UNIX
	case ELECTRIC_KEY:
	  e_mail( NOMODE);
	  key_used = TRUE;
	  break;
#endif
	  
	case OPTION_KEY:		/* edit options */
	  MY_setup(&MY_cfg);
	  key_used = TRUE;
	  break;
	  
	case CONFIG_KEY:		/* save configuration */
	  save_config(&MY_cfg);
	  key_used = TRUE;
	  break;

	case TAB_KEY:		/* Tab block < 4 , 8 > */
	  change_tab();
	  key_used = TRUE;
	  break;
	  
	case ABOUT_KEY:
	  about_project ( cpyright);
	  key_used = TRUE;
	  break;
	  
	  				/** choose another window **/
	case CTRL_G: 
	case ALLWINS_KEY:
	  w = chs_win();
	  key_used = TRUE;
	  break;

	case COLORS_KEY:	/* edit colours of choose and default colors */
	  change_colors();
	  key_used = TRUE;
	  break;
	  
	  /** insert | overwrite mode **/
	case CTRL_N:
	case INSERT:
	  ins_mode = ~ ins_mode;
	  ins_help_line( VIEW_INS_MODE);
	  key_used = TRUE;
	  break;
	  
	case BACK_TAB:
	case MD_KLICK:
	  w = w_change_win( PREVWIN_MODE);
	  key_used = TRUE;
	  break;

	  /* view any file **/
	case CTRL_V:
	case VIEW_KEY:
	  view_any_file( w);
	  break;
	  
	  /* delete file */
	case  F9:
	case  CTRL_R:
	case  DELETE_KEY:
	  remove_file( w);
	  key_used = TRUE;
	  break;
	  
	  /* hide/view current window */
#ifdef UNIX
	case ESC_v:
	case ESC_V:
	  w_view_hide_win (MY_cfg.akt_w) ;
	  key_used = TRUE;
	  break ;
#endif
	  
#ifdef DOS
	case CTRL_F1:
#endif
	case V_H_WIN(0):
	  w_view_hide_win( 0);
	  key_used = TRUE;
	  break;
	  
#ifdef DOS
	case CTRL_F2:
#endif
	case V_H_WIN(1):
	  w_view_hide_win( 1);
	  key_used = TRUE;
	  break;
	  
#ifdef DOS
	case CTRL_F3:
#endif
	case V_H_WIN(2):
	  w_view_hide_win( 2);
	  key_used = TRUE;
	  break;
	  
#ifdef DOS
	case CTRL_F4:
#endif
	case V_H_WIN(3):
	  w_view_hide_win( 3);
	  key_used = TRUE;
	  break;
	  
#ifdef DOS
	case CTRL_F5:
#endif
	case V_H_WIN(4):
	  w_view_hide_win( 4);
	  key_used = TRUE;
	  break;
	  
#ifdef DOS
	case CTRL_F6:
#endif
	case V_H_WIN(5):
	  w_view_hide_win( 5);
	  key_used = TRUE;
	  break;
	  
#ifdef DOS
	case CTRL_F7:
#endif
	case V_H_WIN(6):
	  w_view_hide_win( 6);
	  key_used = TRUE;
	  break;
	  
#ifdef DOS
	case CTRL_F8:
#endif
	case V_H_WIN(7):
	  w_view_hide_win( 7);
	  key_used = TRUE;
	  break;
	  
#ifdef DOS
	case CTRL_F9:
#endif
	case V_H_WIN(8):
	  w_view_hide_win( 8);
	  key_used = TRUE;
	  break;
	  
#ifdef DOS
	case CTRL_F10:
#endif
	case V_H_WIN(9):
	  w_view_hide_win( 9);
	  key_used = TRUE;
	  break;
	  
	case CHMOD_KEY:
#ifdef UNIX
	case ESC_m:
#endif
	  change_mode( w);
	  key_used = TRUE;
	  break;
	  
	case GREP_KEY:
#ifdef UNIX
	case ESC_g:
#endif
	  w_grep( w);
	  key_used = TRUE;
	  break;
	  
	  /* file copy */
	case CTRL_Y:
	case F4:
	case COPY_KEY:
	  copy_file( w);
	  key_used = TRUE;
	  break;

#ifdef UNIX
	case CHOWNGR_KEY:
	case ESC_o:
	  change_owner( w);
	  key_used = TRUE;
	  break;
#endif
	  
	case CTRL_B:
	case HELPLINE_KEY:
	  view_hide_help();
	  key_used = TRUE;
	  break;
	  
	  /* select/mark files */
	case CTRL_K:
	case SELECT_KEY:
	  select_files( w, SELECT_MODE);
	  key_used = TRUE;
	  break;

	  /* unselect/unmark files */
	case CTRL_U:
	case UNSELECT_KEY:
	  select_files( w, UNSELECT_MODE);
	  key_used = TRUE;
	  break;
	  /* if selected then unselect else select */
	case  F5:
	case CTRL_Z:
	  select_one_file( w);
	  key_used = TRUE;
	  break;
	  
	}
      
      if (w->akt_pos >= w->anf_pos + w->files_on_f) 
	{
	  w->fr_out = TRUE;
	  w->anf_pos = max( w->anf_pos, w->akt_pos - w->files_on_f + 1);
	}
      
      if (w->akt_pos < w->anf_pos) 
	{
	  w->anf_pos = max( 0, w->akt_pos);
	  w->fr_out  = TRUE;
	}
      
      if (w->new_read) w_readdir( w, ".", FALSE);
      
      if (w->akt_pos > w->d_files - 1) 
	{
	  w->akt_pos = w->old_pos = w->d_files - 1;
	  w->fr_out = TRUE;
	}
      
      w->akt_pos = min( w->akt_pos, w->d_files - 1);
      w->old_pos = min( w->old_pos, w->d_files - 1);
      w->anf_pos = min( w->anf_pos, w->d_files - 1);
      
      if (w->fr_out) w_outdir (w, w->anf_pos);
      
    } while (! program_end) ;
  
  for (i=MY_cfg.win_cnt-1; i >= 0; i--)
    {
      del_win (w_[i]);
      w_[i] = NULL;
    }
  
  if (mode & GETFILE_MODE)		/* reset old values */
    {
      w_            [0] = old_w ;
      MY_cfg.win_cnt       = old_win_cnt ;
      MY_cfg.def_width [0] = old_width;
      MY_cfg.def_deep  [0] = old_deep;
      MY_cfg.def_x     [0] = old_x ;
      MY_cfg.def_y     [0] = old_y ;
      MY_cfg.akt_w         = old_akt_w;
      F_B_NORMAL        = old_color;
      F_B_CHOOSE_CLR    = old_choose ;
      hide_frame (ffile, HIDE_MODE|DELETE_MODE) ;
    }
  else
    {
      hide_frame( help1, HIDE_MODE|DELETE_MODE);
    }
  
  return key == ENTER || key == CTRL_M ? prompt_file : NULL ;
}
