/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: doedit.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/doedit.c,v $
 */

/************************************************************************/
/************ Editor ****************************************************/
/************************************************************************/

#define GLOBAL extern
#define EXTERN

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>

#ifdef alpha
#include <unistd.h>
#endif

#ifdef DOS
#include <io.h>
#endif

#include "dodefs.h"
#include "doglobal.h"
#include "dofiles.h"
#include "doscr.h"
#include "doqsort.h"
#include "domem.h"
#include "dostring.h"
#include "domenu.h"
#include "doframe.h"
#include "docfg.h"
#include "dotext.h"
#include "dohist.h"
#include "dodir.h"
#include "doedit.h"

#if defined (HAVE_REALPATH) && defined (alpha) && ! defined (HAVE_READLINK)
#define HAVE_READLINK
#endif
#if defined (HAVE_READLINK) && ! defined (HAVE_REALPATH)
#define HAVE_REALPATH
#endif

/**************************************************************************/
/*       Menu for editor 						**/
/**************************************************************************/

#if defined( DOS)
#	define READ_SIZE 100
#else
#	define READ_SIZE 1024
#endif

#define BLOCK_BEG	9001
#define BLOCK_END	9002
#define BLOCK_CUT	9003
#define BLOCK_COPY	9004
#define BLOCK_UNDEF	9005
#define BLOCK_PASTE	9007
#define BLOCK_UNDO 	9008
#define BLOCK_SAVEAS	9009

#define WORD_FOR	9050
#define WORD_BACK	9051

#define LINE_DEL	9060
#define LINE_INS	9061
#define LINE_APP	9062

#define FILE_SAVEAS	9063
#define FILE_INS	9064
#define FILE_NEW	9067
#define FILE_SAVE       9068
#define FILE_CLOSE      9069
#define FILE_OPEN       9070

#define WIN_NEXT        9080
#define WIN_PREV        9081
#define WIN_RESIZE	9082
#define WIN_CHOOSE	9083

int edit_keys[][MAXMENU_ENTRY] = {
	{ FILE_NEW,          /* Alt-F1 */
	  FILE_OPEN,         /* Alt-F2 */
	  FILE_SAVE,         /* Alt-F3 */
	  FILE_SAVEAS,       /* Alt-F4 */
	  FILE_CLOSE,        /* Alt-F5 */
	  ESC
	  },
	{ FILE_INS,          /* Alt-F6 */
	  BLOCK_BEG,         /* Ctrl-F1 */
	  BLOCK_END,         /* Ctrl-F2 */
	  BLOCK_SAVEAS,      /* Ctrl-F3 */
	  BLOCK_PASTE,       /* Ctrl-F4 */
	  BLOCK_CUT,         /* Ctrl-F5 */
	  BLOCK_COPY,         /* Ctrl-F6 */
	  BLOCK_UNDO,        /* Ctrl-F7 */
	  BLOCK_UNDEF,       /* Ctrl-F8 */
	  LINE_DEL,          /* Ctrl-F9 */
	  LINE_INS,          /* Ctrl-F10 */
	  INSERT,            /* Insert */
	  CTRL_A
	  },
	{ F3,
	  F4,
	  F5,
	  WORD_FOR,          /* Ctrl-Rt */
	  WORD_BACK          /* Ctrl-Lk */
	  },
	{ WIN_NEXT,          /* F8 */
	  WIN_PREV,          /* F9 */
	  WIN_CHOOSE,        /* Alt-F8 */
	  WIN_RESIZE         /* Alt-F9 */
	  },
	{ COLORS_KEY,
	  TAB_KEY,
	  OPTION_KEY,
	  CONFIG_KEY
	  },   /* colors menu */
	{ F1}
	};

char * edit_lines[] = { " File ",
			" Edit ",
			" Search ",
			" Window ",
			" Option ",
			" Help ",
			NULL },
     * edit_event[][MAXMENU_ENTRY] = {
		{
#ifdef DOS
		  " New           Alt-F1 ",
		  " Open          Alt-F2 ",
		  " Save          Alt-F3 ",
		  " Save as ..    Alt-F4 ",
		  " Close         Alt-F5 ",
		  " Exit             F12 ",
#else
		  " New            Esc-n ",
		  " Open              F6 ",
		  " Save              F2 ",
		  " Save as ..     Esc-a ",
		  " Close          Esc-c ",
		  " Exit             F12 ",
#endif
		  NULL },
		{
#ifdef UNIX
		  " File Insert               F7 ",
		  " Block begin           Ctrl-B ",
		  " Block end             Ctrl-E ",
		  " Block Save as ...      Esc-b ",
		  " Block paste           Ctrl-P ",
		  " Block cut             Ctrl-R ",
		  " Block undo            Ctrl-U ",
		  " Block insert          Ctrl-N ",
		  " Block unmark          Ctrl-V ",
		  " Line delete           Ctrl-Y ",
		  " Line insert           Ctrl-O ",
		  " Insert/Overwrite      Insert ",
		  " Insert control char.  Ctrl-A ",
#else
		  " File Insert            Alt-F6 ",
		  " Block begin           Ctrl-F1 ",
		  " Block end             Ctrl-F2 ",
		  " Block Save as ...     Ctrl-F3 ",
		  " Block paste           Ctrl-F4 ",
		  " Block cut             Ctrl-F5 ",
		  " Block undo            Ctrl-F6 ",
		  " Block insert          Ctrl-F7 ",
		  " Block unmark          Ctrl-F8 ",
		  " Line delete    Ctrl-Y/Ctrl-F9 ",
		  " Line insert          Ctrl-F10 ",
		  " Insert/Overwrite       Insert ",
		  " Insert control char.   Ctrl-A ",
#endif
		  NULL
		  },
		{
		  " Search           Ctrl-K F3 ",
		  " Replace          Ctrl-X F4 ",
		  " Goto line        Ctrl-G F5 ",
#ifdef UNIX
		  " First line          Ctrl-F ",
		  " Last line           Ctrl-L ",
		  " Word forwards       Ctrl-W ",
		  " Word backwords      Ctrl-T ",
#else
		  " First line       Ctrl-PgUp ",
		  " Last line        Ctrl-PgDn ",
		  " Word forwards    Ctrl-CrRt ",
		  " Word backwords   Ctrl-CrLf ",
#endif
		  NULL
		  },
		{
#ifdef UNIX
		  " Next window           F8 ",
		  " Prev window           F9 ",
		  " List all windows   Esc-l ",
		  " Move               Esc-m ",
#else
		  " Next window            F8 ",
		  " Prev window            F9 ",
		  " List all windows   Alt-F8 ",
		  " Move               Alt-F9 ",
#endif
		  NULL
		  },
		{ " Colors       ",
		  " Tab Size     ",
		  " Setup        ",
		  " Save Setup   ",
		  NULL
		  },
		{ " Help        F1 ", NULL }
		};

/************************************************************************/
/********* read the name of file to save/edit /insert *******************/
/************************************************************************/

#ifdef XX
int get_string( char * fname, char * title)
{
  struct frame_t * f;
  struct input_t * in;
  int width = min( max_x, 60),
  down  = min( max_y,  4),
  y     = (max_y-down)/2,
  x     = (max_x-width)/2,
  ret_;
  
  f  = make_frame( x, y, width, down, title, leer,
		  F_B_DIALOG_CLR, NOMODE);
  in = make_input( f, 1, CUR_MODE | FIL_MODE | INS_MODE);
  f_putstr( f, 1, 2, "Filename: ", f->color, NOMODE);
  
  input_string (in, 0, 12, 2, fname, NAMELEN-1, NAMELEN-1);
  
  view_frame( f);
  ret_ = f_getstr( in);
  
  hide_frame( f, DELETE_MODE|HIDE_MODE);
  
  return( ret_ == ESC ? FALSE : TRUE);
}
#endif

int word_next( char * str, int pos)
{
  int i, len = strlen(str);
  
  if( pos >= 0) for( i=pos; i<len && str[i] != ' ' && str[i] != TAB; i++);
  else i = 0;           		    /* begin at the first character */
  
  for( i=i  ; i<len; i++)
    {
      if( str[i] != ' ' && str[i] != TAB) return( i);
    }
  return( -1);
}

int word_prev( char * str, int pos)
{
  int i,
  j,
  len = strlen(str),
  found;
  
  if( pos < len) for( i=pos; i>=0 && str[i] != ' ' && str[i] != TAB; i--);
  else i = len-1;           		    /* begin at the first character */
  
  for( j=i  ; j>=0; j--)
    {
      if( str[j] != ' ' && str[j] != TAB) { found = TRUE; break; }
    }
  if( found) for( j=j; j>=0; j--)
    {
      if( str[j] == ' ' || str[j] == TAB) return( j+1);
      if( j == 0) return( j);
    }
  return( -1);
}

int tab_getx( char * s, int pos)
{
  int i,
  tab_pos;
  
  pos = min( pos, strlen(s));
  
  for( i = tab_pos = 0; i < pos; i++)
    {
      tab_pos += (s[i] == TAB)
	? tab_size - (tab_pos%tab_size)
	  : s[i] >= CTRL_A && s[i] <= 31
	    ? 2
	      : 1;
      if( s[i] == 0) break;
    }
  
  return( tab_pos+1);
}

int tab_getpos( char * s, int pos)
{
  int i       ,
  tab_pos ,
  len     = strlen( s);
  
  if( pos > tab_getx( s, len)) return( len);
  
  for( i=0, tab_pos=0; tab_pos<pos-1 && s[i] != 0; i++)
    {
      tab_pos += ( s[i] == TAB)			/* Tab */
	? tab_size - (tab_pos%tab_size)
	  : s[i] >= CTRL_A && s[i] <= 31 	/* Control char. */
	    ? 2
	      : 1;					/* Normal char. */
    }
  
  return( min( i, len));
}

/*************************************************************************/
/***** File operations ***************************************************/
/*************************************************************************/

int file_save(  char * fname,
	      struct line_t  * head_line,
	      struct block_t * block,
	      int block_beg,
	      int block_end
	      )
{
  struct line_t * line      = line_getline( head_line, block_beg),
  * last_line = line_getline( head_line, block_end)->next;
  int first = TRUE,              /* for line feed "\n" */
  i,
  file_h;
  
  if( block != NULL)
    {
      line      = line_getline( head_line, block_beg),
      last_line = line_getline( head_line, block_end)->next;
    }
  else 
    {
      line	  = head_line->next;
      last_line = NULL;
    }
  
  file_h = open (fname,
		 O_RDWR | O_TRUNC | O_CREAT | O_TRUNC,
		 get_rights());
  
  if( file_h < 0)
    {
      message( " Can't open file ", " Save ");
      return( FALSE);
    }
  
  while( line != last_line)
    {
      if( ! first) write( file_h, "\n", 1);
      i = strlen( line->str);
      write( file_h, line->str, i);
      line = line->next;
      first = FALSE;               /* not more first time */
    }
  close( file_h);
  
  return( TRUE);
}

int file_saveas (char * fname, struct line_t  * head_line)
{
  char * filename ;
  char originalName [MAXPATH];
  char selectedName [MAXPATH];
  char newname      [MAXPATH];
  char title        [40] ;
  
#ifdef HAVE_REALPATH
#ifdef HAVE_READLINK
  readlink (fname, originalName, sizeof (originalName));
#else
  realpath (fname, originalName); /* restore the realpath of the original */
#endif
#endif
  
  sprintf (title, " Save <%s> as ", cutpath (basename(fname), 20, NOMODE)) ;
  
  filename = KH_dir (".",		/* don't change to dir. of the file */
		     basename (fname),  /* prompt for same name        */
		     title,
		     GETFILE_MODE | SAVEAS_MODE) ;
  
  if (filename == NULL) return FALSE ;
  
  strcpy (newname, filename);	/* a new name */
  
  /* if another existing file selected */
#ifdef HAVE_REALPATH
  if (
#ifdef HAVE_READLINK
      readlink (fname, selectedName, sizeof (selectedName)) &&
#else
      realpath  (newname, selectedName) != NULL &&	/* file exists */
#endif
      strcmp (originalName, selectedName) != 0	/* another file */
      )
    {
      char ask [] = " File exists, overwrite ?! ";
      if (Getyesno (ask,
		    NULL,
		    cutpath (newname, max_x-5, NOMODE), 
		    1)
	  != 0
	  )
	return FALSE ;
    }
#endif
  
  if (file_save (newname, head_line, NULL, 0, 0))
    {
      strcpy (fname, newname) ;  /* copy the new file name to original */
      return TRUE ;
    }
  return FALSE ;
}

/**************************************************************************/
/********* Block Operations                                            ****/
/**************************************************************************/

int block_paste( struct block_t * block,
		struct line_t * line,
		int block_beg,
		int block_end)
{
  
  if( block->top != NULL) {          /* delete old block */
    line_delall( block->top);
    block->top = NULL;
  }
  
  if( line == NULL) return( FALSE);
  
  block->cnt   = block_end - block_beg + 1;
  
  block->top   = block_copy( line, block->cnt); /* copy lines */
  
  if( block->top == NULL) return( FALSE);
  
  block->last  = line_last ( block->top);
  block->beg   = block_beg;
  block->end   = block_end;
  
  return( TRUE);
  
}

struct line_t * block_copy( struct line_t * line, int cnt)
{
  
  struct line_t * top_line  = NULL,
  * last_line = NULL,
  * tmp_line  = NULL,
  * xline     = NULL;
  int ret_ = TRUE, i;
  
  if( line == NULL) return( NULL);
  /* copy blocks */
  for( tmp_line=line, i=0;
      i<cnt && tmp_line != NULL;
      tmp_line=tmp_line->next, i++)
    {
      
      if( (xline = make_line()) == NULL) break;     /* no mem.    */
      
      ret_ = line_connstr( xline, tmp_line->str); /* add string */
      
      if( ret_ == FALSE) break;
      
      if( top_line == NULL) {			/* first line */
	top_line = last_line = xline;
	continue;
      }
      /* append on the end of queue */
      if( last_line != NULL) line_insline( last_line, xline);
      last_line = xline;
    }
  
  /* error expected */
  if( xline == NULL || ret_ == FALSE)
    {
      if( top_line != NULL) line_delall( top_line);
      return( NULL);
    }
  
  return( top_line);
}

/* insert block in editor */
struct line_t *  block_insert( struct line_t * pos, struct block_t * block) 
{
  struct line_t * top, * last, * p = pos->prev;
  
  if( block->top == NULL) return( NULL);
  
  top = block_copy( block->top, block->cnt);
  
  if( top == NULL) return( NULL);
  
  last = line_last( top);
  
  p->next = top;
  top->prev = p;
  
  pos->prev  = last;
  last->next = pos;
  return( top);
}

struct line_t *  block_undo( struct block_t * block, struct line_t * head)
{
  struct line_t * line1, * line2;
  
  if( block->top == NULL) return( NULL);
  
  line1 = line_getline( head, block->beg-1);	/* old position */
  line2 = line1->next;		        /* next line */
  
  line1->next      = block->top;
  block->top->prev = line1;
  
  block->last->next = line2;
  if( line2 != NULL) line2->prev = block->last;
  
  block->beg = line_number( head, block->top);
  block->end = line_number( head, block->last);
  
  block->top = NULL;
  
  return( line1->next);    /* return the first line in the block */
}

int block_cut( struct block_t * block,
	      struct line_t * head_line,
	      int block_beg,
	      int block_end)
{
  
  struct line_t * line      = line_getline( head_line, block_beg),
  * last_line = line_getline( head_line, block_end),
  * line1, * line2,
  * q;
  
  if( last_line->next == NULL)
    {
      if( ( q = make_line()) == NULL) return( FALSE); /* last line */
      line_insline( last_line, q);      /* a new line */
    }
  
  if( ! block_paste( block, line, block_beg, block_end)) return( FALSE);
  
  line1 = line->prev;           /* befor deleting, save the headers */
  line2 = last_line->next;
  /* delete the editor lines from buffer */
  for( q = line; q != line2; q = line_delline( q));
  
  line1->next = line2;   /* connect the lines togother */
  line2->prev = line1;
  return( TRUE);
}

/************************************************************************/
/********   save block as file                                   ********/
/************************************************************************/

int block_saveas( struct block_t * block,
		 struct line_t  * head_line,
		 int block_beg,
		 int block_end)
{
  char * filename ;
  filename = KH_dir (".", basename(temp_fname),
		     " Save block as ... ",
		     GETFILE_MODE|SAVEAS_MODE
		     );
  if (filename == NULL) return FALSE ;
  strcpy (temp_fname, filename) ;
  
  return( file_save(  temp_fname,
		    head_line,
		    block,
		    block_beg,
		    block_end
		    ) );
}

/**************************************************************************/
/********* Line Operations                                            *****/
/**************************************************************************/

struct line_t * make_line( void)
{
  struct line_t * q;
  
  q = try_getmem( sizeof( struct line_t));
  
  if (q == NULL) return( NULL);
  
  q->prev = q->next = NULL;
  
  q->str  = try_getmem( 1);
  if( q->str == NULL)
    {
      Free (q);
      return( NULL);
    }
  
  q->str[0] = 0;
  
  return( q);
}

void line_delall( struct line_t * line)
{
  while( (line = line_delline(line) ) != NULL); /* delete all lines */
}

struct line_t * line_last( struct line_t * line)
{
  while( line->next != NULL) line = line->next;
  return( line);
}

int line_reconst( struct line_t * line)
{
  int i = strlen(line->str)+1;
  char * q = realloc (line->str, i);
  
  if( q == NULL) return( FALSE);
  line->str = q;
  return( TRUE);
}

int line_resize( struct line_t * line)
{
  int len = strlen( line->str);
  char * q = realloc (line->str, len+2);
  if (q == NULL) return( FALSE);
  line->str = q;
  line->str[len+1]    = 0;
  
  return( TRUE);
}

/* append a character to the line string */
int line_inschr( struct line_t * line, char ch, int pos)
{
  int len = strlen( line->str);
  
  if( pos >= len)
    {
      if( ! line_resize( line)) return( FALSE);
      line->str[pos+1] = 0;
    }
  
  line->str[pos] = ch;
  
  return( TRUE);
}

int line_connstr( struct line_t * line, char * str)
{
  size_t len = strlen(str) + strlen( line->str)+1;
  char * q;
  
  if( strlen( str) ==0) return( TRUE);
  
  if( ( q=realloc(line->str,len) ) == NULL) return( FALSE);
  line->str = q;
  strcpy( line->str+strlen(line->str), str);
  return( TRUE);
}

int line_number( struct line_t * top_line, struct line_t * line)
{
  struct line_t * q;
  int i;
  for( q = top_line->next, i=0;
      
      q != line && q->next != NULL;
      
      i++, q = q->next
      );
  return( i);
}

struct line_t * line_getline( struct line_t * top_line, int number)
{
  struct line_t * q;
  int i;
  for( q = top_line->next, i=0;
      i<number && q->next != NULL;
      i++, q = q->next
      );
  return( q);
}

int line_count( struct line_t * top_line)
{
  struct line_t * line;
  int i;
  for(i=0, line = top_line->next; line != NULL; i++, line = line->next);
  return( i);
}

struct line_t * line_lastline( struct line_t * line)
{
  struct line_t * q = line;
  while( q->next != NULL) q = q->next;
  return( q);
}

void line_insline( struct line_t * l_pos, struct line_t * ed)
{
  struct line_t * p = l_pos->next;
  ed->prev    = l_pos;
  ed->next    = p;
  l_pos->next = ed;
  if( p != NULL) p->prev = ed;
}

struct line_t * line_delline( struct line_t * line)
{
  struct line_t * p, * q;
  
  if (line == NULL) return( NULL);
  
  p = line->prev;
  q = line->next;
  
  if( p != NULL) p->next = q;     /* think on head top */
  if( q != NULL) q->prev = p;     /* for last line */
  Free (line->str);
  Free (line);
  
  return( q != NULL ? q : p);    /* return the next line if avail */
  /* otherwise the prev. line	*/
}

struct line_t * edit_findstr (struct frame_t * f,
			      struct line_t * top_line,
			      char * str,
			      int  lines,
			      int * x_pos,
			      int mode
			      )
{
  struct line_t * line = top_line;
  char
    gr_chr = '*',
    gr_emp = '-';
  int
    i,
    value,
    blck,                            /* the readed buffer block */
    gr_x     = 2,                    /* graphic line x-coord. */
    gr_y     = 4,                    /* graphic line y-coord. */
    gr_view  = 0,                    /* view graphic in cycles */
    gr_width = f->width-4,           /* graphic view width */
    pos;
  
  f_putnchr( f, gr_x, gr_y, gr_emp, gr_width, F_B_DIALOG_CLR, SCR_MODE);
  
  for (line    = top_line,
       value   = 0,
       gr_view = 0,
       pos     = min(*x_pos+1,strlen(top_line->str));
       
       line    != NULL;
       
       line    = line->next,
       gr_view++,
       pos = 0
       )
    {
      /* ignore the unsigned 0 *
       * search interactive
       */
      if (mode & CASES_MODE)
	{
	  value = nstrfind (line->str+pos, 
			    str, 
			    strlen(line->str+pos), 
			    strlen(str));
	}
      else
	{
	  value = case_strfind (line->str+pos, 
				str, 
				strlen(line->str+pos), 
				strlen(str),
				mode
				);
	}
      
      if( (gr_view++ % 10) == 0)
	{
	  i = (gr_view*gr_width) / lines;
	  f_putnchr( f, gr_x, gr_y, gr_chr, i, F_B_DIALOG_CLR, SCR_MODE);
	  fflush_();
	}
      
      if( value > 0) break;           /* battern found */
    }
  
  if( line == NULL || value == 0)
    {
      message( " String not found ", leer);
      return ( top_line);
    }
  *x_pos = value+pos-1;
  return( line);
}

struct line_t * edit_findtext( struct line_t * top_line,
			      char * str,
			      int lines,
			      int *x_pos,
			      int mode)
{
  struct frame_t * f;
  struct input_t * in;
  struct line_t  * line;
  struct log_t   * lg[1];
  char * cases[] = { "X", " " };
  int
    i,
    width = min( max_x, 60),
    down  = 6,
    x     = (max_x-width)/2,
    y     = (max_y-down )/2,
    lk;
  
  f  = make_frame( x, y, width, down, " Search ", leer,
		  F_B_DIALOG_CLR,
		  NOMODE);
  in    = make_input (f, 2, CUR_MODE|INS_MODE);
  lg[0] = make_log   (f, 2, F_B_DIALOG_CHS);
  log_format (lg [0], "X", " ");
  log_xy     (lg [0], 18, 3, 18, 3);
  log_setpos (lg[0], 1);             /* default: not case sensitive */
  
  f_putstr( f, 1, 1, "String:", f->color, NOMODE);
  f_putstr (f, 1, 3, "case sensitive:", f->color, NOMODE) ;
  
  input_string (in, 0, 9, 1, str, FINDLEN, FINDLEN);
  input_log    (in, 1, lg [0]);
  
  view_frame( f);
  lk  = f_getstr( in);
  if (lg[0]->pos == 0) mode |= CASES_MODE ;
  if( (lk == ENTER || lk == CTRL_M) && strlen(str) > 0)
    {
      line = edit_findstr( f, top_line, str, lines, x_pos, mode);
    }
  else line = top_line;
  
  del_input ( in);
  hide_frame( f, HIDE_MODE|DELETE_MODE);
  
  return( line);
}

/*********************************************************************/
struct line_t * edit_replace (struct frame_t * f,
			      struct line_t * top_line,
			      char * str,
			      char * with,
			      int  lines,
			      int * x_pos,
			      int mode
			      )
{
  struct line_t * line = top_line;
  char gr_chr = '*',
  gr_emp = '-',
  *          q;
  int i,
  value,
  blck,                            /* the readed buffer block */
  gr_x     = 2,                    /* graphic line x-coord. */
  gr_y     = 5,                    /* graphic line y-coord. */
  gr_view  = 0,                    /* view graphic in cycles */
  gr_width = f->width-4,           /* graphic view width */
  pos;
  
  f_putnchr( f, gr_x, gr_y, gr_emp, gr_width, F_B_DIALOG_CLR, SCR_MODE);
  
  for( line    = top_line,
      value   = 0,
      gr_view = 0,
      pos     = min(*x_pos+1,strlen(top_line->str));
      
      line    != NULL;
      
      line    = line->next,
      gr_view++,
      pos = 0
      )
    {
      /* ignore the unsigned 0
       * search interactive for the given
       * pattern
       */
      value = nstrfind( line->str+pos, 
		       str, 
		       strlen(line->str+pos), 
		       strlen(str));
      
      /*
       * graphic for optic
       */
      if( (gr_view++ % 10) == 0)
	{
	  i = (int) ( (long) (gr_view*gr_width) / lines);
	  f_putnchr( f, gr_x, gr_y, gr_chr, i, f->color, SCR_MODE);
	  fflush_();
	}
      
      if( value > 0) break;           /* battern found */
    }
  
  if( line == NULL || value == 0)
    {
      message( " String not found ", leer);
      return ( top_line);
    }
  *x_pos = value+pos-1;
  
  /* save the rest of string */
  i = *x_pos + strlen(str);
  if( i < strlen(line->str))
    {
      q = getmem( strlen(line->str+i) + 1);
      strcpy( q, line->str+i);
    }
  else q = NULL;
  
  line->str[ *x_pos] = 0;
  line_connstr( line, with);   /* insert the new string */
  
  if( q != NULL) {			/* CONNECT the string rest */
    line_connstr( line, q);
    Free( q);
  }
  
  return( line);
}

struct line_t * edit_reptext( struct line_t * top_line,
			     char * str,
			     char * with,
			     int lines,
			     int *x_pos,
			     int mode)
{
  struct frame_t * f;
  struct input_t * in;
  struct line_t  * line;
  int width = min( max_x, 60),
  down  = 7,
  x     = (max_x-width)/2,
  y     = (max_y-down )/2,
  lk, i;
  
  f  = make_frame( x, y, width, down, " Replace ", leer, F_B_DIALOG_CLR, NOMODE);
  in = make_input( f, 2, CUR_MODE|INS_MODE);
  
  f_putstr( f, 1, 1, "String:", f->color, NOMODE);
  f_putstr( f, 1, 3, "With  :", f->color, NOMODE);
  input_string (in, 0, 9, 1, str,  FINDLEN, FINDLEN);
  input_string (in, 1, 9, 3, with, FINDLEN, FINDLEN);
  
  view_frame( f);
  
  lk  = f_getstr( in);
  
  if( (lk == ENTER || lk == CTRL_M) && strlen(str) > 0)
    {
      line = edit_replace( f, top_line, str, with, lines, x_pos, mode);
    }
  else line = top_line;
  
  del_input ( in);
  hide_frame( f, HIDE_MODE|DELETE_MODE);
  
  return( line);
}

/************************************************************************/
/********   insert temp.-file                                    ********/
/************************************************************************/

int read_tempfile( struct frame_t * edit_f, struct line_t * line)
{
  int ret_;
  char * filename ;
  
  filename = KH_dir (".",
		     basename (temp_fname),
		     " Insert a file ",
		     GETFILE_MODE | EXISTS_MODE
		     );
  
  if (filename == NULL) return FALSE ;
  
  strcpy (temp_fname, filename) ;
  
  ret_ = read_lines( edit_f, temp_fname, line);  /* read the file */
  
  if( ! ret_)
    {
      message( " File not found ", temp_fname);
    }
  return ( ret_);
}

/************************************************************************/
/******    read file and append it on the line pointer 		*********/
/************************************************************************/

int read_lines( struct frame_t * f,
	       char * txt_file,
	       struct line_t * line)
{
  struct line_t * tmp_line;
  char buf[ READ_SIZE+2],
  tmp[ READ_SIZE+2];
  int file_h,
  lines = 0,
  len   = 0,
  pos   = 0,
  pos_e = 0,
  ret_  = TRUE;
  
  file_h = open( txt_file, O_RDONLY);
  if( file_h < 0)
    {
      return( 0);
    }
  
  /* create the first line */
  if( (tmp_line = make_line()) == NULL)
    {
      close( file_h);
      return lines;
    }
  lines++;
  line_insline( line, tmp_line);
  line = tmp_line;
  
  for( pos_e= tmp[0] = 0; TRUE; )
    {
      len = read( file_h, buf, READ_SIZE);
      /* create extra line anyway */
      if( len <= 0)  break;
      
      for( pos = 0; pos<len; pos++)
	{
	  
	  if( buf[pos] == 10)
	    {
	      /* append the rest of string to last line */
	      if( ! (ret_ = line_connstr( line, tmp))) break;
	      pos_e = tmp[0] = 0;
	      
	      /* create a new line */
	      if( (tmp_line = make_line()) == NULL)
		{
		  ret_ = 0;
		  break;
		}
	      
	      line_insline( line, tmp_line);
	      line       = tmp_line;
	      lines++;
	      

	      if((lines % 100) == 0)
		{
		  sprintf ( tmp, "%05i:%05i", lines, 0);
		  f_putstr( f, 2, f->down+2, tmp, f->color, SCR_MODE);
		  fflush_();
		}
	      pos_e  = 0;
	      tmp[0] = 0;
	    }
	  else
	    {
#ifdef DOS
	      if( buf[pos] != 13) tmp[pos_e++] = buf[pos];
#else
	      tmp [pos_e++] = buf [pos] ;
#endif
	    }
	  tmp[pos_e] = 0;
	}
      
      if( ret_ == 0) break;
      /* connect the readed string at end of actual line */
      ret_   = line_connstr( line, tmp);
      tmp[0] = pos_e = 0;
      
      if( ret_ == 0) break;
    }
  close( file_h);
  
  return( lines);
}
  
  
void edit_ChangeTitle (struct edit_t * ed)
{
  char tmp [MAXPATH] ;
  sprintf  (tmp,
		" Edit file <%s> ",
	    cutpath (ed->txt_file, ed->f->width-16, NOMODE)
	    );
  f_change_t1 (ed->f, tmp) ;
}
/*********************************************************************/

int tmp_number = 0;	/* to create temp. files */

char * gettemp ( char * path, char * name)
{
  char * p   = (path==NULL) ? leer : path;
  char * tmp = getmem( strlen(p) + strlen(name) + 10);
  
  for ( ; TRUE; )
    {
      sprintf( tmp, "%s%s%02i", p, name, tmp_number);
      tmp_number ++;
      if( ! exist( tmp) ) break;
    }
  return ( tmp);
}

#define NONAME		"noname"

struct edit_t * make_edit( char * txt_file,
			  int x, int y, int width, int down
			  )
{
  
  struct edit_t * ed;
  char   tmp[256],
  * unknown = gettemp( NULL, NONAME);
  int ret_;
  
  ed = getmem( sizeof( struct edit_t));
  
  strcpy( ed->txt_file, txt_file != NULL
	 ? txt_file
	 : (unknown==NULL) ? "NONAME" : unknown );
  if (unknown != NULL) Free( unknown);
  
  ed->f_size = file_size( ed->txt_file, NOMODE); /* file size */
  
  /*
     ed->f = make_frame( x, y, width, down, leer, leer, F_B_NORMAL, NOMODE);
     */
  ed->f = make_frame( x, y, max_x, max_y, leer, leer, F_B_NORMAL, NOMODE);
  edit_ChangeTitle (ed) ;
  
  f_changeW ( ed->f, width);
  f_changeD ( ed->f, down );
  
  f_putline( ed->f, ed->f->down-1, ed->f->color);
  ed->f->down   = ed->f->down-2;
  ed->f->type  |= SCROLL_RIGHT_MODE | SCROLL_BUTTOM_MODE;
  f_makescroller (ed->f);
  
  ed->head_line =
    ed->tmp_line  =
      ed->line      = make_line();	 /* make the top line */
  
  view_frame (ed->f);
  
  ret_ = read_lines( ed->f, ed->txt_file, ed->head_line); /* read lines from file */
  
  if( ! ret_ && strcmp( ed->txt_file, txt_file) == 0)
    {
      message( "File not found ", txt_file);
    }
  
  if( ed->head_line->next == NULL) {		/* if the file is empty */
    ed->line    = make_line();
    line_insline( ed->head_line, ed->line);
  }
  
  ed->line      =
    ed->tmp_line  =
      ed->line_open = ed->head_line->next;
  ed->lines     = line_count( ed->head_line);
  
  ed->num_akt_line    = 0,
  ed->num_line_open   = 0,
  ed->line_len   	= 0,
  ed->out_begin  	= 0,
  ed->out_faktor 	= 16;
  
  ed->refr            = TRUE,
  ed->modified        = FALSE,		/* view if text is modified */
  ed->pos_x           = 0,                /* x-coord. of aktual choose block */
  ed->pos_y           = 0,                /* y-coord. of aktual choose block */
  ed->akt_x           = 0,
  ed->tab_x           = 0,
  ed->tab_g           = 0,
  ed->block_beg       = -1,
  ed->block_end       = -1,
  ed->pos_e	        = 0;
  ed->block_lastcom   = FALSE;
  
  f_reposition (ed->f, ed->num_akt_line, ed->lines-1, SCROLL_RIGHT_MODE);
  
  return ed;
}

void dele_edit( struct edit_t * ed)
{
  line_delall( ed->head_line);
  hide_frame ( ed->f, DELETE_MODE|HIDE_MODE);
  Free       ( ed);
}

#ifdef UNIX
#	define EDIT_CNT	40
#else
#	define EDIT_CNT	20
#endif

void KHA_editor ( char * txt_file)
     
{
  struct edit_t  * ed, * edx[ EDIT_CNT];
  struct frame_t * func_f;           /* function keys frame */
  struct block_t block;         /* block */
  char
    hlp_text[] =
      "F10:Menu#1:Hlp#2:save#3:Srch#4:Rep#"
	"5:Go#6:Open#7:Ins#8:Next#9:Prev#F12:End" ;
  char 
    leave_ [] =	" Leave, Are you sure ? ",
    save_  [] =	" Save, Are you sure ? ";
  char tmp [256], c;
  
  int
    lk,                                          /* last key */
    i,
    j,
    end_ = FALSE,
    old_out_formatted;
  
  int
    file_h,
    ed_num = 0,
    ed_cnt = 1;                /* file handler */
  
  tmp_number = 0;		/* temp. files */
  
  for( i=0; i<EDIT_CNT; i++) edx[i] = NULL;
  ed = edx[ed_num] = make_edit( txt_file,
			       0,
			       1,
			       max_x,
			       max_y-2);
  
  block.top = block.last = NULL;   /* empty block */
  block.cnt = 0;
  block.ed  = NULL;
  
  func_f    = make_help (hlp_text, 0, max_y-1, max_x-1);
  
  view_frame( func_f);		/* keys */
  ins_help_line( VIEW_INS_MODE);	/* insert mode frame */
  fflush_();
  
  view_frame( ed->f);			 /* editor frame */
  
  while( TRUE)
    {
      ed->pos_y     = ed->num_akt_line - ed->num_line_open;
      ed->line_len  = strlen( ed->line->str);
      
      sprintf ( tmp, "%05i:%05i [%s] Lines: %05i Size: %li ",
	       ed->num_akt_line+1, 		/* AKTUAL line */
	       ed->akt_x+1, 			/* act. x position */
	       (ed->modified ? "**" : "--"),
	       ed->lines,			/* text lines */
	       ed->f_size			/* file size */
	       );
      f_putstr( ed->f, 2, ed->f->down+2, tmp, ed->f->color, SCR_MODE);
      
      f_reposition (ed->f, ed->num_akt_line,  ed->lines-1,
		    SCROLL_RIGHT_MODE);
      f_reposition (ed->f, ed->akt_x, ed->line_len,
		    SCROLL_BUTTOM_MODE);
      
      ed->tab_x = tab_getx( ed->line->str, min( ed->line_len, ed->akt_x));
      
      while(	ed->tab_x > ed->f->width+ed->out_begin-3)
	{
	  ed->out_begin += ed->out_faktor;
	  ed->refr       = TRUE;
	}
      
      while(	ed->out_begin > 0 && ed->tab_x < ed->out_begin+1)
	{
	  ed->out_begin = max( 0, ed->out_begin-ed->out_faktor-ed->f->down+3);
	  ed->refr      = TRUE;
	}
      
      i = tab_getpos( ed->line->str, ed->out_begin);
      
      ed->tab_x = tab_getx( ed->line->str + i,
			   min( ed->line_len,
			       ed->akt_x) - i);
      
      if( ed->refr)
	{
	  ed->tmp_line      = ed->line_open;
	  old_out_formatted = out_formatted;      /* to view ^H */
	  out_formatted     = FALSE;
	  for( i=0; i<ed->f->down; i++)
	    {
	      f_putstr( ed->f, 1,
		       1+i,
		       ( ed->tmp_line != NULL
			? ed->tmp_line->str +
			min( strlen( ed->tmp_line->str),
			    tab_getpos( ed->tmp_line->str, ed->out_begin)
			    )
			: leer),
		       ( ed->num_line_open+i >= ed->block_beg &&
			ed->num_line_open+i <= ed->block_end &&
			ed->num_line_open+i <  ed->lines
			? F_B_BLOCK_CLR
			: ed->f->color),
		       FILL_MODE|SCR_MODE);
	      if( ed->tmp_line != NULL) ed->tmp_line = ed->tmp_line->next;
	    }
	  ed->refr = FALSE;
	  out_formatted = old_out_formatted;
	}
      
      gotoXY( ed->f->x + ed->tab_x,  ed->f->y+ed->pos_y+1);
      
      view_cursor();
      lk = getkey(-1);
      
      switch( lk)
	{
	case F10:
	  lk = menu( edit_keys, edit_lines, edit_event);
	  break;
	}
      
      switch( lk)
	{
	  
	case CONFIG_KEY:
	  save_config(&MY_cfg);
	  break;
	case TAB_KEY:
	  change_tab();
	  ed->refr = TRUE;
	  break;
	case COLORS_KEY:
	  change_colors();
	  break;
	case OPTION_KEY:
	  MY_setup(&MY_cfg);
	  break;
	case CUR_RIGHT:
	  ed->pos_x = ed->akt_x = min( ed->line_len, ed->akt_x+1);
	  ed->tab_g = tab_getx( ed->line->str, ed->pos_x);
	  break;
	  
	case CUR_LEFT:
	  ed->pos_x = ed->akt_x = max( 0, ed->akt_x-1);
	  ed->tab_g = tab_getx( ed->line->str, ed->pos_x);
	  break;
	  
	case CUR_DOWN:
	  if( ed->line->next == NULL) break;
	  
	  ed->line = ed->line->next;
	  ed->num_akt_line = min( ed->lines-1, ed->num_akt_line+1);
	  
	  ed->akt_x = tab_getpos( ed->line->str, ed->tab_g );
	  break;
	  
	case CUR_UP:
	  if( ed->line == ed->head_line->next) break;
	  ed->line         = ed->line->prev;
	  ed->num_akt_line = max( 0, ed->num_akt_line-1);
	  
	  ed->akt_x = tab_getpos( ed->line->str, ed->tab_g );
	  break;
	  
	case PAGE_UP:
	  for( i = 0; i <ed->f->down-1 && ed->num_akt_line > 0; i++)
	    {
	      ed->num_akt_line--;
	      ed->line = ed->line->prev;
	    }
	  break;
	  
	case PAGE_DOWN:
	  for( i = 0; i <ed->f->down-1 && ed->num_akt_line < ed->lines-1; i++)
	    {
	      ed->num_akt_line++;
	      ed->line = ed->line->next;
	    }
	  break;
	  
	case HOME:
	  ed->pos_x = ed->akt_x = 0;
	  ed->tab_g = tab_getx( ed->line->str, ed->pos_x);
	  break;
	  
	case END:
	  ed->pos_x = ed->akt_x = ed->line_len;
	  ed->tab_g = tab_getx( ed->line->str, ed->pos_x);
	  break;
	  /* first line */
#ifdef DOS
	case CTRL_PAGE_UP:
#endif
	case CTRL_F:
	  ed->num_akt_line = 0;
	  ed->line = ed->head_line->next;
	  break;
	  /* last line */
#ifdef DOS
	case CTRL_PAGE_DOWN:
#endif
	case CTRL_L:
	  ed->num_akt_line = ed->lines-1;
	  ed->line = line_lastline( ed->line);
	  break;
	  
	  /* append line */
	case LINE_APP:
	  
	  if( (ed->tmp_line = make_line()) == NULL) break;
	  
	  ed->modified = TRUE;
	  
	  line_insline( ed->line->prev, ed->tmp_line);     /* append a new line */
	  
	  if( ed->line_open == ed->line) ed->line_open = ed->tmp_line;
	  ed->line = ed->tmp_line;
	  ed->lines++;
	  
	  ed->refr = TRUE;
	  break;
	  
	  /* insert line */
	case LINE_INS:
	case CTRL_O:
#ifdef DOS
	case CTRL_F10:
#endif
	  if( ( ed->tmp_line = make_line()) == NULL) break;
	  
	  ed->modified = TRUE;
	  
	  line_insline( ed->line->prev, ed->tmp_line);
	  if( ed->line_open == ed->line) ed->line_open = ed->tmp_line;
	  
	  if( ed->block_beg >  ed->num_akt_line) ed->block_beg++;
	  if( ed->block_end >= ed->num_akt_line) ed->block_end++;
	  
	  ed->line = ed->tmp_line;
	  ed->lines++;
	  ed->refr = TRUE;
	  break;
	  
	  /* delete line */
	case LINE_DEL:
	case CTRL_Y:
#ifdef DOS
	case CTRL_F9:
#endif
	  ed->refr     = TRUE;
	  ed->modified = TRUE;
	  
	  if( ed->line->next == NULL) {      /* last line */
	    ed->line->str[0] = 0;
	    line_resize( ed->line);
	    break;
	  }
	  
	  ed->tmp_line = ed->line;            /* next line */
	  
	  ed->line = line_delline( ed->line);
	  if( ed->line_open == ed->tmp_line) ed->line_open = ed->line; /* 1. frame line */
	  
	  ed->pos_x = ed->akt_x = 0;
	  ed->tab_g = tab_getx( ed->line->str, ed->pos_x);
	  
	  if( ed->block_end >= ed->num_akt_line) ed->block_end--;
	  if( ed->block_end < ed->block_beg) ed->block_beg = ed->block_end = -1;
	  if( ed->block_beg >= ed->num_akt_line) ed->block_beg--;
	  
	  ed->lines--;
	  break;
	  /* help */
	case F1:
	  help();
	  break;
	  /* save file */
	case FILE_SAVE:
#ifdef DOS
	case ALT_F3:
#endif
	case F2:
	  sprintf( tmp, " %s ",
		  cutpath (ed->txt_file, max_x-8,NOMODE)
		  );
	  if (Getyesno (save_, NULL, tmp, 0) != 0) break;
	  
	  
	  if( ! file_save (ed->txt_file, ed->head_line, NULL, 0, 0))
	    break;
	  
	  ed->modified = FALSE;
	  
	  break;
	  
	case FILE_SAVEAS:
#ifdef DOS
	case ALT_F4:
#else
	case ESC_a:
#endif
	  
	  if (file_saveas ( ed->txt_file, ed->head_line))
	    
	    {
	      edit_ChangeTitle (ed) ;	     /* to view the new name */
	      f_rahmen         (ed->f, NOMODE);
	      view_frame       (ed->f) ;
	    }
	  
	  break;
	  
	case WIN_RESIZE:
#ifdef DOS
	case ALT_F9:
#else
	case ESC_m:
#endif
	  f_resize ( ed->f, 0, 1, max_x, max_y, MOVE_MODE|RESIZE_MODE);
	  f_putline( ed->f, ed->f->rows-3, ed->f->color);
	  ed->f->down     = ed->f->rows-4;
	  ed->refr        = TRUE;
	  view_frame (ed->f);
	  
	  break;
	  
	case FILE_CLOSE:
#ifdef DOS
	case ALT_F5:
#else
	case ESC_c:
#endif
	  if( ed_cnt == 1)
	    {
	      message ( " There is only this window ", " Close ");
	      break;
	    }
	  dele_edit( ed);
	  edx[ ed_num] = NULL;
	  for ( i=ed_num; i<EDIT_CNT-1; i++)
	    {
	      if ( edx[i+1] != NULL)
		{
		  edx[i  ] = edx[i+1];
		  edx[i+1] = NULL;
		}
	    }
	  ed_cnt --;
	  if( edx[ ed_num] == NULL) ed_num--;
	  ed = edx[ ed_num];
	  view_frame ( ed->f);
	  break;
	  /* search */
	case F3:
	case CTRL_K:
	  ed->line         = edit_findtext( ed->line,
					   file_search,
					   ed->lines,
					   & ed->akt_x,
					   NOMODE);
	  ed->num_akt_line = line_number( ed->head_line, ed->line);
	  ed->pos_x        = ed->akt_x;
	  ed->tab_g        = tab_getx( ed->line->str, ed->pos_x);
	  break;
	  /* replace command */
	case F4:
	case CTRL_X:
	  ed->line         = edit_reptext( ed->line,
					  file_search,
					  file_with,
					  ed->lines,
					  & ed->akt_x,
					  NOMODE);
	  ed->num_akt_line = line_number( ed->head_line, ed->line);
	  ed->pos_x        = ed->akt_x;
	  ed->tab_g        = tab_getx( ed->line->str, ed->pos_x);
	  
	  ed->modified = TRUE;
	  ed->refr = TRUE;
	  break;
	  
	case F5:
	case CTRL_G:
	  ed->num_akt_line = file_goto( ed->lines, ed->num_akt_line);
	  ed->line = line_getline( ed->head_line, ed->num_akt_line);
	  break;
	  
	case WORD_FOR:
#ifdef DOS
	case CTRL_CUR_RIGHT:
#endif
	case CTRL_W:
	  {
	    int fnd = FALSE, old_x = ed->akt_x;
	    for( ed->tmp_line  = ed->line;
		ed->tmp_line != NULL;
		ed->tmp_line  = ed->tmp_line->next)
	      {
		
		if( ( ed->akt_x = word_next( ed->tmp_line->str, ed->akt_x)) >= 0)
		  {
		    fnd = TRUE;
		    break;
		  }
		ed->akt_x = -1;
	      }
	    if( ! fnd) { ed->akt_x = old_x; break; }
	    ed->line         = ed->tmp_line;
	    ed->num_akt_line = line_number( ed->head_line, ed->tmp_line);
	    ed->pos_x        = ed->akt_x;
	    ed->tab_g        = tab_getx( ed->line->str, ed->pos_x);
	    ed->refr = TRUE;
	  }
	  break;
	  
	case WORD_BACK:
#ifdef DOS
	case CTRL_CUR_LEFT:
#endif
	case CTRL_T:
	  {
	    int fnd = FALSE, old_x = ed->akt_x;
	    for( ed->tmp_line = ed->line;
		ed->tmp_line != ed->head_line;
		)
	      {
		
		if( ( ed->akt_x = word_prev( ed->tmp_line->str, ed->akt_x)) >= 0)
		  {
		    fnd = TRUE;
		    break;
		  }
		ed->tmp_line = ed->tmp_line->prev;       /* prev. line */
		ed->akt_x = strlen(ed->tmp_line->str)+1; /* begin at the end */
	      }
	    if( ! fnd) { ed->akt_x = old_x; break; }
	    ed->line         = ed->tmp_line;
	    ed->num_akt_line = line_number( ed->head_line, ed->tmp_line);
	    ed->pos_x        = ed->akt_x;
	    ed->tab_g        = tab_getx( ed->line->str, ed->pos_x);
	    ed->refr 	   = TRUE;
	  }
	  break;
	  
	case BLOCK_BEG:
#ifdef DOS
	case CTRL_F1:
#endif
	case CTRL_B:
	  ed->block_beg = ed->num_akt_line;
	  if( ed->block_beg > ed->block_end) ed->block_end = -1;  /* must be */
	  ed->refr = TRUE;
	  break;
	  
	case BLOCK_END:
#ifdef DOS
	case CTRL_F2:
#endif
	case CTRL_E:
	  /* change the coordinates */
	  if( ed->block_beg > ed->num_akt_line)
	    {
	      ed->block_end = ed->block_beg;
	      ed->block_beg = ed->num_akt_line;
	    }
	  else
	    {
	      ed->block_end = ed->num_akt_line;
	    }
	  ed->refr = TRUE;
	  break;
	  
	case BLOCK_SAVEAS:
#ifdef DOS
	case CTRL_F3:
#else
	case ESC_b:
#endif
	  if( ed->block_beg > ed->block_end || ed->block_end == -1) break;
	  block_saveas( &block, ed->head_line, ed->block_beg, ed->block_end);
	  ed->refr = TRUE;
	  break;
	  
	case BLOCK_UNDEF:
	case CTRL_V:
#ifdef DOS
	case CTRL_F8:
#endif
	  ed->block_beg = ed->block_end = -1;
	  ed->refr = TRUE;
	  break;
	  
	case BLOCK_PASTE:
	case CTRL_P:
#ifdef DOS
	case CTRL_F4:
#endif
	  if( ed->block_end < 0 || ed->block_end < ed->block_beg) break;
	  ed->block_end = min( ed->block_end, ed->lines-1);
	  ed->block_beg = max( ed->block_beg, 0);
	  
	  if( ! block_paste( &block,
			    line_getline( ed->head_line, ed->block_beg),
			    ed->block_beg,
			    ed->block_end)
	     ) break;
	  
	  ed->block_beg     = ed->block_end = -1; /* undef the block */
	  
	  ed->block_lastcom = BLOCK_PASTE;  /* last command for UNDO */
	  ed->refr 	    = TRUE;
	  break;
	  
	  /* insert a file */
#ifdef DOS
	case ALT_F6:
#endif
	case F7:
	case FILE_INS:
	  {
	    int line_cnt;
	    line_cnt = read_tempfile( ed->f, ed->line);   /* read the lines */
	    
	    if( line_cnt <= 0) break;	/* file empty or not found */
	    /* define the loaded lines */
	    /* as block 		*/
	    ed->block_beg = line_number( ed->head_line, ed->line->next);
	    ed->block_end = ed->block_beg + line_cnt - 1; /* end of block */
	    
	    ed->lines     = line_count( ed->head_line); /* count the lines */
	    ed->modified  = TRUE;
	    ed->refr      = TRUE;
	  }
	  break;
	  
#ifdef DOS
	case ALT_F1:
	case ALT_F2:
#else
	case F6:
	case ESC_n:
#endif
	case FILE_NEW:
	case FILE_OPEN:
	  {
	    char * filename = NULL;
	    if( ed_cnt == EDIT_CNT)
	      {
		message (" Can't open more windows ", " Open window ");
		break;
	      }
#ifdef DOS
	    if( lk == ALT_F2) lk = FILE_OPEN;
	    if( lk == ALT_F1) lk = FILE_NEW;
#else
	    if( lk == ESC_n ) lk = FILE_NEW;
#endif
	    if( lk == F6) lk = FILE_OPEN;
	    if( lk == FILE_OPEN)
	      {
		filename = KH_dir (".",
				   "*.txt",
				   " Open a new file ",
				   GETFILE_MODE) ;
		if (filename == NULL) break ;
	      }
	    edx[ ed_cnt] = make_edit ( filename,
				      min(ed->f->x+1, max_x-20),
				      min(ed->f->y+1, max_y-10),
				      max(max_x - ed->f->x - 1,   20),
				      max(max_y - ed->f->y - 2,    9) );
	    
	    ed           = edx[ ed_cnt];
	    ed_num       = ed_cnt;
	    ed->refr     = TRUE;
	    ed_cnt       ++;
	    
	    view_frame( ed->f);
	  }
	  break;
	  
	case F8:
	case WIN_NEXT:
	  ed_num   = ( ed_num + 1 ) % ed_cnt;
	  ed       = edx[ ed_num];
	  ed->refr = TRUE;
	  view_frame( ed->f);
	  break;
	  
	case F9:
	case WIN_PREV:
	  ed_num   = ( ed_cnt + ed_num - 1 ) % ed_cnt;
	  ed       = edx[ ed_num];
	  ed->refr = TRUE;
	  view_frame( ed->f);
	  break;
	  
	case WIN_CHOOSE: 
#ifdef DOS
	case ALT_F8:
#else
	case ESC_l:
	case ESC_L:
#endif
	  {
	    char ** wins;
	    int
	      width = min(max_x, 50),
	      down  = min(ed_cnt, max_y-2),
	      x     = (max_x-width)/2,
	      y     = (max_y-down)/2,
	      pos   = ed_num,
	      ret_;
	    
	    wins = getmem ((ed_cnt+1) * sizeof(char *));
	    for ( i=0; i<ed_cnt; i++)
	      {
		sprintf (tmp,
			 "%c Window [%02i]: %s ",
			 edx[i]->modified ? '*' : ' ',
			 i+1,
			 edx[i]->txt_file);
		wins[i] = getmem (strlen(tmp) + 1);
		strcpy (wins[i], tmp);
	      }
	    wins[i] = NULL;
	    
	    ret_ = ch_text ( wins, x, y, width, down,
			    &pos, 
			    " List of all windows ", leer,
			    F_B_DIALOG_CLR,
			    F_B_UTIL_CHS,
			    AUTO_CHOOSE|CENTER_MODE);
	    for  (i=0; i<ed_cnt; i++) Free (wins [i]);
	    Free (wins);
	    if( ret_ == ESC) break;
	    
	    ed_num   = pos;
	    ed       = edx[ ed_num];
	    ed->refr = TRUE;
	    view_frame( ed->f);
	  }
	  break;
	case BLOCK_COPY:
	case CTRL_N:
#ifdef DOS
	case CTRL_F6:
#endif
	  
	  ed->tmp_line = block_insert( ed->line, &block);
	  
	  if( ed->tmp_line == NULL) break;
	  
	  if( ed->line_open == ed->line) ed->line_open = ed->tmp_line;
	  
	  ed->line  = ed->tmp_line;
	  ed->lines = line_count( ed->head_line);
	  
	  ed->block_beg = line_number( ed->head_line, ed->line);
	  ed->block_end = ed->block_beg+block.cnt-1;
	  
	  ed->modified = TRUE;
	  ed->refr     = TRUE;
	  break;
	  /* delete defined block */
	case BLOCK_CUT:
	case CTRL_R:
#ifdef DOS
	case CTRL_F5:
#endif
	  
	  if( ed->block_end < 0         ||
	     ed->block_beg > ed->lines-1   ||
	     ed->block_end < ed->block_beg ) break; /* no block is definded*/
	  
	  ed->block_beg = max( 0, ed->block_beg);  /* korrect begin */
	  ed->block_end = min( ed->lines-1, ed->block_end);  /* korrect end   */
	  
	  if( ! block_cut( &block, ed->head_line, ed->block_beg, ed->block_end))
	    break;
	  
	  block.ed = ed;	/* for UNDO */
	  
	  /* korrect the aktual line and */
	  /* begining */
	  if (ed->num_akt_line  >= ed->block_beg &&
	      ed->num_akt_line  <= ed->block_end
	      )
	    ed->num_akt_line = ed->block_beg;

	  if (ed->num_line_open >= ed->block_beg &&
	      ed->num_line_open <= ed->block_end
	      )
	    ed->num_line_open = ed->block_beg;

	  if (ed->num_akt_line  > ed->block_end)
	    ed->num_akt_line  -= ed->block_end-ed->block_beg+1;
	  if (ed->num_line_open > ed->block_end)
	    ed->num_line_open -= ed->block_end-ed->block_beg+1;
	      
	  ed->lines         = line_count( ed->head_line);
	  ed->num_line_open = max( 0, min( ed->lines-1, ed->num_line_open));
	  ed->num_akt_line  = max( 0, min( ed->lines-1, ed->num_akt_line ));
	  ed->line_open     = line_getline( ed->head_line, ed->num_line_open);
	  ed->line          = line_getline( ed->head_line, ed->num_akt_line);
	  ed->block_beg     = ed->block_end = -1;   /* undef the coordinates */
	  ed->block_lastcom = BLOCK_CUT;
	  ed->modified      = TRUE;
	  ed->refr          = TRUE;
	  break;
	  
	case BLOCK_UNDO:
	case CTRL_U:
#ifdef DOS
	case CTRL_F7:
#endif
	  
	  /* only, when the last command was cuting */
	  if( ed->block_lastcom != BLOCK_CUT) break;
	  if( ed                != block.ed ) break;
	  
	  ed->tmp_line = block_undo( &block, ed->head_line);
	  
	  if( ed->tmp_line == NULL) break;
	  
	  ed->line 	    = ed->tmp_line;
	  ed->num_akt_line  = block.beg;
	  ed->lines	    = line_count( ed->head_line);
	  
	  ed->num_line_open = line_number( ed->head_line, ed->line_open);
	  
	  ed->block_beg     = block.beg;
	  ed->block_end     = block.end;
	  
	  ed->block_lastcom = BLOCK_UNDO;
	  
	  ed->modified      = TRUE;
	  ed->refr          = TRUE;
	  break;
	  
	case REMOVE:
	case DELETE:
	case CTRL_D:
	  {
	    char * q;
	    /* last line */
	    int connect_ = (ed->line->str[ed->akt_x] == 0) ? TRUE : FALSE;
	    
	    ed->modified = TRUE;
	    ed->refr = TRUE;
	    
	    q = ed->line->str + ed->akt_x;
	    while( *q) *q = * (q + 1), q++;
	    
	    if( ! line_reconst( ed->line)) break;
	    
	    if (connect_ && ed->line->next != NULL)
	      {
		if( ! line_connstr( ed->line, ed->line->next->str)) break;
		
		line_delline( ed->line->next);
		
		if( ed->block_beg > ed->num_akt_line) ed->block_beg--;
		if( ed->block_beg > ed->block_end)
		  ed->block_beg = ed->block_end = -1;
		if( ed->block_end > ed->num_akt_line) ed->block_end--;
		ed->lines = ed->lines-1;
	      }
	    
	    ed->pos_x = ed->akt_x;
	    ed->tab_g = tab_getx( ed->line->str, ed->pos_x);
	  }
	  break;
	case BACKSPACE:
	  {
	    char * q;
	    
	    ed->modified = TRUE;
	    ed->refr  = TRUE;
	    
	    if( ed->akt_x == 0 && ed->num_akt_line > 0  )
	      {
		ed->pos_x = strlen  ( ed->line->prev->str);
		ed->tab_g = tab_getx( ed->line->prev->str, ed->pos_x);
		
		if( ! line_connstr( ed->line->prev, ed->line->str))
		  break;
		
		ed->tmp_line = ed->line;
		ed->line     = ed->line->prev;     /* previos line */
		
		if( ed->line_open == ed->tmp_line) {       /* line open is a */
		  ed->line_open = ed->line_open->prev; /* pointer and must */
		  ed->num_line_open--;             /* be an existing p.*/
		}
		
		line_delline( ed->tmp_line);       /* delete old line */
		
		if( ed->block_beg >= ed->num_akt_line) ed->block_beg--;
		if( ed->block_beg > ed->block_end) ed->block_end = ed->block_beg = -1;
		if( ed->block_end >= ed->num_akt_line) ed->block_end--;
		
		ed->num_akt_line--;
		ed->lines--;
		
	      }
	    else
	      {
		ed->akt_x = max( 0, ed->akt_x-1);
		
		q = ed->line->str + ed->akt_x;
		while( *q) *q = * (q + 1), q++;
		
		line_reconst( ed->line);
		
		ed->pos_x = ed->akt_x;
		ed->tab_g = tab_getx( ed->line->str, ed->pos_x);
	      }
	  }
	  break;
	  
	case INSERT:
	  ins_mode = (ins_mode ? FALSE: TRUE);
	  ins_help_line( VIEW_INS_MODE);
	  break;
	  
	case ENTER:
	case CTRL_M:
	  
	  ed->pos_x = ed->akt_x;
	  ed->tab_g = tab_getx( ed->line->str, ed->pos_x);
	  
	  if( ! ins_mode)
	    {
	      if( ed->line->next == NULL) {       /* last line */
		ed->tmp_line = ed->line;            /* new line */
		if( ( ed->line = make_line()) == NULL)
		  {
		    ed->line = ed->tmp_line;
		    break;
		  }
		line_insline( ed->tmp_line, ed->line);
		ed->lines++;
	      }
	      else ed->line = ed->line->next;
	      ed->num_akt_line = ed->num_akt_line+1;
	    }
	  else
	    {
	      
	      if( (ed->tmp_line = make_line()) == NULL) break;
	      
	      line_insline ( ed->line, ed->tmp_line);
	      
	      ed->line = ed->tmp_line;
	      
	      line_connstr( ed->line, ed->line->prev->str + ed->akt_x);
	      
	      ed->line->prev->str[ed->akt_x] = 0;
	      line_reconst( ed->line);         /* get mem. Free */
	      
	      if( ed->block_beg >= ed->num_akt_line) ed->block_beg++;
	      if( ed->block_end >= ed->num_akt_line) ed->block_end++;
	      
	      ed->num_akt_line++;
	      ed->lines++;
	      
	      ed->modified = TRUE;
	      ed->refr = TRUE;
	    }
	  ed->akt_x = ed->pos_x    = 0;
	  ed->tab_g = tab_getx( ed->line->str, ed->pos_x);
	  break;
	  
	case ESC:
	  {
	    int err_;
	    err_ = Getyesno (leave_, NULL, " Editor ", -1);
	    if( err_ == 0) end_ = TRUE;
	  }
	  break;
	  
	case CTRL_A:		/* insert control characters */
	default:
	  {
	    char * q, * p;
	    
	    /* insert control characters */
	    if( lk == CTRL_A)
	      {
		f_putch( ed->f, ed->tab_x, ed->pos_y+1, '^', ed->f->color, SCR_MODE);
		gotoXY( ed->f->x + ed->tab_x,  ed->f->y+ed->pos_y+1);
		view_cursor();
		
		while ( read (0, &lk, 1) == 0); lk &= 0xff;
		if( lk < 1 || lk >= 255) break;
	      }
	    else if( ! is_ascii (lk) && lk != TAB ) break;
	    
	    if( ins_mode)
	      {
		if( ! line_inschr( ed->line, 0, strlen(ed->line->str)))
		  break;
		q = ed->line->str + ed->akt_x;
		p = q + strlen(q) + 1;
		while( p > q) * p = * (p-1), p--;
		ed->line->str[ed->akt_x] = (char) lk;
	      }
	    else
	      {
		if( ! line_inschr( ed->line, (char) lk, ed->akt_x))
		  break;
	      }
	    
	    ed->akt_x++;
	    
	    ed->pos_x = ed->akt_x;
	    ed->tab_g = tab_getx( ed->line->str, ed->pos_x);
	    
	    ed->modified = TRUE;
	    ed->refr = TRUE;
	  }
	  break;
	}
      
      if( end_) break;
      
      ed->akt_x = tab_getpos( ed->line->str, ed->tab_g);
      
      while( ed->num_akt_line > ed->num_line_open+ed->f->down-1)
	{
	  ed->num_line_open = min( ed->lines-1, ed->num_line_open+1);
	  ed->line_open     = ed->line_open->next;
	  ed->refr = TRUE;
	}
      
      while( ed->num_akt_line < ed->num_line_open)
	{
	  ed->num_line_open = max( 0, ed->num_line_open-1);
	  ed->line_open     = ed->line_open->prev;
	  ed->refr          = TRUE;
	}
      
    }
  /* Free memory */
  if( block.top != NULL) line_delall( block.top);
  
  hide_frame( func_f,    HIDE_MODE|DELETE_MODE);
  
  for( i=0; i<ed_cnt; i++) dele_edit( edx[i]);
}
