/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: doedit.h,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/doedit.h,v $
 */

#ifndef GLOBAL
#define GLOBAL
#endif

#ifndef DOEDIT_HH
#	define DOEDIT_HH

#include "dowin.h"
#include "doframe.h"

#define FINDLEN 	120
#define NAMELEN		64

struct edit_t {
    struct frame_t * f;
    struct line_t * head_line,
		  * tmp_line,
		  * line,
		  * line_open;
    char txt_file[ MAXPATH];

    long f_size;            /* file size */

    int lines,
	num_akt_line,
	num_line_open,
	line_len,
	out_begin,
	out_faktor;

    int refr,
	modified,		/* view if text is modified */
	pos_x,                /* x-coord. of aktual choose block */
	pos_y,                /* y-coord. of aktual choose block */
	akt_x,
	tab_x,
	tab_g,
	block_beg,
	block_end,
	pos_e,
	block_lastcom;

    };

struct line_t {
     char * str;
     struct line_t * prev, * next;
     };

				/* for block defines */
struct block_t {
    struct edit_t * ed;
    struct line_t * top, *last;
    int beg, end, cnt;
    };

GLOBAL char temp_fname [NAMELEN],
            file_search[FINDLEN],     /* string to search for text */
	    file_with  [FINDLEN];    /* replace with */

/* editor */

void KHA_editor     ( char * txt_file);

/***************/

GLOBAL int 	word_next	( char * str, int pos);
GLOBAL int 	word_prev	( char * str, int pos);
GLOBAL int 	tab_getx	( char * s, int pos);
GLOBAL int 	tab_getpos	( char * s, int pos);

GLOBAL int 	read_lines	( struct frame_t * f,
				  char * txt_file,
				  struct line_t * line);

GLOBAL int 	block_paste	( struct block_t * block,
				  struct line_t * line,
				  int block_beg,
				  int block_end);
GLOBAL struct 	line_t *
		block_copy	( struct line_t * line, int cnt);
					  /* insert block in editor */
GLOBAL struct 	line_t *
		block_insert	( struct line_t * pos, struct block_t * block);
GLOBAL struct 	line_t *
		block_undo	( struct block_t * block, struct line_t * head);
GLOBAL int 	block_cut	( struct block_t * block,
			  struct line_t * head_line,
			  int block_beg,
			  int block_end);

/**************************************************************************/
/********* Line Operations                                            *****/
/**************************************************************************/

GLOBAL struct 	line_t *
	make_line	( void);
GLOBAL void 	line_delall	( struct line_t * line);
GLOBAL struct 	line_t *
	line_last	( struct line_t * line);
GLOBAL int 	line_reconst	( struct line_t * line);
GLOBAL int 	line_resize	( struct line_t * line);
				/* append a character to the line string */
GLOBAL int 	line_inschr	( struct line_t * line, char ch, int pos);
GLOBAL int 	line_connstr	( struct line_t * line, char * str);
GLOBAL int 	line_number	( struct line_t * top_line, struct line_t * line);
GLOBAL struct 	line_t *
	line_getline	( struct line_t * top_line, int number);
GLOBAL int 	line_count	( struct line_t * top_line);

GLOBAL struct 	line_t *
	line_lastline	( struct line_t * line);

GLOBAL void 	line_insline	( struct line_t * l_pos, struct line_t * ed);
GLOBAL struct 	line_t *
	line_delline	( struct line_t * line);
GLOBAL struct 	line_t *
	edit_findstr	( struct frame_t * f,
			  struct line_t * top_line,
			  char * str,
			  int  lines,
			  int * x_pos,
			  int mode
			  );
GLOBAL struct 	line_t *
	edit_findtext	( struct line_t * top_line,
			  char * str,
			  int lines,
			  int *x_pos,
			  int mode);

GLOBAL struct 	line_t *
	edit_replace	( struct frame_t * f,
			  struct line_t * top_line,
			  char * str,
			  char * with,
			  int  lines,
			  int * x_pos,
			  int mode
			  );
GLOBAL struct 	line_t *
	edit_reptext	( struct line_t * top_line,
			  char * str,
			  char * with,
			  int lines,
			  int *x_pos,
			  int mode);

#endif /*_HH*/
