/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: dofind.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/dofind.c,v $
 */

#define GLOBAL extern
#define EXTERN

#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <dirent.h>
#include <string.h>

#ifdef DOS
#include <io.h>
#else 
#include <termio.h>
#include <unistd.h>
#endif

#include "dodefs.h"
#include "doglobal.h"
#include "dodirent.h"
#include "doutil.h"
#include "dostring.h"
#include "dofiles.h"
#include "doscr.h"
#include "docfg.h"
#include "dostat.h"
#include "dotext.h"
#include "doregex.h"
#include "domem.h"
#include "doqsort.h"
#include "dolib.h"
#include "dofind.h"

/**********************************************************************/
/* search for files <use the 'find'-command>  		      	      */
/**********************************************************************/

#define FILE_LEN	256
#define F_BLOCK_LEN	128

#define REMOVE_MODE	0x0001

#ifdef DOS
#define TMP_DIR 	"\\"
#else
#define TMP_DIR		"/tmp"
#endif

char * concat_path (char * path, char * file)
{
  static char buf [MAXPATH];
  int pos = max (0,  strlen (path) - 1);
  strcpy (buf, path);
  if (buf [pos] == root) buf [pos] = 0;
  sprintf( buf + strlen (buf), "%c%s", root, file);
  return buf;
}

void findfiles (struct frame_t * f,
		struct frame_t * remove_f,
		int * f_y,
		int file_h,
		char * path,
		char * name,
		int  * remove_mode,
		int  * mode
		) 
{
  DIR    * dir;
  struct dirent * dr;
  char   buf [MAXPATH];
  int len;

  f_putstr( f, 1, f->down+2, path, f->color, FILL_MODE | SCR_MODE);

  fflush_() ;

  if( ( dir = X_opendir( path)) == NULL) return;

  for( ; ( dr = X_readdir( dir)) != NULL; )
    {

      if( strcmp(dr->d_name, ".") == 0 || strcmp(dr->d_name, "..") == 0) 
      continue;
      
      strcpy (buf, concat_path (path, dr->d_name));
      len = strlen (buf);

      if (is_regex  (name, dr->d_name))
	{
	  write (file_h, buf, len);
	  write (file_h, "\n", strlen ("\n"));

						/* remove only files */
	  if ((*mode & REMOVE_MODE) && ! is_dir (buf, NOMODE))
	    {
	      recursive_remove (remove_f, buf, * remove_mode);
	      /*
	       * hide_frame       (remove_f, HIDE_MODE);
	       */
	    }

	  if( * f_y >= f->down) f_scroll( f, UP_MODE | SCR_MODE);
	  else (* f_y)++;

	  f_putstr( f, 1, * f_y, buf, f->color, SCR_MODE);

	  fflush_();
	}

      if (is_dir (buf, NOMODE)) 
	{
	  findfiles(f, remove_f, f_y, file_h, buf, name, remove_mode, mode);
	}
    }
  X_closedir( dir);
}

/* search for any file name and 				 */
/* OUTPUT:   NULL, if no search or error 			 */
/*           otherwise a pointer to the the full pathname	 */


char * search_file(char * fnd_path)
{
  struct frame_t * f, * remove_f;
  struct input_t * in;
  struct log_t   * lg, * action;
  
  char
    get_name [FILE_LEN] = { 0 },
    get_path [MAXPATH ] = { 0 },
    * action_txt [] = { "List only", " Remove " },
    * tmp_file = NULL,
    * p = NULL,
    * comp_name ;
  int
    remove_mode [1] = { RM_ASK_MODE },
    mode        [1] = { FALSE },
    width   = min( 60, max_x),
    down    = min( 22, max_y),
    y       = (max_y-down) / 2,
    x       = (max_x-width) / 2,
    file_h,
    i, j, lk,
    ret_,
    err_ = FALSE;

  remove_f = make_frame (10/2,
			 max_y-8, max_x-10, 5, 
			 " Remove ", leer, F_B_UTIL_CLR,
			 NOMODE);

  f = make_frame(x, y, width, down, " Search file ", leer, F_B_UTIL_CLR,
		 NOMODE);

  in     = make_input( f, 4, CUR_MODE | FIL_MODE | INS_MODE);
  lg     = make_log  ( f, 2, F_B_UTIL_CHS);
  action = make_log  ( f, 2, F_B_UTIL_CHS);

  f_putline( f,    f->down - 7, f->color);
  f_putstr ( f, 1, f->down - 6, "Filename :", f->color, NOMODE);
  f_putline( f,    f->down - 5, f->color);
  f_putstr ( f, 1, f->down - 4, "Directory:", f->color, NOMODE);
  f_putline( f,    f->down - 3, f->color);
  f_putstr ( f, 1, f->down - 2, "Action   :", f->color, NOMODE);
  f_putline( f,    f->down - 1, f->color);

  log_format (lg, cont_break[0], cont_break[1]);
  log_xy     (lg,
	      (f->width/2 - strlen(cont_break[0]) ) / 2,
	      f->down,
	      (f->width/2) + (f->width/2 - strlen(cont_break[1]) ) / 2,
	      f->down);
  log_format (action, action_txt[0], action_txt[1]);
  log_xy     (action,
	      12 + ((f->width-12)/2 - strlen(action_txt[0])) / 2,
	      f->down - 2,
	      (f->width/2) + (f->width/2 - strlen(action_txt[1]) ) / 2,
	      f->down - 2);

  input_string (in, 0, 12, f->down - 6, get_name, FILE_LEN-1, FILE_LEN-1);
  input_string (in, 1, 12, f->down - 4, get_path, MAXPATH-1, MAXPATH-1);
  input_log    (in, 2, action);
  input_log    (in, 3, lg);
  
  view_frame( f);
  
  lk = f_getstr (in);

  if (action->pos == 1) * mode = REMOVE_MODE;

  f->down -= 6;		  /* view the found files in the same frame */

#ifdef DOS				/* if he inserted "X:" --> "X:." */
  i = strlen( get_path);
  if (i > 0 && (get_path[i-1] == ':' || get_path[i-1] == root))
    {
      sprintf( get_path+i, "%s", ".");
    }
#endif

  if ((lk != ENTER && lk != CTRL_M) ||
      strlen( get_name) <= 0 ||
      strlen( get_path) <= 0
      )
    err_ = TRUE;

  if( strlen( get_path) > 0 &&  ! exist( get_path))
    {
      message( " Path not found ", " search ");
      err_ = TRUE;
    }

  if( ! err_)
    {
      int pp[2];
      
      width = min( 60, max_x),	/* coordinates for the viewer frame */
      down  = min( 20, max_y),
      y     = (max_y-down)/2,
      x     = (max_x-width)/2;

      tmp_file = tempnam(TMP_DIR, "KH");
      
      file_h = creat (tmp_file, S_IWRITE | S_IREAD); /* TMP. FILE */
      file_h = open  (tmp_file, O_RDWR|O_BINARY) ;

      f->down -= 2;
      f_putline( f, f->down+1, f->color);

      view_frame( f);

#if 0
      pipe( pp);			/* create pipe */

      if( fork() == 0)
	{			/* child */
	  close( pp[STD_IN]);
	  close(    STD_OUT);
	  dup  ( pp[STD_OUT]);
	  close( pp[STD_OUT]);
	  
	  freopen( MY_cfg.options[ ERR_DEV], "a+", stderr);
	  
	  err_ = execlp( "find", "find",
			get_path,
			"-name",
			get_name,
			"-print",
			NULL);
	  exit( err_);
	}
      else
	{
	  int len, s_x = 1, s_y = 1;
	  char buf[ F_BLOCK_LEN];
	  
	  close( pp[STD_OUT]);
	  while( (len = read( pp[STD_IN], buf, F_BLOCK_LEN)) > 0) {

	    write( file_h, buf, len);

	    for( i=0; i<len; i++)
	      {
		if( buf[i] == 10)
		  {
		    if( s_y >= f->down) f_scroll( f, UP_MODE | SCR_MODE);
		    else s_y++;
		    s_x = 1;
		  }
		else if( s_x < f->width)
		  f_putch( f, s_x++, s_y, buf[i], f->color, SCR_MODE);
	      }

	    fflush_();
	    
	  }
	  close( pp[STD_IN]);
	  
	}
      wait( &err_);
#endif  /* if 0 */

      i = 1;
      comp_name = open_comp (get_name) ;

      findfiles (f, remove_f, &i, file_h, get_path, comp_name,
		 remove_mode,
		 mode) ;

      close_comp (comp_name);

      hide_frame (f, HIDE_MODE);
      hide_frame (remove_f, HIDE_MODE);

      close( file_h);

      ret_ = view_file( tmp_file,
			 " List of found files ",
			 x,
			 y,
			 width,
			 down,
			 fnd_path,
			 MAXPATH-1,
			 NOMODE);

      remove (tmp_file);

      if( ret_) p = fnd_path; /* pointer to the path name */

    }

  if (tmp_file != NULL) Free   (tmp_file);

  del_input (in);
  del_log   (lg);

  hide_frame (f,        HIDE_MODE|DELETE_MODE);
  hide_frame (remove_f, HIDE_MODE|DELETE_MODE);
  return p;		/* return pointer to the path */
}


/************************************************************************
 *********************** tree viewer ************************************
 ************************************************************************/

/************************************************************************
 ************* Tree builder, constract a tree and save it in a file *****
 ************************************************************************/

#define TREE_RDIRS	0x0000
#define TREE_RFILES	0x0001
#define TREE_FIRST      0x0002
#define TREE_LAST       0x0004
#define TREE_MIDDLE     0x0008
#define TREE_ROOT	0x0010

char ** s_cont ;

int tree_strcmp (const int a, const int b)
{
  return strcmp (s_cont [a], s_cont [b]);
}

int tree_swap (const int a, const int b)
{
  char * p = s_cont [a] ;

  s_cont [a] = s_cont [b] ;
  s_cont [b] = p ;

  return TRUE ;
}

int write_tree (int file_h,
	     int t_cnt [],
	     int t_pos [],
	     int t_mode[],
	     char * buf)
{
  int len = strlen (buf), i, ii [2];

  int file_pos = lseek (file_h, 0, SEEK_CUR); 		/* file position */

  write (file_h, t_cnt, sizeof(int) ) ;			/* count of records */

  for (i=0; i<t_cnt[0]; i++)				/* y-position */
    {
      ii [0] = t_pos  [i] ;
      ii [1] = t_mode [i] ;
      write (file_h, ii, 2 * sizeof (int) );  	/* x-position */
    }
  write (file_h, &len, sizeof (int) );			/* path length */
  write (file_h, buf, len);				/* path self */
  write (file_h, &file_pos, sizeof(int) );		/* pointer to prev. */

  return TRUE ;
}

int read_tree (int  file_h,
	       int  t_cnt    [],
	       int  t_pos    [],
	       int  t_mode   [],
	       char buf      [])
{
  int i, file_pos, len ;
  int ii [2] ;

  if (read (file_h, t_cnt, sizeof (int)) <= 0)
    return FALSE ;				 /*depth*/
	
  for (i=0; i<*t_cnt; i++)			/* y-positions */
    {
      if (read (file_h, ii, sizeof (int) * 2) <= 0) /* pos & mode */
	return FALSE ;

      t_pos  [i] = ii [0] ;
      t_mode [i] = ii [1] ;
    }
  
  
  if (read (file_h, &len, sizeof (int)) <= 0) /* path length */
    return FALSE ;

  if (read (file_h, buf, len) <= 0)		/* path */
    return FALSE ;

  buf [len] = 0;

  if (read (file_h, &file_pos, sizeof (int)) <= 0)  /* prev */
    return FALSE ;
  
  return TRUE ;
}

/*
 * read contents and build the tree on the temporary file 
 * the files are then saved sorted in the file
 */

void build_tree (struct frame_t * f,
		 int * f_y,
		 int file_h,
		 char * path,
		 char * name,
		 int    t_pos  [],
		 int    t_mode [],
		 int    t_cnt  [],
		 int  * mode
		 ) 
{
  /*
   * mode == TREE_RFILES : read files into tree
   * mode == TREE_DIRS   : read directories into tree   <default>
   * mode == NOMODE      : only directories
   */

  DIR    * dir;
  struct dirent * dr;
  char ** d_cont, buf [MAXPATH];
  int len, i, cnt, j;

  f_putstr (f, 1, 2, path, f->color, FILL_MODE | SCR_MODE); fflush_ () ;

  if ((dir = X_opendir (path)) == NULL) return;

  d_cont = getmem (MY_cfg.max_file_cnt * sizeof(char *) );

  for( cnt=0; cnt < MY_cfg.max_file_cnt && ( dr = X_readdir( dir)) != NULL; )
    {
      if( strcmp(dr->d_name, ".") == 0 || strcmp(dr->d_name, "..") == 0)
	continue;

      if( is_regex  (name, dr->d_name))
	{
	  strcpy (buf, concat_path (path, dr->d_name));

	  if ( ! (mode [0] & TREE_RFILES) && ! is_dir (buf, NOMODE) ) 
	    continue ;

	  d_cont [cnt] = getmem (MAX_COL_LEN) ;  /* save in arry to sort */
	  strncpy_ (d_cont [cnt],
		    dr->d_name,
		    MAX_COL_LEN-1,
		    TE_NULL);
	  cnt ++ ;
	}
    }

  X_closedir( dir);

  s_cont = d_cont ;			/* pointer only hier change */
  OTT_qsort (0, cnt-1, tree_strcmp, tree_swap);

  for (j=0; j<cnt; j++)
    {
      strcpy (buf, concat_path (path, d_cont [j]));
      len = strlen (buf);

      t_mode [ t_cnt[0]-1 ]  = (j == cnt-1)
				? TREE_LAST	/* last element in tree */
				: (j == 0) 
				  ? TREE_FIRST
				  : TREE_MIDDLE ;
	     
      write_tree (file_h, t_cnt, t_pos, t_mode, buf) ;

      if (is_dir (buf, NOMODE))
	{
	  int t_fak   = 0 ,
	  old_pos = t_pos [ t_cnt[0] ],
	  old_cnt = t_cnt [0] ;

	  t_pos [ t_cnt[0] ] = t_pos [ t_cnt[0]-1 ] +	          /* old pos.*/
			       strlen (d_cont [j]) + /* length */
				 t_fak ;	  	    /* faktor to add */

	  t_cnt [0] ++ ;				/* path depth */
      
	  build_tree (f, f_y, file_h, buf, name, t_pos, t_mode, t_cnt, mode);

	  t_cnt [      0] = old_cnt ;		/* decrement */
	  t_pos [old_cnt] = old_pos ;
	}
    }

  for  (i=0; i<cnt; i++) Free (d_cont [i]);
  Free (d_cont) ;
}

/* view a tree for a given path  				*/
/* OUTPUT:  NULL, if no tree or error 			 	*/
/*          otherwise a pointer to the the full pathname	*/

#define TREE_DEPTH		128

char * view_tree (char * fnd_path)
{
  struct frame_t * f; /* frame to view the found files allowes the search */
  struct input_t * in;
  struct log_t   * lg;
  
  char     get_name [ FILE_LEN],
           get_path [ MAXPATH],
  	   tmp_buf  [256],
         * tmp_file,
	 * p = NULL,
         * comp_name ;
  char *   view_dir_files [] = { 
    			         "directories only",
				 "all",
				 NULL
			       } ;
  char hlp_text [] = " Enter your path and the names you want to find ... ";
  int t_pos [TREE_DEPTH],
      t_mode[TREE_DEPTH],
      t_cnt [1] ,
      mode  [1] ;
  int width   = min( 60, max_x),
      down    = min(  7, max_y),
      y       = (max_y-down) / 2,
      x       = (max_x-width) / 2,
      file_h,
      i, j, lk,
      ret_,
      err_ = FALSE;


  f   = make_frame (x, y, width, down, 
		    " Tree Manager ",
		    leer,
		    F_B_UTIL_CLR,
		    NOMODE);

  in = make_input( f, 3, CUR_MODE | FIL_MODE | INS_MODE);
  input_help (in, hlp_text);
  lg = make_log  ( f, 2, F_B_UTIL_CHS);

  f_putstr ( f, 1, 1, "Path:", f->color, NOMODE);
  f_putline( f,    2, f->color);
  f_putstr ( f, 1, 3, "Files:", f->color, NOMODE);
  f_putline( f,    4, f->color);
  f_putstr ( f, 1, 5, "View:", f->color, NOMODE);

					/*
					 * view files in the tree
					 */
  log_format (lg, view_dir_files [0], view_dir_files [1]);
  log_xy     (lg, 
	      6 + ((f->width-6)/2 - strlen(view_dir_files [0]) ) / 2,
	      f->down,
	      6 + ((f->width-6)/2)
	      + ((f->width-6)/2 - strlen(view_dir_files [1]) ) / 2,
	      f->down);
  strcpy (get_path, WIN->path);
  strcpy (get_name, "*");

  input_string (in, 0, 12, 1, get_path, MAXPATH-1, MAXPATH-1);
  input_string (in, 1, 12, 3, get_name, FILE_LEN-1, FILE_LEN-1);
  input_log    (in, 2, lg);

  view_frame (f);
  
  lk = f_getstr( in);

#ifdef DOS				/* if he inserted "X:" --> "X:." */
  i = strlen( get_path);
  if (i > 0 && (get_path[i-1] == ':' || get_path[i-1] == root))
    sprintf( get_path+i, "%s", ".");
#endif

  if ((lk != ENTER && lk != CTRL_M) ||
      strlen( get_name) <= 0 ||
      strlen( get_path) <= 0
      )
    err_ = TRUE;

  if( strlen( get_path) > 0 && ! exist( get_path))
    {
      message( " Path not found ", " search ");
      err_ = TRUE;
    }

  if( ! err_)
    {
      struct frame_t * ff ;
      int pp[2];
      
      tmp_file = tempnam(TMP_DIR, "KH");
      file_h = creat( tmp_file, S_IWRITE | S_IREAD); /* TMP. FILE */
      
      width = min (70, max_x) ;
      down  = min (5, max_y) ;
      x     = (max_x-width) / 2 ;
      y     = (max_y-down ) / 2 ;

      ff = make_frame (x, y, width, down, " Search for .. ", leer,
		       F_B_UTIL_CLR,
		       NOMODE);

      view_frame (ff);

      for (i=0; i<TREE_DEPTH; i++) t_pos [i] = t_mode [i] = 0;

      mode  [0] = (lg->pos ? TREE_RFILES : NOMODE) ;
      t_cnt [0] = 0;
      t_pos [0] = 1;
      t_mode[0] = TREE_ROOT ;

      lseek (file_h, 0, SEEK_SET);
      write_tree (file_h, t_cnt, t_pos, t_mode, get_path) ;
      i         = 1;
      t_cnt [0] = 1;
      t_pos [0] = 2;

      comp_name = open_comp (get_name) ;
      build_tree  (ff, &i, file_h, get_path, comp_name,
		   t_pos, t_mode, t_cnt,
		   mode) ;
      close_comp  (comp_name);

      close (file_h);

      hide_frame( ff, HIDE_MODE | DELETE_MODE);


      sprintf (tmp_buf, " Tree manager, path=[%s], files=[%s] ",
	       get_path,
	       get_name
	       );

      ret_ = choose_tree (tmp_file, leer, fnd_path);

      remove (tmp_file);
      
      if(ret_) p = fnd_path; /* pointer to the path name */

    }

  del_input( in);
  del_log  ( lg);
  
  hide_frame( f, HIDE_MODE|DELETE_MODE);
  return  p;		  		     /* return pointer to the path */
}

#define F_LEN	64

int choose_tree (char * file, char * title, char * fnd_path)
{
  struct frame_t * f, * path_f = NULL, * old_f = NULL, * help_f;
  struct frame_t * ff ;
  char str [F_LEN] ;
  char buf [MAXPATH];
  char * name ;
  char hlp [] = "F3/Ctrl-f:Next"
		   "#Enter:select"
		   "#F12:Break"
    		   "#Cursor-Up/Dn:Move"
		   "#Home/End:First/last";
  int  t_pos  [TREE_DEPTH] ;
  int  t_mode [TREE_DEPTH] ;
  int  t_cnt, top_pos ;
  int  width = min (70, max_x); 
  int  down  = min (16, max_y); 
  int  y     = (max_y-down )/2;
  int  x     = (max_x-width)/2; 
  int  f_y   = 1 ;
  int  len,
       i,
       ret_,
       end_ = FALSE,
       j,
       refr, 
       lk   = -1;
  int  file_h = open (file, O_RDONLY|O_BINARY) ;
  int  file_pos [16],
       x_pos    [16],
       y_pos    [16],
       s_len    [16],
       cur_pos = 0;

  if (file_h < 0) return ;

  f      = make_frame (x, y, width, down,
		       title, leer,
		       F_B_UTIL_CLR,
		       NOMODE) ;
  help_f = make_help  (hlp, 0, max_y-1, max_x - 10);
  ff     = make_frame (f->x, f->to_y+1, f->width, 3,
		       " give your string to search ", leer,
		       F_B_UTIL_CLR,
		       NOMODE);

  view_frame (f);
  view_frame (help_f);
  fflush_();
  if (lseek (file_h, 0, SEEK_END) > 0)
    for (top_pos=0, j=1, refr=TRUE, str [0] = 0; TRUE; ) 
      {

	if (cur_pos < 0 || cur_pos > j - 1) refr = TRUE ; 

	if (refr)				/* view tree part */
	  {
	    lseek (file_h, top_pos, SEEK_SET);	/* old_position */

	    while (cur_pos < 0)			/* scroll backwards */
	      {
		int pos ;
		if (top_pos > 0)
		  {
		    lseek (file_h, - sizeof(int), SEEK_CUR); /* pos > 0) */
		    read  (file_h, &pos, sizeof (int)) ;
		    top_pos = pos ;
		    lseek (file_h, top_pos, SEEK_SET);
		  }
		else
		  {
		    cur_pos = 0 ;
		    break ;
		  }
		cur_pos ++ ;
	      }

	    if (cur_pos > j - 1)		/* scroll forwards */
	      {
		top_pos = file_pos [max (min (j - 1, cur_pos - j + 1), 0)];
		cur_pos = j - 1;
	      }
	    
	    lseek (file_h, top_pos, SEEK_SET);		/* new position */

	    f_rahmen (f, F_CLEAR_MODE) ;		/* clear frame */

	    for (j=0; j<f->down; j++)			/* view contents */
	      {
		file_pos [j] = lseek (file_h, 0, SEEK_CUR) ; /* current pos */
		y_pos    [j] = j + 1 ;
		
		ret_ = read_tree (file_h,
				  &t_cnt,
				  t_pos,
				  t_mode,
				  buf);

		if (!ret_) break ;

	        for (i=0; i<t_cnt; i++)
		  {
		    if ((i<t_cnt-1) && (t_mode [i] & TREE_LAST)) continue ;

		    f_putch (f, t_pos [i], j + 1,
			     (i < t_cnt-1) 
			     ? GV
			     : (t_mode [i] & TREE_LAST)
			       ? G3
			       : GL,
			     GRAPH_MODE|f->color, NOMODE);
		  }
		name = basename (buf) ;

		s_len [j] = strlen (name);
		x_pos [j] = (t_cnt>0) ? t_pos [t_cnt-1] + 1 : 1;

		f_putstr (f, x_pos [j], j+1, name, f->color, NOMODE);

	      }	/* for (j=0 */

	    cur_pos = min (cur_pos, j - 1);
	    view_frame (f) ; 
	    refr = FALSE ;
	  } /* if refr */

	lseek (file_h, file_pos [cur_pos], SEEK_SET);
	ret_ = read_tree (file_h,
			  &t_cnt,
			  t_pos,
			  t_mode,
			  buf);

	len = min (strlen ( cutpath (dirname (buf), f->width-2, NOMODE) ) + 2,
		   f->width-2);
	old_f = path_f ;
	path_f = make_frame (f->x+ (f->width-len)/2,
			     f->y,
			     len,
			     1,
			     leer, leer,
			     F_B_UTIL_CHS,
			     NOBOX_MODE);
	f_putstr (path_f, 1, 0,
		  dirname (buf),
		  path_f->color,
		  FILL_MODE);
	view_frame (path_f); fflush_();
	if (old_f != NULL) hide_frame (old_f, HIDE_MODE|DELETE_MODE);

	f_outnch (f,
		  x_pos [cur_pos],
		  y_pos [cur_pos],
		  s_len [cur_pos],
		  F_B_UTIL_CHS,
		  NOMODE);

	len = strlen (str) ;
	f_putstr (ff, 1, 1, str, ff->color, FILL_MODE);
	view_frame (ff);
	gotoXY (ff->x+len+1, ff->y+1);

	fflush_();

	lk = getkey (-1) ;

	if (is_ascii (lk) || lk == BACKSPACE || lk == CTRL_F || lk == F3)
	  {
	    int old_pos ;

	    if (is_ascii (lk))
	      {
		str [ len ] = lk ;
		str [len+1] = 0 ;
	      }
	    else if (lk == BACKSPACE)
	      {
		str [max (0,len-1)] = 0;
	      }
						/*
						 * search from begining or 
						 * continue to search 
						 */
	    if (lk == CTRL_F || lk == F3 || lk != BACKSPACE) 
	      {
		lseek (file_h, top_pos, SEEK_SET);
		read_tree (file_h,
			   &t_cnt,
			   t_pos,
			   t_mode,
			   buf);
	      }
	    else				/* search from begining */
	      {
		lseek (file_h, 0, SEEK_SET);
	      }

	    for (old_pos = top_pos; TRUE; )
	      {
		top_pos = lseek (file_h, 0, SEEK_CUR);
		ret_ = read_tree (file_h,
				  &t_cnt,
				  t_pos,
				  t_mode,
				  buf);
		if (!ret_)
		  {
		    top_pos = old_pos ;
		    break ;
		  }
		if (begins (basename (buf), str) == 0)
		  break ;
	      }
	    refr = TRUE ;
	  }
	else 
	  str [0] = 0 ;

	f_outnch (f,
		  x_pos [cur_pos],
		  y_pos [cur_pos],
		  s_len [cur_pos],
		  F_B_UTIL_CHS,
		  NORMAL_MODE);

	switch (lk)
	  {
	  case CUR_UP:
	    cur_pos -- ;
	    break ;

	  case CUR_DOWN:
	    cur_pos ++ ;
	    break ;

	  case PAGE_UP:
	    cur_pos -= (f->down - 1) ;
	    break ;

	  case PAGE_DOWN:
	    cur_pos += f->down - 1 ;
	    break ;

	  case HOME:
	    cur_pos = 0;
	    top_pos = 0;
	    refr = TRUE ;
	    break ;

	  case END:
	    lseek (file_h,  - sizeof(int), SEEK_END);
	    read  (file_h, &top_pos, sizeof(int));
	    refr = TRUE ;
	    cur_pos = 0 ;
	    break ;

	  case ESC:
	    end_ = TRUE ;
	    break ;

	  case CTRL_M:
	  case ENTER:
	    strcpy (fnd_path, buf);
	    end_ = TRUE;
	    break ;

	  default:
	    break ;
	  }
	    
	if (end_) break ;

      }  /* for (i=0 */

  if (path_f != NULL) hide_frame (path_f, HIDE_MODE|DELETE_MODE);

  close (file_h) ;
  
  hide_frame (f,      HIDE_MODE|DELETE_MODE);
  hide_frame (ff,     HIDE_MODE|DELETE_MODE);
  hide_frame (help_f, HIDE_MODE|DELETE_MODE);

  if (lk == ENTER || lk == CTRL_M) return TRUE ;

  return FALSE ;
}

/************************************************************************
 *********************** end of tree viewer *****************************
 ************************************************************************/

/* by picked a file with pathname, it changes to this file automaticly */

void w_search_file( struct win_t * w, int mode) {
    char fnd_path [MAXPATH];      /* found path */
    char * f_name;
    int i;

    if (mode & SEARCH_FILE)
      {
	if (search_file(fnd_path) == NULL) return;
      }
    else if (mode & SEARCH_TREE)
      {
	if (view_tree(fnd_path) == NULL) return;
      }
    else return ;

    if( change_dir( w, dirname (fnd_path) ) == -1) return;

    w->akt_pos = w->old_pos = max(w->begin_at-1,0);
    w->anf_pos = 0;
	    
    w_readdir( w, ".", NOMODE);
    get_path( w);

    f_name = basename (fnd_path);

    for( i=0; i<w->d_files && strcmp( f_name, w->dr[i]->f) != 0; i++);

    if( i<w->d_files) w->akt_pos = w->old_pos = i;

    w->fr_out     = TRUE;
    w->rahmen_out = TRUE;
    }









