/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: doframe.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/doframe.c,v $
 */

/*   ************************************************************** */
/*   *****************  frame functions       ********************* */
/*   ************************************************************** */

#define GLOBAL extern
#define EXTERN

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef DOS
#include <conio.h>
#endif

#include "dodefs.h"
#include "doglobal.h"
#include "doerror.h"
#include "dolib.h"
#include "domem.h"
#include "dostring.h"
#include "doscr.h"
#include "docfg.h"
#include "doframe.h"

/*****************************************************************************/
/******************** queue functions    *************************************/
/*****************************************************************************/

/***************  insert event on the top of queue ****/

void   ins_queue    ( struct queue_t * qu) {
	struct queue_t * p = queue->next;

	queue->next = qu;
	qu->prev = queue;

	if( p != NULL) {
	    p->prev = qu;
	    qu->next = p;
	    }
	}

struct queue_t * make_queue   ( struct frame_t * f) {
	struct queue_t * q = getmem( sizeof( struct queue_t));
	q->f	 = f;
	q->f_num = last_queue_number++;
	q->next  = NULL;
	q->prev  = NULL;

	if( f != NULL) ins_queue( q);

	return( q);
	}

void   del_queue    ( struct queue_t * qu) {
	struct queue_t * p = qu->prev,
		       * q = qu->next;

	if( p->next != NULL) p->next = q;
	if( q       != NULL) q->prev = p;
	Free( qu);

	}

void   move_to_top  ( struct queue_t * qu) {
	struct queue_t  * q  = qu->next,
			* p  = qu->prev,
			* p2 = queue->next;

	if (queue->next->f == qu->f) return;

	p->next = q;
	if( q != NULL) q->prev = p;

	queue->next = qu;
	qu->prev    = queue;

	p2->prev  = qu;
	qu->next  = p2;

	}

void f_change_t1 (struct frame_t * f, char * t)
{
  Free (f->t1) ;
  f->t1 = getmem (strlen(t) + 1) ;
  strcpy (f->t1, t) ;
}

void f_change_t2 (struct frame_t * f, char * t)
{
  Free (f->t2) ;
  f->t2 = getmem (strlen(t) + 1) ;
  strcpy (f->t2, t) ;
}

struct frame_t * make_frame( int x, int y, int width, int deep,
			     char * t1,
			     char * t2,
			     int color,
			     int mode) {
	/* NOBOX_MODE : frame without box ***/

						/* size of the frame **/
	struct frame_t * f = getcmem( sizeof( struct frame_t));
	int i,
	    fak  = ( mode & NOBOX_MODE ? 1 : 0);

	XDEBUG5 ("make_frame (x=%i, y=%i, width=%i down=%i\n", x, y, width, deep);

	f->queue = make_queue (f);

	f->x     = x;
	f->y     = y;
	f->width = width;
	f->rows  = deep;
	f->down  = deep - 2 + fak * 2;
	f->to_x  = x+width-1;
	f->to_y  = y+deep-1;
	f->chr_cnt = width * deep;
	f->type  = mode;
	f->color = color;
	f->mode  = HIDE_MODE;

	f->t1    = getmem( strlen (t1) + 1);    /* head-title **/
	f->t2    = getmem( strlen (t2) + 1);    /* buttom-title **/

	strcpy (f->t1, t1);    		     /* copy head-title **/
	strcpy (f->t2, t2);    		     /* copy buttom-title **/

	f->chr   = getcmem (width * deep * sizeof( char)); /* frame-character*/
	f->attr  = getcmem (width * deep * sizeof( int));  /* frame-attribute*/

	f_rahmen (f, F_CLEAR_MODE);  /* Rahmen for the frame **/

	return( f);
	}

int f_pos (struct frame_t * f, int x, int y) {
	int pos = y * f->width + x;

#ifdef XDEBUG
	if (pos > f->chr_cnt) 
		XDEBUG5 ( "Rong X-Y-Position x=[%i], y=[%i] "
			 "but width=[%i], down=[%i]\n",
			 x, y, f->width, f->down);
#endif
	return pos;
	}

void f_changeX( struct frame_t * f, int newX) {
	f->x    = max (0, min (max_x - f->to_x + f->x, newX));
	f->to_x = f->x + f->width - 1;
	}

void f_changeY( struct frame_t * f, int newY) {
	f->y    = max(0, min (max_y - f->rows, newY));
	f->to_y = f->y + f->rows - 1;
	}

void f_changeXY( struct frame_t * f, int newX, int newY) {
	f_changeX( f, newX);
	f_changeY( f, newY);
	}

void f_changeW( struct frame_t * f, int newW) {
	f->width = min (max_x - f->x, newW),
	f->to_x  = f->x + f->width - 1;
        f_rahmen  ( f, F_CLEAR_MODE);
	}

void f_changeD( struct frame_t * f, int newD) {
	f->rows   = max(7, min(max_y-f->y-1, newD));
	f->to_y   = f->y + f->rows - 1;
	f->down   = f->rows - 2;
        f_rahmen  ( f, F_CLEAR_MODE);
	}

void hide_frame( struct frame_t * f, int mode)
{
  /** DELETE_MODE: delete frame from memory and resorte the stack **/
  /** HIDE_MODE : to hide the frame from the screen   **/
  struct queue_t *p;
  int i, j, pos, fnd, x, y;

  if (f == NULL) return;

  XDEBUG5 ("hide_frame (x=%i, y=%i, width=%i, down=%i)\n",
	   f->x,
	   f->y,
	   f->width,
	   f->down);

  hide_cursor();

  f->mode = HIDE_MODE;		   /* change frame status as hidden */

  /*
   * hide frame from desktop
   */
  if (mode & HIDE_MODE)
    view_part( f->x, f->y, f->width, f->rows);

  /*
   * delete frame from struktur
   */
  if( mode & DELETE_MODE)
    {
      del_queue( f->queue);
      Free (f->t1);
      Free (f->t2);
      Free (f->attr);
      Free (f->chr);
      Free (f);
    }
}
#ifdef XDEBUG
static struct frame_t * ff = NULL ;
void view_frame_count (void)
{
	  struct queue_t * q = queue;
	  int i ;
	  char tmp [64] ;
	  if (ff == NULL) ff = make_frame (1, 20, 30, 3, leer, leer, F_B_NORMAL, NOMODE);
	  for (i=0; q != NULL; i++, q = q->next) ;
	  sprintf (tmp, "frames=[%i]", i);
	  f_putstr (ff, 1, 1, tmp, ff->color, NOMODE);
	  view_frame (ff) ;
}
#endif

void view_frame( struct frame_t * f) 
{
	XDEBUG1("view_frame 10\n");

	if (f == NULL) return;

	move_to_top( f->queue); /* move the frame to list-top */

	f->mode = VIEW_MODE;

	view_part( f->x, f->y, f->width, f->rows);

#ifdef XDEBUG
	if (f != ff) view_frame_count () ;
#endif
}

void f_putch( struct frame_t * f, int x, int y, char c, int attr, int mode)
{
	/*** mode = SCR_MODE : auto output to the screen ***/
	/*** mode = ***/

	int pos = f_pos (f, min (x, f->width), min (y, f->rows) );
	f->chr  [pos] = c;
	f->attr [pos] = attr;

	if( mode & SCR_MODE) view_part( f->x+x, f->y+y, 1, 1);
}

		/* put char.  on the frame */

void f_putnchr( struct frame_t * f, int x, int y, char c, int cnt,
		int attr, int mode)
{
	/* mode SCR_MODE: stream to frame as to screen */
	/* mode FILL_MODE: put string to end of file **/

	int i,
	    pos = f_pos ( f, min (x, f->width), min (y, f->rows) ),
	    len = min( cnt, f->width - x - 1);

	if( mode & FILL_MODE) len = f->width - x - 1; /* to end of frame */

	for( i=0; i<len; i++, pos++)
	  {
	    f->chr [ pos] = ( i<cnt ? c : ' ');
	    f->attr[ pos] = attr;
	  }

	if( mode & SCR_MODE) view_part( f->x+x, f->y+y, len, 1);
}

void f_putstr( struct frame_t * f, int x, int y, char * str,
	int attr, int mode) 
{
	f_fillnstr( f, x, y, str, strlen(str), ' ', attr, mode);
}

void f_putnstr( struct frame_t * f, int x, int y, char * str, int cnt,
	int attr, int mode)
{
	f_fillnstr( f, x, y, str, cnt, ' ', attr, mode);
}

void f_fillnstr( struct frame_t * f, int x, int y, char * str, int cnt,
	char fill_ch,
	int attr, int mode) 
{
	/* mode SCR_MODE: stream to frame as to screen */
	/* mode FILL_MODE: put string to end of file **/

	char * q = str;
	int i, j,
	    gr_mode = attr & GRAPH_MODE,
	    pos     = f_pos (f, min (x, f->width), min (y, f->rows) ),
	    fak     = ( f->type & NOBOX_MODE ? 0 : 1),
	    len;

	if( mode & FILL_MODE) len = f->width - x - fak; /* to end of frame */
	else                  len = min( cnt, f->width - x - fak);

	for( i=0; i<len; i++, pos++) {
	    if( gr_mode                        ||
		is_ascii( (int) (* q & 0xFF) ) ||
		*q == 0
		) {
		f->chr [ pos] = *q ? ( *q++) : fill_ch;
		f->attr[ pos] = attr;
		}
	    else if( *q == TAB) {

		      /* when the frame as screen to see, you don't need */
		      /* to know at witch coloumn the frame begins and  */
		      /* you don't need to add the (f->x) faktor for the */
		      /* tab block , also not [f->x+x+i-fak] but [x+i-fak] */

		for( j=tab_size-(x+i-fak)%tab_size;
		      j>0 && i<len;
		      j--, i++, pos++ ) {
		     f->chr [pos] = ' ';
		     f->attr[pos] = attr;
		     }
		i--, pos--;
		q++;
		}
	    else if( *q == BACKSPACE && out_formatted) {
		q   ++;
		pos --;
		i   --;

		f->chr [pos] = * q;
		f->attr[pos] =   f->color != F_B_INPUT_CHS
				  ? F_B_INPUT_CHS
				  : F_B_INPUT_CLR;
		if( * q) q ++;

		}
	    else if( * q >= CTRL_A && * q <= 31) {
		f->chr [pos] = '^';
		f->attr[pos] = attr;
		pos++, i++;
		if( i >= len) break;          /* end of frame */
		f->chr [pos] = * q + 'A' - 1;
		f->attr[pos] = attr;
		q++;
		}
	    else {
		f->chr [pos] = '~';
		f->attr[pos] = attr;
		if( * q) q ++;

		}
	     }
	if( mode & SCR_MODE) view_part( f->x+x, f->y+y, len, 1);
}

/************ put n-character from the frame into the screen ***/

void f_outnch( struct frame_t * f, int x, int y, int len, int color,
	int mode) {

	/* mode NOMODE: for one color **/
	/* mode NORMAL_MODE: for colors from frame **/

	int normal = mode & NORMAL_MODE,
	    i,
	    pos;

	len = min( len, f->width - x);
	gotoxy_( x+f->x, y+f->y);

	for( i=0, pos = f_pos(f, x, y); i<len; i++, pos++) {
	     c_putch( f->chr[ pos],
		      ( normal
			? f->attr[pos]
			: (f->attr[pos] & GRAPH_MODE) | color) /* for graphic*/
		    );
	     }
	}

			/* to design a horizontal line into frame */
void f_putline( struct frame_t * f, int y, int color) {
	int pos = f_pos (f, -1, y+1),
	    i   = f_pos (f,  0, y  );
	f->chr [i] = GL,
	f->attr[i] = f->color | GRAPH_MODE; /* same color as frame */
	for(i=i+1; i<pos; i++) {
	    f->chr [i] = GH,
	    f->attr[i] = color | GRAPH_MODE;
	    }
	f->chr [i] = GR,
	f->attr[i] = f->color | GRAPH_MODE; /* same colro as frame */
	}

			/* to design a vertical line into frame */
void f_putvline( struct frame_t * f, int x, int color) {
	int pos, i,
	    fak = (f->type & NOBOX_MODE ? 0 : 1);

#ifdef DOS
	pos = x;
	if( x < f->width-1 && (f->attr[pos] & GRAPH_MODE)) {
		f->chr [pos] = G5,
		f->attr[pos] = GRAPH_MODE|color;
		}
#endif

	for(i=fak; i<=f->down; i++) {
	    pos = f_pos (f, x, i);
	    f->chr [pos] = GV,
	    f->attr[pos] = color | GRAPH_MODE;
	    }
#ifdef DOS
	pos = f_pos (f, x, f->down+1);
	if( x < f->width-1 && f->attr[pos] & GRAPH_MODE) {
		f->chr [pos] = G6,
		f->attr[pos] = GRAPH_MODE|color;
		}
#endif
	}


/*****************************************************************************/
/******** scroll frame UP or DOWN ********************************************/
/*****************************************************************************/

void f_scroll( struct frame_t * f, int mode) {
    /*** UP_MODE   : scroll frame up *************/
    /*** DOWN_MODE : scroll frame down ************/

    int i, j,
	pos1,
	pos2,
	fak = f->type & NOBOX_MODE ? 0 : 1;
							/* scroll the frame */
    if( mode & UP_MODE) {
	for( i=fak; i<f->down; i++) {
	    pos1 = f_pos (f, 1, i  );
	    pos2 = f_pos (f, 1, i+1);
	    for( j = fak; j<f->width-fak; j++, pos1++, pos2++) {
		f->chr [pos1] = f->chr [pos2]; f->chr [pos2] = ' ';
		f->attr[pos1] = f->attr[pos2]; f->attr[pos2] = f->color;
		}
	    if( mode & SCR_MODE)
		f_outnch( f, 1, i, f->width, f->color, NORMAL_MODE);
	    }
	if( mode & SCR_MODE)
	    f_outnch( f, 1, i, f->width, f->color, NORMAL_MODE);
	}
    else {
	for( i=i<f->down; i>fak; i--) {
	    pos1 = f_pos (f, 0, i-1);
	    pos2 = f_pos (f, 0, i  );
	    for( j = fak; j<f->width-fak; j++, pos1++, pos2++) {
		f->chr [pos1] = f->chr [pos2]; f->chr [pos2] = ' ';
		f->attr[pos1] = f->attr[pos2]; f->attr[pos2] = f->color;
		}
	    if( mode & SCR_MODE)
		f_outnch( f, 1, i, f->width, f->color, NORMAL_MODE);
	    }
	if( mode & SCR_MODE)
	    f_outnch( f, 1, i, f->width, f->color, NORMAL_MODE);
	}
    }

void f_rahmen( struct frame_t * f, int mode)
{
    /* mode = FALSE no clear frame */
    /* mode = F_CLEAR_MODE  clear frame */

  int
    i, j, pos,
    t1_len = min( strlen( f->t1), f->width-2),
    t2_len = min( strlen( f->t2), f->width-2),
    beg = 1,
    fak = ( f->type & NOBOX_MODE ? 0 : 1);
  
  if( fak > 0)
    {    /* if with box ***/
      
      f->chr [ f->width-1] = G1;
      f->attr[ f->width-1] = GRAPH_MODE | f->color;
      f->chr [ 0] = G2;
      f->attr[ 0] = GRAPH_MODE | f->color;
      f->chr [ f_pos (f,  0, f->rows - 1) ] = G3;
      f->attr[ f_pos (f,  0, f->rows - 1) ] = GRAPH_MODE | f->color;
      f->chr [ f_pos (f, -1, f->rows    ) ] = G4;
      f->attr[ f_pos (f, -1, f->rows    ) ] = GRAPH_MODE | f->color;
      
      /* vertical lines */
      for( i=1; i<f->rows-1; i++)
	{
	  f->chr [ f_pos (f, 0, i) ] = f->chr [ f_pos (f, -1, i+1) ] = GV;
	  f->attr[ f_pos (f, 0, i) ] = f->attr[ f_pos (f, -1, i+1) ] =
	    GRAPH_MODE | f->color;
	}
      /* horizontal */
      for( i=1; i<f->width-1; i++)
	{
	  f->chr [ i] = f->chr [ f_pos (f, i, f->rows-1) ] = GH;
	  f->attr[ i] = f->attr[ f_pos (f, i, f->rows-1) ] =
	    GRAPH_MODE | f->color;
	}
      
      f_putnstr( f, max( fak, (max (0, (f->width-2)-t1_len))/2), 0,
		      f->t1,
		t1_len,
		F_B_TITLE_CLR,
		/* f->color, */
		NOMODE);
      
      f_putnstr( f, 1, f->rows-1,
		f->t2,
		t2_len,
		F_B_TITLE_CLR,
		/* f->color, */
		NOMODE);
    }  /* With box **/
  
  /* clear the frame */
  if( mode & F_CLEAR_MODE)
    {
      for( i=fak; i<f->rows-fak; i++)
	for( j=fak; j<f->width-fak; j++)
	  {
	    pos = f_pos (f, j, i);
	    f->chr [ pos] = ' ';
	    f->attr[ pos] = f->color;
	  }
    }
  /*
   * make scroll bars on the right or buttom of the frame
   */
  if ((f->type & SCROLL_RIGHT_MODE) || (f->type & SCROLL_BUTTOM_MODE))
    {
      f_makescroller (f);
    }
}

void view_screen( void) {
     view_part( 0, 0, max_x, max_y-1);
     view_part( 0, max_y-1, max_x-1, 1);  /* don't out the last character on the screen */
     }

void view_part( int xx, int yy, int width, int down) {
    struct queue_t *p;
    int i, j, pos, fnd, x, y;
    int c;

#ifdef XDEBUG
    if (width > max_x-xx) XDEBUG3("Fehler in Frame x=[%i], width=[%i]\n", xx, width);
    if (down  > max_y-yy) XDEBUG3("Fehler in Frame y=[%i], down =[%i]\n", yy, down);

    width = min (width, max_x - xx);
    down  = min (down , max_y - yy);
#endif

    XDEBUG1("view_part 10\n");

    hide_cursor();

    for( i=0; i<down; i++) {

	gotoxy_( xx, yy+i);

	for( j=0; j<width; j++) {

	    fnd = FALSE;
					    /* ramble into the frame-qeues */
					    /* to view the current window */
	    for( p = queue->next; p != NULL; p = p->next) {

		if( p->f->mode & HIDE_MODE) continue;  /* frame is hidden */

		x = xx+j, y = yy+i;		     /* current x-y-coord. */

				/* if founded frame is in the x-y-coordi. */
				/* and this frame is viewed, then out the */
				/* current character from this frame */
		if( ( p->f->x <= x) && ( p->f->to_x >= x) &&
		    ( p->f->y <= y) && ( p->f->to_y >= y) ) {

		    pos = f_pos (p->f,  ( x - p->f->x),
					( y - p->f->y) );


		    c_putch( p->f->chr[ pos], p->f->attr[ pos]);

		    fnd = TRUE;
		    break;
		    }
		}   /* for p */

#ifdef UNIX
	    if( ! fnd) c_putch( ' ', F_B_GROUND_CLR); /* out a space-character */
#else
	    c = screen[(yy+i)*max_x+xx+j];
	    c = (c & 0xff00) >> 8;
	    c = (c & 0xf) | ((c & 0xf0) << 4);  /* translate in my format */
	    if( ! fnd) c_putch( (char)
			        screen[(yy+i)*max_x+xx+j] & 0xff,
				(int)  c
			      );
#endif
	    }   /* for j */
	} /* for i */
    }

void f_resize ( struct frame_t * f, 
		int mov_x, 
		int mov_y, 
		int res_width,
		int res_down,
		int mode) {

/**  mode = RESIZE_MODE : change size
 **  mode = MOVE_MODE   : change position 
 **/
    struct frame_t * help_f;
    char help_txt[] = "Cursor:Move#F1,F2,F3,F4:Resize";
    char chr[8];
    int x, y, width, rows,
	xx[8],
	yy[8],
	attr[8],
	i,
	ret_ = FALSE,
	lk;

    help_f = make_help ( help_txt, 0, max_y-1, max_x-1);

/*
    i = 0;
    xx[ i] = 2;             yy[ i++] = 0;
    xx[ i] = 0;             yy[ i++] = 1;

    xx[ i] = f->width-3;    yy[ i++] = 0;
    xx[ i] = f->width-1;    yy[ i++] = 1;

    xx[ i] = 0;             yy[ i++] = f->rows-2;
    xx[ i] = 2;             yy[ i++] = f->rows-1;

    xx[ i] = f->width-1;    yy[ i++] = f->rows-2;
    xx[ i] = f->width-3;    yy[ i++] = f->rows-1;

    for ( i=0; i<8; i++) {
	chr [i] = f->chr [ f_pos (f, xx[i], yy[i]) ];
	attr[i] = f->attr[ f_pos (f, xx[i], yy[i]) ];
	f_putch ( f, xx[i], yy[i], '*', f->color, SCR_MODE);
	}
*/
    view_frame( help_f);

    for ( ; TRUE; ) {

	x     = max (0, f->x-1 );
	y     = max (1, f->y-1 );
	rows  = min (max_y - y - 1, f->rows +2);
	width = min (max_x - x    , f->width+2);
	view_part   (x, y, width, rows);

	lk = getkey(-1);

	if( mode & RESIZE_MODE)
	switch ( lk) {
	    case F1:
		 f_changeW  ( f, max( 20, f->width-1) );
		 f_rahmen   ( f, F_CLEAR_MODE);
		 break;
	    case F2:
		 f_changeW  ( f, min(res_width, f->width+1) );
		 f_rahmen   ( f, F_CLEAR_MODE);
		 break;

	    case F3:
		 f_changeD  ( f, f->rows - 1 );
		 f_rahmen   ( f, F_CLEAR_MODE);
		 break;
	    case F4:
		 f_changeD  ( f, min(res_down, f->rows+1) );
		 break;
	    }

	if( mode & MOVE_MODE)
	switch ( lk) {
	    case CUR_LEFT:
		 if( f->x == mov_x) continue;
		 f_changeX  ( f, f->x-1 );
		 break;
	    case CUR_RIGHT:
		 if( f->x == max_x - f->width) continue;
		 f_changeX  ( f, f->x+1 );
		 break;
	    case CUR_UP:
		 if( f->y == mov_y) continue;
		 f_changeY  ( f, f->y-1 );
		 break;
	    case CUR_DOWN:
		 if( f->y == max_y - f->rows - 1) continue;
		 f_changeY  ( f, f->y+1 );
		 break;
	    case ENTER:
	    case CTRL_M:
	    case ESC:
		 ret_ = TRUE;
		 break;
	    }

	view_frame ( f);

	if( ret_) break;
	}

/*
    for ( i=0; i<8; i++) {
	f_putch( f, xx[i], yy[i], chr[i], attr[i], SCR_MODE);
	}
*/

    hide_frame( help_f, HIDE_MODE|DELETE_MODE);
    }

/*******************************************************************/
/****     Scroller functions                         ***************/
/*******************************************************************/

/* 
 * make or delete scroll bars on the frame side
 */
void f_scroller (frame_T f, int mode)
{
/*
 * mode: MAKE_SCROLLER   = view the scoll bars
 *       DELETE_SCROLLER = delete the scroll bars
 */
  int i;
  int
    color  = mode & MAKE_SCROLLER ? F_B_SCROLL_CLR : f->color,
    vert1  = mode & MAKE_SCROLLER ? 'v' : GV,
    vert2  = mode & MAKE_SCROLLER ? '^' : GV,
    horiz1 = mode & MAKE_SCROLLER ? '>' : GH,
    horiz2 = mode & MAKE_SCROLLER ? '<' : GH,
    v      = mode & MAKE_SCROLLER ? ' ' : GV,
    h      = mode & MAKE_SCROLLER ? ' ' : GH,
    m      = mode & MAKE_SCROLLER ? 0x0 : GRAPH_MODE;

  if ( f->type & NOBOX_MODE) return;   /* only for BOXES */

  if (f->type & SCROLL_RIGHT_MODE)
    {
      f_putch (f, f->width-1, 1, 	 vert1, color, NOMODE);
      f_putch (f, f->width-1, f->down, vert2, color, NOMODE);
      for (i=2; i<f->down; i++) 	/* vertical lines */
	{
          f_putch (f, f->width-1, i, v, m | color, NOMODE);
	}
    }

  if (f->type & SCROLL_BUTTOM_MODE)
    {
      f_putch (f, 1,          f->down+1, horiz1, color, NOMODE);
      f_putch (f, f->width-2, f->down+1, horiz2, color, NOMODE);
      for (i=2; i<f->width-2; i++)  /* horizontal */
	{
	  f_putch (f, i, f->down+1, h, m | color, NOMODE);
	}
    }
  f->vert_y = f->horiz_x = 3;		/* default */
  f_reposition (f, 0, 1, f->type);
}

/* 
 * view the current position of the bars
 */
void f_reposition (frame_T f, int pos, int total, int mode)
{
  float total_ = max(1, total);
  float pos_   = max(0, min(total, pos));
  float value  = pos_ / total_;
  float xval;
  int scr_mode = f->mode & HIDE_MODE ? NOMODE : SCR_MODE;
  int new_pos;
  int
    h = ' ',
    v = ' ',
    m = 0x0 | F_B_SCROLL_CLR;
  

  if (f->type & NOBOX_MODE) return;

  if (mode & SCROLL_RIGHT_MODE)
    {
      xval = value * (f->down-3);
      new_pos = 2 + (int) xval;			/* new vertical position */
      if (new_pos != f->vert_y)
	{
	  f_putch (f, f->width-1, f->vert_y, v, m, scr_mode);
	  f->vert_y = new_pos;
	  f_putch (f, f->width-1, f->vert_y, '#', F_B_SCROLL_CLR, scr_mode);
	}
    }

  if (mode & SCROLL_BUTTOM_MODE)
    {
      xval    = value * (f->width-5);
      new_pos = 2 + (int) xval;			/* new horizontal position */
      if (new_pos != f->horiz_x)		/* only when different pos. */
	{
	  f_putch (f, f->horiz_x, f->down+1, h, m, scr_mode);
	  f->horiz_x = new_pos;
	  f_putch (f, f->horiz_x, f->down+1, '#', F_B_SCROLL_CLR, scr_mode);
	}
    }
}
