/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: doframe.h,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/doframe.h,v $
 */

/********************* frame functions *************************/

#ifndef GLOBAL
#define GLOBAL
#endif

#ifndef DOFRAME_HH
#	define DOFRAME_HH

#define UP_MODE		0x0001			/* scroller */
#define DOWN_MODE	0x0002			/* scroller */

#define RESIZE_MODE	0x0001			/* f_resize */
#define MOVE_MODE	0x0002

#define F_CLEAR_MODE	0x0001			/* f_rahmen */

#define SCR_MODE        0x0001  /* out the char to the screen as to the frame */
#define FILL_MODE       0x0002  /* f_putstr */

#define NOBOX_MODE      	0x0001  /* make_frame */
#define NORMAL_MODE     	0x0002  /* f_putnch */
#define SCROLL_RIGHT_MODE	0x0004  /* view scrollbar on the right  */
#define SCROLL_BUTTOM_MODE	0x0008  /* view scrollbar on the buttom */

#define HIDE_MODE       0x0001  /* hide_frame */
#define VIEW_MODE       0x0002  /* status */
#define DELETE_MODE     0x0004  /* hide_frame */

#define MAKE_SCROLLER	0x0001	/* f_scroller to make scroller bars */
#define DELETE_SCROLLER	0x0002  /* f_scroller to delete scroller bars */

struct queue_t {
	long f_num;                        /* unique frame number */
	struct frame_t * f;                /* frame-pointer */
	struct queue_t * next, * prev;     /* double list */
	};

struct frame_t {
	struct queue_t * queue;
	int x,
	    y,
	    to_x,
	    to_y,               /* coordinates */
	    width,              /* width of frame */
	    down,               /* the choose-lines **/
	    rows,               /* the lines count of frames **/
	    chr_cnt;            /* count of characters on the frame */
	char * t1, * t2;                /* titles */
	char * chr;
	int  * attr;            /* val: 1-Byte=Char ; 2-Byte=Attribute */
	int  vert_y;    /* scroller position */
	int  horiz_x;  	/* scroller position */
	int  type;              /* type of the frame */
	int  color;             /* default color of frame */
	int  mode;              /* VIEW_MODE | HIDE_MODE */
	};

typedef struct frame_t * frame_T;
typedef struct queue_t * queue_T;
/***********************************************************************/

#ifdef EXTERN
GLOBAL int out_formatted;	/* to view ^H and for manual to enable */
#else
GLOBAL int out_formatted = TRUE;
#endif

/**********************  queue functions for frame sortement ************/

GLOBAL struct queue_t * make_queue   ( struct frame_t * f);
GLOBAL void   del_queue    ( struct queue_t * qu);
GLOBAL void   move_to_top  ( struct queue_t * qu);  /* move queue to top **/
GLOBAL void   ins_queue    ( struct queue_t * qu);  /* on the top of queue **/


GLOBAL struct frame_t * make_frame( int x, int y, int width, int deep,
			     char * t1,
			     char * t2,
			     int color,
			     int mode);
GLOBAL int    f_pos        (struct frame_t * f, int x, int y);
GLOBAL void   f_changeX    ( struct frame_t * f, int newX);
GLOBAL void   f_changeY    ( struct frame_t * f, int newY);
GLOBAL void   f_changeXY   ( struct frame_t * f, int newX, int newY);
GLOBAL void   f_changeW    ( struct frame_t * f, int newW);
GLOBAL void   f_changeD    ( struct frame_t * f, int newD);
GLOBAL void   f_change_t1  (struct frame_t * f, char * t);
GLOBAL void   f_change_t2  (struct frame_t * f, char * t);

GLOBAL void   f_putnchr    ( struct frame_t * f, int x, int y, char c, int cnt,
		      	     int attr, int mode);
GLOBAL void   f_putstr     ( struct frame_t * f, int x, int y, char * str,
			     int attr, int mode);
GLOBAL void   f_putnstr    ( struct frame_t * f, int x, int y, char * str,
		      	     int cnt, int attr, int mode);

GLOBAL void   f_fillnstr   ( struct frame_t * f,
			     int x,
			     int y,
			     char * str,
		      	     int cnt,
			     char fill_ch,
			     int attr,
			     int mode);

GLOBAL void   f_putch      ( struct frame_t * f, int x, int y, char c, int attr,
		      	     int mode);
GLOBAL void   f_outnch     ( struct frame_t * f, int x, int y, int len, int color,
		      	     int mode);
GLOBAL void   f_putvline   ( struct frame_t * f, int x, int color);
GLOBAL void   f_putline    ( struct frame_t * f, int y, int color);
GLOBAL void   hide_frame   ( struct frame_t * f, int mode);
GLOBAL void   view_frame   ( struct frame_t * f);
GLOBAL void   f_rahmen     ( struct frame_t * f, int mode);

/**************************************************************************/
/********************** to view and hide frames and screen     ************/
/**************************************************************************/

GLOBAL void   view_part      ( int xx, int yy, int width, int down);
GLOBAL void   view_screen    ( void);
GLOBAL void   f_scroll	     ( struct frame_t * f, int mode);
GLOBAL void   f_resize       (  struct frame_t * f, 
				int mov_x, 
				int mov_y,
				int res_width,
				int res_down,
			        int mode);

/**************************************************************************/
/*********   Scrolling on the frame to see where I'm                 ******/
/**************************************************************************/

#define f_makescroller(f)    f_scroller (f, MAKE_SCROLLER)
#define f_deletescroller(f) f_scroller (f, DELETE_SCROLLER)

void f_scroller   (frame_T f, int mode);
void f_reposition (frame_T f, int pos, int total, int mode);

#endif /*_HH*/
