/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: doglobal.h,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/doglobal.h,v $
 */

#ifndef DOGLOBAL_HH
#	define DOGLOBAL_HH

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "dodefs.h"
#include "doframe.h"
#include "dolib.h"
#include "dowin.h"
#include "dohist.h"
#include "dochoose.h"

/* .......global Variables............................................*/

#ifdef EXTERN
GLOBAL long last_queue_number;            /* queue-counter */
#else
GLOBAL long last_queue_number = 0;
#endif

GLOBAL struct queue_t * queue;

#ifdef EXTERN
GLOBAL struct com_t * com_l,
		    * com_akt;
#else
GLOBAL struct com_t * com_l   = NULL,
		    * com_akt = NULL;
#endif

extern char * sys_errlist[];

#ifdef UNIX
GLOBAL struct termio oldtty, mytty;
GLOBAL struct group  * grp;
#endif

/***********************************************************************/
/************** COLORS *************************************************/
/***********************************************************************/

GLOBAL int
#ifdef EXTERN
	use_color;              /* color/BLACK-WHITE mode */
#else
	use_color = TRUE;	/* default: use color */
#endif


GLOBAL char ** etc_id;   /* termcap from etc */

GLOBAL int
#ifdef EXTERN
     tab_size;           /* tab size for editor and view programs */
#else
     tab_size = 8;       /* tab size for editor and view programs */
#endif


GLOBAL int
#ifdef EXTERN
     cur_x,          /* current x pos. */
     cur_y,          /* current x pos. */
     out_all,        /* to out only the difference */
     out_x,
     out_y,
     max_x,          /* screen width */
     max_y;          /* screen down */
#else
     cur_x 		= 0,
     cur_y 		= 0,
     out_all 		= FALSE,       /* to out only the difference */
     out_x 		= 0,
     out_y 		= 0,
     max_x 		= 80,          /* default max. x */
     max_y 		= 24;          /* default max. y */
#endif

#ifdef UNIX
GLOBAL short
#	ifdef EXTERN
	have_winsize ;
#	else		/* global */
	have_winsize = FALSE ;
#	endif
#endif

#ifdef UNIX

#ifdef EXTERN
GLOBAL int o_g_l;                      /* owner_group_length */
GLOBAL int firsttime;                  /* firsttime for mouse klick */
#else
GLOBAL int o_g_l     = 0;                     /* owner_group_length */
GLOBAL int firsttime = TRUE;                  /* firsttime for mouse klick */
#endif

#endif

GLOBAL int 
#ifdef EXTERN
     max_com_cnt,                       /* command history of the stack */
     clock_mode,                        /* Time view mode for clock */
     timeout,                           /* timeout for clock */
     aktattr,                           /* the aktuell seted attribute */
     cur_hidden;                        /* cursor hidden/viewed */
#else
     max_com_cnt = 20,		          /* command history of the stack */
     clock_mode  = TIME_MODE | DATE_MODE, /* Time view mode for clock */
     timeout 	 = 2,			  /* timeout for clock */
     aktattr  	 = 0,		          /* to save the akt. attr for diff. */
     cur_hidden  = FALSE;                 /* cur is not hidden */
#endif

#ifdef EXTERN
GLOBAL int ins_mode;                       /* Insert Mode on/off */
#else
GLOBAL int ins_mode = TRUE;
#endif

#ifdef UNIX
#ifdef EXTERN
GLOBAL char * screen_chr;               /* screen memory character */
GLOBAL int  * screen_attr;              /* screen memory attribute */
GLOBAL int    electric_active;		/* for electric blue */
#else
GLOBAL char * screen_chr   = NULL;      /* screen memory character */
GLOBAL int  * screen_attr  = NULL;      /* screen memory attribute */
GLOBAL int    electric_active = FALSE;	/* for electric blue */
#endif
#endif

GLOBAL int     argc_;                   /* argument global variables */
GLOBAL char ** argv_;


#ifdef UNIX
GLOBAL char
     my_tty [MAXPATH],		/* ttyname without path */
     * gr_char [MAX_GR_CHAR], /* graphic design set for frames */
     * owner,
     * owner_gr,
     * term;
#endif			/* ifdef UNIX */

#ifdef EXTERN
GLOBAL char * exec;
GLOBAL char * leer;
#else
#ifdef DOS
GLOBAL char * exec = "";
#else
GLOBAL char * exec = "exec";
#endif
GLOBAL char * leer = "";
#endif  /* ifdef EXTERN */

GLOBAL char
     prog_path   [MAXPATH+1],  /* the voll pathname without program name */
     prog_name   [MAXPATH+1],  /* the program name with voll path */
     pr_to_run   [MAX_COM_LEN+1];

#ifdef EXTERN
GLOBAL char
     * dollar,
     * choose_str,          /* input variable to choose files */
     * select_str;          /* input variable to select files */
#else
GLOBAL char
     * dollar     = NULL,
     * choose_str = NULL,   /* input variable to choose files */
     * select_str = NULL;   /* input variable to select files */
#endif

GLOBAL time_t akt_time;         /* time for clock */

GLOBAL struct win_t * w_[ MAX_WIN];  /* init the w_ struct pointer */

				 /* help frames */
GLOBAL struct frame_t
#ifdef EXTERN
       * title_f,         /* title frame */
       * ins_f,           /* to view insert mode **/
       * clock_f,         /* clock frame */
       * help1,           /* command helps */
       * com_line_frame;  /* for command line */
#else
       * title_f 	= NULL,
       * ins_f 		= NULL,   /* to view insert mode **/
       * clock_f 	= NULL, /* clock frame */
       * help1 		= NULL,
       * com_line_frame = NULL; /* for command line */
#endif

#ifdef UNIX
GLOBAL unsigned short
#ifdef EXTERN
    u_id,
    g_id,
    gid,
    uid;
#else
    u_id = 0,
    g_id = 0,
    gid  = 0,
    uid  = 0;
#endif
#endif

				/* screen basic memory and old value **/
#ifdef UNIX
GLOBAL int * scr_mem;
GLOBAL int  * screen;           /* to save the screen in extra buffer */
#else
GLOBAL unsigned int far * scr_mem;
GLOBAL int scr_seg;                 /* segment adress of screen video */
GLOBAL int * screen;                /* old screen entries */
GLOBAL char scr_videomode;          /* aktiv video mode */
#endif

/************ mouse variables *********************/

#ifdef UNIX

GLOBAL struct devinfo * dev;        /* device information **/

#ifdef MOUSE

GLOBAL  char o_scr_val;
GLOBAL dmask_t dmask;               /* Mouse and Keyboard **/
GLOBAL EVENT
#ifdef EXTERN
	* ev;                  /* a event structure **/
#else
	* ev = NULL ;
#endif

GLOBAL int
#ifdef EXTERN
      gin,                          /* **/
      scr_pos,                      /* scr_position of the mouse */
      o_scr_pos,
      ms_x,                         /* current mouse x-coordinate */
      ms_y,                         /* current mouse y-coordinate */
      o_ms_x,                       /* current mouse x-coordinate */
      o_ms_y,                       /* current mouse y-coordinate */
      o_klick,
      ms_klick,
      ms_wait,                     /* wait ms_wait, wenn the Button klicked */
				   /* and is pressed */
      ms_timeout;                  /* timeout for double klick */
#else
    scr_pos   		= 1, 	   /* scr_position of the mouse */
    o_scr_pos 		= 1,
    ms_x 		= 1, 	   /* current mouse x-coordinate */
    ms_y 		= 1,	   /* current mouse y-coordinate */
    o_ms_x 		= 1, 	   /* current mouse x-coordinate */
    o_ms_y 		= 1,	   /* current mouse y-coordinate */
    o_klick  		= 0,
    ms_klick 		= FALSE,
    ms_wait    		= 30,      /* wait, wenn Buttom klicked and is pressed */
    ms_timeout 		= 300,	   /* timeout for double klick */
    o_timestep 		= 0;	   /* for double klick */
#endif

GLOBAL float
#ifdef EXTERN
       ms_xf,
       ms_yf;                /* float values to set the fast of mouse **/
#else
       ms_xf = 1.0,
       ms_yf = 1.0;    	     /* float values to set the fast of mouse **/
#endif

GLOBAL unsigned long o_timestep;            /* for double klick */

#endif

#endif

GLOBAL  int
#ifdef EXTERN
	mouse_mode,         /* flag for mouse presentation */
	use_mouse,          /* flag for useing mouse or not **/
	err;
#else
	mouse_mode = FALSE,         /* flag for mouse presentation */
	use_mouse  = FALSE,          /* flag for useing mouse or not **/
	err        = 0;
#endif

/******** end of mouse variable def. ***********/

/***************************************************************************/
/*****************  help text   ********************************************/
/***************************************************************************/

#endif /*_HH*/
