/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: dohexa.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/dohexa.c,v $
 */

/************************************************************************/
/************ Hexa Editor ***********************************************/
/************************************************************************/

#define GLOBAL extern
#define EXTERN

#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <string.h>
#ifdef UNIX
#include <unistd.h>
#endif

#ifdef DOS
#include <io.h>
#endif

#include "dodefs.h"
#include "doglobal.h"
#include "doscr.h"
#include "doerror.h"
#include "domem.h"
#include "domenu.h"
#include "doutil.h"
#include "dofiles.h"
#include "doedit.h"
#include "doqsort.h"
#include "dostring.h"
#include "docfg.h"
#include "dotext.h"
#include "dolib.h"
#include "dohexa.h"

#define HEXALEN 12

int hexa_keys[][MAXMENU_ENTRY] = 
	{
	  { F2, ESC },
	  { F3, F4, F5  },
	  {
	    COLORS_KEY,
	    CONFIG_KEY
	  },   /* colors menu */
		{ F1
		}
	};

char * hexa_line[] =
	{ 
	  " File ",
	  " Search ",
	  " Option ",
	  " Help ",
	  NULL
	},
     * hexa_event[][MAXMENU_ENTRY] = 
		{
		  {
		    " Save        F2 ",
		    " Exit       F12 ",
		    NULL
		  },
		  {
		    " Search         Ctrl-K F3 ",
		    " Hexa Search    Ctrl-X F4 ",
		    " Goto Byte      Ctrl-G F5 ",
		    NULL
		  },
		  {
		    " Colors ",
		    " Save options ",
		    NULL
		  },
		  {
		    " Help        F1 ",
		    NULL
		  }
		};


long file_findstr( struct frame_t * f, int file_h, char * str, int mode) 
{
  /* mode: CASES_MODE don't ignore littel and big latters */
  /* NULL: ignore littel and big letters 		 */

  char 
    * tmp,
    gr_chr = '*',
    gr_emp = '-';
  int    
    i,
    value,
    blck,                            /* the readed buffer block */
    gr_x     = 2,                    /* graphic line x-coord. */
    gr_y     = 4,                    /* graphic line y-coord. */
    gr_view  = 0,                    /* view graphic in cycles */
    gr_width = f != NULL ? f->width-4 : 0, /* graphic view width */
    len      = strlen(str),          /* strlength of battern to find */
    buf_len  = max( 1024, len*2),    /* buffer block */
    str_pos  = 0;                    /* ring */
  
  long
    old_pos = lseek( file_h, 0, SEEK_CUR),  /* save position */
    pos     = old_pos,                      /* graph view */
    size    = lseek( file_h, 0, SEEK_END);  /* size of file */
  
  if( len<= 0) return( 0);                     /* no string */
  
  /* graph line */
  if( f != NULL)
    f_putnchr( f, gr_x, gr_y, gr_emp, gr_width, f->color, SCR_MODE);
  
  lseek( file_h, old_pos+1, SEEK_SET);     /* one character forwards */
  
  tmp = getmem( buf_len + 1);                 /* buffer length */
  
  for( value=0; ( blck=read( file_h, tmp+str_pos, buf_len-str_pos)) > 0; ) 
    {
      
      if (mode & CASES_MODE)
	{
	  value = nstrfind (tmp, str, min( blck+str_pos, buf_len), len);
	}
      else
	{
	  value = case_strfind (tmp,
				str,
				min( blck+str_pos, buf_len),
				len,
				mode
				);
	}
      
      if( f != NULL && (gr_view++ % 5) == 0) 
	{
	  i = (int) ( (long) (pos*gr_width) / size);
	  f_putnchr( f, gr_x, gr_y, gr_chr, i, f->color, SCR_MODE);
	  fflush_();
	}
      
      if( value > 0) break;           /* battern found */
      pos += buf_len-str_pos;         /* graph view */
      
      str_pos = len;                  /* slide the ring */
      
      for(i=0; i<str_pos; i++) tmp[i] = tmp[i+buf_len-str_pos];  /* ring */
      
    }
  Free( tmp);
  
  if( value == 0) 
    {
      if( f != NULL) message( " String not found ", leer);
      lseek  ( file_h, old_pos, SEEK_SET);
      return ( old_pos);
    }
  
  pos = lseek (file_h,
	       value-min(blck+str_pos,buf_len)-1,
	       SEEK_CUR
	       ); 			/* current position */
  pos = max( 0, pos);
  
  return (pos);
}

long file_findtext( int file_h, char * str, int mode) 
{
/* mode = COUNT_LINES : count the lines from file cursor to found string */

  struct frame_t * f;
  struct input_t * in;
  struct log_t   * lg;
  char * cases[] = { "X", " " };
  long 
    pos   = (mode & COUNT_LINES) ? 0 : lseek (file_h, 0, SEEK_CUR);
  int 
    i,
    width = min( max_x, 60),
    down  = 6,
    x     = (max_x-width)/2,
    y     = (max_y-down )/2,
    lk;
  
  f     = make_frame (x, y, width, down,
		      " Search ", leer,
		      F_B_DIALOG_CLR,
		      NOMODE
		      );
  in    = make_input (f, 2, CUR_MODE|INS_MODE);
  lg    = make_log   (f, 2, F_B_DIALOG_CHS);
  log_format (lg, "X", " ");
  log_xy     (lg, 18, 3, 18, 3);
  lg->pos = 1;             /* default: not case sensitive */
  
  f_putstr (f, 1, 1, "String:", f->color, NOMODE);
  f_putstr (f, 1, 3, "case sensitive:", f->color, NOMODE) ;

  input_string (in, 0, 9, 1, str, FINDLEN-1, FINDLEN-1);
  input_log    (in, 1, lg);
  
  view_frame( f);
  lk  = f_getstr (in);
  if (lg->pos == 0) mode |= CASES_MODE ;

  if( lk == ENTER || lk == CTRL_M)
    {
      if ( mode & COUNT_LINES)		/* return count of lines */
	{
	  char tmp [1024];
	  int len, found;
	  for (pos = 0, found = FALSE;
	       (len = read_line (file_h, tmp, 1024)) >= 0;
	       pos ++
	       )
	    {
	      tmp [len] = 0;		/* string end */
	      if (! mode & CASES_MODE)
		len = strfind (tmp, str);
	      else
		len = case_strfind  (tmp, str,
				     strlen (tmp), strlen (str),
				     CASES_MODE);
	      if (len > 0) { found = TRUE; pos ++; break; }
	    }
	  if (! found)
	    {
	      message (" String not found ", " Search ");
	      pos = 0;
	    }
	}
      else
	pos = file_findstr (f, file_h, str, mode);
    }
  del_input  (in);
  hide_frame (f, HIDE_MODE|DELETE_MODE);
  return     pos;
}

long file_findhexa( int file_h, char * str, int mode) 
{
  struct frame_t * f;
  struct input_t * in;
  char 
    hexa[HEXALEN][4];
  long
    old_pos = lseek( file_h, 0, SEEK_CUR),
    pos     = old_pos;
  int
    width = min( max_x, 60),
    down  = 4,
    x     = (max_x-width)/2,
    y     = (max_y-down )/2,
    i,
    lk;
  
  f  = make_frame (x, y,
		   width, down, " Search [Hexa] ", 
		   leer,
		   F_B_DIALOG_CLR,
		   NOMODE
		   );
  in = make_input( f, HEXALEN, CUR_MODE|INS_MODE);
  
  f_putstr( f, 1, 1, "String:", f->color, NOMODE);

  for( i=0; i<HEXALEN; i++)  
    {
      sprintf( hexa[i], "%02x", (char) str[i] & 0xff);
      input_hexa (in, i, 8 + i * 3, 1, hexa [i], 2, 2);
    }
  
  view_frame( f);
  lk  = f_getstr( in);
  if( lk == ENTER || lk == CTRL_M) 
    {
      
      for(i=0; i<HEXALEN; i++) sscanf( hexa[i], "%x", &str[i]);
      
      pos = file_findstr( f, file_h, str, mode);
    }
  del_input ( in);
  hide_frame( f, HIDE_MODE|DELETE_MODE);
  return( pos);
}

struct frame_t * make_help (char hlp [], int x, int y, int width) 
{
  struct frame_t * f;
  int i;
  char * p;
  
  f = make_frame( x, y, width, 1, leer, leer, F_B_GROUND_CLR, NOBOX_MODE);

  f_putstr (f, 0, 0, hlp, F_B_HELPLINE_CLR, NOMODE);
  for (p = hlp, i=0; (i = chrindex (p, "#")) >= 0; p += i + 1)
    {
      f_putch (f, (p - hlp) + i, 0, ' ', f->color, NOMODE);
    }

  return f;
}

/*
 * view file in hexadecimal format
 *
 * mode: HEXA_VIEW_MODE: view file only
 *       HEXA_EDIT_MODE: edit the file
 */
void hexa_editor (char * exe_file, int mode)
{
  struct frame_t * f, * hlp;
  char
    hlp_text[] =
	"TAB:Hexa/Character"
	"#F2:save"
	"#F3:Search"
	"#F4:HexaSearch"
	"#F5:Goto"
	"#F12:Abort/Leave";
  char
    tmp [MAXPATH],
    * buf,
    * tmp_file;
  char c;
  int
    width = max_x,                 /* for big frame */
    down  = max_y-2,
    x     = (max_x-width)/2,
    y     = 1,
    refr  = TRUE,
    refr_line = FALSE,
    hex_w   = 3,                   /* hexa digit width on one block */
    chr_w   = 1,                   /* character width on char. column */
    hex_col = 7,                   /* begin of hexa view column */
    chr_set = (width-hex_col)/(hex_w+chr_w) - 1, /* count of chars on 1 line */
    chr_col = chr_set*hex_w+2,                   /* char. block column*/
    lk,                                          /* last key */
    i,
    buf_i,
    j,
    len,
    from,
    to,
    end_ = FALSE,
    chr_hex = FALSE,      /* stay by hexa or character block */
    pos_x,                /* x-coord. of aktual choose block */
    pos_y,                /* y-coord. of aktual choose block */
    pos_w,                /* aktual choose block width on the frame */
    pos_pos;              /* x-coord. for file position */

  struct frame_t * copy_f;                    /* frame f+r copy command */
  int
    copy_mode = OVERWRITE_MODE,          /* copy mode */
    copy_w    = min( max_x,60),          /* coordinates */
    copy_d    = 8,                       /* not smaler than 8 */
    copy_x    = (max_x-copy_w)/2,
    copy_y    = (max_y-copy_d)/2;

  long
    head_open = 0,        /* file header on the top of the frame */
    f_size,            /* file size */
    pos       = 0;        /* aktual positon on the file header */

  int
    file_h;                /* file handler */

  /* if can't open file then break */
  /*
     if( ! can_write( exe_file) )
     {
     sprintf( tmp, "File <%s> can't open ", exe_file);
     message( tmp, leer);
     return;
     }
     */

  /* file size */
  f_size = file_size (exe_file, NOMODE);

  /* size must greater than 0 */
  if( f_size <= 0)
    {
      sprintf( tmp, "File <%s> has size <%li>, Edit not possible",
	      exe_file, f_size
	      );
      message( tmp, leer);
      return;
    }

#ifdef DOS
#define	TEMP_DIR ""
#else
#define TEMP_DIR "/tmp"
#endif

  /*
   * temporary file
   */
  tmp_file = tempnam (TEMP_DIR, "KH");

  if( tmp_file==NULL)
    {
      message(  "Temp.file can't create, Edit not possible", leer);
      return;
    }

  /*
   * Make title
   */
  sprintf (tmp, " Hexa %s of <%s> ",
		mode & HEXA_VIEW_MODE ? "View" : "Edit",
		exe_file);
  f      = make_frame (x, y, width, down, tmp, leer,
		       F_B_NORMAL,
		       NOMODE);

  f_putline( f, f->down-1, f->color);
  f->down = f->down-2;
  f->type |= SCROLL_RIGHT_MODE;
  f_makescroller (f);

  copy_f = make_frame( copy_x, copy_y, copy_w, copy_d,
		      " Save ",
		      leer,
		      F_B_UTIL_CLR, NOMODE);

  hlp    = make_help( hlp_text, x, f->to_y+1, width-1);

  f_putvline( f, hex_col-1, f->color);
  f_putvline( f, hex_col+chr_set*hex_w-1, f->color);

  sprintf ( tmp, "Size: %li", f_size);
  f_putstr( f, 1, f->down+2, tmp, f->color, NOMODE);
  pos_pos = strlen(tmp)+2;
  f_putstr( f, pos_pos, f->down+2, "Position: ", f->color, NOMODE);
  pos_pos +=10;

  view_frame( f);
  view_frame( hlp);

  /*
   * make a copy of the current file to edit a temporary file
   */
  if (mode & HEXA_EDIT_MODE)
    {
      end_ = copy( copy_f, exe_file, tmp_file, NULL, &copy_mode);

      hide_frame( copy_f, HIDE_MODE);

      if( end_ != 0)
	{
	  message( "Can't create temporary file", " Save file ");
	}
      else file_h = open (tmp_file, O_RDWR|O_BINARY); /* file handler */
    }
  else
    {
      /*
       * open the original file as read-only
       */
      file_h = open (exe_file, O_RDONLY|O_BINARY);

      if (file_h < 0)
	end_ = TRUE;
      else
	end_ = FALSE;
    }

  buf = getmem (chr_set * f->down * sizeof(char));

  if( ! end_)
    while( TRUE)
      {
	if( refr || refr_line)
	  {

	    if( refr) from = 0, to = f->down;
	    else from = pos_y-1, to = from+1;       /* current line */

	    lseek( file_h, head_open + from * chr_set, SEEK_SET);

	    len = read( file_h, buf, chr_set * (to - from));

	    for( buf_i=0, i=from; i<to; i++)
	      {
		/* current line in hexa digit */
		strcpy (tmp,
			MY_ltohex (lseek (file_h, 0, SEEK_CUR)
				   / chr_set, 5, '0'
				   )
			);
		f_putstr( f, 1, 1+i, tmp, f->color, NOMODE);

		for( j=0; j<chr_set; j ++, buf_i++)
		  {

		    strcpy (tmp,
			    buf_i >= len
			    ? "  "
			    : MY_ltohex (buf[buf_i] & 0xFF, 2, '0')
			    );
		    f_putstr (f, hex_col+j*hex_w,    /* hexa digits */
			      1+i,
			      tmp,
			      f->color,
			      NOMODE
			      );
		    f_putch ( f, chr_col+hex_col+j*chr_w,  /* character*/
			     1+i,
			     (char) (
				     buf_i >= len 
				     ? ' '
				     : (char)
				     (is_ascii(buf[buf_i] & 0xff)
				      ? buf[buf_i]
				      : '.')),
			     f->color,
			     NOMODE
			     );
		  }
	      }
	    
	    view_frame( f);
	    
	    refr      = FALSE;
	    refr_line = FALSE;
	    
	  }
	
	pos_x = ( pos - head_open) % chr_set;
	pos_x = hex_col + (chr_hex ? chr_w : hex_w) * pos_x;
	pos_x += ( chr_hex ? chr_col : 0);
	
	pos_y = ( pos - head_open) / chr_set + 1;
	pos_w = chr_hex ? chr_w : hex_w-1;
	
	sprintf ( tmp, "%8li", pos+1);
	f_putstr( f, pos_pos, f->down+2, tmp, f->color, SCR_MODE);

	f_reposition (f, pos, f_size-1, SCROLL_RIGHT_MODE);
	
	f_outnch( f, pos_x, pos_y, pos_w, F_B_INPUT_CHS, SCR_MODE);
	
	lk = getkey(-1);

	/*
	 * Edit only in the HEXA_EDIT_MODE
	 */
	if (mode & HEXA_EDIT_MODE)
	  {
	    if (! chr_hex && ishexa (lk))
	      {
		char new_c;
		f_putch ( f, pos_x  , pos_y, (char) lk, f->color, SCR_MODE);
		f_outnch( f, pos_x+1, pos_y, 1,  F_B_INPUT_CHS, NOMODE);

		lseek( file_h, pos, SEEK_SET);
		read ( file_h, &c, 1);

		if( isdecimal(lk)) new_c = lk - '0';
		else if( lk >= 'A' && lk <= 'F') new_c = 10 + lk - 'A';
		else if( lk >= 'a' && lk <= 'f') new_c = 10 + lk - 'a';

		new_c = (new_c << 4) | (c & 0xf);

		lk = getkey(-1);
		if( ishexa( lk))
		  {
		    f_putch (f, pos_x+1, pos_y, (char) lk,
			     f->color, SCR_MODE);

		    new_c &= 0xf0;
		    if( isdecimal(lk)) new_c += lk - '0';
		    else if( lk >= 'A' && lk <= 'F') new_c += 10 + lk - 'A';
		    else if( lk >= 'a' && lk <= 'f') new_c += 10 + lk - 'a';
		  }

		lseek( file_h, pos, SEEK_SET);
		write( file_h, &new_c, 1);
		refr_line = TRUE;
	      }
	    else if( chr_hex && is_ascii (lk))
	      {
		lseek( file_h, pos, SEEK_SET);
		write( file_h, &lk, 1);
		lk        = CUR_RIGHT;
		refr_line = TRUE;
	      }
	  }

	f_outnch( f, pos_x, pos_y, pos_w, NOMODE, NORMAL_MODE);

	switch( lk)
	  {
	  case F10:
	    lk = menu( hexa_keys, hexa_line, hexa_event);
	    break;
	  }
	switch( lk)
	  {

	  case CUR_RIGHT:
	    pos = min( f_size-1, pos+1);
	    break;
	  case CUR_LEFT:
	  case BACKSPACE:
	    pos = max( 0, pos-1);
	    break;
	  case CUR_DOWN:
	    pos = min( f_size-1, pos+chr_set);
	    break;
	  case CUR_UP:
	    pos = max( 0, pos-chr_set);
	    break;
	  case PAGE_UP:
	    pos = max( 0, pos - chr_set * (f->down-1));
	    break;
	  case PAGE_DOWN:
	    pos = min( f_size-1, pos + chr_set * (f->down-1));
	    break;
	  case HOME:
	    pos = 0;
	    break;
	  case END:
	    pos = f_size-1;
	    break;
	  case TAB:
	    chr_hex = ~ chr_hex;
	    break;

	  /*
	   * Save the new modifikation
	   */
	  case F2:
	    if (mode & HEXA_VIEW_MODE) break;

	    view_frame( copy_f);
	    end_ = copy( copy_f, tmp_file, exe_file, NULL, &copy_mode);
	    hide_frame( copy_f, HIDE_MODE);
	    break;
	  case F3:
	  case CTRL_K:
	    lseek( file_h, pos, SEEK_SET);
	    pos = file_findtext( file_h, file_search, NOMODE);
	    break;
	  case F4:
	  case CTRL_X:
	    lseek( file_h, pos, SEEK_SET);
	    pos = file_findhexa( file_h, hexa_search, NOMODE);
	    break;
	  case F5:
	  case CTRL_G:
	    pos = file_goto( f_size, pos);
	    break;
	  case F1:
	    help();
	    break;
	  case CONFIG_KEY:
	    save_config(&MY_cfg);
	    break;
	  case COLORS_KEY:
	    change_colors();
	    break;
	  case ESC: 
	    {
	      int err_;
	      /*
	       * DialogBox only by EDIT-Mode
	       */
	      if (mode & HEXA_EDIT_MODE)
		{
		  err_ = Getyesno (" Leave, Are you sure ? ", NULL,
			       " Hexa Editor ",
			       -1);
		  if( err_ == 0) end_ = TRUE;
		}
	      else
		end_ = TRUE;
	    }
	    break;
	  }
	if( end_) break;
	
	while( pos > head_open+chr_set*(f->down-1)) 
	  {
	    head_open = min( f_size-1, head_open+chr_set);
	    refr = TRUE;
	  }
	while( pos < head_open) 
	  {
	    head_open = max( 0, head_open-chr_set);
	    refr = TRUE;
	  }
      }
  
  close  (file_h  );
  remove (tmp_file);
  Free   (tmp_file);   /* allocted from temnam-procedure */
  Free   (buf     );
  hide_frame (copy_f, HIDE_MODE|DELETE_MODE);
  hide_frame (hlp,    HIDE_MODE|DELETE_MODE);
  hide_frame (f,      HIDE_MODE|DELETE_MODE);
  
}

