/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: dohist.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/dohist.c,v $
 */


#define GLOBAL extern
#define EXTERN

#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#ifdef DOS
#include <io.h>
#endif

#include "dodefs.h"
#include "doglobal.h"
#include "doerror.h"
#include "domem.h"
#include "docfg.h"
#include "dofiles.h"
#include "dohist.h"

/**********************************************************************/
/******************** Commandline functions        ********************/
/**********************************************************************/

/*** make command to save it in the stack ***/

struct com_t * make_com( void )
{
  struct com_t * q = getmem( sizeof( struct com_t));
  q->com  = NULL;
  q->next = NULL;
  q->prev = NULL;
  return( q);
}

/**** insert command in the history and the stack and cut the stack, if ****/
/**** the stack is full ***/

void insert_com( char * com)
{
  struct com_t * q, * p;
  FILE * f;

  if (com_l == NULL) return ;

  q = last_com();
  if( strcmp( q->com, com) == 0) return;
  
  if( ( f = fopen (MY_cfg.options [HIST], "a")) != NULL)
    {
      fprintf( f, "%s\n", com);
      fclose( f);
    }
  
  /**** you have only 'max_com_cnt' of commands to save ****/
  if( com_cnt() > max_com_cnt) del_com( com_l->next);
  
  p = make_com();
  
  p->com = getmem( strlen( com) + 1);
  strcpy( p->com, com);
  q->next = p;
  p->prev = q;
}

/**** last command on the stack ***/

struct com_t * last_com( void)
{
  struct com_t * q = com_akt;
  while( q->next != NULL) q = q->next;
  return( q);
}

/*** delete command from the stack - wenn the stack is overflow */

void del_com( struct com_t * com)
{
  com->next->prev = com->prev;
  com->prev->next = com->next;
  Free( com);
}

void read_first_commands(void)
{
  struct com_t * q = last_com(), * p;
  
  char buf[MAX_COM_LEN+1];
  int
    file_h, i;
  long
    beg,
    end;
  
  beg = end = file_size( MY_cfg.options[HIST], NOMODE);
  file_h    = open     ( MY_cfg.options[HIST], O_RDONLY|O_BINARY);
  if( file_h <= 0) return;
  
  for( i=0; i<max_com_cnt; i++)
    {
      
      if( ! move_line( file_h, PREVLINE_MODE)) break;
      
      if( read_line( file_h, buf, MAX_COM_LEN) <= 0) break;
      
      XDEBUG1( "first-> 20\n");
      
      p = make_com();
      p->com = getmem( strlen(buf) + 1);
      strcpy( p->com, buf);
      
      XDEBUG1( "first-> 30\n");
      
      q = com_l->next;
      com_l->next = p;
      p->prev = com_l;
      p->next = q;
      if( q != NULL) q->prev = p;
      
      XDEBUG1( "first-> 40\n");
    }
  close( file_h);
}

/**** command history count at the stack ***/

int com_cnt( void)
{
  int i = 0;
  struct com_t * q = com_l->next;
  while( q != NULL) i++, q = q->next;
  return( i);
}

/*** get one command form the history ***/

int get_com( char * com)
{
  int i = 0;
  
  i = view_file(
		MY_cfg.options[HIST],
		" command history ",
		0,
		1,
		max_x / 2,
		max_y - 7,
		com,
		MAX_COM_LEN,
		END_OF_FILE);	/* begin at end of file */
  return( i);
}

/**********************************************************************/
/******************** Commandline functions  end   ********************/
/**********************************************************************/

