/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: doinit.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/doinit.c,v $
 */


#define GLOBAL extern
#define EXTERN

#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <string.h>

#ifdef UNIX
#include <termio.h>
#include <signal.h>
#include <pwd.h>
#include <grp.h>
#endif

#ifdef DOS
#include <io.h>
#endif

#include "dodefs.h"
#include "doglobal.h"
#include "doscr.h"
#include "doedit.h"
#include "domem.h"
#include "doerror.h"
#include "dostern.h"
#include "dotext.h"
#include "doutil.h"
#include "docfg.h"
#include "dostring.h"
#include "dohist.h"
#include "doinit.h"

/***********************************************************************/
/********     Program to init the values                          ******/
/***********************************************************************/

extern char * ttyname( int);

void view_about ( void)  {
    struct frame_t * f;
    int width = 0, i;
    for ( i=0; auto_txt[i] != NULL; i++) width = max( width, strlen(auto_txt[i])+3);

    f = make_frame ( (max_x-width)/2, (max_y-i-2)/2, width, i+2,
		     leer,
		     leer,
	             F_B_HEAD_CLR,
		     NOMODE);
	
    for ( i=0; auto_txt[i] != NULL; i++)
	f_putstr ( f, 1, i+1, auto_txt[i], f->color, NOMODE);

    view_frame( f);

    getkey(-1);

    hide_frame ( f, HIDE_MODE|DELETE_MODE);
    }


void init_values (MY_cfg_T config) {

#ifdef UNIX
    struct passwd * pass_wd;
#endif
    int i;
    char * p;

    XDEBUG1("doinit ---> -50\n");

    strcpy (prog_name, prog_path);
    for (i=strlen(prog_path);
	 i>=0 && prog_path [i] != root;
	 i--
	 ) prog_path[i] = 0;

				/* signals */
#ifdef UNIX
    signal( SIGINT,  want_quit);
    signal( SIGQUIT, want_quit);
    signal( SIGKILL, quit);
    signal( SIGBUS,  buserror);
    signal( SIGTERM, quit);
    signal( SIGSTOP, quit);


    XDEBUG1("doinit ---> -40\n");

					/* my tty name without path */
    if( ( p = (char *) ttyname (0)) != NULL) {
	for( i=strlen(p)-1; i>= 0 && p[i] != '/'; i--);
	strcpy( my_tty, p+i+1);
	}

    XDEBUG1("doinit ---> -30\n");
#endif

    XDEBUG1("doinit ---> 1\n");

    temp_fname[0] 	= 0;		 /* name of temp file for editor */

    XDEBUG1("doinit ---->2\n");

#ifdef DOS
    scr_videomode = get_videomode();            /* get active video mode */
    max_x         = get_max_x( scr_videomode);  /* max_x */
    max_y         = get_max_y( scr_videomode);  /* max_y */

    scr_mem = (unsigned int far *) MK_FP( get_seg( scr_videomode), 0x0);
    screen  = NULL;
#else
    screen  = NULL;
#endif

    /******************************** configuration file as first to load */

    XDEBUG3(" doinit 2 &cfg=[%p] config=[%p]\n", &MY_cfg, config);
    XDEBUG2(" doinit 3 cfg.max_file_cnt=[%i]\n", MY_cfg.max_file_cnt);
    XDEBUG2(" doinit 1 sizeof cfg=[%i]\n", sizeof(struct MY_cfg_t));

    read_config (config);      /* colors */

    XDEBUG2(" doinit 4 cofig=[%p]\n", config);
    XDEBUG2(" doinit 5 cfg.max_file_cnt=[%i]\n", config->max_file_cnt);

    /*********************************** queue initialisation ***********/
    queue     = make_queue( NULL);

    XDEBUG2(" doinit 6 cofig=[%p]\n", config);
    XDEBUG2(" doinit 7 cfg.max_file_cnt=[%i]\n", config->max_file_cnt);

    XDEBUG1("doinit ------> 3\n");

    /**************************************************** user utilities */

#ifdef UNIX
    u_id      = geteuid();		                        /* user id */
    g_id      = getegid();		                        /* group id */
    grp       = getgrgid( g_id);	                      /* group name */
    pass_wd   = getpwuid( u_id);		  /* user/group information */
    owner     = getmem( strlen( pass_wd->pw_name) + 1);   /* save user name */
    owner_gr  = getmem( strlen( grp->gr_name) + 1);        /* save group name */
    endpwent();					     /* close the passwd-file */
    strcpy( owner,    pass_wd->pw_name);
    strcpy( owner_gr, grp->gr_name);
    o_g_l     = strlen( owner) + strlen( owner_gr) + 2;
    if( u_id == 0) dollar = " #"; else dollar = " $";
    o_g_l     = 0;
#else
    dollar    = ">";
#endif

    /*************************************** end of user utilities ******/

#ifdef UNIX
    GET_TTY( &oldtty);	    /* I need it for quit */
    term      = getterm();      /* TERM */
#endif

    XDEBUG1("doinit ------> 4\n");


    XDEBUG1("doinit ------> 5\n");

/* This really belongs in get_etc_termcap (), but we need it to
 * set the config variables correctly (Grog, 29 January 1994) */
#ifdef HAVE_WINSIZE
    {
      struct winsize wininfo;
    
      if (ioctl (STD_IN, TIOCGWINSZ, (char *) &wininfo) >= 0)
	{
	  have_winsize = TRUE ;
	  max_x = wininfo.ws_col;
	  max_y = wininfo.ws_row;
	}
    }
#endif

    XDEBUG2(" doinit 8 cofig=[%p]\n", config);
    XDEBUG2(" doinit 9 cfg.max_file_cnt=[%i]\n", config->max_file_cnt);

#ifdef UNIX
    get_etc_termcap();        /* Escape sequence */
#endif

    XDEBUG1("doinit ------> 6\n");

    XDEBUG2(" doinit 10 cofig=[%p]\n", config);
    XDEBUG2(" doinit 11 cfg.max_file_cnt=[%i]\n", config->max_file_cnt);

    get_screen();             /* save screen */

    XDEBUG1("doinit ------> 7\n");

#ifdef UNIX
    init_tty_mouse();       /* init tty and mouse if asked */

    XDEBUG2(" doinit 12 cofig=[%p]\n", config);
    XDEBUG2(" doinit 13 cfg.max_file_cnt=[%i]\n", config->max_file_cnt);

    XDEBUG1("doinit ------> 8\n");

    clrscr_();		    /* clear screen */

    XDEBUG1("doinit ------> 9\n");

#endif

    /***** view the windows **/

#if defined DOS	&& defined MOUSE			/* mouse */
    M_reset();
    M_window( 1, 1, 632, 192);
#endif

    XDEBUG1("doinit ------> 10\n");

    XDEBUG1("doinit ------> 11\n");

    get_tmp_file_hist();                 /* temp file and history */

    XDEBUG2(" doinit 14 cofig=[%p]\n", config);
    XDEBUG2(" doinit 15 cfg.max_file_cnt=[%i]\n", config->max_file_cnt);

    XDEBUG1("doinit ------> 12\n");

    if( argc_ > 1) com_line_arg( argc_, argv_); /* covert the argument list **/


    XDEBUG1("doinit ------> 13\n");

    XDEBUG2(" doinit 16 cofig=[%p]\n", config);
    XDEBUG2(" doinit 17 cfg.max_file_cnt=[%i]\n", config->max_file_cnt);

    /**********  get the user/group lists and save it in the buffer *********/

#ifdef UNIX
    get_user_list();            /* users list */
    get_grp_list();		/* groups list */
#endif


    XDEBUG2(" doinit 18 cofig=[%p]\n", config);
    XDEBUG2(" doinit 19 cfg.max_file_cnt=[%i]\n", config->max_file_cnt);


    XDEBUG1("doinit ------> 14\n");
    XDEBUG2("doinit 14.1 max_x=[%i]\n", max_x);

    /* title frame */

    title_f = make_frame (0, 0, max_x, 1, leer, leer, F_B_HEAD_CLR, NOBOX_MODE);

    XDEBUG2(" doinit 20 cofig=[%p]\n", config);
    XDEBUG2(" doinit 21 cfg.max_file_cnt=[%i]\n", config->max_file_cnt);

    f_putstr (title_f, 0, 0,
	      "  Khamis Utilities Vers. 1.0, CopyRight 1994",
	      title_f->color,
	      FILL_MODE
	      );


    XDEBUG2(" doinit 22 cofig=[%p]\n", config);
    XDEBUG2(" doinit 23 cfg.max_file_cnt=[%i]\n", config->max_file_cnt);

    XDEBUG1("doinit ------> 15\n");

    }

/***************************************************************************/
/********************* end of init variables********************************/
/***************************************************************************/

