/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: dolib.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/dolib.c,v $
 */

#define GLOBAL extern
#define EXTERN

#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <sys/timeb.h>
#include <fcntl.h>
#include <string.h>

#ifdef DOS
#include <process.h>
#include <io.h>
#include <conio.h>
#include <ctype.h>
#else
#include <termio.h>
#include <unistd.h>
#endif

#include "dodefs.h"
#include "doglobal.h"
#include "doerror.h"
#include "domem.h"
#include "dostring.h"
#include "dofind.h"
#include "doscr.h"
#include "doedit.h"
#include "domenu.h"
#include "docfg.h"
#include "dotcap.h"
#include "dowin.h"
#include "doqsort.h"
#include "dostern.h"
#include "docrypt.h"
#include "doutil.h"
#include "dofiles.h"
#include "dohexa.h"
#include "dodirent.h"
#include "dotext.h"
#include "dostat.h"
#include "dohist.h"
#include "dodir.h"
#include "doregex.h"

#include "dolib.h"

int C_X( int u, int g, int m) 
{
#ifdef UNIX
  return(
	 (
	  ( C_O_X( m) != 0 && u == u_id ) ||
	  ( C_G_X( m) != 0 && g == g_id ) ||
	  ( C_A_X( m) != 0 )
	  )  ||
	 ( (
	    ( C_O_X( m) != 0 ) ||
	    ( C_G_X( m) != 0 ) ||
	    ( C_A_X( m) != 0 ) ||
	    ( S_ISDIR( m)    )
	    ) &&
	  u_id == 0
	  )
	 );
#else
  if( strfind( AKT_FILE(w_[MY_cfg.akt_w]), ".COM") > 0 ||
     strfind( AKT_FILE(w_[MY_cfg.akt_w]), ".EXE") > 0 ||
     strfind( AKT_FILE(w_[MY_cfg.akt_w]), ".BAT") > 0
     ) return( TRUE);
  else return( FALSE);
#endif
}

int C_R( int u, int g, int m) 
{
#ifdef UNIX
  return(
	 ( C_O_R( m) != 0 && u == u_id ) ||
	 ( C_G_R( m) != 0 && g == g_id ) ||
	 ( C_A_R( m) != 0 )              ||
	 u_id == 0
	 );
#else
  return( TRUE);
#endif
  
}

int C_W( int u, int g, int m) 
{
#ifdef UNIX
  return(
	 ( C_O_W( m) != 0 && u == u_id ) ||
	 ( C_G_W( m) != 0 && g == g_id ) ||
	 ( C_A_W( m) != 0              ) ||
	 ( u_id == 0                   )
	 );
#else
  return( TRUE);
#endif
}

void clearinput( void) 
{
#ifdef UNIX
  while (getchar() != EOF);
#else
  while (kbhit ()) getchar ();
#endif
}

void presskey( void) 
{
  char * q 	     = "[Press any key to continue]";
  /*
    char * q 	     = "[Press any key to retain to main menu]"; 
  */
  int old_out 	     = out_all;
  int old_stern_active = MY_cfg.stern_active;
  
  hide_frame( help1, HIDE_MODE);
  hide_frame( ins_f, HIDE_MODE);
  
  out_all = TRUE;
  gotoxy_ ( 0, max_y-1);
  c_putstr( q, F_B_NORMAL);
  fflush_();
  out_all = old_out;
  
  MY_cfg.stern_active = TRUE;
  getkey(-1);
  MY_cfg.stern_active = old_stern_active;
  
  if( ! MY_cfg.help_line_hidden) view_frame( help1);
  view_frame( ins_f);
}

/* view/hide help line */
void view_hide_help( void) 
{
  
  if (com_line_frame != NULL)
    hide_frame (com_line_frame, HIDE_MODE);   /* com. line change his pos.*/
  
  if (MY_cfg.help_line_hidden) 
    {
      if (com_line_frame != NULL)
	{
	  f_changeY  (com_line_frame, COMLINE_Y); /* one line down */
	}
      if (help1 != NULL)
	{
	  view_frame (help1);
	  MY_cfg.help_line_hidden = FALSE;
	}
    }
  else
    {
      if (com_line_frame != NULL)
	{
	  f_changeY  (com_line_frame, help1->y);  /* on his old position */
	}
      if (help1 != NULL)
	{
	  hide_frame (help1, HIDE_MODE);
	  MY_cfg.help_line_hidden = TRUE;
	}
    }
  
  if (com_line_frame != NULL)
    {
      view_frame (com_line_frame);             /* view com_line */
    }
}


int run (char * prog, int mode)
{
  char * rn;
  int err_,
  i,
  old_out = out_all;

  if( mode & SAVE_SCREEN)
    {

      put_screen();

#ifdef UNIX
      hide_frame (help1, HIDE_MODE);
      hide_frame (ins_f, HIDE_MODE);
#endif

      setattr( F_B_GROUND_CLR);
      out_all = TRUE;

#ifdef UNIX
      clrscr_();
      /*
	 c_putstr( "Execute:\n", F_B_COMLINE_CLR);
	 c_putstr( prog, F_B_COMLINE_CLR);
	 c_putstr( "\n\n", F_B_COMLINE_CLR);
	 */
      fflush_();
      put_str( "Execute:\n");
      put_str( prog);
      put_str( "\n\n");
#else
      gotoXY   ( 0, max_y-1);
      fflush_  ();
      printf   ( "%s%s %s\n", w_[MY_cfg.akt_w]->path, dollar, prog);
#endif
      
      setattr( F_B_GROUND_CLR);
      view_cursor();
      
      fflush_();
      out_all = old_out;
    }
  
#ifdef UNIX
  
#ifdef MOUSE
  if( mouse_mode) ev_close();		/** mouse close **/
#endif
  
  SET_TTY( &oldtty);    /** save actual tty setup */
  fflush_();            /** delete Help-Line */

  err_ = system (prog); /** execute the program */

  if( mouse_mode == FALSE) SET_TTY( &mytty);     /** set my tty **/
  else 	 		   init_tty_mouse();     /** open mouse **/

#else  		/* DOS */
  {
    char
    * def_swit = "khswitch.exe",
    swit   [MAXPATH],
    cfg_   [MAXPATH],
    prog_  [MAX_COM_LEN+3],
    * p    = def_swit,
    old_cfg[MAXPATH],
    * argx [7];

    strcpy  (old_cfg, MY_cfg.cfg_file);

    sprintf (prog_, "\"%s\"", prog);             /* command line */

    /* search for switcher */
    strcpy (swit, concat_path (prog_path, def_swit));

    if (exist (swit))
      p = swit;                  /* switcher exists */
    else
      p = NULL;

    if (p != NULL)
    {
    /*
     * make a new switch file
     */
    strcpy (cfg_, concat_path (prog_path, "khswitch.cfg"));
    strcpy (MY_cfg.cfg_file, cfg_);

    /*
     * save current configuration
     */
    save_config(&MY_cfg);

    err_ = execlp (p,			/* 0 */
		   p, 			/* 0 switcher           */
		   "++++", 		/* 1 mark               */
		   argv_ [0], 		/* 2 program path       */
		   cfg_, 		/* 3 config.file        */
		   prog, 		/* 4 program to execute */
		   NULL);		/* 6 end of arguments   */
    }


    /*
     * exec not successed
     */
    err_ = system (prog);

    strcpy (MY_cfg.cfg_file, old_cfg);
  }
#endif

  setattr( F_B_GROUND_CLR);
  
  if( mode & SAVE_SCREEN)
    {
      clearinput();
      get_screen();

#ifdef DOS
      set_videomode (scr_videomode); /* if video mode is changed */
#endif

#if 0
      if (! MY_cfg.help_line_hidden) view_frame (help1);       /* help frame */
      view_frame (ins_f);                         /* insertmode frame */
#endif

#ifdef UNIX
      presskey();
      clrscr_();
#endif
      view_screen();
    }

  return( err_);
}

void view_cursor ( void)
{
  if( ! cur_hidden) return;
#ifdef UNIX
  put_str( ETC_CN);
#else
  
#ifndef WIN
  _setcursortype( _NORMALCURSOR);
#endif
  
#endif
  cur_hidden = FALSE;
}

void hide_cursor ( void) 
{
  if( cur_hidden) return;
#ifdef UNIX
  put_str( ETC_CF);
#else
  
#ifndef WIN
  _setcursortype( _NOCURSOR);
#endif
  
#endif
  cur_hidden = TRUE;
}

void clrscr_( void) 
{
  
#ifdef UNIX
  int i, end = max_x * max_y;
  
  if( screen_chr != NULL)
    for( i=0; i<end; i++) 
      {
	screen_chr [ i] = ' ';
	screen_attr[ i] = F_B_GROUND_CLR;
      }
#endif
  
  setattr (F_B_GROUND_CLR);
  
#ifdef UNIX
  put_str (ETC_cl);
#else
  clrscr();
#endif
}

#if 0
void message (char * s, char * t) 
{
  Getyesno (s, "   Ok   ", t1, -1);
}
#endif

char * getterm( void ) 
{
  char * t;
#ifdef UNIX
  if( ( t = getenv( "TERM")) == NULL ) 
    {
      PER( "your Terminal is not definded\n");
      quit( 1);
    }
#else
  t = "ANSI";
#endif
  return( t);
}

char * gettcap( void ) 
{
  char * t;
  if( ( t = getenv( "DIRTERMCAP")) == NULL )
    t = "termcap";
  return( t);
}


void ins_help_line( int mode) 
{
  /*** VIEW_HELP_MODE to view the help line **/
  /*** VIEW_INS_MODE  to view the Insert mode **/
  int i = 0;
  char
    * ins   = "Insert",
    * overw = "Ovwrt",
    hlp[] = 
      "F1:Hlp#2:MkDi#3:long#4:copy#5:sele#6:sort#7:run#8:edit#9:rm#10:Menu";
  int old_x = cur_x, old_y = cur_y;
  
  /* first call */
  if( help1 == NULL) 
    help1 = make_help( hlp, 0, max_y-1, max_x - 10);
  
  if( ins_f == NULL)
    ins_f = make_frame( max_x - 9, max_y-1, 6, 1, leer, leer,
		       F_B_INSMODE_CLR, NOBOX_MODE);
  
  if( (mode & VIEW_HELP_MODE) && ! MY_cfg.help_line_hidden)
    view_frame( help1);
  
  if( mode & VIEW_INS_MODE) 
    {
      f_putstr( ins_f, 0, 0, ins_mode ? ins : overw,
	       ins_f->color,
	       FILL_MODE);
      view_frame( ins_f);
    }
  
  gotoxy_( old_x, old_y);
}

long pow_( long b, int n) 
{
  long erg = 1;
  if( n == 0) return( 1);
  while( n-- >= 1) erg = ( long) erg * b; /* primitive methode */
  return( erg);
}

char * MY_ltohex( long value, int n, char fill) 
{
  static char p[ 20];
  char * q = p + n, c;
  int  i;
  long basis = 16L;
  *q-- = 0;
  for( i=1; i<=n && value != 0; i++) 
    {
      c = value & 0xf;
      if ( c < 10) *q-- = '0' + c;
      else         *q-- = 'a' + c - 10;
      value >>= 4;
    }
  while( q >= p) *q-- = fill;
  return( p);
}

#ifdef UNIX
char * MY_ltoa( long value, int n, char fill) 
{
  static char p[ 20];
  char * q = p + n;
  int i;
  long l, j;
  *q-- = 0;
  for( i=1; i<=n; i++) 
    {
      l = pow_( 10, i);
      j = value % l;
      *q-- = '0' + ( long) j / ( l / 10);
      value -= j;
      if( value == 0) break;
    }
  while( q >= p) *q-- = fill;
  return( p);
}

char * MY_itoa( long value, int n, char fill) 
{
  static char p[ 20];
  char * q = p;
  int i;
  long l, j;
  value = value % ( long) n * 10;
  
  for( i=n; i>=1; i--) 
    {
      l = pow_( 10, i-1);
      j = value / l;
      *q++ = '0' + j;
      value -= j * l;
      if( value == 0) break;
    }
  while( q >= p) *q-- = fill;
  return( p);
}
#endif

/*** current clock on the screen ***/

void clock_( int mode) 
{
  /*** mode = TIME_MODE : View time **/
  /*** mode = DATE_MODE  : View date **/
  
  time_t    tm  = time( NULL);
  struct tm * t = localtime( &tm); /* without green zone */
  int       o_x = cur_x, o_y = cur_y,
  old_cur = cur_hidden; /* save cursor blank status */
  char      tmp[ 50];
  
  if( clock_f == NULL)
    clock_f = make_frame( max_x - 23, 0, 22, 1,
			 leer, leer,
			 F_B_CLOCK_CLR,
			 NOBOX_MODE);
  
  if( mode & DATE_MODE) 
    {		/* the english format for date */
      sprintf( tmp, " %s %i %i ",
	      month[ t->tm_mon],
	      t->tm_mday,
	      t->tm_year + 1900);
      f_putstr( clock_f, 0, 0, tmp, clock_f->color, NOMODE);
    }
  
  if( mode & TIME_MODE) 
    {
      sprintf( tmp, " %2i:%02i:%02i ", t->tm_hour, t->tm_min, t->tm_sec);
      f_putstr( clock_f, clock_f->width-strlen(tmp), 0, tmp,
	       clock_f->color, NOMODE);
    }
  view_frame( clock_f);
  gotoXY( o_x, o_y);
  if( ! old_cur) view_cursor();
}

/*** view command line with current pathname ****/

void view_com_line (struct win_t * w, int mode)
{
  char * q, tmp[ 100];
  int i ;
  
  XDEBUG1( "view_com_line 10\n");
  
  if( com_line_frame == NULL)
    com_line_frame = make_frame( 0, COMLINE_Y,
				max_x-2, 1,
				leer,
				leer,
				F_B_COMLINE_CLR,
				NOBOX_MODE);
  
  q = cutpath( w->path, com_line_frame->width/2, NOMODE); /* cut path */
  
  /* when file is hidden, view current file on the command line 
   */
  if( w->f->mode & HIDE_MODE)
#ifdef DOS
    sprintf (tmp, "%i:%s [%s]%s ",
	     MY_cfg.akt_w+1,                /* aktual window */
	     q, 			/* path */
	     AKT_FILE(w), 		/* file name */
	     dollar);		/* dollar character */
#else
    sprintf (tmp, "%i:%s [%c %s]%s ",
	   MY_cfg.akt_w+1,                /* aktual window */
	   q,			/* path */
	   w->dr[w->akt_pos]->m,   /* file type */
	   AKT_FILE(w),            /* file name */
	   dollar);                /* dollar characcter */
#endif
  else
    sprintf( tmp, "%s%s ",
	    q,                       /* path */
	    dollar);                 /* dollar $|#|> */
  
  f_putstr( com_line_frame, 0, 0, tmp,
	   com_line_frame->color,
	   FILL_MODE);
  
  if( mode == TRUE) f_putstr( com_line_frame, strlen(tmp), 0, pr_to_run,
			     com_line_frame->color,
			     FILL_MODE);
  
  view_frame( com_line_frame);
  
  /* prompt the symbol of the window, if it is
   * hidden
   */
  if (WIN->f->mode & HIDE_MODE)
    for (i=0; i<2; i++)
      {
	f_outnch (WIN->symbol, 0, i,
		  WIN->symbol->width,
		  F_B_CHOOSE_CLR,
		  NOMODE) ;
      }
  
  gotoxy_( strlen(tmp), com_line_frame->y); /* same y-coord. as frame */
}

void copyright( void) 
{
  int i,j;
  fflush_();
  for(i=0; cpyright[i] != NULL; i++) 
    {
      
      for( j=0; cpyright[i][j] != 0; j++)
	fprintf( stderr, "%c", decrypt( cpyright[i][j], NOMODE) );
      
      fprintf( stderr, "\n");
    }
  fflush_();
}

void usage( char * dir) 
{
  int i;
  fflush_();
  fprintf( stderr, "usage : %s [ options ] \n", dir);
  for(i=0; use_hlp[i] != NULL; i++) fprintf( stderr, "%s\n", use_hlp[i]);
  fflush_();
}

/* get an argument from argument list */
char * arg_get      ( char * arg, int argc, char ** argv) 
{
  char * p;
  int i;
  for ( i=0; i<argc; i++) 
    {
      if( begins( argv[i], arg) != 0) continue;
      if( strcmp( argv[i], arg) != 0) p = argv[i]+2;
      else if( i+1 < argc)            p = argv[i+1];
      else                            p = NULL;
      return( p);
    }
  return( NULL);
}

/***********************************************************************
 * convert command line arguments
 ***********************************************************************/

void com_line_arg ( int cnr, char ** arg) 
{
  char opt[ 100], par[ 100], * q, * p;
  int i, 
  j, 
  opt_n = 0,
  w_num = 0,
  stack_cnt,
  fehler = FALSE, 
  len,
  par_file = FALSE,
  f     = 0;		/* parameter file */
  
  for( i=1; i<cnr || par_file; i++) 
    {
      /* read from parameter file */
      if( par_file) 
	{
	  if( ! read_next_par( f, opt, par)) break;
	}
      else {
	q   = arg[ i];
	len = strlen( q);
	/* syntax error */
	if( len == 2 && begins( arg[ i+1], "-") == 0) fehler = TRUE;
	else  {
	  
	  p = opt;
	  /* option name */
	  while( *q && ( *q < '0' || *q > '9') && *q != ' ' && *q != TAB) 
	    {
	      *p++ = *q++;
	    }
	  *p = 0;
	  /* space character */
	  while( *q && ( *q == ' ' || *q == TAB)) q++;
	  
	  /* the another arg as number */
	  if( *q == 0) 
	    {	
	      i++;
	      q = arg[ i];
	    }
	  p = par;
	  while( *q >= '0' && *q <= '9') *p++ = *q++;
	  *p = 0;
	}
      }
      
      opt_n = atoi( par);
      
      if( fehler) break;
      
      /* parameter file */
      if( strcmp( opt, "-p") == 0) 
	{
	  if( par_file) fehler = TRUE;
	  else f = open( arg[i], O_RDONLY);
	  if( f < 0) fehler = TRUE;
	  else par_file = TRUE;
	}
      else if( strcmp( opt, "-c") == 0) 
	{
	}
      
#ifdef MOUSE
      else if( strcmp( opt, "-usemouse") == 0) 
	{
	  use_mouse = TRUE;
	  i--;			/* this arg haven't any numbers */
	}
#endif
      /* black/white screen */
      else if( strcmp( opt, "-nocolor") == 0) 
	{
	  use_color = FALSE;
	  set_colors();               /* set new colors */
	  i--;			/* this arg haven't any numbers */
	}
      /* width of frame */
      else if( strcmp( opt, "-width") == 0) MY_cfg.def_width[ w_num] = opt_n;
      
      /* set the count of window */
      else if( strcmp( opt, "-win") == 0) 
	{
	  MY_cfg.win_cnt = max( 1, min( MAX_WIN, opt_n));
	}
      /* set current frame */
      else if( strcmp( opt, "-w") == 0) 
	{
	  w_num = opt_n;
	  if( w_num < 1 || w_num > MY_cfg.win_cnt) fehler = TRUE;
	  else w_num--;
	}
      /* max. stack length for history */
      else if( strcmp( opt, "-h") == 0) 
	{
	  stack_cnt = opt_n;
	  max_com_cnt = max( 10, stack_cnt);
	}
      /* x-coordinate */
      else if( strcmp( opt, "-x") == 0) MY_cfg.def_x[ w_num] = opt_n;
      
      /* y-coord. */
      else if( strcmp( opt, "-y") == 0) MY_cfg.def_y[ w_num] = opt_n;
      
      /* high of frames */
      else if( strcmp( opt, "-down") == 0) 
	MY_cfg.def_deep[ w_num] = opt_n;
      
      /* max. files count in one window */
      else if( strcmp( opt, "-files") == 0)
	MY_cfg.max_file_cnt = max( 1, opt_n);
      
      else fehler = TRUE;
      
      if( fehler) break;
    }
  
  if( f != 0) close( f);
  if( fehler) 
    {
      usage( arg[ 0]);
      quit( 1);
    }
}

/*** temporare file and history file - names ****/
void get_tmp_file_hist() 
{
#ifdef UNIX
  char * p;
  
  if( ( p = getenv( "HOME")) == NULL || strlen( p) == 0)
    fprintf( stderr, "HOME enveronment is not defined or empty\n");
  
  sprintf( MY_cfg.options[HIST], "%s/.dirhistory", p); /* history file */
#endif
}

/*
 * cut the path to maximal 'max_l' characters 
 */

char * cutpath( char * path, int max_l, int mode) 
{
  int i, len;
  char static s[MAXPATH+4];
  char pnt = '.',
  * q = s + 4,
  * frm = ( mode ? " %s " : "%s"),
  * r = s;
  
  sprintf( s, frm, path);
  
  if( strlen( s) <= max_l) return( s);
  if( ! mode) *( r + 1) = pnt;
  
  r[2] = pnt;
  r[3] = pnt;
  
  len = strlen( s) - max_l;
  
  for( i=0; i<=max_l-4; i++) q[i] = q[len + i];
  
  q[i] = 0;
  return( s);
}


/* 
 * logical asking 
 */
#define ML	8		/* maximum lines */
int Getyesno (char * txt, char * chs, char * ttt, int pos)
{
  char
    * xx = txt,
    * cc = chs,
    * tt = ttt,
    * tmp_txt,
    * tmp_chs,
    * tmp_ttt,
    * text [ML],
    * chos [ML],
    * tit  [2],
    * p;
  int
    i, 
    j,
    ret;

  for (i=0; i<ML; i++, text [i] = chos [i] = NULL);
  tit [0] = tit [1] = leer;
  
  if (cc == NULL) cc = " Yes ;; No ";  /* default yes|no */
  if (xx == NULL) xx = " Answer ";
  if (tt == NULL) tt = leer;

  tmp_txt = getmem (strlen (xx)+1); strcpy (tmp_txt, xx);
  tmp_chs = getmem (strlen (cc)+1); strcpy (tmp_chs, cc);
  tmp_ttt = getmem (strlen (tt)+1); strcpy (tmp_ttt, tt);
  
  for (p = tmp_txt, i = 0; i<ML-1; )
    {
      text [i++] = p;				/* line added */
      j = chrindex (p, ";;"); 			/* next line begin */
      if (j < 0) break;				/* no ";" more */
      p += j;      p [0] = 0;      p += 2;	/* next line */
    }
  for (p = tmp_chs, i = 0; i<ML-1; )
    {
      chos [i++] = p;		/* choose in array */
      j = chrindex (p, ";;");	/* index of next ";" */
      if (j < 0) break;		/* end */
      p += j;      p [0] = 0;      p += 2;
    }
  for (p = tmp_ttt, i = 0; i<2; )
    {
      tit [i++] = p;		/* choose in array */
      j = chrindex (p, ";;");	/* index of next ";" */
      if (j < 0) break;		/* end */
      p += j; p [0] = 0; p += 2;  /* separate the strings between the ";;" */
    }
  ret = getyn (text, chos, tit [0], tit [1], pos); /* call the dialog box */
  Free (tmp_chs);
  Free (tmp_txt);
  Free (tmp_ttt);
  return ret;
}

/*** get Y|y or N|n ***/

int getyn (char * txt[], char * chs[], char * t1, char * t2, int pos) 
{
  char 
    * Yes_No [] = { "  Yes  ", "  No  ", NULL };
  struct frame_t  * f;
  struct choose_t * ch;
  int
    width,
    cnt,       /* txt lines */
    c_cnt,     /* choose count */
    x,
    y,
    lk = FALSE,
    i, 
    ii;
  
  if (chs == NULL) chs = Yes_No;  /* default yes|no */
  
  /* width of choose block */
  for( c_cnt=0, width=0; chs [c_cnt] != NULL; c_cnt ++)
    width = max (width, strlen (chs [c_cnt]));
  
  width = width * c_cnt;
  
  for( cnt=0; txt [cnt] != NULL; cnt ++)            /* if a long text */
    width = max (width, strlen (txt [cnt]) + 4);
  
  width = min (max_x-4, max (width, strlen (t1) + 2));  /* width of title */

  y = max (0, (max_y - cnt  -4) / 2);
  x = max (0, (max_x - width-2) / 2);
  
  f = make_frame (x, y, width+2, cnt+4, t1, t2, F_B_DIALOG_CLR, NOMODE);
  
  ch = make_choose (f, c_cnt, F_B_DIALOG_CHS, AUTO_MODE | VERT_MODE);
  
  if (pos < 0) ch->pos = c_cnt - 1;		/* last index */
  else ch->pos = min (pos, c_cnt - 1);		/* defualt position */
  
  ii = (f->width-2) / c_cnt;
  
  for( i=0; i<c_cnt; i++) 
    {
      ch->x[ i]   = max (1, ii * i + ( ii - strlen( chs[ i])) / 2);
      ch->y[ i]   = f->rows - 2;
      ch->len[ i] = strlen( chs[ i]);
      f_putstr( f, ch->x[i], ch->y[i], chs[i], f->color, NOMODE);
    }
  
  for( i=0; i<cnt; i++)
    f_putstr( f, 1, i+1, txt[i], f->color, NOMODE);
  
  view_frame( f);
  
  lk = f_choose( ch);
  
  if( lk != ENTER && lk != CTRL_M) ii = c_cnt-1;
  else ii = ch->pos;
  
  hide_frame( f, HIDE_MODE | DELETE_MODE);
  del_choose( ch);
  
  return( ii);
}

/*** choose string at x, y to len with mode ***/

void chs( char * str, int x, int y, int len, int color) 
{
  gotoxy_( x, y);
  prn_nchar( str, len, ' ', color, FILL_MODE);
  fflush_();
}

void premission( void) 
{
  message( " Permission denied..!", leer);
}

void help( void) 
{
  char ** p;
  int i, cnt = 0;
  
  for(i=0; hlp_txt[i]  != NULL; i++) cnt++;
  for(i=0; use_hlp[i]  != NULL; i++) cnt++;
  
  p = getmem( ( cnt + 1) * sizeof( char *));
  cnt = 0;
  
  for(i=0; hlp_txt[i]  != NULL; i++) p[cnt++] = hlp_txt[i];
  for(i=0; use_hlp[i]  != NULL; i++) p[cnt++] = use_hlp[i];
  p[ cnt] = NULL;
  
  i=0;
  ch_text( p, 0, 1, max_x, max_y, &i, " Help ", leer,
	  F_B_HELP_CLR, F_B_HELP_CHS, NOMODE);
  
  Free( p);
}

void about_project ( char ** about_str) 
{
  char ** p, * q;
  int i,
  j,
  cnt,
  len;
  
  for( cnt=len=0; about_str[cnt] != NULL; cnt++) 
    {
      len = max( len, strlen (about_str[cnt]) + 1);
    }
  
  p = getmem( (cnt+1) * sizeof( char *) );
  
  for(i=0; i<cnt; i++) 
    {
      p[i] = getmem( strlen(about_str[i]) + 1 );
      q    = about_str[i];
      for( j=0; q[j] != 0; j++) 
	{
	  p[i][j] = decrypt( q[j], NOMODE);
	}
      p[i][j] = 0;
    }
  p[i] = NULL;
  
  i=0;
  ch_text( p,
	  (max_x-len) / 2,
	  max( 1, (max_y-cnt) / 2 ),
	  len,
	  cnt,
	  &i, 
	  " About ",
	  leer,
	  F_B_HELP_CLR, F_B_HELP_CHS,
	  NOMODE);
  
  for( i=0; i<cnt; i++) Free( p[i]);
  Free( p);
}


/*   ************************************************************** */
/*   *****************  view message            ******************* */
/*   ************************************************************** */

#ifdef DOS
#define NL 	10
#else
#define NL      10
#endif

int move_line (int f, int mode) 
{
  /* mode = PREVLINE_MODE  : prev line */
  /* mode = NEXTLINE_MODE  : next line */
#define MOVE_BL		128
  int i, j, fnd_ = FALSE;
  char tmp_buf[MOVE_BL];
  long
    beg     = lseek (f, 0, SEEK_CUR),
    akt_pos = beg,
    pos     = beg,
    l,
    size    = file_opensize (f);
  
  /** move the file-head to the previose line **/
  
  if (mode & PREVLINE_MODE ) 
    {
      for( j = TRUE; akt_pos > 0; ) 
	{
	  l       = min (MOVE_BL, akt_pos);
	  akt_pos = max (0, akt_pos - l);
	  lseek (f, akt_pos, SEEK_SET);		/* move back */
	  j = read (f, tmp_buf, l);		/* read block */
	  for (i=j-1; i >= 0; i--, pos--)
	    {
	      if (tmp_buf[i] == NL) 		/* found new line */
		{
		  fnd_++;
		  if (fnd_ == 2) break;	/* first NL is NL of akt. line */
		}
	    }
	  if (fnd_ == 2 || j <= 0) break;
	} /* for */
      if (j == 0) fnd_ = 2;		/* begin of file */
      if (fnd_) beg = max( pos, 0);	/* correct begin of line */
    }		/* if PREV */
  
  lseek (f, beg, SEEK_SET);	/* old or new position */
  return fnd_;			/* 0 for not found */
}

/*** read line from file f ****/

int read_line (int f, char * buf, int len) 
{
#define READ_BL		128
  char tmp_buf [READ_BL];
  int l, i, j, end_ = FALSE, l_pos;
  long pos = lseek( f, 0, SEEK_CUR);
  
  for (l_pos = j = 0; TRUE; ) 
    {
      l = read( f, tmp_buf, READ_BL);
      for (i = 0; i<l; i++, l_pos++) 
	{
	  if (tmp_buf[i] == NL) end_ = TRUE;    /* read to end of line */
	  if (end_) break;
	  if (j<len-1 && tmp_buf[i] != 13) 
	    {
	      /* max 'len'-characters */
	      /* fill the tab-blocks with spaces */
	      /* this methode is good to scroll in the */
	      /* viewer rights and lefts */
	      if (tmp_buf[i] != TAB) buf [j++] = tmp_buf[i];
	      else {
		int h,
		tt = tab_size - j % tab_size;
		for( h=0;
		    h < tt && j<len;
		    h++)
		  buf[j++] = ' ';   /* fill with spaces */
	      }
	    }
	}
      if( l <= 0 || end_) break;
    }
  buf [j] = 0;
  lseek (f, pos+l_pos+1, SEEK_SET);	/* correct position */
  return (l == 0 && j == 0)		/* end of file reached */
         ? -1				/* mark for end of file */
         : j;				/* string length, was reading */
}

/**** view the specifid file on the screen and choose the current line ***/

long file_opensize (int f)
{
  long
    pos  = lseek (f, 0, SEEK_CUR),
    size = lseek (f, 0, SEEK_END);
  lseek (f, pos, SEEK_SET);
  return size;
}

int file_toend (int f)
{
#ifdef UNIX
#define TOEND_BL	2048
#else 
#define TOEND_BL	512
#endif
  char tmp [TOEND_BL];
  int i, j, l;
  for (i=0; (l = read (f, tmp, TOEND_BL)) > 0; )
    {
      for (j=0; j<l; j++) if (tmp[j] == NL) i++;
    }
  return i;
}

int view_file (char * file,
	       char * t,
	       int x, int y, int x_cnt,
	       int y_cnt, char * com, int len, int mode
	       ) 
{
  
  /* mode = END_OF_FILE: begin at end of file */
  
  frame_T  fr, line_f, help_f;
  struct choose_t * ch;
  int
    f,
    i, j,
    out_beg  = 0, 		/* output begin for the strings */
    lk       = 0,
    refr     = TRUE,
    pos,
    end_     = FALSE;
  long
    size    = 0,
    new_pos = 0,
    line_num = 0,
    * file_pos ;		/* array for every line */
  
  char
    buf [1024],
    find_str [FINDLEN],
    tmp [16];
  int  mn_keys[][15] =
    {
      { ENTER, ESC },
      { F3, HOME, END, CUR_RIGHT, CUR_LEFT },
      { F1 }
    };
  char
     hlp_text[] =
	"F10:Menu"
	"#Enter:Select"
	"#Esc:abbort"
	"#F3:Search"
	"#F1:Help";
  char 
    * mn_line[] = { " File ", " Search ", " Help ", NULL},
    * mn_event[][15] =
      {
	{
	  " Select line  Enter ",
	  " Exit           F12 ",
	  NULL
	} 
	,
	{
	  " Find               F3 ",
	  " First line       Home ",
	  " Last  line        End ",
	  " Scroll right    Cr-Rt ",
	  " Scroll left     Cr-Lf ",
	  NULL
	}
	,
	{
	  " Help            F1 ",
	  NULL
	},
      };
  
  find_str[0] = 0;
  
  if( ( f = open( file, O_RDONLY | O_BINARY)) < 0) 
    {
      message( " File can't open or not found ", " From Viewer ");
      return( FALSE);
    }
  
  hide_cursor();
  
  fr     = make_frame (x, y, x_cnt, y_cnt, t, leer, F_B_UTIL_CLR,
		       SCROLL_RIGHT_MODE|SCROLL_BUTTOM_MODE);
/*
  line_f = make_frame (0, max_y-1, 15, 1, leer, leer, F_B_UTIL_CLR,
  NOBOX_MODE);
*/
  
  line_f = make_frame (fr->x+1, fr->rows, 15, 1, leer, leer, F_B_UTIL_CLR,
		       NOBOX_MODE);
  help_f = make_help (hlp_text, 0, max_y-1, max_x - 10);

  ch = make_choose (fr, 0, F_B_UTIL_CHS, BREAK_MODE | NOWAIT_MODE | LET_MODE);
  choose_help (ch, NULL);
  
  view_frame (fr);
  view_frame (help_f);
  
  file_pos = getcmem (fr->down * sizeof (long));    /* file cursor */
  
  if( mode & END_OF_FILE) 
    {			    /* seek to end of file */
      line_num = file_toend (f);
      size     = lseek( f, 0, SEEK_END);
      for( i=0; i<fr->down; i++)
	{
	  if (move_line (f, PREVLINE_MODE) == 2) line_num --;
	}
      ch->pos = fr->down - 1;
      file_pos [0] = lseek (f, 0, SEEK_CUR);
    }
  else
    {
      size = file_opensize (f);			/* size of file */
    }
  size = max (1, size);
  
  while( TRUE) 
    {
      if( refr) 
	{
	  lseek (f, file_pos[0], SEEK_SET); /* return to current position */
	  for (i=0; i < fr->down; i++)      /* out lines on the frame */
	    {
	      file_pos [i] = lseek (f, 0, SEEK_CUR);
	      read_line (f, buf, 1024);    		/* next line */
	      f_putstr  (fr, 1, i + 1,
			 buf + min (strlen (buf), out_beg),
			 fr->color,
			 FILL_MODE);
	    }

	  f_reposition (fr, file_pos[ch->pos], size, SCROLL_RIGHT_MODE);
	  f_reposition (fr, out_beg, fr->width-4, SCROLL_BUTTOM_MODE);

	  view_frame( fr);			/* out frame */

	  refr = FALSE;
	}

      /* view line number */
      sprintf  (tmp, " Line: %i ", line_num + ch->pos + 1);
      f_putstr (line_f, 0, 0, tmp, line_f->color, FILL_MODE);
      view_frame (line_f);

      lk = f_choose (ch);	/* scrolling */
      lk = getkey   (-1);
      lseek (f, file_pos [ch->pos], SEEK_SET);	 /* file cursor */
      switch( lk) 
	{
	case F10:
	  lk = menu( mn_keys, mn_line, mn_event);
	  break;
	}
      switch( lk) 
	{
	case F1:
	  help();
	  break;
	  
	case CUR_DOWN:
	  if (read_line (f, buf, 2) < 0) break;	 /* next line */
	  if (ch->pos < fr->down-1) { ch->pos ++; break; } /* choose moving */
	  file_pos [0] = file_pos [1];		         /* scroll down */
	  line_num ++;
	  refr = TRUE;
	  break;
	  
	case CUR_UP:
	  if (ch->pos > 0) { ch->pos --; break; }
	  if (! move_line (f, PREVLINE_MODE)) break;
	  line_num --;
	  file_pos [0] = lseek (f, 0, SEEK_CUR);
	  refr = TRUE;
	  break;
	  
	case PAGE_UP:
	  pos = ch->pos;
	  for (i=0; i<fr->down-1; i++)
	    {
	      j = move_line (f, PREVLINE_MODE);
	      if (j == 0) break;
	      pos --;
	      if (pos < 0) line_num --;
	    }
	  if (i == 0) break;
	  ch->pos      = 0;
	  file_pos [0] = lseek (f, 0, SEEK_CUR);
	  refr = TRUE;
	  break;
	  
	case PAGE_DOWN:
	  for (i=0; i<fr->down; i++)
	    {
	      file_pos [0]       = file_pos [i];
	      if (i > 0) line_num ++;
	      j = read_line (f, buf, 2);
	      if (j<0) break;
	      ch->pos            = min (fr->down-1, ch->pos+1);
	    }
	  refr = TRUE;
	  break;

	case CUR_RIGHT:
	  out_beg = min (len, out_beg+1);
	  refr = TRUE;
	  break;
	  
	case CUR_LEFT:
	  out_beg = max (out_beg-1, 0);
	  refr = TRUE;
	  break;
	  
	case TAB:
	  out_beg = min (len, out_beg+8);
	  refr = TRUE;
	  break;
	  
	case BACK_TAB:
	  out_beg = max (out_beg-8, 0);
	  refr = TRUE;
	  break;
	  
	case HOME:
	  ch->pos = line_num = file_pos [0] = 0;
	  refr = TRUE;
	  break;

	case END:
	  /* ask for the end every time, so that me be
	   * the size changes thimself
	   */
	  lseek (f, file_pos [0], SEEK_SET);
	  line_num += file_toend (f);
	  line_num = max (0, line_num - fr->down + 1);
	  size = lseek( f, 0, SEEK_END);
	  for( i=0; i<fr->down-1; i++) move_line (f, PREVLINE_MODE);
	  file_pos [0] = lseek (f, 0, SEEK_CUR);
	  ch->pos = min (line_num, fr->down-1);
	  refr = TRUE;
	  break;

	case F3:			/* find string */
	case CTRL_F:
	  lseek (f, file_pos [0], SEEK_SET);
	  j = read_line (f, tmp, 2);			/* next line */
	  new_pos = file_findtext (f, find_str, COUNT_LINES);
	  if (new_pos == 0) break;			/* nothing found */
	  line_num += new_pos;				/* add found lines */
	  move_line (f, PREVLINE_MODE);         /* begin at the prev. line */
	  file_pos [0] = lseek (f, 0, SEEK_CUR);	/* new position */
	  ch->pos = 0;
	  refr = TRUE;
	  break;

	case CTRL_M:
	case ENTER:
	case ESC:
	  end_ = TRUE;
	  break;
	}
      if( end_) break;
    }
  
  if( ( lk == ENTER || lk == CTRL_M) && com != NULL)
    {
      lseek (f, file_pos [ch->pos], SEEK_SET);
      read_line (f, com, len);
      i = TRUE;
    }
  else i = FALSE;
  
  Free (file_pos);	                           /* get mem Free **/
  del_choose (ch);				    /* delete choose-struct */
  hide_frame (fr,       DELETE_MODE | HIDE_MODE);
  hide_frame (line_f,   DELETE_MODE | HIDE_MODE);
  hide_frame (help_f,   DELETE_MODE | HIDE_MODE);
  
  close( f);					              /* close file */
  
  return i;
}

/*   ************************************************************** */
/*   *****************  view message end      ********************* */
/*   ************************************************************** */

/*   ************************************************************** */
/*   *****************  TTY initialisation    ********************* */
/*   ************************************************************** */

#ifdef UNIX
void init_tty_mouse( void) 
{
  int tries = 3,
  i;
  mouse_mode = FALSE;
#ifdef MOUSE
  if( use_mouse) 
    {
      dmask = D_REL | D_STRING; 		   /* Mouse and Keyboard **/
      err = ev_init();		/* init the event */
      switch( err) 
	{
	case -1:
	  perror( "Mouse");
	  mouse_mode = FALSE;
	  break;
	default:
	  for(i=0; i<tries; i++) 
	    {
	      err = ev_open( &dmask);	/* open the mouse event **/
	      if( err < 0) 
		{
		  perror( "Opening mouse");
		  PER( "Try again ....\n");
		  sleep( 1);
		  err = ev_init();		/* init the event */
		}
	      else break;
	    }
	  if( err < 0) 
	    { perror("Mouse"); quit( 1); }
	  mouse_mode = TRUE;
	  break;
	}
      
      if( mouse_mode) 
	{ 
	  dev = ev_getdev( dmask, NULL);  /* device information of mouse */
	  gin = ev_gindev( dev, '0');     /* include/exclude devices of **/
	  /* event input ***/
	  ev_flush();	   /* clear the input of events in the queue */
	}
    }   /* use_mouse */
  
#endif			/* MOUSE */
  
  /**** end of mouse initialisation *************/
  
  if( ! mouse_mode) 
    {
      
      GET_TTY(  &mytty);
      
      mytty.c_cc [ VMIN] = 0;
      mytty.c_cc [VTIME] = 1;
      mytty.c_lflag      &= ~ICANON & ~ECHO & ~IGNBRK;
      mytty.c_lflag      |= ISIG;                         /* break */
      
      SET_TTY( &mytty);
      
    }  /* ! mouse_mode **/
  
}  /* init_tty_mouse */

/*   ************************************************************** */
/*   ************* end TTY initialisation    ********************** */
/*   ************************************************************** */

void delay( int ms) 
{
  struct timeb tm;
  unsigned start = 0, lastt = 0;
#ifdef HAVE_FTIME
  ftime( &tm);
  start = tm.time * 1000 + tm.millitm;
  while( lastt < start + ms) 
    {
      ftime( &tm);
      lastt = tm.time * 1000 + tm.millitm;
    }
#else
   sleep (ms / 1000);
#endif
}

#endif

int find_file (struct win_t * w,
	       struct frame_t * ff,
	       char * str,
	       int mode) 
{
  struct frame_t * f = ff;
  char
    * tmp = str,
    * q   = str;
  int
    key, i, len,
    ff_val,
    ff_last,
    old_pos,
    ww,
    x = 1,
    first = TRUE;
  
  if (f == NULL)
    {
      f = make_frame( w->f->x,
		     min( max_y-5, w->f->to_y+1),
		     w->f->width, 3,
		     " Search file ",
		     leer,
		     F_B_UTIL_CLR, NOMODE);
      view_frame( f);
    }
  else
    {
      x = 10 ;
      w_reposition (w) ;
    }

  old_pos = w->akt_pos;
  ww      = f->width - x - 1;

  if (tmp == NULL)
    {
      tmp = q = getmem (ww + 1);
      tmp [0] = 0;
    }
  q = tmp + strlen (tmp) ;
  
  while (TRUE /*strlen (tmp) < ww*/ ) 
    {
      len = strlen (tmp) ;
      if( old_pos != w->akt_pos)
	{
	  w_reposition (w) ;
	  old_pos = w->akt_pos;
        }
      
      f_putstr (f, x, 1, tmp, f->color, FILL_MODE);
      if (first) f_putstr (f, x, 1, tmp, F_B_INPUT_CHS, NOMODE);
      view_frame (f) ;         /* if must be allows viewed to be on the top */
      gotoXY     (f->x+x+strlen(tmp), f->y+1);
      
      view_cursor();
      key = getkey(-1);
      
      if (is_ascii( key)) 
	{
	  if (first) q = tmp ;
	  if (q == tmp || len < ww) * q++ = key;
	}
      else if (key == BACKSPACE)
	{
	  if (q > tmp) q--, *q = 0;
	}
      else break;
      *q = 0;
      i = 0;
      
#ifdef DOS
      uppercase (tmp);
#endif
      
      if( tmp [0] != 0)
	{
	  w_lockfor (w, tmp) ;
	}

      first = FALSE ;
    }
  
  if (str == NULL) Free       (tmp);
  if (ff  == NULL) hide_frame (f, HIDE_MODE | DELETE_MODE);
  return     (key);
}

int ff_strcmp( char * s1, char * s2) 
{
  int i = 0;
  while( *(s1+i) && *(s2+i) && ( *( s1+i) == *( s2+i))) i++;
  if( strlen(s1) == i && strlen(s2) == i) return( 999);  /* s1 == s2 */
  return( i);
}

/**************************************************************************/
/* remove selected/current file(s) 					  */
/**************************************************************************/

void remove_file( struct win_t * w) 
{
  struct stat st;
  struct frame_t * f, * qs;
  struct input_t * in;
  struct log_t   * lg[2];
  int file_removed = 0, 
  dir_removed  = 0, 
  err_         = 0, 
  end_	     = FALSE,
  width        = min(50, max_x),
  down	     = min(7, max_y),
  x	     = (max_x-width)/2,
  y	     = (max_y-down)/2,
  i,
  mode	     = NOMODE;
  char * file  = AKT_FILE( w),
  * info[4],
  * recursive[] = { "X", " " },
  tmp[ 100];
  
  if( w->selected == 0) 
    {
      err_ = MY_stat( AKT_FILE( w), &st);    /* file state */
      if( ! C_W( st.st_uid, st.st_gid, st.st_mode)) 
	{
	  premission();
	  return;
	}
      sprintf( tmp, " Delete %s <%s> ", 
	      S_ISDIR(st.st_mode) ? "directory" : "file",
	      file);
    }
  else {
    sprintf( tmp, " Delete %i selected files ", w->selected);
  }
  
  for(i=0; i<4; i++) info[i] = getmem( 80*sizeof(char));
  
  qs = make_frame( x, y, width, down, " Remove ", leer,
		  F_B_UTIL_CLR,
		  NOMODE);
  in = make_input( qs, 2, CUR_MODE | FIL_MODE | INS_MODE);
  
  f_putstr ( qs, (qs->width-strlen(tmp))/2, 1, tmp, qs->color, NOMODE);
  f_putline( qs, 2, qs->color);
  f_putstr ( qs, 12+strlen(recursive[0]), 3,
	    " : recursive remove <danger>",
	    qs->color, NOMODE);
  f_putline( qs, 4, qs->color);
  
  /* logical field for recursive remove */
  lg[0] = make_log( qs, 2, F_B_UTIL_CHS);
  log_format (lg [0], recursive[0], recursive[1]);
  log_xy     (lg [0], 10, 3, 10, 3);
  log_setpos (lg [0], 1);
  
  /* logical field to ask <break or continue>*/
  lg[1]       = make_log( qs, 2, F_B_UTIL_CHS);
  i = qs->width/2;
  log_format (lg [1], cont_break [0], cont_break [1]);
  log_xy     (lg [1],
	      (i - strlen (cont_break[0])) / 2,     5,
	      i + (i - strlen (cont_break[1])) / 2, 5
	      );

  
  
  /* make input record */
  for(i=0; i<2; i++) 
    {
      input_log (in, i, lg [i]);
    }
  input_setpos (in, 1);
  
  view_frame( qs);		/* view the question frame */
  
  if( f_getstr( in) == ESC) end_ = TRUE;   /* choose the options */
  
  if (log_pos (lg[1]) != 0) end_ = TRUE;
  if (log_pos (lg[0]) == 0) mode = mode | RM_RECURSIVE_MODE; /* recusive seted */
  
  if( ! end_) 
    {
      f = make_frame( 10/2, (max_y-5)/2-2, max_x-10, 5, 
		     " Remove ", leer, F_B_UTIL_CLR, NOMODE);
      view_frame( f);
      
      if( w->selected == 0) 
	{
	  err_ = recursive_remove( f, AKT_FILE(w), mode);
	  if( err_) message(  "File/directory not deleted ..!", leer);
	  else w->new_read = TRUE;
	}
      else {
	for(i=0; i<w->d_files; i++) 
	  {
	    if( ! w->dr[i]->s) continue;
	    
	    if( MY_stat( W_FILE(i), &st) != 0) continue;
	    
	    err_ = recursive_remove( f, W_FILE(i), mode);
	    if( err_ & ABORT_MODE) break;
	    
	    if( ! err_) 
	      if( S_ISDIR( st.st_mode)) dir_removed++;
	      else file_removed ++;
	    
	  }
	
	/* tell the information about remove runing */
	sprintf( info[0], " <%i> files deleted ", file_removed);
	sprintf( info[1], " <%i> directories deleted ", dir_removed);
	sprintf( info[2], " <%i> files/directories from <%i> deleted ", 
		file_removed + dir_removed, 
		w->selected);
	info[3] = NULL;
	getyn( info, ok_, " Report from Remove command ", leer, -1);
	if( file_removed + dir_removed > 0) w->new_read = TRUE;
      }
      hide_frame( f, HIDE_MODE | DELETE_MODE);
    }  /* if ! end_ */
  
  hide_frame( qs, DELETE_MODE | HIDE_MODE);
  for(i=0; i<2; i++) del_log( lg[i]);
  del_input( in);
  for(i=0; i<4; i++) Free( info[i]);
  
}

int recursive_remove( struct frame_t * f, char * file, int mode) 
{
  /* mode = RECURSIVE : delete directory recursive */
  
  struct stat st;
  DIR * dir;
  struct dirent * d;
  char
    tmp       [255],
    * q,
    filename  [512],   /* to give file with there path */
    perms     [] = " Permission denied ",    /* for permission */
    stat_err  [] = " Error by reading file state .. !",
    open_err  [] = " Error by opening directory ",
    chs_frmt  [] = " Continue ;; Break ";
  short
    err_ = FALSE,
    ret = FALSE;
  
  q = cutpath (file, f->width-12, NOMODE);
  sprintf     (tmp, "Remove: <%s>", q);
  f_fillnstr  (f, 1, 2, tmp, strlen(tmp), '.', f->color, FILL_MODE);
  view_frame  (f);
  fflush_();

  if (mode & RM_ASK_MODE)
    {
      ret = Getyesno (" Do you wat realy delete this file ",
		      " Remove ;; Remove all ;; Continue ;; Break ",
		      " Remove ",
		      0);
      switch (ret)
	{
	case 0: break;
	case 1: mode &= ~ RM_ASK_MODE; break;
	case 2: return TRUE;
	case 3: return ABORT_MODE;
	}
    }
	
  if( MY_stat( file, &st) != 0) 
    {
      if( Getyesno( stat_err, chs_frmt, " File state ", -1) == 0)
	err_ = TRUE;
      else err_ = ABORT_MODE;
      return( err_);
    }
  
  if( S_ISDIR( st.st_mode)) 
    {
      if (mode & RM_RECURSIVE_MODE) 
	{
	  if( ( dir = X_opendir( file)) == NULL) 
	    {
	      if( Getyesno (open_err, chs_frmt, " open directory ", -1)
		 == 0)
		err_ = TRUE;
	      else err_ = ABORT_MODE;
	      return( err_);
	    }
	  
	  while( ( d = X_readdir( dir)) != NULL) 
	    {
	      
	      if( strcmp( d->d_name, "." ) == 0 ||
		 strcmp( d->d_name, "..") == 0
		 ) continue;
	      /* file with path */
	      sprintf( filename, "%s/%s", file, d->d_name);
	      
	      /* recursive call of remove */
	      err_ = recursive_remove( f, filename, mode);
	      
	      if( err_ & ABORT_MODE) break;
	    }
	  
	  X_closedir( dir); 
	}  /* if mode */
      
#ifndef XENIX
      if( ! err_) if( rmdir( file) != 0) ret = TRUE;
#else
#endif
    }  /* if S_ISDIR */
  else {
    if( remove( file) != 0) ret = TRUE;
  }
  
  if( ret) 
    {
      if (Getyesno (perms, chs_frmt, leer, -1) == 0)
	err_ = TRUE;
      else err_ = ABORT_MODE;
    }
  
  return( err_);
}  /* rec */

/**********************************************************************/
/* view any file, you can only see this file with the scroller       **/
/**********************************************************************/

void view_any_file( struct win_t * w) 
{
  int key,
  width = max_x,
  down  = max_y-2,
  x     = 0,
  y     = 1;
  
  key = get_strxy( w,
		  w->f->x,
		  w->f->to_y+1,
		  MY_cfg.edit_file,
		  80,
		  w->f->width-1,
		  " Enter your file name ",
		  leer,
		  INS_MODE | CUR_MODE | FIL_MODE
		  );
  
  if( key != ENTER && key != CTRL_M) return;
  
  view_file (MY_cfg.edit_file,
	     MY_cfg.edit_file,
	     x, y, width, down,
	     NULL,
	     1024,
	     NOMODE);
}


/* to view only the directories */
void view_dir_only (struct win_t * w, int mode)
{
  struct stat f_st;
  int pnt = 50, i, j;
  
  for( i = j = 2; i<w->d_files; i++)
    {
      if (pnt++ == 50)
	{
	  view_position (i, w->d_files, VIEW_MODE) ;
	  pnt = 0;
	}
      
      if (MY_stat( W_FILE( i), &f_st) != 0) f_st.st_mode = 0;
      
      if (S_ISDIR( f_st.st_mode))
	strcpy (W_FILE( j++), W_FILE( i));
    }
  w->d_files    = j;
  w->akt_pos    = 1;
  w->anf_pos    = 0;
  w->fr_out     = TRUE;
  w->rahmen_out = TRUE;
  view_position (0, 0, HIDE_MODE) ;
}

void chs_files ( struct win_t * w)
{
#ifdef UNIX
  char d[ 255],
  r[ 255];
  char * q;
  
  FILE * f;
  int i, j, err_ = FALSE, end_ = FALSE, key;
  
  if( choose_str == NULL)
    {
      choose_str = getmem( max_x+1);
      choose_str [0] = 0;
    }
  q = choose_str;
  
  key = get_strxy (w, w->f->x, w->f->y+w->f->rows,
		   choose_str, w->f->width-1, w->f->width-1,
		   " Choose files ", leer, 
		   CUR_MODE | FIL_MODE);
  
  if( key != ENTER && key != CTRL_M) end_ = TRUE;
  
  if( ! end_)
    if( ( q = b_strchr( choose_str, '/')) != 0)
      {
	*q++ = 0;            /* cut the string in files */
	/* and directory */
	sprintf (d, "%s/", choose_str); /* the files was cutting */
	strcpy  (choose_str, q);         /* files without the path*/
	if (change_dir( w, d) != -1)
	  {
	    get_path( w);
	  }
	else
	  {
	    message( "Directory not found ..!", leer);
	    end_ = TRUE;
	  }
      }
  
  if (!end_)
    {
      char * comp_name = open_comp (choose_str) ;
      
      w_readdir (w, ".", NOMODE);
      get_path  (w);
      
      for( i=j=2; i<w->d_files; i++)
	{
	  if (is_regex  (comp_name, w->dr [i]->f) && j != i)
	    {
	      * w->dr[j++] = * w->dr[i] ;
	    }
	}
      close_comp (comp_name) ;
      
      w->d_files    = j ;
      w->fr_out     = TRUE;
      w->rahmen_out = TRUE;
    }
  
#endif
}

/**********************************************************************/
/******************************* selection schema */
/**********************************************************************/

void w_count_select( struct win_t * w) 
{
  int i;
  for(i=0, w->selected = w->sel_size = 0; i<w->d_files; i++) 
    {
      if( w->dr[ i]->s) 
	{
	  w->selected++;
	  w->sel_size += file_size (w->dr[i]->f, NOMODE);
	}
    }
}

/* if file is selected then unselect else select file */

void select_one_file( struct win_t * w) 
{
  
  /* select status */
  /* not files "." or ".."  */
  if( w->akt_pos >= w->begin_at) 
    {
      w->dr[w->akt_pos]->s = (w->dr[ w->akt_pos]->s ? FALSE : TRUE);
      w->selected         += w->dr[w->akt_pos]->s ? 1 : -1;
      w->sel_size         += file_size (w->dr[w->akt_pos]->f, NOMODE) * (long)
	(w->dr[w->akt_pos]->s ? 1 : -1);
    }
  
  /* one position forwards */
  w->akt_pos = min( w->d_files - 1, w->akt_pos + 1); /* next position */
  
  w->fr_out  = TRUE;
}

/* CTRL_K */

/* lokal strcmp for search for files */

int KHA_strcmp( const char * str, const int num) 
{
  return( strcmp( str, w_[MY_cfg.akt_w]->dr[num]->f));
}

void select_files ( struct win_t * w, int mode) 
{
  /* mode == UNSELECT_MODE : to unselect the files */
  /* mode == SELECT_MODE   : to select the files */
  char tmp[ 255],  /* file names form pipe */
  d  [ 255],
  * q,
  r[ 255];
  FILE * f;
  int err_, i, end_ = FALSE, key, j;
  
  if (select_str == NULL)
    {               /* first call */
      select_str    = getmem (max_x + 1);
      select_str[0] = 0;
    }
  
  q = select_str;
  
  key = get_strxy (w,
		   w->f->x,
		   w->f->y+w->f->rows,
		   select_str,
		   w->f->width-1,
		   w->f->width-1,
		   mode & SELECT_MODE
		   ? " select files "
		   : " unselect files ",
		   leer,
		   CUR_MODE | FIL_MODE);

  if (key != ENTER && key != CTRL_M) end_ = TRUE;

  if (! end_)
    {
      if (( q = b_strchr (select_str, '/')) != 0)
	{
	  *q++ = 0;            /* cut the string in files */
	  /* and directory */
	  sprintf( d, "%s/", select_str); /* the files was cutting */
	  strcpy( select_str, q);         /* files without the path*/
	  if (change_dir( w, d) != -1)
	    {
	      get_path ( w);   /* a new path */
	      w_readdir( w, ".", FALSE);    /* new read */
	    }
	  else
	    {
	      message( "Directory not found ..!", leer);
	      end_ = TRUE;
	    }
	}
    }

  if (! end_)
    {
      char * comp_name = open_comp (select_str) ;

      for( i=2; i<w->d_files; i++)
	{
	  if (is_regex  (comp_name, w->dr [i]->f) )
	    {
	      w->dr[i]->s = (mode & UNSELECT_MODE
			     ? FALSE
			     : TRUE
			     );
	    }
	}
      close_comp (comp_name) ;

      w->fr_out     = TRUE;
      w->rahmen_out = TRUE;
    }

  w_count_select( w);                              /* count selected files */
}

/* read to end of line in the work file */

void read_to_end( int f) 
{
  char c;
  while( read( f, &c, 1) > 0 && c != ENTER && c != CTRL_M);
}

/**** delete blanks form line in the work file **/

void del_blanks( int f) 
{
  char c;
  while( read( f, &c, 1) > 0 && ( c == ' ' || c == TAB));
  lseek( f, -1, SEEK_CUR);
}

/* program to read a parameter line from the work file.			 */
/* it save the values in word and par 					 */

int ask_par( int f, char * word, char * par) 
{
  int i, j;
  char * p = word, * q = par, c;
  *p = 0;
  *q = 0;
  
  /* key */
  for( j=0; j<2; j++) 
    {
      for(i=0; i<99; i++) 
	{
	  if( read( f, &c, 1) <= 0) break;
	  if( c == ' ' || c == TAB || c == ENTER || c == CTRL_M || c == '#') 
	    break;
	  if( j == 0) 
	    {	/* key, as example "win" */
	      *p++ = c;
	      *p   = 0;
	    }
	  else {		/* value of the key, as example "2" */
	    *q++ = c;
	    *q   = 0;
	  }
	} 
      /* end of line or commentar */
      if( c == '#' || c == CTRL_M || c == ENTER) break; 
      
      del_blanks( f);
    }
  
  lseek( f, -1, SEEK_CUR);	/* go back */
  read_to_end( f);		/* terminate the current line */
  
  if( strlen(word) > 0 || strlen(par) > 0) return( TRUE);
  else return( FALSE);
}

/** to read the next parameter from the work file and to save the **/
/** parameter and there value in p2 				  **/

int read_next_par( int f, char * p1, char * p2) 
{
  char c;
  int err_, j;
  
  while( read( f, &c, 1) > 0) 
    {
      /* ignore blanks */
      if( c == ' ' || c == TAB || c == ENTER || c == CTRL_M) continue;
      if( c == '#') read_to_end( f);		/* ignore line */
      else {
	lseek( f, -1, SEEK_CUR);		/* go a character back */
	return( ask_par( f, p1, p2));	/* read the akual parameter */
      }
    }
  return( FALSE);
}

void change_tab( void) 
{
  struct input_t * in;
  struct log_t   * lg;
  struct frame_t * f;
  int  
    width = min( max_x, 30),
    down  = 5,
    x     = (max_x-width) / 2,
    y     = (max_y-down ) / 2,
    ret_,
    i;
  f  = make_frame (x, y, width, down, " Tab Size ", leer,
		   F_B_UTIL_CLR,
		   NOMODE);
  
  lg = make_log (f, 2, F_B_UTIL_CHS);
  log_format (lg, "  8  ", "  4  ");
  log_xy     (lg, 
	      f->width/4 - 5 / 2, 2,
	      f->width/4 - 5 / 2 + f->width/2, 2);
  log_setpos (lg, ( tab_size==8 ? 0 : 1));
  
  in = make_input (f, 1, NOMODE);
  input_log (in, 0, lg);

  view_frame( f);
  
  ret_ = f_getstr (in);
  
  if( ret_ == ENTER || ret_ == CTRL_M)
    tab_size = ( lg->pos==0 ? 8 : 4 );
  
  del_input ( in);
  del_log   ( lg);
  hide_frame( f, HIDE_MODE|DELETE_MODE);
}

/*
 * Debug function 
 */
void view_position (int pos, int total, int mode)
{
  static struct frame_t * f = NULL ;

  return ;
#if 0
  if (f == NULL)
    {
      int
	width = min (max_x-5, 20),
	down  = 1,
	x     = (max_x-width)/2,
	y     = max_y-1;
      f = make_frame (x, y, width, down, " Working .. ", leer, 
		      F_B_UTIL_CLR,
		      NOBOX_MODE) ;
    }
  if (mode & HIDE_MODE)
    {
      hide_frame (f, HIDE_MODE);
      return ;
    }
  f_putnchr( f,
		1,
		0,
		'*',
		max(0, pos * (f->width-2) / total),
		f->color,
		FILL_MODE
		);
  view_frame (f);
  fflush_() ;
#endif
}






