/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: dolib.h,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/dolib.h,v $
 */

#ifndef GLOBAL
#define GLOBAL
#endif

#ifndef DOLIB_HH
#	define DOLIB_HH

#include "doframe.h"
#include "dowin.h"

#define NEXTLINE_MODE   0x0001	/* read_line */
#define PREVLINE_MODE   0x0002

#define TIME_MODE       0x0002	/* clock_ */
#define DATE_MODE       0x0004

#define RM_ASK_MODE		0x0010
#define RM_RECURSIVE_MODE	0x0020

#define SET_TTY( tty) ioctl( 0, TCSETA, tty)
#define GET_TTY( tty) ioctl( 0, TCGETA, tty)
#define PER( x)       fprintf( stderr, x)

#define WIN          w_[MY_cfg.akt_w]
#define W_FILE( pos) (w->dr[pos]->f)
#define AKT_FILE( w) (w->dr[w->akt_pos]->f)

/*+*/

/**********              procedures             ***************/

GLOBAL void   debug         ( char *);

GLOBAL void   view_hide_help( void);                /* view/hide help line */
GLOBAL void   ins_help_line ( int mode);

GLOBAL void   view_com_line( struct win_t * w, int mode);
GLOBAL int    C_X          ( int u, int g, int m);
GLOBAL int    C_R          ( int u, int g, int m);
GLOBAL int    C_W          ( int u, int g, int m);
GLOBAL int    ff_strcmp    ( char * s1, char *s2);
GLOBAL void   clock_       ( int mode);
GLOBAL void   clearinput   ( void);
GLOBAL void   presskey     ( void);
GLOBAL int    run          ( char * prog, int mode);
GLOBAL void   clrscr_      ( void);
GLOBAL void   hide_cursor  ( void);
GLOBAL void   view_cursor  ( void);

/*****************************************************************************/
/*********************** messages and ok-cancel ******************************/
/*****************************************************************************/

#define       message(txt, tit) Getyesno (txt, " Ok ", tit, -1)
GLOBAL int    getyn        ( char * txt[], 
			     char * chs[], 
			     char * t1, 
			     char * t2, 
			     int pos);
GLOBAL int    Getyesno     (char * txt, char * chs, char * ttt, int pos);

GLOBAL void   colours      ( void);

GLOBAL char * getterm      ( void);
GLOBAL char * gettcap      ( void);
GLOBAL void   printpath    ( char * p);
GLOBAL void   usage        ( char * dir);
GLOBAL void   copyright    ( void );
GLOBAL void   com_line_arg ( int cnr, char ** arg);
GLOBAL char * arg_get      ( char * ths, int argc, char ** argv);
GLOBAL void   get_tmp_file_hist( void);
GLOBAL char * cutpath      ( char * pth, int max_l, int mode);
GLOBAL long   pow_         ( long b, int n);
GLOBAL int    read_next_par( int f, char * p1, char * p2);

#ifdef XX
/*** command history */
GLOBAL struct com_t * last_com( void );
GLOBAL struct com_t * make_com( void );
GLOBAL void   insert_com   ( char * com);
GLOBAL int    get_com      ( char * com);
GLOBAL void   read_first_commands ( void);
GLOBAL int    com_cnt      ( void);
#endif

GLOBAL void   premission   ( void);
GLOBAL void   help         ( void);

GLOBAL long   file_opensize (int f);
GLOBAL int    move_line    ( int f, int mode);
GLOBAL int    read_line    ( int f, char * buf, int len);
GLOBAL int    view_file    ( char * file, char * t, 
			     int x, int y, 
			     int x_cnt, int y_cnt, 
			     char * com, int len, int mode);

#ifdef UNIX
GLOBAL void  init_tty_mouse( void);
GLOBAL void  delay         ( int ms);
#else
#include <dos.h>
#endif

GLOBAL void  copy_files    ( struct win_t * w);  /* copy command */
GLOBAL int   find_file     ( struct win_t * w,
			    struct frame_t * ff,
			    char * str,
			    int mode
			    );  /* find file in the current dir. */

GLOBAL void  view_any_file ( struct win_t * w);  /* view any file */
GLOBAL void  view_dir_only ( struct win_t * w, int mode); /* view dir. only */
GLOBAL void  chs_files     ( struct win_t * w);  /* choose selected files */
GLOBAL void  w_count_select( struct win_t * w);
GLOBAL void  select_one_file( struct win_t * w);
GLOBAL void  select_files  ( struct win_t * w, int mode);  /* choose selected files */
GLOBAL void  manuell       ( struct win_t * w);
GLOBAL void  change_tab    ( void);               /* change tab block */

GLOBAL struct frame_t * make_help (char hlp [], int x, int y, int width);

GLOBAL void  about_project ( char ** about_str);
GLOBAL char * MY_ltohex( long value, int n, char fill);
GLOBAL void view_position (int pos, int total, int mode) ;


#endif /*_HH*/
