/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: domem.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/domem.c,v $
 */

#define GLOBAL extern
#define EXTERN

#include <stdio.h>
#include <stdlib.h>
#include "doerror.h"
#include "doframe.h"
#include "dowin.h"
#include "dolib.h"

void mem_error( void) 
{
    fprintf( stderr, "\nFatal error: No more available Memory, stack overflow\n");
    quit( 1);
}

void * getmem( size_t size) 
{
	void * p;
#ifdef XDEBUG
	if ((size % 1024) == 0)
	{
	XDEBUG2 ("getmem (size=%i)\n", size) ;
	}
#endif
	if( ( p = malloc (max(1, size))) == NULL) mem_error();
	return( p);
}

void * getcmem (size_t size) 
{
	void * p;
	if ((p = calloc (max(size,1), 1)) == NULL) mem_error();
	return( p);
}

void * getrmem( void * old_ptr, size_t size)
{
	void * p;
	if( ( p = realloc( old_ptr, max(size,1))) == NULL) mem_error();
	return( p);
}

#ifdef DOS
void * try_getmem( size_t len) 
{
    void * q = malloc( len),
	 * p = malloc( 2048);

    if (p != NULL) Free (p);
    if (p == NULL || q == NULL) 
      {
	if(q != NULL) Free( q);
	message ( " No more availiable memory ", " Memory allocation ");
	return NULL;
      }

    return q;
}
#endif /* DOS */
