/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: domenu.h,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/domenu.h,v $
 */

/****************************************************************************/
/**   menu-manager							   **/
/****************************************************************************/

#ifndef GLOBAL
#define GLOBAL
#endif

#ifndef DOMENU_HH
#	define DOMENU_HH

#define MAXMENU_ENTRY 		15

#define MNTITL_LEN		60		/* max. title length   */
#define MNCOMM_LEN		256		/* max. command length */

struct menu_t
{
  int    key;				/* key                  */
  char * title;				/* title for menu 	*/
  char * comm;				/* command to execute   */
  char * para;				/* default parameter    */
  int    width;				/* max. width of sons   */
  int    cnt;				/* count of sons        */
  int    pos;				/* current position for sons */
  int    mode;				/* ask for params, ..   */
  struct menu_t * parent;
  struct menu_t * son;
  struct menu_t * prev;			/* in one frame */
  struct menu_t * next;			/* in one frame */
};

typedef struct menu_t * menu_T;

#ifdef EXTERN
GLOBAL menu_T umenu_top;
#else
GLOBAL menu_T umenu_top = NULL;
#endif

GLOBAL menu_T  menu_top        (menu_T mn);
GLOBAL int     menu_bar        (int x, int y, menu_T mn, int * key);
GLOBAL menu_T  menu_insert     (menu_T parent);
GLOBAL int     menu_edit       (menu_T mn);
GLOBAL int     menu_delete     (menu_T mn);
GLOBAL int     menu_delete     (menu_T mn);
GLOBAL int     menu_changetext (menu_T mn, char * title, char * comm);
GLOBAL int     menu_choose     (menu_T mn);
GLOBAL int     menu_save       (menu_T mn);
GLOBAL int     menu_write      (FILE * f, menu_T mn, int * level);
GLOBAL int     menu_open       (menu_T mn);
GLOBAL int     menu_read       (int f, menu_T mn, int * level);


GLOBAL int   menu ( int    mn_keys [][MAXMENU_ENTRY],
		    char * mn_line [],
		    char * mn_event[][MAXMENU_ENTRY]);
/*
GLOBAL int   menu ( int  *   mn_keys[],
		    char *   mn_line [],
		    char **  mn_event[]);
*/
GLOBAL void  chs  ( char * str, int x, int y, int len, int mode);
GLOBAL int umenu_edit (char * title[], char * comm[],
		       int pos, int ev_count, int len,
		       int lk);
void umenu_call (void);

#endif /*_HH*/
