/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: domsg.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/domsg.c,v $
 */

#define GLOBAL extern
#define EXTERN

#ifdef UNIX

#ifdef SCO_UNIX
#include <stropts.h>
#endif
#include <sys/times.h>

#if defined (SCO_UNIX) || defined (UnixWare)
#include <sys/select.h>
#include <poll.h>
#endif

#endif

#include <sys/types.h>
#include <sys/timeb.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <fcntl.h>

#ifdef DOS
#include <dos.h>
#include <dir.h>
#include <io.h>
#endif

#include "dodefs.h"
#include "doglobal.h"
#include "domem.h"
#include "dostring.h"
#include "dofiles.h"
#include "doscr.h"
#include "dotext.h"
#include "dostern.h"
#include "dostat.h"
#include "doframe.h"
#include "dochoose.h"
#include "dohist.h"
#include "docfg.h"

#include "domsg.h"

#define MAIL_CHANGE 	0x0001
#define MAIL_TIMEOUT	300		/* msecondes */
#define MAX_USER	100		/* max. user to list */
#define TMP_FILE	"/tmp/khX"	/* temp. file for pipes */

void get_mail( void) {

#ifdef UNIX
    char tmp[ 128];

    if( electric_active) return;

    sprintf( tmp, "%s%s", TMP_FILE, my_tty);

    if( exist( tmp)) {
        int o_x = cur_x, o_y = cur_y; 

	electric_active = TRUE;
	
	message (" Anybody will communicate with you ",
		 " Electric Blue ");

	e_mail (MAIL_CHANGE);

    	gotoXY( o_x, o_y);
	}
#endif
    }

#ifdef UNIX

				/* user there are on system */
int getuser( char * usr_name, char * usr_tty) {
    int pp[ 2], i, err_, j, usr_cnt, lk;
    char c, *p, * q,
	 tmp[ 128],
	 * list[MAX_USER];
    pipe( pp);
    if( fork() == 0) {		/* child */
	close( pp[ STD_IN]);
	close( STD_OUT);
	dup( pp[ STD_OUT]);
	close( pp[ STD_OUT]);
				/* exec. who command with process id */
	err_ = execlp (options [SH_], options[SH_], "-c", "who -u", NULL);
	exit( err_);
	}
    close( pp[ STD_OUT]);

    for( i=j=0; i<MAX_USER-1 && read( pp[ STD_IN], &tmp[j], 1) > 0; j++) {
	if( tmp[j] == 10) {
	    tmp[j] = 0;

	    list[i] = getmem( strlen(tmp)+1);
	    strcpy( list[i], tmp);

	    j = -1;
	    i ++;
	    }
	}
    close( pp[STD_IN]);		/* close the pipe input */

    usr_cnt = i;
    list[usr_cnt] = NULL;

    wait( &err_);

    if( usr_cnt == 0) {
	message( " No users are found ", " User call ");
	return( FALSE);
	}

    i = 0;
    lk = ch_text( list, 0, 1, max_x, usr_cnt,
		  &i,
		  " List who is on system ",
		  " Choose your user ",
	          F_B_UTIL_CLR,
		  F_B_UTIL_CHS,
		  NOMODE);

    if( lk == ENTER || lk == CTRL_M) {
						/* username */
    	for( q = p = list[i]; * q != ' '; q++); *q = 0;
    	strcpy( usr_name, p);
						/* ttyname */
    	for( q++; * q == ' '; q++);
    	for( p=q; * q != ' '; q++); * q = 0;
    	strcpy( usr_tty, p);
	err_ = TRUE;
	}
    else err_ = FALSE;

    for( i=0; i<usr_cnt; i++) Free( list[i]);

    return( err_);
    
    }


void x_mail( int mode) {

    /****  mode == MAIL_CHANGE: change the file descreptor */

    struct frame_t * f, * hlp, * wt;
    char pipe_name[2][64];
    char hlp_text[] = "F12:End the message",
	 c, * q, * p,
	 usr_name[16],
	 usr_tty [32],
	 tmp     [128];

    int pipe_h     [2],
	pipe_closed[2],
	file_h,
	down,
	width,
	x,
	y,
	msg_x [2],
	msg_y [2],
	msg_by[2],		/* begining of y-coord. for the dialog */
	msg_mx[2],		/* max. x */
	msg_my[2],		/* max. y */
	m_a,			/* msg. aktual */
	lk,
	i,
	end_ = FALSE,	
	ret_,
	free_pipe = FALSE;

    sprintf( pipe_name[0], "%s%s", TMP_FILE, my_tty );		/* make tty from user */

    if( ! (mode & MAIL_CHANGE)) {
	if( ! getuser( usr_name, usr_tty)) return;

    	if( strcmp( my_tty, usr_tty) == 0) {
	    message( " You can't send message to your self ",
		     " send message ");
	    return;
	    }
	}
    else {

	if( ! exist( pipe_name[0])) {
		message( " User don't want more ", leer);
		return;
		}

	pipe_h[0] = open( pipe_name[0], O_RDONLY|O_NDELAY);

	p = usr_name;
	while( TRUE) {
	    ret_ = read( pipe_h[0], p, 1);
	    if( ret_ <  0) return;		/* error */
	    if( ret_ == 0) continue;		/* pipe empty */
	    if( * p == 0) break;
	    p++;
	    }
	p = usr_tty;
	while( TRUE) {
	    ret_ = read( pipe_h[0], p, 1);
	    if( ret_ <  0) return;		/* error */
	    if( ret_ == 0) continue;
	    if( * p == 0) break;
	    p++;
	    }
	close( pipe_h[0]);
 	}

    sprintf( pipe_name[1], "%s%s", TMP_FILE, usr_tty);		/* make tty for user */

    if( exist( pipe_name[1])) {
	sprintf( tmp, " Break, pipe <%s> exists ", pipe_name[1]);
	message( tmp, " create pipe ");
	return;
	}

    ret_ = mknod( pipe_name[1], S_IFIFO | S_IRGRP | S_IRUSR | S_IROTH, 0);

    if( ret_ != 0) {
	sprintf( tmp, " Break, can't create pipe <%s> ", pipe_name[1]);
	message ( tmp, " create pipe ");
	return;
	}

    chmod( pipe_name[1], 0644);    /* only read the message */

    pipe_h[1] = open( pipe_name[1], O_RDWR | O_NDELAY);
    
    if( ! ( mode & MAIL_CHANGE)) {
    	tmp[0] = 0;
    	write( pipe_h[1], owner, strlen( owner));     /* usr name */
    	write( pipe_h[1], tmp, 1);		      /* send \0 */	
    	write( pipe_h[1], my_tty, strlen( my_tty));   /* tty name */
    	write( pipe_h[1], tmp, 1);
	}

    width = min(max_x,50);
    down  = min(max_y,8);
    x     = (max_x-width)/2;
    y     = (max_y-down)/2;

					         /* send a message to user */
						 /* on his terminal */
    if( ! (mode & MAIL_CHANGE)) {
    	sprintf( tmp, "/dev/%s", usr_tty);
    	if( (file_h = open( tmp, O_WRONLY|O_NDELAY)) >= 0) {
	    sprintf( tmp, " ******* Message from <%s> on <%s> ********",
		      	  owner, my_tty);
	    write( file_h, tmp, strlen( tmp));
	    close( file_h);
	    }
	}
    else file_h = 1;

    wt    = make_frame( x, y, width, down, " Wait for user ", leer,
		        F_B_UTIL_CLR, NOMODE);
    f_putstr( wt, 1, 1, " Please wait ......", wt->color, NOMODE);
    if( file_h < 0) {
        f_putstr( wt, 1, 2, " User terminal is closed for messages, but", wt->color, NOMODE);
        f_putstr( wt, 1, 3, " when he have running a Khamis Utility    ", wt->color, NOMODE);
        f_putstr( wt, 1, 4, " he will get a information                ", wt->color, NOMODE);
	}
    f_putstr( wt, 1, 6, " Press F12 to abort", wt->color, NOMODE);

    view_frame( wt);

    
    for( ; TRUE; ) {
        pipe_h[0] = open( pipe_name[0], O_RDONLY | O_NDELAY);
	if( pipe_h[0] >= 0) break;
        lk = getkey( 1000);
	if( lk == ESC) {
		hide_frame( wt, HIDE_MODE|DELETE_MODE);
		remove( pipe_name[1]);     		    /* remove pipe */
		return;
		}
	}

    hide_frame( wt, HIDE_MODE|DELETE_MODE);

    for( i=0; i<2; i++) {
    	if( pipe_h[i] < 0) {
	    message( " Can't open pipe ", " Open pipe ");
	    if( i > 0) close( pipe_h[0]);
	    return;
	    }
	}

    down  = max_y-2,
    width = max_x,
    x     = ( max_x-width) / 2,
    y     = ( max_y-down ) / 2;
    f   = make_frame( x, y, width, down, " Electric Blue ", leer, F_B_NORMAL,
		    NOMODE);

    hlp = make_help( hlp_text, 0, max_y-1, max_x-1);

    f_putline( f, f->down/2+1, f->color);

    sprintf  ( tmp, " Message from <%s> on <%s> ", usr_name, usr_tty);
    f_putstr ( f, 1, f->down/2+1, tmp, F_B_CHOOSE_CLR, NOMODE);

    for( i=0; i<2; i++) {
	pipe_closed[i] = FALSE;
	msg_x [ i] = 1;
	msg_y [ i] = i==0 ? 1 : f->down/2+2;
	msg_by[ i] = i==0 ? 1 : f->down/2+2;
	msg_mx[ i] = f->width-2;
	msg_my[ i] = i==0 ? f->down/2 : f->down - msg_by[i] + 1;
	}

    view_frame( f);
    view_frame( hlp);

    while( TRUE) {

 							  /* read from pipe */
	if( ! pipe_closed[0]) ret_ = read( pipe_h[0], &lk, sizeof(int));
	else ret_ = 0;

	if( free_pipe && ret_ <= 0) {
	    close( pipe_h[0]); pipe_closed[0] = TRUE;
	    }

	if( ret_ > 0) m_a = 0;
	else {
		m_a = 1;
		view_cursor();
	        gotoXY( f->x+msg_x[m_a], f->y+msg_y[m_a]); /* cursor position */
		lk = getkey( 300);	               /* read with time out*/

		if( ! pipe_closed[1])
		    ret_ = write( pipe_h[1], &lk, sizeof(int));  /* send character */
		else ret_ = 0;

		if( pipe_closed[1] && lk == ESC) break;

		}

	if( ! end_ && ret_ <= 0) continue;

	switch( lk) {
	   case ENTER:
		msg_y[m_a] ++;
		msg_x[m_a] = 1;
		break;

	   case CUR_UP:
		msg_y[m_a] --;
		break;

	   case CUR_DOWN:
		msg_y[m_a] ++; 
		break;

	   case CUR_RIGHT:
		msg_x[m_a] ++; 
		break;

	   case CUR_LEFT:
		msg_x[m_a] --;
		break;

						     /* clear the character */
	   case BACKSPACE:
		msg_x[m_a] = max(msg_x[m_a]-1, 1);
		f_putch( f, msg_x[m_a], msg_y[m_a], ' ', f->color, SCR_MODE);
		break;

							/* end of message */
	   case ESC: {
		int end_str[] = { '*', '*', '*', '*', '*', '*', '*', '*',
				  'E', 'N', 'D', ' ', 'O', 'F', ' ',
				  'M', 'E', 'S', 'S', 'A', 'G', 'E', ' ',
				  '*', '*', '*', '*', '*', '*', '*', '*', '*',
				  0
				};

		if( m_a == 1) {
		    for(i=0; end_str[i] != 0; i++)
			write( pipe_h[1], &end_str[i], sizeof(int));

		    sleep( 2);				/* wait for reading */

		    close ( pipe_h[0]); pipe_closed[0] = TRUE;

		    end_ = TRUE;
		    }
		else {	
		    msg_x[m_a] = 1;
		    msg_y[m_a] ++;
		    free_pipe = TRUE;
		    }

		close ( pipe_h[1]); pipe_closed[1] = TRUE;

		remove( pipe_name[1]);
		}
		break;

	   default:
		if( ! is_ascii( lk)) break;

		f_putch( f, msg_x[m_a], msg_y[m_a], (char) lk, f->color,
			    SCR_MODE);

		msg_x[m_a]++;
		break;
	   }

	if( end_) break;

						 /* control the coordinates */
	if( msg_x[m_a] >= msg_mx[m_a]) {
	    msg_x[m_a] = 1;
	    msg_y[m_a] ++;
	    }

						        /* scroll the frame */
	while( msg_y[m_a] >= msg_by[m_a] + msg_my[m_a]) {
	    int pos1, pos2, j;
	    for( i=0; i<msg_my[m_a]-1; i++) {
		pos1 = (msg_by[m_a] + i    ) * f->width + 1;
		pos2 = (msg_by[m_a] + i + 1) * f->width + 1;
		for( j=1; j<f->width-1; pos1++, pos2++, j++) {
		    f->chr [pos1] = f->chr [pos2]; f->chr [pos2] = ' ';
		    f->attr[pos1] = f->attr[pos2]; f->attr[pos2] = f->color;
		    }
		}
	    msg_y[m_a]--;
	    view_frame( f);
	    }

 	msg_x[m_a] = max( 1, msg_x[m_a]);
 	msg_y[m_a] = max( msg_by[m_a], msg_y[m_a]);

	}

    hide_frame( f,   HIDE_MODE|DELETE_MODE);
    hide_frame( hlp, HIDE_MODE|DELETE_MODE);

    for(i=0; i<2; i++) close( pipe_h[i]);
    
    width = min(max_x,40);
    down  = min(max_y,5);
    x     = (max_x-width)/2;
    y     = (max_y-down)/2;
    wt    = make_frame( x, y, width, down, " Wait for user ", leer,
		        F_B_UTIL_CLR, NOMODE);
    f_putstr( wt, 1, 2, " wait for user to delete pipe ", wt->color, NOMODE);
    view_frame( wt);

    while( exist( pipe_name[0])) fflush_(), sleep( 1);

    hide_frame( wt, HIDE_MODE|DELETE_MODE);
    }


void e_mail( int mode) {

    electric_active = TRUE;

    x_mail( mode);

    view_screen();

    view_cursor();

    electric_active = FALSE;

    }
#endif
