/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: doregex.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/doregex.c,v $
 */

#define GLOBAL extern
#define EXTERN

#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <dirent.h>
#include <string.h>

#ifdef alpha
#include <regex.h>
#endif

#include "dostring.h"
#include "doregex.h"

#ifdef UNIX

#if defined (UnixWare)
#include <libgen.h>
#endif

#endif

#ifdef DOS
#include <io.h>
#endif

#include "dodefs.h"
#include "doglobal.h"
#include "domem.h"
#include "doregex.h"

GLOBAL char * open_comp (char * comp)
{
  int i, j = 0;
  static char buf [1024] ;
  char * cmp ;

#ifdef DOS
  cmp = getmem (strlen (comp) + 1);
  strcpy (cmp, comp) ;
  return cmp ;
#else
  buf [j++] = '^';
  for (i=0; comp[i] != 0; i++)
    {
      switch (comp[i])
	{
	case '\\':
	    i ++ ;
	    buf [j++] = '\\' ;
	    buf [j++] = comp[i] ;
	    break ;
	case '*':
	    buf [j++] = '.' ;
	    buf [j++] = '*' ;
	    break ;
	case '?':
	    buf [j++] = '.' ;
	    break ;
	case '.':
	    buf [j++] = '\\' ;
	    buf [j++] = '.' ;
	    break ;

	default:
	    buf [j++] = comp [i] ;
	    break ;
	}
    }
  buf [j++] = '$';
  buf [j]   = 0 ;

  XDEBUG3 ("string=[%s] ==> ed=[%s]\n", comp, buf );

#if defined (SCO_UNIX) || defined (UnixWare)
  cmp = regcmp (buf, NULL) ;
  return cmp ;
#else
  re_comp (buf);
  return NULL ;
#endif
#endif
}

int close_comp (char * cmp)
{
  if (cmp != NULL) Free (cmp);
  return TRUE;
}

GLOBAL int    is_regex (char * comp, char * sub)
{
#ifdef DOS
  return findmatch (comp, sub) ;
#else
#if defined (SCO_UNIX) || defined (UnixWare)
  if ( regex (comp, sub) != NULL )
    return 1 ;
  else
    return 0 ;
#else
  return re_exec (sub) == 1 ? TRUE : FALSE;
#endif
#endif  /* #ifdef DOS */
}




#ifdef XTESTMENU
#warning XDEBUG is defined
main (int argc, char * argv[])
{
  char * str = argv[1] ;
  char * p ;
  
  p = open_comp (str);
  
  XDEBUG3 ("regex(%s) = [%i]\n", p, is_regex (p, argv[2]) );
}
#endif




