/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: doscr.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/doscr.c,v $
 */

#define GLOBAL extern
#define EXTERN

#ifdef DOS
#include <conio.h>
#endif

#include <stdlib.h>
#include <string.h>
#include "dodefs.h"
#include "doglobal.h"
#include "dostring.h"
#include "domem.h"
#include "docfg.h"
#include "dotext.h"
#include "doscr.h"

#define SCREEN_MAX_X   0x0001
#define SCREEN_MAX_Y   0x0002
#define SCREEN_SEG     0x0004

#define STRING_LEN 13
#define CLR_USE    13
#define CNT        3

#define WAIT 	   if(getch()==27) exit(1);

struct log_t ** lg_;
int    for_clrs[]  = {  F_BLACK,  F_WHITE,   F_BLUE,   F_GREEN, F_RED, 
			F_CYAN,   F_YELLOW,  F_BROWN,  F_VIOLET,
			F_NORMAL, F_MESSAGE, F_INPUT,  F_UNDERLINED
		        },
       back_clrs[] = {  B_BLACK,  B_WHITE,   B_BLUE,   B_GREEN, B_RED, 
			B_CYAN,   B_YELLOW,  B_BROWN,  B_VIOLET,
			B_NORMAL, B_MESSAGE, B_INPUT,  B_UNDERLINED
			};

void view_colors( int num)
{
  int lg1   = (num%2) ? num-1 : num,
  lg2   = (num%2) ? num   : num+1,
  i1    = lg_[lg1]->pos,
  i2    = lg_[lg2]->pos,
  fgrnd = lg_[lg1]->color[i1] & 0xFF,
  bgrnd = lg_[lg2]->color[i2] & 0xFF00;
  
  f_outnch( lg_[num]->f, 1,
	   lg_[lg1]->y[i1],
	   STRING_LEN,
	   fgrnd|bgrnd,
	   NOMODE);
}

int color_fnumber( int color)
{
  int i;
  for(i=0; i<CLR_USE-1 && for_clrs [i] != (color & 0xFF  ); i++);
  return i;
}

int color_bnumber (int color)
{
  int i;
  for(i=0; i<CLR_USE-1 && back_clrs[i] != (color & 0xFF00); i++);
  return i;
}

void change_colors(void)
{
  struct frame_t * f;
  struct log_t   * lg[18];
  struct input_t * in;
  int    log_cnt[CNT] =
    { 
      18, /* logical fields in 1. window */
      16, /* logical fields in 2. window */
      12  /* logical fields in 3. window */
    };
  char
    hlp_text [] =
	" Choose your color combination and accept, press Esc for Abort ... ",
    * clr_fmt = " * ",
    * frmt[][20] =
      {
	{
	  /*                 1234 1234 1234 1234 1234 1234 1234 1234 1234 */
	  "             Blck Whte Blue Grn  Red  Cyan Yell Brn  Viol Norm Invs Msg Underl ",
	  " Backgrnd F: ",
	  " 	   B:",
	  " Normal   F:",
	  "          B:",
	  " Choose   F:",
	  "          B:",
	  " Select   F:",
	  "          B:",
	  " Choose   F:",
	  "          B:",
	  " Menu     F:",
	  "          B:",
	  " Choose   F:",
	  "          B:",
	  " Dialog   F:",
	  "          B:",
	  " Choose   F:",
	  "          B:",
	  NULL
	},
        {
	  /*                 1234 1234 1234 1234 1234 1234 1234 1234 1234 */
	  "             Blck Whte Blue Grn  Red  Cyan Yell Brn  Viol Norm Invs Msg Underl ",
	  " Utilities F:",
	  "          B:",
	  " Choose   F:",
	  "          B:",
	  " Help     F:",
	  "          B:",
	  " Choose   F:",
	  "          B:",
	  " Block    F:",
	  "          B:",
	  " Str.input F:",
	  "          B:",
	  " Str.over F:",
	  "          B:",
	  " Title    F:",
	  "          B:",
	  NULL
	},
	{
	  "             Blck Whte Blue Grn  Red  Cyan Yell Brn  Viol Norm Invs Msg Underl ",
	  "Header    F: ",
	  "          B:",
	  "Ins.Mode  F:",
	  "          B:",
	  "Clock     F:",
	  "          B:",
	  "ComLine   F:",
	  "          B:",
	  "Helpline  F:",
	  "          B:",
	  "Scollbars F:",
	  "          B:",
	  NULL
	}
      };
  int
    width = max_x,
    x     = (max_x-width)/2,
    down,
    y     = 1,
    cnt,
    num,
    i,
    l,
    lk,
    j;

  for( num=0; num<CNT; num++)
    {
      for( cnt=0; frmt[num][ cnt] != NULL; cnt++);
      
      down = min( cnt+2, max_y);
      
      f = make_frame( x, y, width, down, " Colors ", leer, F_B_UTIL_CLR,
		     NOMODE);
      
      for( i=0; frmt[num][i] != NULL; i++)
	f_putstr( f, 1, i+1, frmt[num][i], f->color, NOMODE);
      
      in = make_input( f, log_cnt[num], NOMODE);
      input_help (in, hlp_text);
      
      for(j=0; j<log_cnt[num]; j++)
	{
	  lg[j]  = make_log( f, CLR_USE, F_B_UTIL_CHS);  /* for 9 colors */
	  for(i=0; i<CLR_USE; i++)
	    {
	      lg[j]->fmt  [i] = clr_fmt;
	      lg[j]->x    [i] = strlen( frmt[num][1]) + i * 5 + 1;
	      lg[j]->y    [i] = 2 + j;
	      lg[j]->color[i] = for_clrs[i] | back_clrs[i];
	    }
	  lg[j]->pos = 0;             /* default: not recursive */
	}
      
      for(i=0; i<log_cnt[num]; i++)
	{
	  in->type[i] = TYPE_LOG;
	  in->ptr [i] = (void*) lg[i];	/* pointer to adress of logical-record*/
	}
      in->prog = view_colors;
      
      lg_        = &lg[0];
      
      switch( num)
	{
	case  0:
	  /* Window */
	  i = 0;
	  lg[i++]->pos = color_fnumber( F_B_GROUND_CLR);
	  lg[i++]->pos = color_bnumber( F_B_GROUND_CLR);
	  lg[i++]->pos = color_fnumber( F_B_NORMAL);
	  lg[i++]->pos = color_bnumber( F_B_NORMAL);
	  lg[i++]->pos = color_fnumber( F_B_CHOOSE_CLR);
	  lg[i++]->pos = color_bnumber( F_B_CHOOSE_CLR);
	  
	  lg[i++]->pos = color_fnumber( F_B_SELECT_CLR);
	  lg[i++]->pos = color_bnumber( F_B_SELECT_CLR);
	  lg[i++]->pos = color_fnumber( F_B_SELECT_CHS);
	  lg[i++]->pos = color_bnumber( F_B_SELECT_CHS);
	  
	  lg[i++]->pos = color_fnumber( F_B_MENU_CLR);
	  lg[i++]->pos = color_bnumber( F_B_MENU_CLR);
	  lg[i++]->pos = color_fnumber( F_B_MENU_CHS);
	  lg[i++]->pos = color_bnumber( F_B_MENU_CHS);
	  
	  lg[i++]->pos = color_fnumber( F_B_DIALOG_CLR);
	  lg[i++]->pos = color_bnumber( F_B_DIALOG_CLR);
	  lg[i++]->pos = color_fnumber( F_B_DIALOG_CHS);
	  lg[i++]->pos = color_bnumber( F_B_DIALOG_CHS);
	  
	  break;
	  
	case 1:
	  i = 0;
	  lg[i++]->pos = color_fnumber( F_B_UTIL_CLR);
	  lg[i++]->pos = color_bnumber( F_B_UTIL_CLR);
	  lg[i++]->pos = color_fnumber( F_B_UTIL_CHS);
	  lg[i++]->pos = color_bnumber( F_B_UTIL_CHS);
	  
	  lg[i++]->pos = color_fnumber( F_B_HELP_CLR);
	  lg[i++]->pos = color_bnumber( F_B_HELP_CLR);
	  lg[i++]->pos = color_fnumber( F_B_HELP_CHS);
	  lg[i++]->pos = color_bnumber( F_B_HELP_CHS);
	  
	  lg[i++]->pos = color_fnumber( F_B_BLOCK_CLR);
	  lg[i++]->pos = color_bnumber( F_B_BLOCK_CLR);
	  
	  lg[i++]->pos = color_fnumber( F_B_INPUT_CLR);
	  lg[i++]->pos = color_bnumber( F_B_INPUT_CLR);
	  lg[i++]->pos = color_fnumber( F_B_INPUT_CHS);
	  lg[i++]->pos = color_bnumber( F_B_INPUT_CHS);
	  
	  lg[i++]->pos = color_fnumber( F_B_TITLE_CLR);
	  lg[i++]->pos = color_bnumber( F_B_TITLE_CLR);
	  
	  break;
	case 2:
	  
	  lg[0]->pos = color_fnumber( F_B_HEAD_CLR);
	  lg[1]->pos = color_bnumber( F_B_HEAD_CLR);
	  
	  lg[2]->pos = color_fnumber( F_B_INSMODE_CLR);
	  lg[3]->pos = color_bnumber( F_B_INSMODE_CLR);
	  
	  lg[4]->pos = color_fnumber( F_B_CLOCK_CLR);
	  lg[5]->pos = color_bnumber( F_B_CLOCK_CLR);
	  
	  lg[6]->pos = color_fnumber( F_B_COMLINE_CLR);
	  lg[7]->pos = color_bnumber( F_B_COMLINE_CLR);
	  
	  lg[8]->pos = color_fnumber( F_B_HELPLINE_CLR);
	  lg[9]->pos = color_bnumber( F_B_HELPLINE_CLR);

	  lg[10]->pos = color_fnumber( F_B_SCROLL_CLR);
	  lg[11]->pos = color_bnumber( F_B_SCROLL_CLR);
	  break;
	}
      
      view_frame( f);
      
      lk = f_getstr( in);
      
      if( lk == ENTER || lk == CTRL_M)
	
	switch( num)
	  {
	  case  0:
	    i = 0;
	    F_B_GROUND_CLR  = for_clrs[ lg[i]->pos ] | back_clrs[ lg[i+1]->pos ]; i+=2;
	    F_B_NORMAL      = for_clrs[ lg[i]->pos ] | back_clrs[ lg[i+1]->pos ]; i+=2;
	    F_B_CHOOSE_CLR  = for_clrs[ lg[i]->pos ] | back_clrs[ lg[i+1]->pos ]; i+=2;
	    F_B_SELECT_CLR  = for_clrs[ lg[i]->pos ] | back_clrs[ lg[i+1]->pos ]; i+=2;
	    F_B_SELECT_CHS  = for_clrs[ lg[i]->pos ] | back_clrs[ lg[i+1]->pos ]; i+=2;
	    F_B_MENU_CLR    = for_clrs[ lg[i]->pos ] | back_clrs[ lg[i+1]->pos ]; i+=2;
	    F_B_MENU_CHS    = for_clrs[ lg[i]->pos ] | back_clrs[ lg[i+1]->pos ]; i+=2;
	    F_B_DIALOG_CLR  = for_clrs[ lg[i]->pos ] | back_clrs[ lg[i+1]->pos ]; i+=2;
	    F_B_DIALOG_CHS  = for_clrs[ lg[i]->pos ] | back_clrs[ lg[i+1]->pos ]; i+=2;
	    break;
	    
	  case 1:
	    i = 0;
	    F_B_UTIL_CLR  = for_clrs[ lg[i]->pos ] | back_clrs[ lg[i+1]->pos ];i+=2;
	    F_B_UTIL_CHS  = for_clrs[ lg[i]->pos ] | back_clrs[ lg[i+1]->pos ];i+=2;
	    F_B_HELP_CLR  = for_clrs[ lg[i]->pos ] | back_clrs[ lg[i+1]->pos ];i+=2;
	    F_B_HELP_CHS  = for_clrs[ lg[i]->pos ] | back_clrs[ lg[i+1]->pos ];i+=2;
	    F_B_BLOCK_CLR = for_clrs[ lg[i]->pos ] | back_clrs[ lg[i+1]->pos ];i+=2;
	    F_B_INPUT_CLR = for_clrs[ lg[i]->pos ] | back_clrs[ lg[i+1]->pos ];i+=2;
	    F_B_INPUT_CHS = for_clrs[ lg[i]->pos ] | back_clrs[ lg[i+1]->pos ];i+=2;
	    F_B_TITLE_CLR = for_clrs[ lg[i]->pos ] | back_clrs[ lg[i+1]->pos ];i+=2;
	    break;
	    
	  case 2:
	    i=0;
	    F_B_HEAD_CLR     = for_clrs[lg[i]->pos] | back_clrs[lg[i+1]->pos]; i+=2;
	    F_B_INSMODE_CLR  = for_clrs[lg[i]->pos] | back_clrs[lg[i+1]->pos]; i+=2;
	    F_B_CLOCK_CLR    = for_clrs[lg[i]->pos] | back_clrs[lg[i+1]->pos]; i+=2;
	    F_B_COMLINE_CLR  = for_clrs[lg[i]->pos] | back_clrs[lg[i+1]->pos]; i+=2;
	    F_B_HELPLINE_CLR = for_clrs[lg[i]->pos] | back_clrs[lg[i+1]->pos]; i+=2;
	    F_B_SCROLL_CLR   = for_clrs[lg[i]->pos] | back_clrs[lg[i+1]->pos]; i+=2;
	    break;
	  }
      
      for( i = 0; i < log_cnt[num]; i++) del_log( lg[i]);
      del_input( in);
      hide_frame( f, HIDE_MODE|DELETE_MODE);
      if( lk == ESC) break;
    } /* num */

  if( lk != ESC)
    {             /* save configuration */
      char msg[] = " Save new color table ;;"
	" Table is automaticaly readed by next call ;;"
	  " Restart the program to aktivate the new colors "
	    ;
      if( Getyesno (msg, NULL, " Save ", 0) == 0) save_config(&MY_cfg);
    }
}

void set_colors( void)
{
#ifdef UNIX
  F_B_GROUND_CLR     = use_color ? (F_WHITE|B_BLACK)  : (F_NORMAL|B_NORMAL);
  F_B_CHOOSE_CLR     = use_color ? (F_BLACK|B_CYAN)   : (F_MESSAGE|B_MESSAGE);
#else
  F_B_GROUND_CLR     = F_WHITE | B_BLACK;              /* normal choose */
  F_B_CHOOSE_CLR     = use_color ? (F_BLACK |B_CYAN)   : (F_BLACK|B_WHITE);
#endif
  
#ifdef DOS
  F_B_NORMAL         = use_color ? (F_WHITE |B_BLUE )  : (F_CYAN|B_BLACK);
  F_B_SELECT_CLR     = use_color ? (F_YELLOW|B_BLUE)   : (F_WHITE|B_BLACK);
  F_B_SELECT_CHS     = use_color ? (F_YELLOW|B_CYAN)   : (F_WHITE|B_WHITE);
#else
  F_B_NORMAL         = use_color ? (F_WHITE |B_BLUE )  : F_B_GROUND_CLR;
  F_B_SELECT_CLR     = use_color ? (F_YELLOW|B_BLUE)   : (F_INPUT|B_INPUT);
  F_B_SELECT_CHS     = use_color ? (F_YELLOW|B_CYAN)   : (F_UNDERLINED|B_UNDERLINED); /* choose color of selec. files */
#endif
  
  F_B_INPUT_CLR      = use_color ? (F_BLACK |B_CYAN)   : F_B_NORMAL;
  F_B_INPUT_CHS      = use_color ? (F_BLACK |B_GREEN)  : F_B_CHOOSE_CLR;
  
  F_B_MENU_CLR       = use_color ? ( F_BLACK|B_WHITE)  : F_B_NORMAL;
  F_B_MENU_CHS       = use_color ? ( F_BLACK|B_GREEN)  : F_B_CHOOSE_CLR;
  F_B_UTIL_CLR       = use_color ? ( F_BLACK|B_CYAN)   : F_B_NORMAL;
  F_B_UTIL_CHS       = use_color ? ( F_WHITE|B_RED  )  : F_B_CHOOSE_CLR;
  F_B_DIALOG_CLR     = use_color ? ( F_BLACK|B_WHITE)  : F_B_NORMAL;
  F_B_DIALOG_CHS     = use_color ? ( F_WHITE|B_RED  )  : F_B_CHOOSE_CLR;
  F_B_HELP_CLR       = use_color ? ( F_BLACK|B_GREEN)  : F_B_NORMAL;
  F_B_HELP_CHS       = use_color ? ( F_WHITE|B_RED)    : F_B_CHOOSE_CLR;
  F_B_BLOCK_CLR      = use_color ? ( F_BLUE |B_WHITE)  : F_B_CHOOSE_CLR;
  F_B_TITLE_CLR      = use_color ? ( F_BLUE|B_WHITE)   : F_B_CHOOSE_CLR;
  F_B_INSMODE_CLR    = use_color ? ( F_BLACK|B_GREEN)  : F_B_CHOOSE_CLR;
  F_B_CLOCK_CLR      = use_color ? ( F_WHITE|B_RED)    : F_B_CHOOSE_CLR;
  F_B_COMLINE_CLR    = use_color ? F_B_NORMAL          : F_B_NORMAL;
  F_B_HELPLINE_CLR   = use_color ? (F_WHITE|B_RED)     : F_B_NORMAL;
  F_B_HEAD_CLR       = use_color ? (F_WHITE|B_VIOLET)  : F_B_NORMAL;
  F_B_SCROLL_CLR     = use_color ? (F_BLACK|B_GREEN)   : F_B_CHOOSE_CLR;
}

char get_videomode( void)
{
#ifdef DOS
  char videomode;
  asm {
      mov ah, 15                  /* get video mode */
      int 0x10
      mov videomode, al       /* save video mode */
    }
  if( videomode == 0x7) use_color = FALSE, set_colors(); /* no color */
  return( videomode);
#endif
}

void set_videomode ( char m )
{
#ifdef DOS
  if( m == get_videomode()) return;       /* same video mode */
  asm {
      mov ah, 0
      mov al, m
      int 0x10
    }
#endif
}

int get_max_x  ( int video_mode)
{
  return( get_scr_info( video_mode, SCREEN_MAX_X));
}

int get_max_y  ( int video_mode)
{
  return( get_scr_info( video_mode, SCREEN_MAX_Y));
}

int get_seg( int video_mode)
{
  return( get_scr_info( video_mode, SCREEN_SEG));
}

int get_scr_info( int video_mode, int mode)
{
#ifdef DOS
  int x = 80, y = 25, seg = 0xB800;
  
  seg   = 0xb800;
  switch( video_mode)
    {
    case 0x0:
    case 0x1:
      y = 25;
      x = 40;
      break;
    case 0x2:
    case 0x3:
      y = 25;
      x = 80;
      break;
    case 0x4:
    case 0x5:
      y = 25;
      x = 40;
      break;
    case 0x6:
      y = 25;
      x = 80;
      break;
    case 0x7:
      y   = 25;
      x   = 80;
      seg = 0xb000;
      break;
    case 0xD:
      y = 25;
      x = 40;
      seg = 0xA000;
      break;
    case 0xE:
    case 0xF:
    case 0x10:
      x = 80;
      y = 25;
      seg = 0xA000;
      break;
    case 0x11:
    case 0x12:
      x = 80;
      y = 30;
      seg = 0xA000;
      break;
    case 0x13:
      x = 40;
      y = 25;
      seg = 0xA000;
      break;
    case 0x14:
      x = 132;
      y = 25;
      break;
    case 0x22:
      x = 132;
      y = 44;
      break;
    case 0x23:
      x = 132;
      y = 25;
      break;
    case 0x24:
      x = 132;
      y = 28;
      break;
    case 0x25:
      x = 80;
      y = 60;
      seg = 0xA000;
      break;
    case 0x26:
      x = 80;
      y = 60;
      break;
    case 0x29:
      x = 100;
      y = 37;
      seg = 0xA000;
      break;
    case 0x2d:
      x = 80;
      y = 25;
      seg = 0xA000;
      break;
    case 0x2e:
      x = 80;
      y = 30;
      seg = 0xA000;
      break;
    case 0x2f:
      x = 80;
      y = 25;
      seg = 0xA000;
      break;
    case 0x30:
      x = 100;
      y = 37;
      seg = 0xA000;
      break;
    case 0x37:
    case 0x38:
      x = 128;
      y = 48;
      seg = 0xA000;
      break;
    case 0x54:
      x = 132;
      y = 43;
      break;
    case 0x55:
      x = 132;
      y = 25;
      break;
    default:
      x = 80;
      y = 25;
      break;
    }
  return( mode & SCREEN_MAX_X ? x   :
	 mode & SCREEN_MAX_Y ? y   :
	 mode & SCREEN_SEG   ? seg :
	 0
	 );
#endif
}

void   get_screen   ( void)
{                  /* save screen in buffer */
#ifdef DOS
  int size = max_x*max_y,
  i;
  if( screen == NULL) screen = getmem(size*sizeof(int));
  if( ! gettext( 1, 1, max_x, max_y, screen))
    {
      for(i=0; i<size; i++) screen[i] = scr_mem[i];
    }
#else
#endif
}

void   put_screen   ( void)
{                  /* restore screen */
#ifdef DOS
  int size = max_x*max_y,
  i;
  if( screen == NULL) screen = getmem(size*sizeof(int));
  if( ! puttext( 1, 1, max_x, max_y, screen))
    {
      for(i=0; i<size; i++) scr_mem[i] = screen[i];
    }
#else
#endif
}


