/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: dostat.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/dostat.c,v $
 */

/**** file stat ***/

#define GLOBAL extern
#define EXTERN

#ifdef UNIX
#include <sys/param.h>
#endif

#include <sys/types.h>
#include <sys/timeb.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <fcntl.h>

#ifdef alpha
#include <unistd.h>
#endif

#if defined (HAVE_REALPATH) && defined (alpha) && ! defined (HAVE_READLINK)
#define HAVE_READLINK
#endif
#if defined (HAVE_READLINK) && ! defined (HAVE_REALPATH) 
#define HAVE_REALPATH
#endif

#ifdef DOS
#include <dos.h>
#include <dir.h>
#include <io.h>
#endif

#include "dodefs.h"
#include "doglobal.h"
#include "domem.h"
#include "dostring.h"
#include "dofiles.h"
#include "doscr.h"
#include "dotext.h"
#include "dostern.h"
#include "dostat.h"
#include "doframe.h"
#include "dochoose.h"
#include "dohist.h"
#include "docfg.h"

#include "dostat.h"

void file_stat( struct win_t * w, int pos, char * str, int mode) {
	/* mode = STATUS : Statusformat */
	/* mode = CHOOSE_MODE : Chooseformat */

	int m, i;
	struct stat * f_st;
	struct tm mTime, aTime, cTime;
#ifdef UNIX
	char * o_name,
	       g_name [10],
	       u_name [10];
	char f_mod[] = "-oooggguuu";
	char * p = f_mod;
        char * grp, * usr;
#endif
			/* view the size of selected files on the status */

	if( (mode & STATUS) && w->view_size && w->selected > 0) {
	    sprintf( str, " %.3f KBytes in %i selected files",
			  (double) w->sel_size / 1000.0,
		          w->selected);
	    return;
	    }

	f_st     = w->f_stat[ pos];

#ifdef UNIX
					/* group */
	grp      = getgrp_idname (f_st->st_gid);
	if( grp != NULL) sprintf (g_name, "%s", grp);
	else	         sprintf (g_name, "%i", f_st->st_gid);

					/* user name */
	usr  = getuser_idname( f_st->st_uid);
	if( usr != NULL) sprintf( u_name, "%s", usr);
	else	         sprintf( u_name, "%i", f_st->st_uid);
#endif

	mTime  = * localtime( &f_st->st_mtime);  /* modify time */

	/* in DOS the mTime,cTime,assTime are the same */

#ifdef UNIX
	aTime  = * localtime( &f_st->st_atime);  /* access time */
	cTime  = * localtime( &f_st->st_ctime);  /* create time */

	m      = f_st->st_mode;
	*p++   = w->dr[ w->anf_pos+pos]->m;
	*p++   = ( C_O_R( m) ? 'r' : '-');	/* owner */
	*p++   = ( C_O_W( m) ? 'w' : '-');
	*p++   = ( C_O_X( m) ? 'x' : '-');
	*p++   = ( C_G_R( m) ? 'r' : '-');	/* group */
	*p++   = ( C_G_W( m) ? 'w' : '-');
	*p++   = ( C_G_X( m) ? 'x' : '-');
	*p++   = ( C_A_R( m) ? 'r' : '-');	/* all */
	*p++   = ( C_A_W( m) ? 'w' : '-');
	*p++   = ( C_A_X( m) ? 'x' : '-');
	*p     = 0;

	if( mode & STATUS)
	    sprintf( str, "%10s%4i",
		f_mod,
		w->f_stat[ pos]->st_nlink);
	else * str = 0;

	/* block or character files or minor and major for devices */
	if (w->dr [w->anf_pos+pos]->m == 'c' ||
	    w->dr[ w->anf_pos+pos]->m == 'b')
	  {
	    sprintf (str+strlen( str),
		     " %3i,%3i ",
#ifdef SCO_UNIX
		     f_st->st_rdev >> 8,
#else
		     f_st->st_rdev >> 18,
#endif
		     f_st->st_rdev & 0xff
		     );
	  }
	else
	  {
	    sprintf( str+strlen( str),
		    " %7li ", f_st->st_size);
	  }

	if( mode & STATUS)
	    sprintf( str+strlen( str),
		"%7s %7s %2s %3s %2i %4i %02i:%02i i%5i",
		u_name,
		g_name,
		week[ mTime.tm_wday],
		month[ mTime.tm_mon],
		mTime.tm_mday,
		mTime.tm_year + 1900,
		mTime.tm_hour,       /* the time go 1 hour back */
		mTime.tm_min,
		w->f_stat[ pos]->st_ino	 /* inode */
		);

	else {
	    sprintf( str+strlen(str),
		"%2i.%02i.%02i %02i:%02i %8s %8s %s i%5i %3i",
		mTime.tm_mday,		/* modify time */
		mTime.tm_mon + 1,
		mTime.tm_year,
		mTime.tm_hour,
		mTime.tm_min,
		u_name,				/* user name */
		g_name,				/* group name */
		f_mod + 1,			/* mode rwxrwxrwx */
		w->f_stat[ pos]->st_ino,	/* inode */
		w->f_stat[ pos]->st_nlink	/* links */
		);
	    sprintf( str+strlen(str),
		" %2i.%02i.%02i %02i:%02i %2i.%02i.%02i %02i:%02i",
		cTime.tm_mday,		/* create time */
		cTime.tm_mon + 1,
		cTime.tm_year,
		cTime.tm_hour,
		cTime.tm_min,
		aTime.tm_mday,		/* assecc time */
		aTime.tm_mon + 1,
		aTime.tm_year,
		aTime.tm_hour,
		aTime.tm_min
		);
	    }
#else
	if( mode & STATUS)
	    sprintf( str, "%-12s  ", AKT_FILE(w));
	else * str = 0;

	i = strlen(str);
			/* block or character files minor and major */
	if( S_ISDIR(f_st->st_mode)) {
	     char *p = w->dr[w->anf_pos+pos]->f;
		  if( p[0] != '.'         ) sprintf( str+i, "<  DIR  > ");
	     else if( strcmp( p, ".") == 0) sprintf( str+i, "<  WORK > ");
	     else 			    sprintf( str+i, "<  UP_  > ");
	     }
	else
	     sprintf( str+i, "%9li ", f_st->st_size);

	if( mode & STATUS)
	    sprintf( str+strlen( str),
		"%2s %3s %2i %4i %02i:%02i",
		week[ mTime.tm_wday],
		month[ mTime.tm_mon],
		mTime.tm_mday,
		mTime.tm_year + 1900,
		mTime.tm_hour,       /* the time go 1 hour back */
		mTime.tm_min
		);

	else {
	    sprintf( str+strlen(str),
		"%2i.%02i.%02i %02i:%02i "
		"<owner> <group> <rwxrwxrwx> "
		"<I-Node> <Links> "
		"<creTime> <assTime> <UNIX only>",
		mTime.tm_mday,		/* modify time */
		mTime.tm_mon + 1,
		mTime.tm_year,
		mTime.tm_hour,
		mTime.tm_min
		);
	    }
#endif
	}

void print_file_stat( struct win_t * w, int pos)
{
  char static status[ MAXPATH];
  file_stat( w, pos, status, STATUS);
  f_putstr (w->f,
	    1,
	    w->f->rows - 2,
	    status,
	    /* status as selected color, if there are selected */
	    /* Files and the flag is set */
	    w->selected > 0 && w->view_size ? F_B_SELECT_CLR : w->f->color,
	    FILL_MODE |
	    ( w->f->mode & VIEW_MODE
	     ? SCR_MODE /* frame viewed, out on the screen */
	     : NOMODE   /* frame hidden, no output */
	     )
	    );
#ifdef HAVE_REALPATH

  if (w->link_f != NULL) 
    {
      hide_frame (w->link_f, HIDE_MODE|DELETE_MODE);
      w->link_f = NULL ;
    }

  if (w->dr[w->akt_pos]->m == 'l')
    {
      int len, ret_ ;
      char * p ;
      char path[MAXPATH] ;
      struct stat st ;

#ifdef HAVE_READLINK
      readlink (w->dr[w->akt_pos]->f, path, sizeof (path));
#else
      realpath (w->dr[w->akt_pos]->f, path) ;
#endif
      p = cutpath (path, w->f->width-7, NOMODE);

      ret_ = MY_stat (path, &st) ;

      strcpy (path+3, p);

      p         = path ;
      len       = strlen (p);
      p [    0] = '>';
      p [    1] = (ret_ < 0) ? '?' : get_modechar (w, &st) ;
      p [    2] = ' ';
      p [  len] = ' ';
      p [len+1] = 0;

      len = min (w->f->width - 3, strlen (p)) ;

      w->link_f = make_frame (w->f->x+2, w->f->y + w->f->rows - 1, len, 1,
			      leer, leer,
			      w->f->color,
			      NOBOX_MODE
			      );
      f_putstr (w->link_f,
		0,
		0,
		path,
		w->link_f->color,
		NOMODE
		);
      view_frame (w->link_f);
    }
#endif

  /*
   * view pos. on scroll bar 
   */
  f_reposition (w->f, w->akt_pos, w->d_files - 1, SCROLL_RIGHT_MODE);
}

void f_filestat (int pos)
{
  struct win_t * w = WIN;
  
  if( w->ch->mode & EXTRA_MODE)
    w->ch->chs_color = (w->dr[w->anf_pos+pos]->s
			? F_B_SELECT_CHS          /* selected file */
			: F_B_CHOOSE_CLR          /* normal choose */
			);         /* choose color */
  else w->ch->chs_color = (w->dr[w->anf_pos+pos]->s
			   ? F_B_SELECT_CLR      /* selected file */
			   : w->f->color         /* normal color  */
			   );         /* choose color */

  w->akt_pos = min( w->anf_pos + pos, w->d_files);

  pos = w->akt_pos - w->anf_pos;	/* absolute position to choose block */

  print_file_stat (w, pos);             /* file stat on the status line */
  w->ch->pos = pos;

}

#ifdef DOS
void change_disk( int num) {

    struct frame_t * f;
    struct choose_t * ch;

    char * disks[] = { "A", "B", "C", "D", "E", "F", "G", "H", "I", "J",
		       "L", "K", "M", NULL };
    char chng[40];

    int drive      = 0,
	dsk_cnt    = 0,
	last_drive = 0,
	width,
	down,
	fak,
	x,
	y,
	lk,
	i,
	save_akt_w = MY_cfg.akt_w;

    if( num > MY_cfg.win_cnt-1) return;

    drive      = w_[MY_cfg.akt_w]->drive;
    last_drive = setdisk(drive);          /* last drive */
					  /* count of dirves on system */
    for(i=0; i<last_drive; i++) {
	setdisk( i);
	if( i == getdisk()) dsk_cnt++;
	}
    setdisk( drive);

    fak        = 5;			  /* width of choose block */
    width      = max( 40, dsk_cnt * fak); /* width of frame */
    down       = 3;			  /* rows in the frame */
    x          = (max_x-width)/2;	  /* x */
    y          = (max_y-down)/2;          /* y */

    sprintf( chng, " change Drive window [%i] ", num+1);
    f  = make_frame( x, y, width, down, chng, "",
		     F_B_DIALOG_CLR, NOMODE);

    ch = make_choose( f, dsk_cnt, F_B_DIALOG_CHS, AUTO_MODE | VERT_MODE);

    for(i=0; i<dsk_cnt; i++) {
	lk = ( f->width - dsk_cnt*fak)/2+i*fak;
	f_putstr( f, lk+fak/2, 1, disks[i], f->color, NOMODE);
	ch->x[i] = lk;
	ch->y[i] = 1;
	ch->len[i] = fak;
	}
    ch->pos = w_[num]->drive;

    view_frame( f);

    lk = f_choose( ch);

    hide_frame( f, HIDE_MODE |DELETE_MODE);

    if( lk != ENTER && lk != CTRL_M) return;

    MY_cfg.akt_w = num;
    setdisk ( ch->pos);
    get_path( w_[num]);

    w_[num]->fr_out     = TRUE;
    w_[num]->rahmen_out = TRUE;
    w_readdir( w_[num], w_[num]->path, NOMODE);
    w_outdir ( w_[num], 0);

    w_[num]->akt_pos = w_[num]->old_pos = max(w_[num]->begin_at-1,0);
    w_[num]->anf_pos = 0;

    MY_cfg.akt_w = save_akt_w;
    setdisk ( w_[MY_cfg.akt_w]->drive);
    get_path( w_[MY_cfg.akt_w]);
    w_[num]->fr_out     = TRUE;
    w_[num]->rahmen_out = TRUE;
    w_outdir( w_[MY_cfg.akt_w], w_[MY_cfg.akt_w]->anf_pos);
    }

/* for ROOT on DOS */
/* if strlen(pth) == 0 it is no "." or ".."*/
void change_begin_at( struct win_t * w) {
    char path[MAXPATH];
    getcurdir( 0, path);
    w->begin_at = ( strlen(path) > 0 ? 2 : 1);
    }

#endif

int change_dir( struct win_t * w, char * pth) {
	int err_;

	get_cur_dir( w->path, w->cur_dir);

#ifdef DOS
	setdisk( w->drive);
#endif
	err_ = chdir( pth);

#ifdef DOS
	change_begin_at(w);
#endif
	return( err_);

	}

/* get the current directory name without path */

void get_cur_dir( char * pth, char * dr) {
     char * p;
#ifdef UNIX
     char between_pth = '/';
#else
     char between_pth = '\\';
#endif
     for( p=pth+strlen(pth); p > pth && *(p-1) != between_pth; p--);
     strcpy( dr, p);
     }

char * getpath( char * pth) {
				/* use the library 'getcwd' */
#ifdef UNIX_FORK
    FILE * f;
    int err = 0, i;
    char  pwd[] = "pwd";
    pipe( pip);
    if( fork() == 0) {
	close( pip[ STD_IN]);
	close( STD_OUT);
	dup( pip[ STD_OUT]);
	close( pip[ STD_OUT]);
	err = execlp( pwd, pwd, 0);
	quit( err);                     /* fehler */
	}
    else {
	close( pip[ STD_OUT]);
	i = read( pip[ STD_IN], pth, MAXPATH);
	pth[i - 1] = 0;                 /* the newline char must be cut */
	}
    close( pip[ STD_IN]);
    wait( &err);

#else

    getcwd( pth, MAXPATH);

#endif

    return( pth);
    }

void get_path( struct win_t * w) {

#ifdef DOS
    change_begin_at(w);
    w->drive = getdisk();
#endif

    getpath( w->path);
    }

char get_modechar (struct win_t * w, struct stat * f_st)
{
  char c;
  int  m = f_st->st_mode;

  if( S_ISREG( m))
    {
      if( C_X( f_st->st_uid, f_st->st_gid, m)) c = '*';
      else c = ' ';
    }
  else if( S_ISDIR ( m)) c = '/';
  else if( S_ISBLK ( m)) c = 'b';
  else if( S_ISCHR ( m)) c = 'c';
  else if( S_ISFIFO( m)) c = 'p';
  else if( S_ISNAM ( m)) c = 's';
  else if( S_ISLNK ( m)) c = 'l';
  else c = '?';

  return c;

}
