/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: dostern.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/dostern.c,v $
 */

#define GLOBAL	extern
#define EXTERN

#include <stdio.h>
#include <stdlib.h>

#include "dodefs.h"
#include "doglobal.h"
#include "doframe.h"
#include "doscr.h"
#include "dostring.h"
#include "dolib.h"
#include "docfg.h"
#include "dostern.h"

#ifdef UNIX
int Random (int range) 

{
	return rand() % range;
	}
#else
#define Random random
#endif

#define STARS 		30
#define DELAY1		200
#define DELAY2  	400

#ifdef DOS
#	define	BIG_STERN	15
#else
#	define BIG_STERN	'+'
#endif

#define TOGETHER	3

void Scr_stern ( void) 
{
  struct frame_t * f, * big_star = NULL;
  int xx[ STARS],
      yy[ STARS];
  int i,
	j,
	l,
	old_fx = clock_f->x,
	old_fy = clock_f->y,
	old_x  = cur_x,
	old_y  = cur_y,
	begin = FALSE,
	old_cur_hidden = cur_hidden;

  if( MY_cfg.stern_active) return;
  
  MY_cfg.stern_active = TRUE;
  
  XDEBUG3 ("[stern in] old_x=[%i], old_y=[%i]\n", old_fx, old_fy);
  
  f = make_frame (0, 0, max_x, max_y, leer, leer,
		  F_B_GROUND_CLR,
		  NOBOX_MODE);
  
  clrscr_   ();
  view_frame( f);
  
  hide_cursor();
  
  for ( i=0; i<STARS; i++) 
    {
      xx[i] = Random( max_x-1);
      yy[i] = Random( max_y-1);
      f_putch( f, xx[i], yy[i], '.', f->color, SCR_MODE);
    }
  
  for( l=0; l<TOGETHER; l++)
    f_putch( f, xx[0+l], yy[0+l], ' ', f->color, SCR_MODE);
  
  for( i = 0, j = 1;
      getkey( 1) == -1;
      i = (i+1) % (STARS-TOGETHER), j = (j+1) % (STARS-TOGETHER)
      ) 
    {
      xx[i] = Random( max_x-1);
      yy[i] = Random( max_y  );
      
      for( l=0; l<TOGETHER; l++) 
	{
	  f_putch( f, xx[l+i], yy[l+i], '.', f->color, SCR_MODE);
	}
      fflush_();
      delay  ( DELAY1);
      
      for( l=0; l<TOGETHER; l++)
	f_putch( f,
		xx[l+j],
		yy[l+j], 
		(char) (Random(2) ? BIG_STERN : '*'),
		f->color, 
		SCR_MODE);
      fflush_();
      sleep (1); /*	delay(DELAY2); */
      
      for( l=0; l<TOGETHER; l++)
	f_putch ( f, xx[l+j], yy[l+j], ' ', f->color, SCR_MODE);
      fflush_();
      
      if( Random( 5) == 0) 
	{
	  big_star = make_frame( Random( max_x-4),
				Random( max_y-4),
				3, 3,
				leer, leer,
				f->color,
				NOBOX_MODE);
	  f_putch ( big_star, 1, 0,  ':' , big_star->color, SCR_MODE);
	  f_putstr( big_star, 0, 1, "-*-", big_star->color, SCR_MODE);
#ifdef DOS
	  f_putch ( big_star, 1, 1, BIG_STERN, big_star->color, SCR_MODE);
#endif
	  f_putch ( big_star, 1, 2,  ':' , big_star->color, SCR_MODE);
	  view_frame( big_star);
	  fflush_();
	  
	  sleep (1) ; /*	    delay( DELAY2); */
	  hide_frame( big_star, HIDE_MODE|DELETE_MODE);
	  big_star = NULL;
	}
      
      hide_frame( clock_f, HIDE_MODE);
      f_changeXY( clock_f, Random(max_x-23), Random(max_y-1) );
      view_frame( clock_f );
      fflush_();
    }
  
  hide_frame( f, DELETE_MODE|HIDE_MODE);
  
  if( big_star != NULL) hide_frame( big_star, HIDE_MODE|DELETE_MODE);
  
  XDEBUG3 ("[stern vor f_changeXY] old_x=[%i], old_y=[%i]\n", old_fx, old_fy);
  
  hide_frame ( clock_f, HIDE_MODE);
  f_changeXY ( clock_f, old_fx, old_fy );
  view_frame ( clock_f);
  
  if( ! old_cur_hidden) view_cursor();
  
  XDEBUG3 ("[stern nach f_changeXY] old_x=[%i], old_y=[%i]\n", old_fx, old_fy);
  
  gotoXY( old_x, old_y);
  fflush_();
  
  MY_cfg.stern_active = FALSE;
}








