/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: dostring.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/dostring.c,v $
 */

#define GLOBAL extern
#define EXTERN

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/timeb.h>

#ifdef DOS
#include <ctype.h>
#include <conio.h>
#endif

#include "dodefs.h"
#include "doglobal.h"
#include "dostern.h"
#include "doscr.h"
#include "doutil.h"
#include "dostern.h"
#include "docfg.h"
#include "dostring.h"
#include "dolib.h"
#include "dotcap.h"
#include "docfg.h"
#include "dohist.h"

char ch_lowercase( char c)
{
  char l = c;
  if( c >= 'A' && c <= 'Z') l = 'a' + c - 'A';
  /*
  else
    switch( c)
      {
      case '': l = ''; break;
      case '*': l = '*'; break;
      case '*': l = '*'; break;
      case '*': l = '*'; break;
      }
  */
  return( l);
}

void lowercase( char * str)
{
  int i;
  for( i=0; str[i] != 0; i++) str[i] = ch_lowercase (str[i]);
}

int is_lowercase( char c)
{
  if( c >= 'a' && c <= 'z' ||
     c == '' ||
     c == '' ||
     c == ''
     ) return( TRUE);
  return( FALSE);
}

int is_uppercase( char c)
{
  if( c >= 'A' && c <= 'Z' ||
     c == '' ||
     c == '' ||
     c == ''
     ) return( TRUE);
  return( FALSE);
}

char ch_uppercase( char c)
{
  char u = c;
  if( c >= 'a' && c <= 'z') u = 'A' + c - 'a';
  /*
  else
    switch( c)
      {
      case '*': u = '*'; break;
      case '*': u = '*'; break;
      case '*': u = '*'; break;
      case '*': u = '*'; break;
      }
  */
  return( u);
}

void uppercase( char * str)
{
  char * p;
  for( p=str; *p != 0; p++) *p = ch_uppercase( *p);
}

int ishexa( int ch)
{
  return (ch >= '0' && ch <= '9') ||
	 (ch >= 'A' && ch <= 'F') ||
	 (ch >= 'a' && ch <= 'f')
	 ? TRUE
	 : FALSE;
}

int isdecimal( int ch)
{
  return( (ch >= '0' && ch <= '9') ? TRUE : FALSE);
}

GLOBAL int is_ascii( int ch)
{
  return (ch < 32 || ch > 127) ? 0 : 1;
/*    return (isascii ((unsigned char) ch & 0xff) && ch >= 32) ? 1 : 0 ;*/
}

void setattr( int attr)
{
#ifdef UNIX
  unsigned int n_gra, n_for, n_bac;
  unsigned int o_gra, o_for, o_bac;
  int set_gr = FALSE;

  if (attr == aktattr) return;	/* same color and attribute */

  n_gra = min (clr_cnt-1, attr & GRAPH_MODE);	/* new graphic mode */
  n_for = min (clr_cnt-1, attr & 0x00FF);	/* forgrnd color */
  n_bac = min (clr_cnt-1, (attr & ~GRAPH_MODE) >> 8); /* new backgrnd */

  o_gra = min (clr_cnt-1, aktattr & GRAPH_MODE); /* old graphic color */
  o_for = min (clr_cnt-1, aktattr & 0x00FF);     /* old forgrnd color */
  o_bac = min (clr_cnt-1, (aktattr & ~GRAPH_MODE) >> 8); /* old backgrnd */

  /* graphic off */
  if( n_gra == 0 && o_gra != 0)
    {
      put_str( DESINIT_LINE);
      set_gr = TRUE;
    }
						/* if graph then on */
  if( n_gra != 0 && o_gra == 0)
    {
      put_str( INIT_LINE);
      set_gr = TRUE;
    }
  if( n_for != o_for || set_gr)
    {
      put_str( etc_colors[o_for].f_clr_off);  /* forgrnd old color off */
      put_str( etc_colors[n_for].f_clr_on );          /* forgrnd color */
    }
  if( n_bac != o_bac || set_gr)
    {
      put_str( etc_colors[o_bac].b_clr_off);  /* bckgrnd old color off*/
      put_str( etc_colors[n_bac].b_clr_on );  /* bckgrnd color */
    }
#endif
  aktattr = attr;
}

					     /* direct output to the screen */
#ifdef UNIX
void out_ch( char c, int attr)
{
  setattr (attr);
  if ((cur_x  > max_x || cur_y  > max_y) ||
      (cur_x == max_x && cur_y == cur_y)
     )
    return;
  if (attr & GRAPH_MODE) put_str (gr_char[ c]);
  else                   put_char( c);
}
#endif

void c_putstr( char * str, int attr)
{
  int i;
  for( i=0; str[i] != 0; i++ ) c_putch( str[i], attr);
}

void c_putchxy( int x, int y, char c, int attr) {
  gotoxy_( x, y);
  c_putch( c, attr);
}

#if 0
extern char * tgoto(char *, int, int);
#endif
void c_putch( char c, int attr)
{
#ifdef UNIX
  int pos = cur_x + cur_y * max_x;
  if( out_all                   ||      /* out all */
     screen_chr [ pos] != c    ||      /* out only the difference */
     screen_attr[ pos] != attr  )
    {

      screen_chr [ pos] = c;	/* the buffer for frame constraction */
      screen_attr[ pos] = attr;

					 /* true position of cursor */
			/* tgoto only call, when it is a big difference */
			/* between out_x and cur_x,  */
			/* otherwise out the characters to the position */
      if (cur_x != out_x || cur_y != out_y)
	{
	  if (cur_y != out_y ||
	      cur_x < out_x  ||
	      cur_x-out_x > 4
	      )
	    {
	      put_str (tgoto(ETC_cm,cur_x,cur_y));
	    }
	  else
	    {
	      int pos_;
	      for( pos_ = out_x+cur_y*max_x;
		  out_x != cur_x;
		  pos_++, out_x++) {
		out_ch( screen_chr[pos_], screen_attr[pos_]);
	      }
	    }
	}

      out_ch (c, attr);	/* out to the screen */

      cur_x++;

      out_x = cur_x;
      out_y = cur_y;
    }
  else
    {				            /* save the coordinates */
      cur_x++;
    }
#else
  attr = (attr & 0x000f) | ((attr & 0x0f00) >> 4);
  scr_mem [cur_x+cur_y*max_x] = (int) (attr << 8) | ( c & 0xff);
  cur_x = min(max_x-1, cur_x+1);
#endif

}

				   /* TRUE gotoxy */
void gotoXY (int x, int y)
{
#ifdef UNIX
  put_str( tgoto(ETC_cm,x,y));	/* unix */
#else
  gotoxy(x+1, y+1);				/* dos */
#endif
  cur_x=out_x=x, cur_y=out_y=y;
}

				   /* you don't goto XY if not neccessary */
void gotoxy_( int x, int y)
{
  cur_x=x, cur_y=y;
}

void put_char( char c)
{
#ifdef UNIX
  putchar( c);
#else
  putch( c);
#endif
}

void put_str( char * str)
{
  char * p;
  if( str != NULL) for( p=str; *p != 0; p++) put_char( *p);
}

void fflush_( void)
{

#ifdef UNIX
  fflush( stdout);
#endif
}

/**** fill the string 'str' with the char 'ch' to 'len' ***/

void fillstr( char * str, int len, char ch)
{
  int i;
  for( i=0; i<len; i++) str[ i] = ch;
}

/** print the char 'c' n-count on the screen ****/

void prn_char( char c, int n, int attr)
{
  int i;
  for( i=n; i > 0; i--) c_putch( c, attr);
}

/** print the string 'str' n-count on the screen with the current mode ****/

void prn_nchar( char * str, int n, char fill_ch, int attr, int mode)
{
    /* FILL_MODE : fill to end of length with fill_ch */

  unsigned char c;
  int i = 0,
  j = strlen( str);
  while( i < n)
    {
      if( i < j)
	{
	  c = str[i];
	  c_putch( (char) ( c >= 32 ? c : ( c == TAB ? ' ' : '.')), attr);
	}
      /** rest filled with fill_ch **/
      else if( mode & FILL_MODE) c_putch( fill_ch, attr);
      else break; 		      /** only to end of string **/
      i++;
    }
}

void fprn_nchar( char * dest, char * str, int n, int width, char fill_ch)
{
    int i,  w;
    for(w=i=0; w<width; w++)
{
	 if( i<n && str[i] != 0) dest[w] = str[i], i++;
	 else dest[w] = fill_ch;
	 }
    dest[w] = 0;
    }

#ifdef UNIX
/**** convert the ESCAPE-SEQUENCES in the String 'str' in current values ***/
void esc_filter( char * str)
{
	char * q, *p, * s;
	int i;
	for (p=s=str; *p != 0; )
{
	    if( *p == '^')
{
		* s++ = tolower (*p) - 'a';
		p += 2;
		}
	    else if( *p ==  '\\')
{
		q = p + 1;
		     if( *q =='E') *s = 27;
		else if( *q =='e') *s = 27;
		else if( *q =='r') *s = 13;
		else if( *q =='n') *s = 10;
		else if( *q =='t') *s = 9;
		else if( *q =='b') *s = 8;
		else if( *q =='\\') *s = '\\';
		else if( *q >= '0' && *q <= '9')
{
		    for (i=0, *s=0;
			 i < 3 && *q >= '0' && *q <= '9';
			 q++, i++
			)
{
		       *s = ( *s << 3) + ( *q - '0');
		       }
		    q--;
		    }
		else *s = *p;
		p = q + 1;
		s++;
		}
	    else *s++ = *p++;
	    }
	*s = 0;
	}
#endif

int get_str( struct frame_t * f,
	     int f_x,
	     int f_y,
	     char * str, 	/* string */
	     int len, 		/* length of string */
	     int width, 	/* length of input */
	     char fill_ch, 	/* fill-char for the rest of input */
	     int ( * getfromlist)  ( char *),
	     int color,
	     int mode)
{	/* mode */

  /* mode = ASC_MODE only ascii-char. are enabled */
  /* mode = CUR_MODE the move-keys are enabled */
  /* mode = COM_MODE insert command line on the stack */
  /* mode = HIST_MODE use PAGE/CUR for history **/
  /* mode = FIL_MODE print the aktuall file name in the string */
  /* mode = INS_MODE Ins-Mode aktiviting with F3 */
  /* mode = BREAK_MODE break by pressed CUR_DOWN | CUR_UP | TAB | BACK_TAB */
  /* mode = NOWAIT_MODE don't wait for input also print the string and  ***/
  /* mode = TYPE_INT  type of string is INTEGER */
  /* mode = TYPE_HEXA type of string is HEXA */
  /*                    terminate *****/

  struct win_t * w = WIN;
  int
    pos = (mode&TYPE_STRING) ? strlen( str) : 0,
    j,
    i,
    ll,
    fnd        = FALSE,
    x          = ( f==NULL) ? cur_x : f->x + f_x,
    y          = ( f==NULL) ? cur_y : f->y + f_y,
    refr       = TRUE,
    first      = TRUE,
    first_key  = TRUE,
    first_call = TRUE,
    fac        = (mode&TYPE_STRING) ? min( 6, width / 2) : 0,
    beg        = max(  pos - width + fac, 0),
    lk         = -1,
    o_lk,		/* the old key for ESC key **/
    k,
    end_ = FALSE;
  char * q;

  width = min( width, max_x-x-1);     /* input max. to end of window */

  while( TRUE)
    {

      /* out the string only **/
      if( mode & NOWAIT_MODE) end_ = TRUE;
      if( mode & HIST_MODE  ) com_akt = last_com();	/* set the aktuell commando **/

      while( TRUE)
	{

	  /******/
	  if( pos > ( width+beg-fac)) beg = max(0, pos-width+fac);

	  if( pos < ( beg+fac)      ) beg = max(0, pos - fac);

	  if( refr) refr  = FALSE;

	  if( f == NULL)
	    {
	      gotoxy_( x, y);
	      prn_nchar( str+beg, width, fill_ch, color, FILL_MODE);
	    }
	  else
	    {
	      f_fillnstr( f, f_x,
			 f_y,
			 str+beg,
			 width,
			 fill_ch,
			 color,
			 SCR_MODE);
	    }

	  if( first_call && ! end_)
	    {
	      if( f == NULL)
		{
		  gotoxy_( x, y);
		  prn_nchar( str+beg, strlen(str+beg), fill_ch,
			    F_B_INPUT_CHS, FILL_MODE);
		}
	      else
		{
		  f_fillnstr( f, f_x,
			     f_y,
			     str+beg,
			     strlen( str+beg),
			     fill_ch,
			     F_B_INPUT_CHS,
			     SCR_MODE);
		}
	    }

	  gotoXY( x+pos-beg, y);
	  /******/

	  if( end_) break;

	  if( ! first_call) first_key = FALSE; /* do not delete string*/
	  first_call = FALSE;			 /* first call is false */

	  view_cursor();
	  lk = getkey(-1);
	  /* simulate tastes, if mouse clicked */
	  
	  switch( lk) 
	    {
	    case BACKSPACE:
	      if( pos == 0) continue;
	      j = ( --pos);
	      while( str[j+1]) str[j] = str[j+1], j++;
	      str[j] = 0;
	      break;
	    case DELETE:
	    case REMOVE:
	    case CTRL_D:
	      ll = strlen( str);
	      if( pos >= ll) continue;
	      for( j=pos; j<ll; j++) str[j] = str[j+1];
	      break;
	    case CTRL_M:
	    case ENTER:
	      /* save command in history */
	      if( ( mode & COM_MODE) && strlen( str) > 0) insert_com( str);
	      end_ = TRUE;
	      break;
	    case ESC:
	      
	      /** with this mode can you expecte aktual file name in **/
	      /** the string, wenn the FIL_MODE is set **/
	      
	      end_ = TRUE;
	      break;
	      
	    case CTRL_F:
	    case TAB:
	      
	      if( ! (mode & CUR_MODE)) 
		{ end_ = TRUE; break; }
	      if( ! (mode & FIL_MODE)) break;
	      
	      q  = AKT_FILE( w);
	      ll = strlen( str);
	      
	      if( lk == CTRL_F)
		str[pos++] = '.',
		str[pos++] = root;
	      for( i=0; pos < len && q[i] != 0; i++, pos++)
		str[ pos] = q[i];
	      if( pos >= ll) str[ pos] = 0;  /* terminat with \0, if length bigger */
	      break;
	      
	    case CTRL_W:
	      
	      if( ! (mode & CUR_MODE))
		{ end_ = TRUE; break; }
	      
	      fnd = FALSE;
	      while( str[pos] != 0) 
		{
		  if( str[pos] == ' ') 
		    { fnd = TRUE, pos++; }
		  else 
		    { if( fnd) break; pos++; }
		}
	      break;
	      
	    case CTRL_T:
	      
	      if( ! (mode & FIL_MODE)) 
		{
		  end_ = TRUE; break;
		}
	      
	      fnd = FALSE;
	      j = pos;
	      while( pos > 0) 
		{
		  if( str[pos] == ' ') 
		    { 
		      if( fnd) 
			{ pos++; break; }
		      pos--; 
		    }
		  else 
		    { 
		      if( j != pos) fnd = TRUE;
		      pos--; 
		    }
		}
	      break;
	      
	    case CTRL_R: 
	      {
		char * p = str+pos, 
		* q = p;
		
		if( ! (mode & FIL_MODE)) 
		  { end_ = TRUE; break; }
		
		while( *q && *q == ' ') q++;	/* jump the spaces */
		while( *q && *q != ' ') q++;	/* jump to end of word */
		while( *q && *q == ' ') q++;	/* jump the spaces */
		while( *q) *p++ = *q++;         /* slide the rest of string */
		*p = 0;
	      }
	      break;
	      
	    default:
	      if (! is_ascii( lk))  break;
	      if ((mode & TYPE_INT ) &&
		  ! isdecimal( lk)   &&
		  ! (pos == 0 && (lk != '-' || lk != '+')) /* +/- at 1. pos.*/
		  ) break;
	      if ((mode & TYPE_HEXA) && ! ishexa (lk)) break;
	      
	      if( first_key) 
		{
		  for( i=0; str[i] != 0; i++) str[i] = 0; /* delete old string */
		  pos    = 0;
		}
	      
	      if (pos >= len) continue;
	      
	      ll = strlen( str);
	      
	      if (ins_mode && 
		  ! ((mode & TYPE_INT) && 
		     pos == 0 &&
		     (str [0] == '-' || str [0] == '+')
		     )
		  )
		{			/* Insert Mode */
		  if( ll >= len) continue;	/* total length of str*/
		  for( j=ll+1; j>pos; j--) str[j] = str[j-1];
		}
	      else if (pos >= ll) str [pos+1] = 0; /* terminat with \0 */

	      str [pos++] = lk;
	      break;
	    }
	  
	  if( mode & BREAK_MODE) 
	    switch( lk) 
	      {
	      case CUR_UP:
	      case CUR_DOWN:
	      case TAB:
	      case BACK_TAB:
		end_ = TRUE;
		break;
	      }
	  
	  if( ! is_ascii( lk)        			&&
	     lk != BACKSPACE 				&& 
	     ! ( mode & CUR_MODE) 			&&
	     ! ( lk == ESC && ( mode & FIL_MODE))
             ) break;
	  
	  if( (mode & CUR_MODE) && ! end_)
	    {
	      switch( lk) 
		{
		case CUR_LEFT:
		  if( pos == 0) continue;
		  pos--;
		  break;
		case CUR_RIGHT:
		  if( pos >= strlen( str)) continue;
		  pos++;
		  break;
		case CUR_UP:
		  if( !( mode & HIST_MODE)) continue;
		  if( com_akt == com_l) continue;	 /* first command */
		  if( ! first && com_akt->prev != com_l) com_akt = com_akt->prev;
		  strcpy( str, com_akt->com);
		  pos = min( pos, strlen(str) );
		  refr  = TRUE;
		  first = FALSE;
		  break;
		case CUR_DOWN:
		  if( !( mode & HIST_MODE)) continue;
		  if( com_akt->next == NULL) continue;
		  com_akt = com_akt->next;
		  strcpy( str, com_akt->com);
		  pos = min( pos, strlen(str) );
		  refr = TRUE;
		  break;
		case HOME:
		  if( pos == 0) continue;
		  pos = beg = 0;
		  break;
		case END:
		  if( pos >= ( j = strlen( str))) continue;
		  pos = strlen( str);
		  continue;
		case F3:
		case INSERT:
		  if( ! mode & INS_MODE) break;
		  ins_mode = ( ins_mode ? FALSE : TRUE);
		  ins_help_line( VIEW_INS_MODE);
		  break;

		case PAGE_UP:
		case PAGE_DOWN:

		  if( ! (mode & HIST_MODE) ) break; /* get command from history */

		  if( getfromlist == NULL) continue;
		  if( ! getfromlist( str)) continue;
		  pos = strlen(str);
		  refr = TRUE;
		  break;

		default:
		  break;
		} /* switch */
	    } /* if mode & CUR_MODE */

	} /* while 2 */
      break;
    } /* while 1 */
  return( lk);
}			/* get_str */

int get_strxy( struct win_t * w,
	      int x, int y, char * str, int len, int width,
	      char * t1, char * t2, int mode)
{
  struct frame_t * f, * hlp_f;
  int lk, i = 0;
  char
     hlp[] = "C-Up#C-Dn#C-Rt#C-Lf#P-Up#P-Dn#HOME#END#Ins#Tab#Ctr-F";
  y     = min( y, max_y-5);   /* current coordinates */
  width = min( max_x-x-1, width), 		 /* width */

  f = make_frame (x,
		  y,
		  width,
		  3,
		  t1,
		  t2,
		  F_B_NORMAL,
		  NOMODE);

  hlp_f = make_help( hlp, 0, max_y-1, max_x-10);

  view_frame( hlp_f);
  view_frame( f);

  gotoxy_( x+1, y+1);

  lk = get_str (f, 1, 1, str, len, width-2, ' ', get_com, F_B_INPUT_CLR,
		mode|TYPE_STRING);

  hide_frame( f,     HIDE_MODE | DELETE_MODE);
  hide_frame( hlp_f, HIDE_MODE | DELETE_MODE);

  return( lk);
}

int begins( char * str, char * cmp)
{
  char * p = str, * q = cmp;
  if (strlen( str) < strlen( cmp)) return( strcmp( str, cmp));
  while (*q) if( *q++ != *p++) return( strcmp( str, cmp));
  return 0;
}

#ifdef UNIX
int key_begins( char * str, int pos)
{
  char
    * p   = str,
    * cmp = etc_keys[pos].esc_seq,
    * q   = cmp;

  if (strlen (cmp) < strlen (str)) return strcmp (str, cmp);
  while (*p) if (*q++ != *p++)     return strcmp (str, cmp);

  return 0;		/* String begins with "str" */
}
#endif

void strncpy_( char * s1, char *s2, int n, int mode)
{
	/** mode = TE_NULL: Add an terminate NULL at last of the string */
	/** otherwise no NULL is expected **/

  char * q= s1, * p = s2;
  while( n-- > 0 && *p) *q++ = *p++;
  if( mode & TE_NULL) *q = 0;
}

void nstrcpy( char * s1, char * s2, int n)
{
  char * q= s1, * p = s2;
  while( n > 0) n--, *q++ = ( *p ? *p++ : ' ');
  *q = 0;
}

int keyhit( void)
{
  return getkey( 1) != -1 ? TRUE : FALSE;
}

#ifdef UNIX

#define LENGTH	16

int getkey( int outtime )
{
  unsigned char k[ LENGTH];
  unsigned char c;
  struct timeb tm;
  long begining;
  time_t know, stern_time = time( NULL);
  int i,
  j,
  len,
  k_pos = 0,
  lk;

  if( outtime >= 0)
    {
#ifdef HAVE_TIME
      ftime( &tm);
      begining = tm.time;
#else
      begining = time (NULL);
#endif
    }
  
  for( k[0] = 0; TRUE; ) 		/* ask for one key */
    {
      
      fflush_();
      
      know = time( NULL);
      
      if( abs(know - akt_time) >= timeout) 	/* out the time/date */
	{
	  akt_time = know;
	  clock_( clock_mode);
	  get_mail();		/* lock for electric */
	}

      /* if timeout for Stars*/
      if (MY_cfg.stern_timeout > 0 && 
	  abs(know - stern_time) >= MY_cfg.stern_timeout)
	{
	  Scr_stern();
	  stern_time = time (NULL);	/* reset timeout */
	}

      /* time out for input waiting */
      if( k[0] == 0 && outtime >= 0) 
	{
#ifdef HAVE_FTIME
	  ftime( &tm);
	  if (tm.time - begining > outtime)
	    return( -1);
#else
	  if (time(NULL) - begining > outtime)
	    return( -1);
#endif
	}
      
#ifndef MOUSE
      if( mouse_mode == FALSE) len = read( STD_IN, &c, 1); /* read one char. */
#else
      else 
	{
	  ms_x = ( int) ms_xf;		            /* mouse position */
	  ms_y = ( int) ms_yf;	                    /* mouse position */
	  scr_pos = ( ms_y - 1) * 160
	    	    + ( ms_x - 1) * 2
		    + 1; 	    		 /* scr_pos. **/
	  					 /* restore  old scr. value **/
	  if( scr_mem[ o_scr_pos] == ~ o_scr_val)
	    scr_mem[ o_scr_pos] = o_scr_val;  
	  o_scr_val         = scr_mem[ scr_pos];     /* save current value */
	  scr_mem [scr_pos] = ~scr_mem[ scr_pos]; 
					             /* invert scr.value */
	  o_scr_pos         = scr_pos;		     /* save akt. position */
	  
	  /*
	   * you must simulate the klick down and klick up
	   * for this action need you this test to delete 
	   * the last even
	   */
	  if( ( ev != NULL) && ms_klick) 
	    {
	      if( firsttime == TRUE) 
		{ 
		  unsigned int ms = 0;
		  for( i=0; i<10 && ev_count(); i++) delay( ms_wait);
		  firsttime = FALSE;
		}
	      ev->un.loc.rel.dx = 0;
	      ev->un.loc.rel.dy = 0;
	    }
	  else firsttime = TRUE;
	  
	  if( (ev_count() == 1) && ms_klick == FALSE || ev_count() > 1) 
	    ev_pop();
	  /**/
	  ev_block();		           /* wait for event **/
	  ev = ev_read();	           /* read event **/
	  
	  if( ev != NULL) 
	    {		
	      /* mouse moving or BUTTON pressed */
	      if( ev->tag & D_REL || ev->tag & D_BUTTON ) 
		{	
		  ms_xf = max( 1.0,  
			      min( 80.0, ms_xf + (float) ev->un.loc.rel.dx *
				  ( 1.0 - 0.7))
			      );
		  ms_yf = max( 1.0, 
			      min( 25.0, ms_yf - (float) ev->un.loc.rel.dy *
				  ( 1.0 - 0.7))
			      );
		  switch( ev->u1.buttons) 
		    {
		    case LT_BUTTON: c = LT_KLICK; break;
		    case RT_BUTTON: c = RT_KLICK; break;
		    case MD_BUTTON: c = MD_KLICK; break;
		    default:	   c = FALSE; break;
		    }
		  
		  /* receive doppel click **/
		  if( (unsigned) (ev->timestamp - o_timestep) <= 
		     ms_timeout &&
		     o_ms_x == ms_x && 
		     o_ms_y == ms_y &&
		     ms_klick == FALSE &&
		     o_klick == c) 
		    {
		      switch( o_klick) 
			{
			case LT_KLICK: c = LT_D_KLICK; break;
			case RT_KLICK: c = RT_D_KLICK; break;
			case MD_KLICK: c = MD_D_KLICK; break;
			}
		    }
		  o_timestep = ev->timestamp;
		  ms_klick   = c;
		  if( c != FALSE) 
		    {
		      o_klick = c;
		      o_ms_x = ms_x;
		      o_ms_y = ms_y;
		      return( c);
		    }
		  continue;
		}
	      
	      /* input from keyboard */
	      for( i=0; i < 3; i++) k[ i] = ev->un.buf[ i];
	      k[ i] = 0;
	    }
	  else continue;
	}
#endif			/* MOUSE */
      
      if( mouse_mode == FALSE) 
	{
	  
	  if (len <= 0) continue;  /* nothing inputed */
	  
	  k [k_pos++] = c;
	  k [k_pos  ] = 0;
	  
	  if ( k_pos >= LENGTH || k_pos > max_key_len) /* input error */
	    {
	      clearinput();
	      lk = -1;
	      break;
	    }
	  
	}
      else if( (unsigned char) k[ 0] != ESC) 
	{
	  lk = k[0];
	  break;
	}

      i = KHA_search( k, 0, etc_key_cnt, key_begins);

      if( i >= 0)
	{
	  if (strcmp(etc_keys[i].esc_seq, k) != 0) continue;
	  lk = etc_keys[i].num;		/* key number from the key list */
	  break;
	}
      else if( strlen (k) == 1)
	{
	  lk = (int) k[0];
	  break;
	}
      else if (strlen( k) > 0) 		/* input error */
	{
	  clearinput();
	  lk = -1;
	  break;
	}
    }  /* while( true) ***/

  return( lk);				/* return the found key or -1 */
} /* getkey */

#else			/* for MSDOS */

void view_mem (void)
{
  static struct frame_t * ff = NULL;
  char * tmp [601];
  char str [60];
  int i, to = 600;
  long size ;

  if (ff == NULL) ff = make_frame (0, 18, 40, 3,
			      leer, leer,
			      F_B_NORMAL,
			      NOMODE);
  for (i=0; i<to; i++) tmp [i] = NULL;
  for (i=0; i<to; i++)
    {
      tmp [i] = malloc (1024) ;
      if (tmp [i] == NULL) break ;
    }
  size = (long) i * 1024 ;
  for (i=0; tmp [i] != NULL && i < to; i++) Free (tmp [i]);

  sprintf    (str, "Memory: %li", size);
  f_putstr   (ff, 1, 1, str, ff->color, FILL_MODE);
  view_frame (ff);
}

int getkey( int outtime)
{
  struct timeb tm;
  time_t know, stern_time = time( NULL);
  int ch, lastkey;

#ifdef MOUSE
  int
    but,                       /* mouse button */
    x = 0,
    y = 0,
    old_x = 0,
    old_y = 0,
    old_val = scr_mem[0],
    val_inv = (old_val & 0x00ff) | ((~old_val) & 0x7f00);
#endif

  if (stern_time == 0) stern_time = time( NULL);

/*
  view_mem ();
*/

  while( TRUE)
    {
      if( ! kbhit())
	{
	  know = time( NULL);
	  if( abs(know - akt_time) >= timeout)
	    {
	      clock_( clock_mode);
	      akt_time = know;
	    }

	  if( abs(know - stern_time) >= MY_cfg.stern_timeout)
	    {
	      Scr_stern();
	      stern_time = time( NULL);
	    }

	  if( outtime >= 0 &&
	     abs(time( NULL) - akt_time) >= outtime)
	    {
	      return -1;
	    }

#ifdef MOUSE
	  if( old_x != x || old_y != y) 
	    {
	      if( scr_mem[old_x+old_y*max_x] == val_inv)
		scr_mem[old_x+old_y*max_x] = old_val;
	      old_val = scr_mem[x+y*max_x];
	      val_inv = (old_val & 0x00ff) | ((~old_val) & 0x7f00);
	      scr_mem[x+y*max_x] = val_inv;
	      old_x = x;
	      old_y = y;
	    }
	  but = M_getevent( &x, &y); /* get event */
#endif
	}
      else 
	{
	  ch = getch();
	  stern_time = time( NULL);
	  break;
	}
    }
#ifdef MOUSE
  if( scr_mem[old_x+old_y*max_x] == val_inv)
    scr_mem[old_x+old_y*max_x] = old_val;
#endif
  
  if ( ch) 
    {
      lastkey = ch;
    }
  else 
    {
      ch = getch();
      switch ( ch )
	{
	case 15 : lastkey = BACK_TAB;  break;
	case 17 : lastkey = ALT_W;  break;
	case 18 : lastkey = ALT_E;  break;
	case 19 : lastkey = ALT_R;  break;
	case 20 : lastkey = ALT_T;  break;
	case 44 : lastkey = ALT_Z;  break;
	case 22 : lastkey = ALT_U;  break;
	case 23 : lastkey = ALT_I;  break;
	case 24 : lastkey = ALT_O;  break;
	case 25 : lastkey = ALT_P;  break;
	case 30 : lastkey = ALT_A;  break;
	case 31 : lastkey = ALT_S;  break;
	case 32 : lastkey = ALT_D;  break;
	case 33 : lastkey = ALT_F;  break;
	case 34 : lastkey = ALT_G;  break;
	case 35 : lastkey = ALT_H;  break;
	case 36 : lastkey = ALT_J;  break;
	case 37 : lastkey = ALT_K;  break;
	case 38 : lastkey = ALT_L;  break;
	case 21 : lastkey = ALT_Y;  break;
	case 45 : lastkey = ALT_X;  break;
	case 46 : lastkey = ALT_C;  break;
	case 47 : lastkey = ALT_V;  break;
	case 48 : lastkey = ALT_B;  break;
	case 49 : lastkey = ALT_N;  break;
	case 50 : lastkey = ALT_M;  break;
	case 59 : lastkey = F1;  break;
	case 60 : lastkey = F2;  break;
	case 61 : lastkey = F3;  break;
	case 62 : lastkey = F4;  break;
	case 63 : lastkey = F5;  break;
	case 64 : lastkey = F6;  break;
	case 65 : lastkey = F7;  break;
	case 66 : lastkey = F8;  break;
	case 67 : lastkey = F9;  break;
	case 68 : lastkey = F10;  break;
	case 71 : lastkey = HOME;  break;
	case 72 : lastkey = CUR_UP;  break;
	case 73 : lastkey = PAGE_UP;  break;
	case 75 : lastkey = CUR_LEFT;  break;
	case 77 : lastkey = CUR_RIGHT;  break;
	case 79 : lastkey = END;  break;
	case 80 : lastkey = CUR_DOWN;  break;
	case 81 : lastkey = PAGE_DOWN;  break;
	case 82 : lastkey = INSERT;  break;
	case 83 : lastkey = DELETE;  break;
	case 94 : lastkey = CTRL_F1;  break;
	case 95 : lastkey = CTRL_F2;  break;
	case 96 : lastkey = CTRL_F3;  break;
	case 97 : lastkey = CTRL_F4;  break;
	case 98 : lastkey = CTRL_F5;  break;
	case 99 : lastkey = CTRL_F6;  break;
	case 100: lastkey = CTRL_F7;  break;
	case 101: lastkey = CTRL_F8;  break;
	case 102: lastkey = CTRL_F9;  break;
	case 103: lastkey = CTRL_F10;  break;
	case 104: lastkey = ALT_F1;  break;
	case 105: lastkey = ALT_F2;  break;
	case 106: lastkey = ALT_F3;  break;
	case 107: lastkey = ALT_F4;  break;
	case 108: lastkey = ALT_F5;  break;
	case 109: lastkey = ALT_F6;  break;
	case 110: lastkey = ALT_F7;  break;
	case 111: lastkey = ALT_F8;  break;
	case 112: lastkey = ALT_F9;  break;
	case 113: lastkey = ALT_F10;  break;
	case 120: lastkey = ALT_1;  break;
	case 121: lastkey = ALT_2;  break;
	case 122: lastkey = ALT_3;  break;
	case 123: lastkey = ALT_4;  break;
	case 124: lastkey = ALT_5;  break;
	case 125: lastkey = ALT_6;  break;
	case 126: lastkey = 199;  break;
	case 127: lastkey = ALT_7;  break;
	case 128: lastkey = ALT_8;  break;
	case 129: lastkey = ALT_9;  break;
	case 130: lastkey = ALT_0;  break;
	case 131: lastkey = ALT_ ;  break;
	case 115: lastkey = CTRL_CUR_LEFT;  break;
	case 116: lastkey = CTRL_CUR_RIGHT;  break;
	case 117: lastkey = CTRL_END; break;
	case 118: lastkey = CTRL_PAGE_DOWN; break;
	case 119: lastkey = CTRL_HOME; break;
	case 132: lastkey = CTRL_PAGE_UP; break;
	case 133: lastkey = F11;  break;
	case 134: lastkey = F12;  break;
	case 139: lastkey = ALT_F11;  break;
	case 140: lastkey = ALT_F12;  break;
	case 137: lastkey = CTRL_F11;  break;
	case 138: lastkey = CTRL_F12;  break;
	case 146: lastkey = CTRL_INSERT; break;
	case 147: lastkey = CTRL_DELETE; break;
	case 157: lastkey = ALT_CUR_RIGHT;  break;
	case 152: lastkey = ALT_CUR_UP;  break;
	case 160: lastkey = ALT_CUR_DOWN;  break;
	case 155: lastkey = ALT_CUR_LEFT;  break;
	case 141: lastkey = CTRL_CUR_UP;  break;
	case 145: lastkey = CTRL_CUR_DOWN;  break;
	case  16: lastkey = ALT_Q;  break;
	default : lastkey = -1;    break;
	}
    }
  return ( lastkey);
} /* getkey */

#endif

/**** search in string s1, if the s2 specifid in s1 and return the begin  ***/
/**** of the string in s1, else NULL ****/

char * strindex( char * s1, char * s2)
{
  char * p = s1;
  int    l = strlen (s2);
  while (*p) if (strncmp (p, s2, l) == 0) return p; else p++;
  return NULL;
}

int chrindex( char * s1, char * s2)
{
  char * p = s1;
  int    l = strlen (s2);
  while (*p)
    {
      if (strncmp (p, s2, l) == 0)	/* string found */
	return p - s1;
      else
	p++;
    }
  return -1;
}

/*** search the character 'c' in string 's' beginning at the end of string **/

char * b_strchr( char * s, char c)
{
  char * q = s + strlen( s) - 1;
  while( q >= s) if( *q == c) return( q); else q--;
  return( NULL);
}

/*******************************************************************/
/***** Find a pattern of name  (like dos pattern find)     *********/
/*******************************************************************/

int findmatch(char *pat, char *name)
{
  int   match;
  int   ndone;
  char *cpp;
  char *cpn;

  cpp = pat;
  cpn = name;
  match = 1;
  ndone = 1;
  while (ndone)

    {
      switch (*cpp)

	{
	case '*':
	  /* skip to . or end of pat */
	  while (*cpp && *cpp != '.')
	    cpp++;

	  /* skip to . or end of name */
	  while (*cpn && *cpn != '.')
	    cpn++;
	  break;

	case '?':
	  cpp++;
	  cpn++;
	  break;

	case 0:
	  if (*cpn != 0)
	    match = 0;
	  ndone = 0;
	  break;

	default:
	  if (tolower(*cpp) == tolower(*cpn))

	    {
	      cpp++;
	      cpn++;
	    }
	  else

	    {
	      match = 0;
	      ndone = 0;
	    }
	  break;
	}
    }

  return(match);
}


char * dirname( char * str)
{
  static char pth[ MAXPATH+1];
  int i,
  j,
  len = min( MAXPATH, strlen( str));

  for( i = len; i>= 0 && str[i] != root; i--);
  for( j =0; j<i; j++) pth[ j] = str[ j];
  pth[ j] = 0;

  return( pth);
}

char * basename( char * str)
{
  static char base[ MAXPATH+1];
  int i,
  j,
  pos,
  len = min( MAXPATH, strlen( str));

  for( i = len; i>= 0 && str[i] != root; i--);

  for( j=i+1, pos = 0; j<len; j++) base[ pos++] = str[ j];

  base[ pos] = 0;

  return( base);

}







