/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: dostring.h,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/dostring.h,v $
 */

/******************************* character functions *************************/

#ifndef STRING_HH
#	define STRING_HH

#include "doframe.h"
#include "dowin.h"

#define TYPE_STRING     0x1000  /* for f_getstr type is string format */
#define TYPE_LOG        0x2000  /* for f_getstr type is logical format */
#define TYPE_INT        0x4000  /* for f_getstr type is logical format */
#define TYPE_HEXA       0x8000

				 /* convert strings in upper/lower case */
GLOBAL int    is_lowercase ( char   c);
GLOBAL int    is_uppercase ( char   c);

GLOBAL char   ch_lowercase ( char   c);
GLOBAL char   ch_uppercase ( char   c);

GLOBAL void   lowercase    ( char * s);
GLOBAL void   uppercase    ( char * s);

GLOBAL void   strncpy_     ( char * s1, char *s2, int n, int mode);
GLOBAL int    ishexa       ( int ch);
GLOBAL int    isdecimal    ( int ch);
GLOBAL int    is_ascii      ( int ch);
GLOBAL void   setattr      ( int attr);
GLOBAL void   c_putch      ( char c, int attr);
GLOBAL void   c_putchxy    ( int x, int y, char c, int attr);
GLOBAL void   c_putstr     ( char * str, int attr);

GLOBAL void   gotoXY       ( int x, int y);        /* true gotoxy */
GLOBAL void   gotoxy_	    ( int x, int y);	    /* only the coordinates are seting*/

GLOBAL void   fprn_nchar   ( char * dest, char * str, int n, int width, char fill_ch);
GLOBAL void   prn_nchar    ( char * str, int n, char fill_ch, int attr, int mode);
GLOBAL void   prn_char     ( char c, int n, int attr);
GLOBAL void   fillstr      ( char * str, int len, char ch);
GLOBAL void   esc_filter   ( char * );
GLOBAL void   nstrcpy      ( char * s1, char * s2, int n); /*fill the rest with SPACE*/
GLOBAL char * b_strchr     ( char * s, char c);           /* lock for chr. backwords */
GLOBAL char * strindex     ( char * s1, char * s2);
GLOBAL int    chrindex     ( char * s1, char * s2);
GLOBAL int    begins       ( char *, char *);
GLOBAL int    key_begins   ( char *, int pos);  /* exclusive for sort */

GLOBAL void   put_char      ( char c);
GLOBAL void   put_str       ( char * str);
GLOBAL void   fflush_	    ( void);

GLOBAL int    keyhit        ( void);
GLOBAL int    getkey        ( int outtime);
GLOBAL int    get_str       (	struct frame_t * f,
				int f_x,
				int f_y,
				char * str,
				int len,
				int width,
				char fill_ch,
				int ( * getfromlist) ( char *),
				int color,
				int mode);
GLOBAL int    get_strxy     ( struct win_t *w,
		      int x, int y, char * str, int len, int width,
		      char * t1, char * t2, int mode);
GLOBAL int    findmatch(char *pat, char *name);


GLOBAL char * dirname ( char * str);
GLOBAL char * basename( char * str);

#endif /*_HH*/
