/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: dotcap.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/dotcap.c,v $
 */

#ifdef UNIX		/* UNIX ONLY */

#define GLOBAL extern
#define EXTERN

#include <stdlib.h>
#include <stdio.h>

#ifdef UNIX
#include <unistd.h>
#endif

#include <fcntl.h>
#include "dodefs.h"
#include "doglobal.h"
#include "dolib.h"
#include "domem.h"
#include "dostring.h"
#include "dotcap.h"

int tgetline( int file_h , char * line)
{
  return( read_line( file_h, line, 1024));

#ifdef NDEBUG
  fprintf( stderr, line);
#endif
}

char * tgetent1( int file_h, char * tstr, char * term)
{
    long pos, old_pos;
    int  i,
         j,
         len,
         lastline = FALSE,
         tpos;
    char tmp[ 256],
         * tc = ":tc=",
         * tstr1 = tstr,
         * tptr,
         * p,
	 c ;
    
    for( i=0; i<2; i++) 
      {
	/*
	 * search with the character '|' or ':'
	 */
	sprintf( tmp, "%s%c", term, i==0 ? '|' : ':');

#ifdef NDEBUG
	fprintf( stderr, "term|=[%s]\n", tmp);
#endif

	/*
	 * go to the top of file 
	 */
	old_pos = lseek( file_h, 0, SEEK_SET);
	for( ; TRUE; ) 
	  {
	    pos = file_findstr( NULL, file_h, tmp, NOMODE);

	    /*
	     * pos != old_pos <==> pattern is found 
	     */
	    if( pos != old_pos)
	      {
		if( pos == old_pos) { pos = 0; break; }
		lseek( file_h, -1, SEEK_CUR);
		read( file_h, &c, 1);
		/*
		 * vor the string must be one character of the following
		 */
#ifdef NDEBUG
		fprintf( stderr, "pos=[%li], c=[%c], c=[%x]\n", pos, c, c);
#endif
		if( c == '|' || c == ':' || c == '\n') break;
		/*
		 * move one position forwords to continue search
		 */
		old_pos = lseek( file_h, 1, SEEK_CUR);
	      }
	    else break;
	  }
	
#ifdef NDEBUG
	fprintf( stderr, "pos=[%i]\n", pos);
#endif
	if( pos > 0) break;    /* term is founded */
      }

    if( pos == old_pos) return NULL;

    for( tstr1 = tstr; TRUE; )
      {
	len = tgetline( file_h, tstr1);  /* read next line */
#ifdef NDEBUG
	fprintf( stderr, "len=[%i], tstr1=[%s]\n", len, tstr1);
	getchar();
#endif
	if( len <= 0) break;
	tpos = nstrfind( tstr1, tc, len, strlen( tc) );
	/*
	 * last line readed 
	 */
#ifdef NDEBUG
	fprintf( stderr, "tstr1[len-1] = [%c], tstr1[len-2]=[%i]\n",
		tstr1[len-1], tstr1[len-2]);
#endif
	if( tstr1[len-1] != '\\') lastline = TRUE;
	tptr     = tstr1;                  /* if 'tc=' is found */
	tstr1   += len;                    /* inc. the pointer */
        if( tpos > 0) 
	  {
	    /*
	     * get termname from (tc='term') to search
	     */
	    for(i=tpos+3, j=0;
		i<len && tptr[i] != ':';
		i++, j++
		)
	      tmp[j] = tptr[i];
	    
	    tmp[j++] = 0;         /* terminate with \0 */

#ifdef NDEBUG
	    fprintf( stderr, "tptr=[%s], new term=[%s]\n", tptr, tmp);
#endif

	    p = tgetent1( file_h, tstr1, tmp);  /* recursive search */
	    if( p != NULL) tstr1 = p;           /* inc. tstr1 to p */
	  }
	if( lastline) break;                    /* lastline reached */
      }
    return( tstr1);
  }


int MY_tgetent( char * tstr, char * term) 
{
  char * termcap;
  int file_h;
  char * p;
  if ((termcap = getenv( "KHTERMCAP")) == NULL) 
    if ((termcap = getenv ("TERMCAP")) == NULL) 
      {
        termcap = "/etc/termcap";
      }

#ifdef NDEBUG
  printf( "termcap=[%s], term=[%s]\n", termcap, term);
#endif

  file_h = open( termcap, O_RDONLY|O_BINARY);
  if( file_h <= 0) return FALSE;

  p = tgetent1( file_h, tstr, term);

#ifdef NDEBUG
  fprintf( stderr, "%s\n", tstr);
  getchar();
#endif

  close( file_h);
  return p == NULL ? FALSE : TRUE;
}

/**************************************************************************
 * escape-seq to next (':') will be copying in anothor string             *
 **************************************************************************/

#ifdef UNIX

char * esc_cpy ( char * str, char sep) 
{
  char tmp[ 100], 
  * q, 
  * p;
  int i;
  for( q = str, p = tmp; *q != sep; p++, q++) 
    {
      if( * q == '\\') *p++ = *q++;
      * p = * q;
    }
  *p = 0;
  esc_filter (tmp);
  q = getmem (strlen( tmp) + 1);
  strcpy( q, tmp);
  return( q);
}

/***********************************************************************
 * escape sequence from /etc/termcap for current TERM-env 
 ***********************************************************************/

int key_cmp (const int a, const int b) 
{
  return ( strcmp (etc_keys[a].esc_seq, etc_keys[b].esc_seq) );
}

int key_swap (const int a, const int b) 
{
  struct etc_t q = etc_keys[a];
  etc_keys[a]    = etc_keys[b];
  etc_keys[b]    = q;
  return TRUE;
}

#endif /* #ifdef UNIX */

/**************************************************************************
 * reads the TERMCAP-Info from the TERMCAP-file and converts the found
 * sequences in readable strings
 * TERMCAP-Info: Key-Sequences, Attributes and Colors of aktual Terminal
 **************************************************************************/

void get_etc_termcap() 
{
#ifdef UNIX
  int i = 0, j = 0, pos;
  char * q, * p,
  * etc_tcap;
  
  for(clr_cnt=0; etc_colors[clr_cnt].name != NULL; clr_cnt++) 
    {
      etc_colors[clr_cnt].f_clr_on  = leer,
      etc_colors[clr_cnt].f_clr_off = leer,
      etc_colors[clr_cnt].b_clr_on  = leer,
      etc_colors[clr_cnt].b_clr_off = leer;
    }
  
  /* count the keys */
  for (etc_key_cnt=j=0; etc_keys[j].name != NULL; j++) etc_key_cnt++;
  
  etc_tcap = getmem( T_BUFSIZE);     	       /* to load the termcap */
  
  if( X_tgetent( etc_tcap, term) <= 0) 
    {  /* get escseq. from /etc/termcap */
      fprintf( stderr, "%s%s",
	      "termcap in /etc or TERM es not found\n",
	      "Be sure, that the TERM-Env. is current defined\n");
      quit( 1);
    }
  
  XDEBUG1("for etc_keys\n");

  for (i=0; etc_keys[i].name != NULL; i++)
    {
      if( (q = strindex( etc_tcap, etc_keys[i].name)) != NULL) 
	{
	  etc_keys[i].esc_seq =
	    esc_cpy( q + strlen( etc_keys[i].name), ':');
	}
      else if (etc_keys[i].esc_seq == NULL) etc_keys[i].esc_seq = leer;
    }
  
  XDEBUG1("for etc_graph\n");
  
  for (i=0; etc_graph[i].name != NULL; i++) 
    {
      if( (q = strindex( etc_tcap, etc_graph[i].name)) != NULL) 
	{
	  etc_graph[i].esc_seq =
	    esc_cpy( q + strlen( etc_graph[i].name), ':');
	}
      else if (etc_graph[i].esc_seq == NULL) etc_graph[i].esc_seq = leer;
    }
  
  XDEBUG1("for colors\n");

  
  for (i=0; etc_colors[i].name != NULL; i++)
    {
      if( (q = strindex( etc_tcap, etc_colors[i].name)) == NULL) continue;
      
      q = q + strlen( etc_colors[i].name);   
      etc_colors[i].f_clr_on  = esc_cpy( q, ':');
      
      q = strindex( q, ":") + 1;     
      etc_colors[i].f_clr_off = esc_cpy( q, ':');
      
      q = strindex( q, ":") + 1;     
      etc_colors[i].b_clr_on  = esc_cpy( q, ':');
      
      q = strindex( q, ":") + 1;     
      etc_colors[i].b_clr_off = esc_cpy( q, ':');
    }

  /*
   * first color undefined 
   */
  etc_colors[0].f_clr_on  = etc_colors[1].f_clr_on,
  etc_colors[0].f_clr_off = etc_colors[1].f_clr_off,
  etc_colors[0].b_clr_on  = etc_colors[1].f_clr_on,
  etc_colors[0].b_clr_off = etc_colors[1].f_clr_off;
  
  if (! have_winsize)
    {
      if (strlen (ETC_co) > 0) max_x = atoi (ETC_co);
      if (strlen (ETC_li) > 0) max_y = atoi (ETC_li);
    }
  
  XDEBUG1("vor OTT_qsort\n");
  
  OTT_qsort( 0, etc_key_cnt-1, key_cmp, key_swap);    /* sort the keys */
  
  XDEBUG1("vor max_key_len\n");
  
  for (i=0; etc_keys[i].name != NULL; i++) 
    max_key_len = max( max_key_len, strlen (etc_keys[i].esc_seq) );
  
  /* screen memory **/
  i = max_x * max_y;
  screen_chr  = getmem( i * sizeof(char));
  screen_attr = getmem( i * sizeof(int));
  
  for(j=0; j<i; j++) 
    {
      screen_attr[j] = 0;
      screen_chr [j] = 0;
    }
  /* graphic designer ***/
  gr_char [G1] = ETC_G1;    /* + */
  gr_char [G2] = ETC_G2;    /* + */
  gr_char [G3] = ETC_G3;    /* + */
  gr_char [G4] = ETC_G4;    /* + */
  gr_char [GV] = ETC_GV;    /* | */
  gr_char [GH] = ETC_GH;    /* - */
  gr_char [GR] = ETC_GR;    /* -| */
  gr_char [GL] = ETC_GL;    /* |- */
#else
  /* nothing to do */
#endif
}

#endif   /* #ifdef UNIX */

