/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: dotcap.h,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/dotcap.h,v $
 */

#ifndef GLOBAL
#define GLOBAL
#endif

#ifndef DOTERMCAP_HH
#	define DOTERMCAP_HH

#define X_tgetent MY_tgetent

#define T_BUFSIZE		3072

#ifdef UNIX

#define ETC_GS  etc_graph[ 0].esc_seq   /* graphic einschalten */
#define ETC_GE  etc_graph[ 1].esc_seq   /* graphic auschalten */
#define ETC_G1  etc_graph[ 2].esc_seq   /* Eck open-right */
#define ETC_G2  etc_graph[ 3].esc_seq   /* Eck open-link */
#define ETC_G3  etc_graph[ 4].esc_seq   /* Eck unten-lift */
#define ETC_G4  etc_graph[ 5].esc_seq   /* Eck unten-right */
#define ETC_GV  etc_graph[ 6].esc_seq   /* vertikal line */
#define ETC_GH  etc_graph[ 7].esc_seq   /* horiz */
#define ETC_cm  etc_graph[ 8].esc_seq   /* x-y-coord */
#define ETC_md  etc_graph[ 9].esc_seq   /* hell */
#define ETC_mb  etc_graph[10].esc_seq   /* blanked */
#define ETC_me  etc_graph[11].esc_seq   /* normal */
#define ETC_so  etc_graph[12].esc_seq   /* inverse */
#define ETC_kd  etc_graph[13].esc_seq   /* delete char ^h*/
#define ETC_co  etc_graph[14].esc_seq   /* columns number */
#define ETC_li  etc_graph[15].esc_seq   /* line count */
#define ETC_cl  etc_graph[16].esc_seq   /* clear screen */
#define ETC_dl  etc_graph[17].esc_seq   /* delete line*/
#define ETC_GR  etc_graph[18].esc_seq   /* Eck*/
#define ETC_GL  etc_graph[19].esc_seq   /* Eck*/
#define ETC_CF  etc_graph[20].esc_seq   /* hide cursor */
#define ETC_CN  etc_graph[21].esc_seq   /* view cursor */
#define ETC_ce  etc_graph[22].esc_seq   /* delete from current pos. to end of line **/

struct pos_t {
	int akt_pos,
	    anf_pos,
	    files_on_f;
	struct pos_t * prev;
	};

struct color_t {
	char * name;
	char * f_clr_on;
	char * f_clr_off;
	char * b_clr_on;
	char * b_clr_off;
	};

struct etc_t {
	char * name;
	int  num;
	char * esc_seq;
	};

#ifdef EXTERN
GLOBAL int          etc_key_cnt,               /* count of available keys */
		    max_key_len,
                    clr_cnt;
#else
GLOBAL int          etc_key_cnt = 0,
		    max_key_len = 3,
                    clr_cnt     = 0;
#endif

#ifdef EXTERN
GLOBAL struct etc_t etc_graph[],
		    etc_keys [];
GLOBAL struct color_t etc_colors[];
#else
GLOBAL struct etc_t etc_graph[] = {
		{ ":GS=", 0, NULL },  /* 0 graphic einschalten  */
		{ ":GE=", 0, NULL },  /* 1 graphic auschalten  */
		{ ":G1=", 0, NULL },  /* 2 Eck open-right  */
		{ ":G2=", 0, NULL },  /* 3 Eck open-link  */
		{ ":G3=", 0, NULL },  /* 4 Eck unten-lift  */
		{ ":G4=", 0, NULL },  /* 5 Eck unten-right  */
		{ ":GV=", 0, NULL } , /* 6 vertikal line  */
		{ ":GH=", 0, NULL } , /* 7 horiz  */
		{ ":cm=", 0, NULL },  /* 8 x-y-coord  */
		{ ":md=", 0, NULL },  /* 9 hell  */
		{ ":mb=", 0, NULL },  /* 10 blanked  */
		{ ":me=", 0, NULL },  /* 11 normal  */
		{ ":so=", 0, NULL } , /* 12 inverse */
		{ ":kb=", 0, NULL } , /* 13 delete char ^h */
		{ ":co#", 0, NULL },  /* 14 columns number  */
		{ ":li#", 0, NULL },  /* 15 line count  */
		{ ":cl=", 0, NULL },  /* 16 clear screen  */
		{ ":dl=", 0, NULL },  /* 17 delete line */
		{ ":GL=", 0, NULL },  /* 18 eck */
		{ ":GR=", 0, NULL },  /* 19 eck */
		{ ":CF=", 0, NULL },  /* 20 hide cursor */
		{ ":CN=", 0, NULL },  /* 21 view cursor */
		{ ":ce=", 0, NULL },   /* 30 delete to end of line **/
		{ NULL,   0, NULL }
		},
           etc_keys[] = {
		{ ":bt=",    BACK_TAB, NULL  }, /* backtab  */
		{ ":k1=",    F1,       NULL  },	  /* F1 */
		{ ":k2=",    F2,       NULL  },	  /* F2 */
		{ ":k3=",    F3,       NULL  },	  /* F3 */
		{ ":k4=",    F4,       NULL  },	  /* F4 */
		{ ":k5=",    F5,       NULL  },	  /* F5 */
		{ ":k6=",    F6,       NULL  },  /* F6 */
		{ ":k7=",    F7,       NULL  },  /* F7 */
		{ ":k8=",    F8,       NULL  },  /* F8 */
		{ ":k9=",    F9,       NULL  },  /* F9 */
		{ ":k0=",    F10,       NULL  },  /* F0 */
		{ ":ku=",    CUR_UP,    NULL  },  /* Cursor up */
		{ ":kd=",    CUR_DOWN,  NULL},  /* Cursor down */
		{ ":kl=",    CUR_LEFT,  NULL},  /* Cursor links */
		{ ":kr=",    CUR_RIGHT, NULL},  /* Cursor rechts */
		{ ":PU=",    PAGE_UP,   NULL},  /* Page up */
		{ ":PD=",    PAGE_DOWN, NULL},  /* Page down */
		{ ":EN=",    END,       NULL},  /* End */
		{ ":IN=",    INSERT,    NULL},  /* Insert  */
		{ ":HM=",    HOME,      NULL},  /* Home */
		{ ":RM=",    DELETE,    NULL},  /* remove */
		{ ":ESC=",   ESC,       ""}, /* escape */
		{ ":ESC-a=", ESC_a,     "a"},
		{ ":ESC-b=", ESC_b,     "b"},
		{ ":ESC-c=", ESC_c,     "c"},
		{ ":ESC-d=", ESC_d,     "d"},
		{ ":ESC-e=", ESC_e,     "e"},
		{ ":ESC-f=", ESC_f,     "f"},
		{ ":ESC-g=", ESC_g,     "g"},
		{ ":ESC-h=", ESC_h,     "h"},
		{ ":ESC-i=", ESC_i,     "i"},
		{ ":ESC-j=", ESC_j,     "j"},
		{ ":ESC-k=", ESC_k,     "k"},
		{ ":ESC-l=", ESC_l,     "l"},
		{ ":ESC-m=", ESC_m,     "m"},
		{ ":ESC-n=", ESC_n,     "n"},
		{ ":ESC-o=", ESC_o,     "o"},
		{ ":ESC-p=", ESC_p,     "p"},
		{ ":ESC-q=", ESC_q,     "q"},
		{ ":ESC-r=", ESC_r,     "r"},
		{ ":ESC-s=", ESC_s,     "s"},
		{ ":ESC-t=", ESC_t,     "t"},
		{ ":ESC-u=", ESC_u,     "u"},
		{ ":ESC-v=", ESC_v,     "v"},
		{ ":ESC-w=", ESC_w,     "w"},
		{ ":ESC-x=", ESC_x,     "x"},
		{ ":ESC-y=", ESC_y,     "y"},
		{ ":ESC-z=", ESC_z,     "z"},
		{ ":ESC-A=", ESC_A,     "A" },
		{ ":ESC-B=", ESC_B,     "B" },
		{ ":ESC-C=", ESC_C,     "C" },
		{ ":ESC-D=", ESC_D,     "D" },
		{ ":ESC-E=", ESC_E,     "E" },
		{ ":ESC-F=", ESC_F,     "F" },
		{ ":ESC-G=", ESC_G,     "G" },
		{ ":ESC-H=", ESC_H,     "H" },
		{ ":ESC-I=", ESC_L,     "I" },
		{ ":ESC-J=", ESC_J,     "J" },
		{ ":ESC-K=", ESC_K,     "K" },
		{ ":ESC-L=", ESC_L,     "L" },
		{ ":ESC-M=", ESC_M,     "M" },
		{ ":ESC-N=", ESC_N,     "N" },
		{ ":ESC-O=", ESC_O,     "O" },
		{ ":ESC-P=", ESC_P,     "P" },
		{ ":ESC-Q=", ESC_Q,     "Q" },
		{ ":ESC-R=", ESC_R,     "R" },
		{ ":ESC-S=", ESC_S,     "S" },
		{ ":ESC-T=", ESC_T,     "T" },
		{ ":ESC-U=", ESC_U,     "U" },
		{ ":ESC-V=", ESC_V,     "V" },
		{ ":ESC-W=", ESC_W,     "W" },
		{ ":ESC-X=", ESC_X,     "X" },
		{ ":ESC-Y=", ESC_Y,     "Y" },
		{ ":ESC-Z=", ESC_Z,     "Z" },
		{ NULL,      0,         NULL }
		};

GLOBAL struct color_t etc_colors[] = {
		{ ":xx=",	NULL, NULL, NULL, NULL },
		{ ":white=",	NULL, NULL, NULL, NULL },
		{ ":blue=",	NULL, NULL, NULL, NULL },
		{ ":green=",	NULL, NULL, NULL, NULL },
		{ ":cyan=",	NULL, NULL, NULL, NULL },
		{ ":brown=",	NULL, NULL, NULL, NULL },
		{ ":yellow=",	NULL, NULL, NULL, NULL },
		{ ":red=",	NULL, NULL, NULL, NULL },
		{ ":black=",	NULL, NULL, NULL, NULL },
		{ ":violet=",	NULL, NULL, NULL, NULL },
		{ ":normal=",	NULL, NULL, NULL, NULL },
		{ ":message=",	NULL, NULL, NULL, NULL },
		{ ":input=",	NULL, NULL, NULL, NULL },
		{ ":underlined=", NULL, NULL, NULL },
		{ NULL, 	NULL, NULL, NULL }
		};

#endif

#endif  /* UNIX */

/* Finding the termcap entry in the termcap data base */

struct buffer
  {
    char *beg;
    int size;
    char *ptr;
    int ateof;
    int full;
  };

static char * 	find_capability ( char *bp, char *cap);
static char * 	tgetst1 	( char *ptr, char **area);
int 		MY_tgetent 	( char *tstr, char *term);
static int	scan_file 	( char *string, int fd, struct buffer *bufp);
static int	name_match 	( char *line, char *name);
static int	compare_contin  ( register char *str1, char *str);
static char *   gobble_line     ( int fd,
				  register struct buffer *bufp,
				  char *append_end
				);
GLOBAL void     get_etc_termcap (void);
#endif /*_HH*/
