/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: doutil.h,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/doutil.h,v $
 */

#ifndef GLOBAL
#define GLOBAL
#endif

#ifndef DOUTIL_HH
#	define DOUTIL_HH

#include "doframe.h"
#include "dowin.h"

#define ANOTHER_MODE   		0x8000
#define SAMEOWNER_MODE		0x4000      /* same owner */
#define SAMEGROUP_MODE		0x2000	    /* same group by copying */
#define SAMERIGHTS_MODE		0x1000	    /* same group by copying */

#ifdef DOS
#define BLOCKSIZE	(1024*4)
#else
#define BLOCKSIZE	(1024*16)
#endif

#ifdef UNIX
#	define FILELEN        256
#else
#	define FILELEN	       16
#endif

#ifndef mode_t
#	define mode_t unsigned
#endif

#define MAX_USER	100
#	define MAX_GRP 	100
#define U_G_LEN		20

#ifdef DOS
#	define root '\\'
#else
#	define root '/'
#endif

#ifdef UNIX
GLOBAL int
	* user_id,		/* user id list */
	* grp_id,		/* group id list */
#ifdef EXTERN
	max_user,		/* max. count of users */
	max_grp,            	/* max. count of groups */
	u_g_len,           	/* length of user/group name */
	user_cnt,		/* user from passwd file */
	grp_cnt;		/* groups are exesting */
#else
	max_user = MAX_USER,		/* max. count of users */
	max_grp  = MAX_GRP,            	/* max. count of groups */
	u_g_len  = 0,           	/* length of user/group name */
	user_cnt = 0,		/* user from passwd file */
 	grp_cnt  = 0;		/* groups are exesting */
#endif

GLOBAL char
     ** user_name,		/* user names list */
     ** user_desc,              /* user comment */
     ** grp_name;		/* group names list */
#endif

int 	change_ownergrp ( char * pth, int owner, int grp);
void 	get_restdir	( char *src, char *dest);
void 	get_filename	( char *src, char *dest);

/** copy */

int copy( struct frame_t * f, char * src, char * dest, char * filter, int * mode);

GLOBAL void copy_file     ( struct win_t * w);
GLOBAL int  recursive_copy( struct frame_t *f, 
			    char * file, 
			    char * dst, 
			    char * filter,
			    int * mode);

GLOBAL void  change_mode   ( struct win_t * w); /* change the mode of files */
GLOBAL int   recursive_change_mode
			   ( struct frame_t * f, 
			     char * file,
			     int f_mode, int mode);

GLOBAL void  remove_file   ( struct win_t * w);  /* remove aktual file */
GLOBAL int   recursive_remove                    /* recurse remove */
			   ( struct frame_t * f, char * file, int mode);

GLOBAL void   findfile      ( struct frame_t * f,
			      int    f_y,
			      int    file_h,
			      char * path,
			      char * name);
#ifdef UNIX

GLOBAL int  	get_username	( char * usr);
GLOBAL int  	get_grpname 	( char * g  );
GLOBAL char * 	getuser_idname	( int );
GLOBAL char * 	getgrp_idname	( int );

GLOBAL void 	get_user_list	( void);
GLOBAL void 	get_grp_list 	( void);

GLOBAL void  change_owner  ( struct win_t * w);  /* change owner/grp of files */
GLOBAL int   recursive_change_owner
		    ( struct frame_t * f,
		      char * file,
		      int new_uid,
		      int new_gid,
		      int mode);

#endif

GLOBAL void   view_size     ( struct win_t * w);
GLOBAL int    new_dir       ( void);

#endif /*_HH*/
