/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: dowin.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/dowin.c,v $
 */

#define GLOBAL extern
#define EXTERN

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef DOS
#include <dos.h>
#include <dir.h>
#else
#include <sys/types.h>
#include <dirent.h>
#endif

#include "dodefs.h"
#include "doglobal.h"
#include "doerror.h"
#include "doframe.h"
#include "doscr.h"
#include "dostring.h"
#include "dostat.h"
#include "domem.h"
#include "dofiles.h"
#include "doqsort.h"
#include "dodirent.h"
#include "docfg.h"
#include "doregex.h"
#include "dowin.h"

#ifdef DOS
#	define MINUS	  1
#else
#	define MINUS     0
#endif


void w_changesort( struct win_t * w)
{
    struct frame_t * f, * asc_f;
    struct choose_t * ch, * ch_asc;
    char * str[] = {
	" Name              (fast)",
	" Directories first (slow)",
	" Size              (slow)",
	" Modify time       (slow)",
#ifdef UNIX
	" Create time       (slow)",
	" Access time       (slow)",
	" I-Node            (slow)",
	" Links             (slow)",
	" User Id           (slow)",
	" Group Id          (slow)",
	" User name  <not implemented>",
	" Group name <not implemented>",
	" Unsorted          (fastest)",
#else
	" Unsorted          (fastest)",
	" Create time       (UNIX)",
	" Access time       (UNIX)",
	" I-Node            (UNIX)",
	" Links             (UNIX)",
	" User Id           (UNIX)",
	" Group Id          (UNIX)",
	" User name         (UNIX)",
	" Group name        (UNIX)",
#endif
	NULL
	},
	* asc[] = { " ASCENDING ", " DESCENDING ", NULL };
    int i, width = 0;

    XDEBUG1 ("change_sort\n") ;

    for(i=0, width=0; str[i] != NULL; i++) width = max( width, strlen( str[i]));

    f      = make_frame ( 0, 1, width+2, i+2, " Sort ",
			  leer,
			  F_B_UTIL_CLR, NOMODE);

    ch     = make_choose( f,
			  0,
			  F_B_UTIL_CHS,
			  AUTO_MODE | LET_MODE);

    asc_f  = make_frame ( f->x+2, f->y, strlen(asc[1])+2, 4,
			  leer, leer,
			  F_B_DIALOG_CLR, NOMODE);

    ch_asc = make_choose( asc_f, 0, F_B_DIALOG_CHS, AUTO_MODE | LET_MODE);

    for(i=0; asc[i] != NULL; i++)
	f_putstr( asc_f, 1, i+1, asc[i], asc_f->color, NOMODE);

    for(i=0; str[i] != NULL; i++)
	f_putstr( f, 1, i+1, str[i], f->color, NOMODE);

    switch( w->sort_methode & ~ DESCENDING) {
	    case FILE_NAME  : ch->pos = 0; break;
	    case DIR_FIRST  : ch->pos = 1; break;
	    case FILE_SIZE  : ch->pos = 2; break;
	    case MODIFY_TIME: ch->pos = 3; break;
#ifdef UNIX
	    case CREATE_TIME: ch->pos = 4; break;
	    case ASSECC_TIME: ch->pos = 5; break;
	    case FILE_INODE : ch->pos = 6; break;
	    case FILE_LINKS : ch->pos = 7; break;
	    case FILE_USER  : ch->pos = 8; break;
	    case FILE_GROUP : ch->pos = 9; break;
	    case FILE_USER_NAME  : ch->pos = 10; break;
	    case FILE_GROUP_NAME : ch->pos = 11; break;
	    case UNSORTED   : ch->pos = 12; break;
#else
	    case UNSORTED   : ch->pos = 4; break;
#endif
	    }

    view_frame( f);

    i = f_choose( ch);
    if( i == ENTER || i == CTRL_M) {
					/* asc. or desc. sorting */
	f_changeY( asc_f, f->y+ch->pos+2);
	if( w->sort_methode & DESCENDING) ch_asc->pos = 1;
	view_frame( asc_f);
	i = f_choose( ch_asc);

	if( i == ENTER || i == CTRL_M) {
	    i = ch_asc->pos == 0 ? NOMODE : DESCENDING; /* desc. or asc. */
	    switch( ch->pos) {
		case 0: w->sort_methode = FILE_NAME   | i; break;
		case 1: w->sort_methode = DIR_FIRST   | i; break;
		case 2: w->sort_methode = FILE_SIZE   | i; break;
		case 3: w->sort_methode = MODIFY_TIME | i; break;
#ifdef UNIX
		case 4: w->sort_methode = CREATE_TIME | i; break;
		case 5: w->sort_methode = ASSECC_TIME | i; break;
		case 6: w->sort_methode = FILE_INODE  | i; break;
		case 7: w->sort_methode = FILE_LINKS  | i; break;
		case 8: w->sort_methode = FILE_USER   | i; break;
		case 9: w->sort_methode = FILE_GROUP  | i; break;
		case 10: w->sort_methode = FILE_USER_NAME   | i; break;
		case 11: w->sort_methode = FILE_GROUP_NAME  | i; break;
		case 12: w->sort_methode = UNSORTED    | i; break;
#else
		case 4: w->sort_methode = UNSORTED    | i; break;
#endif
		}
	    w_sortfiles (w, TRUE);
	    w->fr_out = TRUE;
	    }
	}

    del_choose( ch);
    del_choose( ch_asc);
    hide_frame( asc_f, HIDE_MODE | DELETE_MODE);
    hide_frame( f, HIDE_MODE | DELETE_MODE);
}

void w_choose( struct win_t * w, int x, int y, int pos, int mode)
{

    /* mode == CHS_CLEAR: clear field */
    /* mode == TRUE : choose color is on */
    /* mode == FALSE: choose color is off */

    char tmp[ 100];
    int i,
	len,
	st_pos = pos - w->anf_pos,
	color  = w->dr[pos]->s ? F_B_SELECT_CLR : w->f->color;

    XDEBUG5 ("w_choose (x=%i, y=%i, pos=%i, mode=0x%x)\n", x, y, pos, mode);


    /*
     * clear choose entry
     */
    if( mode & CHS_CLEAR) 
      {
	if( w->view_mode & LONG_MODE) 
		i = w->f->width;
	else    i = min (w->f->to_x - x, COL_WIDTH-MINUS);
	f_putnstr (w->f, x, y, leer, i, w->f->color, NOMODE);
	return;
      }

#ifdef UNIX
    sprintf( tmp, "%c %s", w->dr[pos]->m, W_FILE( pos));
#else
    /* in dos there are only 8 characters as file-name and **/
    /* max. three characters as extensition */

    if( w->dr[pos]->f[0] != '.') {
	char file[COL_WIDTH+1];
	int m;
	tmp[0] = 0;

	strcpy( file, W_FILE(pos));

	i = chrindex( file, ".");
	if (i<0) i = strlen( file);

	if( ! (w->dr[pos]->m & FA_DIREC)) lowercase( file); /* lowercase */

	fprn_nchar( tmp+strlen(tmp), file, i, 8, ' ');

	m = w->dr[pos]->m & FA_RDONLY ||      /* read only */
	    w->dr[pos]->m & FA_SYSTEM ||      /* system file */
	    w->dr[pos]->m & FA_HIDDEN;        /* hidden file */
					/* if special file, convert */
					/* the first character in */
					/* upper/lower case */
	if( m) tmp[0] = ( is_uppercase( tmp[0])
			  ? ch_lowercase( tmp[0])
			  : ch_uppercase( tmp[0])
			);

	sprintf ( tmp+strlen(tmp), "%c", ( m ? '*' : ' '));

						/* extension */
	fprn_nchar( tmp+strlen(tmp),
		    file+i+1,
		    strlen(file)-i,
		    3,
		    ' ');
	}
    else
	sprintf( tmp, W_FILE( pos));
#endif

    i = min (w->f->to_x - x, (w->view_mode & LONG_MODE) ?
			     COL_WIDTH_LONG - MINUS:
			     COL_WIDTH - MINUS
			     );

#ifdef UNIX
    len = strlen (tmp);
    if (len > i) tmp [i-1] = '>';
#endif

    f_putnstr( w->f, x, y, tmp, i, color, NOMODE);

    if( w->view_mode & LONG_MODE) 
	{
#ifdef UNIX
	if (len > COL_WIDTH_LONG) tmp [COL_WIDTH_LONG-1] = '>';
#endif
	file_stat( w, st_pos, tmp, CHOOSE_MODE);   /* get stat of file */
	f_putstr( w->f, x+COL_WIDTH_LONG,
			y,
			tmp+min( strlen(tmp), w->long_outbegin),
			color, FILL_MODE);
	}
}

void w_gettype( struct win_t * w, int pos)
{
  XDEBUG2 ("w_gettype (pos=%i)\n", pos);
#ifdef UNIX
  if( MY_stat( W_FILE( pos), w->f_stat[ w->files_on_f]) != 0)
    {
      w->dr[ pos]->m = '?';
    }
  else 
    w->dr[pos]->m = get_modechar (w, w->f_stat [w->files_on_f]);
  
#else
  MY_stat( W_FILE(pos), w->f_stat[ w->files_on_f]);
#endif
}

/*
 * redraw Rahmen
 */
void w_new_rahmen( struct win_t * w)
{
  int i;
  char fls[ 50];
  w->rahmen_out = FALSE;
  
#ifdef UNIX
  sprintf( fls, " [%i] Files: %i, %s.%s ",
		      MY_cfg.akt_w+1,
		      w->d_files - 2,
		      owner_gr, owner);
#else
  sprintf( fls, " [%i] Files: %i ", MY_cfg.akt_w+1, w->d_files - 2);
#endif

  f_change_t1 (w->f, cutpath (w->path, w->f->width-2, TRUE)) ;
  f_change_t2 (w->f, leer) ;

				   /* put the corners into frame */
  f_rahmen (w->f, NOMODE);	/* for new titel */

  i              = f_pos (w->f, 0, w->f->down + 1);
  w->f->chr [ i] = GL;
  w->f->attr[ i] = GRAPH_MODE | w->f->color;
  i              = f_pos (w->f, -1, w->f->rows - 2);
  w->f->chr [ i] = GR;
  w->f->attr[ i] = GRAPH_MODE | w->f->color;
  
  f_putline( w->f, w->f->rows-3, w->f->color );
  f_putstr ( w->f, 1,
	    w->f->rows-3,
	    fls,
	    F_B_TITLE_CLR,
	    /* w->f->color, */
	    NOMODE);
  
#ifdef DOS
  if( w->view_mode & SIMPLE)
    {
      /*
       * On DOS view a vertical trenn line
       * And don't paint on the last line on the frame
       */
      for(i=COL_WIDTH; i<w->f->width-1; i += COL_WIDTH)
	f_putvline( w->f, i, w->f->color);
    }
  else
    {
      int pos = COL_WIDTH;
      /*
       * only the first col.
       */
      if( pos<w->f->width) f_putvline( w->f, pos, w->f->color);

      /*
       * Clear the frame
       */
      for(i=COL_WIDTH*2; i<w->f->width-1; i +=COL_WIDTH)
      {
	pos = f_pos (w->f, i, w->f->down+1);
	if (w->f->attr[pos] & GRAPH_MODE)
	  {
	    w->f->chr [pos] = GH,
	    w->f->attr[pos] = GRAPH_MODE|w->f->color;
	  }
      }
    }
#endif
  
}

/* out the directory entries on the frame */

int w_outfile( struct win_t * w,
		 int pos, 		/* position on the frame */
		 int mode)              /* modes */
{
    int i, w_pos, x, y, width;

    XDEBUG3 ("w_outfile (pos=%i, mode=%i)\n", pos, mode);

    w_pos = max( 0, pos - w->anf_pos);

    /*
     * X-Position
     */
    x = (w->view_mode & LONG_MODE ? 0 : (w_pos / w->f->down) * COL_WIDTH) + 1;

    /*
     * Y-Position
     */
    y = w_pos % w->f->down + 1;

    if (pos < w->d_files) {
	 w_gettype( w, pos);		     /* type of dir. entry */
	 w_choose( w, x, y, pos, NOMODE);    /* out the files on the frame */
	 }
    else w_choose( w, x, y, pos, CHS_CLEAR);    /* clear the pos. */

    if( pos < w->d_files) return( TRUE);
    else return( FALSE);
}

/*
 * Get the Max. Number of Files, there can be display on one frame
 */
int w_maxfiles (struct win_t * w)
{
  int width = w->f->width - 2;  
  return w->view_mode & LONG_MODE 
         ? w->f->down
         : ( w->f->down  
	     * 
	     ( (width / COL_WIDTH) 
	       + 
	       (width % COL_WIDTH ? 1 : 0)
	       )
	     );
}

void w_outdir (struct win_t * w, int pos)
{
  /* mode = SIMPLE a simple list */
  /* mode = LONG_MODE  a long   list with more information */

  int i, j, width = w->f->width - 2;

  pos = max (0, pos);
  XDEBUG2 ("w_outdir (pos=%i)\n", pos);
			/* the maximum of files, that one frame cann have **/
  w->f_maxfiles = w_maxfiles (w);

  if( w->fr_out) w->fr_out = FALSE;
					/* the frame becomes new titles */
  if( w->rahmen_out) w_new_rahmen (w);
  
  for( j=0, i=pos, w->files_on_f=0; j < w->f_maxfiles; i++, j++)
    {
      if( w_outfile( w, i, NOMODE)) w->files_on_f++;
    }

  if( w->f->mode & VIEW_MODE)
    {
      view_frame (w->f);
    }
  else
    {
      symbol_path (w) ;
      view_frame (w->symbol) ;		/* view it's symbol */
    }

  XDEBUG2 ("w_outdir (pos=%i) end \n", pos);
}

int w_shortcmp( const void * a, const void * b)
{
  if( * (ushort*) a > * (ushort*) b) return( 1);
  if( * (ushort*) a < * (ushort*) b) return( -1);
  return( 0);
}

void w_readdir( struct win_t * w, char * dir_, int mode)
{
  /* TRUE : search for aktual directory and set the akt_pos for the found */
  /* LOCK_DIR_MODE : it locks for the old directory */
  /* VIEW_POINTS: don't view points on the button of the screen */
  /* directory */
  
#ifdef UNIX
  struct dirent * dp;
  DIR * dir;
#else
  struct ffblk  * dp      = getmem( sizeof(struct ffblk));
  int done;
#endif
  char c, * q, *fname, tmp[ 50], * compiledStr = NULL;
  char * sel_stack;
  int use_regex = FALSE, flag = FALSE;
  int   i, j;

#ifdef UNIX
#	define DIR_NAME d_name
#else
#	define DIR_NAME ff_name
#endif
  
  XDEBUG2 ("w_readdir (dir_=%s)\n", dir_) ;

  if( w->new_read) 
    {
      w->new_read   = FALSE;
      w->fr_out     = TRUE;
      w->rahmen_out = TRUE;
    }
  
  if (mode & VIEW_POINTS) view_com_line( w, FALSE); /* to view ... at the screen */
  
  /* you must save the selected files into stack and after the new read */
  /* of the aktual directory you must set the selected files aloways as */
  /* selected */
  
  /* save the direcotry inodes in the stack **/
  if( w->selected > 0)
    {
      /* save selected names in the stack */
      sel_stack = getmem( w->selected * MAX_COL_LEN * sizeof(char));
      for (j=i=0; i<w->d_files; i++)
	if (w->dr[i]->s)                         /* selecte flag */
	  strcpy (sel_stack + (j++ * MAX_COL_LEN), w->dr[i]->f);
      
      /* sort the files with qsort */
      qsort ((void *) sel_stack,
	     w->selected,
	     MAX_COL_LEN * sizeof(char),
	     (int (*)(const void *, const void *)) strcmp
	     );
    }
  
				/* the first two directory contains
				 * are allows "." and ".."
				 */
  for( w->d_files=0; w->d_files<w->begin_at; w->d_files++)
    {
      strcpy (W_FILE( w->d_files), w->d_files == 0 ? "." : "..");
      w->dr [w->d_files]->s = FALSE;             /* files are not selected */
    }

#ifdef UNIX
#define MATCHES		"*"
#else
#define MATCHES		"*.*"
#endif
  j = 0;
  if (strcmp(w->filter, MATCHES) != 0)
    {
      compiledStr = open_comp (w->filter) ;          /* use regex for filter */
      use_regex   = TRUE ;
    }
#ifdef UNIX
  dir = X_opendir( dir_);                       /* open directory */
  
  while( w->d_files < MY_cfg.max_file_cnt &&      /* max. files */
	( dp = X_readdir( dir)) != NULL     /* read next dir. contents */
	)
#else
  j = 0;
  done = findfirst( w->filter, dp, w->f_attr);
  while (w->d_files < MY_cfg.max_file_cnt &&      /* max. files */
	 ! done
	 ) 
#endif
    {
      if( mode & LOCK_DIR_MODE &&              /* lock for old directory */
	 strcmp( dp->DIR_NAME, w->cur_dir) == 0 /* old dir. found */
	 )
	w->akt_pos = w->d_files;
      
      w->dr [w->d_files]->s = FALSE;  /* files are not selected */
#ifdef DOS
      w->dr [w->d_files]->m = dp->ff_attrib; /* dos attribue */
#endif

      if (strcmp( dp->DIR_NAME, "." ) != 0  &&
	  strcmp( dp->DIR_NAME, "..") != 0  &&
	  (!  use_regex 
	   || use_regex && is_regex (compiledStr, dp->DIR_NAME) 
           || is_dir (dp->DIR_NAME, NOMODE)              /* allows view dir. */
	   )
	  )
	{
	      strncpy_( W_FILE (w->d_files),
		       dp->DIR_NAME,
		       MAX_COL_LEN-1,		/* file length */
		       TE_NULL                   /* term. with unsigned 0 */
		       );
	      w->d_files++;                       /* count of files in dir. */
	    }
#ifdef DOS
      done = findnext( dp);                   /* next dir. entry */
#endif
    }
  
#ifdef UNIX
  X_closedir (dir);
#else
  Free (dp);                                     /* Free buffer */
#endif

  if (compiledStr != NULL) close_comp (compiledStr);
  
#ifdef UNIX
  if( dp != NULL)
    {
      message( " Too many entries, increase option [-files ] ",
	      " Read directory entries ");
    }
#else
  if( ! done)
    {
      message( " Too many entries, increase option [-files ] ",
	      " Read directory entries ");
    }
#endif
  
  w_sortfiles (w, mode);  /* sort files */
  
  /* ask for the selected files to set there aloways as selected */
  /* search for there into the stack with the binary search       **/
  
  if( w->selected > 0)
    {
      int cnt = 0;
      w->sel_size = 0;
      /* it locks for every file, if it is selected */
      for(i=0; i<w->d_files; i++)
	{	   /* count of files */
	  for( j=0; j<w->selected; j++)	   /**# of selected files */
	    if( strcmp( w->dr[i]->f,
		       sel_stack+j*MAX_COL_LEN
			   ) == 0)
	      {
		w->dr[i]->s = TRUE,
		w->sel_size += file_size( w->dr[i]->f, NOMODE); /* file size */
		cnt ++;
	      }
	}
      w->selected = cnt;
      
	  /* the selected files correct */
      Free( sel_stack);     /* Free the stack of the selected files */
    }
  /* count of files on frame */
  w->files_on_f = min (w->f_maxfiles, w->d_files);
}
  
/* for qsort to swap two elements with other */
int w_swap( const int pos1, const int pos2)
{
  struct dir_in_t * p = WIN->dr[ pos1];
  WIN->dr[pos1] = WIN->dr[pos2];
  WIN->dr[pos2] = p;
  return( TRUE);
}

	/* for qsort the compare two characters and to use desc. mode */
int w_strcmp_pos( const int pos1, const int pos2)
{
  int i = strcmp( WIN->dr[ pos1]->f, WIN->dr[ pos2]->f);
  return( WIN->sort_methode & DESCENDING ? i * -1 : i);
}

	/* for qsort the compare two long values and to use desc. mode */
int w_longcmp( const int pos1, const int pos2)
{
  int i;
  if( WIN->dr[pos1]->sort > WIN->dr[pos2]->sort) i = 1;
  else if( WIN->dr[pos1]->sort < WIN->dr[pos2]->sort) i = -1;
						     /* sekund sort criterium*/
  else return( strcmp( WIN->dr[pos1]->f, WIN->dr[pos2]->f));
  return( WIN->sort_methode & DESCENDING ? i * -1 : i);
}

void w_sortfiles( struct win_t * w, int mode)
{
  /* mode == TRUE : search for current file **/
  /* mode == VIEW_POINTS: to view "..." on the screen */

  struct stat st;
  char akt_file[COL_WIDTH+1];
  int i;

  if( mode & TRUE) strcpy( akt_file, w->dr[w->akt_pos]->f);
						/* default sort methode */
  if( w->sort_methode & UNSORTED) {}
  else if( w->sort_methode & FILE_NAME)
    {
      OTT_qsort( w->begin_at, w->d_files-1, w_strcmp_pos, w_swap);
    }
  else
    {		                         /* another sort moethodes */
      int i;
      long * l;
      
/*
      w->dr->sort = getmem( w->d_files * sizeof(long)); 
*/
      
      if (mode & VIEW_POINTS) view_com_line( w, FALSE); /* to but ..... */

	for(i=0; i<w->d_files; i++) {

      	    if (i > 1 && i % 100)
	      {                        /* view points */
		view_position (i, w->d_files, VIEW_MODE);
	      }

	    err = MY_stat( W_FILE( i), &st);

	    l = &w->dr [i]->sort;

		 if( err != 0                     ) *l = (long) 0;
	    else if( w->sort_methode & DIR_FIRST  ) *l =
					(long) (is_dir (W_FILE(i), NOMODE)
						? 0
						: 1) ;
	    else if( w->sort_methode & FILE_SIZE  ) *l = st.st_size;
	    else if( w->sort_methode & CREATE_TIME) *l = st.st_ctime;
	    else if( w->sort_methode & MODIFY_TIME) *l = st.st_mtime;
	    else if( w->sort_methode & ASSECC_TIME) *l = st.st_atime;
	    else if( w->sort_methode & FILE_LINKS ) *l = (long) st.st_nlink;
	    else if( w->sort_methode & FILE_INODE ) *l = (long) st.st_ino;
	    else if( w->sort_methode & FILE_USER  ) *l = (long) st.st_uid;
	    else if( w->sort_methode & FILE_GROUP ) *l = (long) st.st_gid;
	    else if( w->sort_methode & FILE_USER_NAME  ) {
		*l = (long) st.st_uid;
		}
	    else if( w->sort_methode & FILE_GROUP_NAME ) {
		*l = (long) st.st_gid;
		}
	    else 				    *l = st.st_size;
	    }

	OTT_qsort( w->begin_at, w->d_files-1, w_longcmp, w_swap);

	}
				/* search for current file name */
    if( mode & TRUE && strcmp( akt_file, w->dr[w->akt_pos]->f) != 0) {
	for(i=0; i<w->d_files; i++)
	    if( strcmp( akt_file, w->dr[i]->f) == 0) {
		w->akt_pos = i;
		break;
		}
	}
    view_position (0, 0, HIDE_MODE);
}

int w_strcmp( const char * s1, const char * s2)
{
  int i = strcmp( s1, s2);
  return( WIN->sort_methode & DESCENDING ? i * -1 : i);
}

struct win_t * chs_win( void)
{
    struct frame_t * f;
    struct choose_t * ch;
    char file[ 100];
    int i, lk,
	x     = 0,
	y     = 1,
	width = min( max_x-1, 30),
	deep  = MY_cfg.win_cnt+2;

    for( i=0; i<MY_cfg.win_cnt; i++) {
	width = max( width, 
		     strlen( cutpath( w_[i]->path, max_x-2, NOMODE)) + 14
		   ); 
	}
    width = min( width, max_x-x);

    f = make_frame( x, y, width, deep, " choose window ", leer,
		    F_B_UTIL_CLR, NOMODE);

    ch = make_choose( f, 0, F_B_UTIL_CHS, AUTO_MODE);

    for( i=0; i<MY_cfg.win_cnt; i++) {
	sprintf( file, " Window %i : ", i+1);
	f_putstr( f, 1, i+1, file, f->color, NOMODE);
	f_putstr( f,
		  1+strlen(file), 
		  i+1, 
		  cutpath( w_[i]->path, width-strlen(file), NOMODE),
		  f->color,
		  NOMODE
		);
	}

    view_frame( f);

    ch->pos = MY_cfg.akt_w;
    lk = f_choose( ch);

    hide_frame( f, HIDE_MODE | DELETE_MODE);
    del_choose( ch);

    if( lk == ENTER || lk == CTRL_M) MY_cfg.akt_w = ch->pos;
    else return( WIN);

    return( w_change_win( FALSE));           /* current window */
}

void del_dir( struct dir_in_t * dr)
{
  Free( dr);
}

struct dir_in_t * make_dir( void)
{
  struct dir_in_t * dr = getmem( sizeof( struct dir_in_t));
  return( dr);
}

int w_statcount( struct win_t * w)
{
  int cnt, l, h;
  for( cnt=0, l = 1, h = 1; TRUE; l++, cnt++)
    {
      if( l > w->f->down) { h += COL_WIDTH; l = 1; }
      if( h > w->f->width - 2) break;
    }
  return( cnt);
}

/**** make an empty window for file-names **/

struct win_t * make_win ( int x, int y, int to_x, int to_y, int viewmode)
{
  int i, pos, cnt, l, h;
  struct win_t * w = getmem( sizeof (struct win_t) );

  XDEBUG1 ("Make_win 10\n");
  
  w->dr = getmem( MY_cfg.max_file_cnt * sizeof( struct dir_in_t *));
    
  for(i=0; i<MY_cfg.max_file_cnt; i++)
    {
      w->dr[i] = make_dir();  /* window files */
    }
  
  strcpy( w->path  , "."  );
#ifdef UNIX
  strcpy( w->filter, "*");
#else
  strcpy( w->filter, "*.*");
  w->drive        = 0;
  w->f_attr       = 0xffff & ~ FA_LABEL; /* don't read the volume label */
#endif
  w->view_mode    = viewmode;         /* SIMPLE|LONG_MODE */
  w->long_outbegin = 0;
  w->sort_methode = DIR_FIRST;	/* Sort methode */
  w->akt_pos      = 1;
  w->old_pos      = 1;
  w->anf_pos      = 0;
  w->f_pos        = 1;
  w->rahmen_out   = TRUE;
  w->fr_out       = TRUE;
  w->new_read     = TRUE;
  w->files_on_f   = 0;
  w->d_files      = 0;
  w->selected     = 0;
  w->sel_size     = 0;
  w->view_size    = TRUE;         /* view size of selected files */
  w->begin_at     = 2;            /* sorting begin */
  
  				/*
				 * make the frame of the window 
				 */
  w->f	     = make_frame (x, y, to_x - x + 1, to_y - y + 3,
			   leer, leer,
			   F_B_NORMAL,
			   NOMODE);
  w->link_f     = NULL ;  /* link frame as NULL */
  w->f->down    = w->f->down - 2;      /* file stat have 2 lines */
  w->f->mode    = VIEW_MODE;           /* frame is as VIEWED */
  w->f->type    |= SCROLL_RIGHT_MODE;  /* vertical scroller */
  f_makescroller (w->f);	       /* make scroller */
  
  f_putline( w->f, w->f->rows - 3, w->f->color);
  
				/* constract the symbol of the frame 
				 */
  make_symbol (w) ;

  /****** count of files in a window *******/
  
  cnt = w_statcount( w);
  				/* space for the file stat
				 */
  w->f_stat = (struct stat **) getmem( cnt * sizeof( struct stat *));
  for(i=0; i<cnt; i++)
    {
      w->f_stat[i] = getmem( sizeof( struct stat));
    }
  
  w->ch1       = make_choose (w->f, cnt, F_B_CHOOSE_CLR, LET_MODE);
  w->ch2       = make_choose (w->f, 0,   F_B_CHOOSE_CLR, LET_MODE);

  w->ch1->help = w->ch2->help = NULL;

  /* choose coordinates and lengthes
   */
  for( i=0, l = 1, h = 1; TRUE; l++, i++)
    {
      if( l > w->f->down) { h += COL_WIDTH; l = 1; }
      if( h > w->f->width - 2) break;
      w->ch1->x   [i] = h;
      w->ch1->y   [i] = l;
      w->ch1->len [i]  = COL_WIDTH - MINUS;
    }
  
  w->ch1->prog = w->ch2->prog = f_filestat;  /* to execute it by choosing */
  
						  /* default choose **/
  if( viewmode & SIMPLE)
    {
      w->ch = w->ch1;
    }
  else w->ch = w->ch2;
  
  w->ch2->mode =
    w->ch1->mode =
      COM_MODE | FIL_MODE | TYPE_STRING;
				  /* str from command line
				   */
  w->ch1->str       = w->ch2->str       = pr_to_run;
  w->ch1->strlen    = w->ch2->strlen    = MAX_COM_LEN-1; /* max. length */
  w->ch1->inp_color = w->ch2->inp_color = F_B_COMLINE_CLR;
  
  w->f_maxfiles = w_maxfiles (w);
  
  return w;
}


/**** delete window **/

void del_win ( struct win_t * w) {
     int i, cnt = w_statcount(w);

     del_choose( w->ch1);
     del_choose( w->ch2);

     hide_frame( w->f, HIDE_MODE|DELETE_MODE);

     for(i=0; i<MY_cfg.max_file_cnt; i++) {
	del_dir( w->dr[i]);
	}

     Free( w->dr);

     for(i=0; i<cnt; i++) Free( w->f_stat[i]);

     Free( w->f_stat);

     Free      ( w);
     }

/*** view window w at the screen and change the aktuall directory to the ***/
/*** path in o_w and accept the modes in var. mode ***/

void view_win( struct win_t * w, struct win_t * o_w, int mode) {
     /** READ_MODE : new read of the current directory ( refresh ) **/
     /** OUT_MODE  : out the directory contiens **/

     if( mode & READ_MODE) w->new_read   = TRUE;
     if( mode & OUT_MODE ) w->rahmen_out = TRUE,
		      w->fr_out     = TRUE;

     XDEBUG1("dowin 100\n");

     change_dir( w, w->path);


     XDEBUG1("dowin 110\n");

     if( mode & READ_MODE) w_readdir( w, w->path, FALSE);


     XDEBUG1("dowin 120\n");

     if( mode & OUT_MODE)  w_outdir (w, w->anf_pos);


     XDEBUG1("dowin 130\n");

     print_file_stat( w, w->akt_pos - w->anf_pos);


     XDEBUG1("dowin 140\n");

     change_dir( o_w, o_w->path);

     XDEBUG1("dowin 150\n");

     }

/*** view/hide current window ***/

void w_view_hide_win (int num)
  {
    if( num > MY_cfg.win_cnt-1)
      return;

    /*
     * frame hidden
     */
    if( w_[num]->f->mode & HIDE_MODE)
      {
	hide_frame (w_[num]->symbol, HIDE_MODE) ; /* hide symbol */
	view_frame (w_[num]->f);                  /* view window */
	if (w_[num]->ch->chs_f != NULL)		  /* view chooseblock */
	  view_frame (w_[num]->ch->chs_f);
      }
    else /* frame viewed */
      {
	symbol_path (w_[num]);			   /* make icon with path */
	view_frame  (w_[num]->symbol) ;   	   /* view symbol */
	hide_frame  (w_[num]->f, HIDE_MODE);       /* hide window */

	if (w_[num]->ch1->chs_f != NULL)	   /* hide chooseblock */
	  hide_frame  (w_[num]->ch1->chs_f, HIDE_MODE);

	/* hide the another choose block (long view) */
	if (w_[num]->ch2->chs_f != NULL)
	  hide_frame  (w_[num]->ch2->chs_f, HIDE_MODE);
      }

    /*
     * only when the frame is viewed on the screen, then view it
     */
    if( w_[MY_cfg.akt_w]->f->mode & VIEW_MODE)
      view_frame( w_[MY_cfg.akt_w]->f);
  }

/**** change file window ***/
struct win_t * w_change_win( int mode)
{

  /*** NEXTWIN_MODE : change to next frame **/
  /*** PREVWIN_MODE : change to prev frame **/

  int i ;
				/* hide the block-choose
				 */
  WIN->ch->mode   = (WIN->ch->mode | NOWAIT_MODE)&~EXTRA_MODE;
  f_choose( WIN->ch);

				/* if a symbol was viewed, set the normal color
				 */
  if (WIN->f->mode & HIDE_MODE) view_frame (WIN->symbol) ;

  switch( mode)
    {
    case NEXTWIN_MODE: 
      MY_cfg.akt_w = ( MY_cfg.akt_w + 1) % MY_cfg.win_cnt;
      break;
    case PREVWIN_MODE: 
      MY_cfg.akt_w = ( MY_cfg.win_cnt + MY_cfg.akt_w - 1) % MY_cfg.win_cnt;
      break;
    }

  change_dir( WIN, WIN->path);
  
  WIN->fr_out     = TRUE;
  WIN->rahmen_out = TRUE;
  WIN->new_read   = TRUE;


  return( WIN);
}


int w_filter (struct win_t * w, frame_T ff)
{
  struct input_t * in;
  struct frame_t * f = ff;
  int
    width = min( max_x, 30),
    down  = 5,
    x     = (max_x-width)/2,
    y     = (max_y-down )/2;
  if (f == NULL)
    {
      f  = make_frame( x, y, width, down, " Filter ", leer,
		      F_B_UTIL_CLR,
		      NOMODE);
    }

  in = make_input( f, 1, INS_MODE|CUR_MODE);
  input_string (in, 0, ff == NULL ? 2 : 10, 2, w->filter, 15, 20);

  view_frame (f);
  f_getstr   (in);
  del_input( in);
  if (ff == NULL) hide_frame( f, HIDE_MODE|DELETE_MODE);
  w->new_read = TRUE;
  return( TRUE);
}

void w_reposition (struct win_t * w)
{
  int i ;

#if 0
  /****** old position */
  i 	      = max( 0, min( w->files_on_f, w->akt_pos - w->anf_pos)),
  w->ch->pos       = w->f_pos;
  w->ch->chs_color = w->f->color;
  w->ch->mode      = w->ch->mode & ~EXTRA_MODE|NOWAIT_MODE;
  f_choose( w->ch);
  w->ch->pos    = i,
  w->akt_pos    = w->anf_pos + i;
#endif
  
  /****** currect position **/
  
  w->ch->pos       = w->akt_pos - w->anf_pos;
  w->ch->chs_color = F_B_CHOOSE_CLR;
  w->akt_pos       = w->anf_pos + w->ch->pos;
  w->f_pos         = w->ch->pos;
  w->ch->mode      = w->ch->mode|EXTRA_MODE|NOWAIT_MODE|LET_MODE; 
  f_choose (w->ch);			/* auto choose to view the **/
  /* current position 	   **/
}

void w_lockfor (struct win_t * w, char * filename)
{ 				/* find the best string of the list */
  int 
    old_srch = w->akt_pos ,
    ff_val, i,
    ff_last;
  for(i=0, ff_val = 0, ff_last = 0; i<w->d_files; i++) 
    {
      ff_val = ff_strcmp( filename, W_FILE( i));
      if( ff_val > ff_last) 
	{
	  w->akt_pos = i;
	  ff_last = ff_val;
	}
    }

  w->akt_pos =
    w->old_pos = min( w->d_files - 1, max( 0, w->akt_pos));
  w->anf_pos = max( 0, w->akt_pos - w->f_maxfiles / 2 + 1);
  w->anf_pos -= max( 0, w->f_maxfiles - ( w->d_files - w->anf_pos));
  w->anf_pos = max( 0, w->anf_pos);
  
  if( w->akt_pos != old_srch) w_outdir( w, w->anf_pos);
}

#define SYMBOL_WIDTH	20

void symbol_path (struct win_t * w)
{
  int i ;

  if (w->symbol == NULL) make_symbol (w);

  f_putstr   (w->symbol,
	      0,
	      w->symbol->rows - 1,
	      leer,
	      w->symbol->color,
	      FILL_MODE
	      );
  /*
   * view path under the icon
   */
  i = strlen (cutpath (w->path, w->symbol->width, NOMODE));
  f_putstr   (w->symbol,
	      (w->symbol->width-i)/2,
	      w->symbol->rows - 1,
	      cutpath (w->path, w->symbol->width, NOMODE),
	      w->symbol->color,
	      NOMODE
	      );
}

void make_symbol (struct win_t * w)
{
  static int symbol_x = 2 ;
  char * window = "Window";
  char tmp [32] ;
  int  i ;
  w->symbol = make_frame (symbol_x,
			  max_y - 7,
			  SYMBOL_WIDTH,
			  3,
			  leer, leer,
			  F_B_NORMAL,
			  NOBOX_MODE);
  symbol_x = (symbol_x + SYMBOL_WIDTH + 2) % (max_x-SYMBOL_WIDTH) ;
  i = strlen  (window);
  f_putstr    (w->symbol,
	       (SYMBOL_WIDTH-i)/2,
	       0,
	       window,
	       w->symbol->color,
	       NOMODE);
  sprintf     (tmp, "%02i", MY_cfg.akt_w + 1);
  i = strlen  (tmp);
  f_putstr    (w->symbol,
	       (SYMBOL_WIDTH-i)/2,
	       1,
	       tmp,
	       w->symbol->color,
	       NOMODE);
  symbol_path (w) ;
}





