/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: dowin.h,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/dowin.h,v $
 */

#ifndef GLOBAL
#define GLOBAL
#endif

#ifndef DOWIN_HH
#	define DOWIN_HH

#ifdef DOS
#include <sys/stat.h>
#include <dir.h>
#endif

#include "dodefs.h"
#include "doframe.h"
#include "dochoose.h"

#define MAX_COM_LEN             200              /* command line length **/

#ifdef UNIX
#    define MAX_COL_LEN     125     /* max. file name length under UNIX */
#    define COL_WIDTH       19     /* filename-length by normal view-mode */
#    define COL_WIDTH_LONG  14     /* filename-length by long-view-mode */
#else
#    define COL_WIDTH       13     /* filename-length by normal view-mode */
#    define COL_WIDTH_LONG  13     /* filename-length by long-view-mode */
#    define MAX_COL_LEN     13
#endif

#define CHS_CLEAR	0x0001	/* w_choose */
#define LOCK_DIR_MODE   0x0002  /* for read directory and position */
#define VIEW_POINTS	0x0004  /* to view points on the screen */

#define NEXTWIN_MODE    0x0001  /* w_change_win */
#define PREVWIN_MODE    0x0002

#define SIMPLE          0x0001  /* make_win, simple list mode */
#define LONG_MODE       0x0002  /* long list mode */

struct dir_in_t {
	char   f[ MAX_COL_LEN+1];     /* file-name */
	long   sort;                  /* for sort methodes */
	short  m;                     /* mode */
	short  s;                     /* to mark the selected files */
	};

struct win_t {
     struct stat     ** f_stat;
     struct frame_t   * f;
     struct frame_t   * symbol ;	/* symbol viewed, when frame hidden */
     struct frame_t   * link_f; 	/* to view links */
     struct choose_t  * ch;
     struct choose_t  * ch1;
     struct choose_t  * ch2;
     struct dir_in_t ** dr;                            /* double pointer */

     char path   [ MAXPATH];                /* in DOS is MAXPATH defined */
     char cur_dir[ MAX_COL_LEN];   /* the current directory without path */
     char filter [16];              /* filter for names */
#ifdef DOS
     int  drive;        /* for dos, you must give the drive number */
     int  f_attr;       /* attribute of files to view */
#endif

     long sel_size;
     int view_size;

     int
	begin_at,      /* sort begining at .. <for dos the root begins at 0*/
	selected,      /* count of selected files */
	unselect,      /* to unselect the directory, wenn changed the path */
	view_mode,     /* long/simple list or viewed/hidden window */
	long_outbegin, /* out begin of long info, only by long mode */
	sort_methode,  /* Sort methode <name, modify.create.assecc time> */
	which_time,    /* select the time to view <modify, create or assicc>*/
	akt_pos,
	old_pos,
	f_pos,        /* position in the frame of window **/
	anf_pos,
	rahmen_out,
	fr_out,                /* view window */
	new_read,              /* reread directory */
	d_files,               /* count of files in the current directory **/
	f_maxfiles,            /* max. viewed files on one frame */
	files_on_f;            /* viewed files on the frame */
    };


GLOBAL void   w_changesort ( struct win_t * w);
GLOBAL void   w_sortfiles  ( struct win_t * w, int mode);
GLOBAL void   w_gettype    ( struct win_t * w, int pos);
GLOBAL int    w_outfile    ( struct win_t * w, 
		      int pos, 		/* position on the frame */
		      int mode);             /* modes */
GLOBAL void   w_outdir     ( struct win_t * w, int pos);
GLOBAL void   w_readdir    ( struct win_t * w, char * dir_, int mode);
GLOBAL void   w_choose     ( struct win_t * w, int x, int y, int pos, int mode);
GLOBAL struct win_t * chs_win( void);

		         /* to scroll the window forwards or backwords */
GLOBAL void   w_scroll_win ( struct win_t * w, int n, int mode);  

GLOBAL struct win_t * make_win
		    ( int x, int y, int to_x, int to_y, int viewmode);
GLOBAL void   del_win      ( struct win_t * w);

GLOBAL struct win_t * w_change_win
		    ( int mode );

GLOBAL void   view_win     ( struct win_t *, struct win_t *, int );

GLOBAL struct dir_in_t *   make_dir
		    ( void);  /* directory for window */
GLOBAL void   del_dir      ( struct dir_in_t * dr);

GLOBAL int    w_strcmp     ( const char * s1, const char * s2);	/* for sort alg. */
GLOBAL int    w_swap       ( const int pos1, const int pos2);	/* for sort alg. */
GLOBAL int    w_longcmp    ( const int pos1, const int pos2);	/* for sort alg. */
GLOBAL int    w_shortcmp   ( const void * a, const void * b);	/* for sort alg. */
GLOBAL int    w_strcmp_pos ( const int pos1, const int pos2);	/* for sort alg. */
GLOBAL void   w_swap_LONG  ( const int pos1, const int pos2); /* for sort alg.*/
GLOBAL void   w_view_hide_win ( int num);
GLOBAL int    w_filter        ( struct win_t * w, frame_T ff);
GLOBAL void   w_reposition    (struct win_t * w);
GLOBAL void   w_lockfor       (struct win_t * w, char * filename);
GLOBAL void   make_symbol     (struct win_t * w) ;
GLOBAL void   symbol_path     (struct win_t * w);
#endif /*_HH*/

