/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: khview.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/khview.c,v $
 */

#	define GLOBAL

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/stat.h>
#include <errno.h>
#include <dirent.h>

#include <time.h>
#include <sys/timeb.h>
#include <malloc.h>
#include <fcntl.h>

#ifdef UNIX

#include <termio.h>
#include <string.h>
#include <sys/types.h>
#include <grp.h>
#include <pwd.h>
#include <signal.h>
#include <sys/wait.h>
#include <sys/param.h>
#include <sys/sysmacros.h>
#ifdef SCO_UNIX
#include <sys/page.h>
#include <sys/event.h>
#endif

#ifdef SCO_UNIX
#include <tinfo.h>		/* KEY_NUMBER is defined in this file */
#include <sys/console.h>
#include <mouse.h>
#endif

#include <curses.h>

#else			/* ifdef UNIX */

#include <dos.h>
#include <conio.h>
#include <io.h>
#include <dir.h>
#include <string.h>
#endif

#include "dodefs.h"
#include "doglobal.h"
#include "dolib.h"
#include "dowin.h"
#include "doscr.h"
#include "docfg.h"
#include "doabout.h"
#include "dochoose.h"
#include "docrypt.h"
#include "dodirent.h"
#include "doedit.h"
#include "dofiles.h"
#include "dofind.h"
#include "doframe.h"
#include "dogrep.h"
#include "dohexa.h"
#include "doinit.h"
#include "domem.h"
#include "domenu.h"
#include "domsg.h"
#include "dostat.h"
#include "dostern.h"
#include "dostring.h"
#include "dotcap.h"
#include "dotext.h"
#include "doutil.h"
#include "doqsort.h"
#include "doerror.h"
#include "dostern.h"
#include "dofiles.h"
#include "domem.h"
#include "dogrep.h"
#include "dotext.h"
#include "doabout.h"
#include "docfg.h"
#include "dohist.h"
#include "dofind.h"
#include "dodir.h"
#include "docopy.h"
#include "docdrom.h"


#	define MAXBUF	1024

void view_usage( char * prg) {
    fprintf( stderr, "Usage: %s <file>\n", prg);
    }

void main( int argc, char * argv[]) {

#ifdef DOS
    int old_x = wherex(), old_y = wherey();
#endif

    char * tmp_file = NULL,
	 * f_name,
	 tmp[MAXBUF],
	 c,
	 * file;
    int  file_h,
	 i,
	 pipe_ = TRUE;

    argc_ = argc;
    argv_ = argv;

    strcpy( prog_path, argv[0]);

    if( argc >= 2) {
	file = argv[1];
	for( i=1; i<argc; i++) argv[i] = argv[i+1];
	argc = argc_ = argc - 1;
	pipe_ = FALSE;
	}

    init_values(&MY_cfg);

    fflush_();

    if( pipe_) {                             /* from standard input     */

#ifdef UNIX
	SET_TTY( &oldtty);
#endif

	tmp_file = file = tempnam(
#ifdef DOS
				"\\",
#else
				"/tmp",
#endif
				"KH");
	if( tmp_file == NULL) {
	    message( " Temporary file can't created ", leer);
	    quit( 1);
	    }
					     /* write pipe into temp. file */

	file_h = creat( tmp_file, S_IWRITE|S_IREAD);             /* create */

	for( i = 0; c = getchar(), TRUE; ) {
	    if( i>=MAXBUF || c == EOF) {
		write( file_h, tmp, i);
		i = 0;
		}
	    if( c == EOF) break;
	    tmp[ i++] = c;
	    }
	close( file_h);

        clrscr_();

#ifdef UNIX

	fclose( stdin);                 /* close duped INPUT */

	if( freopen( "/dev/tty", "r", stdin) == NULL) {
		perror("reopen stdin");
		quit(1);
		}

	GET_TTY( &oldtty);
	GET_TTY( &mytty );

        oldtty.c_lflag    |= ICANON | ECHO  | IGNBRK;
        oldtty.c_cc[ VEOF] = CTRL_D;

        mytty.c_lflag     &= ~ ICANON & ~ ECHO  & ~ IGNBRK;
        mytty.c_cc[ VMIN ] = 0;
        mytty.c_cc[ VTIME] = 5;
	SET_TTY( &mytty);
#else
	fclose( stdin);                 /* close duped INPUT */
					/* open the con: standard input */
	if( freopen( "con", "r", stdin) == NULL) {
		perror("reopen stdin");
		quit(1);
		}
#endif
	}

    fflush_();
    fflush( stderr);

    f_putstr( title_f, 0, 0, " Khamis Viewer Version 1.0, CopyRight 1994",
	      title_f->color, NOMODE);
    hide_frame( title_f, HIDE_MODE);
    view_frame( title_f);

    fflush_();

    sprintf( tmp, " %s ", file);
    view_file( file, tmp, 0, 1, max_x, max_y-2, NULL, 1024, NOMODE);

    if( tmp_file != NULL) {
	remove( tmp_file);
	Free  ( tmp_file);
	}

    hide_frame( title_f, HIDE_MODE|DELETE_MODE);

#ifdef DOS
    gotoXY( old_x-1, old_y-1);
#else
    gotoXY( 0, max_y); put_str("\n");
#endif

    fflush_();
    quit( 1);
    }
