/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/* Funktionsname=fileutil.h, SID=1.5, Date=95/09/25 */

/****************************************************************************/
/**                  							   **/
/****************************************************************************/

#ifndef FILEUTIL_HH
#define FILEUTIL_HH

#include <sys/types.h>
#include "defines.h"

#define FILE_END	43000000
#define FILE_BEG	0x00000000

#define EXEC_FILE	0x0001
#define DATA_FILE	0x0002
#define TEXT_FILE	0x0004
#define DIR_SYMLINK	0x0002

#define RECURSIVE_MODE	0x0001

#define get_rights() (~ get_umask (FALSE) & 0777)
#define C_G_X(m) ((m) & S_IXGRP)  /* group execute */
#define C_G_W(m) ((m) & S_IWGRP)  /* group write */
#define C_G_R(m) ((m) & S_IRGRP)  /* group read */

#define C_O_X(m) ((m) & S_IXUSR)  /* user */
#define C_O_W(m) ((m) & S_IWUSR)  /* user */
#define C_O_R(m) ((m) & S_IRUSR)  /* user */

#define C_A_X(m) ((m) & S_IXOTH)  /* other */
#define C_A_W(m) ((m) & S_IWOTH)  /* other */
#define C_A_R(m) ((m) & S_IROTH)  /* other */


EXTERN int 	UFileExists		( char * file);
EXTERN int 	UFileIsDir		( char * dr);
EXTERN int 	UFileIsFile		( char * file);
EXTERN int 	UFileOwner	( char * file);
EXTERN int 	UFileGroup	( char * file);
EXTERN long 	UFileSize	( char * file);
EXTERN int 	UFileCanWrite	( char * file);
EXTERN int 	UFileCanRead	( char * file);
EXTERN int     UFileCanExec	( char * file);
EXTERN unsigned short UFileStat	( char * file);
EXTERN int 	UCreateDir	( char * dr, int mode);
EXTERN int	UFileType	( char * file);
EXTERN int     UFileRename      (char * file, char * newname);

EXTERN long	UFileFindString	(int fdesc, char * str, int mode);
EXTERN int	UFileReadLine    (int fdesc, char *buf, int len, int mode);
EXTERN int	UFileCopyPart	(int fsrc, int fdesc, long beg, long end);

EXTERN char *  UPathAppend     (char * path1, char * path2);
EXTERN char *  UDirName	(char * path);

/********* Moegliche Werte fuer mode ******************************************/
/********* False: Umask mit Exec-Rechte, dies ist sinnvoll fuer Directories ***/
/********* True:  Umask ohne Exec-Rechte, dies ist sinnvoll fuer reg. Dateien */
mode_t 	UGetUmask	( int mode);
#endif /*_HH*/

