/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: copy.h,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khlib/include/RCS/copy.h,v $
 */
/* Funktionsname=%M%, SID=%I%, Date=%E% */

#ifndef COPY_H
#define COPY_H

#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <sys/param.h>
#include <fcntl.h>

#define CPY_ASK			0x0001
#define CPY_RECURSIVE		0x0002
#define CPY_CANCEL		0x0004
#define CPY_ALL			0x0008
#define CPY_YES			0x0010
#define CPY_NO			0x0020
#define CPY_SAME_OWNER		0x0040
#define CPY_SAME_GROUP		0x0080
#define CPY_SAME_RIGHTS		0x0100
#define CPY_ERROR		0x0200
#define CPY_DISK_ERROR		0x0400
#define CPY_OVERWRITE		0x0800
#define CPY_SKIP_EXISTING	0x1000
#define CPY_COPY_LINKS		0x2000
#define CPY_ERROR_AVAIL		0x4000
#define CPY_MOVE		0x8000

typedef struct
{
  char * filter;
  char * copy;
  char * donotCopy;
  int (* ViewProc) (int, int, void *);
  int (* ViewFilesProc) (Dchain_t, Dchain_t, void *);
  int (* AskProc ) (Dchain_t, Dchain_t, void *);
  int (* AskOverwriteProc) (Dchain_t, Dchain_t, void*);
  int (* ErrProc ) (Dchain_t, void *);
  void * ClData;
  unsigned long mode;
} copyInfo_t, * CopyInfo_t;

int RecursiveCopy (Dchain_t src,
		   Dchain_t dst,
		   CopyInfo_t cpy_info);
#if 0
		   char * filter,
		   char * copy,
		   char * donotCopy,
		   int (* ViewProc) (int, int, void *),
		   int (* ViewFilesProc) (Dchain_t, Dchain_t, void *),
		   int (* AskProc ) (Dchain_t, Dchain_t, void *),
		   int (* ErrProc ) (Dchain_t, void *),
		   void * ClData,
		   int mode;
#endif
int CopyFile (Dchain_t src, Dchain_t dest,
	      CopyInfo_t cpy_info);
#if 0
	      char * filter,
	      int (* ViewProc) (int, int, void*),
	      void * ClData,
	      int mode;
#endif

#endif
