/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: dodirent.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khlib/include/RCS/dodirent.c,v $
 */

#define GLOBAL extern
#define EXTERN

#include "dodirent.h"

#ifdef XENIX

DIR * MY_opendir( char * pth) {
    DIR * dirp;
    int d_d = open( pth, O_RDONLY);
     
    if( d_d < 0) return( NULL);
   
    dirp = getmem (sizeof( DIR));
  
    dirp->dd_fd  = d_d;
    dirp->dd_buf = pth;

    return( dirp);
    }

void MY_closedir( DIR * dirp) {
    close( dirp->dd_fd);
    Free( dirp);
    }

struct dirent * MY_readdir( DIR * dirp) {
    static struct dirent dd;
    char buf[ 16];

    int len,
	pos,
	f_pos = 0,
	found = FALSE,
	cnt   = 0;
    unsigned int akt_ino = 0;
	
    for( cnt = 0;
	 (len = read( dirp->dd_fd, buf, 16) ) > 0;
	 ) {

	dd.d_ino = (ino_t) * buf;

	if( dd.d_ino == 0) {
	    cnt = f_pos = 0;
	    continue;             /* file not exists (removed) */
	    }

	if( cnt == 0) akt_ino = dd.d_ino;
	else {
	    if( akt_ino != dd.d_ino) {
		lseek( dirp->dd_fd, - 16, SEEK_CUR);
		break;
		}
	    }

	cnt++;

	for( pos = 2; pos < len; pos++) dd.d_name[ f_pos++] = buf[ pos];
	
	dd.d_name[ f_pos] = 0;

					      /* found a not removed file */
	if( buf[ pos-1 ] == 0) {
            found = TRUE;
	    break;
	    }
	}

    return( found || f_pos > 0 ? &dd : NULL);
    }

#endif
