/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: sort.h,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khlib/include/RCS/sort.h,v $
 */

#ifndef EXTERN
#define EXTERN
#endif

#ifndef SORT_HH
#define SORT_HH

#define CASES_MODE	0x0001   /* littel or big letters ignore */

EXTERN void OTT_qsort( 
		      void * ClData,
		      int l, 				/* first element */
		      int r, 				/* last element */
		      int (*compare) (const int, const int, void*), /* compare function */
		      int (*swap   ) (const int, const int, void*)); /* swap function */

EXTERN int bin_srch( void * v,  /* the element to search */
		     void * kette,
		     int cnt,   /* count of elements */
		     int len,
		     int ( * compare) ( const void *, const void *));
EXTERN long power  ( long a, int n);

/*****************************************************************************/
/* String Matching 							     */
/* Alg. from Knuth, Morris und Pratt 					     */
/* With this alg. it is possible to test the string matching in only 	     */
/* O( n + m) time 							     */
/* n-Faktor is the length of the string in it to search 		     */
/* m-Faktor to calculate the suffix and prefix in the string to find 	     */
/*****************************************************************************/

EXTERN int  strfind      (char * s, char * p);
EXTERN int  nstrfind     (char * s, char * p, int n, int m);
EXTERN int  case_strfind (char * s, char * p, int n, int m, int mode);

#endif  /* _HH */
