/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/* Letzte Aenderung: Mon May 15 14:09:55 MDT 1995 durch: V.Saueressig */
/* Letzte Aenderung: Thu Feb  9 15:12:27 MET 1995 durch: D. Kunitz */
/* Letzte Aenderung: Thu Nov 24 14:15:20 MET 1994 durch: G. Kowalewski */
/* Letzte Aenderung: Fri May  6 11:15:57 MDT 1994 durch: Ch. Mueller */
/* Letzte Aenderung: Wed May  4 17:41:15 MDT 1994 durch: Ch. Mueller */
/* Letzte Aenderung: Wed May  4 17:39:38 MDT 1994 durch: Ch. Mueller */
/**** stdfunc.h:  Include-File fuer allgemeine Funktionen der Std.-Library ***/
/**** Version 2.0 ************************************************************/

#ifndef STDFUNC_H
#define STDFUNC_H

#include <stdio.h>
#include <stdlib.h>

#if !defined (_STDFUNC)
#define _STDFUNC
#endif

#ifndef EXTERN
#define EXTERN	extern
#endif

/********** Konstantendefinitionen ********************************/
/*#define LEN_ERRSTRING	256*/	/** Max. Laenge einer Fehlerbeschreibung **/
#define LEN_ERRSTRING	5000	/** Max. Laenge einer Fehlerbeschreibung **/
/*#define MAXLEN_CNFLINE  512*/ /** Max. Laenge einer Zeile in cnf-Datei **/
#define MAXLEN_CNFLINE  4096	/** Max. Laenge einer Zeile in cnf-Datei **/
#define MAX_LEN_CMDARG	50	/** Max. Laenge eines Kdo-Zeilenargs     **/
				/** fuer wr_trace ()			 **/
#define MAX_DESCR_LEN	80	/** Max. Laenge Bezeichnungseintrag in *.cnf**/
#define MAX_VAL_LEN	200	/** Max. Laenge Werteintrag in .cnf (=x) **/
#define MAX_LEN_USER	8	/** Max. Laenge eines User-Logins	 **/
#define EXIT		0	/** Flag fuer Programmabbruch in Fehler- **/
				/** behandlung			         **/
#define NO_EXIT		1	/** exit() in Fehlerbehandlung           **/

#define RCHAR		register char
#define RINT		register int
#define RSHORT		register short
#define RLONG		register long
#define RUCHAR		register unsigned char
#define RUSHORT		register unsigned short
#define RULONG		register unsigned long

#if defined (ALPHA_SOURCE) && 0
typedef unsigned short ushort;
typedef unsigned long ulong;
#endif /* ALPHA_SOURCE */

#if !defined (ALPHA_SOURCE)
#if !defined (_H_TYPES)
#include <sys/types.h>
#endif /* _H_TYPES */
#endif /* ALPHA_SOURCE */

#define BIT_0	1
#define BIT_1	2
#define BIT_2	4
#define BIT_3	8
#define BIT_4	16
#define BIT_5	32
#define BIT_6	64
#define BIT_7	128
#define BIT_8	256
#define BIT_9	512
#define BIT_10	1024
#define BIT_11	2048
#define BIT_12	4096
#define BIT_13	8192
#define BIT_14	16384
#define BIT_15	32768


/********* Die Struktur msgbuf wird fuer das Meldungshandling benoetigt ******/
/********* Durch das define "_XOPEN_SOURCE" wird sie allerdings nicht def. ***/
/********* unter Interactive erfolgt das Einbinden automatisch ***************/
#ifdef ALPHA_SOURCE
struct msgbuf {
        long    mtype;          /* message type eigentlich definiert als */
				/* mtyp_t in ipc.h. Definition erfolgt hier */
				/* als long, um ein generelles Einbinden */
				/* der ipc.h in alle Sourcen zu verhindern */
        char    mtext[1];       /* message text */
};
#endif /* ALPHA_SOURCE */


/********** Struktur fuer die verkettete Liste *******************************/
struct chain_elem
{
  char* p_data;
  struct chain_elem* prev;
  struct chain_elem* next;
};
typedef struct chain_elem chain_elem;

/********** Funktionsprototypen, Dateihandling  *******************/
EXTERN void 	Uerr_open  ( char *pfad, char *mode,  int iexit);
EXTERN void 	Uerr_close ( char *pfad, FILE *handle, int iexit);

EXTERN void 	Uerr_write ( char *pfad, FILE *handle, int iexit);
EXTERN void 	Uerr_read  ( char *pfad, FILE *handle, int iexit);
EXTERN FILE*	Udat_open  ( char *path, char *mode, int iexit);
EXTERN void 	Udat_close ( char *path, FILE *handle, int iexit);
EXTERN int	Uget_line  ( char* file, FILE* fp, char* zeile, char com);

/********** Funktionsprototypen, Prozesshandling *******************/
EXTERN void 	Uerr_fork  ( int pid, int chid);
EXTERN void 	Uerr_exec  ( int pid, int name);  

/********** Funktionsprototypen, IPC *******************************/
EXTERN int	Uinitshm 	( int key, int size, int shmflag );
EXTERN void	Udestroyshm	( int shmid);
EXTERN void*	Ush_attach	( int shmid, int shflag);
EXTERN void	Ush_detach	( void*	shaddress );
EXTERN void	Uerr_shmat	( int shmid, int shflag);
EXTERN int	Ucreate_msg	( char* file, int proj_id, int perms);
EXTERN void	Udestroy_msg	( int msqid); 
EXTERN void 	Ushm_stat       ( int shmid);
EXTERN int     Ucreatesem      ( char* file, int proj_id, int perms, int nsems );
EXTERN void	Urmsem		( int semid);
EXTERN void	Usetsem		( int semid, int semnum, int semval);
EXTERN int 	Uopsem 		( int semid, int semnum, int semval, int semflag );


/********** Funktionsprototypen, IPC - Fehlerbehandlung ************/
EXTERN void	Uerr_shmget ( int shmid, int size);
EXTERN void	Uerr_shmctl ( int shmid, int ctlact, int iexit);
EXTERN void	Uerr_shmat  ( int shmid, int shflag);
EXTERN void	Uerr_shmdt  ( void* shaddress, int iexit);
EXTERN void 	Uerr_msg_cr ( char* file, char proj_id, int perms);
EXTERN void 	Uerr_msg_de ( int msqid); 

/********** Funktionsprototypen, Zeitbearbeitung *******************/
EXTERN void	Uget_time_str	( char* timestring);
EXTERN void	Ugettimestr	( char* timestring);


/********** Sonstiges **********************************************/
EXTERN void	Uname_trace  ( char* pname, char* trname);
EXTERN FILE*	Uopen_trace  ( char* cname );
EXTERN void	Uwr_trace    ( char* text );
EXTERN void	Uwr_st_trace ( void);
EXTERN char*	Ucp_args    ( char* dest, char* source, char cut);
EXTERN char*	Ucpargstxt  ( char* dest, char* source, char cut);
EXTERN int	Uget_arg    ( char* zeile, char* carg, int iarg, char cut);
EXTERN int	Ugetargtxt  ( char* zeile, char* carg, int iarg, char cut);
EXTERN int	Uget_val    ( char* data);

/********** Prototypen fuer Konfigurationsdateibehandlungen ********/
EXTERN void 	Uerr_cnf	    ( char* text); 
/*int	readcnf     ( char* cnfdat, void (*auswertf) (char* zeile), char com );*/
EXTERN int	Ureadcnf     ( char* cnfdat, void (*) (char* ), char com );
EXTERN int 	U_readcnf (char* cnfdat, void(*auswertf) (char* zeile), char com);
EXTERN int	Uset_paragraph ( char* zeile );
EXTERN void    Uread_val    ( char* zeile, char* val);
EXTERN char*	Uread_descr  ( char* zeile, char* descr);
EXTERN char*	Uset_path    ( char* dest_path, char* src_path, char* file);
EXTERN int	Ui_cnf_gen   ( char* name, char* wert);

/********** Prototypen fuer Kommandozeilenroutinen + Umgebung ******/
EXTERN void 	Uerr_cmdlin  ( char* err_mess , char* err_cause);
EXTERN void	Urcmdlin    ( int argc, char** argv, void (*i_func)(char*, char*) );
EXTERN void    Uerr_env     ( char* vname);
EXTERN void	Ui_cmd_gen   ( char* name, char* wert);
EXTERN int	Ui_cmd_spez  ( char*, char*);
EXTERN void	Ui_cmdlin    ( int argc, char** argv, int (*i_cmd_gen) (char*, char*),
					     int (*i_cmd_spez) (char*, char*) ); 
/********** Funktion zur Bearbeitung verketteter Liste *************/
EXTERN chain_elem* Uchainwr  ( chain_elem* start, char* (*makedata) ());
EXTERN void        Uchainre  ( chain_elem* start, long start_ind, long anz_elem,
                        void (* read_data) (char* p_data));
EXTERN chain_elem* Udel_elem ( chain_elem* start, long delete_ind,
                        void (* free_data) (char* p_data));

/********** Allgemeine utility-Funktionen **************************/
EXTERN char* Urm_blank (char* clean_line, char* orig_line);
EXTERN int     Ustrucp   (char* dest, char* src, int len);
EXTERN void* Umalloc ( int );
EXTERN unsigned long Upowertwo ( int );
EXTERN char*	Uconvbit ( char* , int , long*);
EXTERN double  Uatof ( char* s);  
EXTERN void 	Udummy ( void );
EXTERN double  Uabsdbl( double dbl_val);
EXTERN char*   Uhextostr ( char* src, char*dest, size_t size);
EXTERN char*   Ucrypt (char* pwd);

/********** Allgemeine Fehler-Funktionen  **************************/
EXTERN void Uerr_alloc (char* err_mess);	
EXTERN void Uerr_atoi  (char* data);
EXTERN void Uerr_getarg(int argnr, char* zeile);
EXTERN void Uerrfatal  ( char* text);

/********** Funktionen zum internen Softwaretest, INTERNE SOFTWARE ***********/
EXTERN void 	Utesthead	(char* funcname );

#endif
