/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: util.h,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khlib/include/RCS/util.h,v $
 */

#ifndef EXTERN
#define EXTERN
#endif

#ifndef UTIL_HH
#define UTIL_HH

#ifndef DOS
#include <pwd.h>
#include <grp.h>
#endif

#define ANOTHER_MODE   		0x8000
#define SAMEOWNER_MODE		0x4000      /* same owner */
#define SAMEGROUP_MODE		0x2000	    /* same group by copying */
#define SAMERIGHTS_MODE		0x1000	    /* same group by copying */

#ifdef UNIX
#	define FILELEN        256
#else
#	define FILELEN	       16
#endif

#ifndef mode_t
#	define mode_t unsigned short
#endif

#ifdef DOS
#	define BetDir '\\'
#else
#	define BetDir '/'
#endif

/* week days and month names*/
#ifdef IS_EXTERN
EXTERN char * week[];
EXTERN char * month[];
#else
EXTERN char * week[]  =
{
  "Su", "Mo", "Tu", "We",
  "Th", "Fr", "Sa"
};
EXTERN char * month[] =
{
  "Jan", "Feb", "Mar", "Apr",
  "May", "Jun", "Jul", "Aug",
  "Sep", "Oct", "Nov", "Dec"
};
#endif

#ifndef DOS
/* user list */
typedef struct passwd * UserList_t, userList_t;
Dchain_t usrAdd      (Dchain_t top, char * Name);
int      usrDest     (UserList_t lst);
int  	 usrReadList (Dchain_t top);
char * 	 usrNameById (Dchain_t, int);
int	 usrIdByName (Dchain_t top, char * name);
#define  usrName(usr) ((usr == NULL) \
		      ? NULL \
		      : ((UserList_t)UdchClient (usr))->pw_name)
#define  usrId(usr) ((usr == NULL) \
		     ? -1 \
		     : ((UserList_t)UdchClient (usr))->pw_uid)
#define usrRemove(lst) UdchEmptyAndDel(lst,(int(*)(void*))usrDest)

/* group list */
typedef  struct group * GrpList_t, grpList_t;
Dchain_t grpAdd      (Dchain_t top, char * Name);
int      grpDest     (GrpList_t lst);
int  	 grpReadList (Dchain_t top);
char * 	 grpNameById (Dchain_t, int);
int	 grpIdByName (Dchain_t top, char * name);
#define  grpName(grp) ((grp == NULL) \
		      ? NULL \
		      : ((GrpList_t)UdchClient (grp))->gr_name)
#define  grpId(grp) ((grp == NULL) \
		     ? -1 \
		     : ((GrpList_t)UdchClient (grp))->gr_gid)
#define grpRemove(lst) UdchEmptyAndDel(lst, (int(*)(void*))grpDest)
#endif

#if 0
int 	change_ownergrp ( char * pth, int owner, int grp);
void 	get_restdir	( char *src, char *dest);
void 	get_filename	( char *src, char *dest);

/** copy */

int copy                  ( struct frame_t * f,
			   char * src, char * dest, char * filter, int * mode);

EXTERN void copy_file     ( struct win_t * w);
EXTERN int  recursive_copy( struct frame_t *f, 
			    char * file, 
			    char * dst, 
			    char * filter,
			    int * mode);
EXTERN void  change_mode   ( struct win_t * w); /* change the mode of files */
EXTERN int   recursive_change_mode
			   ( struct frame_t * f, 
			     char * file,
			     int f_mode, int mode);
EXTERN void  remove_file   ( struct win_t * w);  /* remove aktual file */
EXTERN int   recursive_remove                    /* recurse remove */
			   ( struct frame_t * f, char * file, int mode);
EXTERN void   findfile      ( struct frame_t * f,
			      int    f_y,
			      int    file_h,
			      char * path,
			      char * name);
#endif /* if 0 */

#if 0
#ifdef UNIX
EXTERN void  change_owner  ( struct win_t * w);  /* change owner/grp of files */
EXTERN int   recursive_change_owner
		    ( struct frame_t * f,
		      char * file,
		      int new_uid,
		      int new_gid,
		      int mode);
#endif

EXTERN void   view_size     ( struct win_t * w);
EXTERN int    new_dir       ( void);
#endif /* #if 0 */

#endif /*_HH*/
