/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: mem.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khlib/khmisc/RCS/mem.c,v $
 */

#define IS_EXTERN
#define EXTERN		extern

#include <stdlib.h>
#include "defines.h"
#include "Umem.h"
#include "Umessage.h"

#ifndef max
#define max(a,b) ((a) >= (b) ? (a) : (b))
#define min(a,b) ((a) <= (b) ? (a) : (b))
#endif

#ifdef DEBUG_VIEWMEM
#include "Udchain.h"

int MemCalls = 0;
static int active = False;
static long mem_counter = 0;

static Dchain_t memList = NULL;

/** mem history **/
typedef struct
{
  void *Ptr;
  long Size;
  long Counter;
  char * Type;
  int Line;
  char * File;
} *Mem_t, mem_t;
Mem_t memMake (void* p);
int memCompare (Mem_t m, void *p);
int memDest (Mem_t m);
#define memItem(m,item) ((Mem_t)UdchClient(m))->item
#define memAdd(m, p) UdchAdd (m, p, (void*(*)(void*))memMake, \
			      (int(*)(void*,void*))memCompare)
#define memDel(m) UdchDelete(m, (int(*)(void*))memDest)
#define memFind(m,p) UdchFind(m,p,(int(*)(void*,void*))memCompare)

Mem_t memMake (void* p)
{
  Mem_t m = malloc (sizeof (mem_t));
  m->Ptr = p;
  return m;
}
int memCompare (Mem_t m, void *p)
{
  if (m->Ptr == p)
    return 0;
  return 1;
}
int memDest (Mem_t m)
{
  free (m);
  return True;
}
void memNotFreed (void)
{
  Dchain_t dch;
  for (dch=UdchNext (memList);
       dch != NULL;
       dch = UdchNext (dch))
    {
      WARNING6 ("unfreed cnt=%li, size=%li, type=%s, line=%i, file=%s\n",
		memItem(dch, Counter),
		memItem(dch, Size),
		memItem(dch, Type),
		memItem(dch, Line),
		memItem(dch, File)
		);
      if (strcmp (memItem(dch, File), "/home/xkhfm/khlib/khmisc/strutil.c") == 0)
	WARNING2 ("strvalue[%s]\n", memItem(dch, Ptr));
    }
  WARNING2 ("Total Size of unfreed memory = %li\n", bufUsage);
}
#endif

#ifdef DEBUG_VIEWMEM
void * gmalloc (long size, int line, char * file)
#else
void * GMalloc (unsigned long size)
#endif
{
  int nsize = max (1, size);
  void * p;

  p = calloc (1, nsize);
  if (p == NULL)
    {
      perror ("gcalloc");
      ERROR2 ("gmalloc: No more availiable memory, size=(%i)\n", size);
      exit   (1);
    }

#ifdef DEBUG_VIEWMEM
  bufUsage += nsize;
  MemCalls ++;
  
  if (!active)
  {
    Dchain_t mm;
    active = True;
    /* register allocated */
    if (memList == NULL) memList = memAdd (NULL, NULL);
    mm = memAdd (memList, p);
    memItem (mm, Counter) = mem_counter++;
    memItem (mm, Size) = size;
    memItem (mm, Type) = "malloc";
    memItem (mm, Line) = line;
    memItem (mm, File) = file;
    active = False;
  }
#endif

  return p;
}

#ifdef DEBUG_VIEWMEM
void * gcalloc (long size, int line, char * file)
#else
void * GCalloc (unsigned long size)
#endif
{
  int nsize = max (1, size);
  void * p;

  p = calloc (nsize, 1);
  if (p == NULL)
    {
      perror ("gcalloc");
      ERROR2 ("gcalloc: No more availiable memory, size=(%i)\n", size);
      exit   (1);
    }

#ifdef DEBUG_VIEWMEM
    bufUsage += nsize;
    MemCalls ++;
    
  if (!active)
  {
    Dchain_t mm;
    active = True;
    /* register allocated */
    if (memList == NULL) memList = memAdd (NULL, NULL);
    mm = memAdd (memList, p);
    memItem (mm, Counter) = mem_counter++;
    memItem (mm, Size) = size;
    memItem (mm, Type) = "calloc";
    memItem (mm, Line) = line;
    memItem (mm, File) = file;
    active = False;
  }
#endif

  return p;
}

#ifdef DEBUG_VIEWMEM
#include "Xinc.h"
#include "Uxutil.h"
#include "Umessage.h"

int MFree (void*ptr, int size)
{
  free (ptr);
  bufUsage -= size;
  memDel (memFind(memList, ptr));
  return True;
}

void ViewMemUsage (void * w, void * b)
{
  char tmp [1024];
  sprintf (tmp, "Bisher deklarierter Speicher: (%li)", bufUsage);
  MessageBox (GetTopShell (w),
	      "Bufferusage",
	      tmp,
	      XmDIALOG_INFORMATION,
	      OK_BUTTON,
	      NULL,
	      NULL);
}
#endif

