/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: readarg.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khlib/khmisc/RCS/readarg.c,v $
 */
#define IS_EXTERN
#define EXTERN extern

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "Xinc.h"
#include "defines.h"
#include "Ureadarg.h"

int Ureadarg ( char* zeile, char * carg, int iarg, char cut )
{
  /********* Definitionen ****************************************************/
  int i, j;	        /* Laufindex fuer die Argumente in der Zeile *********/
  int beg = 0, end = 0;	/* Stringpointer innerhalb der Zeile *****************/
  int num;
  char * p = zeile, o_ch;

  carg [0] = 0;

  /****** Falls die Zeile leer ist ********************************************/
  if (zeile == NULL || zeile[0] == 0)
    return False;

  /****** Beginn suchen *******************************************************/
  for (num = beg = 0, o_ch = 0; num < iarg && zeile [beg]; beg++)
  {
    if (o_ch != '\\' && zeile [beg] == cut)
      num ++;
    
    o_ch = zeile [beg];
  }
  
  /****** Falls das iarg. Argument nicht vorhanden, dann False zurueckgeben ***/
  if (num < iarg)
    {
      carg [0] = 0;
      return False;
    }

  /****** Fuehrende Leerzeichen und Tabs ueberspreingen ***********************/
  for ( ; zeile [beg] == ' ' || zeile [beg] == '\t'; beg ++);

  /****** Ende suchen *********************************************************/
  for (end = beg, o_ch = 0; zeile [beg] != cut && zeile [end]; end++)
    {
      if (o_ch != '\\' && zeile [end] == cut) 
	{
	  end --;
	  break;
	}
      o_ch = zeile [end];
    }
  if (end > beg && zeile [end] == 0) end --;

  /****** Leer und Tabs am Ende ueberspringen *********************************/
  for ( ;
       end > beg &&
       (zeile [end] == ' ' || zeile [end] == '\t' || zeile [end] == '\n');
       end --);

  /****** falls Das Ende an einem Trennzeichen steht **************************/
  if (zeile [end] == cut && zeile [max (0, end - 1)] != '\\') end --; 

  /****** Bereich in den Buffer kopieren **************************************/
  for (o_ch = 0, i=beg, j = 0; i <= end; i++)
    {
      /** Trennzeichen mit `\` maskiert, gilt als normales Zeichen ************/
      if (zeile [i] == cut && o_ch == '\\')
	{
	  carg [j++] = zeile [i];
	}

      /** NewLine als '\n', konvertieren in 10 ********************************/
      else if (zeile [i] == 'n' && o_ch == '\\')
	{
	  carg [j++] = '\n';
	}

      /** Das Zeichen danach **************************************************/
      else if (o_ch == '\\')
	{
	  carg [j++] = zeile [i];
	}

      /** Normales Zeichen ****************************************************/
      else if (zeile [i] != '\\')
	carg [j++] = zeile [i];

      /** Man muss beachten, dass die BackSlashes nur paarweise auftreten *****/
      /** koennen							  *****/
      if (o_ch == '\\' && zeile [i] == '\\')
	o_ch = 0;
      else
	o_ch = zeile [i];
    }
  carg[j] = 0;

  return True;
}

#if 0
main () 
{
  char tmp[1024];
  char * zeile = "1 = 2 =3=4=5	Nun Ich bin dann nach hause \" gegangen # djskl sal \"  =6		=7  =  9 !\\= 7 \\=\\=> 9 !\\= 7 8  = = 9 .,a sdsa aslkd lasop wp";
  int i;
  for (i=0; i<10; i++)
    {
      Ureadarg (zeile, tmp, i, '=' );
      DEBUG3 ("zeile[%i]=(%s)\n", i, tmp);
    }
}
#endif
