/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: strutil.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khlib/khmisc/RCS/strutil.c,v $
 */
#define IS_EXTERN
#define EXTERN extern

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/timeb.h>
#include <sys/param.h>

#ifdef DOS
#include <ctype.h>
#include <conio.h>
#endif

#include "defines.h"
#include "Ustrutil.h"

int StrShellSpecialCnt (char * s)
{
  int i;
  char * p;
  for (p=s, i=0; *p!=0; p++)
    if (StrShellSpecial(*p))
      i++;
  return i;
}

/******************************************************************************/
/* Achte darauf, im Falle des Existierens eine \0 zurueckgegeben wird *********/
/******************************************************************************/
int StringBegins (char * str, char * cmp) 
{
  char * p = str, * q = cmp;

  if (strlen (str) < strlen (cmp))
    return strcmp( str, cmp);

  while (*q) if (*q++ != *p++)
    return strcmp( str, cmp);

  return 0;
}


/********* Entfernt ein Buchstabe aus einer Zeichenkette **********************/
char * StrDelChar (char * str, char ch) 
{
  int i, j, len;
  char * p = str;

  if (str == NULL)
     return NULL;

  len = strlen (str);
  for (i=j=0; j<len; i++,j++)
    {
      /** Alle Buchstaben (= ch) uebergehen ***********************************/
      while (str[j] == ch) j++;
      str [i] = str[j];
    }
  str[i] = 0;
  return str;
}

int StringFindStr (char * str, char * pattern)
{
  return StringFindNStr (str, pattern, strlen(str), strlen(pattern));
}

/******************************************************************************/
/* Patternmatching in O(n + m) Zeit, siehe Eff.Algorithmen ********************/
/******************************************************************************/
void F( char * s, int f[], int m)
{
  int
    i, j;
  f [0] = 0;
  f [1] = 1;
  i = 3;
  while( i <= m) 
    {
      j = f[i-2];
      while( j != 0 && s[j-1] != s[i-2]) j = f[j-1];
      f[i-1] = j + 1;
      i++;
    }
}

int StringFindNStr (char * str, char * pattern, int str_len, int pattern_len)
{
  int
    i = 1,
    j = 1,
    * f = (int *) gmalloc (max(pattern_len,2) * sizeof(int), __LINE__, __FILE__),
    found = 0;

  F (pattern, f, pattern_len);			/* prefix and suffix values */
  
  while (i <= str_len)
    {
      while (j != 0 && pattern[j-1] != str[i-1]) j = f[j-1];
      if( j == pattern_len)
	{
	  found = 1; break;
	}
      else i++, j++;
    }
  MFree (f, max(pattern_len,2) * sizeof(int));
  return (found ? i - j + 1 : 0);
}

int StringFindCaseStr (char * str, char * pattern,
		       int str_len, int pattern_len, int mode)
{
  int
    i = 1,
    j = 1,
    * f = (int *) gmalloc (max(pattern_len,2) * sizeof(int), __LINE__, __FILE__),
    found = 0;

  F (pattern, f, pattern_len);			/* prefix and suffix values */

  while( i <= str_len)
    {
      if (mode & FIND_CASESENSITIVE)
	{
	  while( j != 0 && pattern [j-1] != str [i-1]) j = f[j-1];
	}
      else
	{
	  while (j != 0
		 && ch_lowercase (pattern[j-1]) != ch_lowercase(str[i-1])
		 )
	    j = f[j-1];
	}

      if (j == pattern_len)
	{
	  found = 1;
	  break;
	}
      else i++, j++;
    }
  MFree (f, max(pattern_len,2) * sizeof(int));
  return( found ? i - j + 1 : 0);
}

char * StrAppend (char * src, char * toadd)
{
  char * p;

  if (toadd == NULL)
    return src;

  if (src == NULL)
    {
      p = malloc  (strlen (toadd)+1);
      p[0] = 0;
    }
  else
    p = realloc (src, strlen(src)+strlen(toadd)+1);
 
  if (p == NULL)
    return NULL;

  strcpy (p+strlen(p), toadd);

  return p;
}

char * StrReplace (char * src, char * dest)
{
  char * newStr = NULL;

  if (src != NULL)
    {
      MFree (src, strlen (src) + 1);
    }

  if (dest != NULL)
    {
      newStr = gmalloc (strlen (dest) + 1, __LINE__, __FILE__);
      strcpy (newStr, dest);
    }

  return newStr;
}

/******** Ueberprueft einen String, ob es ein Integer ist */
int StrIsInt (char * str)
{
  char * p = str;
  /****** Falls ein Vorzeichen existiert ******************/
  if (*p == '+' || *p == '-') p++;

  /****** Alle Zeichen durchsuchen ************************/
  for (; *p |= 0; p++)
    {
      /****** Keine Integerzahl ***************************/
      if (*p < '0' || *p > '9')
	return False;
    }
  return True;
}

char ch_lowercase( char c)
{
  char l = c;
  if( c >= 'A' && c <= 'Z') l = 'a' + c - 'A';
  /*
  else
    switch( c)
      {
      case '': l = ''; break;
      case '*': l = '*'; break;
      case '*': l = '*'; break;
      case '*': l = '*'; break;
      }
  */
  return( l);
}

void lowercase( char * str)
{
  int i;
  for( i=0; str[i] != 0; i++) str[i] = ch_lowercase (str[i]);
}

int is_lowercase( char c)
{
  if( c >= 'a' && c <= 'z' ||
     c == '*' ||
     c == '*' ||
     c == '*'
     ) return( TRUE);
  return( FALSE);
}

int is_uppercase( char c)
{
  if( c >= 'A' && c <= 'Z' ||
     c == '*' ||
     c == '*' ||
     c == '*'
     ) return( TRUE);
  return( FALSE);
}

char ch_uppercase( char c) 
{
  char u = c;
  if( c >= 'a' && c <= 'z') u = 'A' + c - 'a';
  /*
  else
    switch( c)
      {
      case '*': u = '*'; break;
      case '*': u = '*'; break;
      case '*': u = '*'; break;
      case '*': u = '*'; break;
      }
  */
  return( u);
}

void uppercase( char * str) 
{
  char * p;
  for( p=str; *p != 0; p++) *p = ch_uppercase( *p);
}

int ishexa( int ch)
{
  return (ch >= '0' && ch <= '9') ||
	 (ch >= 'A' && ch <= 'F') ||
	 (ch >= 'a' && ch <= 'f')
	 ? TRUE
	 : FALSE;
}

int isdecimal( int ch) 
{
  return( (ch >= '0' && ch <= '9') ? TRUE : FALSE);
}

int is_ascii( int ch) 
{
  return (ch < 32 || ch > 127) ? 0 : 1; 
/*    return (isascii ((unsigned char) ch & 0xff) && ch >= 32) ? 1 : 0 ;*/
}

					     /* direct output to the screen */
/**** fill the string 'str' with the char 'ch' to 'len' ***/

void fillstr( char * str, int len, char ch)
{
  int i;
  for( i=0; i<len; i++) str[ i] = ch;
}

void strncpy_( char * s1, char *s2, int n, int mode)
{
  /** mode = TE_NULL: Add a terminate NULL at last of the string */
  /** otherwise no NULL is expected **/

  char * q= s1, * p = s2;
  while( n-- > 0 && *p) *q++ = *p++;
  if( mode & TE_NULL) *q = 0;
}

char * StrNStrCpy( char * s1, char * s2, int n)
{
  int i;
  for (i=0; i<n && s2 [i] != 0; i++) s1 [i] = s2 [i];
  s1 [i] = 0;

  return s1;
}

/**** search in string s1, if the s2 specifid in s1 and return the begin  ***/
/**** of the string in s1, else NULL ****/

char * StringIndex( char * s1, char * s2) 
{
  char * p = s1;
  int    l = strlen (s2);
  while (*p)
    {
      if (strncmp (p, s2, l) == 0)
	return p;
      else
	p++;
    }
  return NULL;
}

int chrindex( char * s1, char * s2) 
{
  char * p = s1;
  int    l = strlen (s2);
  while (*p)
    {
      if (strncmp (p, s2, l) == 0)	/* string found */
	return p - s1;
      else
	p++;
    }
  return -1;
}

/*** search the character 'c' in string 's' beginning at the end of string **/

char * b_strchr( char * s, char c) 
{
  char * q = s + strlen( s) - 1;
  while( q >= s) if( *q == c) return( q); else q--;
  return( NULL);
}

/*******************************************************************/
/***** Find a pattern of name  (like dos pattern find)     *********/
/*******************************************************************/

int findmatch(char *pat, char *name) 
{
  int   match;
  int   ndone;
  char *cpp;
  char *cpn;
  
  cpp = pat;
  cpn = name;
  match = 1;
  ndone = 1;
  while (ndone)
    
    {
      switch (*cpp)
        
	{
	case '*':
	  /* skip to . or end of pat */
	  while (*cpp && *cpp != '.')
	    cpp++;
	  
	  /* skip to . or end of name */
	  while (*cpn && *cpn != '.')
	    cpn++;
	  break;
	  
	case '?':
	  cpp++;
	  cpn++;
	  break;
	  
	case 0:
	  if (*cpn != 0)
	    match = 0;
	  ndone = 0;
	  break;
	  
	default:
	  if (tolower(*cpp) == tolower(*cpn))
	    
	    {
	      cpp++;
	      cpn++;
	    }
	  else
	    
	    {
	      match = 0;
	      ndone = 0;
	    }
	  break;
        }
    }
  
  return(match);
}


char * dirname( char * str) 
{
  static char pth[ MAXPATHLEN+1];
  int i,
  j,
  len = min (MAXPATHLEN, strlen(str));
  
  for (i=len; i>=0 && str [i] != RootDir; ) i--;
  for (j=0; j<i; j++) pth [j] = str [j];
  pth [j] = 0;

  if (j == 0)
    {
      if (str [i] == RootDir)
	pth [j++] = RootDir;
      else
	pth [j++] = '.';
      pth [j] = 0;
    }
	
#if 1
  DEBUG3 ("dirname(%s)=(%s)\n", str, pth);
#endif
  
  return( pth);
}

char * basename( char * str) 
{
  static char base[ MAXPATHLEN+1];
  int i,
  j,
  pos,
  len = min( MAXPATHLEN, strlen( str));
  
  for( i = len; i>= 0 && str[i] != RootDir; i--);
  
  for( j=i+1, pos = 0; j<len; j++) base[ pos++] = str[ j];
  
  base[ pos] = 0;
  
  return( base);  
}

int StrChrIndex (char * str, char chr)
{
  int i;

  for (i=0; str[i] != chr && str[i] != 0; i++);

  if (str[i] == 0) i = -1;

  return i;
}

#ifdef TEST_STRING
main (int argc, char * argv[])
{
	if (argc <= 2)
	exit (1);
	printf ("(%s)", argv[1]);
	printf (" ==> (%s)\n", StrDelChar (argv[1], argv[2][0]));
}
#endif
