/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: dir.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khlib/khsrc/RCS/dir.c,v $
 */
#define IS_EXTERN
#define EXTERN		extern

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include "Xinc.h"
#ifdef alpha
#include <unistd.h>
#endif

#include "defines.h"
#include "Umenu.h"
#include "Ustrutil.h"
#include "doregex.h"
#include "dodirent.h"
#include "Ufileutil.h"
#include "util.h"
#include "dir.h"
#include "xmisc.h"

#define USE_EXTENDED

Dir_t dirMake (char * Name)
{
  Dir_t l = gcalloc (sizeof (dir_t), __LINE__, __FILE__);

#if 0
  DEBUG2 ("dirMake: Name=(%s)\n", Name);
#endif

  /****** Strukturfelder auf Defaultwerte festlegen **************************/
  l->Name   = StrReplace (l->Name, Name != NULL ? Name : "?");

  /****** first extented type is unknown ***************/
  l->ExtentedType = -1;

  return l;
}

int dirDest (Dir_t lst)
{
#if 0
  DEBUG1 ("dirDest:");
#endif

  StrReplace (lst->Name, NULL);
  StrReplace (lst->Path, NULL);

  if (lst->Stat != NULL)
    MFree (lst->Stat, sizeof (struct stat));

  MFree (lst, sizeof (dir_t));
  return True;
}

int dirComp (Dir_t liste, char * Name)
{
  int ret;

  /****** Liste leer ******************************/
  if (liste == NULL || Name == NULL)
    return 0;

  /****** Namen vergleichen ***********************/
  ret = strcmp (liste->Name, Name);

  return ret;
}

Dchain_t dirAdd   (Dchain_t top, char * Name)
{
#if 0
  DEBUG2 ("dirAdd: Name (%s) in Liste eintragen\n", Name);
#endif

  /****** Es kann sein, dass dies das erste Element ist, ansonsten darf ***/
  /****** pos kein NULL Pointer sein **************************************/
  /****** keine double-deutige Nummern ************************************/
  if (UdchItemExists (top, Name, (int (*) (void*, void*)) dirComp))
    {
      ERROR2 ("dirAdd: Name [%s] is already existing\n",
	      Name);
      return NULL;
    }

  /****** In die Liste eintragen *****************************************/
  return UdchAdd (top, Name,
		     (void * (*) (void *)) dirMake,
		     (int    (*) (void *, void *)) dirComp);
}

int dirDelete (Dchain_t lst)
{
  return UdchEmptyAndDel (lst, (int (*)(void*)) dirDest);
}

int dirCopy (Dir_t lst1, Dir_t lst2)
{

  /****** Namen kopieren *************************************************/
  memcpy (lst2, lst1, sizeof (dir_t));
  
  return True;
}

int dirData (Dchain_t lst, struct stat * NameStatus)
{
  Dir_t dir;

#if 0
  DEBUG1 ("dirData:");
#endif

  /****** Falsch aufgerufen **********************************************/
  if (lst == NULL)
    return False;

  dir = (Dir_t) UdchClient (lst);

  memcpy (dir->Stat, NameStatus, sizeof (struct stat));

  return True;
}

int dirSaveName (Dchain_t lst, char * Name)
{
  Dir_t dir;

  if (lst == NULL || Name == NULL || strlen (Name) == 0)
    return False;

  dir = (Dir_t) UdchClient (lst);

  dir->Name = StrReplace (dir->Name, Name);

  return True;
}

int dirSelect (Dchain_t lst, int mode)
{
  if (mode )
    ((Dir_t)UdchClient(lst))->Info |= DIR_SELECTED;
  else
    ((Dir_t)UdchClient(lst))->Info &= ~DIR_SELECTED;

  return True;
}

int dirSoftSelect (Dchain_t lst, int mode)
{
  if (mode )
    ((Dir_t)UdchClient(lst))->Info |= DIR_SOFT_SELECTED;
  else
    ((Dir_t)UdchClient(lst))->Info &= ~DIR_SOFT_SELECTED;

  return True;
}

int dirCopySelect (Dchain_t lst, int mode)
{
  if (mode )
    ((Dir_t)UdchClient(lst))->Info |= DIR_COPY_SELECTED;
  else
    ((Dir_t)UdchClient(lst))->Info &= ~DIR_COPY_SELECTED;

  return True;
}

int dirChng (Dchain_t lst, char * newName)
{
  Dir_t tl;

#if 0
  DEBUG2 ("dirChng: newName (%s)", newName != NULL ? newName : "NULL");
#endif

  if (newName == NULL || strlen (newName) == 0)
    return False;

  tl = (Dir_t) UdchClient (lst);

  /****** ueberpruefen, ob Aendern moeglich ist **/
  /* NOTHING TO DO */

  /****** die neue Nummer in die Liste kopieren **/
  tl->Name = StrReplace (tl->Name, newName);

#if 0
  DEBUG1 ("dirChng: ende");
#endif

  return True;
}

int dirReadDir (Dchain_t top, char * dir_, char * filter, int mode)
{
  /* TRUE : search for aktual directory and set the akt_pos for the found */
  /* LOCK_DIR_MODE : it locks for the old directory */
  /* VIEW_POINTS: don't view points on the button of the screen */
  /* directory */
  int d_files = 0;
  int begin_at = 2;
  char pName[MAXPATHLEN];
#ifndef DOS
  struct dirent * dp;
  DIR * dir;
#else
  struct ffblk  * dp = gmalloc (sizeof(struct ffblk), __LINE__, __FILE__);
  int done;
#endif
  char c, * q, *fname, tmp[ 50], * compiledStr = NULL;
  char * sel_stack;
  int use_regex = FALSE, flag = FALSE;
  int   i, j;
  Dchain_t ndir;

#ifdef DOS
#	define DIR_NAME ff_name
#else
#	define DIR_NAME d_name
#endif
  
#if 0
  DEBUG2 ("dirReadDir: (dir_=%s)\n", dir_) ;
#endif

#if 0
  if (mode & VIEW_POINTS)
    ViewReadingStatus (0, 0); /* to view ... at the screen */
#endif
  
  /* you must save the selected files into stack and after the new read */
  /* of the aktual directory you must set the selected files aloways as */
  /* selected */
  
  /* the first two directories contains
   * are allows "." and ".."
   */
  if (mode & DIR_READ_ALL)
    for (d_files=0; d_files<begin_at; d_files++)
      {
	ndir = dirAdd (top, d_files == 0 ? "." : "..");
	dirPath (ndir) = StrReplace (dirPath(ndir),
				     UPathAppend (dir_, dirName (ndir)));
      }

#ifdef DOS
#define MATCHES		"*.*"
#else
#define MATCHES		"*"
#endif
  j = 0;
  if (strcmp(filter, MATCHES) != 0)
    {
      compiledStr = open_comp (filter) ;          /* use regex for filter */
      use_regex   = TRUE ;
    }
#ifndef DOS
  dir = X_opendir( dir_);                       /* open directory */
  if (dir != NULL)
  /* read next dir. contents */
  while ((dp = X_readdir( dir)) != NULL)
#else
  j = 0;
  done = findfirst (filter, dp, f_attr);
  while (! done) 
#endif
    {
      if (strcmp( dp->DIR_NAME, "." ) == 0 ||
	  strcmp( dp->DIR_NAME, "..") == 0)
	continue;

      if ((mode & READ_DIR_ONLY) ||
	  (use_regex && ! is_regex (compiledStr, dp->DIR_NAME)))
	{
	  sprintf (pName, "%s/%s", dir_, dp->DIR_NAME);
	  if (! UFileIsDir (pName))
	    continue;
	}

      ndir = dirAdd (top, dp->DIR_NAME);
      if (ndir != NULL)
      {
        dirPath (ndir) = StrReplace (dirPath(ndir),
				     UPathAppend (dir_, dirName (ndir)));
      }
      d_files ++;

#ifdef DOS
      done = findnext( dp);                   /* next dir. entry */
#endif
    }
  
#ifndef DOS
  if (dir!=NULL)
    X_closedir (dir);
#else
  MFree (dp, sizeof(struct ffblk));                           /* Free buffer */
#endif

  if (compiledStr != NULL) close_comp (compiledStr);
  
#if 0
  DEBUG3 ("dirReadDir: (Dir=%s), count=(%i)\n", dir_, d_files);
#endif

  return UdchCount (top);
}
  
struct stat * dirStat (Dchain_t entry)
{
  Dir_t dir = UdchClient (entry);

  if (dir->Stat == NULL)
    {
      int ret;
      dir->Stat = gmalloc (sizeof (struct stat), __LINE__, __FILE__);
      ret = MY_stat (dirPath (entry) != NULL
		     ? dirPath (entry)
		     : dirName (entry),
		     dir->Stat);
      if (ret != 0)
	memset (dir->Stat, 0, sizeof (struct stat));
    }
  return dir->Stat;
}

time_t  dirModTime	     (Dchain_t entry)
{
  Dir_t dir = UdchClient (entry);
  if (dir->Stat == NULL)
    dirStat (entry);
  return dir->Stat->st_mtime;
}
time_t  dirCreateTime   (Dchain_t entry)
{
  Dir_t dir = UdchClient (entry);
  if (dir->Stat == NULL)
    dirStat (entry);
  return dir->Stat->st_ctime;
}
time_t  dirAccessTime   (Dchain_t entry)
{
  Dir_t dir = UdchClient (entry);
  if (dir->Stat == NULL)
    dirStat (entry);
  return dir->Stat->st_atime;
}
uid_t   dirUserId       (Dchain_t entry)
{
  Dir_t dir = UdchClient (entry);
  if (dir->Stat == NULL)
    dirStat (entry);
  return dir->Stat->st_uid;
}
gid_t   dirGrpId        (Dchain_t entry)
{
  Dir_t dir = UdchClient (entry);
  if (dir->Stat == NULL)
    dirStat (entry);
  return dir->Stat->st_gid;
}
char *  dirUserName   (Dchain_t entry)
{
  static char tmp[32];
  char * name;
  name = usrNameById (UserList, dirUserId (entry));
  if (name == NULL)
    {
      sprintf (tmp, "<%i>", dirUserId (entry));
      name = tmp;
    }
  return name;
}
char *  dirGrpName    (Dchain_t entry)
{
  static char tmp[32];
  char * name;
  name = grpNameById (GrpList, dirGrpId (entry));
  if (name == NULL)
    {
      sprintf (tmp, "<%i>", dirGrpId (entry));
      name = tmp;
    }
  return name;
}
ino_t   dirINode        (Dchain_t entry)
{
  Dir_t dir = UdchClient (entry);
  if (dir->Stat == NULL)
    dirStat (entry);
  return dir->Stat->st_ino;
}
nlink_t dirLinks        (Dchain_t entry)
{
  Dir_t dir = UdchClient (entry);
  if (dir->Stat == NULL)
    dirStat (entry);
  return dir->Stat->st_nlink;
}
dev_t   dirDevice       (Dchain_t entry)
{
  Dir_t dir = UdchClient (entry);
  if (dir->Stat == NULL)
    dirStat (entry);
  return dir->Stat->st_dev;
}
dev_t   dirRDevice      (Dchain_t entry)
{
  Dir_t dir = UdchClient (entry);
  if (dir->Stat == NULL)
    dirStat (entry);
  return dir->Stat->st_rdev;
}
off_t   dirSize         (Dchain_t entry)
{
  Dir_t dir = UdchClient (entry);
  if (dir->Stat == NULL)
    dirStat (entry);
  return dir->Stat->st_size;
}

char * dirRealPath (Dchain_t dir)
{
  int len;
  static char RPath [MAXPATHLEN];

  dirStat (dir);

  strcpy (RPath, dirName (dir));

  if (dirType (dir) != TYPE_LNK)
    return RPath;

#if defined (HAVE_REALPATH) || defined (HAVE_READLINK)
#ifdef HAVE_READLINK
  len = readlink (dirName (dir), RPath, sizeof (RPath));
  RPath [len] = '\0';
#elif defined (HAVE_REALPATH)
  realpath (dirName (dir), RPath);
#endif
#if 0
  DEBUG3 ("dirRealPath (%s) => (%s)\n", dirName (dir), RPath);
#endif
#endif

  return RPath;
}

int dirTypeOfRealPath (Dchain_t dir)
{
  Dchain_t ndir;
  char RPath [MAXPATHLEN];
  int type = TYPE_UNK;
  int len;

  dirStat (dir);

  if (dirType (dir) != TYPE_LNK)
    return dirType (dir);

#if defined (HAVE_REALPATH) || defined (HAVE_READLINK)

#ifdef HAVE_READLINK
  len = readlink (dirName (dir), RPath, sizeof (RPath));
  RPath[len] = '\0';
#elif defined (HAVE_REALPATH)
  realpath (dirName (dir), RPath);
#endif

  DEBUG3 ("dirTypeOfRealPath (%s) => (%s)\n", dirName (dir), RPath);

  ndir = dirAdd (NULL, RPath);
  type = dirType (ndir);
  UdchDelete (ndir, (int (*)(void*))dirDest);
  return type;
#else
  return dirType (dir);
#endif
}

int dirType (Dchain_t entry)
{
  Dir_t dir = UdchClient (entry);
  int type;
  char c;
  mode_t m;

  if (dir->Stat == NULL)
    dirStat (entry);

  m = dir->Stat->st_mode;

  if (S_ISLNK ( m))
    {
      c = 'l';
      type = TYPE_LNK;
    }

  else if (S_ISDIR ( m))
    {
      c = '/';
      type = TYPE_DIR;
    }

  else if (S_ISREG( m))
    {
      if (C_X (dir->Stat->st_uid, dir->Stat->st_gid, m))
	c = '*', type = TYPE_EXE;
      else
	c = ' ', type = TYPE_REG;
    }

  else if (S_ISBLK ( m))
    {
      c = 'b';
      type = TYPE_BLK;
    }

  else if (S_ISCHR (m))
    {
      c = 'c';
      type = TYPE_CHR;
    }
      
  else if (S_ISFIFO( m))
    {
      c = 'p';
      type = TYPE_FIFO;
    }

  /* XENIX special types */
  else if (S_ISNAM ( m))
    {
      unsigned int num;
      num = m >> 12;
#if defined (S_INSEM) && defined (S_INSHD)
      if (num & S_INSEM) /* Semaphore */
	{
	  c = 's';
	  type = TYPE_SEM;
	}
      else if (num & S_INSHD) /* Shared Data */
	{
	  c = 'S';
	  type = TYPE_SHD;
	}
      else
#endif
	type = TYPE_NAME;
    }

  else
    {
      c = '?';
      type = TYPE_UNK;
    }

  return type;
}

static dirExtendedTypes_t dirFileExt[] =
{
#ifdef USE_EXTENDED
  /* Resource files */
  { ".*",    PIXM_file_ress32},

  /* c sources */
  { "*.c",   PIXM_file_csource32 },
  { "*.h",   PIXM_file_cheader32 },
  { "*.o",   PIXM_file_obj32 },
  { "*.obj", PIXM_file_obj32 },

  { "*.s",   PIXM_file_assembler32 },
  { "*.asm", PIXM_file_assembler32 },

  /* doc files */
  { "*.doc", PIXM_file_doc1_32},
  { "*.doc", PIXM_file_doc2_32},
  { "*.doc", PIXM_file_doc3_32},

  /* compressed files */
  { "*.Z",    PIXM_file_compr32}, /* compress */
  { "*.gz",   PIXM_file_compr32}, /* gzip */
  { "*.tgz",  PIXM_file_compr32}, /* tar gzip */
  { "*.cgz",  PIXM_file_compr32}, /* cpio gzip */
  { "*.z",    PIXM_file_compr32}, /* zcat format */
  { "*.arj",  PIXM_file_compr32}, /* arj */
  { "*.zip",  PIXM_file_compr32}, /* zipp */

  /* postscript */
  { "*.ps",  PIXM_file_ps32},
  { "*.PS",  PIXM_file_ps32},

  /* image files */
  { "*.pds",  PIXM_file_image32},
  { "*.bmp",  PIXM_file_bmp32},
  { "*.gif",  PIXM_file_gif32},
  { "*.iff",  PIXM_file_iff32},
  { "*.iris", PIXM_file_iris32},
  { "*.jpeg", PIXM_file_jpeg32},
  { "*.jpg",  PIXM_file_jpeg32},
  { "*.pbm",  PIXM_file_pbm32},
  { "*.pcx",  PIXM_file_pcx32},
  { "*.pm",   PIXM_file_pm32},
  { "*.tiff", PIXM_file_tiff32},
  { "*.rle",  PIXM_file_rle32},
  { "*.xbm",  PIXM_file_xbm32},
  { "*.pixm", PIXM_file_xbm32},
  { "*.icon", PIXM_file_xbm32},
  { "*.bitm", PIXM_file_xbm32},
  { "*.xpm",  PIXM_file_xpm32},
  { "*.xwd",  PIXM_file_xwd32},

  /* sound files */
  { "*.wav",  PIXM_file_sound32 },
  { "*.au",  PIXM_file_sound32 },
  { "*.mid",  PIXM_file_sound32 },
  { "*.midi", PIXM_file_sound32 },

  /* Makefiles */
  { "Make*",     PIXM_file_makefile32},
  { "makefile*", PIXM_file_makefile32},
  { "*.mak",     PIXM_file_makefile32},

  /* archives and Packages files */
  { "*.tar",  PIXM_file_package32},
  { "*.cpio", PIXM_file_package32},
  { "*.pkg", PIXM_file_package32},
  { "[P|p]ackage*", PIXM_file_package32},

  { "*[C|c]lock", PIXM_file_clock32},

  /* dos and Windows types */
  { "[M|m]sdos", PIXM_file_dos32},
  { "[C|c]ommand.com", PIXM_file_dos32},
  { "[W|w]in.com", PIXM_file_win32},
  { "*.exe", PIXM_file_dosEXE32},
  { "*.bat", PIXM_file_dosBAT32 },
  { "*.com", PIXM_file_dosCOM32 },

  /* Catridge Tapes */
  { "*[T|t]ape*", PIXM_file_tape32},
  
  /* Mail files */
  { "email*", PIXM_file_mail32},
  { "[M|m]ail*",  PIXM_file_mail32},

  /* Info Files */
  { "*[I|i]nfo*",  PIXM_file_info32},
  { "README*",     PIXM_file_info32},
  { "[R|r]eadme*", PIXM_file_info32},
  { "*.rme",       PIXM_file_info32},
  { "HELP*",       PIXM_file_info32},
  { "[H|h]elp*me", PIXM_file_info32},
  { "*.hlp",       PIXM_file_info32},

  /* Libraries */
  { "lib*.a",    PIXM_file_archive32 },
  { "lib*.so",   PIXM_file_sharedobj32 },
  { "lib*.so.*", PIXM_file_sharedobj32 },

  /* Terminals */
  { "xterm",  PIXM_file_term32 },
  { "??term",  PIXM_file_term32 },
  { "[T|t]erminal",  PIXM_file_term32 },

  /* Misc */
  { "*.fon",  PIXM_file_font32 },
  { "*.fax",  PIXM_file_fax32 },
  { "core",   PIXM_file_core32 },
  { "core.*", PIXM_file_core32 },

  { "[G|g]roup*", PIXM_file_group32},

  { "[M|m]ouse*", PIXM_file_mouse32},

  /* Package/Folder Map */
  { "pkgmap", PIXM_fldr_map32},

  /* Floppy Disks */
  { "[d|D]isk_*", PIXM_file_Disk_A32},
  { "fd*135ds*",  PIXM_file_disk35zoll32},
  { "rfd*135ds*", PIXM_file_disk35zoll32},
  { "fd*96ds*",  PIXM_file_disk525zoll32},
  { "rfd*96ds*", PIXM_file_disk525zoll32},
  { "rfd*48ds*", PIXM_file_disk525zoll32},
  { "fd*48ds*",  PIXM_file_disk525zoll32},
  { "fd0",       PIXM_file_disk35zoll32},
  { "rfd0",      PIXM_file_disk35zoll32},
  { "fd0t",      PIXM_file_disk35zoll32},
  { "rfd0t",     PIXM_file_disk35zoll32},

  /* Scheduler */
  { "[S|s]chedul*", PIXM_file_sched32},

/*
  { "*.", PIXM_file_},
  { "*.", PIXM_file_},
  { "*.", PIXM_file_},
  { "*.", PIXM_file_},
*/
  
#if 0
  { "*.o", PIXM_ofile32 },
#endif
#endif
  { NULL, 0}
};

static dirExtendedTypes_t dirDirExt[] =
{
#ifdef USE_EXTENDED
  { "dev",     PIXM_fldr_dev32},
  { "Disks*",  PIXM_fldr_dev32},
  { "*[G|g]ames*", PIXM_fldr_games32},
  { "*[U|u]ucp*",  PIXM_fldr_uucp32},
  { "[A|a]pplic*", PIXM_fldr_appl32},
  { "[C|c]drom*",  PIXM_fldr_cdrom32},
  { "CD*ROM*", PIXM_fldr_cdrom32},
  { "*email*", PIXM_fldr_email32 },
  { "*[M|m]ail*",  PIXM_fldr_email32 },
  { "*[F|f]ont*",  PIXM_fldr_font32 },
  { "[A|a]dmin",  PIXM_fldr_admin32 },
  { "[N|n]fs",  PIXM_fldr_nfs32 },
  { "[N|n]fs*[L|l]ocal*",  PIXM_fldr_nfsLocal32 },
  { "[N|n]fs*[M|m]ount*",  PIXM_fldr_nfsMounted32 },
  { "proc",  PIXM_fldr_proc_on32 },
  { "proc*",  PIXM_fldr_proc_off32 },
  { "[W|w]astpasket*",  PIXM_fldr_wb32 },
  { "[K|k]eyboard*",  PIXM_keybd32 },
  { "[W|w]indows", PIXM_file_win32},
#endif
  { NULL, 0}
};

int dirExtendedType (Dchain_t entry)
{
  Dir_t dir = (Dir_t)UdchClient(entry);
  int type, i;

  if (dir->ExtentedType != -1)
    return dir->ExtentedType;

  type = dirType (entry);

#ifdef USE_EXTENDED
  if (dirType (entry) == TYPE_DIR)
    /* find directory types in the extension list */
    for (i=0; dirDirExt[i].StringMatch != NULL; i++)
      {
	if (IsRegular (dirDirExt[i].StringMatch, dirName (entry)))
	  {
	    dir->ExtentedType = dirDirExt[i].Type;
	    return dir->ExtentedType;
	  }
    }
  else
    /* find filetype in the extension list */
    for (i=0; dirFileExt[i].StringMatch != NULL; i++)
      {
	if (IsRegular (dirFileExt[i].StringMatch, dirName (entry)))
	  {
	    dir->ExtentedType = dirFileExt[i].Type;
	    return dir->ExtentedType;
	  }
    }
#endif

  switch (type)
    {
    case TYPE_LNK:
      type = PIXM_file_link32;
      break;

    case TYPE_DIR:
      type = PIXM_fldr32;
      break;

    case TYPE_REG:
      type = PIXM_file32;
      break;

    case TYPE_EXE:
      type = PIXM_file_exec32;
      break;

    case TYPE_BLK:
      type = PIXM_file_devblk32;
      break;

    case TYPE_CHR:
      type = PIXM_file_devchr32;
      break;
      
    case TYPE_FIFO:
      type = PIXM_file_pipe32;
      break;

    case TYPE_SEM:
      type = PIXM_file_sem32;
      break;

    case TYPE_SHD:
      type = PIXM_file_shmem32;
      break;

    case TYPE_NAME:
      type = PIXM_file_unknown32;
      break;

    default:
      type = PIXM_file_unknown32;
      break;
    }

  dir->ExtentedType = type;
  return type;
}

int dirExists (Dchain_t entry)
{
  Dir_t dir = UdchClient (entry);

  dirStat (entry);

  return dir->Stat->st_atime > 0;
}

mode_t dirRights (Dchain_t entry)
{
  Dir_t dir = UdchClient (entry);

  dirStat (entry);

  return dir->Stat->st_mode;
}

int dirChangeDir (char * newdir)
{
  int err_;
  
#ifdef DOS
  setdisk( w->drive);
#endif
  /* on success, returns 0 */
  err_ = chdir (newdir);
  if (err_ == 0)
    {
      strcpy (CurrentPath, newdir);
      cmdViewCurrentPath (cmdHist);
    }
  return err_ == 0;
}

int dirChngOwnerGrp (Dchain_t dir, int owner, int grp)
{
#ifdef UNIX
  return chown (dirName (dir), owner, grp) ? FALSE : TRUE;
#else
  return TRUE;
#endif
}


int dirCreateDir (Dchain_t dir, int mode)
{
  if (dirType (dir) == TYPE_DIR)
    return 0;

#ifdef DOS
  return mkdir (dirName (dir));
#else
#ifndef XENIX
  return mkdir (dirName (dir), (short) mode);
#else
  return True;
#endif
#endif
}

int dirSort (Dchain_t lst, int sortMethode)
{
  return False;
}

int dirGetType (char * path)
{
  int type = 0;

  Dchain_t dir = dirAdd (NULL, path);
  type      = dirType (dir);
  dirDelete (dir);

  return type;
}

char *  dirGetName (char * PathName, int NameNum)
{
  static char Name [MAXPATHLEN];
  int i, j, p;

  Name [0] = 0;

  for (i=0, p = 0; PathName [p] != 0; i++)
    {
      j =0;

      /* last slash in a path (/home/name/) */
      if (PathName [p] == '/' && i > 0)
	break;

      if (PathName [p] == '/')
	{
	  Name [0] = PathName [p++];
	  Name [1] = 0;
	}
      else
	{
	  for (j=0; PathName[p] != 0 && PathName[p] != '/'; j++)
	    Name [j] = PathName[p++];
	  Name [j] = 0;
	}

      while (PathName[p] == '/') p++;

      if (NameNum == i)
	{
#if 0
	  DEBUG4 ("dirGetName: PathName=(%s), Num (%i) = (%s)\n",
		  PathName,
		  NameNum,
		  Name);
#endif
	  return Name;
	}
    }
#if 0
  DEBUG3 ("dirGetName: PathName=(%s), Num (%i) not found\n",
	  PathName,
	  NameNum);
#endif

  return NULL;
}

char * dirMakeChoose (Dchain_t dir, int mode)
{
  static char str [MAXPATHLEN*2];
  int m, i, count, size, pos, selected, selSize;
  struct stat * f_st;
  struct tm mTime, aTime, cTime;
  char * diff;
#ifndef DOS
  static char f_mod[] = "-oooggguuu";
  char * p = f_mod;
#endif

  str[0] = 0;

  /* differ the contintes with a new line */
  if (mode & DIR_DIFFER)
    diff = "\n ";
  else
    diff = " ";

  /* filename */
  if (mode & DIR_PRINT_NAME)
    strcat (str, dirName (dir));

  f_st = dirStat (dir);
  mTime = * localtime( &f_st->st_mtime);  /* modify time */
      
#ifndef DOS
  /* in DOS the mTime,cTime,assTime are the same */  

  aTime  = * localtime( &f_st->st_atime);  /* access time */
  cTime  = * localtime( &f_st->st_ctime);  /* create time */
  
  m      = f_st->st_mode;
  i      = 0;
  f_mod[i++] = TypeChr [dirType (dir)];	/* known char. for types */
  f_mod[i++] = ( C_O_R( m) ? 'r' : '-');	/* owner */
  f_mod[i++] = ( C_O_W( m) ? 'w' : '-');
  f_mod[i++] = ( C_O_X( m) ? 'x' : '-');
  f_mod[i++] = ( C_G_R( m) ? 'r' : '-');	/* group */
  f_mod[i++] = ( C_G_W( m) ? 'w' : '-');
  f_mod[i++] = ( C_G_X( m) ? 'x' : '-');
  f_mod[i++] = ( C_A_R( m) ? 'r' : '-');	/* all */
  f_mod[i++] = ( C_A_W( m) ? 'w' : '-');
  f_mod[i++] = ( C_A_X( m) ? 'x' : '-');
  f_mod[i++] = 0;
  
  /* count of links */
  if (mode & DIR_STATUS)
    sprintf (str+strlen(str), ", %10s%4i",
	     f_mod,
	     dirLinks (dir));
  
  /* block or character files or minor and major for devices */
  if (dirType (dir) == TYPE_BLK ||
      dirType (dir) == TYPE_CHR)
    {
      sprintf (str+strlen( str),
	       "%s%i,%i",
	       diff,
#ifdef SVR32
	       dirRDevice (dir) >> 8,
#else
	       dirRDevice (dir) >> 18,
#endif
	       dirRDevice (dir) & 0xff
	       );
    }
  else
    {
      sprintf (str+strlen( str),
	       "%s%li",
	       diff,
	       dirSize (dir));
    }
  
  if (mode & DIR_STATUS)
    {
      sprintf (str+strlen( str),
	       "%s%7s %7s %2s %3s %2i %4i %02i:%02i i%5i",
	       diff,
	       dirUserName (dir),
	       dirGrpName  (dir),
	       week  [mTime.tm_wday],
	       month [mTime.tm_mon],
	       mTime.tm_mday,
	       mTime.tm_year + 1900,
	       mTime.tm_hour,       /* the time go 1 hour back */
	       mTime.tm_min,
	       dirINode (dir)	 /* inode */
	       );
    }
  else if (mode & DIR_CHOOSE)
    {
      /* mode rwxrwxrwx */
      sprintf (str+strlen(str),
	       "%s%s",
	       diff,
	       f_mod + 1);

      /* user name */
      sprintf (str+strlen(str),
	       "%s%s",
	       diff,
	       dirUserName (dir));

      /* group name */
      sprintf (str+strlen(str),
	       "%s%s",
	       diff,
	       dirGrpName  (dir));

      /* modify time */
      sprintf (str+strlen(str),
	       "%s%02i.%02i.%02i%s%02i:%02i",
	       diff,
	       mTime.tm_mday,
	       mTime.tm_mon + 1,
	       mTime.tm_year,
	       diff,
	       mTime.tm_hour,
	       mTime.tm_min);

      sprintf (str+strlen(str),
	       "%si%i",
	       diff,
	       dirINode (dir));

      sprintf (str+strlen(str),
	       "%s%i",
	       diff,
	       dirLinks (dir));

      sprintf (str+strlen(str),
	       "%s%02i.%02i.%02i",
	       diff,
	       cTime.tm_mday,		/* create time */
	       cTime.tm_mon + 1,
	       cTime.tm_year);

      sprintf (str+strlen(str),
	       "%s%02i:%02i",
	       diff,
	       cTime.tm_hour,
	       cTime.tm_min);

      sprintf (str+strlen(str),
	       "%s%02i.%02i.%02i",
	       diff,
	       aTime.tm_mday,		/* assecc time */
	       aTime.tm_mon + 1,
	       aTime.tm_year);

      sprintf (str+strlen(str),
	       "%s%02i:%02i",
	       diff,
	       aTime.tm_hour,
	       aTime.tm_min);
    }

  if ((mode & DIR_LINKED_TO) && dirType (dir) == TYPE_LNK)
    {
      sprintf (str+strlen(str),
	       "%s->%s%s",
	       diff, diff,
	       dirRealPath (dir));
    }
#else
  if( mode & DIR_LONG_STATUS)
    sprintf( str, "%-12s  ", AKT_FILE(w));
  else * str = 0;
  
  i = strlen(str);
  /* block or character files minor and major */
  if( S_ISDIR(f_st->st_mode))
    {
      char *p = w->dr[w->anf_pos+pos]->f;
      if( p[0] != '.'         ) sprintf( str+i, "<  DIR  > ");
      else if( strcmp( p, ".") == 0) sprintf( str+i, "<  WORK > ");
      else 			    sprintf( str+i, "<  UP_  > ");
    }
  else
    sprintf( str+i, "%9li ", f_st->st_size);
  
  if( mode & DIR_LONG_STATUS)
    sprintf( str+strlen( str),
	     "%2s %3s %2i %4i %02i:%02i",
	     week[ mTime.tm_wday],
	     month[ mTime.tm_mon],
	     mTime.tm_mday,
	     mTime.tm_year + 1900,
	     mTime.tm_hour,       /* the time go 1 hour back */
	     mTime.tm_min
	     );
  
  else
    {
      sprintf( str+strlen(str),
	       "%2i.%02i.%02i %02i:%02i "
	       "<owner> <group> <rwxrwxrwx> "
	       "<I-Node> <Links> "
	       "<creTime> <assTime> <UNIX only>",
	       mTime.tm_mday,		/* modify time */
	       mTime.tm_mon + 1,
	       mTime.tm_year,
	       mTime.tm_hour,
	       mTime.tm_min
	       );
    }
#endif
  strcpy (str+strlen(str), diff);
  return str;
}

/* mode = DIR_LONG_STATUS : Statusformat */
/* mode = DIR_SHORT_STATUS: Chooseformat */
char * dirMakeStatStr (Dchain_t top, int mode)
{
  Dchain_t dir, selDir = NULL;
  static char str [MAXPATHLEN*2];
  int m, i, count, size, selected, selSize;

  str [0] = 0;

  for (count = size = selected = selSize = 0, dir = UdchNext (top);
       dir != NULL; 
       dir = UdchNext (dir))
    {
      count ++;
      size += dirSize (dir);

      if (dirSelected (dir))
	{
	  selDir = dir;
	  selected ++;
	  selSize += dirSize (dir);
	}
    }

  sprintf (str, "%.3f KBytes in %i Files",
	   (double) ((double) size / 1000.0),
	   count);
  if (selected > 1)
    {
      sprintf (str+strlen(str),
	       ", %.3f KBytes in %i selected Files",
	       (double) ((double) selSize / 1000.0),
	       selected);
    }
  else if (selected == 1 && selDir != NULL)
    {
      sprintf (str+strlen(str),
	       dirMakeChoose (selDir, DIR_STATUS | DIR_LINKED_TO));
    }

  return str;
}

int dirRecursive (Dchain_t src, Dchain_t dst, DirInfo_t info)
{
  Dchain_t list, p, dstList, srcList;
  int  ret = FALSE;

  DEBUG2 ("dirRecursive: (%s)\n", dirName (src));

  /* check regular expression */
  if (dirType (src) != TYPE_DIR &&
      info->Ignore != NULL &&
      strlen (info->Ignore) > 0 &&
      IsRegular (info->Ignore, basename (dirName (src))))
    {
      DEBUG2 ("dirRecursive: Ignore: Skip (%s)\n", dirName (src));
      return info->mode;
    }
  if (dirType (src) != TYPE_DIR &&
      info->Enclose != NULL &&
      strlen (info->Enclose) > 0 &&
      strcmp (info->Enclose, "*") != 0 &&
      ! IsRegular (info->Enclose, basename (dirName (src))))
    {
      DEBUG2 ("dirRecusive: Enclose: Skip (%s)\n", dirName (src));
      return info->mode;
    }
  if ((info->mode & DIR_SKIP_FILES) &&
      dirType (src) != TYPE_DIR)
    {
      DEBUG2 ("dirRecusive: Skip files (%s)\n", dirName (src));
      return info->mode;
    }
  if ((info->mode & DIR_SKIP_LINKS) &&
      dirType (src) == TYPE_LNK)
    {
      DEBUG2 ("dirRecusive: Skip links (%s)\n", dirName (src));
      return info->mode;
    }

  /* view files with client program , there will be copy now */
  if (info->ViewFilesProc != NULL)
    {
      info->mode |= info->ViewFilesProc (src, dst, info->ClData);
      if (info->mode & DIR_CANCEL)
	return info->mode;
    }

#if 0
  /* directories can only be copied by recursive copying flag */
  if (dirType (src) == TYPE_DIR && ! (info->mode & DIR_RECURSIVE))
    {
      info->mode |= DIR_CANCEL;
      return info->mode;
    }
#endif

  /* if asking mode is enabled, get answer */
  if ((info->mode & DIR_ASK) && info->AskProc != NULL)
    {
      info->mode &= ~ DIR_NO;			/* delete old answers */
      /* ask for coping */
      info->mode |= info->AskProc (src, dst, info->ClData);
      if (info->mode & (DIR_CANCEL|DIR_NO))
	return info->mode;
    }
      
  /* call the client procedure */
  if (! ((info->mode & DIR_SKIP_DIRS) && dirType (src) == TYPE_DIR))
    {
      info->mode |= info->ClProc (src, dst, info);
    }
#ifdef DEBUG
  else
    {
      DEBUG2 ("dirRecusive: Skip Dirs (%s)\n", dirName (src));
    }
#endif


  /* if an error is expected */
  if (info->mode & DIR_ERROR)
    {
      info->mode &= ~ DIR_ERROR;		/* delete error flag */

      /* call user defined message dialog */
      if (info->ErrProc != NULL)
	{
	  info->mode |= info->ErrProc (dst, info->ClData);
	}
      return info->mode;
    }
      
  /* if directory and recursive copying */
  if (dirType (src) == TYPE_DIR && (info->mode & DIR_RECURSIVE))
    {
      /* make head for a new directory list */
      list = dirAdd (NULL, "TOP");

      /* read directory entries */
      dirReadDir (list, dirName (src),
		  info->Filter == NULL || strlen (info->Filter) == 0
		  ? "*"
		  : info->Filter,
		  False);
      
      for (p=UdchNext (list);
	   p!=NULL;
	   p=UdchNext (p))
	{
	  /* append path for src. and dest. files */
	  srcList = dirAdd (NULL,
			    UPathAppend (dirName (src), dirName (p)));
	  dstList = dirAdd (NULL,
			    UPathAppend (dirName (dst), dirName (p)));
	  
	  /* call recursive copying for every entry */
	  info->mode |= dirRecursive (srcList,
				      dstList,
				      info);

	  /* delete created list entries */
	  dirDelete (srcList);
	  dirDelete (dstList);
	  
	  /* if break mode is seted, break copying  */
	  if (info->mode & DIR_CANCEL)
	    break;
	}
      
      /* delete created list of directories */
      dirDelete (list);
      
      return info->mode;
    }  /* if DIR_RECURSIVE  */

  return info->mode;
}  /* rec */

char * dirCutPath (char * path, int max_l, int mode)
{
  int
    i,
    len,
    pos,
    mlen = min (MAXPATHLEN+3, max (0, max_l));
  char static s[MAXPATHLEN+4];
  char pnt = '.';
  
  if (path != NULL)
  {
    len = min (strlen (path), MAXPATHLEN);
    strncpy (s, path, len);
    s [len] = 0;
  
    if (strlen (s) <= mlen)
      return s;
    
    i = 1;
    s[i++] = pnt;
    s[i++] = pnt;
  
    pos = strlen (s) - mlen;
    for (; i<=mlen; i++) s[i] = s [pos + i];
    s [i] = 0;
  }
  else
  {
    strcpy (s, "");
  }
  s[mlen] = 0;
  
  return s;
}

