/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: doregex.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khlib/khsrc/RCS/doregex.c,v $
 */

#define EXTERN extern
#define IS_EXTERN

#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <dirent.h>
#include <string.h>

#ifdef UNIX
/* use self implemented regex (from GNU) */
#ifndef HAVE_REGEX
#include "regex.h"
#else
#include <regex.h>
#endif
#ifdef HAVE_LIBGEN
#include <libgen.h>
#endif
#endif

#ifdef DOS
#include <io.h>
#endif

#include "defines.h"
#include "Umem.h"
#include "doregex.h"

#ifdef MY_REGEX_HH
#undef HAVE_REGEX
#endif

char * open_comp (char * comp)
{
  int i, j = 0, grp = False;
  static char buf [1024] ;
  char * cmp ;

#ifdef DOS
  cmp = malloc (strlen (comp) + 1);
  if (cmp == NULL)
    return NULL;

  strcpy (cmp, comp) ;
  return cmp ;
#else
  buf [j++] = '^';
  for (i=0; comp[i] != 0 && i<1024; i++)
    {
      if (grp)
	{
	  buf [j++] = comp[i];
	}
      else switch (comp[i])
	{
	case '\\':
	  i ++ ;
	  buf [j++] = '\\' ;
	  buf [j++] = comp[i] ;
	  break ;
	case '*':
	  buf [j++] = '.' ;
	  buf [j++] = '*' ;
	  break ;
	case '?':
	  buf [j++] = '.' ;
	  break ;
	case '.':
	  buf [j++] = '\\' ;
	  buf [j++] = '.' ;
	  break ;
	case '[':
	  buf [j++] = comp[i];
	  grp = True;
	  break;
	case ']':
	  buf [j++] = comp[i];
	  grp = False;
	  break;

	default:
	    buf [j++] = comp [i] ;
	    break ;
	}
    }
  buf [j++] = '$';
  buf [j]   = 0 ;

#if 0
  DEBUG3 ("string=[%s] ==> ed=[%s]\n", comp, buf );
#endif

#if defined (HAVE_REGEX)
  cmp = regcmp (buf, NULL) ;
  return cmp ;
#else
  MY_re_comp (buf); /* static pointer */
  return NULL;
#endif

#endif /* not dos */
}

int close_comp (char * cmp)
{
  if (cmp != NULL) free (cmp);
  return TRUE;
}

int is_regex (char * comp, char * sub)
{
#ifdef DOS
  return findmatch (comp, sub) ;
#else

#if defined (HAVE_REGEX)
  if (regex (comp, sub) != NULL)
    return 1 ;
  else
    return 0 ;
#else
  return MY_re_exec (sub) == 1 ? TRUE : FALSE;
#endif

#endif  /* #ifdef DOS */
}

int IsRegular (char * suf, char * pref)
{
  char * p;
  int ret;

  p = open_comp (suf);
  ret = is_regex (p, pref);
  close_comp (p);
  return ret;
}

#ifdef TESTMENU
main (int argc, char * argv[])
{
  char * str = argv[1] ;
  char * p ;
  
  p = open_comp (str);
  
  DEBUG3 ("regex(%s) = [%i]\n", p, is_regex (p, argv[2]) );
}
#endif

