/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: util.c,v 1.1 1996/10/28 03:36:23 khamis Exp khamis $
 * $Source: /home/xkhfm/khlib/khsrc/RCS/util.c,v $
 */

#define IS_EXTERN
#define EXTERN extern

#ifndef DOS
#include <pwd.h>
#include <grp.h>
#endif

#include <sys/types.h>
#include <sys/timeb.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <fcntl.h>

#ifdef DOS
#include <dos.h>
#include <dir.h>
#include <io.h>
#endif

#include "defines.h"
#include "Umem.h"
#include "util.h"

/*
 * User List Managment
 */

/*
 * make a new user entry to add in a dopple chain
 */
UserList_t usrMake (char * Name)
{
  UserList_t l = gcalloc (sizeof (userList_t), __LINE__, __FILE__);
  l->pw_name   = StrReplace (l->pw_name, Name != NULL ? Name : "unknown");
  return l;
}
/*
 * delete a user entry from memory
 */
int usrDest (UserList_t lst)
{
  StrReplace (lst->pw_name,    NULL);
  StrReplace (lst->pw_passwd,  NULL);
#ifdef HAVE_PW_COMMENT
  StrReplace (lst->pw_comment, NULL);
#endif
  StrReplace (lst->pw_gecos,   NULL);
  StrReplace (lst->pw_dir,     NULL);
  StrReplace (lst->pw_shell,   NULL);

#ifdef HAVE_PW_AGE
  StrReplace (lst->pw_age,     NULL);
#endif

  MFree (lst, sizeof (userList_t));
  return True;
}
/*
 * copy user data to another entry 
 */
int usrCopy (Dchain_t lst, UserList_t lst2)
{
  UserList_t usr = UdchClient (lst);

  usr->pw_name    = StrReplace (usr->pw_name,     lst2->pw_name);
  usr->pw_passwd  = StrReplace (usr->pw_passwd,   lst2->pw_passwd);
  usr->pw_uid     = lst2->pw_uid;
  usr->pw_gid     = lst2->pw_gid;
#ifdef HAVE_PW_COMMENT
  usr->pw_comment = StrReplace (usr->pw_comment,  lst2->pw_comment);
#endif
  usr->pw_gecos   = StrReplace (usr->pw_gecos,    lst2->pw_gecos);
  usr->pw_dir     = StrReplace (usr->pw_dir,      lst2->pw_dir);
  usr->pw_shell   = StrReplace (usr->pw_shell,    lst2->pw_shell);
#ifdef HAVE_PW_AGE
  usr->pw_age     = StrReplace (usr->pw_age,      lst2->pw_age);
#endif
  return True;
}
int usrComp (UserList_t lst, char * Name)
{
  if (strcmp (lst->pw_name, Name) != 0)
    return -1;
  else
    return 0;
}
Dchain_t usrAdd   (Dchain_t top, char * Name)
{
  return UdchAdd (top, Name,
		  (void * (*) (void *)) usrMake,
		  (int    (*) (void *, void *)) usrComp);
}
int usrReadList (Dchain_t top)
{
  struct passwd * pw;
  Dchain_t usrLst;
  
  /* get user list */
  for(; (pw = getpwent()) != NULL; )
    {
      usrLst = usrAdd  (top, pw->pw_name);
      if (usrLst == NULL) continue;
      usrCopy (usrLst, pw);
    }
  endpwent();		/* close passwd file */
  return True;
}
/*
 * get username by User ID
 */
char * usrNameById (Dchain_t top, int id)
{
  Dchain_t usr;
  for (usr = UdchNext (top);
       usr != NULL;
       usr = UdchNext (usr))
    {
      if (((UserList_t)UdchClient (usr))->pw_uid == id)
	return ((UserList_t)UdchClient (usr))->pw_name;
    }
  return NULL;
}
int usrIdByName (Dchain_t top, char * name)
{
  Dchain_t usr;

  if (top == NULL || name == NULL)
    return -1;

  for (usr = UdchNext (top);
       usr != NULL;
       usr = UdchNext (usr))
    {
      if (strcmp (((UserList_t)UdchClient (usr))->pw_name, name) == 0)
	return ((UserList_t)UdchClient (usr))->pw_uid;
    }
  return -1;
}

/*
 * group list managment 
 */
GrpList_t grpMake (char * Name)
{
  GrpList_t l = gcalloc (sizeof (grpList_t), __LINE__, __FILE__);
  l->gr_name   = StrReplace (l->gr_name, Name != NULL ? Name : "unknown");
  return l;
}
int grpDest (GrpList_t lst)
{
  StrReplace (lst->gr_name,    NULL);
#ifdef HAVE_GR_PASSWD
  StrReplace (lst->gr_passwd,  NULL);
#endif
  MFree (lst, sizeof (grpList_t));
  return True;
}
int grpComp (GrpList_t lst, char * Name)
{
  if (strcmp (lst->gr_name, Name) != 0)
    return -1;
  else
    return 0;
}
Dchain_t grpAdd   (Dchain_t top, char * Name)
{
  return UdchAdd (top, Name,
		  (void * (*) (void *)) grpMake,
		  (int    (*) (void *, void *)) grpComp);
}
int grpCopy (Dchain_t lst, GrpList_t lst2)
{
  GrpList_t grp = UdchClient (lst);
  grp->gr_name   = StrReplace (grp->gr_name,   lst2->gr_name);
  grp->gr_gid    = lst2->gr_gid;
#ifdef HAVE_GR_PASSWD
  grp->gr_passwd = StrReplace (grp->gr_passwd, lst2->gr_passwd);
#endif
  return True;
}
char * grpNameById (Dchain_t top, int id)
{
  Dchain_t grp;
  for (grp = UdchNext (top);
       grp != NULL;
       grp = UdchNext (grp))
    {
      if (((GrpList_t)UdchClient (grp))->gr_gid == id)
	return ((GrpList_t)UdchClient (grp))->gr_name;
    }
  return NULL;
}
int grpIdByName (Dchain_t top, char * name)
{
  Dchain_t grp;
  if (top == NULL || name == 0)
    return -1;
  for (grp = UdchNext (top);
       grp != NULL;
       grp = UdchNext (grp))
    {
      if (strcmp (((GrpList_t)UdchClient (grp))->gr_name, name) == 0)
	return ((GrpList_t)UdchClient (grp))->gr_gid;
    }
  return -1;
}
int grpReadList (Dchain_t top)
{
  Dchain_t grp;
  struct group  * gr;         /* group record */
  
  /* get grp list */
  for(; (gr = getgrent()) != NULL;)
    { 
      grp = grpAdd (top, gr->gr_name);
      if (grp == NULL)
	continue;
      grpCopy (grp, gr);
    }
  endgrent();			/* close group entry */
  return True;
}

#if 0
char
  perms      [] = " Permission denied ",    		/* for permission */
  stat_err   [] = " Error by reading file state .. !",
  open_err   [] = " Error by opening directory ",
  Cont_Break [] = " Continue ;; Break ",
  not_del    [] = " Error: mode of file/directory can't change ";

/**************************************************************************/
/* recursive copy file(s) 					  	  */
/**************************************************************************/
/**************************************************************************/
/************** size of file in Bytes 				***********/
/**************************************************************************/
int change_ownergrp( char * pth, int owner, int grp)
{
#ifdef UNIX
  return( chown( pth, owner, grp) ? FALSE : TRUE);
#else
  return( TRUE);
#endif
}

int copy (struct frame_t * f,
	  char * src, char * dest,
	  char * filter,
	  int * mode)
{
  
  /* return 0, when copied file */
  
  char 
    
    yes        [] = " Overwrite ;; Overwrite all ;; Continue ;; Abort ",
    tmp        [80],
    block      [BLOCKSIZE],
    cpy_tmp    [256],
    cpy        [] = "TO";
  
#ifdef UNIX
  int filter_pid ;	/* proccess id's for the childes */
  int writer_pid ;
#endif
  
  unsigned long size = 0, copied = 0;
  int src_h,
  dest_h,
  err_,
  c,
  break_ = FALSE,
#ifdef UNIX
  use_filter = (filter != NULL && strlen(filter) > 0 ? TRUE : FALSE),
#endif
  len,
  i,
  j,
  l        = f->width-4,
  gr_width = f->width/2,  /* to view file header in graphic */
  gr_x     = (f->width-gr_width)/2,
  gr_y     = 6,
  ret_      = FALSE,
  ret       = 0,
#ifdef UNIX
  new_owner = u_id,
  new_grp   = g_id,
#else
  new_owner = 0,
  new_grp   = 0,
#endif
  ch_ownergrp = ( * mode & SAMEOWNER_MODE || * mode & SAMEGROUP_MODE),
  rights      = ( * mode & SAMERIGHTS_MODE)
                ? get_stat (src)
		: get_rights();
  
  l = f->width-4;       /* length of string */
  
  /* source file in the middle of frame */
  
  sprintf( cpy_tmp, " <%s>", cutpath(src,l,NOMODE));
  f_fillnstr( f, 1, 2, cpy_tmp, strlen(cpy_tmp), '.', f->color, FILL_MODE);
  
  f_putstr( f, 1, 3, leer, f->color, FILL_MODE);
  f_putstr( f, (f->width-strlen(cpy)) / 2, 3, cpy, f->color, NOMODE);
  
  sprintf( cpy_tmp, " <%s>", cutpath(dest,l,NOMODE));
  f_fillnstr( f, 1, 4, cpy_tmp, strlen(cpy_tmp), '.', f->color, FILL_MODE);
  
  f_putnchr( f, gr_x, gr_y, '-', gr_width, f->color, NOMODE);
  
  view_frame( f);
  fflush_();
  
  if( strcmp( dest, src) == 0)
    {
      message (" Source and destination are same ", " Error ");
      return( ret_|ABORT_MODE);
    }
  
  if( ch_ownergrp)
    
    {
      if( * mode & SAMEOWNER_MODE) new_owner = file_owner( src);
      if( * mode & SAMEGROUP_MODE) new_grp   = file_grp  ( src);
    }
  
  /* copy directory to none existing dir. */
  if( is_dir(src, NOMODE))
    
    {
      err_ = create_dir( dest, rights);
      
      if( err_)
	{
	  sprintf( tmp, "Can't create directory <%s>", dest);
	  err_ = Getyesno (tmp, Cont_Break, " create directory ", 0);
	  ret_ = ret_ | (err_ == 1 ? ABORT_MODE : FALSE);
	}
      else if( ch_ownergrp) 
	change_ownergrp( dest, new_owner, new_grp); /* new owner/group */
      
      return( ret_);
    }
  
  /* file exists and not overwrite mode */
  if( ! (*mode & OVERWRITE_MODE))
    
    {
      err_   = 0;
      if( is_file( dest,TRUE))
	{
	  sprintf (tmp, " File <%s> exists, Overwrite ? ",
		   cutpath( dest, 30,NOMODE)
		   );
	  err_ = Getyesno (tmp, yes, " copy ", 0);
	  
	  ret_ = ret_ | (err_ == 3 ? ABORT_MODE : FALSE);
	  if( err_ == 1) *mode = *mode|OVERWRITE_MODE;
	  
	  if( err_ > 1) return( ret_); /* continue or break */
	}
    }
  
  /* copy file */
  if( ! break_)
    
    {
      /* overwrite existing file */
      src_h  = open( src,  O_RDONLY|O_BINARY);
      if( ! is_file( src,TRUE) || src_h < 0)
	{
	  sprintf (tmp, " By opening file <%s> ",
		   cutpath( src, 30,NOMODE)
		   );
	  err_ = Getyesno (tmp, Cont_Break, " Error ", 0);
	  if( err_ == 1) ret_ = ret_|ABORT_MODE;
	  return( ret_);
	}
      
      if( ! (* mode & SAMERIGHTS_MODE) ) rights &= ~0111;
      
      dest_h = open( dest,
		    O_WRONLY|O_BINARY|O_CREAT|O_TRUNC,
		    (short) rights);
      if( dest_h < 0)
	{
	  sprintf (tmp,
		   " Can't create/open file <%s> ",
		   cutpath( dest, 30, NOMODE)
		   );
	  err_   = Getyesno (tmp, Cont_Break, " copy ", -1);
	  ret_   = ret_|(err_ == 1 ? ABORT_MODE : FALSE);
	  close ( src_h);
	  return( ret_);
	}
      
      size   = max(1, lseek( src_h, 0, SEEK_END) / BLOCKSIZE); /*size of file*/
      lseek( src_h, 0, SEEK_SET);		/* size of file */
      
#ifdef UNIX
      if (use_filter)
	{			/* filter system */
	  char tmp[256];
	  int filter_pip[2] ;		/* we need two filters */
	  int writer_pip[2];
	  
	  pipe (filter_pip);		/* open two pipes */
	  pipe (writer_pip);
	  
	  filter_pid = fork ();
	  if ( filter_pid == 0 )
	    
	    {		/* run filter */
	      close (STD_OUT);      
	      dup   (filter_pip [STD_OUT]);
	      close (filter_pip [STD_OUT]);
	      close (STD_IN );      
	      dup   (writer_pip [STD_IN ] );
	      
	      execlp (filter, filter, NULL); /* exec the filter & exit */
	      exit   (-1);		     /* error */
	    }
	  
	  writer_pid = fork () ;
	  if ( writer_pid == 0 )
	    
	    {		/* write to filter */
	      close (STD_IN);
	      close (STD_OUT);      
	      close (writer_pip[ STD_IN]);	/* nothing to read */
	      
	      while ( (len = read (src_h, block, BLOCKSIZE) ) > 0)
		{
		  if ( len != write ( writer_pip [STD_OUT], block, len)) 
		    exit (-1);
		}
	      /* send a EOF's to term. the filter */
	      for (i=0; i<10; block[i++] = EOF);
	      write ( writer_pip [STD_OUT], block, 10);
	      
	      close (src_h);
	      close (writer_pip [STD_OUT]);
	      /* wait for filter to terminate */
	      exit  (0);
	    }
	  
	  close (filter_pip [STD_OUT]);
	  close (src_h);
	  src_h = filter_pip [STD_IN];		/* read from filter */
	}
#endif
      
      while( ( len = read( src_h, block, BLOCKSIZE)) > 0)
	{
	  if( write( dest_h, block, len) != len)
	    
	    {
	      remove ( dest);
	      message( " Disk is full ", " copy ");
	      ret_  |= ABORT_MODE;
	      break_ = TRUE;	
	      break;
	    }
	  
	  copied = min(size, copied+1);
	  
	  f_putnchr( f,
		    gr_x,
		    gr_y,
		    '*',
		    max(0, copied * gr_width / size),
		    f->color,
		    SCR_MODE
		    );
	  fflush_();
	}
      close( dest_h);
      close(  src_h);
      
#ifdef UNIX
      if (use_filter)
	{
	  waitpid (writer_pid, &ret, NOMODE);
	  waitpid (filter_pid, &ret, NOMODE);
	  if (ret == -1)
	    
	    {
	      message ( " Bad filter        ", " usage filter ");
	      ret_ |= ABORT_MODE;
	      return (ret_);
	    }
	}
#endif
      if( ch_ownergrp) 
	change_ownergrp( dest, new_owner, new_grp);
    }
  
  return( ret_);
}

#ifdef UNIX
#	define LOG_CNT 		5
#	define LOG_BEG		2
#	define STR_CNT		2
#	define LINE_CNT		2
#	define FILTERLEN	30
#else
#	define LOG_CNT 		2
#	define LOG_BEG		1
#	define STR_CNT		1
#	define LINE_CNT		1
#endif

void copy_file( struct win_t * w)
{
  struct frame_t * qs, *f;
  struct input_t * in;
  struct log_t   * lg[LOG_CNT];
  
  int file_copied= 0,
  dir_copied = 0,
  err_         = 0,
  end_	     = FALSE,
  width        = min(60, max_x),
  down	     = min(5+LINE_CNT+STR_CNT+LOG_CNT, max_y),
  ok_line      = 0,
  ri_line      = 0,
  x	     = (max_x-width)/2,
  y	     = (max_y-down)/2,
  i, l, j,
  mode	     = NOMODE;
  char * file  = AKT_FILE( w),
  * info[4],
  * log_fmt[] =
    { "X", "-" },
    tmp [ 100],
    dest[ MAXPATH];
#ifdef DOS
  char * filter = NULL;
#else
  char filter[FILTERLEN] = { 0 };
#endif
  
  dest[0] =0;
  
  if( w->selected == 0)
    
    {
      if( ! can_read( file) )
	{
	  premission();
	  return;
	}
      sprintf( tmp, " Copy %s <%s> ",
	      is_dir (file, NOMODE) ? "directory" : "file",
	      file);
    }
  else
    
    {
      sprintf( tmp, " Copy %i selected files ", w->selected);
    }
  
  for(i=0; i<4; i++) info[i] = getmem (80*sizeof(char));
  
  qs = make_frame (x, y, width, down, " Copy ",
		   leer,
		   F_B_UTIL_CLR, NOMODE);
  
  width = max_x-max_x/8;
  down  = 8;
  x     = (max_x-width)/2;
  y     = (max_y-down )/2;
  f     = make_frame (x, y, width, down, " Copying ",
		      leer, F_B_UTIL_CLR, NOMODE);
  
  in = make_input( qs, STR_CNT+LOG_CNT, CUR_MODE | FIL_MODE | INS_MODE);
  
  l = 1;
  f_putstr ( qs, (qs->width-strlen(tmp))/2, l, tmp, qs->color, NOMODE);
  l += 2;
  f_putstr ( qs, 2, l, "Destination:", qs->color, NOMODE);
  l++;
  f_putline( qs, l, qs->color);
  l++;
  ri_line = l;
  
#ifdef UNIX
  f_putstr( qs,  2, l, "Filter     :", qs->color, NOMODE);
  f_putstr( qs,  qs->width-19, l, "example: 'decibm' ", qs->color, NOMODE);
  l++;
  f_putline( qs, l, qs->color);
  l++;
  ri_line = l;
  f_putstr (qs, 15, l, ": same rights",
	    qs->color, NOMODE);
  l++;
  f_putstr (qs, 15, l, ": same owner as source ",
	    qs->color, NOMODE);
  l++;
  f_putstr( qs, 15, l, ": same group as source ",
	   qs->color, NOMODE);
  l++;
#endif
  
  f_putstr ( qs, 15, l, ": recursive copy ", qs->color, NOMODE);
  l++;
  f_putline( qs, l, qs->color);
  l++;
  ok_line = l;
  /* logical field for recursive copy */
  /* and group/owner flags */
  for( j=0; j<LOG_CNT-1; j++)
    
    {
      lg[j] = make_log( qs, 2, F_B_UTIL_CHS);
      log_format (lg [j], "X", "-");
      log_xy     (lg [j], 10, ri_line+j, 10, ri_line+j);
      log_setpos (lg[j], 1);    /* default: not recursive */
    }
  
#ifdef UNIX
  log_setpos (lg[0], 0);		/* default is same rights */
#endif
  
  /* logical field to ask <break or continue>*/
  j = LOG_CNT-1;
  lg[j] = make_log( qs, 2, F_B_UTIL_CHS);
  log_format (lg [j], cont_break [0], cont_break [1]);
  log_xy     (lg [j],
	      (qs->width/2-strlen(cont_break[0]))/2, ok_line,
	      (qs->width/2) + (qs->width/2-strlen(cont_break[1]))/2, ok_line
	      );
  
  input_string (in, 0, 15, 3, dest, MAXPATH-2, MAXPATH-2);
  strcpy( dest, w_[(MY_cfg.akt_w+1)%MY_cfg.win_cnt]->path);
  
#ifdef UNIX
  input_string (in, 1, 15, 5, filter, FILTERLEN-1, FILTERLEN-1);
#endif
  
  for(i=0; i<LOG_CNT; i++)
    {
      input_log (in, i+ LOG_BEG, lg [i]);
    }
  
  view_frame( qs);		/* view the question frame */
  
  if( f_getstr( in) == ESC) end_ = TRUE;   /* choose the options */
  
  j = LOG_CNT-1;
  if( lg[j--]->pos != 0) end_ = TRUE;                  /* break */
  if( lg[j--]->pos == 0) mode = mode | RECURSIVE_MODE; /* recusive seted */
  
#ifdef UNIX
  if( lg[j--]->pos == 0) mode = mode | SAMEGROUP_MODE; /* same group */
  if( lg[j--]->pos == 0) mode = mode | SAMEOWNER_MODE;  /* same owner */
  if( lg[j--]->pos == 0) mode = mode | SAMERIGHTS_MODE;  /* same Rights */
#endif
  
  if( ! end_ && strlen(dest) > 0)
    
    {
      /* cut last '\' or '/' from path */
      for( i= strlen(dest)-1; i>=0 && dest[i] == root; i--) dest[i] = 0;
      if( w->selected == 0)
	{
	  if(
#ifdef DOS
	     dest[ strlen(dest)-1 ] != ':' &&
#endif
	     ! is_dir (dest, NOMODE)
	     )
	    mode = mode|ANOTHER_MODE;
	  
	  err_ = recursive_copy( f, AKT_FILE(w), dest, filter, &mode);
	  
	  if( err_) message(  "File/directory not copied ..!", leer);
	  else w->new_read = TRUE;
	}
      else if( ! is_file( dest,TRUE))
	{  /* only when destination is a direcotry */
	  
	  if( ! exist( dest))
	    
	    {
	      create_dir (dest, get_rights());      /* umask */
	    }
	  
	  for(i=0; i<w->d_files; i++)
	    
	    {
	      if( ! w->dr[i]->s) continue;
	      
	      if( ! exist( W_FILE(i)) ) continue;
	      
	      err_ = recursive_copy( f, w->dr[i]->f, dest, filter, &mode);
	      if( err_ & ABORT_MODE) break;
	      
	      if( ! err_)
		{
		  if( is_dir (W_FILE(i), NOMODE) )
		    dir_copied  ++;
		  else file_copied ++;
		  w->dr[i]->s = FALSE;
		}
	    }
	  
	  /* tell the information about copy runing */
	  sprintf( info[0], " <%i> files copied ", file_copied);
	  sprintf( info[1], " <%i> directories copied ", dir_copied);
	  sprintf( info[2], " <%i> files/directories from <%i> copied ",
		  file_copied+ dir_copied,
		  w->selected);
	  info[3] = NULL;
	  getyn (info, ok_, " Report from copy command ", leer, -1);
	  if( file_copied+ dir_copied> 0) w->new_read = TRUE;
	}
    }  /* if ! end_ */
  
  hide_frame( f, DELETE_MODE | HIDE_MODE);
  hide_frame( qs, DELETE_MODE | HIDE_MODE);
  for(i=0; i<2; i++) del_log (lg[i]);
  del_input( in);
  for(i=0; i<4; i++) Free    (info[i]);
  
}

int recursive_copy (struct frame_t *f,
		    char * file, char * dst, char * filter,
		    int * mode)
{
  /* mode = RECURSIVE : copy directory recursive */
  
  DIR * dir;
  struct dirent * d;
  char filename[ MAXPATH],   /* to give file with there path */
  dest_[MAXPATH],
  tmp  [MAXPATH];
  int	err_ = FALSE;
  
  if( is_dir (file, NOMODE) )
    {
      
      if( *mode & RECURSIVE_MODE)
	{
	  
	  if( *mode & ANOTHER_MODE) get_restdir ( file, tmp);
	  else strcpy( tmp, file);
	  strcpy( dest_, dst);
	  if( strlen(tmp) > 0)
	    sprintf( dest_+strlen(dest_), "%c%s", root, tmp);
	  
	  err_ = copy( f, file, dest_, filter, mode);      /* first make dir. */
	  
	  if( err_) return( err_);
	  
	  if( ( dir = X_opendir( file)) == NULL)
	    
	    {
	      if( Getyesno (open_err,
			    Cont_Break,
			    " open directory ",
			    -1) 
		 == 0)
		err_  = TRUE;
	      else err_ = ABORT_MODE;
	    }
	  else
	    while( ( d = X_readdir( dir)) != NULL)
	      {
		
		if( strcmp( d->d_name, "." ) == 0 ||
		   strcmp( d->d_name, "..") == 0
		   ) continue;
		
		strcpy (filename, concat_path (file, d->d_name));
		
	        err_ = recursive_copy( f, filename, dst, filter, mode);
		
		if( err_ & ABORT_MODE) break;
	      }
	  
	  X_closedir( dir);
	}  /* if RECURSIVE_MODE  */
      
    }  /* if S_ISDIR */
  else
    {
      
      strcpy( dest_, dst);
      if( *mode & ANOTHER_MODE) get_restdir( file, tmp);
      else 			  strcpy( tmp, file);
      if( strlen(tmp) > 0)
	sprintf( dest_+strlen(dest_), "%c%s", root, tmp);
      
      err_ = copy( f, file, dest_, filter, mode);
    }
  
  return( err_);
}  /* rec */


int new_dir( void)
{
  struct frame_t * f;
  struct input_t * in;
  char str[MAXPATH];
  int err_  = 0,
  width = max_x - 10,
  down  = 6,
  x     = (max_x-width)/2,
  y     = (max_y-down)/2,
  lk;
  
  f  = make_frame( x, y, width, down,
		  " New directory ",
		  leer,
		  F_B_UTIL_CLR,
		  NOMODE);
  in = make_input( f, 1, CUR_MODE|INS_MODE);
  
  f_putstr( f, 1, 3, " Directory: ", f->color, NOMODE);
  
  str        [0] = 0;    /* string is empty */
  input_string (in, 0, 13, 3, str, MAXPATH-1, MAXPATH-1);
  
  view_frame( f);
  lk = f_getstr( in);
  
  if( (lk == ENTER || lk == CTRL_M) && strlen(str) > 0 )
    { 
      /* 
       * mode have only 8 Bits (0777) <=> 0x7F
       */
      err_ = create_dir (str, get_rights());
    }
  
  if (err_) message (" Directory not created ", " MakeDir ");
  
  del_input  (in);
  hide_frame (f, HIDE_MODE|DELETE_MODE);
  
  return (err_);
}

/**********************************************************************/
/*       change mode of current/selected files 			      */
/**********************************************************************/

void change_mode( struct win_t * w)
{
  struct frame_t * f, * qs;
  struct input_t * in;
#ifdef UNIX
  struct log_t   * lg[11];    /* owner, group and all writes and recursive
				 and to ask of '  OK  ' */
  int log_cnt   = 11,	        /* count of the logical fields to edit */
  rwx_cnt   = 9,          /* count of rightes */
  rec_mode  = 9,		/* recursive-mode position */
  cont_mode = 10;		/* logical field to continue */
#else
  struct log_t   * lg[6];     /* WRITE, READ recursive and to ask of 'OK' */
  int log_cnt   = 6,	        /* count of the logical fields to edit */
  rwx_cnt   = 4,
  rec_mode  = 4,		/* recursive-mode position */
  cont_mode = 5;		/* logical field to continue */
#endif
  int file_changed = 0,
  dir_changed  = 0,
  err_         = 0,
  end_	     = FALSE,
  width        = min(50, max_x),
#ifdef UNIX
  down	     = min(12, max_y),
#else
  down	     = min(12, max_y),
#endif
  x	     = (max_x-width)/2,
  y	     = (max_y-down)/2,
  i, j,
  f_mode	     = 0,	/* the new mode of selected/current files */
  mode	     = NOMODE;
  char * file  = AKT_FILE( w),
  * info[4],
  * log_fmt[]   =
    { "X", " " },
    * rwx_fmt[] = { "X", "-" },
      tmp[ 100];
  
  if( w->selected == 0)
    {
      if( ! can_write( file) )
	{
	  premission();
	  return;
	}
      sprintf( tmp, " change mode of %s <%s> ",
	      is_dir (file, NOMODE) ? "directory" : "file",
	      file);
    }
  else
    {
      sprintf( tmp, " change mode of %i selected files ", w->selected);
    }
  
  for(i=0; i<4; i++) info[i] = getmem( 80*sizeof(char));
  
  qs = make_frame( x, y, width, down, " change mode ", leer, F_B_UTIL_CLR, NOMODE);
  in = make_input( qs, log_cnt, CUR_MODE | INS_MODE);
  
  /* information line */
  f_putstr ( qs, (qs->width-strlen(tmp))/2, 1, tmp, qs->color, NOMODE);
  /* line between info-line and mode lines **/
  f_putline( qs, 2, qs->color);
#ifdef UNIX
  f_putstr( qs, 2, 3, "           Owner          Group          Other ",
	   qs->color, NOMODE);
  f_putstr( qs, 2, 4, "Read:   ", qs->color, NOMODE);
  f_putstr( qs, 2, 5, "Write:  ", qs->color, NOMODE);
  f_putstr( qs, 2, 6, "Execute:", qs->color, NOMODE);
#else
  f_putstr( qs, 2, 3, "Read only:", qs->color, NOMODE);
  f_putstr( qs, 2, 4, "Hidden:   ", qs->color, NOMODE);
  f_putstr( qs, 2, 5, "System:   ", qs->color, NOMODE);
  f_putstr( qs, 2, 6, "Archiv:   ", qs->color, NOMODE);
#endif
  
  f_putline( qs, 7, qs->color); /* line between modes and ask of recursive */
  
  f_putstr ( qs, 12+strlen(log_fmt[0]), 8, " : recursive change mode",
	    qs->color, NOMODE);
  
  f_putline( qs, 9, qs->color); /* line between recursive and continue line*/
  
  /* logical field for file modes and recursive mode */
#ifdef UNIX
  for(j=0; j<rwx_cnt; j++)
    {
      lg[j] = make_log( qs, 2, F_B_UTIL_CHS);
      log_format (lg [j], "X", "-");
      log_xy     (lg [j],
		  15 + (j/3) * 15, 4 + j % 3,
		  15 + (j/3) * 15, 4 + j % 3);
      log_setpos (lg[j], 1);             /* default: not recursive */
    }
#else
  for(j=0; j<rwx_cnt; j++)
    {
      lg[j]  = make_log( qs, 2, F_B_UTIL_CHS);
      log_format (lg [j], "X", "-");
      log_xy     (lg [j], 15, 3 + j, 15, 3 + j);
      log_setpos (lg[j], 1);             /* default: not recursive */
    }
#endif
  
  /* input field for recursive mode */
  
  lg[rec_mode] = make_log( qs, 2, F_B_UTIL_CHS);
  log_format (lg [rec_mode], "X", " ");
  log_xy     (lg [rec_mode], 10, 8, 10, 8);
  log_setpos (lg [rec_mode], 1);             /* default: not recursive */
  
  /* logical field to ask <break or continue>*/
  lg[cont_mode]  = make_log( qs, 2, F_B_UTIL_CHS);
  log_format (lg [cont_mode], cont_break[0], cont_break[1]);
  log_xy     (lg [cont_mode],
	      (qs->width/2-strlen(cont_break[0]))/2, 10,
	      (qs->width/2) + (qs->width/2-strlen(cont_break[1]))/2, 10);

  /* make input record */
  for(i=0; i<log_cnt; i++)
    {
      input_log (in, i, lg [i]);
    }
  
  view_frame( qs);		/* view the question frame */
  
  /* set the mode of current file as default */
  if( w->selected == 0)
    {
#ifdef UNIX
      int mm = get_stat( AKT_FILE(w));
      for(i=0; i<rwx_cnt; i++)
	{
	  lg[i]->pos = (mm & 0x0100) ? 0 : 1;  	/* ask the 9. Bit */
	  mm = mm << 1;	 		  /* move the bits rights */
	}
#else
      f_mode = _chmod( AKT_FILE(w), 0, 0xffff);  /* get file mode */
      lg[0]->pos = (f_mode & FA_RDONLY) ? 0 : 1;  /* ask the 9. Bit */
      lg[1]->pos = (f_mode & FA_HIDDEN) ? 0 : 1;  /* ask the 9. Bit */
      lg[2]->pos = (f_mode & FA_SYSTEM) ? 0 : 1;  /* ask the 9. Bit */
      lg[3]->pos = (f_mode & FA_ARCH  ) ? 0 : 1;  /* ask the 9. Bit */
#endif
    }
  
  if( f_getstr( in) == ESC) end_ = TRUE;   /* choose the options */
  
  if( lg[cont_mode]->pos != 0) end_ = TRUE;
  if( lg[rec_mode]->pos == 0)
    mode = mode | RECURSIVE_MODE; /* recusive mode seted */
  
  /* construate the file mode to set */
#ifdef UNIX
  for(i=0; i<rwx_cnt; i++)
    {
      f_mode = f_mode << 1;
      f_mode = f_mode | ( lg[i]->pos == 0 ? 0x0001 : 0x0000);
    }
#else
  f_mode = 0;
  f_mode = f_mode | ( lg[0]->pos == 0 ? FA_RDONLY : 0x0000);
  f_mode = f_mode | ( lg[1]->pos == 0 ? FA_HIDDEN : 0x0000);
  f_mode = f_mode | ( lg[2]->pos == 0 ? FA_SYSTEM : 0x0000);
  f_mode = f_mode | ( lg[3]->pos == 0 ? FA_ARCH   : 0x0000);
#endif
  
  if( ! end_)
    {
      int width = min( max_x, 65),
      down  = 5,
      x     = (max_x - width) / 2,
      y     = (max_y - down)  / 2;
      
      f = make_frame( x, y, width, down, " change mode of .. ",
		     leer,
		     F_B_UTIL_CLR,
		     NOMODE);
      view_frame( f);
      
      if( w->selected == 0)
	{
	  err_ = recursive_change_mode( f, AKT_FILE(w), f_mode, mode);
	  if( err_) message(  "Mode of file/directory not modified ..!", leer);
	  else w->new_read = TRUE;
	}
      else
	{
	  for(i=0; i<w->d_files; i++)
	    {
	      if( ! w->dr[i]->s) continue;
	      
	      if( ! exist( W_FILE(i)) ) continue;
	      
	      err_ = recursive_change_mode( f, W_FILE(i), f_mode, mode);
	      if( err_ & ABORT_MODE) break;
	      
	      if( ! err_) 
		if( is_dir (W_FILE(i), NOMODE) )
		  dir_changed++;
		else file_changed ++;
	      
	    }
	  
	  /* tell the information about change mode runing */
	  sprintf( info[0], " Mode of <%i> files was modified ", 
		  file_changed);
	  sprintf( info[1], " Mode of <%i> directories was modified ", 
		  dir_changed);
	  sprintf( info[2], 
		  " Mode of <%i> files/directories from <%i> was modified ",
		  file_changed + dir_changed, 
		  w->selected);
	  info[ 3] = NULL;
	  getyn (info, ok_,
		 " Report from 'change mode' command ",
		 leer,
		 -1);
	  if( file_changed + dir_changed > 0) w->new_read = TRUE;
	}
      
      hide_frame( f, HIDE_MODE | DELETE_MODE);
    }  /* if ! end_ */
  
  hide_frame( qs, DELETE_MODE | HIDE_MODE);
  for(i=0; i<log_cnt; i++) del_log( lg[i]);
  del_input( in);
  for(i=0; i<4; i++) Free( info[i]);
  
}

int recursive_change_mode( struct frame_t * f, char * file, int f_mode, 
			  int mode)
{
  /* mode = RECURSIVE : change mode of directory recursive */
  
  DIR * dir;
  struct dirent * d;
  char tmp     [ 255],
  filename[ 512];   /* to give file with there path */
  int err_ = FALSE, ret = FALSE;
  
  sprintf( tmp, "Change mode of <%s>", cutpath( file, f->width-12, NOMODE));
  f_fillnstr( f, 1, 2, tmp, strlen(tmp), '.', f->color, SCR_MODE|FILL_MODE);
  fflush_();
  
  if( ! exist( file))
    
    {
      if( Getyesno (stat_err, Cont_Break, " File state ", 0) == 0)
	err_ = TRUE;
      else err_ = ABORT_MODE;
      return( err_);
    }
  
  if( is_dir (file, NOMODE) )
    {
      
      if( mode & RECURSIVE_MODE)
	{
	  
	  if( ( dir = X_opendir( file)) == NULL)
	    
	    {
	      if( Getyesno (open_err, Cont_Break, " open directory ", -1)
		 == 0)
		err_ = TRUE;
	      else err_ = ABORT_MODE;
	      return( err_);
	    }
	  
	  while( ( d = X_readdir( dir)) != NULL)
	    {
	      
	      if( strcmp( d->d_name, "." ) == 0 || 
		 strcmp( d->d_name, "..") == 0
		 ) continue;
	      
	      /* file with path */
	      sprintf( filename, "%s/%s", file, d->d_name);
	      
	      err_ = recursive_change_mode( f, filename, f_mode, mode);
	      
	      if( err_ & ABORT_MODE) break;
	    }
	  
	  X_closedir( dir); 
	}  /* if mode & RECURSIVE_MODE */
      
#ifdef UNIX
      if( ! err_) if( chmod( file, (short) f_mode) != 0) ret = TRUE;
#else
      if( ! err_) if( _chmod( file, 1, f_mode) == -1) ret = TRUE;
#endif
    }  /* if S_ISDIR */
  
  else
    {
      
#ifdef UNIX
      if( chmod( file, (short) f_mode) != 0) ret = TRUE;
#else
      if( _chmod( file, 1, f_mode) == -1) ret = TRUE;
#endif
    }
  
  if( ret)
    {
      if( Getyesno (not_del, Cont_Break, leer, 0) == 0)
	err_ = TRUE;
      else err_ = ABORT_MODE;
    }
  
  return( err_);
}  /* rec */

/**********************************************************************/
/* end change mode of 'selected' files 			      	      */
/**********************************************************************/

/**********************************************************************/
/*       change owner of current/selected files 		      */
/**********************************************************************/

#ifdef UNIX

void change_owner( struct win_t * w)
{
  struct frame_t * f, * qs;
  struct input_t * in;
  struct log_t   * lg[2];    /* recursive and to ask of '  OK  ' */
  
  char new_user[ U_G_LEN],				/* new user  */
  new_grp [ U_G_LEN];				/* new group */
  int new_uid   = u_id,
  new_gid   = g_id,
  log_cnt   = 2,
  rec_owner  = 0,
  cont_owner = 1;
  int file_changed = 0, 
  dir_changed  = 0, 
  err_         = 0, 
  end_	     = FALSE,
  width        = min(50, max_x),
  down	     = min(10, max_y),
  x	     = (max_x-width)/2,
  y	     = (max_y-down)/2,
  i, j,
  l = 0,				/* current line */
  ok,
  len,
  mode	     = NOMODE;
  char
    * file  = AKT_FILE( w),
    * txt[] = { "x", "x", NULL };
  char 
    * info[4],
    tmp[ 100];
  
  new_user[0] = 0;
  new_grp [0] = 0;
  
  if( w->selected == 0)
    {
      if( ! can_write( file) )
	{
	  premission();
	  return;
	}
      sprintf( tmp, " change owner/group of %s <%s> ", 
	      is_dir (file, NOMODE) ? "directory" : "file", 
	      file);
    }
  else
    {
      sprintf( tmp, " change owner/group of %i selected files ", w->selected);
    }
  
  
  for(i=0; i<4; i++) info[i] = getmem( 80*sizeof(char)); /* info block */
  
  qs = make_frame( x, y, width, down, 
		  " change owner/group of files ",
		  /*" PageUp/Down:for list of owners/groups ",*/
		  " PageUp/Down:for"
		  " l\bli\bis\bst\bt*\b o\bof\bf \b "
		  "o\bow\bwn\bne\ber\brs\bs/\b/g\bgr\bro\bou\bup\bps\bs ",
		  F_B_UTIL_CLR, NOMODE);
  in = make_input( qs, 2+log_cnt, CUR_MODE | INS_MODE);
  
  l = 1;				/* first line */
  /* information line */
  /*1*/    f_putstr ( qs, (qs->width-strlen(tmp))/2, l++, tmp, 
		     qs->color, NOMODE);
  /* line between info-line and owner/group lines **/
  /*2*/    f_putline( qs, l++, qs->color);
  /*3*/    f_putstr( qs, 2, l++, "Owner:", qs->color, NOMODE);
  /*4*/    f_putstr( qs, 2, l++, "Group:", qs->color, NOMODE);
  
  /*5*/    f_putline( qs, l++, qs->color);                      /* line */
  
  /*6*/    f_putstr ( qs, 13, l++, 
		     " : recursive change owner/group",
		     qs->color, NOMODE);
  
  /*7*/    f_putline( qs, l++, qs->color); /* line */
  
  /* input field for recursive mode */
  
  lg[rec_owner] = make_log( qs, 2, F_B_UTIL_CHS);
  log_format (lg [rec_owner], "X", " ");
  log_xy     (lg [rec_owner], 10, 6, 10, 6);
  lg[rec_owner]->pos = 1;             /* default: not recursive */
  
  /* logical field to ask <break or continue>*/
  lg[cont_owner]  = make_log( qs, 2, F_B_UTIL_CHS);
  log_format (lg [cont_owner], cont_break[0], cont_break[1]);
  log_xy     (lg [cont_owner],
	      (qs->width/2-strlen(cont_break[0]))/2, 8,
	      (qs->width/2) + (qs->width/2-strlen(cont_break[1]))/2, 8);
  
  /* make input record */
  input_string (in, 0, 10, 3, new_user, U_G_LEN-1, U_G_LEN-1);
  input_string (in, 1, 10, 4, new_grp,  U_G_LEN-1, U_G_LEN-1);

  in->getfromlist [0] = get_username;	      /* call lists by page-Up/Dn*/
  in->getfromlist [1] = get_grpname;
  in->mode            = in->mode | HIST_MODE; /* to get string from list */
  
  for(i=0; i<log_cnt; i++)
    {
      input_log (in, i+2, lg [i]);
    }
  
  view_frame( qs);		/* view the question frame */
  
  /* validate, if user/group is avail */
  while( TRUE)
    {
      char * q, * p;
      if( f_getstr( in) == ESC) end_ = TRUE;   /* choose the options */
      ok = TRUE;
      
      if( end_) break;
      
      /* check user name, if avail */
      for(i=0; i<user_cnt; i++)
	{
	  if( strcmp( new_user, user_name[i]) == 0) break;
	}
      if( i>=user_cnt) in->pos = 0, ok = FALSE;
      else new_uid = user_id[i];
      if( ! ok) continue;
      
      /* check group name, if avail */
      for(i=0; i<grp_cnt; i++)
	{
	  if( strcmp( new_grp, grp_name[i]) == 0) break;
	}
      if( i>=grp_cnt) in->pos = 1, ok = FALSE;
      else new_gid = grp_id[i];
      if( ! ok) continue;
      
      break;
    }
  
  if( lg[cont_owner]->pos != 0) end_ = TRUE;
  if( lg[rec_owner]->pos == 0) mode = mode | RECURSIVE_MODE; /* recusive */
  
  if( ! end_)
    {
      
      f = make_frame( (max_x-70)/2, (max_y-5)/2-2, 70, 5, 
		     " change owner/group of .. ", leer,
		     F_B_UTIL_CLR, NOMODE);
      view_frame( f);
      
      if( w->selected == 0)
	{
	  err_ = recursive_change_owner( f, AKT_FILE(w), new_uid, new_gid, 
					mode);
	  if( err_) message(  "Owner/group of file/directory not modified ..!",
			    leer);
	  else w->new_read = TRUE;
	}
      else
	{
	  for(i=0; i<w->d_files; i++)
	    {
	      if( ! w->dr[i]->s) continue;
	      
	      if( ! exist( W_FILE(i)) ) continue;
	      
	      err_ = recursive_change_owner( f, W_FILE(i), new_uid, new_gid,
					    mode);
	      if( err_ & ABORT_MODE) break;
	      
	      if( ! err_) 
		if( is_dir (W_FILE(i), NOMODE) )
		  dir_changed++;
		else file_changed ++;
	      
	    }
	  
	  /* tell the information about change owner/group runing */
	  sprintf( info[0], " Owner/Group of <%i> files was modified ", 
		  file_changed);
	  sprintf( info[1], " Owner/Group of <%i> directories was modified ", 
		  dir_changed);
	  sprintf( info[2],
		  " Owner/Group of <%i> files/directories from <%i> was modified ",
		  file_changed + dir_changed, 
		  w->selected);
	  info[3] = NULL;
	  getyn (info, ok_,
		 " Report from 'change Owner/Group' command ",
		 leer,
		 -1);
	  if( file_changed + dir_changed > 0) w->new_read = TRUE;
	}
      hide_frame( f, HIDE_MODE | DELETE_MODE);
    }  /* if ! end_ */
  
  hide_frame( qs, DELETE_MODE | HIDE_MODE);
  for(i=0; i<log_cnt; i++) del_log( lg[i]);
  del_input( in);
  for(i=0; i<4; i++) Free( info[i]);
  
}

int recursive_change_owner( struct frame_t * f, 
			   char * file,
			   int new_uid,
			   int new_gid, 
			   int mode)
{
  /* mode = RECURSIVE : change owner/group of directory recursive */
  
  DIR * dir;
  struct dirent * d;
  char tmp     [ 255],
  filename[ 512];   /* to give file with there path */
  int err_ = FALSE, ret = FALSE;
  
  sprintf( tmp, "Change Owner/Grp of <%s>", cutpath( file, f->width-12, NOMODE));
  f_fillnstr( f, 1, 2, tmp, strlen(tmp), '.', f->color, SCR_MODE | FILL_MODE);
  fflush_();
  
  if( is_dir (file, NOMODE))
    {
      
      if( mode & RECURSIVE_MODE)
	{
	  
	  if( ( dir = X_opendir( file)) == NULL)
	    {
	      if( Getyesno ( open_err, 
			    Cont_Break, 
			    " open directory ", 
			    -1) == 0)
		err_ = TRUE;
	      else err_ = ABORT_MODE;
	      return( err_);
	    }
	  
	  while( ( d = X_readdir( dir)) != NULL)
	    {
	      
	      if( strcmp( d->d_name, "." ) == 0 || 
		 strcmp( d->d_name, "..") == 0
		 ) continue;
	      
	      /* file with path */
	      sprintf( filename, "%s/%s", file, d->d_name);
	      
	      /* recursive call of remove */
	      err_ = recursive_change_owner( f, filename,
					    new_uid,
					    new_gid,
					    mode);
	      if( err_ & ABORT_MODE) break;
	    }
	  
	  X_closedir( dir); 
	}  /* if mode & RECURSIVE_MODE */
      
      if( ! err_) if( chown( file, new_uid, new_gid) != 0) ret = TRUE;
    }  /* if S_ISDIR */
  else
    {
      if( chown( file, new_uid, new_gid) != 0) ret = TRUE;
    }
  
  if( ret)
    {
      if (Getyesno (not_del, Cont_Break, leer, 0) == 0)
	err_ = TRUE;
      else err_ = ABORT_MODE;
    }
  
  return( err_);
}  /* rec */

#endif

/**********************************************************************/
/* end change owner/group of 'selected' files 		      	      */
/**********************************************************************/

/**********************************************************************/
/* view size of file/direcotry recursive      		      	      */
/**********************************************************************/

void view_size( struct win_t * w)
{
  struct frame_t * f;
  char
    tmp[128];
  double size = 0;
  int
    dirs  = 0,
    files = 0,
    i,
    width = min( max_x,40),
    down  = min( max_y, 8),
    y     = ( max_y-down) / 2,
    x     = ( max_x-width) / 2;
  
  if( w->selected == 0)
    sprintf( tmp, " Size of <%s> ", w->dr[w->akt_pos]->f);
  else
    sprintf( tmp, " Size of %i selected files ", w->selected);
  
  f = make_frame( x, y, width, down, tmp, leer, F_B_UTIL_CLR, NOMODE);
  
  f_putstr( f, 1, 2, " Please wait ... ", f->color, NOMODE);
  
  view_frame( f); fflush_();
  

  if( w->selected == 0)				/* size of aktual file */
    size = file_size_count (w->dr[w->akt_pos]->f,
			    &files,
			    &dirs,
			    f,
			    RECURSIVE_MODE);
  else
    for( i=0; i<w->d_files; i++)		/* size of selected files */
      {
	if( w->dr[i]->s)
	  size += file_size_count (w->dr[i]->f,
				   &files,
				   &dirs,
				   f,
				   RECURSIVE_MODE);
      }
  
  i = 2;
  sprintf  (tmp, "Directories : %i ", dirs);
  f_putstr (f, 1, i++, tmp, f->color, FILL_MODE);
  sprintf  (tmp, "Files       : %i ", files);
  f_putstr (f, 1, i++, tmp, f->color, FILL_MODE);
  sprintf  (tmp, "Total size  : %.3f KBytes ", (double) size / 1000.0);
  f_putstr (f, 1, i++, tmp, f->color, FILL_MODE);
  
  f_putstr( f, 1, i+1, " Press any key to continue ", f->color, NOMODE);
  
  view_frame( f);
  
  getkey(-1);
  
  hide_frame( f, DELETE_MODE|HIDE_MODE);
}

#endif /* if 0 */

