/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: Umenu.h,v 1.1 1996/10/16 07:09:26 khamis Exp khamis $
 * $Source: /home/xkhfm/xkhlib/include/RCS/Umenu.h,v $
 */

/******************************************************************************/
/*                                                                            */
/* Strukturen:                                                                */
/*                                                                            */
/* In diesem Include ist die MenueStruktur enthalten, die fuer                */
/* Menue Erstellung notwendig ist                                             */
/*                                                                            */
/* Funktionen:                                                                */
/*                                                                            */
/******************************************************************************/

#ifndef MENU_H
#define MENU_H

#define MENU_SEPARATOR	"SEPARATOR"
#define MENU_RULE	"RULE"
#define MENU_SPECIAL	"SPECIAL"

typedef struct
{
  void   (* prog) (Widget, void *);	/* Das Callback Programm  */
  char * label;				/* Titel des Menuebars    */
  short  visible;			/* Besuchbar oder nicht   */
  void * nextlevel;			/* Untermens		  */
  Widget buttonWdg;			/* Pointer to the created widget */
} menuitem_t;

typedef menuitem_t * Menuitem_t;

typedef struct
{
  char *     menu_bar;
  Menuitem_t menu_item;
  short      visible;
  void       (* prog) (Widget, void *);
  Widget pulldownWdg;			/* Pointer to the created widget */
  Widget cascadeWdg;
} menu_t;

typedef menu_t * Menu_t;

Widget mnuMake   (Widget parent, menu_t menu[], void * cl_data);
Widget MakeOptionMenu (Widget parent, menu_t menu[], void * cl_data);

#endif
