/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: Uxutil.h,v 1.1 1996/10/16 07:17:09 khamis Exp khamis $
 * $Source: /home/xkhfm/xkhlib/include/RCS/Uxutil.h,v $
 */
/* Funktionsname=xutil.h, SID=1.8, Date=95/09/19 */

#ifndef XUTIL_H
#define XUTIL_H

#include "Umenu.h"

/************/
/** Window Managment ********/
/************/

/** Moegliche Attribute fuer die Erstellung einer Shell ***/
#define SHELL_APPL	0x0001
#define SHELL_DIALOG	0x0002

#define TXT_MESGAREA	0x0001
#define LIST_MESGAREA	0x0002
#define BTN_MESGAREA	0x0004
#define OPM_MESGAREA	0x0008
#define RAD_MESGAREA	0x0010

/** Setzt den Titel eines Fensters **/
#define WIN_SCROLLED_WINDOW	0x0001
#define WIN_NO_MESG_AREA	0x0002

#define SetWindowTitle(win, title) XtVaSetValues (win, XmNtitle, title, NULL)

EXTERN int SetMinMaxOfShell (Widget shell,
		      XtPointer client_data, XConfigureEvent * event);

EXTERN int defMesgArea (Widget w, char * text, int Type);
EXTERN int winMesgArea (Widget w, char * text);
EXTERN int winCreate (char * title,
		      Widget *toplevel,
		      Widget * mainwindow,
		      Widget * fom_main,
		      int frac_cnt,
		      void * ClData,
		      void (* ClDest) (Widget, void*),
		      int mode);

#define DLG_NORMAL	0x0001
#define DLG_MESSAGE	0x0002
#define DLG_NOT_MODAL	0x0004
EXTERN int dlgCreate (Widget,
		      char * title,
		      Widget *toplevel,
		      Widget *mainwindow,
		      int mode);

/************/
/** ButtonFunktionen ********/
/************/
#define btnMesgArea(w, text) defMesgArea (w, text, BTN_MESGAREA)

/************/
/** Scale Funktionen ********/
/************/
EXTERN Widget sclMake (Widget parent,
		       char * label,
		       int minValue, int maxValue,
		       char * MesgArea,
		       int mode);

/************/
/** OptionMenues Funktionen *******/
/************/
#define opmMesgArea(w, text) defMesgArea (w, text, OPM_MESGAREA)
EXTERN Widget opmMake   (Widget parent,
			 menu_t menu[],
			 char * MesgArea,
			 void * cl_data);
EXTERN char * opmGetStr (Widget option);
EXTERN int    opmSetStr (Widget option, char * title);

/************/
/** RadioBox Managment ********/
/************/
#define RADIO_BOX	0x0001
#define TOGGLEE_BOX	0x0002
typedef struct 
{
  Widget radRadio;
  /** Liste der Buttons in dem RadioBox ******/
  Widget * btnRadio;
  int    countRadio;
} radioBox_t, * RadioBox_t;

#define radMesgArea(w, text) defMesgArea (w, text, RAD_MESGAREA)
EXTERN RadioBox_t radCreate   (Widget parent,
			       Menu_t mnuList,
			       char * MesgArea,
			       void * cl_data,
			       int mode);
EXTERN int        radValue    (RadioBox_t radio);
EXTERN int	  radSetValue (RadioBox_t radio, int index);

/************/
/** Listenoperationen ********/
/************/
#define LIST_SORTED	0x0001
#define LIST_UNSORTED	0x0002
#define LIST_SELECTED	0x0004	/* Einfuegen und selektieren ***/

#define enableList(list)  XtSetSensitive (list, True)
#define disableList(list) XtSetSensitive (list, False)
EXTERN Widget listCreate  (Widget parent, Menu_t mnuList, int mode);
int  listCount		  (Widget lst);
int  listAddItem	  (Widget lst, char * item, int mode);
int  listSelItem	  (Widget lst, char * item);
#define listMesgArea(w, text) defMesgArea (w, text, LIST_MESGAREA)

/************/
/** ComboBox Managment ********/
/************/
#define COM_SIDELABEL	0x0001
typedef struct
{
  Widget fomCombo;
  Widget lblCombo;
  Widget btnCombo;
  Widget txtCombo;
  Widget lstCombo;
  Menu_t mnuCombo;
  
  char * MesgArea;
  void * cl_data;

  /** Anzahl der Zeilen in der ListBox ******/
  /** Default: 10 Zeilen ********/
  short  NumLines;
  short  Hidden;
} comboBox_t, * ComboBox_t;

#define ComboItemCount(combo) listCount (combo->lstCombo)
void lstComboCB (Widget lst, ComboBox_t, XmListCallbackStruct * cbs);
void btnComboCB (Widget btn, ComboBox_t);
EXTERN ComboBox_t comCreate (Widget parent,
			     char * name,
			     Menu_t mnuList,
			     char * MesgArea,
			     void * cl_data,
			     int mode);
EXTERN int  comAddItem  (ComboBox_t, char * item, int mode);
EXTERN int  comChngItem (ComboBox_t, char * item, char * newItem);
EXTERN int  comDelItem  (ComboBox_t, char * item);
EXTERN int  comDelPos   (ComboBox_t, int pos, int count);
EXTERN int  comDispItem (ComboBox_t, char * item);
EXTERN void comDisable  (ComboBox_t);
EXTERN void comEnable   (ComboBox_t);
EXTERN int  comSelPos   (ComboBox_t, int pos);
EXTERN int  comSelItem  (ComboBox_t, char *);

/************/
/** ListBox  Managment ********/
/************/
typedef struct
{
  Widget fomLBox;
  Widget btnLBox;
  Widget txtLBox;
  Widget lstLBox;
  char * title;
  void (* lbxCB) (void *, void *);
  void * cl_data;
  /** Anzahl der Zeilen in der ListBox ******/
  /** Default: 10 Zeilen ********/
  short  NumLines;
  short  Hidden;
} listBox_t, * ListBox_t;

#define lbxItemCount(lbx)	listCount (lbx->lstLBox)
#define lbxItemPos(lbx,item)	XmListItemPos ((lbx)->lstLBox, item)

/** Selektiert ein Eintrag in der ListBox ******/
#define lbxSelItem(lbx,item)	listSelItem ((lbx)->lstLBox, item)

void lstLBoxCB (Widget lst, ListBox_t, XmListCallbackStruct * cbs);
void btnLBoxCB (Widget btn, ListBox_t);
EXTERN ListBox_t lbxCreate (Widget parent,
			    char * name,
			    void (* lbxCB) (ListBox_t, void *),
			    void * cl_data);
EXTERN int  lbxDest     (ListBox_t);
EXTERN int  lbxAddItem  (ListBox_t, char * item, int mode);
EXTERN int  lbxChngItem (ListBox_t, char * item, char * newItem);
EXTERN int  lbxDelItem  (ListBox_t, char * item);
EXTERN int  lbxDelPos   (ListBox_t, int pos, int count);
EXTERN int  lbxDispItem (ListBox_t, char * item);
EXTERN void lbxDisable  (ListBox_t);
EXTERN void lbxEnable   (ListBox_t);

/************/
/** Textoperationen ********/
/************/
#define TXT_SIDELABEL	0x0001
#define TXT_TOPLABEL	0x0002

typedef struct
{
  Widget fomText;
  Widget lblText;
  Widget txtText;
  void * cl_data;
} text_t, * Text_t;

#define txtEnable(txt) XtSetSensitive (txt, True)
#define txtDisable(txt) XtSetSensitive (txt, False)

Text_t txtCreate     (Widget parent,
		      char * title,
		      int textLength,
		      int (* textType) (char c, int pos),
		      char * MesgArea,
		      int mode);
int     txtInsString (Widget, char *);
#define txtMesgArea(w, text) defMesgArea (w, text, TXT_MESGAREA)

int     IsFileFrm   (char c, int pos);
int     IsDescrFrm  (char c, int pos);
int     IsDigitFrm  (char c, int pos);
int     IsRealFrm   (char c, int pos);
int     IsPathFrm   (char c, int pos);
int     IsInfoFrm   (char c, int pos);
int     IsCondFrm   (char c, int pos);
int     IsCommFrm   (char c, int pos);
int     IsVarFrm    (char c, int pos);

void    txtCheckFrm (Widget w, XtPointer IsOk, XmTextVerifyCallbackStruct *);

/************/
/** fuer die variable "action" *******/
/** Moegliche Parameter ********/
#define FILE_OPEN	0x0001
#define FILE_SAVE	0x0002
#define FILE_SAVEAS	0x0004
#define FILE_NEW	0x0008
#define DIR_OPEN	0x0010
#define DIR_SAVE	0x0020
#define DIR_SAVEAS	0x0040
#define DIR_NEW		0x0080

#define FILE_MUST_EXIST	0x0001

EXTERN void FileOperation (Widget parent,
			   void (* OkProg)     (Widget, void *),
			   void (* CancelProg) (Widget, void *),
			   void * cl_data,
			   char * filter,
			   int action,
			   int mode);
#endif
