/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/* Funktionsname=xutil.h, SID=1.8, Date=95/09/19 */
/* Header Deklaration fuer die AppList, dieser Typ ermoeglicht */
/* 1. Einfuegen								      */
/* 2. Bearbeiten							      */
/* 3. Loeschen und							      */
/* 4. Undo Funktion fuer eine Liste					      */

#ifndef APPLIST_H
#define APPLIST_H


#include "Umenu.h"
#include "Udchain.h"
#include "Uxutil.h"

typedef struct
{
  ListBox_t lbxApl;			       /* Die Liste der Eintraege     */
  Dchain_t  lstApl;			       /* Die zugehoerige Doppelliste */
  Dchain_t  CurrentList;
  Widget fomApl;		             /* Das Oberwidget fuer die Liste */
  Widget btnAdd, btnMod, btnDel, btnUndo;      /* Funktionswidgets ************/

  /****** User-Data-Zeiger ****************************************************/
  void * ClData;

  /****** UserFunktionen ******************************************************/

  /****** Funktion , um den Wert der Liste zu lesen ***************************/
  char * (* ClValue) (Dchain_t);

  /****** Funtion, um einen Wert in die Liste einzutragen *********************/
  void * (* ClMake) (char *);

  /****** Funtion, um einen Wert in die Liste zu aendern  *********************/
  int (* ClChange) (Dchain_t, void *);

  /****** Funtion, um einen Listeneintrag zu loeschen *************************/
  int (* ClDel) (void*);

  /****** Funtion wird aufgerufen, wenn ein Listeneintr. gespeichert wird *****/
  int (* ClSave) (Dchain_t, void*);

  /****** Funktion, um private Routinen beim Ausgeben vorzunehmen *************/
  int (* ClDisp) (Dchain_t, void *);

  /****** Funktion, um Vergleiche zwecks Sortierung zu machen *****************/
  int (* ClCompare) (void*, void*);

  /****** interne Parameter ***************************************************/
  Widget lblApl;				/* Label Widget ***************/
} appList_t, * AppList_t;

/******** erstellet neuen Eintrag mit Listenanbindung *************************/
AppList_t aplCreate (Widget parent,
		     char * title,
		     Dchain_t aplList,			   /* zugeh. Liste ***/
		     int  txtLength,
		     void * cl_data,
		     int (* ClDisp)  (Dchain_t, void*),	   /* client display */
		     int (* ClDel)   (void*),     /* Client delete **/
		     char * (* ClValue) (Dchain_t),
		     void * (* ClMake)   (char *),
		     int (* ClSave) (Dchain_t, void*),
		     int (* ClChange) (Dchain_t, void*),
		     int (* ClCompare)  (void *, void *)  /* Client Compare */
		     );

/******** gibt den Pointer auf den aktuellen Listeneintrag ********************/
Dchain_t aplValue     (AppList_t);

int aplRedisplay (AppList_t);
int aplDisplay   (AppList_t);
int aplDelete	 (AppList_t);
#endif
