/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: global.h,v 1.2 1996/10/28 03:36:10 khamis Exp khamis $
 * $Source: /home/xkhfm/xkhlib/include/RCS/global.h,v $
 */
/* Funktionsname=defines.h, SID=1.9, Date=95/09/20 */

#ifndef GLOBAL_H
#define GLOBAL_H

#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <sys/param.h>

#include "Xinc.h"

#include "config.h"
#include "Umem.h"
#include "Udchain.h"
#include "help.h"
#include "util.h"
#include "xmisc.h"

/*****************************************************************************/
/********* Globale Variable-Declarations   ***********************************/
/*****************************************************************************/
#ifdef HAVE_THREAD
/********* Threads support **/
#include <thread.h>
EXTERN thread_t * mainloop;
#endif
/********* Allgemeine Variablen, die Moduluebergreifend sind *****************/
EXTERN FILE * fptrace;

/* mutliclick timeout */
#ifdef IS_EXTERN
EXTERN int MultiClickTimeout;
#else
EXTERN int MultiClickTimeout = 300;
#endif

/********* CommandoFile **/
#ifdef IS_EXTERN
EXTERN char * XtermCommand;
EXTERN char * EditCommand;
EXTERN char * CommandFile;
#else
EXTERN char * XtermCommand = NULL;
EXTERN char * EditCommand  = NULL;
EXTERN char * CommandFile  = NULL;
#endif

/****** Variables for images *************************************************/
#ifdef HAVE_XPM
EXTERN XImage* imgList [MAX_PIXMAPS];
#else
EXTERN XImage imgList [MAX_PIXMAPS];
#endif

EXTERN Pixmap pxmList   [MAX_PIXMAPS];
EXTERN int    pxmWidth  [MAX_PIXMAPS];
EXTERN int    pxmHeight [MAX_PIXMAPS];

/****** Hilfefenster *********************************************************/
#ifdef IS_EXTERN
EXTERN Help_t   HelpWindow;
EXTERN Dchain_t HelpList;
#else
Help_t   HelpWindow = NULL;
Dchain_t HelpList   = NULL;
#endif

/********* Diese Variablen benutzt man bei Motif-Applikationen ***************/
EXTERN XtAppContext	app_context;
EXTERN Display *	display;
EXTERN int		theScreen;
EXTERN Widget           topShell;
EXTERN Window		rootWindow;
EXTERN GC		theGC;

/*** Hostname **/
EXTERN char * Hostname;

/********* User bzw GruppenId's **********************************************/
EXTERN int UserId;
EXTERN char * UserName;
EXTERN int GroupId;
EXTERN char * GroupName;

/* user- and groups list */
EXTERN Dchain_t UserList, GrpList;

/*** History command list **/
EXTERN Dchain_t  cmdList;
EXTERN Command_t cmdHist;

/*** Association list **/
EXTERN Dchain_t assList;
EXTERN Associate_t assWindow;

/*** Icon Extensions List **/
EXTERN Dchain_t iconExtensionList;
EXTERN Associate_t iconExtensionWindow;

/*** Toolbar list **/
EXTERN Dchain_t toolbarList;
EXTERN Toolbar_t toolbarWindow;

/* current pathname */
EXTERN char CurrentPath [MAXPATHLEN];


EXTERN int PixmIconWidth;
EXTERN int PixmIconHeight;

/********* Pfad der Configurationsdateien, wo alle Parameterdateien stehen ***/
EXTERN char ConfigDir [MAXPATHLEN];

/********* Programmname bzw. -pfad (argv[0]) und basename (argv[0]) **********/
EXTERN char progName [MAXPATHLEN], progDir [MAXPATHLEN]; 

/********* List for filemanager windows **************************************/
EXTERN Dchain_t winList;
/*****************************************************************************/
/********* Funkt.Declarationen ***********************************************/
/*****************************************************************************/

#ifdef IS_EXTERN
Widget GetTopShell (Widget w);
#else
Widget GetTopShell (Widget w)
{
  while (w && ! XtIsWMShell (w))
    w = XtParent (w);
#if 0
  if (w == NULL)
    return topShell;
  else
    return w;
#endif
  return w;
}
#endif

#endif
