/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: help.h,v 1.1 1996/10/16 07:12:10 khamis Exp khamis $
 * $Source: /home/xkhfm/xkhlib/include/RCS/help.h,v $
 */
/* Funktionsname=help.h, SID=1.1, Date=96/10/04 */

#ifndef HELP_H
#define HELP_H

#include "Ustrutil.h"
#include "Udchain.h"
#include "mapplist.h"

#define TITLE_HELP	"Help"
#define HelpHeader \
   "## Helpfile with existing help text xkhfm Version 1.0\n" \
   "##\n" \
   "\n"

/* Dateiname der Hilfetexte **/
#define HLP_FILENAME	"ptool.hlp"

#define hlpListFind(lst, section) UdchFind (lst, section, (int (*)(void*,void*)) hlpListComp)

/* Entsprecht in der Datei "help.cnf" **/
typedef struct 
{
  /* Sektionsbezeichnung des Hilfethemas **/
  char * hlpSection;

  /* Hilfethema **/
  char * hlpThema;

  /* MessageArea Bereich **/
  char * hlpMesgArea;

  /* Hilfeinhalt **/
  char * hlpStr;
} helpList_t, * HelpList_t;

HelpList_t hlpListMake     (char * Section);
int	   hlpListDest     (HelpList_t lst);
int        hlpListComp     (HelpList_t liste, char * Section);
Dchain_t   hlpListAdd      (Dchain_t top, char * Section);
int	   hlpListData     (Dchain_t lst, char * helpStr);
int        hlpListChng     (Dchain_t lst, char * newName);
#define hlpListRemove(lst) UdchEmptyAndDel(lst,(int(*)(void*))hlpListDest)

char *     hlpListThema    (Dchain_t);
char *     hlpListSection  (Dchain_t);
char *     hlpListStr      (Dchain_t);
char *     hlpListMesgArea (Dchain_t);

int        hlpListSaveThema  (Dchain_t, char *);
int        hlpListSaveSection(Dchain_t, char *);
int        hlpListSaveStr    (Dchain_t, char *);
int        hlpListSaveMesgArea(Dchain_t, char *);


/* Struktur der Hilfemaske */
/* Graphische Oberflaeche */
typedef struct
{
  /* Haupt Window Parameter */
  Widget winHlp, shHlp, fomMain;

  /* Die Buttons Ok */
  Widget btnOk;

  /* Editor, in dem die Hilfe gezeigt wird */
  Widget txtHelp;

  /* Applikationbox der Hilfe */
  MAppList_t aplThema;

  /* Liste der Hilfetexte (HelpList_t) */
  Dchain_t helpList;

  /* Dateiname der Hilfetexte */
  char * helpFilename;

  /* Flagge, falls die Hilfe geaendert wurde, muss neu gespeichert werden*/
  int WriteFlagg;
} help_t, * Help_t;

/* Funktionen fuer die Parameterapplikation */
EXTERN Help_t hlpMake (void);
EXTERN int    hlpView     (Help_t, char * Thema);
EXTERN int    hlpHide     (Help_t);
EXTERN int    hlpDest     (Help_t);
EXTERN int    hlpOpen     (Help_t);
EXTERN int    hlpSave	  (Help_t);

EXTERN int    hlpCheckin  (Dchain_t, Help_t);
EXTERN int    hlpDisp     (Dchain_t, Help_t);
#endif
