/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: macros.h,v 1.4 1996/10/28 05:44:50 khamis Exp khamis $
 * $Source: /home/xkhfm/xkhlib/include/RCS/macros.h,v $
 */
/* Funktionsname=defines.h, SID=1.9, Date=95/09/20 */

#ifndef MACROS_H
#define MACROS_H

#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <sys/param.h>

#define VIEW_WINDOW_LIST

/** MakroKonstanten ueberpruefen ***/
#ifndef False
#define False	0
#endif

#ifndef True
#define True	1
#endif

/*** Macro definitionen ***/
#define PROGRAM_NAME	"xkhfm"

#define OPTION_SECTION	"Options"
#define WINDOW_SECTION	"Windows"

/* defines for X11 Events */
#define DBLCLICK_TIMEOUT	MultiClickTimeout
#define CLICK_REGION		4
#define REASON_MOTION		777
#define REASON_KEYMAP		778
#define REASON_ENTER_WIN	779
#define REASON_LEAVE_WIN	780
#define REASON_FOCUS_CHANGE	781
#define REASON_COPY_MOTION	782

#define SPACE		5
#define FRAME_SPACE	5
#define MAX_INFO_LEN	1024
#define MAX_DIGIT_LEN	10
#define MAX_NAME_LEN	32
#define MAX_FILE_LEN	32
#define MAX_ARG_LEN	64

#ifndef MAXPATHLEN
#if defined (_POSIX_SOURCE) && defined (_POSIX_PATH_MAX)
#define MAXPATHLEN	_POSIX_PATH_MAX
#elif defined (PATH_MAX)
#define MAXPATHLEN	PATH_MAX
#else
#define MAXPATHLEN	512
#endif
#endif

#define SET_FG(dsp, gc, fg)   XSetForeground (dsp, gc, fg)
#define SET_BG(dsp, gc, fg)   XSetBackground (dsp, gc, fg)
#define SET_FONT(dsp, gc, fn) XSetFont       (dsp, gc, fn)

#define XTOP_F		XmNtopAttachment,    XmATTACH_FORM
#define XBOTTOM_F	XmNbottomAttachment, XmATTACH_FORM
#define XLEFT_F		XmNleftAttachment,   XmATTACH_FORM
#define XRIGHT_F	XmNrightAttachment,  XmATTACH_FORM
#define XALL_F		XTOP_F, XLEFT_F, XBOTTOM_F, XRIGHT_F

#define XTOP_W(w)	XmNtopAttachment,    XmATTACH_WIDGET, \
                        XmNtopWidget,        w
#define XLEFT_W(w)	XmNleftAttachment,   XmATTACH_WIDGET, \
                        XmNleftWidget,       w
#define XRIGHT_W(w)	XmNrightAttachment,  XmATTACH_WIDGET, \
                        XmNrightWidget,      w
#define XBOTTOM_W(w)	XmNbottomAttachment, XmATTACH_WIDGET, \
                        XmNbottomWidget,     w
  
#define XTOP_P(w)	XmNtopAttachment, XmATTACH_POSITION, \
                        XmNtopPosition, w
#define XLEFT_P(w)	XmNleftAttachment, XmATTACH_POSITION, \
                        XmNleftPosition, w
#define XRIGHT_P(w)	XmNrightAttachment, XmATTACH_POSITION, \
                        XmNrightPosition, w
#define XBOTTOM_P(w)	XmNbottomAttachment, XmATTACH_POSITION, \
                        XmNbottomPosition, w

#ifndef XmFONTLIST_DEFAULT_TAG
#define XmFONTLIST_DEFAULT_TAG XmSTRING_DEFAULT_CHARSET
#endif

#define ALL_MASKS (KeyPressMask|KeyReleaseMask|ButtonPressMask| \
		   ButtonReleaseMask|EnterWindowMask|LeaveWindowMask|\
		   PointerMotionMask|PointerMotionHintMask|\
		   Button1MotionMask|Button2MotionMask|Button3MotionMask|\
		   Button4MotionMask|Button5MotionMask|ButtonMotionMask|\
		   KeymapStateMask|ExposureMask|VisibilityChangeMask|\
		   StructureNotifyMask|ResizeRedirectMask|\
		   SubstructureNotifyMask|SubstructureRedirectMask|\
		   FocusChangeMask|PropertyChangeMask|\
		   ColormapChangeMask|OwnerGrabButtonMask)
#ifdef UnixR32
#define MXtRealizeWidget(w) {XtRealizeWidget(w); \
			     XMapRaised(XtDisplay(w),XtWindow(w));}
#else
#define MXtRealizeWidget(w) XtRealizeWidget(w)
#endif

#undef DEBUG_VIEWMEM

#ifdef DEBUG
#	define DEBUG1(a) 	  fprintf (stderr, "%s\n", a)
#	define DEBUG2(a,b) 	  fprintf (stderr, a, b)
#	define DEBUG3(a,b,c) 	  fprintf (stderr, a, b, c)
#	define DEBUG4(a,b,c,d)   fprintf (stderr, a, b, c, d)
#	define DEBUG5(a,b,c,d,e) fprintf (stderr, a, b, c, d, e)
#else
#	define DEBUG1(a) 	  
#	define DEBUG2(a,b) 	  
#	define DEBUG3(a,b,c) 	  
#	define DEBUG4(a,b,c,d)   
#	define DEBUG5(a,b,c,d,e) 
#endif

#ifndef ASSERT
#define ASSERT(x)
#endif

#define WARNING1(a) 	    fprintf (stderr, "%s\n", a)
#define WARNING2(a,b) 	    fprintf (stderr, a, b)
#define WARNING3(a,b,c)     fprintf (stderr, a, b, c)
#define WARNING4(a,b,c,d)   fprintf (stderr, a, b, c, d)
#define WARNING5(a,b,c,d,e) fprintf (stderr, a, b, c, d, e)
#define WARNING6(a,b,c,d,e,f) fprintf (stderr, a, b, c, d, e, f)
#define WARNING7(a,b,c,d,e,f,i) fprintf (stderr, a, b, c, d, e, f, i)

#define ERROR1(a) 	  fprintf (stderr, "%s\n", a)
#define ERROR2(a,b) 	  fprintf (stderr, a, b)
#define ERROR3(a,b,c) 	  fprintf (stderr, a, b, c)
#define ERROR4(a,b,c,d)   fprintf (stderr, a, b, c, d)
#define ERROR5(a,b,c,d,e) fprintf (stderr, a, b, c, d, e)

#ifdef UNIX
#	define MY_stat     	lstat
#else
#	define MY_stat		stat
#endif
#ifndef ushort
#define ushort unsigned short
#endif

#ifndef max
#define max(a, b) ((a) > (b) ? (a) : (b))
#define min(a, b) ((a) < (b) ? (a) : (b))
#else
/*#warning max and min are defined*/
#endif

#ifndef sclMesgArea
#define SCL_MESGAREA	0x0008
#define sclMesgArea(w, text) defMesgArea (w, text, SCL_MESGAREA)
#endif

/* defines for pixmaps */
enum
{
  PIXM_file16,
  PIXM_file32,
  PIXM_file_archive32,
  PIXM_file_assembler32,
  PIXM_file_bmp32,
  PIXM_file_cheader32,
  PIXM_file_clock32,
  PIXM_file_compr32,
  PIXM_file_core32,
  PIXM_file_csource32,
  PIXM_file_devblk16,
  PIXM_file_devblk32,
  PIXM_file_devchr16,
  PIXM_file_devchr32,
  PIXM_file_disk35zoll32,
  PIXM_file_disk525zoll32,
  PIXM_file_Disk_A32,
  PIXM_file_doc1_32,
  PIXM_file_doc2_32,
  PIXM_file_doc3_32,
  PIXM_file_dos32,
  PIXM_file_dosBAT32,
  PIXM_file_dosCOM32,
  PIXM_file_dosEXE32,
  PIXM_file_exec16,
  PIXM_file_exec32,
  PIXM_file_fax32,
  PIXM_file_font32,
  PIXM_file_gif32,
  PIXM_file_group32,
  PIXM_file_iff32,
  PIXM_file_image32,
  PIXM_file_info32,
  PIXM_file_iris32,
  PIXM_file_jpeg32,
  PIXM_file_link16,
  PIXM_file_link32,
  PIXM_file_mail32,
  PIXM_file_makefile32,
  PIXM_file_mouse32,
  PIXM_file_obj32,
  PIXM_file_package32,
  PIXM_file_pbm32,
  PIXM_file_pcx32,
  PIXM_file_pipe16,
  PIXM_file_pipe32,
  PIXM_file_pm32,
  PIXM_file_ps32,
  PIXM_file_ress32,
  PIXM_file_rle32,
  PIXM_file_sched32,
  PIXM_file_sem16,
  PIXM_file_sem32,
  PIXM_file_sharedobj32,
  PIXM_file_shmem16,
  PIXM_file_shmem32,
  PIXM_file_sound32,
  PIXM_file_tape32,
  PIXM_file_term32,
  PIXM_file_tiff32,
  PIXM_file_unknown16,
  PIXM_file_unknown32,
  PIXM_file_win32,
  PIXM_file_xbm32,
  PIXM_file_xpm32,
  PIXM_file_xwd32,
  PIXM_fldr16,
  PIXM_fldr32,
  PIXM_fldr_admin32,
  PIXM_fldr_appl32,
  PIXM_fldr_cdrom32,
  PIXM_fldr_dev32,
  PIXM_fldr_email32,
  PIXM_fldr_font32,
  PIXM_fldr_games32,
  PIXM_fldr_map32,
  PIXM_fldr_nfs32,
  PIXM_fldr_nfsLocal32,
  PIXM_fldr_nfsMounted32,
  PIXM_fldr_open32,
  PIXM_fldr_proc_off32,
  PIXM_fldr_proc_on32,
  PIXM_fldr_start32,
  PIXM_fldr_uucp32,
  PIXM_fldr_wb32,
  PIXM_host16,
  PIXM_keybd32,
  PIXM_kh_on_donkey,
  PIXM_ptool,
  PIXM_quit24,
  PIXM_quit32,
  PIXM_tool_copy24,
  PIXM_tool_del24,
  PIXM_tool_details24,
  PIXM_tool_draw24,
  PIXM_tool_edit24,
  PIXM_tool_execbg24,
  PIXM_tool_execwin24,
  PIXM_tool_fix24,
  PIXM_tool_horiz24,
  PIXM_tool_large24,
  PIXM_tool_link24,
  PIXM_tool_mkdir24,
  PIXM_tool_move24,
  PIXM_tool_new24,
  PIXM_tool_open24,
  PIXM_tool_parent24,
  PIXM_tool_print24,
  PIXM_tool_prop24,
  PIXM_tool_save24,
  PIXM_tool_saveas24,
  PIXM_tool_small24,
  PIXM_tool_sortdf24,
  PIXM_tool_sortn24,
  PIXM_tool_vert24,
  PIXM_tool_xkhfm24,
  PIXM_tree_dir16,
  PIXM_tree_odir16,
  PIXM_win32,
  PIXM_tool_abort48,
  PIXM_tool_run48,
  PIXM_tool_abortd48,
  PIXM_tool_stop48,

  PIXM_tool_add24,
  PIXM_tool_addd24,
  PIXM_tool_mod24,
  PIXM_tool_modd24,
  PIXM_tool_dele24,
  PIXM_tool_deled24,
  PIXM_tool_cpy24,
  PIXM_tool_cpyd24,
  PIXM_tool_paste24,
  PIXM_tool_pasted24,
  PIXM_tool_undo24,
  PIXM_tool_undod24,
  PIXM_tool_find24,
  PIXM_tool_grep24,

  MAX_PIXMAPS
};

/* Texte fuer die MessageArea **/
#define MWIN_INFO	"MWIN_INFO"
#define MWIN_WORK       "MWIN_WORK"
#define MWIN_PARENT	"MWIN_PARENT"
#define MWIN_NEW	"MWIN_NEW"
#define MWIN_OPEN	"MWIN_OPEN"
#define MWIN_COPY	"MWIN_COPY"
#define MWIN_MOVE	"MWIN_MOVE"
#define MWIN_LINK	"MWIN_LINK"
#define MWIN_PROP	"MWIN_PROP"
#define MWIN_LARGE	"MWIN_LARGE"
#define MWIN_SMALL	"MWIN_SMALL"
#define MWIN_DETAILS	"MWIN_DETAILS"
#define MWIN_VERTICAL	"MWIN_VERTICAL"
#define MWIN_HORIZ	"MWIN_HORIZ"
#define MWIN_FIXED	"MWIN_FIXED"
#define MWIN_EXIT	"MWIN_EXIT"
#define MWIN_NEWWINDOW	"MWIN_NEWWINDOW"
#define MWIN_EXECUTE	"MWIN_EXECUTE"
#define MWIN_XEXEC	"MWIN_XEXEC"
#define MWIN_DEL	"MWIN_DEL"
#define MWIN_FIXED	"MWIN_FIXED"
#define MWIN_txtComm	"MWIN_txtComm"
#define	MWIN_MKDIR	"MWIN_MKDIR"
#define	MWIN_PROP	"MWIN_PROP"
#define	MWIN_FIND	"MWIN_FIND"
#define	MWIN_GREP	"MWIN_GREP"

#define MAPL_ADD	"MAPL_ADD"
#define MAPL_MOD	"MAPL_MOD"
#define MAPL_DEL	"MAPL_DEL"
#define MAPL_UNDO	"MAPL_UNDO"
#define MAPL_COPY	"MAPL_COPY"
#define MAPL_PASTE	"MAPL_PASTE"

#define HLP_PROP_FILES	"HLP_PROP_FILES"
#define HLP_PROP_RIGHTS	"HLP_PROP_RIGHTS"
#define HLP_PROP_FILTER	"HLP_PROP_FILTER"
#define HLP_PROP_ENCLOSE "HLP_PROP_ENCLOSE"
#define HLP_PROP_IGNORE	"HLP_PROP_IGNORE"
#define HLP_PROP_FLAGGS	"HLP_PROP_FLAGS"
#define HLP_PROP_OWNER	"HLP_PROP_OWNER"
#define HLP_PROP_GROUP	"HLP_PROP_GROUP"

#define HLP_HELP	"HLP_FOR_HELP"
#define HLP_THEMA	"HLP_THEMA"
#define HLP_SECTION	"HLP_SECTION"
#define HLP_MESGAREA	"HLP_MESGAREA"
#define HLP_txtHelp	"HLP_txtHelp"

#define	REM_OK		"REM_OK"
#define	REM_CLOSE	"REM_CLOSE"
#define	REM_SOURCE	"REM_SOURCE"
#define	REM_FLAGGS	"REM_FLAGGS"

#define	HLP_CPY_OK	"CPY_OK"
#define	HLP_CPY_CLOSE	"CPY_CLOSE"
#define	HLP_CPY_SOURCE	"CPY_SOURCE"
#define	HLP_CPY_DEST	"CPY_DEST"
#define	HLP_CPY_FLAGGS	"CPY_FLAGGS"
#define	HLP_CPY_FILTER	"CPY_FILTER"
#define	HLP_CPY_COPY	"CPY_COPY"
#define	HLP_CPY_DONOTCOPY	"CPY_DONOTCOPY"

/** Titel fuer die Hilfeaufrufe der Module **/
#define MWIN_HELP	"MWIN_HELP"

#define	CMD_OK		"CMD_OK"
#define	CMD_CLOSE	"CMD_CLOSE"
#define	CMD_FLAGGS	"CMD_FLAGGS"

#define	FND_FLAGGS	"FND_FLAGGS"
#define	HLP_FND_FILES	"HLP_FND_FILES"
#define	FND_FLAGS	"FND_FLAGS"
#define	FND_INCLUSE	"FND_INCLUSE"
#define	FND_IGNORE	"FND_IGNORE"
#define	FND_OK		"FND_OK"
#define	FND_CLOSE	"FND_CLOSE"

#define	PROP_OK		"PROP_OK"
#define	PROP_CLOSE	"PROP_CLOSE"

#define	ASS_EXEC		"ASS_EXEC"
#define	ASS_MODE		"ASS_MODE"
#define	ASS_DESCR		"ASS_DESCR"
#define	ASS_PATTERN		"ASS_PATTERN"

#define	TBAR_EXEC		"TBAR_EXEC"
#define	TBAR_MODE		"TBAR_MODE"
#define	TBAR_DESCR		"TBAR_DESCR"
#define	TBAR_ICON		"TBAR_ICON"
#define	TBAR_LABEL		"TBAR_LABEL"
#define	TBAR_ICONPATH		"TBAR_ICONPATH"
#define	TBAR_FLAGGS		"TBAR_FLAGGS"

#if 0
#define			""
#endif
#endif 
