/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: mainwin.h,v 1.2 1996/10/28 03:38:26 khamis Exp khamis $
 * $Source: /home/xkhfm/xkhlib/include/RCS/mainwin.h,v $
 */

#include <sys/param.h>

#ifndef MAINWIN_H
#define MAINWIN_H

#include "defines.h"
#include "dir.h"
#include "Uxutil.h"
#include "xmisc.h"

#define MAX_WIN_MOVE	0x7FFF	/* int 2^15 */

#define TITLE_MAINWINDOW	"xkhfm"

/* defines for mwinDel */
#define MWIN_READ_FROM_CLIPBOARD 0x0001
#define MWIN_READ_NOTHING        0x0002

/* Working Direcotry History submenu */
#define HIST_MAX_ITEMS		20

/* defines for the view */
enum
{
  VIEW_LRG_ICONS = 1,
  VIEW_SML_ICONS,
  VIEW_DETAILS
};

/* defines for the function mwinViewStyle */
enum
{
  VIEW_STYLE_FIXED = 1,
  VIEW_STYLE_VERT,
  VIEW_STYLE_HORIZ
};

/* defines (flags) for the motion types (MotionType) */
#define MOTION_SELECT	0x0001
#define MOTION_MOVE	0x0002
#define MOTION_COPY	MOTION_MOVE	/* the same as MOVE flag */

/* defines for the mwinSelect and mwinSelectTree procedures **/
#define SELECT_BTN_PRESSED	0x0001
#define SELECT_BTN_RELEASE	0x0002

/* defines for the function mwinBuildTree */
#define BUILD_DONOT_CHANGE_PATH	0x0001

#ifndef IS_EXTERN
EXTERN int DefaultPixmTreeHeight	= 16;
EXTERN int DefaultPixmTreeWidth		= 16;

EXTERN int DefaultPixmWidth		= 32;
EXTERN int DefaultPixmHeight		= 32;
EXTERN int DefaultNameHeight		= 20;
EXTERN int DefaultSpaceBetweenIcons	= 15;
EXTERN int DefaultViewHeight		= 440;
EXTERN int DefaultViewWidth		= 580;
EXTERN int DefTrSpaceBetwIconAndName    = 2;
EXTERN int DefTrSpaceBetwLines          = 2;
#else
EXTERN int DefaultPixmTreeHeight;
EXTERN int DefaultPixmTreeWidth;
EXTERN int DefaultPixmWidth;
EXTERN int DefaultPixmHeight;
EXTERN int DefaultNameHeight;
EXTERN int DefaultSpaceBetweenIcons;
EXTERN int DefaultViewHeight;
EXTERN int DefaultViewWidth;
EXTERN int DefTrSpaceBetwIconAndName;
EXTERN int DefTrSpaceBetwLines;
#endif

/********* Defines ************************************************************/

/* structs for main window ****************************************/
typedef struct
{
  int iconX, iconY;
  unsigned int iconWidth, iconHeight;
  int nameX, nameY;
  unsigned int nameWidth, nameHeight;
  Dchain_t dirTreeEntry;  
} dirTreeWidgets_t , * DirTreeWidgets_t;

typedef struct
{
  int nameX, nameY;
  unsigned int nameWidth, nameHeight;
  
  int iconX, iconY;
  unsigned int iconWidth, iconHeight, iconDepth;
  
  /* when the icon have it's own pixmap */
  Pixmap   iconPixm;
  unsigned int iconPixmWidth, iconPixmHeight, iconPixmDepth;
  Colormap iconColormap;
  unsigned short iconTested;
  
  Dchain_t dirListEntry;
  unsigned short Selected;
  int      EntryType;
} dirWidgets_t , * DirWidgets_t;

typedef struct 
{

  /****** Graphische Oberflaeche **************************************/
  Widget shlMainwin;
  Widget winMainwin;			/* Das Main Fenster ***********/
  Widget txtInfo;			/* Texte **********************/
  Widget fomMain;			/* Formen *********************/
  Widget lblInfo;			/* labels *********************/

  XFontStruct * fntMainwin;
  GC gc;

  /* IntervallId for timeout callbacks */
  XtIntervalId IntervalId;

  int PixmWidth;
  int PixmHeight;
  int NameHeight;
  int SpaceBetweenIcons;
  int ViewHeight;
  int ViewWidth;
  int PixmBoxWidth;
  int PixmBoxHeight;
  int PixmXBegin;
  int PixmYBegin;

  int PixmTreeX;
  int PixmTreeY;
  int PixmTreeHeight;
  int PixmTreeIconWidth;

  Widget fomCommands;
  Widget
    btnParent,
    btnNewFile,
    bntNewDir,
    btnOpen,
    btnMove,
    btnCopy,
    btnLink,
    btnDel,
    btnMkDir,
    btnProp,
    btnGrep,
    btnFind,
    btnExec,
    btnSave,
    btnUndo,
    btnRefresh,
    btnNewWindow,
    btnExit,
    btnLarge,
    btnSmall,
    btnDetails,
    btnVertical,
    btnHorizontal,
    btnFixed;

  /* Commando line widgets */
  Widget fomExec;
  Widget cmdComm;
  Text_t txtComm;
  Widget btnExecBackgrnd, btnExecXterm;

  Widget LastSortWidget;
  Widget DirFirstWidget;
  Widget AscendingWidget;

  /* XSelection parameters */
  Time SelectionTime;

  /* tree parameters */
  Widget fomTreeFiles;
  Widget frmTree, fomTree;
  Widget scrVertTree, scrHorizTree;
  Window TreeWindow;
  DirTreeWidgets_t * dirTreeWidgets;
  int TreeClearIcons;
  int TreeLevel;
  int CurrentTreeNum;
  unsigned int dimTreeHeight, dimTreeWidth;
  unsigned int TreeMaxXPaint;
  unsigned int TreeMaxYPaint;
  long TreeViewX, TreeViewY;
  int TreeFocus;		/* Focus State for Tree */
  int TreeSoftSelNum; /* Soft Selection for Cursor Movement */
  int TreeCopySelNum; /* Copy Selection for Cursor Movement */

  /* Files entries Parameters */
  Widget frmFiles;
  Widget fomFiles;
  Widget scrVertFiles, scrHorizFiles;
  Window FilesWindow;
  DirWidgets_t * dirWidgets;

  int SelectedIcons;
  int FilesClearIcons;
  int SortMethode;
  int DirFirst;
  int Descending;
  int BeginSortingAt;
  int NameWidths [20];
  int NameWidth;
  unsigned int dimFilesHeight, dimFilesWidth;
  unsigned int FilesMaxXPaint, FilesMaxYPaint;
  long FilesViewX, FilesViewY;
  int FilesFocus;		/* focus for files list */
  int FilesSoftSelNum; /* Soft Selection for Cursor Movement */
  /* There can be more than one selected file */
  int FilesCopySelNum; /* Copy Selection for Cursor Movement */

  int btnPressX, btnPressY;
  int btnReleaseX, btnReleaseY;

  Pixmap * pixmList;
  
  Pixel fg, bg;
  Pixel filesFg, filesBg, filesHighLight;
  Pixel treeFg,  treeBg,  treeHighLight;

  /****** Current Pathname and Filter *****************************/
  char DirName   [MAXPATHLEN];
  char * DirFilter;

  /* last modify time of the current path for refreshing procedure */
  Dchain_t dirPathName;

  /****** Tree list DirTree_t ***********************/
  Dchain_t dirTree;
  int      TreeCount;

  /****** Directory entry as double chain (Dir_t) **/
  Dchain_t dirEntry;

  /****** Count of directory entries (count of items in the list) */
  int dirEntryCount;
  
  /****** Menubuttons for history **/
  Widget HistButtons[HIST_MAX_ITEMS];

  /** Structures for misc. utils *********************************/
  /** pointer to the remove utility **/
  Remove_t Remove;
  
  /** pointer to the copy utility **/
  Copy_t Copy;

  /** pointer to the Properities utility **/
  Prop_t Prop;

  /** Pointer to the MkDir utility **/
  Mkdir_t MkDir;

  /** Pointer to the Command box   **/
  Command_t Command;

  /** Pointer to the Find box   **/
  Find_t Find;

  /** Locked Flag to control the display modes */
  int Locked [4];

  /****** flag for selection&coping actions **/
  int MotionType;

  /****** Large, Smale or Details */
  unsigned short ViewMode;
  unsigned short Style;
} mainwin_t , * Mainwin_t;

/** This Action Struct is needed for the User Interface Manipulation **/
typedef struct
{
  int (* SelectProc)   (Mainwin_t mwin, XEvent *event);
  int (* ExecProc)     (Mainwin_t mwin, XEvent *event);
  int (* MotionProc)   (Mainwin_t mwin, XEvent *event);
  int (* KeyboardProc) (Mainwin_t mwin, KeySym, unsigned int);
  int (* CopyProc)     (Mainwin_t mwin, int, int);
  int (* CanCopyProc)  (Mainwin_t mwin, int, int);
  int (* PressProc)    (Mainwin_t mwin, XEvent *event);
  int (* ReleaseProc)  (Mainwin_t mwin, XEvent *event);
  
  int ActionType;
  int MotionType;
} action_t, * Action_t;

/********* macros for procedures **********************************************/
#define   mwinSelected(mwin,i) dirSelected (mwin->dirWidgets[i]->dirListEntry)

/********* Funktions *********************************************************/
/********* Graphische Oberflaeche *********************************************/
Mainwin_t mwinMake	  (void);
int	  mwinView	  (Mainwin_t);
int	  mwinDest	  (Mainwin_t);
void	  mwinTitle	  (Mainwin_t);
int	  mwinCalc	  (Mainwin_t);
int	  mwinChangeAndDisplay (Mainwin_t);
int	  mwinViewSelectedIcon (Mainwin_t mwin);
char *    mwinName  (Mainwin_t mwin);
Widget    mwinShell (Mainwin_t mwin);

int	  mwinLock	(Mainwin_t mwin, int num);
int	  mwinUnLock	(Mainwin_t mwin, int num);

void NewFileCB		(Widget, Mainwin_t);
void OpenExistingFileCB (Widget, Mainwin_t);
void SaveFileCB		(Widget, Mainwin_t);
void SaveAsFileCB	(Widget, Mainwin_t);
int  mwinAddToHistory   (Mainwin_t mwin, char * PathName);
int  mwinGetSelectedFiles (Mainwin_t mwin, char ** files);

int mwinCopyMove    (Mainwin_t mwin, int mode);
int mwinProp        (Mainwin_t mwin);
int mwinMkDir       (Mainwin_t mwin);
int mwinDel         (Mainwin_t mwin, int mode);
int mwinSave	    (Mainwin_t);
int mwinSaveAs	    (Mainwin_t);
int mwinCrPixmaps   (void);

/* file manipulation */
int mwinDisp	    (Mainwin_t);
int mwinFilesDest   (Mainwin_t mwin);
int mwinSelect	    (Mainwin_t mwin, XEvent *event);
int mwinRelease	    (Mainwin_t mwin, XEvent *event);
int mwinSelectIcon  (Mainwin_t mwin, int num, int mode);
int mwinRedisp	    (Mainwin_t mwin);
int mwinRedraw	    (Mainwin_t mwin, int mode);
int mwinSort	    (Mainwin_t mwin, int sortMethode);
int mwinCurrentSort (Mainwin_t mwin, Widget w);
int mwinSaveSetup   (void);
int mwinReadSetup   (void);
int mwinSetCoord    (Mainwin_t mwin);
int mwinKey         (Mainwin_t mwin, KeySym, unsigned int state);
int mwinViewStyle (Mainwin_t, unsigned long);

/* file tree manipulation */
int mwinDispTreeIcon (Mainwin_t mwin, int num, int mode);
int mwinTreeDisp     (Mainwin_t mwin);
int mwinCalcTree     (Mainwin_t mwin);
int mwinSetTree      (Mainwin_t mwin, Dchain_t tree, int pos);
int mwinTreeRedisp   (Mainwin_t mwin);
int mwinTreeSelPath  (Mainwin_t mwin);
int mwinSelectTree   (Mainwin_t mwin, XEvent *event);
int mwinBuildTree    (Mainwin_t mwin, int mode);
int mwinTreePress    (Mainwin_t mwin, XEvent *event);
int mwinExecTree     (Mainwin_t mwin, XEvent *event);
int mwinTreeViewHide (Mainwin_t mwin, int index);
int mwinShowIcon     (Mainwin_t mwin, int num);
int mwinChangeTo     (Mainwin_t mwin, char * path);


int mwinChangePathName (Mainwin_t mwin, char * PathName);
int mwinExecCmd        (Mainwin_t mwin, char * Cmd, int mode);
int mwinDispStatus     (Mainwin_t mwin);

int mwinExec           (Mainwin_t mwin, XEvent *event);
int mwinPress          (Mainwin_t mwin, XEvent *event);

int mwinTreeKey        (Mainwin_t mwin, KeySym, unsigned int state);

int mwinCopy           (Mainwin_t mwin, int x, int y);
int mwinCanCopy        (Mainwin_t mwin, int x, int y);
int mwinSoftSelectIcon (Mainwin_t mwin, int num, int mode);
int mwinCopySelectIcon (Mainwin_t mwin, int num, int mode);

int mwinTreeCopy       (Mainwin_t mwin, int x, int y);
int mwinTreeCanCopy    (Mainwin_t mwin, int x, int y);
int mwinTreeSoftSelectIcon (Mainwin_t mwin, int num, int mode);
int mwinTreeCopySelectIcon (Mainwin_t mwin, int num, int mode);
int mwinTreeViewKinds      (Mainwin_t mwin, int index);


int mwinAction         (Widget w,
			Mainwin_t mwin,
			XmDrawingAreaCallbackStruct * cbs,
			Action_t action);
int mwinSetPixmapToWidget (Widget wdgt, int index, int mode);
int mwinHaveSubDir      (Mainwin_t, int index, int mode);


/* defines for long text ?! ***/
#define MW_TENTRY(m,i) (m)->dirTreeWidgets[i]->dirTreeEntry
#define MW_TREE(m,i)       (m)->dirTreeWidgets[i]
#define MW_TICON_X(m,i)  MW_TREE(m,i)->iconY
#define MW_TICON_Y(m,i)  MW_TREE(m,i)->iconY
#define MW_TICON_W(m,i)  MW_TREE(m,i)->iconWidth
#define MW_TICON_H(m,i)  MW_TREE(m,i)->iconHeight
#define MW_TICON_Y2(m,i) (MW_TICON_Y(m,i)+MW_TICON_H(m,i))
#define MW_TICON_X2(m,i) (MW_TICON_X(m,i)+MW_TICON_W(m,i))
#define MW_TNAME_X(m,i)  MW_TREE(m,i)->iconY
#define MW_TNAME_Y(m,i)  MW_TREE(m,i)->iconY
#define MW_TNAME_W(m,i)  MW_TREE(m,i)->iconWidth
#define MW_TNAME_H(m,i)  MW_TREE(m,i)->iconHeight
#define MW_TNAME_Y2(m,i) (MW_TICON_Y(m,i)+MW_TICON_H(m,i))
#define MW_TNAME_X2(m,i) (MW_TICON_X(m,i)+MW_TICON_W(m,i))

#define MW_FENTRY(m,i) (m)->dirWidgets[i]->dirEntry
#define MW_FILES(m,i)       (m)->dirWidgets[i]
#define MW_FICON_X(m,i)     MW_FILES(m,i)->iconY
#define MW_FICON_Y(m,i)     MW_FILES(m,i)->iconY
#define MW_FICON_W(m,i)     MW_FILES(m,i)->iconWidth
#define MW_FICON_H(m,i)     MW_FILES(m,i)->iconHeight
#define MW_FICON_Y2(m,i)    (MW_FICON_Y(m,i)+MW_FICON_H(m,i))
#define MW_FICON_X2(m,i)    (MW_FICON_X(m,i)+MW_FICON_W(m,i))
#define MW_FNAME_X(m,i)     MW_FILES(m,i)->iconY
#define MW_FNAME_Y(m,i)     MW_FILES(m,i)->iconY
#define MW_FNAME_W(m,i)     MW_FILES(m,i)->iconWidth
#define MW_FNAME_H(m,i)     MW_FILES(m,i)->iconHeight
#define MW_FNAME_Y2(m,i)    (MW_FICON_Y(m,i)+MW_FICON_H(m,i))
#define MW_FNAME_X2(m,i)    (MW_FICON_X(m,i)+MW_FICON_W(m,i))


EXTERN char * histList[HIST_MAX_ITEMS];


#endif
