/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: mapplist.h,v 1.1 1996/10/16 07:14:53 khamis Exp khamis $
 * $Source: /usr2/xkhfm/xkhlib/include/RCS/mapplist.h,v $
 */
/* Funktionsname=xutil.h, SID=1.8, Date=95/09/19 */
/* Header Deklaration fuer die MAppList, dieser Typ ermoeglicht */
/* 1. Einfuegen								      */
/* 2. Bearbeiten							      */
/* 3. Loeschen und							      */
/* 4. Undo Funktion fuer eine Liste					      */

#ifndef MAPPLIST_H
#define MAPPLIST_H


#include "Udchain.h"
#include "Uxutil.h"

#ifndef MAX_COMM_LEN
#define MAX_COMM_LEN	MAX_INFO_LEN
#endif

#ifndef MAX_COND_LEN
#define MAX_COND_LEN	MAX_INFO_LEN
#endif

#define MAX_LIST_CNT	10
#define MLC		MAX_LIST_CNT

/********* Moegliche Werte fuer (appList_t).mode ******************************/
#define ADD_AFTER_SELECTED	0x0001
#define ADD_BEVOR_SELECTED	0x0002
#define ADD_AT_LAST		0x0004
#define ADD_AT_TOP		0x0008

#define MOD_DONOT_CHANGE_POS	0x0010

typedef struct
{
  int      ListCount;
  Dchain_t ClList;		/* zugeh. Liste ***/
  void *   ClData;		/* Private Daten */
  char *   Title;		/* Titel der Liste, falls mehrere Spalten */
  int      mode;

  int      txtLength [MLC];
  char *   Titles    [MLC];
  char *   MesgArea  [MLC];
  int      Width     [MLC];

  int    (* txtForm[MLC])     (char, int);
  char * (* ClValues [MLC])   (Dchain_t);
  int    (* ClSaveOthers[MLC])(Dchain_t, char *); /*speichere weit. Felder*/
  int    (* ClDisp)           (Dchain_t, void*);   /* client display */
  int    (* ClDestroy)        (void*);             /* Client delete **/
  void * (* ClMake)           (char *);
  int    (* ClSave)           (Dchain_t, void*);
  int    (* ClCallFirst)      (Dchain_t, void*);
  int    (* ClChange)         (Dchain_t, void*);
  int    (* ClCompare)        (void *, void *);             /* Client Compare */
  int    (* ClCopy)           (Dchain_t,  Dchain_t);        /* Kopierfunktion */
} mAppData_t, * MAppData_t;

typedef struct
{
  mAppData_t aplData;		/* User-definierte Daten */

  /****** Private Daten *******************************************************/
  Dchain_t  CurrentList;		  /* aktive Liste in der AppBox *******/
  Dchain_t  CopyList;			  /* Im Buffer kopierte Funktion ******/
  ListBox_t lbxApl [MLC];                 /* Die Listen der Eintraege *********/
  Widget lblTitle;
  Widget lblApl [MLC];                    /* Label Widget *********************/
  Widget fomApl;		          /* Das Oberwidget fuer die Liste ****/
  Widget RowCol;
  Widget btnAdd, btnMod, btnDel, btnUndo; /* Funktionswidgets *****************/
  Widget btnCopy, btnPaste;		  /* Cut and Paste Funktionen *********/
  int (* LastAction) (void *);	/* zuletzt aufgerufene Aktion *****************/
} mAppList_t, * MAppList_t;

/******** erstellet neuen Eintrag mit Listenanbindung *************************/
MAppList_t maplCreate (Widget parent, MAppData_t maplData);

/******** gibt den Pointer auf den aktuellen Listeneintrag ********************/
Dchain_t maplValue     (MAppList_t);
int      maplDisplay   (MAppList_t);

int      maplRedisp (MAppList_t);
int      maplDel    (MAppList_t);
int      maplAdd    (MAppList_t);
int      maplMod    (MAppList_t);
int      maplUndo   (MAppList_t);
void     maplDest   (MAppList_t);
int      maplCopy   (MAppList_t);
int      maplPaste  (MAppList_t);

void btnMAplAddCB (Widget btn, MAppList_t apl);
void btnMAplModCB (Widget btn, MAppList_t apl);
void btnMAplDelCB (Widget btn, MAppList_t apl);
void btnMAplUndoCB (Widget btn, MAppList_t apl);

#endif
