/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: window.h,v 1.2 1997/01/15 01:21:13 khamis Exp khamis $
 * $Source: /usr2/xkhfm/xkhlib/include/RCS/window.h,v $
 */
#ifndef WINDOW_H
#define WINDOW_H

#include "defines.h"
#include "xmisc.h"
#include "mainwin.h"

/* defines for Window Types **/
#define WIN_NORMAL	0x0001
#define WIN_ICONIZED	0x0002

enum
{
  WIN_TOP = 1,
  WIN_REGULAR,
  WIN_COMMAND,
  WIN_FIND,
  WIN_PROP,
  WIN_COPY,
  WIN_REMOVE,
  WIN_GREP,
  WIN_MKDIR,
  WIN_FTP,
  WIN_TCP
};

/* functions to manipulate menu entries for all windows */
typedef struct
{
  Dchain_t win;
  Widget mnuButton;
} winMenu_t, * WinMenu_t;
WinMenu_t winMnuMake (Dchain_t win);
int       winMnuDest (WinMenu_t lst);
int       winMnuComp (WinMenu_t lst, Dchain_t win);
#define   winMnuAdd(top, v) UdchAdd(top,v,\
				    (void*(*)(void*)) winMnuMake,\
				    (int(*)(void*,void*))winMnuComp)
#define	  winMnuFind(lst, win) UdchFind(lst, win, \
					(int(*)(void*,void*))winMnuComp)
#define   winMnuDel(lst)    UdchDelete(lst, (int(*)(void*))winMnuDest)
#define   winMnuEmpty(lst)  UdchEmpty(lst,(int(*)(void*))winMnuDest)
#define   winMnuRemove(lst) UdchEmptyAndDel(lst, (int(*)(void*))winMnuDest)

/* List for opened filemanager windows */
typedef struct
{
  char * Name;
  int x, y, width, height, treeWidth, filesWidth;
  union
  {
    Mainwin_t mainwin;	/* pointer to a filemanager window */
    Command_t cmd;	/* for command windows */
    Find_t    fnd;
    Prop_t prop;
    Copy_t cpy;
    Remove_t rem;
    Mkdir_t mkdir;
    void * obj;
  } wins;

  /* manipulate menu entries for all windows */
  Widget mnPulldown;
  Dchain_t mnList;

  unsigned short Type;	/* Window type */
  unsigned short State;
  unsigned short State1;
  
  void * (* ClMake) (void);
  int    (* ClDest) (void*);
  char * (* ClName) (void*);
  Widget (* ClShell)(void*);
} * WindowList_t, windowList_t;
WindowList_t winListMake      (char * Name);
int          winListDest      (WindowList_t lst);
int          winListComp      (WindowList_t lst, char * Name);
int          winListCmpWin    (WindowList_t lst, void*);
Dchain_t     winListFind      (Dchain_t winList, void *win);
int          winListDelete    (Dchain_t win);
Dchain_t     winListFindFirst (Dchain_t top, int type);
int          winCorrectCoords (void * obj);
int          winListCount     (Dchain_t top, int type);
#define winListRemove(lst) UdchEmptyAndDel(lst,(int(*)(void*))winListDest)
#define winListDel(lst)    UdchDelete(lst,(int(*)(void*))winListDest)
#define winObj(lst)        ((WindowList_t)UdchClient(lst))->wins.obj
#define winWin(lst)        ((WindowList_t)UdchClient(lst))

void winSetCoordCB (Widget shell, void * obj, XConfigureEvent * event);
void winSetStateCB (Widget shell, void * obj, XConfigureEvent * event);
int  winBuildWinMenu (Widget menu_pulldown, void* mwin);
int  xiconize        (Widget w);
void winIconizeCB    (Widget w, void* obj);
void winIconOtherCB  (Widget w, void* obj);
void winRestoreAllCB (Widget w, void* obj, XConfigureEvent * event);
void winIconAllCB    (Widget w, void* obj);
void winCloseOtherCB (Widget w, void* obj);
void winWindowsCB    (Widget w, void* obj);

Widget   winGetShellFromList(Dchain_t lst);
Dchain_t winGetListFromObj (void *obj);

Dchain_t winListAdd    (Dchain_t top, char * Name);
Dchain_t winListAddCmd (Dchain_t top, char * Name);
Dchain_t winListAddFind(Dchain_t top, char * Name);
Dchain_t winListAddProp(Dchain_t top, char * Name);
Dchain_t winListAddCopy(Dchain_t top, char * Name);
Dchain_t winListAddRemove(Dchain_t top, char * Name);
Dchain_t winListAddMkDir (Dchain_t top, char * Name);
int winDelWinMenu (Dchain_t del_win);

void mwinQuitCB   (Widget w, Mainwin_t mwin);

static menuitem_t itemWinMenu [] =
{
  { (void(*)(Widget,void*)) winIconizeCB,    "Iconize", True, NULL},
  { (void(*)(Widget,void*)) winIconOtherCB,  "Iconize other", True, NULL},
#if 1
  { (void(*)(Widget,void*)) winIconAllCB,  "Iconize all to one icon",
    True, NULL},
#endif
#ifndef WINMENU_NO_CLOSE
  { (void(*)(Widget,void*)) mwinQuitCB,      "Close", True, NULL},
  { (void(*)(Widget,void*)) winCloseOtherCB, "Close other", True, NULL},
#endif
#ifdef VIEW_WINDOW_LIST
  { NULL, MENU_SEPARATOR, False, NULL},
  { (void(*)(Widget,void*)) winBuildWinMenu, MENU_SPECIAL, False, NULL},
#endif
  { NULL, NULL}
};

#endif
