/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: xmisc.h,v 1.2 1996/10/28 03:38:13 khamis Exp khamis $
 * $Source: /home/xkhfm/xkhlib/include/RCS/xmisc.h,v $
 */

#include <sys/param.h>

#ifndef XMISC_H
#define XMISC_H

#include "Xinc.h"
#include "defines.h"
#include "Ucnfutil.h"
#include "dir.h"
#include "copy.h"

/* defines for mwinSetPixmapToWidget **/
#define MWIN_LOADANDSET 0x0001
#define MWIN_DISABLED	0x0002

#define MNU_STRLEN	35

/* defines for pointer cursor */
enum
{
  CURSOR_NORMAL,
  CURSOR_BAISY,
  CURSOR_COPY,
  CURSOR_MOVE,
  CURSOR_PROP,
  CURSOR_LINK,
  CURSOR_CAN_COPY,
  CURSOR_RONG,
  CURSOR_DELETE,
  CURSOR_EDIT
};

#define BaisyCursor(w)	SetCursor (w, CURSOR_BAISY);
#define NormalCursor(w)	SetCursor (w, CURSOR_NORMAL);

/*
 * Helpprocedures 
 */
Dimension wdgWidth  (Widget w);
Dimension wdgHeight (Widget w);
Dimension wdgX      (Widget w);
Dimension wdgY      (Widget w);

int SetCursor	    (Widget w, int mode);
Pixmap LoadPixmap (Widget parent, char * iconpath, Colormap *clrmap);

/*******************************************************************/
/** Scrollmanaging *************************************************/
/*******************************************************************/
#define SCR_UP		0x00000001
#define SCR_DOWN	0x00000002
#define SCR_SET		0x00000004
#define SCR_REDRAW	0x00000008
int scrSetValues (Widget w, long * XorY, long size, long wSize, int stip);
int scrSetValue (Widget w, long * XorY, long size,
		 long wSize,
		 int stip,
		 int newValue);
int scrAddValue (Widget w, int newvalue, unsigned long mode);

int CloseClipboard       (unsigned long item_id);
int OpenClipboard        (void);
int GetDataFromClipboard (char ** buf);
int AddToClipboard       (unsigned long item_id, char * buf, int len);

/** copy/move utility ****************************************/
typedef struct
{
  Widget Parent;
  Widget dlgCpy;
  Widget winCpy;
  Widget fomMain;

  Text_t txtSource, txtDst, txtFilter, txtDonotCopy, txtCopy;

  RadioBox_t radCopyFlaggs;
  
  Widget lblSrcState, lblDstState, drwState;

  Widget btnStart, btnClose;

  char * Source;
  char Dest   [MAXPATHLEN];

  int Stop;
  int Started;

  copyInfo_t info;
} copy_t, * Copy_t;
Copy_t cpyMake (void);
int    cpyView (Widget parent, Copy_t);
int    cpyHide (Copy_t);
int    cpyDest (Copy_t);
char * cpyName (Copy_t cpy);
Widget cpyShell(Copy_t cpy);

/** remove utilility *******************************/
typedef struct
{
  /* Interface part */
  Widget Parent;
  Widget dlgRem;
  Widget winRem;
  Widget fomMain;

  Text_t txtFiles, txtDonotRemove, txtRemove;  
  Widget togRecursive, togAsk;

  RadioBox_t radRemFlaggs;
  Widget lblState;

  Widget btnOk, btnClose;

  int Stop;
  int Started;

  /* Datatype */
  char * Files;		/* Filelist to remove */
} remove_t, * Remove_t;
Remove_t remMake (void);
int      remView (Widget parent, Remove_t rem);
int      remHide (Remove_t rem);
int      remDest (Remove_t rem);
char *   remName (Remove_t rem);
Widget   remShell(Remove_t rem);

/*** Mkdir Util ***********/
typedef struct
{
  Widget Parent;
  Widget dlgMd;
  char * DirName;
} mkdir_t, *Mkdir_t;

Mkdir_t mkdirMake (void);
int	mkdirView (Widget parent, Mkdir_t md);
int	mkdirHide (Mkdir_t md);
int	mkdirDest (Mkdir_t md);
char *  mkdirName (Mkdir_t md);
Widget  mkdirShell(Mkdir_t md);

/** Properities utility ****************************************/
#define PROP_ENCLOSE_RIGHTS	(DIR_CLIENT << 1)
#define PROP_ENCLOSE_OWN	(DIR_CLIENT << 2)
#define PROP_ENCLOSE_GRP	(DIR_CLIENT << 3)
typedef struct
{
  Widget Parent;
  Widget dlgProp;
  Widget winProp;
  Widget fomMain;

  Text_t txtFiles;
  char * Files;

  ComboBox_t comOwner, comGroup;
  char * Owner, * Group;
  int OwnId, GrpId;

  Widget lblOwner, lblGroup, lblOther;
  RadioBox_t radRights;
  short Rights, Skip;

  Text_t txtFilter, txtIgnore, txtEnclose;

  Widget lblInfo, btnRevert;
  long DirsCnt, FilesCnt, LinksCnt, Size;
  short StopRevert, LockedRevert;

  RadioBox_t radPropFlaggs;
  
  Widget lblState;

  Widget btnStart, btnClose;

  int Stop, Locked;
  dirInfo_t info;
} prop_t, * Prop_t;
Prop_t propMake (void);
int    propView (Widget parent, Prop_t);
int    propHide (Prop_t);
int    propDest (Prop_t);
char * propName (Prop_t prop);
Widget propShell(Prop_t prop);

/***************************************************************************/
/** Command Execution Types and Procedures *********************************/
/***************************************************************************/
#define CMD_BACKGROUND		0x0001
#define CMD_XTERM		0x0002
#define CMD_EDIT		0x0004
#define CMD_ASSOCIATED		0x0008

/* defines for executing a command */
#define EXEC_BACKGROUND	CMD_BACKGROUND
#define EXEC_IN_XTERM	CMD_XTERM
#define EXEC_EDIT	CMD_EDIT
#define EXEC_ASSOCIATED	CMD_ASSOCIATED

typedef struct
{
  Widget Parent;
  Widget dlgCmd;
  Widget winCmd;
  Widget fomMain;

  Widget cmdComm;
  Widget btnOk, btnClose;
  RadioBox_t radCmdFlaggs;

  char * Cmd;
  char * Pwd;	    /* Change to this bevor execution */
  Dchain_t cmdList; /* History commands */
  short Locked;
  unsigned long Flaggs;
} command_t, * Command_t;
char * cmdListMake (char * Name);
int    cmdListDest (char * cmd);
int    cmdListComp (char * cmd, char * Name);
Dchain_t cmdAdd   (Dchain_t top, char * Name);
#define cmdListRemove(lst) UdchEmptyAndDel(lst, (int(*)(void*))cmdListDest)

int       cmdExecCmd (char * pwd, char * Cmd, int mode);
Command_t cmdMake (void);
int       cmdView (Widget parent, Command_t);
int       cmdHide (Command_t);
int       cmdDest (Command_t);
int       cmdViewCurrentPath (Command_t cmd);
char *    cmdName (Command_t cmd);
Widget    cmdShell(Command_t cmd);


/*******************************************************************/
/** search utilility ***********************************************/
/*******************************************************************/
typedef struct
{
  /* Interface part */
  Widget Parent;
  Widget dlgFnd;
  Widget winFnd;
  Widget fomMain;

  Text_t txtFiles;
  Text_t txtFilter, txtIgnore, txtEnclose;

  RadioBox_t radFndFlaggs;
  Widget lblState;

  Widget lstFound;

  Widget btnOk, btnClose;

  int Stop;
  int Started;

  char * Files;		/* Filelist to find */
  char * Ignore, * Enclose, * Filter;

  void * ClData;
  void (*ClProc) (void*,char*);
} find_t, * Find_t;
Find_t   fndMake (void);
int      fndView (Widget parent, Find_t fnd);
int      fndHide (Find_t fnd);
int      fndDest (Find_t fnd);
Widget   fndShell(Find_t fnd);
char *   fndName (Find_t fnd);

/* association manipulation */
typedef struct
{
  char * Pattern;
  char * Exec;
  unsigned long Mode;
  char * Descr;
} assocList_t, * AssocList_t;

typedef struct
{
  Widget shlAss, winAss, btnOk;
  Widget fomMain;
  MAppList_t aplThema;
  Dchain_t assList;
} associate_t, * Associate_t;

Associate_t assMake (Dchain_t *top);
Dchain_t assListAdd (Dchain_t top, char * pattern);
char * assListPattern (Dchain_t lst);
char * assListExec (Dchain_t lst);
char * assListMode (Dchain_t lst);
char * assListDescr (Dchain_t lst);
int    assListDest (AssocList_t lst);
#define assListRemove(lst) UdchEmptyAndDel(lst, (int(*)(void*))assListDest)

int assDest (Associate_t ass);
int assHide (Associate_t ass);
int assSave (Dchain_t top, Conf_t cnf);
int assRead (Dchain_t top, Conf_t cnf);
int assView (Associate_t *assWin, Dchain_t *top);

/* Toolbar manipulation */
#define TBAR_VIEW_VERT	0x0001
#define TBAR_VIEW_HORIZ	0x0002
typedef struct
{
  char * Exec;
  char * Label;
  unsigned long Mode;
  char * Descr;
  char * Icon;
  Pixmap pxmIcon;
  Widget btnIcon;
} tbarList_t, * TbarList_t;

typedef struct
{
  Widget shlTbar, winTbar, btnOk, btnCancel;
  Text_t txtPath;
  RadioBox_t radTbarFlaggs;
  Widget fomMain;
  Widget btnIcon;
  MAppList_t aplThema;
  Dchain_t tbarList;
} toolbar_t, * Toolbar_t;

Toolbar_t tbarMake       (void);
Dchain_t  tbarListAdd    (Dchain_t top, char * pattern);
char *    tbarListPattern(Dchain_t lst);
char *    tbarListExec   (Dchain_t lst);
char *    tbarListMode   (Dchain_t lst);
char *    tbarListDescr  (Dchain_t lst);
int       tbarListDest   (TbarList_t lst);
#define   tbarListRemove (lst) UdchEmptyAndDel(lst,(int(*)(void*))tbarListDest)

int tbarDest (Toolbar_t tbar);
int tbarHide (Toolbar_t tbar);
int tbarSave (Dchain_t top, Conf_t cnf);
int tbarRead (Dchain_t top, Conf_t cnf);
int tbarView (Toolbar_t tbar);
#endif
