/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: button.c,v 1.1 1996/12/07 23:27:51 khamis Exp khamis $
 * $Source: /usr2/xkhfm/xkhlib/xkhmisc/RCS/button.c,v $
 */
/*****************************************************************************/
/*                             btnRedraw                                     */
/*                                                                           */
/*  Zeichnet einen DrawButton nach Verlangen                                 */
/*                                                                           */
/*  Globalvariablen: keine                                                   */
/*                                                                           */
/*  Aufrufparameter:                                                         */
/*                                                                           */
/*  Returnwerte:     keine                                                   */
/*                                                                           */
/*****************************************************************************/

#define IS_EXTERN
#define EXTERN		extern

#include <stdio.h>
#include <stdlib.h>
#include "Xinc.h"
#include <Xm/DrawnB.h>
#include <Xm/RowColumn.h>
#include <Xm/Protocols.h>

#include "defines.h"
#include "Umem.h"
#include "Umenu.h"
#include "Uxutil.h"

void btnRedraw (Widget button,
		Pixmap pixmap,
		XmDrawnButtonCallbackStruct * cbs)
{
  int srcx, srcy, destx, desty, pix_w, pix_h;
  int drawsize, border;
  Dimension bdr_w, w_width, w_height;
  short hlthick, shthick;
  Window root;
  static GC gc = NULL;

  DEBUG1 ("btnRedraw: redraw Button");

  if (gc == NULL)
    {
      int fg, bg;
      gc = XCreateGC (XtDisplay(button),
		      RootWindowOfScreen (XtScreen(button)),
		      0, 0);
      XtVaGetValues (XtParent(button),
		     XmNforeground, &fg,
		     XmNbackground, &bg,
		     NULL );
      XSetForeground (XtDisplay (button), gc, fg);
      XSetBackground (XtDisplay (button), gc, bg);
    }

  DEBUG1 ("btnRedraw: XGetGeometry");

#if 1
  XGetGeometry (XtDisplay (button), pixmap, &root,
		&srcx, &srcx, &pix_w, &pix_h, &srcx, &srcx);
#else
      pix_w = 40;
      pix_h = 20;
#endif

  DEBUG1 ("btnRedraw: XtGetValues");

  XtVaGetValues (button,
		 XmNwidth,		&w_width,
		 XmNheight,		&w_height,
		 XmNborderWidth,	&bdr_w,
		 XmNhighlightThickness, &hlthick,
		 XmNshadowThickness,	&shthick,
		 NULL);

  DEBUG1 ("btnRedraw: Calculation");

  border = bdr_w + hlthick + shthick;

  drawsize = w_width - 2 * border;

  if (drawsize > pix_w)
    {
      srcx  = 0;
      destx = (drawsize - pix_w) / 2 + border;
    }
  else
    {
      srcx  = (pix_w - drawsize) / 2;
      pix_w = drawsize;
      destx = border;
    }

  drawsize = w_height - 2 * border;

  if (drawsize > pix_h)
    {
      srcy  = 0;
      desty = (drawsize - pix_h) / 2 + border;
    }
  else
    {
      srcy = (pix_h - drawsize) / 2;
      pix_h = drawsize;
      desty = border;
    }

  DEBUG1 ("btnRedraw: XCopyArea");

  XCopyArea (XtDisplay (button), pixmap, cbs->window, gc,
	     srcx, srcy, pix_w, pix_h, destx, desty);

  DEBUG1 ("btnRedraw: Ende");
}

