/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: combo.c,v 1.1 1996/11/08 04:51:24 khamis Exp khamis $
 * $Source: /home/xkhfm/xkhlib/xkhmisc/RCS/combo.c,v $
 */
#define IS_EXTERN
#define EXTERN		extern

#include <stdio.h>
#include <stdlib.h>
#include "Xinc.h"

#include "defines.h"
#include "about.h"
#include "quit.h"
#include "Umenu.h"
#include "Uxutil.h"

int comAddItem (ComboBox_t combo, char * item, int mode)
{
  /****** Programm falsch aufgerufen ******************************************/
  if (item == NULL)
    return False;

  /****** Falls die Liste noch nicht existiert ********************************/
  if (combo->lstCombo == NULL)
    {
      /****** Erstellen *******************************************************/
      comCrList (combo);

      /****** Sofort wieder verstecken ****************************************/
      XtUnmapWidget   (XtParent (combo->lstCombo));
      combo->Hidden = True;
    }

  /****** In die List eintragen ***********************************************/
  if (combo->lstCombo != NULL)
     listAddItem (combo->lstCombo, item, mode);

  return True;
}

int comChng (ComboBox_t combo, char * item, char * newItem)
{
  XmString Item, NewItem;
  int pos, ret;

  DEBUG3 ("ComboChangeItem: item (%s), newItem (%s)\n", item, newItem);

  if (strcmp (item, newItem) == 0) return True;

  Item    = XmStringCreateSimple (item);
  NewItem = XmStringCreateSimple (newItem);

  pos = XmListItemPos (combo->lstCombo, Item);	/* Item position ermitteln ****/

  /****** kein Fehler *********************************************************/
  if (pos > 0)
    {
      XmListDeleteItem (combo->lstCombo, Item); /* Alten Eintrag loeschen *****/

      comAddItem (combo, newItem, LIST_SORTED);  /* Wert ersetzen ***********/

      ret = True;
    }
  else ret = False;				/* Fehler *********************/

  XtFree ((XtPointer) Item);
  XtFree ((XtPointer) NewItem);

  return ret;
}

#ifndef XmFONTLIST_DEFAULT_TAG
#define XmFONTLIST_DEFAULT_TAG XmSTRING_DEFAULT_CHARSET
#endif
void lstComboCB (Widget lst, ComboBox_t combo, XmListCallbackStruct * cbs)
{
  char * choise;

  DEBUG1 ("lstComboCB:");

  XmStringGetLtoR (cbs->item, XmFONTLIST_DEFAULT_TAG, &choise);
  XmTextSetString (combo->txtCombo, choise);
  XtFree          (choise);

  /****** UserProgramm aufrufen, falls vorhanden ******************************/
  if (combo->mnuCombo != NULL && combo->mnuCombo[0].prog != NULL)
    combo->mnuCombo[0].prog (combo->txtCombo, combo->cl_data);

  /****** Input Focus auf den Text einrichten *********************************/
  XmProcessTraversal (combo->txtCombo, XmTRAVERSE_CURRENT);

  /****** Nach der Selektion verschwindet die Auswahlliste ********************/
  DEBUG1 ("lstComboCB: Unmanage Combo List");
  XtUnmapWidget   (XtParent (lst));
  combo->Hidden = True;
}

/******************************************************************************/
/*                          btnComboCB					      */
/*									      */
/* Beschreibung:							      */
/*		 Die Fkt wird aufgerufen, wenn der Button der ComboBox 	      */
/*               betaetigt wird                                               */
/*									      */
/* Aufrufparameter:  OSF/Motif Standard					      */
/*                   ComboBox_t als ClientData                                */
/*									      */
/* Returnwerte:	     keine						      */
/*									      */
/******************************************************************************/
void btnComboCB (Widget btn, ComboBox_t combo)
{
  if (combo->Hidden == False)
    {
      /****** Input Focus auf den Button einrichten ***************************/
      XmProcessTraversal (combo->btnCombo, XmTRAVERSE_CURRENT);

      XtUnmapWidget   (XtParent (combo->lstCombo));
      combo->Hidden = True;
      return;
    }

  /****** Falls Liste noch nicht erstellt wurde, dann erst erstellen **********/
  if (combo->lstCombo == NULL)
    {
      comCrList (combo);
    }

  /****** Zeige die Liste auf dem Bildschirm **********************************/
  XtMapWidget (XtParent (combo->lstCombo));

  comViewList (combo);
}

ComboBox_t comCreate (Widget parent,
		      char * name,
		      Menu_t mnuList,
		      char * MesgArea,
		      void * cl_data,
		      int mode)
{
  ComboBox_t Combo = gcalloc (sizeof(comboBox_t), __LINE__, __FILE__);

  DEBUG1 ("CreateComboBox");

  /****** Default 10 Zeilen ***************************************************/
  Combo->NumLines = 10;
  Combo->lstCombo = NULL;
  Combo->mnuCombo = mnuList;
  Combo->MesgArea = StrReplace (Combo->MesgArea, MesgArea != NULL ? MesgArea : "");
  Combo->cl_data  = cl_data;
  Combo->Hidden   = True;

  Combo->fomCombo = XtVaCreateManagedWidget (name,
					     xmFormWidgetClass,
					     parent,
					     NULL);

  DEBUG1 ("CreateComboBox: ComboBtn");

  /****** ComboBox fuer die Meldungsnummern zeichnen **************************/
  Combo->lblCombo =
    XtVaCreateManagedWidget (name,
			     xmLabelGadgetClass, Combo->fomCombo,
			     XmNalignment, XmALIGNMENT_BEGINNING,
			     
			     XmNtopAttachment,    XmATTACH_FORM,
			     XmNleftAttachment,   XmATTACH_FORM,
			     NULL);
  if (mode & COM_SIDELABEL)
    XtVaSetValues (Combo->lblCombo,
		   XmNbottomAttachment, XmATTACH_FORM,
		   NULL);
  else
    XtVaSetValues (Combo->lblCombo,
		   XmNrightAttachment,  XmATTACH_FORM,
		   NULL);
  XtManageChild (Combo->lblCombo);      

  Combo->btnCombo =
    XtVaCreateManagedWidget (name,
			     xmArrowButtonGadgetClass,
			     Combo->fomCombo,
			     XmNarrowDirection,   XmARROW_DOWN,

			     XmNrightAttachment,  XmATTACH_FORM,
			     XmNbottomAttachment, XmATTACH_FORM,
			     NULL);
  if (mode & COM_SIDELABEL)
    XtVaSetValues (Combo->btnCombo,
		   XmNtopAttachment,    XmATTACH_FORM,
		   NULL);
  else
    XtVaSetValues (Combo->btnCombo,
		   XmNtopAttachment,    XmATTACH_WIDGET,
		   XmNtopWidget,        Combo->lblCombo,
		   NULL);
  XtAddCallback (Combo->btnCombo, XmNactivateCallback, 
		 (XtCallbackProc) btnComboCB,
		 Combo);
  XtManageChild (Combo->btnCombo);
  
  DEBUG1 ("CreateComboBox: Combotxt");

  Combo->txtCombo = XmCreateText (Combo->fomCombo, name, NULL, 0);
  XtVaSetValues (Combo->txtCombo,
		 XmNrightAttachment,  XmATTACH_WIDGET,
		 XmNrightWidget,      Combo->btnCombo,
		 XmNbottomAttachment, XmATTACH_FORM,
		 NULL);
  if (mode & COM_SIDELABEL)
    XtVaSetValues (Combo->txtCombo,
		   XmNtopAttachment,   XmATTACH_FORM,
		   XmNleftAttachment,  XmATTACH_WIDGET,
		   XmNleftWidget,      Combo->lblCombo,
		   NULL);
  else
    XtVaSetValues (Combo->txtCombo,
		   XmNtopAttachment,   XmATTACH_WIDGET,
		   XmNtopWidget,       Combo->lblCombo,
		   XmNleftAttachment,  XmATTACH_FORM,
		   NULL);
  txtMesgArea   (Combo->txtCombo, Combo->MesgArea);
  XtManageChild (Combo->txtCombo);

  DEBUG1 ("CreateComboBox: return Combo");

  return Combo;

}

int comCrList (ComboBox_t combo)
{
  XtWidgetGeometry size;
  Arg args [10];
  int n, i;

#if 0
  DEBUG1 ("comCrList:");
#endif

  n = 0;
  XtSetArg (args[n], XmNvisibleItemCount, combo->NumLines); n++;

  XtSetArg (args[n], XmNtopAttachment,   XmATTACH_WIDGET); n++;
  XtSetArg (args[n], XmNtopWidget,       combo->fomCombo); n++;

  XtSetArg (args[n], XmNleftAttachment,  XmATTACH_OPPOSITE_WIDGET); n++;
  XtSetArg (args[n], XmNleftWidget,      combo->fomCombo); n++;

  XtSetArg (args[n], XmNrightAttachment, XmATTACH_OPPOSITE_WIDGET); n++;
  XtSetArg (args[n], XmNrightWidget,     combo->fomCombo); n++;

  combo->lstCombo
    = XmCreateScrolledList (XtParent (combo->fomCombo),
			    combo->mnuCombo != NULL
			    ? combo->mnuCombo[0].menu_bar
			    : "Liste",
			    args, n);
  listMesgArea (combo->lstCombo, combo->MesgArea);
  /****** Werte sortiert in die Liste eintragen *******************************/
#if 0
  listAddTo (combo->lstCombo, combo->mnuCombo);
#else
  if (combo->mnuCombo != NULL && combo->mnuCombo->menu_item != NULL)
    for (i=0; combo->mnuCombo[0].menu_item[i].label != NULL; i++)
      {
	comAddItem (combo,
		    combo->mnuCombo[0].menu_item[i].label,
		    LIST_SORTED);
      }
#endif
  
  XtAddCallback (combo->lstCombo, 
		 XmNbrowseSelectionCallback /*XmNdefaultActionCallback*/,
		 (XtCallbackProc) lstComboCB,
		 combo);
  XtManageChild (combo->lstCombo);

#if 0
  DEBUG1 ("comCrList: Liste ist erstellt (ende)");
#endif

  return True;
}

int comDelItem (ComboBox_t combo, char * item)
{
  XmString Item;

  /****** Falsch uebergeben ***************************************************/
  if (item == NULL)
    return False;

  /****** Liste ist noch nicht erzeugt ****************************************/
  if (combo->lstCombo == NULL)
    return False;

  /****** Erweiterten String erzeuegen ****************************************/
  Item = XmStringCreateSimple (item);

  /****** Element aus der Liste entfernen *************************************/
  XmListDeleteItem (combo->lstCombo, Item);

  XmStringFree (Item);

  return True;
}

int comDelPos (ComboBox_t combo, int pos, int count)
{
  return listDelPos (combo->lstCombo, pos, count);
}

void comDest (ComboBox_t com)
{
  DEBUG1 ("comDest:");

  if (com == NULL)
    return;

  StrReplace (com->MesgArea, NULL);
  MFree (com, sizeof (comboBox_t));

  DEBUG1 ("comDest: Ende");
}

void comDisable (ComboBox_t combo)
{
  XtSetSensitive (combo->btnCombo, False);
  XtSetSensitive (combo->txtCombo, False);
}

int comDisp (ComboBox_t combo, char * item)
{
  if (item == NULL)
    return False;

  XmTextSetString (combo->txtCombo, item);
  return True;
}

void comEnable (ComboBox_t combo)
{
  XtSetSensitive (combo->btnCombo, True);
  XtSetSensitive (combo->txtCombo, True);
}

int comSelItem (ComboBox_t combo, char *item)
{
  XmString tmp;

  /****** Den Wert in die Eingabebox zeigen ***********************************/
  XmTextSetString (combo->txtCombo, item);

  tmp = XmStringCreateSimple (item);

  /****** Den Listeneintrag aktualisieren *************************************/
  XmListSelectItem (combo->lstCombo, tmp, True);

  XmStringFree (tmp);
  return True;
}

int comSelPos (ComboBox_t combo, int pos)
{
  char * item;
  if (pos < 0)
    return False;

  XmListSelectPos (combo->lstCombo, pos, True);  
  XmListSetPos    (combo->lstCombo, max (0, pos - 1));
#if 0
  XmTextSetString (combo->txtCombo, tmp);
#endif

  return True;
}

int comViewList (ComboBox_t combo)
{
  char * tmpString;

#if 0
  XtWidgetGeometry size;
  Arg args [10];  
  size.request_mode = CWWidth;
  XtQueryGeometry (combo->fomCombo, NULL, &size);

  XtManageChild (XtParent (combo->lstCombo));  
  XtVaSetValues (XtParent (combo->lstCombo),
		 XmNwidth, size.width,
		 NULL);  
  XtManageChild (XtParent (combo->lstCombo));
#endif

  XtMapWidget   (XtParent (combo->lstCombo));  
  /****** Input Focus auf die Liste einrichten ********************************/
  XmProcessTraversal (XtParent (combo->lstCombo), XmTRAVERSE_CURRENT);

#if 0
  /****** Den Listen-Eintrag, der in der Eingabe steht, selektieren ***********/
  tmpString = XmTextGetString (combo->txtCombo);
  listSelItem (combo->lstCombo, tmpString);
  XtFree (tmpString);
#endif

  combo->Hidden = False;

  return True;
}
