/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: fileop.c,v 1.1 1997/01/05 18:30:10 khamis Exp khamis $
 * $Source: /usr2/xkhfm/xkhlib/xkhmisc/RCS/fileop.c,v $
 */

#define IS_EXTERN
#define EXTERN		extern

#include <stdio.h>
#include <stdlib.h>
#include "Xinc.h"

#include "defines.h"
#include "about.h"
#include "quit.h"
#include "Umenu.h"
#include "Uxutil.h"

short FileClass = False;

/********* DialogBox destroyen ************************************************/
void CloseFileSelection (Widget w, void * cl_data)
{
  XtDestroyWidget (w);
}

void FileOperation (Widget parent,
		    void (* OkProg)     (Widget, void *),
		    void (* CancelProg) (Widget, void *),
		    void * cl_data,
		    char * filter,
		    int action,
		    int mode)
{
  Widget dialog;
  Widget win, shl;
  Arg args [5];
  char * title;
  int n;

  DEBUG1 ("fileOperatn: OpenFile");
  

  /****** Kopf festlegen und die Operation festlegen **************************/
  if (action & FILE_OPEN)
    {
      FileClass = FILE_OPEN;
      title = "Datei Oeffnen";
    }
  else if (action & FILE_SAVE)
    {
      FileClass = FILE_SAVE;
      title = "Datei Speichern";
    }
  else if (action & FILE_SAVEAS)
    {
      FileClass = FILE_SAVEAS;
      title = "Datei Speichern als";
    }
  else if (action & FILE_NEW)
    {
      FileClass = FILE_NEW;
      title = "Neue Datei";
    }
  else if (action & DIR_OPEN)
    {
      FileClass = DIR_OPEN;
      title = "Verzeichnis Oeffnen";
    }
  else if (action & DIR_SAVE)
    {
      FileClass = DIR_SAVE;
      title = "Verzeichnis Speichern";
    }
  else if (action & DIR_SAVEAS)
    {
      FileClass = DIR_SAVEAS;
      title = "Verzeichnis Speichern als";
    }
  else if (action & DIR_NEW)
    {
      FileClass = DIR_NEW;
      title = "Neues Verzeichnis";
    }
  else
    {
      FileClass = False;
      return;
    }

  n = 0;
  XtSetArg (args [n], XmNdialogStyle,   XmDIALOG_APPLICATION_MODAL); n++;
  XtSetArg (args [n], XmNfileTypeMask,  XmFILE_REGULAR); n++;
  dialog = XmCreateFileSelectionDialog (parent, 
					title,
					args,
					n);
  if (dialog == NULL)
    return;

  /****** Filter zuweisen *****************************************************/
  if (filter != NULL)
    {
      Widget txtFilter;

      DEBUG1 ("fileOperatn: Filter zuweisen");
  
      txtFilter = XmFileSelectionBoxGetChild (dialog, XmDIALOG_FILTER_TEXT);
      XmTextSetString (txtFilter, filter);
#if 0
      XtSetSensitive (txtFilter, False);
#endif
      XmFileSelectionDoSearch (dialog, NULL); /* refresh **********************/
    }

  DEBUG1 ("fileOperatn: Ok Callback");
  /****** Ok und Cancel Callbacks festlegen ***********************************/
  XtAddCallback (dialog, XmNokCallback,
		 (XtCallbackProc)
		 (OkProg == NULL ? CloseFileSelection : OkProg),
		 cl_data);

  DEBUG1 ("fileOperatn: Cancel Callback");
  XtAddCallback (dialog, XmNcancelCallback,
		 (XtCallbackProc)
		 (CancelProg == NULL ? CloseFileSelection : CancelProg),
		 cl_data);

  /********* Im Falle von Verzeichnis Auswahl, gibt es keine Files-Liste ******/
  if (action & 0x00F0)
    {
      Widget txtFiles, lblFiles;

      DEBUG1 ("fileOperatn: Widgets ermitteln");

      /****** Liste und Label der Liste ermitteln *****************************/
      txtFiles = XmFileSelectionBoxGetChild (dialog, XmDIALOG_LIST);
      lblFiles = XmFileSelectionBoxGetChild (dialog, XmDIALOG_LIST_LABEL);

      DEBUG1 ("fileOperatn: Widgets nicht besuchbar machen");

      /****** Die Liste und den Label disablen ********************************/
      XtSetSensitive (txtFiles, False);
      XtSetSensitive (lblFiles, False);
    }


  DEBUG1 ("fileOperatn: manage dialog");

  /****** Diaglo zeigen *******************************************************/
  XtManageChild (dialog);

  DEBUG1 ("fileOperatn: Ende OpenFile");
}

