/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: help.c,v 1.1 1997/01/07 08:38:27 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/xkhlib/xkhmisc/RCS/help.c,v $
 */
#define IS_EXTERN
#define EXTERN		extern

#include <stdio.h>
#include <stdlib.h>
#include "Xinc.h"

#include "defines.h"
#include "Uxutil.h"
#include "Umenu.h"
#include "Ustrutil.h"
#include "Ucnfutil.h"
#include "help.h"

int hlpCheckin (Dchain_t hlpDch, Help_t hlp)
{
  HelpList_t hlpList;
  char * tmp;

  if (hlpDch == NULL || hlp == NULL)
    return False;

  hlpList = UdchClient (hlpDch);

  tmp = XmTextGetString (hlp->txtHelp);
  hlpList->hlpStr = StrReplace (hlpList->hlpStr, tmp);
  XtFree (tmp);

  hlp->WriteFlagg = True;

  return True;
}

int hlpDest (Help_t hlp)
{
  if (hlp == NULL)
    return False;

  hlpHide (hlp);

  if (HelpWindow->WriteFlagg)
    {
      hlpSave (hlp);
    }

  maplDest   (hlp->aplThema);

  hlpListRemove (hlp->helpList);

  StrReplace (hlp->helpFilename, NULL);

  MFree (hlp, sizeof (Help_t));

  if (hlp == HelpWindow)
    HelpWindow = NULL;

  return True;
}

int hlpDisp (Dchain_t hlpDch, Help_t hlp)
{
  HelpList_t hlpList = NULL;

  if (hlpDch == NULL || hlp == NULL)
    {
      return False;
    }

  hlpList = UdchClient (hlpDch);

  XmTextSetString (hlp->txtHelp,
		   (hlpList != NULL && hlpList->hlpStr != NULL)
		   ? hlpList->hlpStr
		   : "no help found");

  return True;
}

int hlpHide (Help_t hlp)
{
  if (hlp->shHlp != NULL)
    {
      XtDestroyWidget (hlp->shHlp);
      hlp->shHlp = NULL;
    }

  return True;
}

HelpList_t hlpListMake (char * Section)
{
  HelpList_t l = gcalloc (sizeof (helpList_t), __LINE__, __FILE__);

  l->hlpSection = StrReplace (l->hlpSection,
			      (Section != NULL) ? Section : "unknown");
  l->hlpThema   = StrReplace (l->hlpThema,    "title not availiable");
  l->hlpMesgArea= StrReplace (l->hlpMesgArea, "no status availiable");
  l->hlpStr     = StrReplace (l->hlpStr,      "no help availaible");

  return l;
}

int hlpListDest (HelpList_t lst)
{
  StrReplace (lst->hlpSection, NULL);
  StrReplace (lst->hlpThema,   NULL);
  StrReplace (lst->hlpMesgArea, NULL);
  StrReplace (lst->hlpStr,     NULL);
  MFree (lst, sizeof (helpList_t));

  return True;
}

int hlpListComp (HelpList_t liste, char * Section)
{
  int ret;

  if (liste == NULL)
    return 0;

  ret = strcmp (liste->hlpSection, Section);
  return ret;
}

Dchain_t hlpListAdd   (Dchain_t top, char * Section)
{

  if (UdchItemExists (top, Section, (int (*) (void*, void*)) hlpListComp))
    {
      ERROR2 ("hlpListAdd: Name [%s] already available\n",
	      Section);
      return NULL;
    }

  return UdchAdd (top, Section,
		     (void * (*) (void *)) hlpListMake,
		     (int    (*) (void *, void *)) hlpListComp);
}

int hlpListCpy (HelpList_t lst1, HelpList_t lst2)
{

  memcpy (lst2, lst1, sizeof (helpList_t));
  
  return True;
}

int hlpListData (Dchain_t lst, char * helpStr)
{
  HelpList_t hlpList;

  if (lst == NULL)
    return False;

  hlpList = (HelpList_t) UdchClient (lst);

  hlpList->hlpStr = StrReplace (hlpList->hlpStr, helpStr);

  return True;
}

char * hlpListThema (Dchain_t lst)
{
  return ((HelpList_t) UdchClient (lst))->hlpThema;
}

char * hlpListSection (Dchain_t lst)
{
  return ((HelpList_t) UdchClient (lst))->hlpSection;
}

char * hlpListMesgArea (Dchain_t lst)
{
  return ((HelpList_t) UdchClient (lst))->hlpMesgArea;
}

int hlpListSaveStr (Dchain_t lst, char * helpStr)
{
  HelpList_t hlpList;

  if (helpStr == NULL)
    return False;

  hlpList = (HelpList_t) UdchClient (lst);

  hlpList->hlpStr = StrReplace (hlpList->hlpStr, helpStr);
  return True;
}

int hlpListSaveSection (Dchain_t lst, char * helpSection)
{
  HelpList_t hlpList;

  if (helpSection == NULL || strlen (helpSection) == 0)
    return False;

  hlpList = (HelpList_t) UdchClient (lst);

  hlpList->hlpSection = StrReplace (hlpList->hlpSection, helpSection);

  return True;
}

int hlpListSaveThema (Dchain_t lst, char * Thema)
{
  HelpList_t hlpList;

  hlpList = (HelpList_t) UdchClient (lst);
  hlpList->hlpThema = StrReplace (hlpList->hlpThema,
				  Thema != NULL
				  ? Thema
				  : "");
  return True;
}

int hlpListSaveMesgArea (Dchain_t lst, char * MesgArea)
{
  HelpList_t hlpList;

  hlpList = (HelpList_t) UdchClient (lst);
  hlpList->hlpMesgArea = StrReplace (hlpList->hlpMesgArea,
				     MesgArea != NULL
				     ? MesgArea
				     : "");
  return True;
}

int hlpListChng (Dchain_t lst, char * newName)
{
  HelpList_t hlpList;

  if (newName == NULL || strlen (newName) == 0)
    return False;

  hlpList = ((HelpList_t) UdchClient (lst));
  hlpList->hlpSection = StrReplace (hlpList->hlpSection, newName);

  return True;
}

Help_t hlpMake (void)
{
  Help_t hlp;

  hlp =
    HelpWindow =
      gcalloc (sizeof (help_t), __LINE__, __FILE__);

  if (hlp == NULL)
    return NULL;

  hlp->helpFilename = StrReplace (hlp->helpFilename, HLP_FILENAME);
  hlp->helpList =
    HelpList =
      hlpListAdd (NULL, "TOP");
  hlpOpen (hlp);

  return hlp;
}

int hlpOpen (Help_t hlp)
{
  Dchain_t hlpDch = NULL;
  HelpList_t helpList = NULL;
  char tmp  [MAXPATHLEN];
  char orig [MAXPATHLEN];
  char * line;
  char arg0 [MAXLEN_CNFLINE];
  char arg1 [MAXLEN_CNFLINE];

  strcpy (orig, hlp->helpFilename);

  if (! UFileCanRead (hlp->helpFilename))
    {
      sprintf (tmp, "%s/%s", progDir, orig);
      hlp->helpFilename = StrReplace (hlp->helpFilename, tmp);
    }

  if (! UFileCanRead (hlp->helpFilename))
    {
      sprintf (tmp, "%s/%s", getenv ("HOME"), orig);
      hlp->helpFilename = StrReplace (hlp->helpFilename, tmp);
    }

  if (UFileCanRead (hlp->helpFilename))
    {
      Conf_t conf;
      conf = confOpen (hlp->helpFilename, HelpHeader);

      for (;True;)
	{
	  line  = confReLine (conf, False);
	  if (line == NULL)
	    break;

	  Ureadarg (line, arg0, 0, '=');
	  Ureadarg (line, arg1, 1, '=');
	  if (arg0 [0] == '[')
	    {
	      char * p = arg0 + 1;
	      p [strlen (p) - 1] = 0;

	      hlpDch = hlpListAdd (hlp->helpList, p);
	      if (hlpDch == NULL)
		helpList = NULL;
	      else
		helpList = UdchClient (hlpDch);
	    }

	  else if (strcmp (arg0, "Thema") == 0 && helpList != NULL)
	    {
	      helpList->hlpThema = StrReplace (helpList->hlpThema, arg1);
	    }
	  else if (strcmp (arg0, "Help") == 0 && helpList != NULL)
	    {
	      helpList->hlpStr = StrReplace (helpList->hlpStr, arg1);
	    }
	  else if (strcmp (arg0, "MesgArea") == 0 && helpList != NULL)
	    {
	      helpList->hlpMesgArea = StrReplace (helpList->hlpMesgArea, arg1);
	    }
	}
      confClose (conf);
    }

  return True;
}

int hlpSave (Help_t hlp)
{
  Dchain_t p;
  HelpList_t helpList;
  Conf_t cnf;
  int pos;

  if (hlp == NULL)
    return False;

  cnf = confOpen (hlp->helpFilename, HelpHeader);
  if (cnf == NULL)
    return False;

  pos = confSectPos (cnf, "");
  confDelToEnd (cnf, pos);

  for (p=UdchNext (hlp->helpList);
       p != NULL;
       p = UdchNext (p))
    {
      char* argv[2];
      helpList = UdchClient (p);
      argv[0] = "Thema";
      argv[1] = helpList->hlpThema;
      confWrite (cnf, '=', helpList->hlpSection, 2, argv);
      argv[0] = "Help",
      argv[1] = helpList->hlpStr;
      confWrite (cnf, '=', helpList->hlpSection, 2, argv);
      argv[0] = "MesgArea";
      argv[1] = helpList->hlpMesgArea;
      confWrite (cnf, '=', helpList->hlpSection, 2, argv);
    }

  hlp->WriteFlagg = False;

  confClose (cnf);

  return True;
}
#define MAX_SECTION_LEN	24

void hlpHelpCB (Widget, Help_t);
void hlpSaveCB (Widget, Help_t);
int  maplDisp (MAppList_t apl, char * Value);

menuitem_t hlpItemFile [] = 
{
  {
    (void (*) (Widget, void*)) hlpSaveCB,
    "Save Help File",
    True,
    NULL},
  { NULL, NULL}
};
menuitem_t hlpItemHelp [] = 
{
  {
    (void (*) (Widget, void*)) hlpHelpCB,
    "Help for Help",
    True,
    NULL},
  { NULL, NULL}
};
menu_t hlpMenu [] =
{
  { "File", hlpItemFile, True, NULL },
  { "Help", hlpItemHelp, True, NULL },
  { NULL, NULL, False }
};

void hlpHelpCB (Widget w, Help_t hlp)
{
  hlpView (HelpWindow, HLP_HELP);
}

void hlpSaveCB (Widget w, Help_t hlp)
{
  hlpSave (hlp);
}

void hlpHideCB (Widget w, Help_t hlp)
{
  hlpHide (hlp);
}

void btnHlpOkCB (Widget w, Help_t hlp)
{
  hlpHide (hlp);
}

int hlpView (Help_t hlp, char * Thema)
{
  mAppData_t hlpAppData;
  Widget paned;
  Arg args [10];
  int i, j, n, ret;

  if (hlp == NULL)
    {
      hlp = hlpMake ();
      if (hlp == NULL)
	return False;
    }

  if (hlp->shHlp != NULL)
    {
      XMapRaised (XtDisplay (hlp->shHlp), XtWindow  (hlp->shHlp));
      maplDisp (hlp->aplThema, Thema);
      return True;
    }

  ret = winCreate (TITLE_HELP,
		   &hlp->shHlp,
		   &hlp->winHlp,
		   &hlp->fomMain,
		   4,
		   hlp,
		   (void (*)(Widget, void*)) hlpHideCB,
		   False);

  if (ret == False)
    return False;

  mnuMake (hlp->winHlp, hlpMenu, hlp);
  
  hlp->btnOk =
    XtVaCreateManagedWidget ("Close",
			     xmPushButtonGadgetClass,
			     hlp->fomMain,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNrightAttachment,  XmATTACH_FORM,
			     XmNbottomAttachment, XmATTACH_FORM,
			     XmNtopOffset,      SPACE,
			     XmNleftOffset,     SPACE,
			     XmNrightOffset,    SPACE,
			     XmNbottomOffset,   SPACE,
			     NULL);
  XtAddCallback (hlp->btnOk, XmNactivateCallback, 
		 (XtCallbackProc) btnHlpOkCB,
		 hlp);
  XtManageChild (hlp->btnOk);
  
  paned = XmCreatePanedWindow  (hlp->fomMain, "PanedWindow", NULL, 0);
  XtVaSetValues (paned,
		 XmNtopAttachment,    XmATTACH_FORM,
		 XmNleftAttachment,   XmATTACH_FORM,
		 XmNrightAttachment,  XmATTACH_FORM,
		 XmNbottomAttachment, XmATTACH_WIDGET,
		 XmNbottomWidget,     hlp->btnOk,
#if 0
		 XmNtopOffset,        SPACE,
		 XmNleftOffset,       SPACE,
		 XmNrightOffset,      SPACE,
		 XmNbottomOffset,     SPACE,
#endif
		 NULL);

  memset (&hlpAppData, 0, sizeof (mAppData_t));
  hlpAppData.ListCount       = 3;
  hlpAppData.Titles      [0] = "Identity";
  hlpAppData.Titles      [1] = "Title";
  hlpAppData.Titles      [2] = "Status";

  hlpAppData.MesgArea    [0] = HLP_SECTION;
  hlpAppData.MesgArea    [1] = HLP_THEMA;
  hlpAppData.MesgArea    [2] = HLP_MESGAREA;

  hlpAppData.txtLength   [0] = MAX_INFO_LEN/3;
  hlpAppData.txtLength   [1] = MAX_INFO_LEN;
  hlpAppData.txtLength   [2] = MAX_INFO_LEN;

  hlpAppData.txtForm     [0] = IsInfoFrm;
  hlpAppData.txtForm     [1] = IsInfoFrm;
  hlpAppData.txtForm     [2] = IsInfoFrm;

  hlpAppData.ClValues    [0] = hlpListSection;
  hlpAppData.ClValues    [1] = hlpListThema;
  hlpAppData.ClValues    [2] = hlpListMesgArea;

  hlpAppData.ClSaveOthers[0] = NULL;		/* Immer nicht belegt */
  hlpAppData.ClSaveOthers[1] = hlpListSaveThema;
  hlpAppData.ClSaveOthers[2] = hlpListSaveMesgArea;
  hlpAppData.ClData          = hlp;
  hlpAppData.ClList          = hlp->helpList;
  hlpAppData.ClDisp          = (int (*) (Dchain_t, void*)) hlpDisp;
  hlpAppData.ClSave          = (int (*) (Dchain_t, void*)) hlpCheckin;
  hlpAppData.ClDestroy       = (int (*) (void*))           hlpListDest;
  hlpAppData.ClMake          = (void * (*) (char *))       hlpListMake;
  hlpAppData.ClChange        = (int (*) (Dchain_t, void*)) hlpListChng;
  hlpAppData.ClCompare       = (int (*) (void*, void*))    hlpListComp;
  hlp->aplThema = maplCreate (paned /*hlp->fomMain*/ , &hlpAppData);
  XtVaSetValues (hlp->aplThema->fomApl,
#if 0
		 XmNtopAttachment,    XmATTACH_FORM,
		 XmNleftAttachment,   XmATTACH_FORM,
		 XmNrightAttachment,  XmATTACH_FORM,
#endif
		 XmNtopOffset,        SPACE,
		 XmNleftOffset,       SPACE,
		 XmNrightOffset,      SPACE,
		 XmNbottomOffset,     SPACE,
		 NULL);
  XtManageChild (hlp->aplThema->fomApl);

  n = 0;
  XtSetArg (args [n], XmNeditMode, XmMULTI_LINE_EDIT); n++;
  XtSetArg (args [n], XmNrows, 10); n++;
  hlp->txtHelp = XmCreateScrolledText (paned /*hlp->fomMain*/ ,
				      "Helptext", args, n);
  XtVaSetValues (XtParent (hlp->txtHelp),
#if 0
		 XmNtopAttachment,    XmATTACH_WIDGET,
		 XmNtopWidget,        hlp->aplThema->fomApl,
		 XmNleftAttachment,   XmATTACH_FORM,
		 XmNrightAttachment,  XmATTACH_FORM,
		 XmNbottomAttachment, XmATTACH_WIDGET,
		 XmNbottomWidget,     hlp->btnOk,
#endif
		 XmNtopOffset,     SPACE,
		 XmNleftOffset,     SPACE,
		 XmNrightOffset,    SPACE,
		 XmNbottomOffset,   SPACE,
		 NULL);
  txtMesgArea   (hlp->txtHelp, HLP_txtHelp);
  XtManageChild (hlp->txtHelp);

  XtManageChild (paned);

#if 0
  hlpTitle (hlp);
#endif

  XtManageChild (hlp->fomMain);
  XtManageChild (hlp->winHlp);

  maplRedisp (hlp->aplThema);

  MXtRealizeWidget (hlp->shHlp);

  maplDisp (hlp->aplThema, Thema);

  return True;
}
