/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: listbox.c,v 1.1 1996/10/28 03:38:47 khamis Exp khamis $
 * $Source: /home/xkhfm/xkhlib/xkhmisc/RCS/listbox.c,v $
 */
#define IS_EXTERN
#define EXTERN		extern

#include <stdio.h>
#include <stdlib.h>
#include "Xinc.h"

#include "defines.h"
#include "about.h"
#include "quit.h"
#include "Umenu.h"
#include "Uxutil.h"

int lbxAddItem (ListBox_t lbx, char * item, int mode)
{
  int ret = False;

  /****** Programm falsch aufgerufen ******************************************/
  if (item == NULL || lbx == NULL)
    return False;

  /****** Falls die Liste noch nicht existiert ********************************/
  if (lbx->lstLBox == NULL)
    lbxCrList (lbx);

  /****** In die List eintragen ***********************************************/
  ret = listAddItem (lbx->lstLBox, item, mode);

#if 0
  DEBUG1 ("lbxAddItem: Item einfuegen ende");
#endif

  return ret;
}

void lstLBoxCB (Widget lst, ListBox_t lbx, XmListCallbackStruct * cbs)
{
  char * choise;

  XmStringGetLtoR (cbs->item, XmFONTLIST_DEFAULT_TAG, &choise);
  XmTextSetString (lbx->txtLBox, choise);
  XtFree          (choise);

  /****** UserProgramm aufrufen, falls vorhanden ******************************/
  if (lbx->lbxCB != NULL)
    lbx->lbxCB (lbx, lbx->cl_data);

  /****** Input Focus auf den Text einrichten ???? ****************************/
  /*
  XmProcessTraversal (lbx->txtLBox, XmTRAVERSE_CURRENT);
  */
}

ListBox_t lbxCreate (Widget parent, char * name,
		     void (* lbxCB) (ListBox_t, void *),
		     void * cl_data)
{
  ListBox_t lbx = gcalloc (sizeof(listBox_t), __LINE__, __FILE__);

#if 0
  DEBUG1 ("lbxCreate");
#endif

  /****** Default 10 Zeilen ***************************************************/
  lbx->NumLines = 10;
  lbx->lstLBox  = NULL;
  lbx->lbxCB    = (void (*) (void*, void*)) lbxCB;
  lbx->title    = StrReplace (lbx->title, name);
  lbx->cl_data  = cl_data;

  lbx->fomLBox  = XtVaCreateManagedWidget (name,
					   xmFormWidgetClass,
					   parent,
					   NULL);
#if 0
  XtAddCallback (lbx->fomLBox,
		 XmNdestroyCallback,
		 lbxDest,
		 lbx);
#endif

  /****** Texteingabefeld zeichnen ********************************************/
#if 0
  DEBUG1 ("lbxCreate: txtLBox zeichnen");
#endif

  lbx->txtLBox = XmCreateText (lbx->fomLBox, name, NULL, 0);
  XtVaSetValues (lbx->txtLBox,
		 XmNtopAttachment,    XmATTACH_FORM,
		 XmNleftAttachment,   XmATTACH_FORM,
		 XmNrightAttachment,  XmATTACH_FORM,
		 NULL);
  XtManageChild (lbx->txtLBox);

  /****** Liste zeichnen ******************************************************/
  lbxCrList (lbx);

#if 0
  DEBUG1 ("lbxCreate: return lbx");
#endif

  return lbx;

}

int lbxChngItem (ListBox_t lbx, char * item, char * newItem)
{
  XmString Item;
  int pos, ret;

  DEBUG3 ("lbxChngItem: item (%s), newItem (%s)\n", item, newItem);
  
  if (item == NULL || newItem == NULL)
    return False;

  if (strcmp (item, newItem) == 0)
    return True;

  Item    = XmStringCreateSimple (item);

  pos = XmListItemPos (lbx->lstLBox, Item);	/* Item position ermitteln ****/

  /****** kein Fehler *********************************************************/
  if (pos > 0)
    {
      XmListDeleteItem (lbx->lstLBox, Item);   /* Alten Eintrag loeschen ******/

      lbxAddItem (lbx, newItem, LIST_SORTED);  /* Wert ersetzen ***************/

      ret = True;
    }
  else ret = False;				/* Fehler *********************/

  XmStringFree (Item);

  return ret;
}

int lbxCrList (ListBox_t lbx)
{
  XtWidgetGeometry size;
  Arg args [10];
  int n, i;

  DEBUG1 ("lbxCrList:");

  n = 0;
#if 0
  XtSetArg (args[n], XmNlistSizePolicy, XmCONSTANT); n++;
#endif
  XtSetArg (args[n], XmNvisibleItemCount, lbx->NumLines); n++;
  XtSetArg (args[n], XmNtopAttachment,    XmATTACH_WIDGET); n++;
  XtSetArg (args[n], XmNtopWidget,        lbx->txtLBox); n++;
  XtSetArg (args[n], XmNleftAttachment,   XmATTACH_FORM); n++;
  XtSetArg (args[n], XmNrightAttachment,  XmATTACH_FORM); n++;
  XtSetArg (args[n], XmNbottomAttachment, XmATTACH_FORM); n++;

  lbx->lstLBox
    = XmCreateScrolledList (lbx->fomLBox,
			    lbx->title != NULL ? lbx->title : "ListBox",
			    args, n);

  XtAddCallback (lbx->lstLBox, 
		 XmNbrowseSelectionCallback /*XmNdefaultActionCallback*/ ,
		 (XtCallbackProc) lstLBoxCB,
		 lbx);
  XtManageChild (lbx->lstLBox);

  DEBUG1 ("lbxCrList: Ende");
  
  return True;
}

int lbxDelItem (ListBox_t lbx, char * item)
{
  XmString Item;

  /****** Falsch uebergeben ***************************************************/
  if (item == NULL)
    return False;

  /****** Liste ist noch nicht erzeugt ****************************************/
  if (lbx->lstLBox == NULL)
    return False;

  /****** Erweiterten String erzeuegen ****************************************/
  Item = XmStringCreateSimple (item);

  /****** Element aus der Liste entfernen *************************************/
  XmListDeleteItem (lbx->lstLBox, Item);

  /****** Speicher freigeben **************************************************/
  XmStringFree (Item);

  return True;
}

int lbxDelPos (ListBox_t lbx, int pos, int count)
{
  return listDelPos (lbx->lstLBox, pos, count);
}

int lbxDest (ListBox_t lbx)
{
  DEBUG1 ("lbxDest:");
  
  if (lbx == NULL)
    return False;
  
  StrReplace (lbx->title, NULL);
  MFree (lbx, sizeof (listBox_t));

  DEBUG1 ("lbxDest: ende");

  return True;
}

void lbxDisable (ListBox_t lbx)
{
  XtSetSensitive (lbx->btnLBox, False);
  XtSetSensitive (lbx->txtLBox, False);
}

int lbxDispItem (ListBox_t lbx, char * item)
{
  if (item == NULL)
    return False;

  XmTextSetString (lbx->txtLBox, item);
  return True;
}

void enableListBox (ListBox_t lbx)
{
  XtSetSensitive (lbx->btnLBox, True);
  XtSetSensitive (lbx->txtLBox, True);
}

int lbxViewList (ListBox_t lbx)
{
  XtWidgetGeometry size;
  Arg args [10];
  
  size.request_mode = CWWidth;

  XtQueryGeometry (lbx->fomLBox, NULL, &size);

  XtManageChild (XtParent (lbx->lstLBox));
  
  XtVaSetValues (XtParent (lbx->lstLBox),
		 XmNwidth, size.width,
		 NULL);
  
  XtManageChild (XtParent (lbx->lstLBox));
  
  XtMapWidget   (XtParent (lbx->lstLBox));
  
  /****** Input Focus auf die Liste einrichten ********************************/
  XmProcessTraversal (XtParent (lbx->lstLBox), XmTRAVERSE_CURRENT);
  
  lbx->Hidden = False;

  return True;
}
