/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: mapplist.c,v 1.1 1996/10/28 03:38:43 khamis Exp khamis $
 * $Source: /home/xkhfm/xkhlib/xkhmisc/RCS/mapplist.c,v $
 */

#define IS_EXTERN
#define EXTERN		extern

#include <stdio.h>
#include <stdlib.h>
#include "Xinc.h"

#include "defines.h"
#include "Uxutil.h"
#include "Umessage.h"
#include "Umessage.h"
#include "mapplist.h"
#include "xmisc.h"

int maplAddComp (void * x, void * y)
{
  return 1;
}

int maplAdd (MAppList_t apl)
{
  Dchain_t lstPos;
  int (* lstComp)(void *, void*);
  int ret = True, i;
  int ViewMessage = True; /* Damit nicht mehrere Messages gezeigt werden */
  char ** txtEntry;

#if 1
  DEBUG1 ("maplAdd:");
#endif

  /* Falls die CallFirst Prozedur vorhanden, als erstes aufrufen */
  if (apl->aplData.ClCallFirst != NULL)
    {
      ret = apl->aplData.ClCallFirst
	(apl->CurrentList, apl->aplData.ClData);
      if (!ret)
	{
	  ErrorBox (GetTopShell (apl->fomApl),
		    "Insert",
		    "Error by inserting !");
	  return False;
	}
    }

  /* Speicher allokieren und mit NullPointer initialisieren */
  txtEntry = gcalloc (apl->aplData.ListCount * sizeof (char *), __LINE__, __FILE__);

  /* Alle Felder einlesen */
  for (i=0; i<apl->aplData.ListCount; i++)
    {
      txtEntry [i] = XmTextGetString (apl->lbxApl[i]->txtLBox);
    }

  /* Falls keine Liste zugeordnet ist, keine Eintragung **/
  if (apl->aplData.ClList == NULL)
    {
      ErrorBox (GetTopShell (apl->fomApl),
		  "Insert",
		  "No object to insert !");
      ret = False;
    }

  /* Falls Item schon existiert, nicht eintragen */
  if (ret && UdchItemExists (apl->aplData.ClList,
			     txtEntry[0],
			     (int (*) (void*, void*)) apl->aplData.ClCompare))
    {
      ErrorBox (GetTopShell (apl->fomApl),
		"Insert",
		"Entry already availiable !");
      ViewMessage = False;
      ret = False;
    }

  DEBUG2 ("maplAdd: (%s) hinzufuegen\n", txtEntry[0]);

  /* Eintragen */
  if (ret)
    {
      Dchain_t p;

      /* spezifizieren, wo die Liste eingetragen werden soll **/
      if (apl->aplData.mode & ADD_AFTER_SELECTED)
	{
	  if (apl->CurrentList != NULL)
	    lstPos = apl->CurrentList;
	  else
	    lstPos = UdchLast (apl->aplData.ClList);
	  lstComp = maplAddComp;
	}
      else if (apl->aplData.mode & ADD_BEVOR_SELECTED)
	{
	  if (apl->CurrentList != NULL && UdchPrev (apl->CurrentList) != NULL)
	    lstPos = UdchPrev (apl->CurrentList);
	  else
	    lstPos = apl->aplData.ClList;
	  lstComp = maplAddComp;
	}
      else if (apl->aplData.mode & ADD_AT_TOP)
	{
	  lstPos = apl->aplData.ClList;
	  lstComp = maplAddComp;
	}
      else if (apl->aplData.mode & ADD_AT_LAST)
	{
	  lstPos = UdchLast (apl->aplData.ClList);
	  lstComp = maplAddComp;
	}
      /* normales Einfuegen **/
      else
	{
	  lstPos  = apl->aplData.ClList;
	  lstComp = apl->aplData.ClCompare;
	}
      /* Item in Liste eintragen **/
      apl->CurrentList =
	UdchAdd (lstPos,
		 txtEntry[0],
		 (void * (*) (void *)) apl->aplData.ClMake,
		 (int (*) (void*, void*)) lstComp);

      /* Erfolgreich oder nicht */
      ret = (apl->CurrentList != NULL);
  
      /** die weiteren Felder speichern **/
      if (ret)
	{
	  for (i=0; i<apl->aplData.ListCount; i++)
	    {
	      /* Das erste Element muss einen Wert haben */
	      if (i == 0 && strlen (txtEntry[i]) == 0)
		ret = False;

	      else if (apl->aplData.ClSaveOthers[i] != NULL)
		ret =
		  apl->aplData.ClSaveOthers[i]
		    (apl->CurrentList, txtEntry [i]);

	      /** Falls ein Feld den neuen Wert nicht annimmt, abbrechen */
	      if (ret == False)
		{
		  ErrorBox
		    (GetTopShell (apl->fomApl),
		     "Insert",
		     "a field is empty or have roung entry !\n"
		     "Check your entries and try again !");
		  
		  /* Input Focus auf das fehlende Feld einrichten **/
		  XmProcessTraversal (apl->lbxApl[i]->txtLBox,
				      XmTRAVERSE_CURRENT);
		  ViewMessage = False;
		  ret = False;
		  break;
		}
	    }
	}

      DEBUG1 ("maplAdd: Client Save");

      if (ret)
	{
	  /** An Die ClientSave Funktion uebergeben, falls vorhanden **/
	  if (apl->aplData.ClSave != NULL)
	    ret = apl->aplData.ClSave (apl->CurrentList, apl->aplData.ClData);
	}

      /* Falls die ClSaveFunktion nicht erfolgreich, Wert zuruecknehmen **/
      if (!ret)
	{
	  UdchDelete (apl->CurrentList, apl->aplData.ClDestroy);
	  apl->CurrentList = NULL;
	}
      
      DEBUG1 ("maplAdd: in Liste Hinzufuegen");

      if (ret)
	{
	  int newPos;
	  
	  newPos = UdchPos (apl->aplData.ClList, apl->CurrentList) + 1;

	  DEBUG1 ("maplAdd: weitere Felder in Liste Hinzufuegen");

	  /** Weitere Felder an der selben Position eintragen */
	  for (i=0; i<apl->aplData.ListCount; i++)
	    {
	      listAddPos               (apl->lbxApl[i]->lstLBox, txtEntry[i],
					newPos,
					False);
	      XmListDeselectAllItems   (apl->lbxApl[i]->lstLBox);
	      XmListSetPos             (apl->lbxApl[i]->lstLBox,
					max (1, newPos - 2));
	      XmListSelectPos          (apl->lbxApl[i]->lstLBox, newPos, True);
	    }

	  DEBUG1 ("maplAdd: nach in ListBox eintragen");
	}

      /* Falls nicht eingetragen, dann abbrechen */
      if (! ret && ViewMessage)
	ErrorBox (GetTopShell (apl->fomApl),
		  "Insert",
		  "Entry not added to the list !");
    }
  
  DEBUG1 ("maplAdd: alle txtEntry freigeben");

  /* Speicher freigeben */
  for (i=0; i<apl->aplData.ListCount; i++)
    {
      if (txtEntry [i] != NULL)
	XtFree (txtEntry[i]);
    }
  MFree (txtEntry, apl->aplData.ListCount * sizeof (char *));

  DEBUG1 ("maplAdd: Ende");
  return ret;
}

int maplCopy (MAppList_t apl)
{
  int ret = True, i;

#if 1
  DEBUG1 ("maplCopy:");
#endif

  /* kein Element aktiv */
  if (apl->CurrentList == NULL)
    {
      ErrorBox (GetTopShell (apl->fomApl),
		"Copy",
		"No entry is selected. \n"
		"After selection an item, can you retry this action.\n"
		"No values added to the clipboard !");
      return False;
    }

  /* alten kopierten Eintrag verwerfen **/
  if (apl->CopyList != NULL && apl->aplData.ClDestroy != NULL)
    UdchDelete (apl->CopyList, (int (*)(void*)) apl->aplData.ClDestroy);
  apl->CopyList = NULL;

  DEBUG2 ("maplCopy: Kopiere (%s)\n",
	  apl->aplData.ClValues[0] (apl->CurrentList));

  /* neuen Eintrag erstellen */
  apl->CopyList = UdchAdd (NULL,
			   apl->aplData.ClValues[0] (apl->CurrentList),
			   (void*(*)(void*)) apl->aplData.ClMake,
			   (int (*)(void*,void*)) apl->aplData.ClCompare);
  if (apl->CopyList == NULL)
    return False;

  /* den Inhalt des aktuellen Eintrags in den Zwischenbuffer kopieren */
  if (apl->aplData.ClCopy != NULL)
    ret = apl->aplData.ClCopy (UdchClient (apl->CopyList),
			       UdchClient (apl->CurrentList));

  DEBUG1 ("maplCopy: Ende");
  return ret;
}

#ifdef USE_PIXMAPS
#undef USE_PIXMAPS
#endif

#ifdef USE_PIXMAPS
#include "add.pixm"
#include "mod.pixm"
#include "del.pixm"
#include "undo.pixm"
static Pixmap pxmAdd = NULL, pxmArmAdd = NULL;
static Pixmap pxmMod = NULL, pxmArmMod = NULL;
static Pixmap pxmDel = NULL, pxmArmDel = NULL;
static Pixmap pxmUndo = NULL, pxmArmUndo = NULL;
#endif

void lbxMAplCB (ListBox_t, MAppList_t apl);

void btnMAplAddCB (Widget btn, MAppList_t apl)
{
  apl->LastAction = (int (*) (void*)) maplAdd;
  maplAdd (apl);
}

void btnMAplModCB (Widget btn, MAppList_t apl)
{
  apl->LastAction = (int (*) (void*)) maplMod;
  maplMod (apl);
}

void btnMAplDelCB (Widget btn, MAppList_t apl)
{
  apl->LastAction = (int (*) (void*)) maplDel;
  maplDel (apl);
}

void btnMAplUndoCB (Widget btn, MAppList_t apl)
{
  apl->LastAction = (int (*) (void*)) maplUndo;
  maplUndo (apl);
}

void btnMAplCopyCB (Widget btn, MAppList_t apl)
{
  apl->LastAction = (int (*) (void*)) maplCopy;
  maplCopy (apl);
}

void btnMAplPasteCB (Widget btn, MAppList_t apl)
{
  apl->LastAction = (int (*) (void*)) maplPaste;
  maplPaste (apl);
}

void lbxMAplCB (ListBox_t lbxApl, MAppList_t apl)
{
  static int Active = False;
  int i;
  int * Positions, topPosition, count;
  char * txtEntry;

  /* Da die selbe Funktion fuer alle Spalten aufgerufen wird, darf keine */
  /* unendlichen Schleifen stattfinden, so wird die Prozedur verlassen, **/
  /* wenn sie aktiv bei einer Fallback ist */
  if (Active)
    return;

#if 0
  DEBUG1 ("lbxMAplCB:");
#endif
  
  /* Selektierte Position und die 1. Zeile ermitteln **/
  XmListGetSelectedPos (lbxApl->lstLBox, &Positions, &count);
  XtVaGetValues (lbxApl->lstLBox,
		 XmNtopItemPosition, &topPosition,
		 NULL);

  if (count <= 0 || Positions == NULL)
    {
      WARNING1 ("lbxMAplCB: Error in selektion");
      return;
    }

  /* Flagge setzen, dass die Prozedur aktiv ist */
  Active = True;
  /* Alle anderen Spalten in der AppBox muessen die gleiche */
  /* selektierte Stelle haben */
  for (i=0; i<apl->aplData.ListCount; i++)
    {
      /* nur die anderen Listen anpassen */
      if (lbxApl != apl->lbxApl[i])
	{
	  XmListDeselectAllItems (apl->lbxApl[i]->lstLBox);
	  XmListSelectPos (apl->lbxApl[i]->lstLBox, Positions[0], True);
	  XmListSetPos    (apl->lbxApl[i]->lstLBox, topPosition);
	}
    }

  /* Flagge zuruecksetzen */
  Active = False;

  /* selek. Index einlesen */
  txtEntry = XmTextGetString (apl->lbxApl[0]->txtLBox);

  /* den Listeneintrag suchen und als aktiv merken **/
  apl->CurrentList = UdchFind (apl->aplData.ClList,
			       txtEntry,
			       (int (*) (void*, void*)) apl->aplData.ClCompare);

  /* An die userFunktion uebergeben **/
  if (apl->aplData.ClDisp != NULL)
    apl->aplData.ClDisp (apl->CurrentList, apl->aplData.ClData);

  XtFree (txtEntry);
  free (Positions);

  DEBUG1 ("lbxMAplCB: Ende");
}

MAppList_t maplCreate (Widget parent, MAppData_t aplData)
{
  MAppList_t apl;
  Arg args [10];
  int n, i;
  Dimension width;
  int factor = 1, frCount, frBeg = 0, frEnd = 0, maxw;

#if 1
  DEBUG1 ("maplCreate: Anfang");
#endif

  /* Struktur erstellen */
  apl = gcalloc (sizeof (mAppList_t), __LINE__, __FILE__);

  /* Den Inhalt der uebergebenen Struktur in die MultiApplikationListe */
  /* kopieren **/
  memcpy (&apl->aplData, aplData, sizeof (mAppData_t));

  /* maximale Anzahl der Felder ueberpruefen **/
  apl->aplData.ListCount = min (MAX_LIST_CNT, apl->aplData.ListCount);

  /* AppList zeichnen **/

  /* Form erstellen **/
  for (i=frCount=0; i<apl->aplData.ListCount; i++)
    {
      maxw = max (maxw, apl->aplData.txtLength[i]);
      frCount += apl->aplData.txtLength[i];
    }
  apl->fomApl =
    XtVaCreateManagedWidget
      (apl->aplData.Titles[0],
       xmFormWidgetClass,
       parent,
       XmNfractionBase, frCount /*apl->aplData.ListCount*/ ,
       NULL);

  apl->RowCol =
    XtVaCreateWidget ("Buttons",
		      xmRowColumnWidgetClass,
		      apl->fomApl,
		      XmNorientation,	   XmHORIZONTAL,
		      XmNentryAlignment,   XmALIGNMENT_CENTER,

		      XmNleftAttachment,   XmATTACH_FORM,
		      XmNrightAttachment,  XmATTACH_FORM,
		      XmNbottomAttachment, XmATTACH_FORM,
		      NULL);

  DEBUG1 ("maplCreate: btnAdd");

  apl->btnAdd =
    XtVaCreateManagedWidget
      ("Add",
       xmPushButtonGadgetClass,
       apl->RowCol,
       XmNtopOffset,      SPACE,
       XmNrightOffset,    SPACE,
       NULL);
  XtAddCallback (apl->btnAdd, XmNactivateCallback, 
		 (XtCallbackProc) btnMAplAddCB,
		 apl);
  /* Falls keine ClMake-Prozedur vorhanden ist, ist dieses Button nicht **/
  /* vorhanden */
  if (apl->aplData.ClMake == NULL)
    XtSetSensitive (apl->btnAdd, False);
  btnMesgArea (apl->btnAdd, MAPL_ADD);
  mwinSetPixmapToWidget (apl->btnAdd, PIXM_tool_add24,  MWIN_LOADANDSET);
  mwinSetPixmapToWidget (apl->btnAdd, PIXM_tool_addd24, MWIN_DISABLED);
  XtManageChild (apl->btnAdd);
  
  DEBUG1 ("maplCreate: btnMod");

  apl->btnMod =
    XtVaCreateManagedWidget
      ("Mod",
       xmPushButtonGadgetClass,
       apl->RowCol,
       XmNtopOffset,      SPACE,
       XmNleftOffset,     SPACE,
       NULL);
  XtAddCallback (apl->btnMod, XmNactivateCallback, 
		 (XtCallbackProc) btnMAplModCB,
		 apl);
  btnMesgArea   (apl->btnMod, MAPL_MOD);
  mwinSetPixmapToWidget (apl->btnMod, PIXM_tool_mod24,  MWIN_LOADANDSET);
  mwinSetPixmapToWidget (apl->btnMod, PIXM_tool_modd24, MWIN_DISABLED);
  XtManageChild (apl->btnMod);
  
  DEBUG1 ("maplCreate: btnDel");

  apl->btnDel =
    XtVaCreateManagedWidget ("Del",
			     xmPushButtonGadgetClass,
			     apl->RowCol,
			     XmNtopOffset,      SPACE,
			     XmNleftOffset,     SPACE,
			     XmNrightOffset,    SPACE,
			     
			     NULL);
  XtAddCallback (apl->btnDel, XmNactivateCallback, 
		 (XtCallbackProc) btnMAplDelCB,
		 apl);
  /* Falls keine ClMake-Prozedur vorhanden ist, ist dieses Button nicht **/
  /* vorhanden **/
  if (apl->aplData.ClDestroy == NULL)
    XtSetSensitive (apl->btnDel, False);
  btnMesgArea (apl->btnDel, MAPL_DEL);
  mwinSetPixmapToWidget (apl->btnDel, PIXM_tool_dele24,  MWIN_LOADANDSET);
  mwinSetPixmapToWidget (apl->btnDel, PIXM_tool_deled24, MWIN_DISABLED);
  XtManageChild (apl->btnDel);
  
  DEBUG1 ("maplCreate: btnUndo");

  apl->btnUndo =
    XtVaCreateManagedWidget
      ("Undo",
       xmPushButtonGadgetClass,
       apl->RowCol,
       XmNtopOffset,      SPACE,
       XmNleftOffset,     SPACE,
       NULL);
  XtAddCallback (apl->btnUndo, XmNactivateCallback, 
		 (XtCallbackProc) btnMAplUndoCB,
		 apl);
  btnMesgArea   (apl->btnUndo, MAPL_UNDO);
  mwinSetPixmapToWidget (apl->btnUndo, PIXM_tool_undo24,  MWIN_LOADANDSET);
  mwinSetPixmapToWidget (apl->btnUndo, PIXM_tool_undod24, MWIN_DISABLED);
  XtManageChild (apl->btnUndo);
  

  /* Falls Cut & Paste vorhanden ist **/
  if (apl->aplData.ClCopy != NULL)
    {
      apl->btnCopy =
	XtVaCreateManagedWidget ("Copy",
				 xmPushButtonGadgetClass,
				 apl->RowCol,
				 XmNtopOffset,      SPACE,
				 XmNrightOffset,    SPACE,
				 NULL);
      XtAddCallback (apl->btnCopy, XmNactivateCallback, 
		     (XtCallbackProc) btnMAplCopyCB,
		     apl);
      btnMesgArea (apl->btnCopy, MAPL_COPY);
      mwinSetPixmapToWidget (apl->btnCopy, PIXM_tool_cpy24,  MWIN_LOADANDSET);
      mwinSetPixmapToWidget (apl->btnCopy, PIXM_tool_cpyd24, MWIN_DISABLED);
      XtManageChild (apl->btnCopy);

      apl->btnPaste =
	XtVaCreateManagedWidget ("Paste",
				 xmPushButtonGadgetClass,
				 apl->RowCol,
				 XmNtopOffset,      SPACE,
				 XmNleftOffset,     SPACE,
				 NULL);
      XtAddCallback (apl->btnPaste, XmNactivateCallback, 
		     (XtCallbackProc) btnMAplPasteCB,
		     apl);
      btnMesgArea   (apl->btnPaste, MAPL_PASTE);
      mwinSetPixmapToWidget (apl->btnPaste, PIXM_tool_paste24,  MWIN_LOADANDSET);
      mwinSetPixmapToWidget (apl->btnPaste, PIXM_tool_pasted24, MWIN_DISABLED);
      XtManageChild (apl->btnPaste);
    }  /* Copy und Paste funktionen **/

  XtManageChild (apl->RowCol);

  DEBUG1 ("maplCreate: lblTitle");

  if (apl->aplData.Title != NULL)
    apl->lblTitle =
      XtVaCreateManagedWidget (apl->aplData.Title,
			       xmLabelGadgetClass, apl->fomApl,
			       XmNalignment,        XmALIGNMENT_BEGINNING,
			       XmNtopAttachment,    XmATTACH_FORM,
			       XmNleftAttachment,   XmATTACH_FORM,
			       XmNrightAttachment,  XmATTACH_FORM,
			       NULL);

  /** Die Spalten werden nacheinander erstellt und gezeichnet **/
  for (i=0; i<apl->aplData.ListCount; i++)
    {

      frEnd += apl->aplData.txtLength[i];

      DEBUG2 ("maplCreate: lblApl (%s) zeichnen\n", apl->aplData.Titles [i]);
  
      /** Label zeichnen **/
      apl->lblApl [i] =
	XtVaCreateManagedWidget (apl->aplData.Titles [i],
				 xmLabelGadgetClass, apl->fomApl,
				 XmNalignment,        XmALIGNMENT_BEGINNING,
				 XmNtopAttachment,    (apl->lblTitle != NULL
						       ? XmATTACH_WIDGET
						       : XmATTACH_FORM),
				 XmNtopWidget,        apl->lblTitle,
				 XmNleftAttachment,   XmATTACH_POSITION,
				 XmNleftPosition,     frBeg /*i*/ ,
				 XmNrightAttachment,  XmATTACH_POSITION,
				 XmNrightPosition,    frEnd /*i + 1*/ ,
				 
				 NULL);
      
      /** ListBox zeichnen **/
      DEBUG1 ("maplCreate: lbxApl (Listbox) zeichnen");

      apl->lbxApl[i] =
	lbxCreate (apl->fomApl, /* Vater */
		   apl->aplData.Titles[i],
		   (void (*) (ListBox_t,void*)) lbxMAplCB,
		   apl);       /* Als Client Privat Data */

      XtVaSetValues (apl->lbxApl[i]->fomLBox,
		     XmNtopAttachment,    XmATTACH_WIDGET,
		     XmNtopWidget,        apl->lblApl [i],

		     XmNleftAttachment,   XmATTACH_POSITION,
		     XmNleftPosition,     frBeg /*i*/ ,

		     XmNrightAttachment,  XmATTACH_POSITION,
		     XmNrightPosition,    frEnd /*i + 1*/ ,

		     XmNbottomAttachment, XmATTACH_WIDGET,
		     XmNbottomWidget,     apl->RowCol,
		     NULL);
      /** Textlaenge beschraenken **/
      /** Standardmaessig, ist es ein Infotext, falls nicht definiert **/
      XmTextSetMaxLength (apl->lbxApl[i]->txtLBox,
			  (XtCallbackProc) apl->aplData.txtLength[i] != NULL
			  ? apl->aplData.txtLength[i]
			  : MAX_INFO_LEN);

      /** Eingabe auf erlaubte Zeichen beschraenken **/
      /** defaultmaessig gibt es keine */
      if (apl->aplData.txtForm[i] != NULL)
	XtAddCallback (apl->lbxApl[i]->txtLBox,
		       XmNmodifyVerifyCallback,
		       (XtCallbackProc) txtCheckFrm,
		       (XtPointer) apl->aplData.txtForm[i]);

      /* MessageArea als Callback definieren */
      if (apl->aplData.MesgArea[i] != NULL)
	{
	  txtMesgArea  (apl->lbxApl[i]->txtLBox, apl->aplData.MesgArea[i]);
	  listMesgArea (apl->lbxApl[i]->lstLBox, apl->aplData.MesgArea[i]);
	}

      frBeg = frEnd;
      XtManageChild (apl->lblApl[i]);
      XtManageChild (apl->lbxApl[i]->fomLBox);

    }	/* for (i */

  for (i=0; i<apl->aplData.ListCount; i++)
    {
      maxw = max (maxw, apl->aplData.txtLength[i]);
    }
  for (i=0; i<apl->aplData.ListCount; i++)
    {
      XtVaGetValues (apl->lbxApl[i]->txtLBox,
		     XmNwidth, &width,
		     NULL);
      width = width * apl->aplData.txtLength[i] / maxw;
      XtVaSetValues (apl->lbxApl[i]->txtLBox,
		     XmNwidth, width,
		     NULL);
    } 

  DEBUG1 ("maplCreate: ende");

  return apl;
}

int maplDel (MAppList_t apl)
{
  Dchain_t next;
  int * Positions = NULL, topPosition, count, i;

  int ret;

  DEBUG1 ("maplDel:");

  /* Ist Eintrag aktiv **/
  if (apl->CurrentList == NULL)
    return False;

  DEBUG1 ("maplDel: naechsten Eintrag ermitteln");

  /* Falls das Element entfernt wurde, den naechsten Eintrag als aktiv */
  /* setzen, ansonsten, den vorigen, falls nicht vorhanden */
  next = UdchNext (apl->CurrentList);
  if (next == NULL && UdchPrev (UdchPrev (apl->CurrentList)) != NULL)
    next = UdchPrev (apl->CurrentList);
    
  DEBUG1 ("maplDel: Element aus der Liste loeschen");

  /* 1. die ClientDelete Porzedur aufrufen */
  ret = UdchDelete (apl->CurrentList, apl->aplData.ClDestroy);

  /* 2. den Eintrag aus der Liste entfernen **/
  if (ret)
    {
      /** Falls das Element entfernt wurde, den naechsten Eintrag als aktiv */
      /** setzen, ansonsten, den vorigen, falls nicht vorhanden */
      apl->CurrentList = next;

      DEBUG1 ("maplDel: Listeneintraege loeschen");

      /** Selektierte Position und die 1. Zeile ermitteln */
      XmListGetSelectedPos (apl->lbxApl[0]->lstLBox, &Positions, &count);
      XtVaGetValues        (apl->lbxApl[0]->lstLBox,
			    XmNtopItemPosition, &topPosition,
			    NULL);

      /** Eintrag aus allen Listen loeschen **/
      for (i=0; i<apl->aplData.ListCount; i++)
	{
	  /* Listeneintrag loeschen */
	  lbxDelPos       (apl->lbxApl[i], Positions[0], 1);
	  /* Eingabe loeschen */
	  XmTextSetString (apl->lbxApl[i]->txtLBox, "");
	}
	  
    }

  /* neuen aktiven Eintrag selektieren **/
  if (apl->CurrentList != NULL)
    {
      int newPos;
      newPos = UdchPos (apl->aplData.ClList, apl->CurrentList) + 1;
      XmListSelectPos  (apl->lbxApl[0]->lstLBox, newPos, True);
    }

  /* Bildschirm aktualisieren **/
  if (apl->aplData.ClDisp != NULL)
    apl->aplData.ClDisp (apl->CurrentList, apl->aplData.ClData);

  DEBUG1 ("maplDel: vor Message");

  if (!ret)
    {
      MessageBox (GetTopShell (apl->fomApl),
		  "Delete",
		  "Entry isn't deleted !",
		  XmDIALOG_ERROR,
		  False,
		  NULL,
		  NULL);
    }

  DEBUG1 ("maplDel: Speicher freigeben");

  if (Positions != NULL)
    free (Positions);

  DEBUG1 ("maplDel: Ende");

  return ret;
}

void maplDest (MAppList_t apl)
{
  int i;
  DEBUG1 ("maplDest:");
  
  if (apl == NULL)
    return;

  for (i=0; i<apl->aplData.ListCount; i++)
    {
      lbxDest (apl->lbxApl[i]);
    }

  MFree (apl, sizeof (mAppList_t));

  DEBUG1 ("maplDest: ende");

  return;
}

int maplDisp (MAppList_t apl, char * Value)
{
  Dchain_t newSel = NULL;
  int pos;

#if 0
  DEBUG1 ("maplDisp:");
#endif

  if (apl == NULL || Value == NULL)
    return False;
  
  newSel =
    UdchFind (apl->aplData.ClList, Value,
	      (int (*) (void*, void*)) apl->aplData.ClCompare);

  if (newSel == NULL)
    {
      ErrorBox (GetTopShell (apl->fomApl),
		Value,
		"Pattern not found !");
      return False;
    }

  apl->CurrentList = newSel;
  pos = UdchPos (apl->aplData.ClList, apl->CurrentList) + 1;
  
  XmListSelectPos (apl->lbxApl[0]->lstLBox, pos, True);

  return True;
}

int maplEntry (MAppList_t apl, int mode)
{
  return maplTextEntry (apl, mode) && maplListEntry (apl, mode);
}

int maplListEntry (MAppList_t apl, int mode)
{
  int i;
  if (apl == NULL)
    return False;

  /* Status aller Listen aendern **/
  for (i=0; i<apl->aplData.ListCount; i++)
    {
      XtSetSensitive (apl->lbxApl[i]->lstLBox, mode);
    }

  return True;
}

int maplMod (MAppList_t apl)
{
  char ** txtEntry, ** oldEntry;
  int * Positions = NULL, topPosition, count;
  int ret = True, i;

  DEBUG1 ("maplMod:");

  /* kein Element aktiv */
  if (apl->CurrentList == NULL)
    return False;

  /* Falls die CallFirst Prozedur vorhanden, als erstes aufrufen */
  if (apl->aplData.ClCallFirst != NULL)
    {
      ret = apl->aplData.ClCallFirst
	(apl->CurrentList, apl->aplData.ClData);
      if (!ret)
	{
	  ErrorBox (GetTopShell (apl->fomApl),
		    "Save",
		    "Error by saving the current item !");
	  return False;
	}
    }

  /* Falls keine ClChange Prozedur vorhanden, dann nur die ClientSave */
  /* Prozedur aufrufen */
  if (apl->aplData.ClChange == NULL)
    {
      if (apl->aplData.ClSave != NULL)
	ret = apl->aplData.ClSave (apl->CurrentList, apl->aplData.ClData);

      return True;
    }

  /** Speicher allokieren und mit NullPointer initialisieren */
  txtEntry = gcalloc (apl->aplData.ListCount * sizeof (char *), __LINE__, __FILE__);
  oldEntry = gcalloc (apl->aplData.ListCount * sizeof (char *), __LINE__, __FILE__);
  for (i=0; i<apl->aplData.ListCount; i++)
    {
      /* Alte Eintraege zur Wiederherstellung speichern **/
      if (apl->aplData.ClValues[i] != NULL)
	{
	  oldEntry[i] = gmalloc (strlen (apl->aplData.ClValues[i]
					 (apl->CurrentList)) + 1, __LINE__, __FILE__);
	  strcpy (oldEntry[i], apl->aplData.ClValues[i] (apl->CurrentList));
	}
      txtEntry[i] = XmTextGetString (apl->lbxApl[i]->txtLBox);
    }

  /* Falls nichts vorhanden **/
  if (txtEntry[0] == NULL || strlen (txtEntry[0]) == 0)
    ret = False;

  DEBUG2 ("maplMod: neuer Name: (%s)\n",
	  txtEntry[0] != NULL ? txtEntry[0] : "NULL");

  /* Nur Listeneintrag aendern, wenn der Eintrag geaendert wurde */
  /* Eindeutiges Sortierfeld aendern, falls txtEntry[0] != oldName **/
  if (ret != False &&
      apl->aplData.ClCompare (UdchClient (apl->CurrentList), txtEntry[0]) != 0)
    {
      char * oldValue;

      DEBUG1 ("maplMod: Item Exists ?");

      /** Falls name schon vorhanden */
      if (UdchItemExists (apl->aplData.ClList, txtEntry[0],
			  apl->aplData.ClCompare))
	ret = False;
      
      /** 1. Listeneintrag in der verk. Liste jetzt aendern **/
      if (ret != False)
	{
	  DEBUG3 ("maplMod: verkettete Liste (%s) ==> (%s)\n",
		  apl->aplData.ClValues[0] (apl->CurrentList),
		  txtEntry[0]);
	  
	  /* Falls die Position nicht geaendert werden soll */
	  /* wird der Name geaendert und keine Resortierung gemacht */
	  if (apl->aplData.mode & MOD_DONOT_CHANGE_POS)
	    {
	      ret = apl->aplData.ClChange (apl->CurrentList, txtEntry[0]);
	    }
	  /* ansonsten wird an der richtigen Stelle positioniert */
	  else
	    {
	      ret =
		UdchChange (apl->aplData.ClList,
			    apl->CurrentList,
			    txtEntry[0],
			    (int (*) (Dchain_t, void*)) apl->aplData.ClChange,
			    (int (*) (void*, void*))    apl->aplData.ClCompare
			    );
	    }
	}
    }
      
  if (ret != False)
    {
      /** die weiteren Felder in der Liste speichern */
      for (i=1; i<apl->aplData.ListCount; i++)
	{
	  /* Neuen Wert ueber die ClientProzedur zuweisen */
	  if (apl->aplData.ClSaveOthers [i] != NULL)
	    ret = 
	      apl->aplData.ClSaveOthers[i]
		(apl->CurrentList, txtEntry [i]);
	  if (ret == False)
	    break;
	}
      
      /** An die Client Porzedur uebergeben */
      /** Wenn die ClientProzedur Fehler zurueck gibt, dann abbrechen **/
      /** Die Prozedur kann lokale Felder in die Liste speichern **/
      if (ret)
	{
	  if (apl->aplData.ClSave != NULL)
	    ret =
	      apl->aplData.ClSave (apl->CurrentList, apl->aplData.ClData);
	}
      
      /** Falls Fehler auftaucht, alte Werte in der Liste wiederherstellen*/
      if (ret == False)
	{
	  if (apl->aplData.mode & MOD_DONOT_CHANGE_POS)
	    {
	      ret = apl->aplData.ClChange (apl->CurrentList, oldEntry[0]);
	    }
	  else
	    {
	      UdchChange (apl->aplData.ClList,
			  apl->CurrentList,
			  oldEntry[0],
			  (int (*) (Dchain_t, void*)) apl->aplData.ClChange,
			  (int (*) (void*, void*))    apl->aplData.ClCompare);
	    }
	  for (i=1; i<apl->aplData.ListCount; i++)
	    {
	      /* alten Wert ueber die ClientProzedur zuweisen **/
	      if (apl->aplData.ClSaveOthers [i] != NULL)
		apl->aplData.ClSaveOthers[i]
		  (apl->CurrentList, oldEntry [i]);
	    }
	}
    }

  /** 2. In der ListBox aendern (Reihenfolge wichtig) **/
  /** Dabei ist kein Rueckgang mehr moeglich **/
  if (ret)
    {
      int newPos;
      DEBUG1 ("maplMod: Listeneintrag aendern");
      
      /** Selektierte Position und die 1. Zeile ermitteln */
      XmListGetSelectedPos (apl->lbxApl[0]->lstLBox, &Positions, &count);
      XtVaGetValues (apl->lbxApl[0]->lstLBox,
		     XmNtopItemPosition, &topPosition,
		     NULL);
      
      /** Die alten Eintraege der Spalten zu Anfang loeschen **/
      for (i=0; i<apl->aplData.ListCount; i++)
	{
	  lbxDelPos (apl->lbxApl[i], Positions[0], 1);
	}
      
      /* Position des neuen Eintrags ermitteln **/
      newPos = UdchPos (apl->aplData.ClList, apl->CurrentList) + 1;

      DEBUG1 ("maplMod: Weitere Felder an der selben Position eintragen");

      /** Weitere Felder an der selben Position eintragen */
      for (i=0; i<apl->aplData.ListCount; i++)
	{
	  XmListDeselectAllItems   (apl->lbxApl[i]->lstLBox);
	  listAddPos               (apl->lbxApl[i]->lstLBox, txtEntry[i],
				    newPos,
				    False);
	  XmListSetPos             (apl->lbxApl[i]->lstLBox,
				    max (1, newPos - 2));
	  XmListSelectPos          (apl->lbxApl[i]->lstLBox, newPos, True);
	}
    }

  /* Message ausgeben **/
#if 1
  if (ret == False)
    {
      ErrorBox
	(GetTopShell (apl->fomApl),
	 "Modfiy",
	 "Entry can't be changed\n"
	 "That have one of the following possibles:\n"
	 "* Entry already availiable\n"
	 "* Not alll mandotory field are filled\n"
	 "* Rong entry for logical fields\n"
	 "\n"
	 "Please check es and retry again !");
    }
#endif

  /* Speicher freigeben */
  /* Speicher freigeben */
  for (i=0; i<apl->aplData.ListCount; i++)
    {
      if (txtEntry [i] != NULL) XtFree (txtEntry[i]);
      if (oldEntry [i] != NULL)	MFree  (oldEntry[i], strlen (oldEntry[i])+1);
    }
  MFree (txtEntry, apl->aplData.ListCount * sizeof (char *));
  MFree (oldEntry, apl->aplData.ListCount * sizeof (char *));

  if (Positions != NULL)
    free (Positions);

  DEBUG1 ("maplMod: Ende");

  return ret;
}

int maplPaste (MAppList_t apl)
{
  int ret = True, i;

#if 1
  DEBUG1 ("maplPaste:");
#endif

  /* Parameter muessen richtig sein **/
  if (apl->CopyList == NULL)
    return False;

  /* keine Daten im Zwischenspeicher */
  if (apl->aplData.ClCopy == NULL)
    {      
      ErrorBox (GetTopShell (apl->fomApl),
		"Insert",
		"No values available in the clipboard !");
      return False;
    }
  
  /* Kein Eintrag aktiv, neu Eintragen und gleiche Daten uebernehmen **/
  if (apl->CurrentList == NULL)
    {
      Dchain_t lst;

      /** Felder mit dem kopierten Eintrag ausfuellen */
      for (i=0; i<apl->aplData.ListCount; i++)
	{
	  XmTextSetString (apl->lbxApl[i]->txtLBox,
			   apl->aplData.ClValues[i] (apl->CopyList));
	}
      ret = maplAdd (apl);
      if (ret == False || apl->CurrentList == NULL)
	return False;
    }

  /* Inhalt der Zwischenabl. in das neue Element eintragen */
  ret = apl->aplData.ClCopy (UdchClient (apl->CurrentList),
			     UdchClient (apl->CopyList));

  /* Bildschirm aktualisieren und neue Eintraege zeigen **/
  if (apl->aplData.ClDisp != NULL)
    apl->aplData.ClDisp (apl->CurrentList, apl->aplData.ClData);

  DEBUG1 ("maplPaste: Ende");
  return ret;
}

int maplRedisp (MAppList_t apl)
{
  Dchain_t p = NULL;
  int i;

#if 1
  DEBUG1 ("maplRedisp:");
#endif

  /* vorhandene Eintraege loeschen **/
  for (i=0; i<apl->aplData.ListCount; i++)
    {
      lbxDelPos (apl->lbxApl[i], 1, lbxItemCount (apl->lbxApl[i]));
    }

#if 1
  DEBUG1 ("maplRedisp: Liste aktualisieren");
#endif

#if 1
  if (apl->aplData.ClList == NULL)
    {
      DEBUG1 ("maplRedisp: apl->lstApl == NULL");
    }
  else
    {
      DEBUG2 ("maplRedisp: apl->aplData.ClList != NULL == (%s)\n",
	      apl->aplData.ClValues[0] (apl->aplData.ClList));
    }
#endif

  /* Elemente der Verketteten Liste in die ListBox eintragen */
  if (apl->aplData.ClList != NULL)
    for (p=UdchNext (apl->aplData.ClList); p != NULL; p = UdchNext (p))
      {
	for (i=0; i<apl->aplData.ListCount; i++)	
	  lbxAddItem (apl->lbxApl[i], apl->aplData.ClValues[i] (p),
		      /* DURCH DIE LISTE SIND DIE ELEMENTE VORSORTIERT */
		      LIST_UNSORTED
		      );
      }

  /* keine Liste selektiert **/
  apl->CurrentList = NULL;

  /* Eingabe loeschen **/
#if 1
  DEBUG1 ("maplRedisp: Texteintrag loeschen");
#endif

  for (i=0; i<apl->aplData.ListCount; i++)
    {
      XmTextSetString (apl->lbxApl[i]->txtLBox, "");
    }

  /* BildschirmInhalt loeschen **/
  if (apl->aplData.ClDisp != NULL)
    {
#if 1
      DEBUG1 ("maplRedisp: ClientDisp aufrufen");
#endif

      apl->aplData.ClDisp (apl->CurrentList, apl->aplData.ClData);
    }
  
#if 1
  DEBUG1 ("maplRedisp: Ende");
#endif

  return True;
}

int maplTextEntry (MAppList_t apl, int mode)
{
  int i;
  if (apl == NULL)
    return False;
  /* Status der TextFelder aendern */
  for (i=0; i<apl->aplData.ListCount; i++)
    {
      XmTextSetEditable (apl->lbxApl[i]->txtLBox, mode);
    }
  return True;
}

int maplUndo (MAppList_t apl)
{
  int i;
  DEBUG1 ("maplUndo:");

  /* Undo ist nicht's weiter, als den aktuellen Listenaintrag erneut */
  /* auf den Bildschirm auszugeben **/
  if (apl->aplData.ClDisp != NULL)
    apl->aplData.ClDisp (apl->CurrentList, apl->aplData.ClData);

  for (i=0; i<apl->aplData.ListCount; i++)
    {
      if (apl->aplData.ClValues[i] != NULL && apl->CurrentList != NULL)
        XmTextSetString (apl->lbxApl[i]->txtLBox,
		         apl->aplData.ClValues[i] (apl->CurrentList));
      else
        XmTextSetString (apl->lbxApl[i]->txtLBox, "");
    } 
  DEBUG1 ("maplUndo: Ende");

  return True;
}
