/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: menu.c,v 1.2 1996/12/31 01:38:33 khamis Exp $
 * $Source: /usr2/xkhfm/xkhlib/xkhmisc/RCS/menu.c,v $
 */
#define IS_EXTERN
#define EXTERN		extern

#include "Xinc.h"

#include "defines.h" 
#include "Umenu.h"

Widget mnuMake (Widget parent, menu_t menu[], void * cl_data)
{
  Widget menu_bar, menu_pulldown, menu_item, menu_button, menu_cascade;
  int i, j, n;
  XmString menu_str;
  Arg args [10];

  DEBUG1 ("menubar");

  if (menu == NULL)
    return NULL;
          
  /****** Menueerstellen **************/
  menu_bar = XmCreateMenuBar (parent, "menubar", NULL, 0 );
  if (menu_bar == NULL)
    return NULL;

  /****** Einzelne Menue Bars abtasten */
  for (i=0; menu[i].menu_bar != NULL; i++)
    {
          
      DEBUG2 ("Menubar: [%s]\n", menu[i].menu_bar);

      /* fuer jedes Menue bar, die MenueLeiste erstellen **/
      menu_pulldown = XmCreatePulldownMenu (menu_bar,
					    menu[i].menu_bar,
					    NULL, 0);
      if (menu_pulldown == NULL)
	break;
      
      /* save the widget pointer in the structur */
      menu[i].pulldownWdg = menu_pulldown;

      if (menu[i].visible == False)
	XtVaSetValues (menu_pulldown, XmNsensitive, True);

      /** Menubuttons durchlaufen *****/
      for (j=0; menu[i].menu_item[j].label != NULL; j++)
	{
	  DEBUG2 ("menu.label=[%s]\n", menu[i].menu_item[j].label);

	  /* Falls Separator **********/
	  if (strcmp (menu[i].menu_item[j].label, MENU_SEPARATOR) == 0 ||
	      strcmp (menu[i].menu_item[j].label, MENU_RULE) == 0)
	    {
	      menu_button =
		menu[i].menu_item[j].buttonWdg = 
		XtVaCreateManagedWidget (MENU_SEPARATOR,
					 xmSeparatorGadgetClass,
					 menu_pulldown,
					 NULL);
	      
	      /* Falls Rule (Leer) ****/
	      if (strcmp (menu[i].menu_item[j].label, MENU_RULE) == 0)
		XtVaSetValues (menu_button,
			       XmNseparatorType,	XmNO_LINE);
	    }
	  else if (strcmp (menu[i].menu_item[j].label, MENU_SPECIAL) == 0)
	    {
	      menu[i].menu_item[j].buttonWdg = NULL;
	      /* call client procedure to build submenu */
	      menu[i].menu_item[j].prog (menu_pulldown, cl_data);
	      continue;
	    }
	  else
	    {
	      n = 0;
	      XtSetArg (args[n], XmNmnemonic,
			menu[i].menu_item[j].label[0]); n++;
	      XtSetArg (args[n], XmNsensitive,
			menu[i].menu_item[j].visible); n++;
	      menu_button =
		menu[i].menu_item[j].buttonWdg = 
		XmCreatePushButtonGadget (menu_pulldown,
					  menu[i].menu_item[j].label,
					  args, n);
	    }

	  /* Falls eine Callbackprozedur vorhanden ist, dann deklarieren ***/
	  if (menu[i].menu_item[j].prog != NULL)
	    XtAddCallback (menu_button,
			   XmNactivateCallback,
			   (XtCallbackProc) menu[i].menu_item[j].prog,
			   cl_data);

	  /* Falls noch Untermenues vorhanden, dann rekursiv aufrufen ***/
	  if (menu[i].menu_item[j].nextlevel != NULL)
	    {
	      DEBUG2 ("next level=[%p]", menu[i].menu_item[j].nextlevel);
	      mnuMake (menu_button, menu[i].menu_item[j].nextlevel, cl_data);
	    }

	  XtManageChild (menu_button);
	}

      DEBUG2 ("Menucascade[%s]\n", menu[i].menu_bar);

      menu_str = XmStringCreateSimple (menu[i].menu_bar);
          
      /**** Die Menue-Leiste ist ueber das folgende Menue Cascade ***/
      /**** anzusprechen **************/
      /********************************/
      menu_cascade =
	menu[i].cascadeWdg = 
	XtVaCreateManagedWidget (menu[i].menu_bar,
				 xmCascadeButtonWidgetClass,
				 menu_bar,
				 XmNsubMenuId,   menu_pulldown,
				 XmNmnemonic, menu[i].menu_bar[0],
				 NULL);
      if (menu_cascade == NULL)
	break;
      XtManageChild (menu_cascade);
      XmStringFree (menu_str);
    }

  XtManageChild (menu_bar); 	    /* Menue managen */
  return menu_bar;		    /* Menue Struktur */
}
