/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: option.c,v 1.1 1997/01/07 08:38:27 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/xkhlib/xkhmisc/RCS/option.c,v $
 */
#define IS_EXTERN
#define EXTERN		extern

#include <stdio.h>
#include <stdlib.h>
#include "Xinc.h"

#include "defines.h"
#include "about.h"
#include "quit.h"
#include "Umenu.h"
#include "Uxutil.h"

char * opmGetStr (Widget option)
{
  XmString label;
  char * value;

  DEBUG2 ("OptionButton=(%s)\n", XtName (XmOptionButtonGadget (option)));

  XtVaGetValues (XmOptionButtonGadget (option),
		 XmNlabelString, &label,
		 NULL);

  XmStringGetLtoR (label, XmSTRING_DEFAULT_CHARSET, &value);
  
  DEBUG2 ("OptionString=(%s)\n", value);

  return value;
}

Widget opmMake (Widget parent,
		menu_t menu[],
		char * MesgArea,
		void * cl_data)
{
  Widget
    menu_pulldown,				/* Pointer auf die MenueLeiste*/
    menu_button,				/* Pointer auf die Buttons ****/
    menu_cascade;			        /* Pointer auf das Optionmenu */
  int i, j, n;			                /* Hilfsvariablen *************/
  XmString menu_str;				/* Hilfsstring ****************/
  Arg args [10];				/* Argumentliste **************/

  /*
   * Da wir mit einer Menue-Leiste zu tun haben, wird die Liste nur einmal
   * durchlaufen
   */
  for (i=0; i<1; i++)
    {
      menu_pulldown = XmCreatePulldownMenu (parent,
					    menu[i].menu_bar,
					    NULL, 0);

      if (menu[i].prog != NULL)
	XtAddCallback (menu_pulldown, XmNvalueChangedCallback,
		       (XtCallbackProc) menu[i].prog,
		       cl_data);

      /*
       * Menue-Eintraege erstellen
       */
      for (j=0; menu[i].menu_item[j].label != NULL; j++)
	{
#if 0
	  DEBUG2 ("opmMake: menu.label=[%s]\n", menu[i].menu_item[j].label);
#endif

	  if (strcmp (menu[i].menu_item[j].label, MENU_SEPARATOR) == 0)
	    {
	      menu_button = XtVaCreateManagedWidget (MENU_SEPARATOR,
						     xmSeparatorGadgetClass,
						     menu_pulldown,
						     NULL);
	    }
	  else
	    {
	      menu_button =
		XmCreatePushButtonGadget (menu_pulldown,
					  menu[i].menu_item[j].label,
					  NULL, 0);
	      XtVaSetValues 
		(menu_button,
		 XmNsensitive, menu[i].menu_item[j].visible,
		 NULL);
	    }
	  if (menu[i].menu_item[j].prog != NULL)
	    XtAddCallback (menu_button,
			   XmNactivateCallback,
			   (XtCallbackProc) menu[i].menu_item[j].prog,
			   cl_data);
	  XtManageChild (menu_button);
	}

      /**** Die OptionMenue ist ueber das folgende Menue Cascade
       **** anzusprechen
       ****/

      menu_str = XmStringCreateSimple (menu[i].menu_bar);

#if 0
      DEBUG2 ("opmMake: Option Menu=[%s]\n", menu_str);
#endif

      n = 0;
      XtSetArg (args [n], XmNsubMenuId,   menu_pulldown); n++;
      XtSetArg (args [n], XmNlabelString, menu_str); n++;
      menu_cascade = XmCreateOptionMenu (parent, "Menu", args, n);

      XmStringFree (menu_str);


      XtManageChild (menu_cascade);
    }

  /****** MessageArea und Hilfe einbinden *************************************/
  opmMesgArea   (menu_cascade, MesgArea);

  /*
   * Das Menue ist ueber das folgende Widget anzusprechen
   */

  return menu_cascade;
}

int opmSetStr (Widget option, char * title)
{
  XmString label;

  label = XmStringCreateSimple (title);

  XtVaSetValues (XmOptionButtonGadget (option),
		 XmNlabelString, label,
		 NULL);  

  return True;
}
