/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: radio.c,v 1.1 1996/11/08 04:53:15 khamis Exp khamis $
 * $Source: /home/xkhfm/xkhlib/xkhmisc/RCS/radio.c,v $
 */
#define IS_EXTERN
#define EXTERN		extern

#include <stdio.h>
#include <stdlib.h>
#include "Xinc.h"

#include "defines.h"
#include "Umenu.h"
#include "Uxutil.h"

void radDest (RadioBox_t);

RadioBox_t radCreate (Widget parent,
		      Menu_t mnuList,
		      char * MesgArea,
		      void * cl_data,
		      int mode)
{
  RadioBox_t radBox = gcalloc (sizeof (radioBox_t), __LINE__, __FILE__);
  int i;

  DEBUG1 (mnuList[0].menu_bar);

  if (mode == 0 || mode & RADIO_BOX)
    {
      radBox->radRadio =
	XmCreateRadioBox (parent, mnuList[0].menu_bar, NULL, 0);
    }
  else if (mode & TOGGLEE_BOX)
    {
      radBox->radRadio =
	XtVaCreateWidget (mnuList[0].menu_bar,
			  xmRowColumnWidgetClass,
			  parent,
#if 0
			  XmNradioBehavior,    False,
			  XmNindicatorType,    XmN_OF_MANY,
#endif
			  XmNpacking, XmPACK_COLUMN,
			  NULL);
    }      

  /****** Anzahl der radio Elemente ermitteln**********************************/
  for (radBox->countRadio = 0;
       mnuList[0].menu_item[radBox->countRadio].label != NULL;
       radBox->countRadio ++);

  /****** Speicher fuer alle Buttons ******************************************/
  radBox->btnRadio = gcalloc (sizeof (Widget) * radBox->countRadio, __LINE__, __FILE__);
  for (i=0; mnuList[0].menu_item[i].label != NULL; i++)
    {
#if 0
      DEBUG1 (mnuList[0].menu_item[i].label);
#endif

      radBox->btnRadio[i]
	= XtVaCreateManagedWidget (mnuList[0].menu_item[i].label,
				   xmToggleButtonGadgetClass, 
				   radBox->radRadio,
				   NULL);
      if (mnuList[0].menu_item[i].prog != NULL)
	XtAddCallback (radBox->btnRadio[i], 
		       XmNvalueChangedCallback,
		       (XtCallbackProc) mnuList[0].menu_item[i].prog,
		       cl_data);
    }

#if 0
  XtAddCallback (radBox->radRadio,
		 XmNdestroyCallback,
		 radDest,
		 radBox);
#endif
  radMesgArea   (radBox->radRadio, MesgArea);
  XtManageChild (radBox->radRadio);

  return radBox;
}

void radDest (RadioBox_t rad)
{
  DEBUG1 ("radDest:");

  if (rad == NULL)
    return;

  MFree (rad->btnRadio, sizeof (Widget) * rad->countRadio);
  MFree (rad, sizeof (radioBox_t));

  DEBUG1 ("radDest: Ende");
}

int radSetValue (RadioBox_t radio, int index)
{
  int i;
  
#if 0
  DEBUG2 ("radSetValue: index=(%i)\n", index);
#endif

  /****** Alles auf False setzen **********************************************/
  for (i=0; i<radio->countRadio; i++)
    {
      /** Toggle mit der gewuenschten Nummer setzen ***************************/
      if (i == index)
	XmToggleButtonGadgetSetState (radio->btnRadio[i], True, True);

      /** Falls selektiert, dann Selektion aufheben ***************************/
      else if (XmToggleButtonGadgetGetState (radio->btnRadio[i]))
	XmToggleButtonGadgetSetState (radio->btnRadio[i], False, False);
    }
  
  return True;
}

int radValue (RadioBox_t radio)
{
  int i, value = -1;
  /****** Finden, welches Toggle selektiert ist *******************************/
  for (i=0; i<radio->countRadio; i++)
    {
      if (XmToggleButtonGadgetGetState (radio->btnRadio[i]))
	{
	  value = i;
	  break;
	}
    }
  return value;
}

int radValueNum (RadioBox_t radio, int num)
{
  int i, value = -1;

  /****** Finden, welches Toggle selektiert ist *******************************/
  if (num<radio->countRadio)
    value = XmToggleButtonGadgetGetState (radio->btnRadio[num]);

  return value;
}
