/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: text.c,v 1.1 1996/11/08 04:53:29 khamis Exp khamis $
 * $Source: /home/xkhfm/xkhlib/xkhmisc/RCS/text.c,v $
 */
#define IS_EXTERN
#define EXTERN		extern

#include <stdio.h>
#include <stdlib.h>
#include "Xinc.h"

#include "defines.h"
#include "Uxutil.h"

Text_t txtCreate (Widget parent,
		  char * title,
		  int textLength,
		  int (* textType) (char c, int pos),
		  char * MesgArea,
		  int mode)
{
  Arg args[10];
  int n;
  Text_t txt = gcalloc (sizeof(text_t), __LINE__, __FILE__);

  txt->fomText = XtVaCreateManagedWidget (title,
					  xmFormWidgetClass,
					  parent,
					  NULL);
  txt->lblText =
    XtVaCreateManagedWidget (title,
			     xmLabelGadgetClass, txt->fomText,
			     XmNalignment, XmALIGNMENT_BEGINNING,
			     
			     XmNtopAttachment,    XmATTACH_FORM,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNbottomAttachment, XmATTACH_FORM,
				 
			     NULL);
  XtManageChild (txt->lblText);
      
  n = 0;
  XtSetArg (args[n], XmNtopAttachment,    XmATTACH_FORM); n++;
  XtSetArg (args[n], XmNrightAttachment,  XmATTACH_FORM); n++;
  XtSetArg (args[n], XmNbottomAttachment, XmATTACH_FORM); n++;
  XtSetArg (args[n], XmNleftAttachment,   XmATTACH_WIDGET); n++;
  XtSetArg (args[n], XmNleftWidget,       txt->lblText); n++;
  txt->txtText = XmCreateText (txt->fomText, title, args, n);
  /** Eingabe auf erlaubte Zeichen und Laenge beschraenken **/
  if (textLength > 0)
    XmTextSetMaxLength (txt->txtText, textLength);
  /** Type der Eingabe bestimmen, falls vorhanden ***/
  if (textType != NULL)
    XtAddCallback (txt->txtText,
		   XmNmodifyVerifyCallback,
		   (XtCallbackProc) txtCheckFrm,
		   (XtPointer) textType);
  txtMesgArea   (txt->txtText, MesgArea);
  XtManageChild (txt->txtText);

  XtManageChild (txt->fomText);

  return txt;
}

void txtCheckFrm (Widget w,
		  XtPointer IsOk,
		  XmTextVerifyCallbackStruct * cbs);

/** Ueberprueft ein Zeichen fuer Namensvergebung, erlaubte Zeichen: **/
/** "A-Z a-z 0-9 - und _" *****/
int IsDescrFrm (char c, int pos)
{
  return ((c >= 'a' && c <= 'z') ||
	  (c >= 'A' && c <= 'Z') ||
	  (c >= '0' && c <= '9') ||
	  c == '_' ||
	  c == '-');
}

/** Ueberprueft ein Zeichen eine Zahl ist ***/
/** "0-9" *******/
int IsDigitFrm (char c, int pos)
{
  return (c >= '0' && c <= '9');
}

/** Ueberprueft ein Zeichen eine reelle Zahl ist ***/
/** "0-9" und . *****/
int IsRealFrm (char c, int pos)
{
  return IsDigitFrm (c, pos) || c == '.';
}

/** Zeichen auf Namensvergebung fuer Pfadangabe ***/
/** Erlaubte Zeichen: IsDescrFrm mit / und . ****/
int IsPathFrm (char c, int pos)
{
  return IsDescrFrm (c, pos) || c == '.' || c == '/';
}

/** Zeichen auf Namensvergebung fuer Dateiname ***/
/** Erlaubte Zeichen: IsDescrFrm mit . ***/
int IsFileFrm (char c, int pos)
{
  return IsDescrFrm (c, pos) || c == '.';
}

/** Zeichen fuer Infozeile ****/
/** Keine Begrenzung ******/
int IsInfoFrm (char c, int pos)
{
  return True;
}

/** Alle zeichen, die bei einer Condition-Definition erlaubt sind */
int IsCondFrm (char c, int pos)
{
  return True;
}

/** Alle Zeichen, die bei einer Kommandodefinition erlaubt sind */
int IsCommFrm (char c, int pos)
{
  return True;
}

/** Alle Zeichen, die bei einer Variablendefinition erlaubt sind */
int IsVarFrm (char c, int pos)
{
#if 0
  /** Das erste Zeichen muss ein Dollar sein ****/
  if (pos == 0 && c != '$')
    return False;
#endif
  /** Ansonsten ist es ein Parametername ***/
  return IsDescrFrm (c, pos) || c == '$';
}

void txtCheckFrm (Widget w,
		  XtPointer IsOk,
		  XmTextVerifyCallbackStruct * cbs)
{
  char * newStr;
  int len, modified = False;

  if (w == NULL || IsOk == NULL)
    {
      return;
    }

  /** Backspace eingetippt ****/
  if (cbs->startPos < cbs->currInsert)
    return;

  /** Laenge der eingegebenen Zeichenkette ****/
  len = XmTextGetLastPosition (w);

#if 0
  if (len >= MAX_DESCR_LEN)
    {
      cbs->doit = False;
      return;
    }
#endif

  /** Zeichenkette durchlaufen und verifizieren, ob ein fremdes Zeichen */
  /** vorhanden ist ******/
  for (len = 0; len < cbs->text->length; len ++)
    {
      if (! ((int (*) (char, int)) IsOk) (cbs->text->ptr [len], len))
	{
	  int i;

	  modified = True;

	  /** Unerlaubtes Zeichen entfernen und alles vorruecken */
	  for (i = len; (i+1) < cbs->text->length; i++)
	    {
	      cbs->text->ptr [i] = cbs->text->ptr [i+1];
	    }
	  cbs->text->length--;
	  len --;
	}
    }

  /** Falls etwas am String geaendert, dann piepsen **/
  if (modified)
    XBell (XtDisplay (w), 50);
}

void txtDest (Text_t txt)
{
  DEBUG1 ("txtDest:");

  if (txt == NULL)
    return;

  MFree (txt, sizeof (text_t));

  DEBUG1 ("txtDest: Ende");
}

int txtInsString (Widget txt, char * str)
{
  /** Position ermitteln *****/
  XmTextPosition pos = XmTextGetInsertionPosition (txt);

  if (str == NULL || strlen (str) == 0)
    return False;

  /** Text in den Text einfuegen *****/
  XmTextInsert (txt, pos, str);

  XmTextSetInsertionPosition (txt, pos + strlen (str));

  /** Input Focus auf das Kommando einrichten ****/
  XmProcessTraversal (txt, XmTRAVERSE_CURRENT);

  return True;
}
