/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: window.c,v 1.2 1996/10/28 03:35:17 khamis Exp khamis $
 * $Source: /usr2/xkhfm/xkhlib/xkhmisc/RCS/window.c,v $
 */
#define IS_EXTERN
#define EXTERN		extern

#include <stdio.h>
#include <stdlib.h>
#include "Xinc.h"
#include <Xm/Protocols.h>

#include "defines.h"
#include "about.h"
#include "quit.h"
#include "Umenu.h"
#include "Uxutil.h"
#include "help.h"

#ifdef HAVE_XPM
#include "X11/xpm.h"
#include "pixmap/xkhfm.xpm"
#endif

#include "bitmap/xkhfm.xbm"


#if 0
#define WIN_VIEW_MAXIMIZED
#endif

#define USE_ICONBITMAP
#define USE_MY_DELETE_WINDOW
#define USE_MESG_AREA

int winMesgArea (Widget w, char * text);

void winHelpCB (Widget w, char * text)
{
  hlpView (HelpWindow, text);
}

void TestMotion (Widget w, void * ptr)
{
  DEBUG1 ("motion Callback");
}

void TestEnterWindowMask (Widget w, void * ptr)
{
  DEBUG1 ("EnterWindowMask EventHandler");
}

int defMesgArea (Widget w, char * text, int Type)
{
  Dchain_t hlp = NULL;
  char * MesgArea = " ";

  /****** In der Hilfedatei nach der Sektion suchen, falls nicht gefunden */
  /****** die Hilfe mit der Section aufrufen ******************************/
  if (HelpList != NULL)
    hlp = hlpListFind (HelpList, text);
  if (hlp != NULL)
    {
      MesgArea = hlpListMesgArea (hlp);
    }

#if 1
  if (Type & LIST_MESGAREA)
    {
      XtAddCallback (w,
		     XmNbrowseSelectionCallback,
		     (XtCallbackProc) winMesgArea,
		     MesgArea);
    }
  else if (Type & BTN_MESGAREA)
    {
      XtAddCallback (w,
		     XmNactivateCallback,
		     (XtCallbackProc) winMesgArea,
		     MesgArea);
    }
  else if (Type & TXT_MESGAREA)
    {
      XtAddCallback (w,
		     XmNfocusCallback,
		     (XtCallbackProc) winMesgArea,
		     MesgArea);
      XtAddCallback (w,
		     XmNlosingFocusCallback,
		     (XtCallbackProc) winMesgArea,
		     "");
    }
  else if (Type & OPM_MESGAREA)
    {
    }
  else if (Type & RAD_MESGAREA)
    {
    }
  else
    {
      XtAddCallback (w,
		     XmNfocusCallback,
		     (XtCallbackProc) winMesgArea,
		     MesgArea);
      XtAddCallback (w,
		     XmNlosingFocusCallback,
		     (XtCallbackProc) winMesgArea,
		     "");
    }
#else
#if 1
  DEBUG1 ("defMesgArea: Focus");
  XtAddRawEventHandler (w, FocusChangeMask, False, winMesgArea, MesgArea);
#else
  DEBUG1 ("defMesgArea: EnterWindow");
  XtAddEventHandler (w, EnterWindowMask, False, winMesgArea, MesgArea);
  
  DEBUG1 ("defMesgArea: LeaveWindow");
  XtAddEventHandler (w, LeaveWindowMask, False, winMesgArea, "");
#endif
#endif
     
  /****** Hilfe auch dran haengen ********/
  XtAddCallback (w,
		 XmNhelpCallback,
		 (XtCallbackProc) winHelpCB,
		 text);
  return True;
}

int winMesgArea (Widget w, char * text)
{
  Widget mainWindow, msgArea = NULL;
  XmString label, oldlabel;

#if 1
  for (mainWindow = w;
       mainWindow && ! XmIsMainWindow (mainWindow);
       mainWindow = XtParent (mainWindow));
  if (mainWindow == NULL)
    return False;
#else
  for (mainWindow = w;
       mainWindow && XtParent (mainWindow) != NULL;
       mainWindow = XtParent (mainWindow));
  if (mainWindow == NULL)
    return False;
#endif

  XtVaGetValues (mainWindow,
#if 1
		 XmNmessageWindow, &msgArea,
#else
		 XmNclientData, &msgArea,
#endif
		 NULL);
  if (msgArea == NULL)
    return False;

  label = XmStringCreateSimple (text);
  XtVaGetValues (msgArea,
		 XmNlabelString, &oldlabel,
		 NULL);

  if (! XmStringCompare (label, oldlabel))
    XtVaSetValues (msgArea,
		   XmNlabelString, label,
		   NULL);

  XmStringFree (oldlabel);
  XmStringFree (label);

  DEBUG1 ("winMesgArea: Ende");

  return True;
}

int SetMinMaxOfShellCB (Widget shell,
		      XtPointer client_data, XConfigureEvent * event);

int winCreate (char * title,
	       Widget *toplevel,
	       Widget * mainwindow,
	       Widget * fom_main,
	       int frac_cnt,
	       void * ClData,
	       void (* ClDest) (Widget, void*),
	       int mode)
{
#ifdef USE_ICONBITMAP
  static Pixmap iconBitmap = 0;
#endif
  Widget txtMsgArea, w;
  Text_t txt;
  Arg args[10];
  int n;
  int MY_borderWidth;
  int screenWidth, screenHeight;

  /** oberstes Widget erzeugen (Vater aller) *****************************/
  n = 0;
  XtSetArg (args [n], XmNdeleteResponse, XmDO_NOTHING); n++;
  * toplevel =
    XtAppCreateShell (PROGRAM_NAME /*title*/ ,
		      NULL, 
		      applicationShellWidgetClass,
		      display,	          /* globale variable */
		      args, n);

  if (* toplevel == NULL)
    return False;

  /****** Mainfenster erstellen ***/
  if (mode & WIN_SCROLLED_WINDOW)
    {
      n = 0;
      XtSetArg (args [n], XmNscrollingPolicy, XmAUTOMATIC); n++;
      XtSetArg (args [n], XmNtopAttachment,    XmATTACH_FORM); n++;
      XtSetArg (args [n], XmNleftAttachment,   XmATTACH_FORM); n++;
      XtSetArg (args [n], XmNrightAttachment,  XmATTACH_FORM); n++;
      XtSetArg (args [n], XmNbottomAttachment, XmATTACH_FORM); n++;
      * mainwindow =
	  XmCreateScrolledWindow (* toplevel,
				  title,
				  args, n);
    }
  else
    {
      n = 0;
      XtSetArg (args [n], XmNtopAttachment,    XmATTACH_FORM); n++;
      XtSetArg (args [n], XmNleftAttachment,   XmATTACH_FORM); n++;
      XtSetArg (args [n], XmNrightAttachment,  XmATTACH_FORM); n++;
      XtSetArg (args [n], XmNbottomAttachment, XmATTACH_FORM); n++;
      * mainwindow = XmCreateMainWindow (* toplevel,
					 title,
					 args, n);
    }

#ifdef USE_ICONBITMAP
  /****** Icon Bitmap dem Shell zuordnen *******************************/
  if (iconBitmap == 0)
    {
#ifdef HAVE_XPM
      int ret;
      XpmAttributes attributes;
      XpmColorSymbol symbols[1];
      Pixel color = 0;
      
      XtVaGetValues (*toplevel, XmNbackground, &color, NULL);
      symbols[0].value = "none";
      symbols[0].pixel = color;
      attributes.numsymbols   = 1;
      attributes.colorsymbols = symbols;
      attributes.valuemask = XpmColorSymbols ;
      ret = XpmCreatePixmapFromData(display,
				    RootWindowOfScreen
				    (XtScreen(*toplevel)),
				    xkhfm,
				    &iconBitmap,
				    NULL,
				    &attributes);
      if (ret)
#endif
	iconBitmap =
	  XCreatePixmapFromBitmapData (XtDisplay (*toplevel),
				       RootWindowOfScreen
				       (XtScreen(*toplevel)),
				       xkhfm_bits,
				       xkhfm_width,
				       xkhfm_height,
				       1, 0 , 1);
    }
  /****** erstellte Pixmap dem Fenster zuordnen ***********************/
  if (iconBitmap > 0)
    XtVaSetValues (*toplevel,
		   XmNiconPixmap, iconBitmap,
		   NULL);
#endif

#ifdef USE_MY_DELETE_WINDOW
  /****** Die Close Funktion der Shell abfangen ***/
  if (ClDest != NULL)
    {
      Atom WM_DELETE_WINDOW;
      WM_DELETE_WINDOW =
	XmInternAtom (XtDisplay (*toplevel), "WM_DELETE_WINDOW",
		      False);
      XmAddWMProtocolCallback (*toplevel, WM_DELETE_WINDOW,
			       (XtCallbackProc) ClDest, ClData);
    }
#endif

  /****** Titel zeigen ****/
  SetWindowTitle (*toplevel, title);
  XtVaSetValues  (*toplevel,
		  XtNiconName, title,
		  NULL);

  /****** MessageArea erstellen ***/
  /****** message area als label erstellen ***/
#ifdef HAVE_MOTIF20
  *fom_main =
    XtVaCreateManagedWidget ("Form",
			     xmFormWidgetClass,
			     *mainwindow,
			     XmNfractionBase, frac_cnt,
			     XLEFT_F,
			     XRIGHT_F,
			     XTOP_F,
			     XBOTTOM_F,
			     NULL);
#endif
#ifdef USE_MESG_AREA
  if (! (mode & WIN_NO_MESG_AREA))
    {
      txtMsgArea =
	XtVaCreateManagedWidget (title,
				 xmLabelGadgetClass,
				 *mainwindow,
				 XmNalignment, XmALIGNMENT_BEGINNING,
				 NULL);
      XtVaSetValues (*mainwindow,
		     XmNclientData,    txtMsgArea,
		     XmNmessageWindow, txtMsgArea,
		     NULL);
      XtManageChild (txtMsgArea);
    }
#endif
#ifndef HAVE_MOTIF20
  *fom_main =
    XtVaCreateManagedWidget ("Form",
			     xmFormWidgetClass,
			     *mainwindow,
			     XmNfractionBase, frac_cnt,
			     NULL);
#endif



#if 0
  /****** Minimale Groesse festlegen, so dass das Fenster groesser aber ***/
  /****** nicht kleiner wird als es am Anfang erstellt wurde **************/
  XtAddEventHandler (*toplevel, StructureNotifyMask, False,
		     (XtEventHandler) SetMinMaxOfShellCB,
		     NULL);
#endif

  return (*mainwindow == NULL) ? False : True;
}

int SetMinMaxOfShellCB (Widget shell,
			XtPointer client_data,
			XConfigureEvent * event)
{
  int screen_w, screen_h, max_w, max_h, min_h, min_w;
  int w, h, border_w = 0, x, y;

  if (event->type != ConfigureNotify) 
    return True;

  XtVaGetValues (shell,
		 XmNborderWidth, &border_w,
		 NULL);

  /****** maximale Hoehe und Breite bestimmen *****/
  screen_w = WidthOfScreen  (XtScreen (shell));
  screen_h = HeightOfScreen (XtScreen (shell));
  max_w    = screen_w - border_w * 2;   /** Border-Breite beruecksichtigen **/
  max_h    = screen_h - border_w * 2;   /** Border-Breite beruecksichtigen **/
  w        = min (max_w, event->width);   /* Breite auf Bildschirmbreite anp.*/
  h        = min (max_h, event->height);    /** Hoehe anpassen *******/
  min_w    = min (max_w/2, event->width);   /** minimale Breite ***********/
  min_h    = min (max_h/2, event->height);  /** minimale Hoehe ************/

  /****** Voruebergehend wird das Maximum angenommen ************/
#ifdef WIN_VIEW_MAXIMIZED
  w        = max_w;
  h        = max_h;
#endif

  DEBUG3 ("event->width=%i, event->height=%i\n", event->width, event->height);

  XtVaSetValues (shell,
#ifdef WIN_VIEW_MAXIMIZED
		 XmNx,         0,
		 XmNy,         0,
#endif
		 XmNmaxWidth,  max_w,
		 XmNmaxHeight, max_h,
		 XmNminWidth,  min_w,
		 XmNminHeight, min_h,
		 XmNwidth,     w,
		 XmNheight,    h,
		 NULL);
  XtRemoveEventHandler (shell, StructureNotifyMask, False,
			(XtEventHandler) SetMinMaxOfShellCB,
			NULL);
  return True;
}

extern int SetMinMaxOfShellCB (Widget shell,
			       XtPointer client_data,
			       XConfigureEvent * event);

int dlgCreate (Widget parent,
	       char * title,
	       Widget *toplevel,
	       Widget * mainwindow,
	       int mode)
{
  Arg args[10];
  int n;

  n = 0;
  if (! (mode & DLG_NOT_MODAL))
    {
      XtSetArg (args [n], XmNautoUnmanage, False); n++;
      XtSetArg (args [n], XmNdialogStyle,  XmDIALOG_APPLICATION_MODAL); n++;
    }
  if (mode & DLG_MESSAGE)
    {
      * toplevel = 
	  XmCreateMessageDialog (parent != NULL ? parent : topShell,
				 title,
				 args,
				 n);
    }
  else
    {
#if 1
      * toplevel =
	  XmCreateDialogShell ((parent != NULL) ? parent : topShell,
			       title,
			       args,
			       n);
#else
      * toplevel =
	  XtCreatePopupShell (title,
			      xmDialogShellWidgetClass,
			      (parent != NULL) ? parent : topShell,
			      args,
			      n);
#endif
    }
  if (* toplevel == NULL)
    return False;

  /****** Minimale Groesse festlegen, so dass das Fenster groesser aber ***/
  /****** nicht kleiner wird als es am Anfang erstellt wurde *************/
  XtAddEventHandler (*toplevel, StructureNotifyMask, False,
		     (XtEventHandler) SetMinMaxOfShellCB,
		     NULL);

  /****** Titel im Dialogfenster zeigen **/
  SetWindowTitle (*toplevel, title);
  XtVaSetValues  (*toplevel,
		  XtNiconName, title,
		  NULL);

  /****** Mainfenster erstellen *******************************************/
  if (mainwindow != NULL)
    {
      * mainwindow = XmCreateMainWindow (* toplevel,
					 title,
					 NULL, 0);

      if (*mainwindow == NULL)
	XtDestroyWidget (*toplevel);
    }
  else
    return True;

  return (*mainwindow == NULL) ? False : True;
}
