/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: color.c,v 1.1 1997/01/07 08:38:27 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/xkhlib/xkhsrc/RCS/color.c,v $
 */
#define IS_EXTERN
#define EXTERN		extern

#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>
#include <string.h>
#include <Xm/DrawingA.h>
#include <Xm/ScrollBar.h>
#include "Xinc.h"

#include "defines.h"
#include "Umem.h"
#include "Uxutil.h"
#include "Umessage.h"
#include "Umenu.h"
#include "Urcnfvoid.h"
#include "Ureadarg.h"
#include "Ufileutil.h"
#include "Ustrutil.h"
#include "about.h"
#include "quit.h"
#include "help.h"
#include "xmisc.h"
#include "mainwin.h"

static Widget shlColor = NULL, winColor = NULL;

void clrResizeCB (Widget w, void * ptr, XmDrawingAreaCallbackStruct * cbs)
{
  long width, height;
  int i;

  XtVaGetValues (w,
		 XmNwidth, &width,
		 XmNheight, &height,
		 NULL);

  if (width == 0 || height == 0 || cbs->window == 0)
    return;

  if (cbs->reason == XmCR_EXPOSE ||
      cbs->reason == XmCR_RESIZE)
    {
      /* clear old entries of the drawing area on resizing */
      if (cbs->reason == XmCR_RESIZE)
	{
	  XClearArea (display,
		      cbs->window,
		      0, 0,
		      width, height,
		      False);
	}
      for (i=0; i<256; i++)
	{
	  char tmp[64];
	  long x, y, width, height;
	  width  = 16;
	  height = 16;
	  x = 10 + (i % 28) * 40;
	  y = 10 + (i / 28) * 65;
	  XSetForeground (display, theGC, i);
	  XFillRectangle (display, cbs->window, theGC, x, y, width, height);

	  sprintf (tmp, "%i", i);
	  XDrawImageString (display, cbs->window, theGC,
			    x, y + height + 15, tmp, strlen (tmp));
	  sprintf (tmp, "%x", i);
	  XDrawImageString (display, cbs->window, theGC,
			    x, y + height + 30, tmp, strlen (tmp));
	  sprintf (tmp, "%o", i);
	  XDrawImageString (display, cbs->window, theGC,
			    x, y + height + 45, tmp, strlen (tmp));
	}
    }
}
int clrView (void)
{
  Widget w, fomMain, drwColor;
  Arg args[20];
  int i, j, n;
  long width, height, x, y, nameHeight;

  if (shlColor != NULL)
    return True;

  /* Hauptmaske in einer neuen Shell erstellen ********************************/
  winCreate ("Color list",
	     &shlColor,
	     &winColor,
	     &fomMain,
	     6,
	     NULL,
	     NULL,
	     False /*SCROLLED_WINDOW*/ );
  if (winColor == NULL)
    {
      ERROR1 ("mwinView: cannot create a mainwindow");
      exit (1);
    }
  XtVaSetValues (winColor,
		 XmNwidth, 640,
		 XmNheight, 480,
		 NULL);
  /****** Menue-Eintraege fuer das Hauptfenster erstellen *********************/
  mnuMake (winColor, NULL, NULL);

  /****** Das Fenster wird in 3 Fractions aufgeteitl, es wird von unten nach **/
  /****** oben gezeichnet, am Ende wird der Editor dazwischen angebunden ******/

  drwColor =
    XtVaCreateManagedWidget ("DrawingArea",
			     xmDrawingAreaWidgetClass,
			     fomMain,
			     XmNtopAttachment, XmATTACH_FORM,
			     XmNrightAttachment, XmATTACH_FORM,
			     XmNleftAttachment, XmATTACH_FORM,
			     XmNbottomAttachment, XmATTACH_FORM,
			     NULL);
  XtAddCallback (drwColor, XmNexposeCallback, (XtCallbackProc) clrResizeCB, NULL);
  XtAddCallback (drwColor, XmNresizeCallback, (XtCallbackProc) clrResizeCB, NULL);
  XtManageChild (drwColor);

  XtManageChild (fomMain);

  XtManageChild (winColor);

  /****************************************************************************/
  /***** E N D E D E R Z E I C H N U N G **************************************/
  /****************************************************************************/

  MXtRealizeWidget (shlColor);
  return True;
}

