/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: mwinAction.c,v 1.2 1996/10/28 03:37:33 khamis Exp khamis $
 * $Source: /home/xkhfm/xkhlib/xkhsrc/RCS/mwinAction.c,v $
 */
#define IS_EXTERN
#define EXTERN		extern

#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>
#include <string.h>
#include <Xm/DrawingA.h>
#include <Xm/ScrollBar.h>
#include "Xinc.h"
#include <Xm/CutPaste.h>
#include <Xm/Command.h>

#include "defines.h"
#include "Umem.h"
#include "Uxutil.h"
#include "Umessage.h"
#include "Umenu.h"
#include "Urcnfvoid.h"
#include "Ureadarg.h"
#include "Ufileutil.h"
#include "Ustrutil.h"
#include "about.h"
#include "quit.h"
#include "help.h"
#include "xmisc.h"
#include "window.h"
#include "mainwin.h"

#define DBL_CLICK	0x0001

enum
{
  ACTION_COPY = 1,
  ACTION_MOVE,
  ACTION_DEL,
  ACTION_PROP,
  ACTION_EDIT
};

/* selects region by using a Rectanlge */
#define SEL_REGION(clr) \
{ \
XSetForeground (display, mwin->gc, clr); \
XDrawRectangle (display, \
		XtWindow (w), \
		      mwin->gc, \
		      min (mwin->btnPressX, mwin->btnReleaseX), \
		      min (mwin->btnPressY, mwin->btnReleaseY), \
		      abs (mwin->btnReleaseX - mwin->btnPressX), \
		      abs (mwin->btnReleaseY - mwin->btnPressY)); \
}

/* get Window and X,Y of the Pointer position */
int CursorWindowAndXY (Window * rwin, int * xx, int * yy)
{
  Window rW, win, cW;
  int rx, ry, x, y;
  unsigned int mask;

  while (!XQueryPointer (display, rootWindow,
			 &rW, &cW,
			 &rx, &ry, &x, &y, &mask));
  
#if 0
  if (! (mask & Button1Mask))
    break;
#endif
  
  /* find deepest child that the mouse is in */
  for (win=cW; cW!=None; ) {
    XTranslateCoordinates
      (display, rW, win, rx, ry, &x, &y, &cW);
    if (cW != None)
      win = cW;
  }
  
#if 0
  XSync (display, False);
#endif

  if (win == None)
    {
      DEBUG1 ("CursorWindowAndXY: Pointer points to none Window");
      return False;
    }
  
  if (xx != NULL) *xx   = x;
  if (yy != NULL) *yy   = y;
  if (rwin != NULL) *rwin = win;

  DEBUG4 ("CursorWindowAndXY: win(%li), x(%i), y(%i)\n", win, x, y);

  return True;
}

int mwinProp1 (Mainwin_t mwin)
{
  int i, len, ret;

  if (mwin->Prop == NULL)
    mwin->Prop = propMake ();

  /* Remove old values in the propr. window */
  mwin->Prop->Files = StrReplace (mwin->Prop->Files, NULL);

  /* get filelist from Clipboard */
  len = GetDataFromClipboard (&mwin->Prop->Files);

  if (len <= 0) return False;
  
  /* view propr. window */
  ret = propView (mwin->shlMainwin, mwin->Prop);

  return ret;
}

int mwinCopyMove1 (Mainwin_t mwin, int mode)
{
  int len, ret;

  if (mwin->Copy == NULL)
    mwin->Copy = cpyMake ();

  /* Remove old values in the copy-window */
  mwin->Copy->Source = StrReplace (mwin->Copy->Source, NULL);

  /* get filelist from Clipboard */
  len = GetDataFromClipboard (&mwin->Copy->Source);

  if (len <= 0) return False;
  
  if (mode)
    mwin->Copy->info.mode |= CPY_MOVE;
  else
    mwin->Copy->info.mode &= ~CPY_MOVE;

  /* view remove window */
  ret = cpyView (mwin->shlMainwin, mwin->Copy);

  return ret;
}

int mwinRunWindowProg (int mode)
{
  Window win;
  int x, y, i;
  Dchain_t dirWins;
  Mainwin_t mwin;
  int ret = False;

  if (! CursorWindowAndXY (&win, &x, &y))
    win = 0;

  for (dirWins = UdchNext (winList);
       dirWins != NULL;
       dirWins = UdchNext (dirWins))
    {
      WindowList_t ww = UdchClient (dirWins);

      if (ww->Type == WIN_COMMAND && ww->wins.cmd->cmdComm != NULL)
	{
	  Widget txt;
	  Command_t cmd = ww->wins.cmd;
	  txt = XmCommandGetChild (cmd->cmdComm, XmDIALOG_COMMAND_TEXT);
	  if (win == XtWindow (txt))
	    {
	      char * files = NULL;
	      if (mode)
		{
		  int len = GetDataFromClipboard (&files);
		  int pos;
		  /* Add Filenames to the insertion Position 
		   * of Command line */
		  if (len > 0 && files != NULL)
		    for (i=0; i<len-1; i++)
		      {
			if (i == 0 || i > 0 && files [i-1] == 0)
			  {
			    if (i > 0)
			      XmTextInsert
				(txt,
				 XmTextGetInsertionPosition
				 (txt),
				 " ");
			    XmTextInsert
			      (txt,
			       XmTextGetInsertionPosition (txt),
			       &files [i]);
			  }
		      }
		  MFree (files, len);
		  ret = True;
		}
	      else
		ret = ACTION_EDIT;
	    }
	}

      if (ww->Type != WIN_REGULAR)
	continue;
      mwin = ww->wins.mainwin;

      /* Cut and Paste for the commando line */
      if (mwin->txtComm != NULL &&
	  win == XtWindow (mwin->txtComm->txtText))
	{
	  char * files = NULL;
	  if (mode)
	    {
	      int len = GetDataFromClipboard (&files);
	      int pos;
	      /* Add Filenames to the insertion Position 
	       * of Command line */
	      if (len > 0 && files != NULL)
		for (i=0; i<len-1; i++)
		  {
		    if (i == 0 || i > 0 && files [i-1] == 0)
		      {
			if (i > 0)
			  XmTextInsert
			    (mwin->txtComm->txtText,
			     XmTextGetInsertionPosition
			     (mwin->txtComm->txtText),
			     " ");
			XmTextInsert
			  (mwin->txtComm->txtText,
			   XmTextGetInsertionPosition (mwin->txtComm->txtText),
			   &files [i]);
		      }
		  }
	      MFree (files, len);
	      ret = True;
	    }
	  else
	    ret = ACTION_EDIT;
	}

      if (win == XtWindow (mwin->fomCommands))
	{
	  Position bx = 0, by = 0;
	  Dimension width = 0, height = 0;

	  /* Delete Button */
	  XtVaGetValues (mwin->btnDel,
			 XmNx, &bx,
			 XmNy, &by,
			 XmNheight, &height,
			 XmNwidth, &width,
			 NULL);
	  if (bx <= x && bx+width >= x &&
	      by <= y && by+height >= y)
	    {
	      if (mode)
		ret = mwinDel (mwin, MWIN_READ_FROM_CLIPBOARD);
	      else
		ret = ACTION_DEL;
	    }

	  /* Copy Button */
	  XtVaGetValues (mwin->btnCopy,
			 XmNx, &bx,
			 XmNy, &by,
			 XmNheight, &height,
			 XmNwidth, &width,
			 NULL);
	  if (bx <= x && bx+width >= x &&
	      by <= y && by+height >= y)
	    {
	      if (mode)
		ret = mwinCopyMove1 (mwin, False);
	      else
		ret = ACTION_COPY;
	    }

	  /* Move Button */
	  XtVaGetValues (mwin->btnMove,
			 XmNx, &bx,
			 XmNy, &by,
			 XmNheight, &height,
			 XmNwidth, &width,
			 NULL);
	  if (bx <= x && bx+width >= x &&
	      by <= y && by+height >= y)
	    {
	      if (mode)
		ret = mwinCopyMove1 (mwin, True);
	      else
		ret = ACTION_MOVE;
	    }

	  /* Properities Button */
	  XtVaGetValues (mwin->btnProp,
			 XmNx, &bx,
			 XmNy, &by,
			 XmNheight, &height,
			 XmNwidth, &width,
			 NULL);
	  if (bx <= x && bx+width >= x &&
	      by <= y && by+height >= y)
	    {
	      if (mode)
		ret = mwinProp1 (mwin);
	      else
		ret = ACTION_PROP;
	    }
	}

      if (win == XtWindow (mwin->fomFiles))
	{
	  DEBUG2 ("mwinAction: fomFiles(%s)\n",
		  mode ? "mwinCopy" : "mwinCanCopy");
	  if (mode)
	    ret = mwinCopy (mwin, x, y);
	  else
	    {
	      if (mwinCanCopy (mwin, x, y))
		ret = ACTION_COPY;
	      else
		ret = False;
	    }
	}

      /* deselect old soft selected file */
      if (mode || win != XtWindow (mwin->fomFiles))
	mwinSoftSelectIcon (mwin, mwin->FilesSoftSelNum, False);

      /* By ending the copy delete the copy marked icon */
      if (mode)
	mwinCopySelectIcon (mwin, mwin->FilesCopySelNum, False);

      if (win == XtWindow (mwin->fomTree))
	{
	  DEBUG2 ("mwinAction: fomTree(%s)\n",
		  mode ? "mwinTreeCopy" : "mwinTreeCanCopy");
	  if (mode)
	    ret = mwinTreeCopy (mwin, x, y);
	  else
	    ret = mwinTreeCanCopy (mwin, x, y);
	}

      /* deselect old soft selected Tree */
      if (mode || win != XtWindow (mwin->fomTree))
	mwinTreeSoftSelectIcon (mwin, mwin->TreeSoftSelNum, False);

      /* By ending the copy delete the copy marked icon */
      if (mode)
	mwinTreeCopySelectIcon (mwin, mwin->TreeCopySelNum, False);
    }

  DEBUG2 ("mwinAction: ret(%i)\n", ret);
  return ret;
}

int mwinAction (Widget w,
		Mainwin_t mwin,
		XmDrawingAreaCallbackStruct * cbs,
		Action_t Action)
{
  XEvent *event = cbs->event;
  XEvent tmpEvent;
  KeySym key;
  static unsigned long lastEventClickTime = 0;
  static int LastAction = 0;
  static int MotionType = MOTION_SELECT;
  static int CopiedToClippboard = False;
  int x1, x2, y1, y2;

  DEBUG3 ("mwinAction: Window[%li], Widget[%s]\n",
	  XtWindow(w),
	  w == mwin->fomFiles ? "Files" : "Tree");
  
  switch (cbs->reason)    
    {
    case XmCR_INPUT:
      switch (event->xany.type)
	{
	case ButtonPress:

	  if (event->xbutton.button == Button1)
	    {
	      
	      DEBUG4 ("mwinAction: btnPress[%s] x=%li y=%li\n",
		      w == mwin->fomFiles ? "Files" : "Tree",
		      event->xbutton.x,
		      event->xbutton.y);
	      
	      /* default, motion selects region */
	      MotionType = MOTION_SELECT;
	      
	      mwin->btnPressX = mwin->btnReleaseX = event->xbutton.x;
	      mwin->btnPressY = mwin->btnReleaseY = event->xbutton.y;
	      
	      /** call press procedure if availiable, this will be needed */
	      /** when copying by moving the selected objects is possible */
	      if (Action->PressProc != NULL)
		MotionType = Action->PressProc (mwin, event);
	    }
	  break;

	  /* select action by button release, so we can select a region */
	case ButtonRelease:

	  if (event->xbutton.button == Button1)
	    {
	  DEBUG4 ("mwinAction: btnRelease[%s] x=%li y=%li\n",
		  w == mwin->fomFiles ? "Files" : "Tree",
		  event->xbutton.x,
		  event->xbutton.y);

	  /* Set Cursor to normal */
	  NormalCursor (mwin->shlMainwin);

	  mwin->btnReleaseX = event->xbutton.x;
	  mwin->btnReleaseY = event->xbutton.y;

	  CopiedToClippboard = False;

	  /* delete selection box, if selectionbox availiable */
	  if (! (MotionType & MOTION_COPY) && Action->MotionProc != NULL)
	    SEL_REGION (mwin->bg);
	  
	  /* double Click */
	  if (abs (mwin->btnPressX - mwin->btnReleaseX) <= CLICK_REGION &&
	      abs (mwin->btnPressY - mwin->btnReleaseY) <= CLICK_REGION &&
	      event->xbutton.time - lastEventClickTime <= DBLCLICK_TIMEOUT)
	    {
	      DEBUG4 ("mwinActoin: event->xbutton.time=(%li),\n"
		      "lastEventClickTime=(%li),\n"
		      "event->xbutton.time - lastEventClickTime=(%li)\n",
		      event->xbutton.time,
		      lastEventClickTime,
		      event->xbutton.time - lastEventClickTime);
	      
	      if (Action->ReleaseProc != NULL)
		Action->ReleaseProc (mwin, event);

	      if (Action->ExecProc != NULL)
		Action->ExecProc (mwin, event);
	      
	      lastEventClickTime = 0;
	      LastAction = DBL_CLICK;
	      mwin->btnPressX = mwin->btnPressY = 0;
	      return True;
	    }

	  /* selection only */
	  else if
	    (abs (mwin->btnPressX - mwin->btnReleaseX) <= CLICK_REGION &&
	     abs (mwin->btnPressY - mwin->btnReleaseY) <= CLICK_REGION)
	    {
	      DEBUG1 ("mwinAction: SelectProc ... 1");

	      if (Action->SelectProc != NULL)
		Action->SelectProc (mwin, event);

	      DEBUG1 ("mwinAction: After SelectProc ... 1");
	    }

	  else if (MotionType & MOTION_SELECT)
	    {
	      DEBUG1 ("mwinAction: ReleaseProc ... 1");

	      if (Action->ReleaseProc != NULL)
		Action->ReleaseProc (mwin, event);

	      DEBUG1 ("mwinAction: After ReleaseProc ... 1");
	    }

	  /* at the end of a Motion Action, send an event to the destination */
	  /* window */
	  else if (MotionType & MOTION_COPY)
	    {
	      DEBUG1 ("mwinAction: mwinRunWindow ... 1");

	      /* Execute Copy Program */
	      mwinRunWindowProg (True);

	      /* Set Cursor to normal */
	      NormalCursor (mwin->shlMainwin);

	      MotionType = False;
	      LastAction = False;

	      DEBUG1 ("mwinAction: After mwinRunWindow ... 1");

	      break;
	    }

	  lastEventClickTime = event->xbutton.time;	  
	  LastAction = 0x0;
	    }
	  break;

	case KeyPress:
	  {

	    XLookupString (&event->xkey, NULL, 0, &key, NULL);

	    DEBUG5 ("mwinAction: PressKey[%s] keycode=%i, stat=%i, keySym=%i\n",
		    w == mwin->fomTree ? "Tree" : "Files",
		    event->xkey.keycode,
		    event->xkey.state,
		    key);

	    if (Action->KeyboardProc != NULL)
	      Action->KeyboardProc (mwin, key, event->xkey.state);
	  }
	  break;
	  
	case KeyRelease:
	  break;

	default:
	  DEBUG2 ("unknown action (%i)\n", event->xany.type);
	  break;
	}
      break;
      
    case REASON_MOTION:

      if (event->xbutton.state & Button1MotionMask)
	{

	  if (event->xbutton.send_event)
	    {
	      int x, y;
	      int CanCopy = False;
	      DEBUG1 ("mwinAction: Event Recieved");
	      
	      if (! CursorWindowAndXY (NULL, &x, &y))
		break;
	      
	      /* Verify if we can copy, where the cursor points */
	      if (Action->CanCopyProc != NULL)
		CanCopy = Action->CanCopyProc (mwin, x, y);
	      
	      /* Load Rong Cursor as Default */
	      if (CanCopy)
		SetCursor (mwin->shlMainwin, CURSOR_CAN_COPY);
	      else
		SetCursor (mwin->shlMainwin, CURSOR_RONG);
	      
	      break;
	    }
	  
	  /* copy/move selected objects */
	  if (MotionType & MOTION_COPY)
	    {
	      Window       rW, cW, win;
	      int          x, y, rx, ry;
	      unsigned int mask;
	      int ret = False;
	      
	      DEBUG1 ("mwinAction: MOTION_COPY");
	      
	      /* copy selected files to clipboard */
	      if (CopiedToClippboard == False)
		{
		  unsigned long item_id = 0;
		  int status;
		  
		  DEBUG1 ("mwinAction: Copy selected files");
		  
		  item_id = OpenClipboard();
		  
		  /* copy selected files form files window */
		  if (w == mwin->fomFiles)
		    {
		      int len, i, cnt, Flag = False;
		      
		      DEBUG1 ("mwinAction: Copy files");
		      
		      /* if an item moved, that not originaly selected */
		      /* then copy only it into the clipboard */
		      if (mwin->FilesCopySelNum < mwin->dirEntryCount &&
			  dirCopySelected
			  (mwin->dirWidgets[mwin->FilesCopySelNum]->
			   dirListEntry) &&
			  ! mwinSelected (mwin, mwin->FilesCopySelNum))
			{
			  Flag = True;
			}
		      
		      /* Copy to Clipboard */
		      for (i=cnt=0; i<mwin->dirEntryCount; i++)
			{
			  if ((Flag &&
			       dirCopySelected
			       (mwin->dirWidgets[i]->dirListEntry))
			      ||
			      (Flag == False && mwinSelected (mwin, i)))
			    {
			      char * buf;
			      buf = gmalloc
				(strlen (mwin->DirName)
				 + strlen
				 (dirName
				  (mwin->dirWidgets[i]->dirListEntry))
				 + 2, __LINE__, __FILE__);
			      sprintf (buf, "%s/%s",
				       mwin->DirName,
				       dirName
				       (mwin->dirWidgets[i]->dirListEntry));
			      
			      AddToClipboard (item_id, buf, strlen (buf) + 1);
			      
			      /* get memory free */
			      StrReplace (buf, NULL);
			      cnt ++;
			    }
			}
		    }
		  /* copy selected direcotry form directory tree window */
		  else if (w == mwin->fomTree)
		    {
		      int len, i, cnt;
		      
		      DEBUG1 ("mwinAction: Copy tree");
		      
		      /* Copy to Clipboard */
		      for (i=cnt=0; i<mwin->TreeCount; i++)
			{
			  if (dirTreeCopySelected
			      (mwin->dirTreeWidgets[i]->dirTreeEntry))
			    {
			      AddToClipboard
				(item_id,
				 dirTreePathName
				 (mwin->dirTreeWidgets[i]->dirTreeEntry),
				 strlen 
				 (dirTreePathName
				  (mwin->dirTreeWidgets[i]->dirTreeEntry))
				 + 1);
			      
			      /* it's only one entry */
			      break;
			    }
			}
		    }
		  
		  DEBUG1 ("mwinAction: Close Clipboard");
		  
		  CloseClipboard (item_id);
		  CopiedToClippboard = True;
		}
	      
	      DEBUG1 ("mwinAction: MOTION_COPY");
	      
	      /* Execute Can Copy Program */
	      ret = mwinRunWindowProg (False);
	      
	      if (ret == ACTION_DEL)
		SetCursor (mwin->shlMainwin, CURSOR_DELETE);
	      else if (ret == ACTION_COPY)
		SetCursor (mwin->shlMainwin, CURSOR_CAN_COPY);
	      else if (ret == ACTION_MOVE)
		SetCursor (mwin->shlMainwin, CURSOR_MOVE);
	      else if (ret == ACTION_PROP)
		SetCursor (mwin->shlMainwin, CURSOR_PROP);
	      else if (ret == ACTION_EDIT)
		SetCursor (mwin->shlMainwin, CURSOR_EDIT);
	      else
		SetCursor (mwin->shlMainwin, CURSOR_RONG);
	      
	      break;
	    }

	  /* no motions */
	  if (Action->MotionProc == NULL)
	    break;
	  
	  /* delete old Rectanlge */
	  if (! (MotionType & MOTION_COPY))
	    SEL_REGION(mwin->bg);
	  
	  /* get all motions to reduce process time */
	  mwin->btnReleaseX = event->xmotion.x;
	  mwin->btnReleaseY = event->xmotion.y;
	  while (XCheckMaskEvent (display, ButtonMotionMask, &tmpEvent))
	    {
	      mwin->btnReleaseX = tmpEvent.xmotion.x;
	      mwin->btnReleaseY = tmpEvent.xmotion.y;
	    }
	  
	  DEBUG4 ("mwinAction: Motion[%s] x=%i y=%i\n",
		  w == mwin->fomFiles ? "Files" : "Tree",
		  mwin->btnReleaseX,
		  mwin->btnReleaseY);
	  
	  if (Action->MotionProc != NULL)
	    Action->MotionProc (mwin, event);
	  
	  DEBUG1 ("mwinAction: After MotionProc");
	  
	  /* draw a new Rectanlge (after selection) */
	  if (! (MotionType & MOTION_COPY))
	    SEL_REGION (mwin->fg);
	}
      break;

    case REASON_KEYMAP:
      DEBUG1 ("mwinAction: Keymap");
      break;

    case REASON_COPY_MOTION:
      DEBUG1 ("mwinAction: Motion Copy");
      break;

    default:
      DEBUG3 ("unknown reason (%i), type (%i)\n",
	      cbs->reason,
	      event->type);
      break;
    }

  DEBUG1 ("mwinAction: end");

  return True;
}

