/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: mwinMake.c,v 1.1 1996/10/28 03:36:32 khamis Exp khamis $
 * $Source: /home/xkhfm/xkhlib/xkhsrc/RCS/mwinMake.c,v $
 */
#define IS_EXTERN
#define EXTERN		extern

#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>
#include "Xinc.h"

#include "defines.h"
#include "Umem.h"
#include "mainwin.h"
#include "window.h"

char * fonts [] =
{
#if 0
  "*defualt*fontlist*",
  "-*defualt*fontlist*",
  "-*",
  "-*-*",
  "-*-*-*-",
#endif
  "-*-lucida-medium-r-*-*-12-*-*-*-*-*-*-*",
  "-*-lucida-medium-r-*-*-*-*-*-*-*-*-*-*",
  "-*-helvetica-medium-r-*-*-*-*-*-*-*-*-*-*",
  "-*-helvetica-medium-r-*-*-12-*-*-*-*-*-*-*",
  "-*-helvetica-medium-r-*-*-*-*-*-*-*-*-*-*",
  "-*-helvetica-medium-r-*-*-11-*-*-*-*-*-*-*",
  "7x14",
  "6x13",
  "fixed",
  NULL
};

Mainwin_t mwinMake (void)
{
  XGCValues GCValues;
  Mainwin_t mwin;
  int i;

  DEBUG1 ("mwinMake: Strukturen vorbereiten");

  /****** Struktur erstellen **************************************************/
  mwin = gcalloc (sizeof (mainwin_t), __LINE__, __FILE__);

  mwin->ViewMode	  = VIEW_LRG_ICONS;
  mwin->Style             = VIEW_STYLE_VERT;
  mwin->pixmList          = pxmList;
  mwin->dimFilesHeight    = DefaultViewHeight;
  mwin->dimFilesWidth     = DefaultViewWidth;
  mwin->PixmWidth	  = DefaultPixmWidth;
  mwin->PixmHeight	  = DefaultPixmHeight;
  mwin->NameHeight	  = DefaultNameHeight;
  mwin->SpaceBetweenIcons = DefaultSpaceBetweenIcons;
  mwin->PixmBoxWidth      = mwin->PixmWidth  + mwin->SpaceBetweenIcons;
  mwin->PixmBoxHeight     = (mwin->PixmHeight
			     + mwin->NameHeight
			     + mwin->SpaceBetweenIcons);
  mwin->PixmXBegin	  = 5;
  mwin->PixmYBegin	  = 5;

  mwin->PixmTreeX	  = 5;
  mwin->PixmTreeY	  = 5;
  mwin->PixmTreeHeight    = 16;
  mwin->PixmTreeIconWidth = 16;

  mwin->BeginSortingAt	  = 0;	/* ignore "." and ".." */
  mwin->DirFirst	  = True;	/* default: directories first */
  mwin->SortMethode	  = SORT_NAME;	/* default: sorting by names */
  mwin->Descending	  = False;	/* default: ascending */
  mwin->TreeViewX	  = 0;
  mwin->FilesViewX	  = 0;

  /****** read current directory **********************************************/
  if (! getcwd (mwin->DirName, MAXPATHLEN))
    strcpy (mwin->DirName, ".");
  strcpy (ConfigDir, mwin->DirName);

  mwin->DirFilter = StrReplace (mwin->DirFilter, "*");

  /* initial directory list */
  mwin->dirEntry = dirAdd (NULL, "TOP");
  mwin->dirTree  = dirTreeAdd (NULL, "TOP");

#if 1
  for (i=0; fonts[i] != NULL; i++)
    {
      mwin->fntMainwin = XLoadQueryFont (display, fonts[i]);
      if (mwin->fntMainwin != NULL)
	{
	  DEBUG2 ("mwinMake: loading (%s) fontlist\n", fonts[i]);
	  break;
	}      
    }  
#else
  memset (&GCValues, 0, sizeof (GCValues));
  XGetGCValues (display, theGC, GCFont, &GCValues);
  DEBUG2 ("mwinMake: GC.font = (%i)\n", GCValues.font);
  mwin->fntMainwin = XQueryFont (display, GCValues.font);
#endif
  if (mwin->fntMainwin == NULL)
    {
      ERROR1 ("mwinMake: cannot load fontlist");
      exit (1);
    }
  
#if 0
  /* read directory contents */
  mwinReadDir (mwin);
#endif

  /****************************************************************************/
  DEBUG1 ("mwinMake: ende");

  return mwin;
}

int mwinDest (Mainwin_t mwin)
{
  int i;

  if (mwin == NULL)
    return False;

  /* free the allocated memory */
  if (mwin->Remove != NULL && winGetListFromObj (mwin->Remove) != NULL && ! winListDel (winGetListFromObj (mwin->Remove)))
    return False;
  else
    mwin->Remove = NULL;
  if (mwin->Copy   != NULL && winGetListFromObj (mwin->Copy) != NULL && ! winListDel (winGetListFromObj (mwin->Copy)))
    return False;
  else
    mwin->Copy = NULL;
  if (mwin->Prop   != NULL && winGetListFromObj (mwin->Prop) != NULL &&! winListDel (winGetListFromObj (mwin->Prop)))
    return False;
  else
    mwin->Prop = NULL;
  if (mwin->MkDir  != NULL && winGetListFromObj (mwin->MkDir) != NULL && ! winListDel (winGetListFromObj (mwin->MkDir)))
    return False;
  else
    mwin->MkDir = NULL;
  if (mwin->Find   != NULL && winGetListFromObj (mwin->Find) != NULL && ! winListDel (winGetListFromObj (mwin->Find)))
    return False;
  else
    mwin->Find = NULL;
  
  /* Remove Time Callback First */
  XtRemoveTimeOut (mwin->IntervalId);

  txtDest (mwin->txtComm);

  if (mwin->shlMainwin != NULL)
    XtDestroyWidget (mwin->shlMainwin);

  /* delete file list structures */
  mwinFilesDest (mwin);
  
  /* delete file lists */
  dirDelete (mwin->dirEntry);
  
  /* delete file tree structures */
  mwinTreeDest (mwin, False);
  dirTreeRemove (mwin->dirTree);

  StrReplace (mwin->DirFilter, NULL);
  MFree      (mwin, sizeof (mainwin_t));

  DEBUG1 ("mwinDest: ende");

  return True;
}

int mwinSubWindows (Mainwin_t mwin)
{
  if (mwin->Remove != NULL && winGetListFromObj (mwin->Remove) == NULL)
    mwin->Remove = NULL;
  
  if (mwin->Copy   != NULL && winGetListFromObj (mwin->Copy) == NULL)
    mwin->Copy = NULL;
  
  if (mwin->Prop   != NULL && winGetListFromObj (mwin->Prop) == NULL)
    mwin->Prop = NULL;
  
  if (mwin->MkDir  != NULL && winGetListFromObj (mwin->MkDir) == NULL)
    mwin->MkDir = NULL;
  
  if (mwin->Find   != NULL && winGetListFromObj (mwin->Find) == NULL)
    mwin->Find = NULL;
  
  return True;
}

char * mwinName (Mainwin_t mwin)
{
  return mwin->DirName;
}

Widget mwinShell (Mainwin_t mwin)
{
  return mwin->shlMainwin;
}


