/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: mwinOpen.c,v 1.1 1997/01/07 08:38:27 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/xkhlib/xkhsrc/RCS/mwinOpen.c,v $
 */
#define IS_EXTERN
#define EXTERN		extern

#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>
#include "Xinc.h"

#include "defines.h"
#include "Umem.h"
#include "Urcnfvoid.h"
#include "Ureadarg.h"
#include "Ufileutil.h"
#include "Ustrutil.h"
#include "Ucnfutil.h"
#include "Umessage.h"
#include "mainwin.h"

void mwinOpLine (char *, Mainwin_t);
void OpenParamFile (Widget,
		    Mainwin_t,
		    XmFileSelectionBoxCallbackStruct *);

void mwinOpen (Mainwin_t mwin)
{
  Dchain_t dir;
  int found = False;

  /* edit all selected files */
  for (dir = UdchNext (mwin->dirEntry);
       dir != NULL;
       dir = UdchNext (dir))
    {
      if (! dirSelected (dir))
	continue;
      
      if (dirType (dir) != TYPE_REG &&
	  dirType (dir) != TYPE_EXE &&
	  dirType (dir) != TYPE_LNK)
	continue;

      found = True;
      /* edit files only */
      cmdExecCmd (mwin->DirName, dirName (dir), EXEC_EDIT);
    }

  if (!found)
    MessageBox (mwin->shlMainwin,
		"open",
		"no files are selected",
		XmDIALOG_INFORMATION,
		OK_BUTTON,
		NULL, NULL);

#if 0
  FileOperation (mwin->shlMainwin,
		 /* OK Programm ****/
		 (void (*) (Widget, void *))  OpenParamFile,
		 NULL,				     /* Cancel Programm *******/
		 mwin,				     /* client data ***********/
		 "*",				     /* Filter ****************/
		 DIR_OPEN,			     /* Operation *************/
		 FILE_MUST_EXIST);		     /* Datei muss existieren */
#endif
}

#if 0
void OpenParamFile (Widget w,
		    Mainwin_t mwin,
		    XmFileSelectionBoxCallbackStruct * cbs)
{
  Dchain_t mod, cnf;
  char * line;
  char * pStr;
  char dirname  [MAXPATHLEN];
  char filename [MAXPATHLEN];
  char tmp      [MAXPATHLEN+32];
  char systemfile [MAXPATHLEN];

  DEBUG1 ("OpenParamFile: Anfang");
  
  /****** Das Laender-Teil aus dem File ausschneiden **************************/
  if (! XmStringGetLtoR (cbs->value, XmSTRING_DEFAULT_CHARSET, &pStr))
    {
      ERROR1 ("Dateiname falsch");
      return;
    }

  /****** um an jeder Stelle in der Prozedur abbrechen zu koennen *************/
  strcpy (dirname, pStr);
  XtFree (pStr);

  /****** Fehler beim Auswerten ***********************************************/
  if (!*dirname)
    {
      ErrorBox (mwin->winMainwin, "Oeffnen", "Keine Datei selektiert");
      return;
    }

  /****** Ueberpruefen, ob der selektierte Pfad gueltig ist *******************/
  /****** Ein Verzeichnis muss Lese- bzw. Ausfuehrrechte haben ****************/
  if (! UFileCanRead (dirname) ||		/* Lese Rechte ****************/
      ! UFileCanExec (dirname) ||		/* Ausfuehrrechte *************/
      ! UFileIsDir   (dirname))
    {
      ErrorBox (mwin->winMainwin,
		dirname,
		"Selektiertes Verzeichnis oder Datenbank ist nicht vorhanden "
		"oder es sind keine Leserechte vorhanden");
      return;
    }

  /****************************************************************************/
  /****** Die system.cnf Datei einlesen ***************************************/
  strcpy (filename, UPathAppend (dirname, SYSTEM_CNF));
  if (! UFileExists (filename))
    {
      ErrorBox (mwin->shlMainwin,
		filename,
		"Die Datei wurde nicht gefunden, ohne diese "
		"Datei koennen keine Konfigurationen eingelesen werden");
      return;
    }

  /****** Dialogfenster destroyen *********************************************/
  XtDestroyWidget (w);

  DEBUG1 ("OpenParamFile: Ende des Lesevorgangs");
}
#endif
