/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: mwinSaveAs.c,v 1.1 1997/01/07 08:38:27 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/xkhlib/xkhsrc/RCS/mwinSaveAs.c,v $
 */
#define IS_EXTERN
#define EXTERN		extern

#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>
#include "Xinc.h"

#include "defines.h"
#include "Umem.h"
#include "Uxutil.h"
#include "Umessage.h"
#include "Umenu.h"
#include "Urcnfvoid.h"
#include "Ureadarg.h"
#include "Ufileutil.h"
#include "Ustrutil.h"
#include "Ucnfutil.h"
#include "about.h"
#include "quit.h"
#include "mainwin.h"

void SaveAsOkCB     (Widget w, Mainwin_t, XmFileSelectionBoxCallbackStruct *);
void SaveAsCancelCB (Widget w, Mainwin_t);

/******************************************************************************/
/* Arbeit unter einem anderen Namen speichern				      */
/******************************************************************************/
int mwinSaveAs (Mainwin_t mwin)
{
  DEBUG2 ("FileSaveAs: (%s)\n", mwin->DirName);

#if 0
  FileOperation (mwin->winMainwin,
		 (void (*) (Widget, void*)) SaveAsOkCB,
		 (void (*) (Widget, void*)) SaveAsCancelCB,
		 mwin,
		 "*",
		 DIR_SAVEAS,
		 False);
#endif
  return True;
}

#if 0
/******************************************************************************/
/* Callbacks fuer die Buttons der DialogBox                                   */
/******************************************************************************/

/******************************************************************************/
/* Datei speichern unter einem anderen Namen				      */
/******************************************************************************/
void SaveAsOkCB (Widget w, Mainwin_t mwin,
		 XmFileSelectionBoxCallbackStruct * cbs)
{
  char * dirname;
  char filename [MAXPATHLEN];
  char tmp      [MAXPATHLEN+32];
  
  /****** Das Laender-Teil aus dem File ausschneiden **************************/
  if (! XmStringGetLtoR (cbs->value, XmSTRING_DEFAULT_CHARSET, &dirname))
    {
      ERROR1 ("SaveAsOkCB: Verzeichnisname falsch");
    }

  /****** Fehler beim Auswerten ***********************************************/
  if (!*dirname)
    {
      ERROR1 ("SaveAsOkCB: Kein Verzeichnis selektiert");
      XtFree (dirname);
      return;
    }

  /****** Falls Verzeichnis existiert, dann abbrechen *************************/
  if (UFileExists (dirname))
    {
      MessageBox (mwin->winMainwin,
		  "Speichern als ..",
		  "Verzeichnis ist bereits vorhanden, "
		  "Dateien koennen nicht unter diesem Verzeichnis gespeichert "
		  "werden !",
		  XmDIALOG_QUESTION,
		  OK_BUTTON|CANCEL_BUTTON|HELP_BUTTON,
		  NULL,
		  NULL);
      return;
    }

  /****** Verzeichnis anlegen *************************************************/
  if (! UFileExists (dirname))
    {
      if (mkdir (dirname, UGetUmask (False)) != 0)
	{
	  MessageBox (mwin->winMainwin,
		      "Verzeichnis anlegen",
		      "Verzeichnis kann nicht erstellt werden, "
		      "wahrscheinlich keine Rechte oder Pfad falsch angegeben",
		      XmDIALOG_ERROR,
		      OK_BUTTON|CANCEL_BUTTON|HELP_BUTTON,
		      NULL,
		      NULL);
	  return;
	}
    }

  /****** Neues Verzeichnis bekannt geben: ************************************/
  strcpy (mwin->DirName, dirname);	/* interne Struktur *******************/
  strcpy (ConfigDir, dirname);		/* globale variable *******************/
  mwinTitle (mwin);		/* Titel auf den neuen Namen akt.    **/

  /****** Falls gespeichert, dann Dialogfenster loeschen, ansonsten warten ****/
  if (mwinSave (mwin))
    XtDestroyWidget (w);

  XtFree (dirname);
}

/******************************************************************************/
/* Das Cancel Dialog im DialogFenster wird betaetigt, dann diese Prozedur *****/
/* aufrufen								      */
/******************************************************************************/
void SaveAsCancelCB (Widget w, Mainwin_t mwin)
{
  XtDestroyWidget (w);
}
#endif

