/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: mwinView.c,v 1.4 1996/12/31 01:37:44 khamis Exp khamis $
 * $Source: /usr2/xkhfm/xkhlib/xkhsrc/RCS/mwinView.c,v $
 */
#define IS_EXTERN
#define EXTERN		extern

#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>
#include <string.h>
#include <fcntl.h>
#include "Xinc.h"
#include <X11/Xaw/Paned.h>
#include <Xm/DrawingA.h>
#include <Xm/ScrollBar.h>
#include <Xm/Command.h>

#include "defines.h"
#include "Umem.h"
#include "Uxutil.h"
#include "Umessage.h"
#include "Umenu.h"
#include "Urcnfvoid.h"
#include "Ureadarg.h"
#include "Ufileutil.h"
#include "Ustrutil.h"
#include "about.h"
#include "quit.h"
#include "help.h"
#include "xmisc.h"
#include "window.h"
#include "mainwin.h"

#undef USE_ROWCOL
#undef VIEW_EXEC_LINE

#ifdef Solaries
#define HAVE_FONTLIST_ENTRY_GET_FONT
#endif

#define REFRESH_TIMEOUT	3000

int clrView (void);
void clrViewCB   (Widget w, Mainwin_t mwin)
{
  int ww = 0;
  XtVaGetValues (mwin->shlMainwin,
		 XmNborderWidth, &ww,
		 NULL);
  DEBUG4 ("clrView: shellx(%$i), winx(%i), borderw(%i)\n",
	  wdgX (mwin->shlMainwin),
	  wdgX (mwin->winMainwin),
	  ww);
  clrView ();
}

int WatchCursor (Widget w);
void curViewCB   (Widget w, Mainwin_t mwin)
{
  WatchCursor (mwin->shlMainwin);
}
int mwinViewSelectedIcon (Mainwin_t mwin);
int scrSetValues (Widget w, long * XorY, long size, long wSize, int stip);

void mwinHelpCB   (Widget w, Mainwin_t mwin);
void mwinQuitCB   (Widget w, Mainwin_t mwin);
void mwinExitCB   (void);
void mwinRecursiveCB (Widget w, Mainwin_t mwin);
void mwinRefreshCB (Widget w, Mainwin_t mwin);

void mwinHelpCB (Widget w, Mainwin_t mwin)
{
  hlpView (HelpWindow, MWIN_HELP);
}

int mwinQuit (Mainwin_t mwin)
{
  int ret = False;
  if (winListCount (winList, WIN_REGULAR) == 1)
    MessageBox (mwin->shlMainwin,
		"Exit",
		"Closing the last window will exit the program, \n"
		"really you want to close this window",
		XmDIALOG_QUESTION,
		OK_BUTTON|CANCEL_BUTTON,
		mwinExitCB,
		NULL);
  else
    {
      Dchain_t win;
      WindowList_t winL;
      Widget shell;
      /* if the topshell deleted, define it to next avail. */
      win   = winListFind (winList, mwin);
      shell = winGetShellFromList (win);
      if (win != NULL)
	{
	  ret = winListDel (win);
	  if (topShell == shell)
	    topShell =
	      winGetShellFromList(winListFindFirst (winList, WIN_REGULAR));
	}
    }
  return ret;
}

void mwinQuitCB (Widget w, Mainwin_t mwin)
{
  mwinQuit (mwin);
}

void mwinExitCB   (void)
{
  Dchain_t win;
  int i;

  /* save current setup */
  mwinSaveSetup();

  /* lock if any window is locked by a client process (copy, remove, ..) */
  for (win=UdchNext (winList);
       win != NULL;
       win=UdchNext (winList))
    {
      int ret = winListDel (win);
      if (! ret)
	return;
    }
  winListDel (winList);

  if (CommandFile != NULL)
    remove (CommandFile);

  hlpDest       (HelpWindow);
  StrReplace    (EditCommand, NULL);
  StrReplace    (XtermCommand, NULL);
  cmdListRemove (cmdList);

  assDest       (assWindow);
  assListRemove (assList);
  assDest       (iconExtensionWindow);
  assListRemove (iconExtensionList);

  grpRemove     (GrpList);
  usrRemove     (UserList);
  for (i=0; i<HIST_MAX_ITEMS; i++)
    StrReplace (histList[i], NULL);

#ifdef DEBUG_VIEWMEM
  /* view not freed memory */
  memNotFreed();
#endif

  exit (0);
}

int NotImplemented (Widget shell)
{
  MessageBox (shell,
	      "xkhfm",
	      "Program not yet implemented",
	      XmDIALOG_INFORMATION,
	      OK_BUTTON,
	      NULL, NULL);
  return True;
}

#define DIR_FIRST(w) if (mwin->DirFirstWidget != NULL) \
XtSetSensitive (mwin->DirFirstWidget, True); \
XtSetSensitive (w, False); \
mwin->DirFirstWidget = w;

#define ASC_DESC(w) if (mwin->AscendingWidget != NULL) \
XtSetSensitive (mwin->AscendingWidget, True); \
XtSetSensitive (w, False); \
mwin->AscendingWidget = w;

/* sorting criteties */
void mwinSortDirFirstCB (Widget w, Mainwin_t mwin)
{
  mwin->DirFirst = True;		/* toggle directories first */
  mwinSort        (mwin, mwin->SortMethode);
  DIR_FIRST	  (w);
  mwinRedraw      (mwin, True);
}
void mwinSortNoDirFirstCB (Widget w, Mainwin_t mwin)
{
  mwin->DirFirst = False;	/* toggle directories first */
  mwinSort        (mwin, mwin->SortMethode);
  DIR_FIRST	  (w);
  mwinRedraw      (mwin, True);
}
void mwinSortAscendingCB (Widget w, Mainwin_t mwin)
{
  mwin->Descending = False;              /* toggle ascending descending */
  mwinSort        (mwin, mwin->SortMethode);
  ASC_DESC	  (w);
  mwinRedraw      (mwin, True);
}
void mwinSortDescendingCB (Widget w, Mainwin_t mwin)
{
  mwin->Descending = True; /* toggle ascending descending */
  mwinSort        (mwin, mwin->SortMethode);
  ASC_DESC	  (w);
  mwinRedraw      (mwin, True);
}
void mwinSortNameCB (Widget w, Mainwin_t mwin)
{
  mwinSort   (mwin, SORT_NAME);
  mwinCurrentSort (mwin, w);
  mwinRedraw (mwin, True);
}
void mwinSortSizeCB (Widget w, Mainwin_t mwin)
{
  mwinSort   (mwin, SORT_SIZE);
  mwinCurrentSort (mwin, w);
  mwinRedraw (mwin, True);
}
void mwinSortModTimeCB (Widget w, Mainwin_t mwin)
{
  mwinSort   (mwin, SORT_MOD_TIME);
  mwinCurrentSort (mwin, w);
  mwinRedraw (mwin, True);
}
void mwinSortCreateTimeCB (Widget w, Mainwin_t mwin)
{
  mwinSort   (mwin, SORT_CREATE_TIME);
  mwinCurrentSort (mwin, w);
  mwinRedraw (mwin, True);
}
void mwinSortAccessTimeCB (Widget w, Mainwin_t mwin)
{
  mwinSort   (mwin, SORT_ACCESS_TIME);
  mwinCurrentSort (mwin, w);
  mwinRedraw (mwin, True);
}
void mwinSortUserIdCB (Widget w, Mainwin_t mwin)
{
  mwinSort   (mwin, SORT_USER_ID);
  mwinCurrentSort (mwin, w);
  mwinRedraw (mwin, True);
}
void mwinSortGrpIdCB (Widget w, Mainwin_t mwin)
{
  mwinSort   (mwin, SORT_GRP_ID);
  mwinCurrentSort (mwin, w);
  mwinRedraw (mwin, True);
}
void mwinSortUserNameCB (Widget w, Mainwin_t mwin)
{
  mwinSort   (mwin, SORT_USER_NAME);
  mwinCurrentSort (mwin, w);
  mwinRedraw (mwin, True);
}
void mwinSortGrpNameCB (Widget w, Mainwin_t mwin)
{
  mwinSort   (mwin, SORT_GRP_NAME);
  mwinCurrentSort (mwin, w);
  mwinRedraw (mwin, True);
}
void mwinSortINodeCB (Widget w, Mainwin_t mwin)
{
  mwinSort   (mwin, SORT_INODE);
  mwinCurrentSort (mwin, w);
  mwinRedraw (mwin, True);
}
void mwinSortLinksCB (Widget w, Mainwin_t mwin)
{
  mwinSort   (mwin, SORT_LINKS);
  mwinCurrentSort (mwin, w);
  mwinRedraw (mwin, True);
}
void mwinSortUnsortedCB (Widget w, Mainwin_t mwin)
{
  mwinSort   (mwin, SORT_UNSORTED);
  mwinCurrentSort (mwin, w);
  mwinRedraw (mwin, True);
}

void btnNewWindowCB (Widget w, Mainwin_t mwin)
{
  Dchain_t newWin;
  newWin = winListAdd (winList, "mainwin");
  if (newWin != NULL)
    {
      mwinView (((WindowList_t)UdchClient (newWin))->wins.mainwin);
    }
}

void btnHorizontalCB (Widget w, Mainwin_t mwin)
{
#if 0
  NotImplemented (mwin->shlMainwin);
  return;
#else
  mwinViewStyle (mwin, VIEW_STYLE_HORIZ);
#endif
}

void btnVerticalCB (Widget w, Mainwin_t mwin)
{
#if 0
  NotImplemented (mwin->shlMainwin);
  return;
#else
  mwinViewStyle (mwin, VIEW_STYLE_VERT);
#endif
}

void btnFixedCB (Widget w, Mainwin_t mwin)
{
  mwinViewStyle (mwin, VIEW_STYLE_FIXED);
}

/*#define USE_PIXMAP*/

/******************************************************************************/
/*** Menue-Aufrufe als Callbacks                                            ***/
/******************************************************************************/

/* Die Callback Prozedur fuer Neuerstellung einer Konfiguration ***************/
void mwinNewCB (Widget w, Mainwin_t mwin)
{
  mwinNew (mwin);
}

void mwinOpenCB (Widget w, Mainwin_t mwin)
{
  mwinOpen (mwin);
}

void btnParentCB (Widget w, Mainwin_t mwin)
{
  char newPath [MAXPATHLEN], * p;
  int i;
  
  p = dirTreePathName
    (mwin->dirTreeWidgets[mwin->CurrentTreeNum]->dirTreeEntry);

  if (strcmp (p, "/") == 0)
    return;

  strcpy (newPath, dirname (p));
  mwinChangePathName (mwin, newPath);
}

void btnMwinDelCB (Widget w, Mainwin_t mwin)
{
  mwinDel (mwin, False);
}

void mwinPropCB (Widget w, Mainwin_t mwin)
{
  mwinProp (mwin);
}

void mwinFindCB (Widget w, Mainwin_t mwin)
{
  mwinFind (mwin);
}

void mwinGrepCB (Widget w, Mainwin_t mwin)
{
  NotImplemented (mwin->shlMainwin);
}

void mwinTimeOutCB (Mainwin_t mwin)
{
  int ReadDir = False;

#if 0
  DEBUG2 ("mwinTimeOutCB: (%s)\n", mwin->DirName);
#endif

#if 1  /* we need hier SEMAPHORE CONTROL */

  if (mwin->Locked[0] == 0 && mwin->Locked[1] == 0 && mwin->Locked[2] == 0)
    {
      mwinLock (mwin, 0);
      mwinLock (mwin, 1);

      /* if directory doesn't more exist, get parent ********************/
      for (;! UFileExists (mwin->DirName); )
	{
	  strcpy (mwin->DirName, dirname (mwin->DirName));
	  ReadDir = True;
	}

      /* lock if the modify time changed */
      if (!ReadDir)
	{
	  Dchain_t ndir = dirAdd (NULL, mwin->DirName);
	  dirStat (ndir);
	  /**************************************************************
	  ***** Zeitkritisch, wenn dirPathName von mwinReadDir fuer ein *
	  ***** Moment geloescht wird                                   *
	  ***** Es muss ein Semaphore angewendet werden                 *
	  ***************************************************************/
	  if (dirModTime (mwin->dirPathName) != dirModTime (ndir))
	    ReadDir = True;
	  dirDelete (ndir);
	}
      
      mwinUnLock  (mwin, 0);
      mwinUnLock  (mwin, 1);

      if (ReadDir)
	{
	  BaisyCursor (mwin->shlMainwin);
	
	  mwinReadDir (mwin, mwin->DirName);
	  mwinCalc    (mwin);
	  mwinRedisp  (mwin);
	  
	  dirTreeRefresh
	    (mwin->dirTreeWidgets[mwin->CurrentTreeNum]->dirTreeEntry,
	     False);
	  mwinBuildTree  (mwin, False);
	  mwinTreeRedisp (mwin);
	  mwinDispStatus (mwin);
	  
	  NormalCursor (mwin->shlMainwin);
	}
    }
#endif

  /* add timer to refresh the contintes, when modified */
  mwin->IntervalId =
    XtAppAddTimeOut (app_context, REFRESH_TIMEOUT,
		     (XtTimerCallbackProc) mwinTimeOutCB, mwin);

#if 0
  DEBUG1 ("mwinTimeOutCB: Ende");
#endif
}

int fltrView (Mainwin_t);

void mwinFilterCB (Widget w, Mainwin_t mwin)
{
  fltrView (mwin);
}

void mwinCommandCB (Widget w, Mainwin_t mwin)
{
  BaisyCursor (mwin->shlMainwin);

  /* it's only one command window */
  if (cmdHist == NULL)
    {
      winListAddCmd (winList, "command");
    }
  /* always the same window */
  mwin->Command = cmdHist;

  if (mwin->Command != NULL)
    {
      mwin->Command->Pwd = StrReplace (mwin->Command->Pwd, mwin->DirName);
      cmdView (mwin->shlMainwin, mwin->Command);
    }
  NormalCursor (mwin->shlMainwin);
}

void btnExecBackgrndCB (Widget w, Mainwin_t mwin)
{
  char * Cmd;

  Cmd = XmTextGetString (mwin->txtComm->txtText);

  if (Cmd == NULL) return;

  cmdExecCmd (dirTreePathName
	       (mwin->dirTreeWidgets[mwin->CurrentTreeNum]->dirTreeEntry),
	       Cmd, EXEC_BACKGROUND);
  cmdAddToList (mwin->Command, Cmd);
  XtFree (Cmd);
}

void btnExecXtermCB (Widget w, Mainwin_t mwin)
{
  char * Cmd;

  Cmd = XmTextGetString (mwin->txtComm->txtText);

  if (Cmd == NULL) return;

  cmdExecCmd (mwin->DirName, Cmd, EXEC_IN_XTERM);
  cmdAddToList (mwin->Command, Cmd);
  XtFree (Cmd);
}

void mwinMkdirCB (Widget w, Mainwin_t mwin)
{
  mwinMkDir (mwin);
}

void btnCopyCB (Widget w, Mainwin_t mwin)
{
  mwinCopyMove (mwin, False);
}

void btnLinkCB (Widget w, Mainwin_t mwin)
{
  NotImplemented (mwin->shlMainwin);
}

void btnMoveCB (Widget w, Mainwin_t mwin)
{
  mwinCopyMove (mwin, True);
}

void mwinViewLrgIconsCB (Widget w, Mainwin_t mwin)
{
  mwin->ViewMode = VIEW_LRG_ICONS;
  mwinCalc   (mwin);
  mwin->FilesClearIcons = True;
  mwinRedisp (mwin);
}

void mwinViewSmlIconsCB (Widget w, Mainwin_t mwin)
{
  mwin->ViewMode = VIEW_SML_ICONS;
  mwinCalc   (mwin);
  mwin->FilesClearIcons = True;
  mwinRedisp (mwin);
}

void mwinViewDetailsCB (Widget w, Mainwin_t mwin)
{
  mwin->ViewMode = VIEW_DETAILS;
  mwinCalc   (mwin);
  mwin->FilesClearIcons = True;
  mwinRedisp (mwin);
}

void mwinSelectSomeCB (Widget w, Mainwin_t mwin)
{
  slctView (mwin);
}

void mwinSelectAllCB (Widget w, Mainwin_t mwin)
{
  Dchain_t dir;
  for (mwin->SelectedIcons = 0,
       dir=UdchNext (mwin->dirEntry);
       dir!=NULL;
       dir=UdchNext (dir))
    {
      dirSelect (dir, True);
      mwin->SelectedIcons ++;
    }
  mwinRedisp (mwin);
  mwinDispStatus (mwin);
}

void mwinUnSelectAllCB (Widget w, Mainwin_t mwin)
{
  Dchain_t dir;
  for (dir=UdchNext (mwin->dirEntry);
       dir!=NULL;
       dir=UdchNext (dir))
    {
      dirSelect (dir, False);
    }
  mwin->SelectedIcons = 0;
  mwinRedisp (mwin);
  mwinDispStatus (mwin);
}

int mwinOwnSelection (Mainwin_t mwin);

void mwinCopySelectionCB (Widget w, Mainwin_t mwin)
{
  mwinOwnSelection (mwin);
}

void mwinAssociateCB (Widget w, Mainwin_t mwin)
{
  assView (&assWindow, &assList);
}

void mwinIconExtensionCB (Widget w, Mainwin_t mwin)
{
  assView (&iconExtensionWindow, &iconExtensionList);
}

void mwinToolbarCB (Widget w, Mainwin_t mwin)
{
  BaisyCursor (mwin->shlMainwin);
  tbarView (toolbarWindow);
  NormalCursor (mwin->shlMainwin);
}

void mwinViewToolbarCB (Widget w, Mainwin_t mwin)
{
  BaisyCursor (mwin->shlMainwin);
  tbarViewToolbar ();
  NormalCursor (mwin->shlMainwin);
}

void mwinSaveOptionsCB (Widget w, Mainwin_t mwin)
{
  mwinSaveSetup();
}

/********* Menue-Struktur fuer das hauptfenster **/
static menuitem_t itemFile [] =
{
  { (void(*)(Widget,void*)) mwinNewCB,    "New", True, NULL },
  { (void(*)(Widget,void*)) mwinMkdirCB,  "New Directory", True, NULL},
  { NULL, MENU_SEPARATOR, False, NULL},
  { (void(*)(Widget,void*)) mwinOpenCB,   "Open", True, NULL},
#if 0
  { NULL, MENU_SEPARATOR, False, NULL},
  { (void(*)(Widget,void*)) SaveFileCB,   "Save", True, NULL},
  { (void(*)(Widget,void*)) SaveAsFileCB, "Save as", True, NULL},
#endif
  { NULL, MENU_SEPARATOR, False, NULL},
  { (void(*)(Widget,void*))mwinFindCB,     "Find", True, NULL},
  { (void(*)(Widget,void*)) mwinCommandCB, "Program Starter", True, NULL},
  { NULL, MENU_SEPARATOR, False, NULL},
  { (void(*)(Widget,void*))mwinQuitCB,     "Close", True, NULL},
  { (void(*)(Widget,void*))mwinExitCB,     "Exit", True, NULL},
  { NULL, NULL}
};

static menuitem_t itemEdit [] =
{
  { (void(*)(Widget,void*)) btnCopyCB, "Copy", True, NULL },
  { (void(*)(Widget,void*)) btnMoveCB, "Move", True, NULL },
  { (void(*)(Widget,void*)) btnLinkCB, "Link", True, NULL },
  { (void(*)(Widget,void*)) btnMwinDelCB,  "Delete", True, NULL },
  { NULL, MENU_SEPARATOR, False, NULL},
  { (void(*)(Widget,void*)) mwinSelectAllCB,   "Select All",   True, NULL },
  { (void(*)(Widget,void*)) mwinSelectSomeCB,  "Select Some", True, NULL },
  { (void(*)(Widget,void*)) mwinUnSelectAllCB, "Unselect All", True, NULL },
  { (void(*)(Widget,void*)) mwinCopySelectionCB, "Copy Selected to clipboard", True, NULL },
  { NULL, MENU_SEPARATOR, False, NULL},
  { (void (*) (Widget, void *)) mwinPropCB, "Properities",   True, NULL },
  { NULL, NULL}
};

static menuitem_t itemView [] = 
{
  /* Tree commands */
  { (void(*)(Widget,void*)) mwinRecursiveCB, "Show All Levels", True, NULL},
  { NULL, MENU_SEPARATOR, False, NULL},

  /* Viewing commands */
  { (void(*)(Widget,void *)) mwinViewLrgIconsCB, "Large Icons", True, NULL },
  { (void(*)(Widget,void *)) mwinViewSmlIconsCB, "Smale Icons", True, NULL },
  { (void(*)(Widget,void *)) mwinViewDetailsCB,  "Details",     True, NULL },
  { NULL, MENU_SEPARATOR, False, NULL},
  { (void(*)(Widget,void*)) mwinFilterCB, "Filter", True, NULL},
  { (void(*)(Widget,void*)) mwinRefreshCB, "Refresh", True, NULL},
  { NULL, MENU_SEPARATOR, False, NULL},
  { (void(*)(Widget,void*)) mwinViewToolbarCB, "Toolbar on/off", True, NULL},
  
  { NULL, NULL}
};

static menuitem_t itemSort [] = 
{
  /* Sorting commands */
  { (void(*)(Widget,void*)) mwinSortDirFirstCB, "Directories first", True, NULL},
  { (void(*)(Widget,void*)) mwinSortNoDirFirstCB, "Directories first off", True, NULL},
  { NULL, MENU_SEPARATOR, False, NULL},

  { (void(*)(Widget,void*)) mwinSortAscendingCB,  "Ascending", True, NULL},
  { (void(*)(Widget,void*)) mwinSortDescendingCB, "Descending", True, NULL},

#if 0
  { NULL, MENU_RULE, False, NULL},
#else
  { NULL, MENU_SEPARATOR, False, NULL},
#endif
  { (void(*)(Widget,void*)) mwinSortNameCB, "Name", True, NULL },
  { (void(*)(Widget,void*)) mwinSortSizeCB, "Size", True, NULL },
  { (void(*)(Widget,void*)) mwinSortModTimeCB, "Modify Time", True, NULL },
  { (void(*)(Widget,void*)) mwinSortCreateTimeCB, "Create Time", True, NULL },
  { (void(*)(Widget,void*)) mwinSortAccessTimeCB, "Access Time", True, NULL },
  { (void(*)(Widget,void*)) mwinSortUserIdCB, "User ID", True, NULL },
  { (void(*)(Widget,void*)) mwinSortGrpIdCB, "Group ID", True, NULL },
  { (void(*)(Widget,void*)) mwinSortUserNameCB, "User Name", True, NULL },
  { (void(*)(Widget,void*)) mwinSortGrpNameCB, "Group Name", True, NULL },
  { (void(*)(Widget,void*)) mwinSortINodeCB, "I-Node", True, NULL },
  { (void(*)(Widget,void*)) mwinSortLinksCB, "Links", True, NULL },
  { (void(*)(Widget,void*)) mwinSortUnsortedCB, "unsorted",    True, NULL },

  { NULL, NULL}
};

static menuitem_t itemMisc [] =
{
  { (void(*)(Widget,void*))mwinAssociateCB, "Association list", True, NULL},
  { (void(*)(Widget,void*))mwinIconExtensionCB, "Icon extensions to automaticaly display there Pixmaps", True, NULL},
  { (void(*)(Widget,void*))mwinToolbarCB,   "Toolbar", True, NULL},
#ifdef VIEW_MISC
  { (void(*)(Widget,void*)) clrViewCB, "ColorList", True, NULL},
  { (void(*)(Widget,void*)) curViewCB, "Cursor Viewing Modes", True, NULL},
#endif
  { NULL, MENU_SEPARATOR, False, NULL},
  { (void(*)(Widget,void*))mwinSaveOptionsCB, "Save Options", True, NULL},
  { NULL, NULL}
};

/* Working Direcotry History submenu */
void histPwdCB   (Widget w, Mainwin_t mwin);

static menuitem_t itemHist [] =
{
  { (void(*)(Widget,void*)) histPwdCB, "(Empty)", True, NULL},
  { (void(*)(Widget,void*)) histPwdCB, "(Empty)", True, NULL},
  { (void(*)(Widget,void*)) histPwdCB, "(Empty)", True, NULL},
  { (void(*)(Widget,void*)) histPwdCB, "(Empty)", True, NULL},
  { (void(*)(Widget,void*)) histPwdCB, "(Empty)", True, NULL},
  { (void(*)(Widget,void*)) histPwdCB, "(Empty)", True, NULL},
  { (void(*)(Widget,void*)) histPwdCB, "(Empty)", True, NULL},
  { (void(*)(Widget,void*)) histPwdCB, "(Empty)", True, NULL},
  { (void(*)(Widget,void*)) histPwdCB, "(Empty)", True, NULL},
  { (void(*)(Widget,void*)) histPwdCB, "(Empty)", True, NULL},
  { (void(*)(Widget,void*)) histPwdCB, "(Empty)", True, NULL},
  { (void(*)(Widget,void*)) histPwdCB, "(Empty)", True, NULL},
  { (void(*)(Widget,void*)) histPwdCB, "(Empty)", True, NULL},
  { (void(*)(Widget,void*)) histPwdCB, "(Empty)", True, NULL},
  { (void(*)(Widget,void*)) histPwdCB, "(Empty)", True, NULL},
  { (void(*)(Widget,void*)) histPwdCB, "(Empty)", True, NULL},
  { (void(*)(Widget,void*)) histPwdCB, "(Empty)", True, NULL},
  { (void(*)(Widget,void*)) histPwdCB, "(Empty)", True, NULL},
  { (void(*)(Widget,void*)) histPwdCB, "(Empty)", True, NULL},
  { (void(*)(Widget,void*)) histPwdCB, "(Empty)", True, NULL},
  { NULL, MENU_SEPARATOR, False, NULL},
  { (void (*) (Widget, void*)) histPwdCB, "Home", True, NULL},
  { NULL, NULL}
};

static menuitem_t itemHelp [] = 
{
  { (void(*)(Widget,void*)) mwinHelpCB, "Main window", True,  NULL},
#ifdef DEBUG_VIEWMEM
  { NULL, MENU_SEPARATOR, False, NULL},
  { (void(*)(Widget,void*))ViewMemUsage, "Memory usage", True, NULL},
#endif
  { NULL, MENU_SEPARATOR, False, NULL},
  { (void(*)(Widget,void*))AboutProduct, "About the Project", True, NULL},
  { NULL, NULL}
};

#ifdef VIEW_MISC
#define HIST_INDEX	5
#else
#define HIST_INDEX	4
#endif

static menu_t menu [] =
{
  { "File",     itemFile, True, NULL },
  { "Edit",     itemEdit, True, NULL },
  { "View",     itemView, True, NULL },
  { "Sorting",  itemSort, True, NULL },
  { "Options",  itemMisc, True, NULL },
  { "Window",   itemWinMenu, True, NULL },
  { "History",  itemHist, True, NULL },
  { "Help",     itemHelp, True, NULL },
  { NULL, NULL}
};

void histPwdCB (Widget w, Mainwin_t mwin)
{
  XmString prg;
  char * pwd;

  XtVaGetValues (w,
		 XmNlabelString, &prg,
		 NULL);
  if (prg == NULL)
    return;

  XmStringGetLtoR (prg, XmFONTLIST_DEFAULT_TAG, &pwd);
  XmStringFree (prg);

  if (pwd == NULL)
    return;

  if (strcmp (pwd, "Home") == 0)
    {
      mwinChangePathName (mwin, getenv ("HOME"));
    }
  else if (strcmp (pwd, "(Empty)") != 0)
    mwinChangePathName (mwin, pwd);

  XtFree (pwd);
}

void mwinRefreshCB (Widget w, Mainwin_t mwin)
{
  Dchain_t dirTr;

  BaisyCursor (mwin->shlMainwin);

  /**** refresh tree */
  dirTreeRefresh (UdchNext (mwin->dirTree), False);

  /* verify, if path exists, if not then select parent */
  for (; ! mwinTreeSelPath (mwin); )
    strcpy (mwin->DirName, dirname (mwin->DirName));

  mwinBuildTree  (mwin, False);
  mwinTreeRedisp (mwin);
  mwinDispStatus (mwin);

  NormalCursor (mwin->shlMainwin);
}

void mwinRecursiveCB (Widget w, Mainwin_t mwin)
{
  DirTree_t dirTr;
  int i;

  BaisyCursor (mwin->shlMainwin);

  for (i=0; i<mwin->TreeCount; i++)
    {
      if (strcmp (dirTreePathName (mwin->dirTreeWidgets[i]->dirTreeEntry),
		  mwin->DirName) == 0)
	{
	  break;
	}
    }
  if (i>mwin->TreeCount)
    return;

  dirTr = UdchClient (mwin->dirTreeWidgets[i]->dirTreeEntry);

  if (dirTr->subTree == NULL)
     dirTr->subTree = dirTreeAddSubTree (mwin->dirTreeWidgets[i]->dirTreeEntry);
  if (dirTr->subTree == NULL)
    return;

  dirTreeRead (dirTr->subTree,
	       mwin->DirName,
	       mwin->DirFilter,
	       TREE_READ_RECURSIVE);
  mwinBuildTree  (mwin, False);
  mwinTreeRedisp (mwin);
  mwinDispStatus (mwin);

  NormalCursor (mwin->shlMainwin);
}

void mwinTreeFocusChangeCB (Widget w, Mainwin_t mwin, XEvent * ev)
{
  DEBUG1 ("Tree Focus Change...");

  /* focus state is changed */
  mwin->TreeFocus = (ev->type == FocusIn) ? True : False;
  mwinDispTreeIcon (mwin, mwin->CurrentTreeNum, False);
}

void mwinFilesFocusChangeCB (Widget w, Mainwin_t mwin, XEvent * ev)
{
  XmDrawingAreaCallbackStruct cbs;

  DEBUG1 ("Files Focus Change...");

  cbs.reason = REASON_FOCUS_CHANGE;	/* my definition */
  cbs.event  = ev;
  cbs.window = XtWindow (w);

  /* focus state is changed */
  mwin->FilesFocus = (ev->type == FocusIn) ? True : False;
  if (mwin->SelectedIcons > 0)
    mwinRedisp (mwin);
}

#if 0
void mwinLeaveTreeCB (Widget w, Mainwin_t mwin, XEvent * ev)
{
  XmDrawingAreaCallbackStruct cbs;
  cbs.reason = REASON_LEAVE_WIN;	/* my definition */
  cbs.event  = ev;
  cbs.window = XtWindow (w);
  DEBUG1 ("Tree Leave ..");
}
#endif

void mwinMotionTreeCB (Widget w, Mainwin_t mwin, XEvent * ev)
{
  XmDrawingAreaCallbackStruct cbs;
  action_t action;

  DEBUG1 ("mwinMotionTreeCB:");

  cbs.reason = REASON_MOTION;	/* my definition */
  cbs.event  = ev;
  cbs.window = XtWindow (w);
  
  action.SelectProc   = mwinSelectTree;
  action.ReleaseProc  = NULL;
  action.ExecProc     = mwinExecTree;
  action.MotionProc   = NULL;
  action.KeyboardProc = mwinTreeKey;
  action.CopyProc     = mwinTreeCopy;
  action.CanCopyProc  = mwinTreeCanCopy;
  action.PressProc    = mwinTreePress;

  mwin->fg   = mwin->treeFg;
  mwin->bg   = mwin->treeBg;

  mwinAction (w, mwin, &cbs, &action);
}

void mwinInputTreeCB (Widget w,
		      Mainwin_t mwin,
		      XmDrawingAreaCallbackStruct * cbs)
{
  action_t action;

  DEBUG1 ("mwinInputTreeCB");

  mwin->fg   = mwin->treeFg;
  mwin->bg   = mwin->treeBg;

  action.SelectProc  = mwinSelectTree;
  action.ReleaseProc = NULL;
  action.ExecProc   = mwinExecTree;
  action.MotionProc = (int (*) (Mainwin_t, XEvent*)) NULL;
  action.KeyboardProc = mwinTreeKey;
  action.CopyProc     = mwinTreeCopy;
  action.CanCopyProc  = mwinTreeCanCopy;
  action.PressProc    = mwinTreePress;

  mwinAction (w, mwin, cbs, &action);
}

void mwinMotionCB (Widget w, Mainwin_t mwin, XEvent * ev)
{
  action_t action;
  XmDrawingAreaCallbackStruct cbs;

  cbs.reason = 777; /* my definition */
  cbs.event  = ev;
  cbs.window = XtWindow (w);
  mwin->fg   = mwin->filesFg;
  mwin->bg   = mwin->filesBg;

  action.SelectProc   = mwinSelect;
  action.ReleaseProc  = mwinRelease;
  action.ExecProc     = mwinExec;
  action.MotionProc   = mwinSelect;
  action.KeyboardProc = NULL;
  action.CopyProc     = mwinCopy;
  action.CanCopyProc  = mwinCanCopy;
  action.PressProc    = mwinPress;

  mwinAction (w, mwin, &cbs, &action);
}

void mwinInputCB (Widget w, Mainwin_t mwin, XmDrawingAreaCallbackStruct * cbs)
{
  action_t action;

  mwin->fg   = mwin->filesFg;
  mwin->bg   = mwin->filesBg;

  action.SelectProc   = mwinSelect;
  action.ReleaseProc  = mwinRelease;
  action.ExecProc     = mwinExec;
  action.MotionProc   = mwinSelect;
  action.KeyboardProc = mwinKey;
  action.CopyProc     = mwinCopy;
  action.CanCopyProc  = mwinCanCopy;
  action.PressProc    = mwinPress;

  mwinAction (w, mwin, cbs, &action); /* motion and selection are same */
}

void mwinOwnerCB (Widget w, Mainwin_t mwin, XEvent * ev)
{
  DEBUG1 ("mwinOwnerCB: Files Ower");
}

void mwinOwnerTreeCB (Widget w, Mainwin_t mwin, XEvent * ev)
{
  DEBUG1 ("mwinOwnerTreeCB: Tree Ower");
}

void mwinScrVertTreeCB (Widget w, Mainwin_t mwin,
			XmScrollBarCallbackStruct * cbs)
{
  mwin->TreeViewY = (long) - (cbs->value * (mwin->PixmTreeHeight + 2));

  XMoveWindow (display, XtWindow (mwin->fomTree),
	       mwin->TreeViewX,
	       mwin->TreeViewY /*% MAX_WIN_MOVE*/ );
}

void mwinScrHorizTreeCB (Widget w, Mainwin_t mwin,
			 XmScrollBarCallbackStruct * cbs)
{
  mwin->TreeViewX = (long) - cbs->value;

  XMoveWindow (display, XtWindow (mwin->fomTree),
	       mwin->TreeViewX,
	       mwin->TreeViewY /*% MAX_WIN_MOVE*/ );
}

void mwinScrVertFilesCB (Widget w, Mainwin_t mwin,
			XmScrollBarCallbackStruct * cbs)
{
  XEvent tmpEvent;
  XCheckMaskEvent (display, ButtonMotionMask, &tmpEvent);

  mwin->FilesViewY = (long) - cbs->value * 10;

  XMoveWindow (display,
	       XtWindow (mwin->fomFiles),
	       mwin->FilesViewX,
	       mwin->FilesViewY /*% MAX_WIN_MOVE*/ );
}
void mwinScrHorizFilesCB (Widget w, Mainwin_t mwin,
			 XmScrollBarCallbackStruct * cbs)
{
  XEvent tmpEvent;
  XCheckMaskEvent (display, ButtonMotionMask, &tmpEvent);

  mwin->FilesViewX = (long) - cbs->value * 10;

  XMoveWindow (display,
	       XtWindow (mwin->fomFiles),
	       mwin->FilesViewX,
	       mwin->FilesViewY /*% MAX_WIN_MOVE*/ );
}

void mwinFilesFirstCB (Widget w, Mainwin_t mwin,
		       XmDrawingAreaCallbackStruct * cbs)
{
  if (cbs->window == 0)
    return;

  BaisyCursor (mwin->shlMainwin);

  mwin->dimFilesWidth  = wdgWidth  (mwin->fomFiles);
  mwin->dimFilesHeight = wdgHeight (mwin->fomFiles);
  mwin->FilesWindow    = cbs->window;
  mwinReadDir (mwin);
  mwinCalc    (mwin);
  mwinDispStatus (mwin);

  DEBUG1 ("mwinFilesFirstCB: End");

  XtRemoveCallback (w, XmNexposeCallback,
		    (XtCallbackProc) mwinFilesFirstCB, mwin);

  /* add timer to refresh the contintes, when modified */
  mwin->IntervalId =
    XtAppAddTimeOut (app_context, REFRESH_TIMEOUT,
		     (XtTimerCallbackProc) mwinTimeOutCB, mwin);

  NormalCursor (mwin->shlMainwin);
}

void mwinResizeCB (Widget w, Mainwin_t mwin, XmDrawingAreaCallbackStruct * cbs)
{
  if (cbs->window == 0)
    return;
#if 1
  DEBUG3 ("mwinResizeCB: Resize request width=(%i), height=(%i)\n",
	  wdgWidth (w), wdgHeight (w));
#endif
#if 0
  BaisyCursor (mwin->shlMainwin);
#endif
  mwin->dimFilesWidth  = wdgWidth  (mwin->fomFiles);
  mwin->dimFilesHeight = wdgHeight (mwin->fomFiles);
  mwin->FilesWindow    = cbs->window;

  if (cbs->reason == XmCR_EXPOSE ||
      cbs->reason == XmCR_RESIZE)
    {
      /* clear old entries of the drawing area on resizing */
      if (cbs->reason == XmCR_RESIZE)
	mwin->FilesClearIcons = True;

      if (cbs->reason == XmCR_RESIZE)
	mwinCalc   (mwin);

      mwinRedisp (mwin);
    }
#if 0
  NormalCursor (mwin->shlMainwin);
#endif
#if 1
  DEBUG1 ("mwinResizeCB: End");
#endif
}

void mwinTreeFirstCB (Widget w, Mainwin_t mwin,
		       XmDrawingAreaCallbackStruct * cbs)
{
  if (cbs->window == 0)
    return;

  DEBUG4 ("mwinTreeFirst: width=(%i), height=(%i), reason (%s)\n",
	  wdgWidth (w), wdgHeight (w),
	  cbs->reason == XmCR_EXPOSE ? "expose" : "resize");

  BaisyCursor (mwin->shlMainwin);

  XtRemoveCallback (mwin->fomTree, XmNexposeCallback,
		    (XtCallbackProc) mwinTreeFirstCB, mwin);

  mwin->dimTreeWidth  = wdgWidth  (mwin->fomTree);
  mwin->dimTreeHeight = wdgHeight (mwin->fomTree);
  mwin->TreeWindow    = cbs->window;
  mwinBuildTree        (mwin, TREE_BUILD);

  NormalCursor (mwin->shlMainwin);
}

void mwinResizeTreeCB (Widget w, Mainwin_t mwin,
		       XmDrawingAreaCallbackStruct * cbs)
{

  if (cbs->window == 0)
    return;

#if 1
  DEBUG3 ("mwinResizeTreeCB: Resize request width=(%i), height=(%i)\n",
	  wdgWidth (w), wdgHeight (w));
#endif

  mwin->dimTreeWidth  = wdgWidth  (mwin->fomTree);
  mwin->dimTreeHeight = wdgHeight (mwin->fomTree);
  mwin->TreeWindow    = cbs->window;

  if (cbs->reason == XmCR_EXPOSE ||
      cbs->reason == XmCR_RESIZE)
    {
      if (cbs->reason == XmCR_RESIZE)
	mwinCalcTree   (mwin);
      mwinTreeRedisp (mwin);
    }
}

#undef TEST_XPM

/* Die Hauptprozedur **********/
int mwinView (Mainwin_t mwin)
{
  Widget w;
  mAppData_t mwinAppData;
  Dchain_t p;
  Arg args[20];
  int i, j, n;
  long width, height, x, y, nameHeight;

  /*** Strukturen vorbereiten ****************/
  if (mwin == NULL)
      return False;

  if (mwin->shlMainwin != NULL)
    return True;

#if 1
  DEBUG1 ("mwinView:");
#endif

  mwinLock (mwin, 2);

  /* Hauptmaske in einer neuen Shell erstellen ***************/
  winCreate (TITLE_MAINWINDOW,
	     &mwin->shlMainwin,
	     &mwin->winMainwin,
	     &mwin->fomMain,
	     6,
	     mwin,
	     (void (*)(Widget, void*)) mwinQuitCB,
	     False /*SCROLLED_WINDOW*/ );
  if (mwin->winMainwin == NULL)
    {
      ERROR1 ("mwinView: cannot create window shell");
      exit (1);
    }

#if 0
  /* add readed coordinates from ressource file, if avail. */
  XtAddEventHandler (mwin->shlMainwin, StructureNotifyMask, False,
		     (XtEventHandler) winSetCoordCB,
		     mwin);
  /* Merk the state of a window */
  XtAddEventHandler (mwin->shlMainwin, StructureNotifyMask, False,
		     (XtEventHandler) winSetStateCB,
		     mwin);
#endif

  for (i=0; i<HIST_MAX_ITEMS; i++)
    {
      if (histList[i] != NULL)
	{
	  itemHist[i].label = histList[i];
	}
    }

  /****** Menue-Eintraege fuer das Hauptfenster erstellen *************/
  mnuMake (mwin->winMainwin, menu, mwin);
  
  /****** set the current history list to history menu */
  for (i=0; i<HIST_MAX_ITEMS; i++)
    {
      XmString str;
      mwin->HistButtons[i] = itemHist[i].buttonWdg;
    }

  /************************************************/
  /***** Widgets zeichnen *************************/
  /************************************************/

  /****** Util-Buttons  ***************************/

#if 0
  DEBUG1 ("mwinView: fomCommands");
#endif
  mwin->fomCommands =
    XtVaCreateManagedWidget ("Commands",
			     xmFormWidgetClass,
			     mwin->fomMain,
			     XmNtopAttachment,   XmATTACH_FORM,
			     XmNleftAttachment,  XmATTACH_FORM,
			     XmNrightAttachment, XmATTACH_FORM,
			     XmNleftOffset,      FRAME_SPACE/2,
			     XmNrightOffset,     FRAME_SPACE/2,
			     NULL);

#if 1
  DEBUG1 ("mwinView: btnParent");
#endif

  mwin->btnParent =
    XtVaCreateManagedWidget ("parent",
			     xmPushButtonGadgetClass,
			     mwin->fomCommands,
			     XmNtraversalOn,      False,
			     XmNtopAttachment,    XmATTACH_FORM,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNbottomAttachment, XmATTACH_FORM,
			     XmNrightOffset,      12,
			     NULL);
  mwinSetPixmapToWidget (mwin->btnParent, PIXM_tool_parent24, MWIN_LOADANDSET);
  btnMesgArea   (mwin->btnParent, MWIN_PARENT);
  XtAddCallback (mwin->btnParent, XmNactivateCallback, 
		 (XtCallbackProc) btnParentCB,
		 mwin);
  XtManageChild (mwin->btnParent);
  
  DEBUG1 ("mwinView: btnNewFile");

  mwin->btnNewFile =
    XtVaCreateManagedWidget ("new",
			     xmPushButtonGadgetClass,
			     mwin->fomCommands,
			     XmNtraversalOn,      False,
			     XmNtopAttachment,   XmATTACH_FORM,
			     XmNleftAttachment,   XmATTACH_WIDGET,
			     XmNleftWidget, mwin->btnParent,
			     XmNbottomAttachment,   XmATTACH_FORM,
			     NULL);
  mwinSetPixmapToWidget (mwin->btnNewFile, PIXM_tool_new24, MWIN_LOADANDSET);
  XtAddCallback (mwin->btnNewFile, XmNactivateCallback, 
		 (XtCallbackProc) mwinNewCB,
		 mwin);
  btnMesgArea   (mwin->btnNewFile, MWIN_NEW);
  XtManageChild (mwin->btnNewFile);
  
  DEBUG1 ("mwinView: btnMkDir");
  mwin->btnMkDir =
    XtVaCreateManagedWidget ("mkdir",
			     xmPushButtonGadgetClass,
			     mwin->fomCommands,
			     XmNtraversalOn,      False,
			     XmNtopAttachment,   XmATTACH_FORM,
			     XmNleftAttachment,  XmATTACH_WIDGET,
			     XmNleftWidget,      mwin->btnNewFile,
			     XmNbottomAttachment,   XmATTACH_FORM,
			     NULL);
  mwinSetPixmapToWidget (mwin->btnMkDir, PIXM_tool_mkdir24, MWIN_LOADANDSET);
  XtAddCallback (mwin->btnMkDir, XmNactivateCallback, 
		 (XtCallbackProc) mwinMkdirCB,
		 mwin);
  btnMesgArea   (mwin->btnMkDir, MWIN_MKDIR);
  XtManageChild (mwin->btnMkDir);

  DEBUG1 ("mwinView: btnOpen");

  mwin->btnOpen =
    XtVaCreateManagedWidget ("open",
			     xmPushButtonGadgetClass,
			     mwin->fomCommands,
			     XmNtraversalOn,      False,
			     XmNtopAttachment,   XmATTACH_FORM,
			     XmNleftAttachment,  XmATTACH_WIDGET,
			     XmNleftWidget,      mwin->btnMkDir,
			     XmNbottomAttachment,   XmATTACH_FORM,
			     NULL);
  mwinSetPixmapToWidget (mwin->btnOpen, PIXM_tool_open24, MWIN_LOADANDSET);
  XtAddCallback (mwin->btnOpen, XmNactivateCallback, 
		 (XtCallbackProc) mwinOpenCB,
		 mwin);
  btnMesgArea   (mwin->btnOpen, MWIN_OPEN);
  XtManageChild (mwin->btnOpen);
  
  DEBUG1 ("mwinView: btnCopy");

  mwin->btnCopy =
    XtVaCreateManagedWidget ("copy",
			     xmPushButtonGadgetClass,
			     mwin->fomCommands,
			     XmNtraversalOn,      False,
			     XmNtopAttachment, XmATTACH_FORM,
			     XmNleftAttachment,  XmATTACH_WIDGET,
			     XmNleftWidget,      mwin->btnOpen,
			     XmNbottomAttachment, XmATTACH_FORM,
			     NULL);
  mwinSetPixmapToWidget (mwin->btnCopy, PIXM_tool_copy24, MWIN_LOADANDSET);
  XtAddCallback (mwin->btnCopy, XmNactivateCallback, 
		 (XtCallbackProc) btnCopyCB,
		 mwin);
  btnMesgArea   (mwin->btnCopy, MWIN_COPY);
  XtManageChild (mwin->btnCopy);
  
  mwin->btnMove =
    XtVaCreateManagedWidget ("move",
			     xmPushButtonGadgetClass,
			     mwin->fomCommands,
			     XmNtraversalOn,      False,
			     XmNtopAttachment, XmATTACH_FORM,
			     XmNleftAttachment,  XmATTACH_WIDGET,
			     XmNleftWidget,      mwin->btnCopy,
			     XmNbottomAttachment, XmATTACH_FORM,
			     NULL);
  mwinSetPixmapToWidget (mwin->btnMove, PIXM_tool_move24, MWIN_LOADANDSET);
  XtAddCallback (mwin->btnMove, XmNactivateCallback, 
		 (XtCallbackProc) btnMoveCB,
		 mwin);
  btnMesgArea   (mwin->btnMove, MWIN_MOVE);
  XtManageChild (mwin->btnMove);
  
  DEBUG1 ("mwinView: btnLink");

  mwin->btnLink =
    XtVaCreateManagedWidget ("link",
			     xmPushButtonGadgetClass,
			     mwin->fomCommands,
			     XmNtraversalOn,      False,
			     XmNtopAttachment, XmATTACH_FORM,
			     XmNleftAttachment,  XmATTACH_WIDGET,
			     XmNleftWidget,      mwin->btnMove,
			     XmNbottomAttachment, XmATTACH_FORM,
			     NULL);
  mwinSetPixmapToWidget (mwin->btnLink, PIXM_tool_link24, MWIN_LOADANDSET);
  XtAddCallback (mwin->btnLink, XmNactivateCallback,
		 (XtCallbackProc) btnLinkCB,
		 mwin);
  btnMesgArea   (mwin->btnLink, MWIN_LINK);
  XtManageChild (mwin->btnLink);
  
  DEBUG1 ("mwinView: btnProp");
  mwin->btnProp =
    XtVaCreateManagedWidget ("properities",
			     xmPushButtonGadgetClass,
			     mwin->fomCommands,
			     XmNtraversalOn,      False,
			     XmNtopAttachment,   XmATTACH_FORM,
			     XmNleftAttachment,  XmATTACH_WIDGET,
			     XmNleftWidget,      mwin->btnLink,
			     XmNbottomAttachment,   XmATTACH_FORM,
			     NULL);
  mwinSetPixmapToWidget (mwin->btnProp, PIXM_tool_prop24, MWIN_LOADANDSET);
  XtAddCallback (mwin->btnProp, XmNactivateCallback, 
		 (XtCallbackProc) mwinPropCB,
		 mwin);
  btnMesgArea   (mwin->btnProp, MWIN_PROP);
  XtManageChild (mwin->btnProp);

  DEBUG1 ("mwinView: btnDel");
  mwin->btnDel =
    XtVaCreateManagedWidget ("delete",
			     xmPushButtonGadgetClass,
			     mwin->fomCommands,
			     XmNtraversalOn,      False,
			     XmNtopAttachment,   XmATTACH_FORM,
			     XmNleftAttachment,  XmATTACH_WIDGET,
			     XmNleftWidget,      mwin->btnProp,
			     XmNbottomAttachment,   XmATTACH_FORM,
			     NULL);
  mwinSetPixmapToWidget (mwin->btnDel, PIXM_tool_del24, MWIN_LOADANDSET);
  XtAddCallback (mwin->btnDel, XmNactivateCallback, 
		 (XtCallbackProc) btnMwinDelCB,
		 mwin);
  btnMesgArea   (mwin->btnDel, MWIN_DEL);
  XtManageChild (mwin->btnDel);

  DEBUG1 ("mwinView: btnFind");
  mwin->btnFind =
    XtVaCreateManagedWidget ("find",
			     xmPushButtonGadgetClass,
			     mwin->fomCommands,
			     XmNtraversalOn,      False,
			     XmNtopAttachment,   XmATTACH_FORM,
			     XmNleftAttachment,  XmATTACH_WIDGET,
			     XmNleftWidget,      mwin->btnDel,
			     XmNbottomAttachment,   XmATTACH_FORM,
			     NULL);
  mwinSetPixmapToWidget (mwin->btnFind, PIXM_tool_find24, MWIN_LOADANDSET);
  XtAddCallback (mwin->btnFind, XmNactivateCallback, 
		 (XtCallbackProc) mwinFindCB,
		 mwin);
  btnMesgArea   (mwin->btnFind, MWIN_FIND);
  XtManageChild (mwin->btnFind);

  DEBUG1 ("mwinView: btnGrep");
  mwin->btnGrep =
    XtVaCreateManagedWidget ("grep",
			     xmPushButtonGadgetClass,
			     mwin->fomCommands,
			     XmNtraversalOn,      False,
			     XmNtopAttachment,   XmATTACH_FORM,
			     XmNleftAttachment,  XmATTACH_WIDGET,
			     XmNleftWidget,      mwin->btnFind,
			     XmNbottomAttachment,   XmATTACH_FORM,
			     NULL);
  mwinSetPixmapToWidget (mwin->btnGrep, PIXM_tool_grep24, MWIN_LOADANDSET);
  XtAddCallback (mwin->btnGrep, XmNactivateCallback, 
		 (XtCallbackProc) mwinGrepCB,
		 mwin);
  btnMesgArea   (mwin->btnGrep, MWIN_GREP);
  XtManageChild (mwin->btnGrep);

  DEBUG1 ("mwinView: btnExec");
  mwin->btnExec =
    XtVaCreateManagedWidget ("exec",
			     xmPushButtonGadgetClass,
			     mwin->fomCommands,
			     XmNtraversalOn,      False,
			     XmNtopAttachment,   XmATTACH_FORM,
			     XmNleftAttachment,  XmATTACH_WIDGET,
			     XmNleftWidget,      mwin->btnGrep,
			     XmNbottomAttachment,   XmATTACH_FORM,
			     NULL);
  mwinSetPixmapToWidget (mwin->btnExec, PIXM_tool_execbg24, MWIN_LOADANDSET);
  XtAddCallback (mwin->btnExec, XmNactivateCallback, 
		 (XtCallbackProc) mwinCommandCB,
		 mwin);
  btnMesgArea   (mwin->btnExec, MWIN_GREP);
  XtManageChild (mwin->btnExec);

  mwin->btnLarge =
    XtVaCreateManagedWidget ("large",
			     xmPushButtonGadgetClass,
			     mwin->fomCommands,
			     XmNtraversalOn,      False,
			     XmNtopAttachment,   XmATTACH_FORM,
			     XmNleftAttachment,  XmATTACH_WIDGET,
			     XmNleftWidget,      mwin->btnExec,
			     XmNbottomAttachment,   XmATTACH_FORM,
			     NULL);
  mwinSetPixmapToWidget (mwin->btnLarge, PIXM_tool_large24, MWIN_LOADANDSET);
  XtAddCallback (mwin->btnLarge, XmNactivateCallback, 
		 (XtCallbackProc) mwinViewLrgIconsCB,
		 mwin);
  btnMesgArea   (mwin->btnLarge, MWIN_LARGE);
  XtManageChild (mwin->btnLarge);


  mwin->btnSmall =
    XtVaCreateManagedWidget ("small",
			     xmPushButtonGadgetClass,
			     mwin->fomCommands,
			     XmNtraversalOn,      False,
			     XmNtopAttachment,   XmATTACH_FORM,
			     XmNleftAttachment,  XmATTACH_WIDGET,
			     XmNleftWidget,      mwin->btnLarge,
			     XmNbottomAttachment,   XmATTACH_FORM,
			     NULL);
  mwinSetPixmapToWidget (mwin->btnSmall, PIXM_tool_small24, MWIN_LOADANDSET);
  XtAddCallback (mwin->btnSmall, XmNactivateCallback, 
		 (XtCallbackProc) mwinViewSmlIconsCB,
		 mwin);
  btnMesgArea   (mwin->btnSmall, MWIN_SMALL);
  XtManageChild (mwin->btnSmall);

  mwin->btnDetails =
    XtVaCreateManagedWidget ("details",
			     xmPushButtonGadgetClass,
			     mwin->fomCommands,
			     XmNtraversalOn,      False,
			     XmNtopAttachment,   XmATTACH_FORM,
			     XmNleftAttachment,  XmATTACH_WIDGET,
			     XmNleftWidget,      mwin->btnSmall,
			     XmNbottomAttachment,   XmATTACH_FORM,
			     NULL);
  mwinSetPixmapToWidget (mwin->btnDetails, PIXM_tool_details24,
			 MWIN_LOADANDSET);
  XtAddCallback (mwin->btnDetails, XmNactivateCallback, 
		 (XtCallbackProc) mwinViewDetailsCB,
		 mwin);
  btnMesgArea   (mwin->btnDetails, MWIN_DETAILS);
  XtManageChild (mwin->btnDetails);


  mwin->btnVertical =
    XtVaCreateManagedWidget ("vertical",
			     xmPushButtonGadgetClass,
			     mwin->fomCommands,
			     XmNtraversalOn,      False,
			     XmNtopAttachment,   XmATTACH_FORM,
			     XmNleftAttachment,  XmATTACH_WIDGET,
			     XmNleftWidget,      mwin->btnDetails,
			     XmNbottomAttachment,   XmATTACH_FORM,
			     NULL);
  mwinSetPixmapToWidget (mwin->btnVertical, PIXM_tool_vert24, MWIN_LOADANDSET);
  XtAddCallback (mwin->btnVertical, XmNactivateCallback, 
		 (XtCallbackProc) btnVerticalCB,
		 mwin);
  btnMesgArea   (mwin->btnVertical, MWIN_VERTICAL);
  XtManageChild (mwin->btnVertical);

  mwin->btnHorizontal =
    XtVaCreateManagedWidget ("horizontal",
			     xmPushButtonGadgetClass,
			     mwin->fomCommands,
			     XmNtraversalOn,      False,
			     XmNtopAttachment,   XmATTACH_FORM,
			     XmNleftAttachment,  XmATTACH_WIDGET,
			     XmNleftWidget,      mwin->btnVertical,
			     XmNbottomAttachment,   XmATTACH_FORM,
			     NULL);
  mwinSetPixmapToWidget (mwin->btnHorizontal, PIXM_tool_horiz24, MWIN_LOADANDSET);
  XtAddCallback (mwin->btnHorizontal, XmNactivateCallback, 
		 (XtCallbackProc) btnHorizontalCB,
		 mwin);
  btnMesgArea   (mwin->btnHorizontal, MWIN_HORIZ);
  XtManageChild (mwin->btnHorizontal);

  mwin->btnFixed =
    XtVaCreateManagedWidget ("fixed",
			     xmPushButtonGadgetClass,
			     mwin->fomCommands,
			     XmNtraversalOn,      False,
			     XmNtopAttachment,   XmATTACH_FORM,
			     XmNleftAttachment,  XmATTACH_WIDGET,
			     XmNleftWidget,      mwin->btnHorizontal,
			     XmNbottomAttachment,   XmATTACH_FORM,
			     NULL);
  mwinSetPixmapToWidget (mwin->btnFixed, PIXM_tool_fix24, MWIN_LOADANDSET);
  XtAddCallback (mwin->btnFixed, XmNactivateCallback, 
		 (XtCallbackProc) btnFixedCB,
		 mwin);
  btnMesgArea   (mwin->btnFixed, MWIN_FIXED);
  XtManageChild (mwin->btnFixed);

  DEBUG1 ("mwinView: btnExit");

  mwin->btnExit =
    XtVaCreateManagedWidget ("exit",
			     xmPushButtonGadgetClass,
			     mwin->fomCommands,
			     XmNtraversalOn,      False,
			     XmNtopAttachment,   XmATTACH_FORM,
			     XmNrightAttachment, XmATTACH_FORM,
			     XmNbottomAttachment, XmATTACH_FORM,
			     XmNleftOffset,       24,
			     NULL);
  mwinSetPixmapToWidget (mwin->btnExit, PIXM_quit24, MWIN_LOADANDSET);
  XtAddCallback (mwin->btnExit, XmNactivateCallback, 
		 (XtCallbackProc) mwinQuitCB,
		 mwin);
  btnMesgArea   (mwin->btnExit, MWIN_EXIT);
  XtManageChild (mwin->btnExit);
  
  mwin->btnNewWindow =
    XtVaCreateManagedWidget ("newwindow",
			     xmPushButtonGadgetClass,
			     mwin->fomCommands,
			     XmNtraversalOn,      False,
			     XmNtopAttachment,    XmATTACH_FORM,
			     XmNrightAttachment,  XmATTACH_WIDGET,
			     XmNrightWidget,      mwin->btnExit,
			     XmNbottomAttachment, XmATTACH_FORM,
			     NULL);
  mwinSetPixmapToWidget (mwin->btnNewWindow, PIXM_tool_xkhfm24, MWIN_LOADANDSET);
  XtAddCallback (mwin->btnNewWindow, XmNactivateCallback, 
		 (XtCallbackProc) btnNewWindowCB,
		 mwin);
  btnMesgArea   (mwin->btnNewWindow, MWIN_NEWWINDOW);
  XtManageChild (mwin->btnNewWindow);

#ifdef VIEW_EXEC_LINE
  DEBUG1 ("mwinView: fomExec");
  mwin->fomExec =
    XtVaCreateManagedWidget ("Exec",
			     xmFormWidgetClass,
			     mwin->fomMain,
			     XmNtraversalOn,      False,
			     XmNleftAttachment,  XmATTACH_FORM,
			     XmNrightAttachment, XmATTACH_FORM,
			     XmNbottomAttachment,   XmATTACH_FORM,
			     NULL);

  DEBUG1 ("mwinView: ExecXterm");
  
  mwin->btnExecXterm =
    XtVaCreateManagedWidget ("execute",
			     xmPushButtonGadgetClass,
			     mwin->fomExec,
			     XmNtraversalOn,      False,
			     XmNtopAttachment, XmATTACH_FORM,
			     XmNrightAttachment,   XmATTACH_FORM,
			     XmNbottomAttachment, XmATTACH_FORM,
			     NULL);
  mwinSetPixmapToWidget (mwin->btnExecXterm, PIXM_tool_execwin24, MWIN_LOADANDSET);
  XtAddCallback (mwin->btnExecXterm, XmNactivateCallback, 
		 (XtCallbackProc) btnExecXtermCB,
		 mwin);
  btnMesgArea   (mwin->btnExecXterm, MWIN_EXECUTE);
  XtManageChild (mwin->btnExecXterm);
  
#if 1
  DEBUG1 ("mwinView: ExecBackgrnd");
#endif
  
  mwin->btnExecBackgrnd =
    XtVaCreateManagedWidget ("Xexecute",
			     xmPushButtonGadgetClass,
			     mwin->fomExec,
			     XmNtraversalOn,      False,
			     XmNtopAttachment, XmATTACH_FORM,
			     XmNrightAttachment,  XmATTACH_WIDGET,
			     XmNrightWidget,      mwin->btnExecXterm,
			     XmNbottomAttachment, XmATTACH_FORM,
			     NULL);
  mwinSetPixmapToWidget (mwin->btnExecBackgrnd, PIXM_tool_execbg24, MWIN_LOADANDSET);
  XtAddCallback (mwin->btnExecBackgrnd, XmNactivateCallback, 
		 (XtCallbackProc) btnExecBackgrndCB,
		 mwin);
  btnMesgArea   (mwin->btnExecBackgrnd, MWIN_XEXEC);
  XtManageChild (mwin->btnExecBackgrnd);
  
  /****** Commando line  **/
#if 1
  DEBUG1 ("mwinView: CommandoEditor");
#endif
  
  mwin->txtComm = txtCreate (mwin->fomExec,
			     "Commando",
			     MAX_COMM_LEN,
			     IsInfoFrm,
			     MWIN_txtComm,
			     False);
  XtVaSetValues (mwin->txtComm->fomText,
		 XmNtraversalOn,      True,
		 XmNtopAttachment,    XmATTACH_FORM,
		 XmNleftAttachment,   XmATTACH_FORM,
		 XmNrightAttachment,  XmATTACH_WIDGET,
		 XmNrightWidget,      mwin->btnExecBackgrnd,
		 XmNbottomAttachment, XmATTACH_FORM,
		 NULL);
  XtVaSetValues (mwin->txtComm->txtText,
		 XmNtraversalOn, True,
		 NULL);
  XtManageChild (mwin->txtComm->fomText);
#endif /* VIEW_EXEC_LINE */

  /***** Form for the Directory tree **/
  mwinViewStyle (mwin, mwin->Style);

  /************************************/
  /***** Am Ende die Form ausgeben ****/
  /************************************/
#if 1
  DEBUG1 ("ManageForm");
#endif
  XtManageChild (mwin->fomMain);

  XtManageChild (mwin->winMainwin);

  /******************************************/
  /***** E N D E D E R Z E I C H N U N G ****/
  /******************************************/

#if 1 /*def HAVE_XPM*/
  /* Create widgets relativ to this drawing area */
  for (i=0; i<MAX_PIXMAPS; i++)
    {
      switch (i)
	{
	case PIXM_tree_dir16:
	case PIXM_tree_odir16:
	  mwinSetPixmapToWidget (mwin->fomTree, i, False);
	  break;
	default:
	  mwinSetPixmapToWidget (mwin->fomFiles, i, False);
	  break;
	}
    }
#endif

  /* create a gc to draw the icons */
  if (!mwin->gc)
    {
      mwin->gc = theGC;
      SET_FONT (display, mwin->gc, mwin->fntMainwin->fid);
    }

  /* Get colors */
  XtVaGetValues (mwin->fomFiles,
		 XmNforeground, &mwin->filesFg,
		 XmNbackground, &mwin->filesBg,
		 XmNhighlightColor, &mwin->filesHighLight,
		 NULL);
  
  /* Get colors */
  XtVaGetValues (mwin->fomTree,
		 XmNforeground, &mwin->treeFg,
		 XmNbackground, &mwin->treeBg,
		 XmNhighlightColor, &mwin->treeHighLight,
		 NULL);

  /****** Zu Anfang ist leere Konfiguration vorhanden **/
  mwinTitle (mwin);

#if 1
  DEBUG1 ("Realize");
#endif

#ifdef HAVE_FONTLIST_ENTRY_GET_FONT
  /* try to load default fontlist **********************/
  {
    XmFontList  fntList = NULL;
    XFontStruct * fnt = NULL;
    XmFontType  fntType = NULL;

    XtVaGetValues (mwin->btnExit,
		   XmNfontList, &fntList,
		   NULL);
    if (fntList != NULL)
      {
	fnt = (XFontStruct*) XmFontListEntryGetFont (fntList, &fntType);
	if (fntType == XmFONT_IS_FONT)
	  {
	    DEBUG1 ("load default fontlist..");
	    mwin->fntMainwin = fnt;
	    mwin->NameHeight = (mwin->fntMainwin->ascent
				+ mwin->fntMainwin->descent);
	    mwin->PixmTreeHeight = max (mwin->PixmTreeHeight,
					mwin->NameHeight);
	  }
      }  
  }
#else
  {
    XmFontContext fntContext;
    XmFontList  fntList = NULL;
    XFontStruct * fnt = NULL;
    XmStringCharSet fntType = NULL;

    DEBUG1 ("mwinView: try to load default font");

    XtVaGetValues (mwin->btnExit,
		   XmNfontList, &fntList,
		   NULL);
    if (fntList != NULL)
      {
	XmFontListInitFontContext (&fntContext, fntList);
	if (XmFontListGetNextFont (fntContext, &fntType, &fnt))
	  {
	    DEBUG1 ("load default fontlist..");
	    mwin->fntMainwin = fnt;
	    mwin->NameHeight = (mwin->fntMainwin->ascent
				+ mwin->fntMainwin->descent);
	    mwin->PixmTreeHeight = max (mwin->PixmTreeHeight,
					mwin->NameHeight);
	  }
      }  

    DEBUG1 ("mwinView: end of trying to load default font");

  }
#endif

  MXtRealizeWidget (mwin->shlMainwin);

  if (mwin->fntMainwin == NULL)
    {
      ERROR1 ("mwinMake: cannot load fontlist");
      exit (1);
    }

  mwinUnLock (mwin, 2);

  return True;
}
	   
int mwinViewStyle (Mainwin_t mwin, unsigned long mode)
{
  Widget w;
  int width = -1, height = -1;

  mwin->dimFilesHeight  = DefaultViewHeight / 2;
  mwin->dimFilesWidth   = DefaultViewWidth / 2;

  if (mwin->fomTreeFiles != NULL)
    {
#if 0
      if (mode == VIEW_STYLE_HORIZ)
	XtVaSetValues (mwin->fomTreeFiles,
		       XmNorientation,      XmHORIZONTAL,
		       NULL);
      else if (mode == VIEW_STYLE_VERT)
	XtVaSetValues (mwin->fomTreeFiles,
		       XmNorientation,      XmVERTICAL,
		       NULL);
      return True;

#else
      XtDestroyWidget (mwin->fomFiles);
      XtDestroyWidget (mwin->scrHorizFiles);
      XtDestroyWidget (mwin->scrVertFiles);
      XtDestroyWidget (mwin->frmFiles);
      XtDestroyWidget (mwin->fomTree);
      XtDestroyWidget (mwin->scrHorizTree);
      XtDestroyWidget (mwin->scrVertTree);
      XtDestroyWidget (mwin->frmTree);
      XtDestroyWidget (mwin->fomTreeFiles);
#endif
    }

#if 1
  DEBUG1 ("mwinView: Frame frmTreeFiles");
#endif
  
  /*#ifndef USE_ROWCOL*/
  if (mode == VIEW_STYLE_HORIZ)
    mwin->fomTreeFiles = 
      XtVaCreateManagedWidget ("TreeFiles",
			       xmPanedWindowWidgetClass,
			       mwin->fomMain,
#if 0
			       XmNpacking,          XmPACK_NONE,
			       XmNnumColumns,       2,
#endif
			       XmNorientation,      XmVERTICAL,
			       XmNtraversalOn,	    True,
			       
			       XmNwidth,  mwin->dimFilesWidth,
			       XmNheight, mwin->dimFilesHeight,
			       XmNpaneMinimum,      mwin->dimFilesHeight/2,
			       XmNpaneMaximum,      mwin->dimFilesHeight/2,

			       XmNtopAttachment,    XmATTACH_WIDGET,
			       XmNtopWidget,        mwin->fomCommands,
			       XmNleftAttachment,   XmATTACH_FORM,
			       XmNrightAttachment,  XmATTACH_FORM,
#ifdef VIEW_EXEC_LINE
			       XmNbottomAttachment, XmATTACH_WIDGET,
			       XmNbottomWidget,     mwin->fomExec,
#else
			       XmNbottomAttachment, XmATTACH_FORM,
#endif
			       NULL);
  else if (mode == VIEW_STYLE_VERT)
  {
#ifdef HAVE_MOTIF20
    mwin->fomTreeFiles = 
      XtVaCreateManagedWidget ("TreeFiles",
			       xmPanedWindowWidgetClass /*panedWidgetClass*/ ,
			       mwin->fomMain,
			       XmNorientation,      XmHORIZONTAL,

			       /*
				 There are Xm only, not for X11
				 */
			       XmNtraversalOn,	    True,
			       XmNtopAttachment,    XmATTACH_WIDGET,
			       XmNtopWidget,        mwin->fomCommands,
			       XmNleftAttachment,   XmATTACH_FORM,
			       XmNrightAttachment,  XmATTACH_FORM,
#ifdef VIEW_EXEC_LINE
			       XmNbottomAttachment, XmATTACH_WIDGET,
			       XmNbottomWidget,     mwin->fomExec,
#else
			       XmNbottomAttachment, XmATTACH_FORM,
#endif

			       XtNwidth,            mwin->dimFilesWidth,
			       XtNheight,           mwin->dimFilesHeight,
			       XmNpaneMinimum,      mwin->dimFilesWidth/2,

			       NULL);
#else
   /* Motif 1.* doesn't have vertical splitting */
    mwin->fomTreeFiles =
      XtVaCreateManagedWidget ("TreeFiles",
                               panedWidgetClass,
                               mwin->fomMain,
                               XtNorientation,      XmHORIZONTAL,

                               XmNtraversalOn,      True,
                               XmNtopAttachment,    XmATTACH_WIDGET,
                               XmNtopWidget,        mwin->fomCommands,
                               XmNleftAttachment,   XmATTACH_FORM,
                               XmNrightAttachment,  XmATTACH_FORM,
                               XmNbottomAttachment, XmATTACH_WIDGET,
                               XmNbottomWidget,     mwin->fomExec,

                               XtNwidth,            mwin->dimFilesWidth,
                               XtNheight,           mwin->dimFilesHeight,
                               XmNpaneMinimum,      mwin->dimFilesWidth/2,
                               NULL);
#endif
  }
  else
  {
    mwin->fomTreeFiles = 
      XtVaCreateManagedWidget ("TreeFiles",
			       xmFormWidgetClass,
			       mwin->fomMain,
			       XmNfractionBase,     3,
			       
			       XmNwidth,            mwin->dimFilesWidth,
			       XmNheight,           mwin->dimFilesHeight,
			       
			       XmNtopAttachment,    XmATTACH_WIDGET,
			       XmNtopWidget,        mwin->fomCommands,
			       XmNleftAttachment,   XmATTACH_FORM,
			       XmNrightAttachment,  XmATTACH_FORM,
#ifdef VIEW_EXEC_LINE
			       XmNbottomAttachment, XmATTACH_WIDGET,
			       XmNbottomWidget,     mwin->fomExec,
#else
			       XmNbottomAttachment, XmATTACH_FORM,
#endif
			       NULL);
  }

  mwin->frmTree =
    XtVaCreateManagedWidget ("TreeFrame", 
			     xmFrameWidgetClass,
			     mwin->fomTreeFiles,
			     XmNtopOffset,      FRAME_SPACE/2,
			     XmNleftOffset,     FRAME_SPACE/2,
			     XmNrightOffset,    FRAME_SPACE/2,
			     XmNbottomOffset,   FRAME_SPACE/2,
			     NULL);
  if (mode == VIEW_STYLE_FIXED)
    XtVaSetValues (mwin->frmTree,
		   XmNtopAttachment,    XmATTACH_FORM,
		   XmNleftAttachment,   XmATTACH_FORM,
		   XmNrightAttachment,  XmATTACH_POSITION,
		   XmNrightPosition,	  1,
		   XmNbottomAttachment, XmATTACH_FORM,
		   NULL);

  w =
    XtVaCreateManagedWidget ("form",
			     xmFormWidgetClass,
			     mwin->frmTree,
			     XmNtopAttachment,    XmATTACH_FORM,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNrightAttachment,  XmATTACH_FORM,
			     XmNbottomAttachment, XmATTACH_FORM,
			     NULL);

  mwin->scrVertTree =
    XtVaCreateManagedWidget ("scrolling",
			     xmScrollBarWidgetClass,
			     w,
			     XmNmaximum,	  1,
			     XmNtopAttachment,    XmATTACH_FORM,
			     XmNrightAttachment,  XmATTACH_FORM,
			     XmNbottomAttachment, XmATTACH_FORM,
			     NULL);
  XtAddCallback (mwin->scrVertTree, XmNvalueChangedCallback,
		 (XtCallbackProc) mwinScrVertTreeCB,
		 mwin);
  XtAddCallback (mwin->scrVertTree, XmNdragCallback,
		 (XtCallbackProc) mwinScrVertTreeCB,
		 mwin);
  
  mwin->scrHorizTree =
    XtVaCreateManagedWidget ("scrolling",
			     xmScrollBarWidgetClass,
			     w,
			     XmNorientation,      XmHORIZONTAL,
			     XmNmaximum,	  1,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNrightAttachment,  XmATTACH_WIDGET,
			     XmNrightWidget,      mwin->scrVertTree,
			     XmNbottomAttachment, XmATTACH_FORM,
			     NULL);
  XtAddCallback (mwin->scrHorizTree, XmNvalueChangedCallback,
		 (XtCallbackProc) mwinScrHorizTreeCB,
		 mwin);
  XtAddCallback (mwin->scrHorizTree, XmNdragCallback,
		 (XtCallbackProc) mwinScrHorizTreeCB,
		 mwin);
  
#if 0
  DEBUG1 ("mwinView: Form fomTree");
#endif
  mwin->fomTree =
    XtVaCreateManagedWidget ("tree",
			     xmDrawingAreaWidgetClass,
			     w,
			     XmNtopAttachment,    XmATTACH_FORM,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNrightAttachment,  XmATTACH_WIDGET,
			     XmNrightWidget,      mwin->scrVertTree,
			     XmNbottomAttachment, XmATTACH_WIDGET,
			     XmNbottomWidget,     mwin->scrHorizTree,
			     XmNheight,           400,
			     XmNwidth,            200,
			     NULL);

  /* for first call */
  XtAddCallback (mwin->fomTree, XmNexposeCallback,
		 (XtCallbackProc) mwinTreeFirstCB, mwin);

  XtAddEventHandler (mwin->fomTree, FocusChangeMask, False,
		     (XtEventHandler) mwinTreeFocusChangeCB,
		     mwin);
  XtAddEventHandler (mwin->fomTree, ButtonMotionMask, False,
		     (XtEventHandler) mwinMotionTreeCB,
		     mwin);
  XtAddEventHandler (mwin->fomTree, Button1MotionMask, False,
		     (XtEventHandler) mwinOwnerTreeCB,
		     mwin);
#if 0
  XtAddEventHandler (mwin->fomTree,
		     0x100000 /*NoEventMask*/ ,
		     True,
		     mwinOwnerTreeCB,
		     mwin);
#endif

  XtAddCallback (mwin->fomTree, XmNexposeCallback,   
		 (XtCallbackProc) mwinResizeTreeCB, mwin);
  XtAddCallback (mwin->fomTree, XmNresizeCallback,   
		 (XtCallbackProc) mwinResizeTreeCB, mwin);
  XtAddCallback (mwin->fomTree, XmNinputCallback,    
		 (XtCallbackProc) mwinInputTreeCB,  mwin);

  XtManageChild (mwin->fomTree);
  XtManageChild (mwin->frmTree);

  /***** Form for directory contents **/
#if 1
  DEBUG1 ("mwinView: Frame frmFiles");
#endif
  
  mwin->frmFiles =
    XtVaCreateManagedWidget ("FilesFrame", 
			     xmFrameWidgetClass,
			     mwin->fomTreeFiles,			      
			     XmNtopOffset,      FRAME_SPACE/2,
			     XmNleftOffset,     FRAME_SPACE/2,
			     XmNrightOffset,    FRAME_SPACE/2,
			     XmNbottomOffset,   FRAME_SPACE/2,
			     NULL);
  if (mode == VIEW_STYLE_FIXED)
    XtVaSetValues (mwin->frmFiles,
		   XmNtopAttachment,    XmATTACH_FORM,
		   XmNleftAttachment,   XmATTACH_POSITION,
		   XmNleftPosition,	  1,
		   XmNrightAttachment,  XmATTACH_FORM,
		   XmNbottomAttachment, XmATTACH_FORM,
		   NULL);
  w =
    XtVaCreateManagedWidget ("form",
			     xmFormWidgetClass,
			     mwin->frmFiles,
			     XmNtopAttachment,   XmATTACH_FORM,
			     XmNleftAttachment,  XmATTACH_FORM,
			     XmNrightAttachment, XmATTACH_FORM,
			     XmNbottomAttachment, XmATTACH_FORM,
			     NULL);

  mwin->scrVertFiles =
    XtVaCreateManagedWidget ("scrolling",
			     xmScrollBarWidgetClass,
			     w,
			     XmNmaximum,	  1,
			     XmNtopAttachment,    XmATTACH_FORM,
			     XmNrightAttachment,  XmATTACH_FORM,
			     XmNbottomAttachment, XmATTACH_FORM,
			     NULL);
  XtAddCallback (mwin->scrVertFiles, XmNvalueChangedCallback,
		 (XtCallbackProc) mwinScrVertFilesCB,
		 mwin);
  XtAddCallback (mwin->scrVertFiles, XmNdragCallback,
		 (XtCallbackProc) mwinScrVertFilesCB,
		 mwin);
  
  mwin->scrHorizFiles =
    XtVaCreateManagedWidget ("scrolling",
			     xmScrollBarWidgetClass,
			     w,
			     XmNmaximum,	  1,
			     XmNorientation,      XmHORIZONTAL,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNrightAttachment,  XmATTACH_WIDGET,
			     XmNrightWidget,      mwin->scrVertFiles,
			     XmNbottomAttachment, XmATTACH_FORM,
			     NULL);
  XtAddCallback (mwin->scrHorizFiles, XmNvalueChangedCallback,
		 (XtCallbackProc) mwinScrHorizFilesCB,
		 mwin);
  XtAddCallback (mwin->scrHorizFiles, XmNdragCallback,
		 (XtCallbackProc) mwinScrHorizFilesCB,
		 mwin);
  
#if 0
  DEBUG1 ("mwinView: Form fomFiles");
#endif
  mwin->fomFiles =
    XtVaCreateManagedWidget ("files",
			     xmDrawingAreaWidgetClass,
			     w,
			     XmNtopAttachment,    XmATTACH_FORM,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNrightAttachment,  XmATTACH_WIDGET,
			     XmNrightWidget,      mwin->scrVertFiles,
			     XmNbottomAttachment, XmATTACH_WIDGET,
			     XmNbottomWidget,     mwin->scrHorizFiles,
			     XmNheight,           400,
			     XmNwidth,            400,
#if 0
			     XmNtopOffset,      10,
			     XmNleftOffset,     10,
			     XmNrightOffset,    10,
			     XmNbottomOffset,   10,
#endif
			     NULL);

  /* for first call */
  XtAddCallback (mwin->fomFiles, XmNexposeCallback,
		 (XtCallbackProc) mwinFilesFirstCB, mwin);

  XtAddCallback (mwin->fomFiles, XmNexposeCallback,
		 (XtCallbackProc) mwinResizeCB, mwin);
  XtAddCallback (mwin->fomFiles, XmNresizeCallback,
		 (XtCallbackProc) mwinResizeCB, mwin);
  XtAddCallback (mwin->fomFiles, XmNinputCallback,
		 (XtCallbackProc) mwinInputCB,  mwin);

  XtAddEventHandler (mwin->fomFiles, FocusChangeMask, False,
		     (XtEventHandler) mwinFilesFocusChangeCB,
		     mwin);
  XtAddEventHandler (mwin->fomFiles, ButtonMotionMask, False,
		     (XtEventHandler) mwinMotionCB,
		     mwin);
#if 0
  XtAddEventHandler (mwin->fomFiles, OwnerGrabButtonMask, False,
		     (XtEventHandler) mwinOwnerCB,
		     mwin);
#endif
  XtManageChild (mwin->fomFiles);
  XtManageChild (mwin->frmFiles);

  XtManageChild (mwin->fomTreeFiles);

  mwin->Style = mode;

  return True;
}

