/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: scroll.c,v 1.1 1996/10/16 06:55:16 khamis Exp khamis $
 * $Source: /home/khamis/RCS/scroll.c,v $
 */
#define IS_EXTERN
#define EXTERN		extern

#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>
#include <Xm/DrawnB.h>
#include "Xinc.h"

#include "defines.h"
#include "xmisc.h"

int scrSetValues (Widget w, long * XorY, long size, long wSize, int stip)
{
  long count = 0, value = 0;
  long viewedLines;

  viewedLines = max (1, wSize / stip);
  count = max (1, 1 + (size + stip - 1) / stip - viewedLines);
  if (count == 1)
    *XorY = 0;
  else
    * XorY = max (*XorY, - count * stip);

  XtVaGetValues (w, XmNvalue, &value, NULL);

  if (value > count)
    XtVaSetValues (w,
		   XmNvalue, min (value, count-1),
		   NULL);

  XtVaSetValues (w,
		 XmNmaximum,       count,
		 /*
		 XmNpageIncrement, viewedLines,
		 */
		 NULL);
  XmScrollBarSetValues (w,
			min (value, count-1),
			1,
			1,
			viewedLines,
			False);
  return True;
}

int scrSetValue (Widget w, long * XorY,
		 long size,
		 long wSize,
		 int stip,
		 int newValue)
{
  long count = 0, value = 0, oldvalue = 0;
  long viewedLines;

  if (newValue == *XorY)
    return True;

  viewedLines = max (1, wSize / stip);
  count = max (1, 1 + (size + stip - 1) / stip - viewedLines);
  value = min (count - 1, abs (newValue) / stip);
  value = max (0, value);

  XtVaGetValues (w, XmNvalue, &oldvalue, NULL);

  if (count == 1)
    *XorY = 0;
  else
    *XorY = newValue;

  /*
  XtVaSetValues (w, XmNvalue, &value, NULL);
  */
  XmScrollBarSetValues (w,
			value,
			1,
			1,
			viewedLines,
			True);

  return True;
}

int scrAddValue (Widget w, int newvalue, unsigned long mode)
{
  int value, slidersize, incrreturn, pageincrret, maxvalue;

  DEBUG2 ("scrAddValue: newvalue(%i)\n", newvalue);

  XmScrollBarGetValues (w,
			&value,
			&slidersize,
			&incrreturn,
			&pageincrret);

  if (mode & SCR_UP)
    value -= newvalue;
  else if (mode & SCR_DOWN)
    value += newvalue;
  else if (mode & SCR_SET)
    value = newvalue;

  XtVaGetValues (w,
		 XmNmaximum, &maxvalue,
		 NULL);

  DEBUG3 ("scrAddValue: value(%i), maxvalue(%i)\n", value, maxvalue);

  XmScrollBarSetValues (w,
			min (maxvalue-slidersize, max (0, value)),
			slidersize,
			incrreturn,
			pageincrret,
			mode & SCR_REDRAW ? True : False);
  DEBUG1 ("scrAddValue: end");

  return True;
}
