/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: xassoc.c,v 1.1 1997/01/07 08:36:05 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/xkhlib/xkhsrc/RCS/xassoc.c,v $
 */
#define IS_EXTERN
#define EXTERN		extern

#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>

#include "Xinc.h"
#include <Xm/DrawingA.h>
#include <Xm/DrawnB.h>

#include "defines.h"

#ifdef HAVE_THREAD
#include <thread.h>
#endif

#include "Umem.h"
#include "Uxutil.h"
#include "Umessage.h"
#include "Umenu.h"
#include "Ufileutil.h"
#include "Ustrutil.h"
#include "Ucnfutil.h"
#include "xmisc.h"

#define ICON_EXT_SECT "IconExtension"
#define ASS_SECT "Association"

int assDisp (Dchain_t assDch, Associate_t ass);
AssocList_t assListMake (char * Section);
int assListDest (AssocList_t lst);
int assListComp (AssocList_t liste, char * pattern);
int assListCpy (AssocList_t lst1, AssocList_t lst2);
int assListData (Dchain_t lst, char *);
int assListSaveExec (Dchain_t lst, char * assExec);
int assListSaveDescr (Dchain_t lst, char * Descr);
int assListSaveMode (Dchain_t lst, char * mode);
int assListChng (Dchain_t lst, char * newName);

void assHideCB (Widget w, Associate_t ass)
{
  assHide (ass);
}

void btnAssOkCB (Widget w, Associate_t ass)
{
  assHide (ass);
}

static menuitem_t assItemFile [] = 
{
  {(void (*) (Widget, void*)) assHideCB, "Close", True, NULL},
  { NULL, NULL}
};
static menu_t assMenu [] =
{
  { "List", assItemFile, True, NULL },
  { NULL, NULL, False }
};

int assCheckin (Dchain_t assDch, Associate_t ass)
{
  AssocList_t assLst;
  char * tmp;

  if (assDch == NULL || ass == NULL)
    return False;
  assLst = UdchClient (assDch);

  return True;
}

int assDest (Associate_t ass)
{
  if (ass == NULL)
    return False;

  assHide (ass);
  MFree   (ass, sizeof (associate_t));

  assWindow = NULL;

  return True;
}

int assDisp (Dchain_t assDch, Associate_t ass)
{
  AssocList_t assLst = NULL;

  if (assDch == NULL || ass == NULL)
    {
      return False;
    }
  assLst = UdchClient (assDch);
  return True;
}

int assHide (Associate_t ass)
{
  if (ass->shlAss != NULL)
    {
      XtDestroyWidget (ass->shlAss);
      ass->shlAss = NULL;
      maplDest (ass->aplThema);
    }

  return True;
}

AssocList_t assListMake (char * Section)
{
  AssocList_t l = gcalloc (sizeof (assocList_t), __LINE__, __FILE__);

  l->Pattern = StrReplace (l->Pattern,
			   (Section != NULL) ? Section : "*.c");
  l->Exec    = StrReplace  (l->Exec, "echo no program assocciated with this pattern");
  l->Descr   = StrReplace (l->Descr, "");
  l->Mode    = CMD_XTERM;

  return l;
}

int assListDest (AssocList_t lst)
{
  StrReplace (lst->Pattern, NULL);
  StrReplace (lst->Exec,   NULL);
  StrReplace (lst->Descr,     NULL);
  MFree (lst, sizeof (assocList_t));
  return True;
}

int assListComp (AssocList_t liste, char * pattern)
{
  if (liste == NULL)
    return 0;
  return strcmp (liste->Pattern, pattern);
}

Dchain_t assListAdd   (Dchain_t top, char * pattern)
{
  if (UdchItemExists (top, pattern, (int (*) (void*, void*)) assListComp))
    {
      ERROR2 ("assListAdd: Pattern [%s] already available\n",
	      pattern);
      return NULL;
    }
  return UdchAdd (top, pattern,
		     (void * (*) (void *)) assListMake,
		     (int    (*) (void *, void *)) assListComp);
}

int assListCpy (AssocList_t lst1, AssocList_t lst2)
{
  lst2->Pattern = StrReplace (lst2->Pattern, lst1->Pattern);
  lst2->Exec    = StrReplace (lst2->Exec,    lst1->Exec);
  lst2->Descr   = StrReplace (lst2->Descr,   lst1->Descr);
  lst2->Mode    = lst1->Mode;
  return True;
}

char * assListPattern (Dchain_t lst)
{
  return ((AssocList_t) UdchClient (lst))->Pattern;
}

char * assListExec (Dchain_t lst)
{
  return ((AssocList_t) UdchClient (lst))->Exec;
}

char * assListMode (Dchain_t lst)
{
  if (((AssocList_t) UdchClient (lst))->Mode & CMD_XTERM)
    return "xterm";
  else
    return "bg";
}

char * assListDescr (Dchain_t lst)
{
  return ((AssocList_t) UdchClient (lst))->Descr;
}

int assListSaveExec (Dchain_t lst, char * assExec)
{
  AssocList_t assLst;
  if (assExec == NULL || strlen (assExec) == 0)
    return False;
  assLst = (AssocList_t) UdchClient (lst);
  assLst->Exec = StrReplace (assLst->Exec, assExec);
  return True;
}

int assListSaveDescr (Dchain_t lst, char * Descr)
{
  AssocList_t assLst;
  assLst = (AssocList_t) UdchClient (lst);
  assLst->Descr = StrReplace (assLst->Descr,
				  Descr != NULL
				  ? Descr
				  : "");
  return True;
}
int assListSaveMode (Dchain_t lst, char * mode)
{
  AssocList_t assLst;
#if 0
  if (strcmp (mode, "bg") != 0 &&
      strcmp (mode, "xterm") != 0)
    return False;
#endif
  assLst = (AssocList_t) UdchClient (lst);
  assLst->Mode = (strcmp (mode, "bg") == 0 || strcmp (mode, "Bg") == 0
		   ? CMD_BACKGROUND
		   : CMD_XTERM);
  return True;
}

int assListChng (Dchain_t lst, char * newName)
{
  AssocList_t assLst;

  if (newName == NULL || strlen (newName) == 0)
    return False;
  assLst = ((AssocList_t) UdchClient (lst));
  assLst->Pattern = StrReplace (assLst->Pattern, newName);
  return True;
}

int assSave (Dchain_t top, Conf_t cnf)
{
  int i;
  Dchain_t dch;
  if (top == NULL)
    return False;
    
  confDelSect (cnf,
	       top == assList ? ASS_SECT : ICON_EXT_SECT);
	       
  for (dch = UdchNext (top), i=0;
       dch != NULL;
       dch = UdchNext (dch), i++)
    {
      char *argv[5];
      char tmp[32];
      sprintf (tmp, "%i", i);
      argv[0] = tmp;
      argv[1] = assListPattern (dch);
      argv[2] = assListExec (dch);
      argv[3] = assListMode (dch);
      argv[4] = assListDescr (dch);
      confAppend (cnf, '=',
  		  top == assList ? ASS_SECT : ICON_EXT_SECT,
                  5, argv);
    }
  return True;
}

int assRead (Dchain_t top, Conf_t cnf)
{
  Dchain_t newAss;
  char * p, line [CNF_MAXPARAMLEN];
  int i, pos;

  if (top == NULL || cnf == NULL)
    return False;

  /* section position */
  pos = confSectPos (cnf,
  		     top == assList ? ASS_SECT : ICON_EXT_SECT);
  if (pos >= 0)
    {
      /* Skip section name */
      confReLine (cnf, True);
      for (p = confReLine (cnf, True), i = 0;
	   p != NULL && p[0] != '[';
	   p = confReLine (cnf, True), i++)
	{
	  if (! Ureadarg (p, line, 1, '='))
	    continue;
	  
	  newAss = assListAdd (top, line);
	  if (newAss == NULL)
	    continue;
	  
	  if (! Ureadarg (p, line, 2, '='))
	    continue;
	  assListSaveExec (newAss, line);
	  
	  if (! Ureadarg (p, line, 3, '='))
	    continue;
	  assListSaveMode (newAss, line);
	  
	  if (! Ureadarg (p, line, 4, '='))
	    continue;
	  assListSaveDescr (newAss, line);
	}
    }

  /** add default list to the association list */
  if (UdchNext (top) == NULL)
    {
      struct list
	{
	  char * p;
	  char * e;
	  char * m;
	  char * d;
      };
      struct list defAssList[] =
	{
	  /* image files */
	  {"*.ps", "ghostview", "bg", "Postscript file"},
	  {"*.bm", "bitmap", "bg", "Bitmap Image"},
	  {"*.bitm", "bitmap", "bg", "Bitmap Image"},
	  {"*.pixm", "pixmap", "bg", "Pixmap Image"},
	  {"*.xpm", "sxpm", "bg", "Xpm Image"},
	  {"*.jpeg", "xv", "bg", "JPeg Image"},
	  {"*.jpg", "xv", "bg", "JPeg Image"},
	  {"*.bmp", "xv", "bg", "BMP Image"},
	  {"*.gif", "xv", "bg", "GIF Image"},
	  {"*.icon", "bitmap", "bg", "Bitmap Image"},
	  {"*.html", "netscape", "bg", "WWW Site"},

	  /* Text files */
	  {"*.[c|h]", "vi", "xterm", "C Program source"},
	  {"*.txt", "vi", "xterm", "Text file"},
	  {"[R|r]eadme", "vi", "xterm", "Readme"},
	  {"README", "vi", "xterm", "Readme"},
	  {"[M|m]akefile", "make -f", "xterm", "Makefile for a project"},

	  /* compressed files */
	  {"*.tgz", "cat %f|gzip -d|tar -tvf -|less", "xterm", "Gzip Tar Archive"},
	  {"*.taz", "cat %f|uncompress|tar -tvf -|less", "xterm", "Compressed Tar Archive"},
	  {"*.tar.gz", "cat %f|gzip -d|tar -tvf -|less", "xterm", "Gzip Tar Archive"},
	  {"*.tar", "tar -tvf|less", "xterm", "Gzip Tar Archive"},
	  {"*.cpio", "cpio -itv -I|less", "xterm", "CPIO Archive"},
	  {"*.mpg", "mpeg", "bg", "MPEG Video film"},
	  {"*.mpeg", "mpeg", "bg", "MPEG Video film"},
	  {"*.avi", "mpeg", "bg", "AVI Video film"},
	  {NULL,NULL,NULL}
	};
      struct list defIconExtList[] =
        {
	  {"*.xpm",  "*", "*", "Xpm Bitmap"},
	  {"*.pixm", "*", "*", "Xpm Bitmap"},
	  {"*.icon", "*", "*", "Bitmap"},
	  {"*.xbm",  "*", "*", "X11 Bitmap"},
	  {"*.bitm", "*", "*", "X11 Bitmap"},
	  {"*.bm",   "*", "*", "X11 Bitmap"},
	  {"xm_*",   "*", "*", "X11 Bitmap"},
	  {NULL,NULL,NULL}
	};
      struct list *defList;
      
      if (top == assList)
        defList = defAssList;
      else
        defList = defIconExtList;
	
      for (i=0; defList[i].p != NULL; i++)
	{
	  newAss = assListAdd (top, defList[i].p);
	  if (newAss == NULL)
	    continue;
	  assListSaveExec  (newAss, defList[i].e);
	  assListSaveMode  (newAss, defList[i].m);
	  assListSaveDescr (newAss, defList[i].d);
	}
    }

  return True;
}

Associate_t assMake (Dchain_t *top)
{
  Associate_t ass;

  ass = gcalloc (sizeof (associate_t), __LINE__, __FILE__);

  if (ass == NULL)
    return NULL;

  if (*top == NULL)
    {
      ass->assList =
	*top =
	  assListAdd (NULL, "TOP");
    }
  else
    ass->assList = *top;

  return ass;
}

int assView (Associate_t *assWin, Dchain_t *top)
{
  Associate_t ass = *assWin;
  mAppData_t assAppData;
  Widget paned;
  Arg args [10];
  Dimension width = 0, maxw = 0;
  int i, j, n, ret;

  if (ass == NULL)
    {
      ass = *assWin = assMake (top);
      if (ass == NULL)
	return False;
    }

  if (ass->shlAss != NULL)
    {
      XMapRaised (XtDisplay (ass->shlAss), XtWindow  (ass->shlAss));
      return True;
    }

  ret = winCreate ("Association list",
		   &ass->shlAss,
		   &ass->winAss,
		   &ass->fomMain,
		   4,
		   ass,
		   (void (*)(Widget, void*)) assHideCB,
		   False);

  if (ret == False)
    return False;

  mnuMake (ass->winAss, assMenu, ass);
  
  ass->btnOk =
    XtVaCreateManagedWidget ("Close",
			     xmPushButtonGadgetClass,
			     ass->fomMain,
			     XmNleftAttachment,   XmATTACH_POSITION,
			     XmNleftPosition,     1,
			     XmNrightAttachment,  XmATTACH_POSITION,
			     XmNrightPosition,    3,
			     XmNbottomAttachment, XmATTACH_FORM,
			     XmNtopOffset,      SPACE,
			     XmNleftOffset,     SPACE,
			     XmNrightOffset,    SPACE,
			     XmNbottomOffset,   SPACE,
			     NULL);
  XtAddCallback (ass->btnOk, XmNactivateCallback, 
		 (XtCallbackProc) btnAssOkCB,
		 ass);
  mwinSetPixmapToWidget (ass->btnOk, PIXM_tool_abort48,  MWIN_LOADANDSET);
  mwinSetPixmapToWidget (ass->btnOk, PIXM_tool_abortd48, MWIN_DISABLED);
  XtManageChild (ass->btnOk);
  
  memset (&assAppData, 0, sizeof (mAppData_t));
  if (ass->assList == assList)
  {
    assAppData.ListCount       = 4;
  }
  else
  {
    assAppData.ListCount       = 2;
  }
  
  i=0;
  assAppData.Titles      [i++] = "Pattern";
  if (ass->assList == assList)
  {
  assAppData.Titles      [i++] = "Execute";
  assAppData.Titles      [i++] = "Bg/Xterm";
  }
  assAppData.Titles      [i++] = "Info";

  i=0;
  assAppData.MesgArea    [i++] = ASS_PATTERN;
  if (ass->assList == assList)
  {
  assAppData.MesgArea    [i++] = ASS_EXEC;
  assAppData.MesgArea    [i++] = ASS_MODE;
  }
  assAppData.MesgArea    [i++] = ASS_DESCR;

  i=0;
  assAppData.txtLength   [i++] = MAX_INFO_LEN / 2;
  if (ass->assList == assList)
  {
  assAppData.txtLength   [i++] = MAX_INFO_LEN;
  assAppData.txtLength   [i++] = MAX_INFO_LEN / 3;
  }
  assAppData.txtLength   [i++] = MAX_INFO_LEN;

  i=0;
  assAppData.txtForm     [i++] = IsInfoFrm;
  if (ass->assList == assList)
  {
  assAppData.txtForm     [i++] = IsInfoFrm;
  assAppData.txtForm     [i++] = IsInfoFrm;
  }
  assAppData.txtForm     [i++] = IsInfoFrm;

  i=0;
  assAppData.ClValues    [i++] = assListPattern;
  if (ass->assList == assList)
  {
  assAppData.ClValues    [i++] = assListExec;
  assAppData.ClValues    [i++] = assListMode;
  }
  assAppData.ClValues    [i++] = assListDescr;

  i=0;
  assAppData.ClSaveOthers[i++] = NULL;		/* Immer nicht belegt */
  if (ass->assList == assList)
  {
  assAppData.ClSaveOthers[i++] = assListSaveExec;
  assAppData.ClSaveOthers[i++] = assListSaveMode;
  }
  assAppData.ClSaveOthers[i++] = assListSaveDescr;
  assAppData.ClData          = ass;
  assAppData.ClList          = ass->assList;
  assAppData.ClDisp          = (int(*)(Dchain_t,void*)) assDisp;
  assAppData.ClSave          = (int(*)(Dchain_t,void*)) assCheckin;
  assAppData.ClDestroy       = (int(*)(void*))          assListDest;
  assAppData.ClMake          = (void*(*)(char*))        assListMake;
  assAppData.ClChange        = (int(*)(Dchain_t,void*)) assListChng;
  assAppData.ClCompare       = (int(*)(void*,void*))    assListComp;
  ass->aplThema = maplCreate (ass->fomMain, &assAppData);
  XtVaSetValues (ass->aplThema->fomApl,
		 XmNtopAttachment,    XmATTACH_FORM,
		 XmNleftAttachment,   XmATTACH_FORM,
		 XmNrightAttachment,  XmATTACH_FORM,
		 XmNbottomAttachment, XmATTACH_WIDGET,
		 XmNbottomWidget,     ass->btnOk,
		 XmNtopOffset,        SPACE,
		 XmNleftOffset,       SPACE,
		 XmNrightOffset,      SPACE,
		 XmNbottomOffset,     SPACE,
		 NULL);
  XtManageChild (ass->aplThema->fomApl);

  XtManageChild (ass->fomMain);
  XtManageChild (ass->winAss);

  maplRedisp (ass->aplThema);

  XtVaSetValues (ass->shlAss,
  		XmNmaxWidth, 1024,
		NULL);
		
  MXtRealizeWidget (ass->shlAss);
  
  return True;
}
