/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: xcommand.c,v 1.3 1996/10/28 05:44:01 khamis Exp khamis $
 * $Source: /home/xkhfm/xkhlib/xkhsrc/RCS/xcommand.c,v $
 */
#define IS_EXTERN
#define EXTERN		extern

#define WINMENU_NO_CLOSE

#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>
#include <Xm/DrawnB.h>
#include "Xinc.h"
#include <Xm/Command.h>
#include "defines.h"

#ifdef HAVE_THREAD
#include <thread.h>
#endif

#include "Umem.h"
#include "Uxutil.h"
#include "Umessage.h"
#include "Umenu.h"
#include "Urcnfvoid.h"
#include "Ureadarg.h"
#include "Ufileutil.h"
#include "Ustrutil.h"
#include "Ucnfutil.h"
#include "about.h"
#include "quit.h"
#include "help.h"
#include "mainwin.h"
#include "window.h"
#include "xmisc.h"

/***********************************/
/* Histroy manipulation functions **/
/***********************************/

static char HistTitle[] = "\n";

char * cmdListMake (char * Name)
{
  return StrReplace (NULL, Name);
}
int cmdListDest (char * cmd)
{
  StrReplace (cmd, NULL);
  return True;
}
int cmdListComp (char * cmd, char * Name)
{
  return -1;	/* add to the end of list */
}
Dchain_t cmdAdd   (Dchain_t top, char * Name)
{
  static char * lastCmd = NULL;

  /* do't add the same command to history */
  if (Name == NULL || lastCmd != NULL && strcmp (lastCmd, Name) == 0)
    return NULL;
  lastCmd = StrReplace (lastCmd, Name);

  return UdchAdd (top, Name,
		  (void * (*) (void *))         cmdListMake,
		  (int    (*) (void *, void *)) cmdListComp);
}

int cmdExecCmd (char * pwd, char * Cmd, int mode)
{
  char * tmpCmd = NULL, * tmpCmd1 = NULL;
  int ret = True, cmdLen, cmdLen1;

  if (Cmd == NULL || Cmd[0] == '\0')
    return False;


  if (mode & (EXEC_BACKGROUND|EXEC_IN_XTERM|EXEC_EDIT|EXEC_ASSOCIATED))
    {
      /* execute associated program with the file */
      if (mode & EXEC_ASSOCIATED)
	{
	  Dchain_t dch;
	  for (dch = UdchNext (assList);
	       dch != NULL;
	       dch = UdchNext (dch))
	    {
	      if (IsRegular (assListPattern (dch), basename (Cmd)))
		break;
	    }
	  if (dch != NULL)
	    {
	      /** replace the macros */
	      int i, j, found = False;
	      int len = strlen (assListExec (dch));
	      char
		* p = assListExec (dch),
		* tstr = malloc  (len + 1);
	      char oc = 0;
	      for (i=j=0,tstr[0]=0; p[i] != 0; i++)
		{
		  if (p[i] == '%' && oc != '\\' && p[i+1] != 0)
		    {
		      switch (p[i+1])
			{
			case 'f':
			case 'p':
			  found = True;
			  len += strlen(Cmd);
			  tstr = realloc (tstr, len + 1);
			  strcpy (tstr+strlen(tstr), Cmd);
			  j = strlen (tstr);
			  i++;
			  break;
			default:
			  tstr [j++] = p[i];
			  break;
			}
		    }
		  else
		    {
		      tstr [j++] = p[i];
		    }
		  tstr[j] = 0;
		  oc = p[i];
		}

	      if (strcmp (assListMode (dch), "xterm") == 0)
		{
		  cmdLen1
		    = strlen (tstr)
		    + strlen (Cmd)
		    + strlen (XtermCommand)
		    + 8;
		  tmpCmd1 = gcalloc (cmdLen1, __LINE__, __FILE__);
		  sprintf (tmpCmd1, "%s %s",
			   tstr,
			   found ? "" : Cmd);
		  mode |= EXEC_IN_XTERM;
		}
	      else
		{
		  cmdLen
		    = strlen (tstr)
		    + strlen (Cmd)
		    + strlen (XtermCommand)
		    + 8;
		  tmpCmd = gcalloc (cmdLen, __LINE__, __FILE__);
		  sprintf (tmpCmd, "%s %s &",
			   tstr,
			   found ? "" : Cmd);
		}
	      MFree (tstr, strlen(tstr)+1);
	    }
	  else
	    mode |= EXEC_EDIT;
	}

      /* Exec in background */
      if (mode & EXEC_BACKGROUND)
	{
	  cmdLen = strlen (Cmd) + 3;
	  tmpCmd = gcalloc (cmdLen, __LINE__, __FILE__);
	  
	  sprintf (tmpCmd, "%s &", Cmd);
	}
      else if (mode & EXEC_IN_XTERM)
	{
	  static char waitStr [] = 
	    "\necho [press return to close window]"
	      "\nread abc\n";
	  char * pname, *XtermTitle = NULL, *q;
	  int fDest, TitleLen, i, j;
	  
	  /* remove old file */
	  if (CommandFile != NULL)
	    {
	      remove (CommandFile);
	      free   (CommandFile);
	    }
	  CommandFile = (char *) tempnam ("/tmp/", "Xkh");
	  fDest = open (CommandFile, O_WRONLY|O_TRUNC|O_CREAT, 0700);
	  if (fDest < 0 || CommandFile == NULL)
	    {
	      return False;
	    }

	  /* change to the latest work directory */
	  pname = pwd;
	  write (fDest, "cd ", strlen ("cd "));
	  write (fDest, pname, strlen (pname));
	  write (fDest, "\n", strlen ("\n"));
	  if (mode & EXEC_ASSOCIATED)
	    write (fDest, tmpCmd1, strlen (tmpCmd1));
	  else
	    write (fDest, Cmd, strlen (Cmd));
	  write (fDest, waitStr, strlen (waitStr));
	  close (fDest);

	  q = mode & EXEC_ASSOCIATED ? tmpCmd1 : Cmd;
	  TitleLen = strlen (q) + StrShellSpecialCnt (q);
	  XtermTitle = gmalloc (TitleLen + 1, __LINE__, __FILE__);
	  for (i=j=0; q[i] != 0 && j < 90; i++)
	    {
	      static char * s = "\\\"'`$&";
	      if (StrShellSpecial(q[i]))
		XtermTitle[j++] = '\\';
	      XtermTitle[j++] = q[i];
	    }
	  XtermTitle[j] = 0;
	    

	  cmdLen = (strlen (XtermCommand)
		    + strlen (XtermTitle)
		    + strlen (CommandFile)
		    + 30);
	  tmpCmd = gmalloc (cmdLen, __LINE__, __FILE__);

	  sprintf (tmpCmd,
		   "%s -title \"%s\" -e %s &",
		   XtermCommand, 
		   XtermTitle,
		   CommandFile);

	  MFree (XtermTitle, TitleLen+1);
	}
      else if (mode & EXEC_EDIT)
	{
	  cmdLen = strlen (Cmd) + strlen (EditCommand) + 5;
	  tmpCmd = gcalloc (cmdLen, __LINE__, __FILE__);
	  sprintf (tmpCmd, "%s %s &", EditCommand, Cmd);
	}
      DEBUG2 ("cmdExecComm: Commandline(%s)\n", tmpCmd);

#if 0
      /* change to the latest work directory */
      dirChangeDir (CurrentPath);
#endif

      /* returns 0x0, when successfull **/
      ret = system (tmpCmd);
    }
  
  if (tmpCmd != NULL)
    MFree (tmpCmd, cmdLen);
  if (tmpCmd1 != NULL)
    MFree (tmpCmd1, cmdLen1);
  return (ret == 0);
}

int cmdViewCurrentPath (Command_t cmd)
{
  static char tmpS[] = "Program Starter [%s]";
  char * tmp;

  /* view current work directory on the status bar */
  if (cmd == NULL)
    return False;

  cmd->Pwd = StrReplace (cmd->Pwd, CurrentPath);

  if (cmd->dlgCmd == NULL)
    return True;

  tmp = gmalloc (strlen (cmd->Pwd) + strlen (tmpS) + 1, __LINE__, __FILE__);
  sprintf (tmp, tmpS, cmd->Pwd);

  SetWindowTitle (cmd->dlgCmd, tmp);
  XtVaSetValues  (cmd->dlgCmd,
		  XtNiconName, tmp,
		  NULL);

  MFree (tmp, strlen (tmp)+1);

  return True;
}

char * cmdGetCommand (Command_t cmd)
{
  Widget child;
  char * Cmd = NULL;
  child = XmCommandGetChild (cmd->cmdComm, XmDIALOG_COMMAND_TEXT);
  Cmd   = XmTextGetString   (child);
  if (Cmd == NULL)
    return NULL;
  if (Cmd [0] == '\0')
    {
      XtFree (Cmd);
      return NULL;
    }
  return Cmd;
}

void cmdFlaggsCB (Widget w, Command_t cmd)
{
}

int cmdError (char * file, Command_t cmd)
{
  char Mess [MAXPATHLEN];
  int ret;
  sprintf (Mess, "Error by executing the command\n[%s]", file);
  ret = MessageBox (cmd->dlgCmd,
		    "CommandError",
		    Mess,
		    XmDIALOG_ERROR,
		    OK_BUTTON | DONOT_SETTITLE,
		    NULL, NULL);
  return True;
}

void cmdCommCB (Widget w, Command_t cmd, XmCommandCallbackStruct * cbs)
{
  char * Cmd;

  if (cbs->length <= 0)
    return;

  BaisyCursor (cmd->dlgCmd);

  XmStringGetLtoR (cbs->value, XmSTRING_DEFAULT_CHARSET, &Cmd);

  if (Cmd != NULL && Cmd[0] != '\0')
    {
      if (XmToggleButtonGadgetGetState (cmd->radCmdFlaggs->btnRadio[0]))
	cmdExecCmd (cmd->Pwd, Cmd, EXEC_BACKGROUND);
      else
	cmdExecCmd (cmd->Pwd, Cmd, EXEC_IN_XTERM);

      /* add the command to history */
      cmdAdd (cmd->cmdList, Cmd);
    }
  if (Cmd != NULL)
    XtFree (Cmd);

  NormalCursor (cmd->dlgCmd);
}

void btnCmdOkCB (Widget w, Command_t cmd)
{
  char * Cmd;

  Cmd = cmdGetCommand (cmd);
  if (Cmd == NULL) return;

  BaisyCursor (cmd->dlgCmd);

  if (Cmd[0] != 0)
    {
      if (XmToggleButtonGadgetGetState (cmd->radCmdFlaggs->btnRadio[0]))
	cmdExecCmd (cmd->Pwd, Cmd, EXEC_BACKGROUND);
      else
	cmdExecCmd (cmd->Pwd, Cmd, EXEC_IN_XTERM);

      cmdAddToList (cmd, Cmd);
    }

  XtFree (Cmd);

  NormalCursor (cmd->dlgCmd);
}

void btnCmdCloseCB (Widget w, Command_t cmd)
{
  cmdHide (cmd);
}

static menuitem_t itemCommand [] =
{
  { (void(*)(Widget,void*)) btnCmdOkCB, "Run", True, NULL },
  { NULL, MENU_SEPARATOR, False, NULL },
  { (void(*)(Widget,void*)) btnCmdCloseCB, "Close", True, NULL },
  { NULL, NULL }
};

static menu_t menuCommand [] =
{
  { "Starter", itemCommand, True, NULL },
  { "Window",  itemWinMenu, True, NULL },
  { NULL, NULL, False, NULL }
};


menuitem_t itemCmdFlags [] =
{
  { (void (*) (Widget, void *)) cmdFlaggsCB, "Background",
      True, NULL },
  { (void (*) (Widget, void *)) cmdFlaggsCB, "In Xterm",
      True, NULL },
  { NULL, NULL}
};
menu_t mnuCmdFlaggs [] =
{ 
  { "Command Flaggs", itemCmdFlags, True, NULL },
  { NULL, NULL }
};

int cmdAddToList (Command_t cmd, char * Cmd)
{
  Dchain_t dchC;
  if (cmdHist == NULL)
    {
      winListAddCmd (winList, "command");
    }
  if (cmdHist == NULL)
    return False;

  /* add the command to history */
  dchC = cmdAdd (cmdList, Cmd);
  if (dchC != NULL && cmdHist->dlgCmd != NULL)
    {
      Widget list = XmCommandGetChild (cmdHist->cmdComm,
				       XmDIALOG_HISTORY_LIST);
      int lines;
      listAddItem  (list, Cmd, False);
      /* select last item */
      XmListSelectPos (list, 0, False);
      XtVaGetValues (list,
		     XmNvisibleItemCount, &lines,
		     NULL);
      XmListSetPos    (list, max (1, listCount (list) - lines + 1));
    }
  return True;
}
Command_t cmdMake (void)
{
  Command_t cmd;
  Conf_t cnf;
  char HistFile[MAXPATHLEN];
  char * p;
  int i;

  if (cmdHist == NULL)
    {
      cmd = cmdHist = gcalloc (sizeof (command_t), __LINE__, __FILE__);
      if (cmd == NULL)
	return NULL;
      cmd->Pwd     = StrReplace (cmd->Pwd, ".");
      cmd->cmdList = cmdList = cmdAdd (NULL, "TOP");

      /* read command history */
      sprintf (HistFile, "%s/%s", getenv ("HOME"), ".khhistory");
      cnf = confOpen (HistFile, HistTitle);
      if (cnf == NULL)
	return cmd;
      cnf->Comment = '\0';	/* no comments */
      for (p = confReLine (cnf, True), i = 0;
	   p != NULL;
	   p = confReLine (cnf, True), i++)
	{
	  if (p[0] != '\0')
	    cmdAdd (cmd->cmdList, p);
	}
      confClose (cnf);
    }
  else
    cmd = cmdHist;

  return cmd;
}

char * cmdName (Command_t cmd)
{
  static char tmp[MAXPATHLEN];
  static char fmt[] = "Command Starter [%s]";
  sprintf (tmp, fmt,
           dirCutPath (cmd->Pwd,
	               MNU_STRLEN - strlen(fmt) - 1,
		       False));
  return tmp;
}

Widget cmdShell (Command_t cmd)
{
  return cmd->dlgCmd;
}

int cmdHide (Command_t cmd)
{
  int i;

  if (cmd->dlgCmd != NULL)
    {
      if (cmd->Locked)
	{
	  XMapRaised (XtDisplay (cmd->dlgCmd), XtWindow (cmd->dlgCmd));
	  XBell (display, 0);
	  return False;
	}
#if 1
      XtUnmapWidget (cmd->dlgCmd);
#else
      radDest (cmd->radCmdFlaggs);
      XtDestroyWidget (cmd->dlgCmd);
      cmd->dlgCmd = NULL;
#endif
    }

  return True;
}

int cmdDest (Command_t cmd)
{
  if (cmd == NULL)
    return False;

  if (! cmdHide (cmd))
    return False;

  if  (cmd->dlgCmd != NULL)
    {
      radDest (cmd->radCmdFlaggs);
      XtDestroyWidget (cmd->dlgCmd);
      cmd->dlgCmd = NULL;
      if (cmd == cmdHist)
	cmdHist = NULL;
    }

  StrReplace (cmd->Cmd, NULL);
  StrReplace (cmd->Pwd, NULL);
  MFree (cmd, sizeof (command_t));
  return True;
}

int cmdView (Widget parent, Command_t cmd)
{
  Dchain_t dch;
  Widget list;
  int ret, n, i;
  Arg args [10];

  /* Rong call or command process is running */
  if (cmd == NULL || /*parent == NULL || */ cmd->Locked)
    {
      XBell (display, 0);
      return False;
    }
  
  if (cmd->dlgCmd != NULL)
    {
      XMapRaised (XtDisplay (cmd->dlgCmd), XtWindow (cmd->dlgCmd));
      return True;
    }
  cmd->Parent = parent;

  DEBUG1 ("cmdView:");

  ret = winCreate (/*parent,*/
		   "Program Starter",
		   &cmd->dlgCmd,
		   &cmd->winCmd,
		   &cmd->fomMain,
		   6,
		   cmd,
		   (void (*)(Widget, void*)) btnCmdCloseCB,
		   False);
  if (ret == False)
    return False;
  mnuMake (cmd->winCmd, menuCommand, cmd);

#if 0
  /* add readed coordinates from ressource file, if avail. */
  XtAddEventHandler (cmd->dlgCmd, StructureNotifyMask, False,
		     (XtEventHandler) winSetCoordCB,
		     cmd);
  /* Merk the state of a window */
  XtAddEventHandler (cmd->dlgCmd, StructureNotifyMask, False,
		     (XtEventHandler) winSetStateCB,
		     cmd);
#endif

  XtVaSetValues (cmd->fomMain,
		 XmNtopOffset,     SPACE,
		 XmNrightOffset,   SPACE,
		 XmNleftOffset,    SPACE,
		 XmNbottomOffset,  SPACE,
		 NULL);

  cmd->btnClose =
    XtVaCreateManagedWidget ("Close",
			     xmPushButtonGadgetClass,
			     cmd->fomMain,
			     XmNrightAttachment,  XmATTACH_POSITION,
			     XmNrightPosition,    5,
			     XmNleftAttachment,   XmATTACH_POSITION,
			     XmNleftPosition,     4,
			     XmNbottomAttachment, XmATTACH_FORM,
			     XmNtopOffset,      SPACE,
			     XmNleftOffset,     SPACE,
			     XmNrightOffset,    SPACE,
			     XmNbottomOffset,   SPACE,			     
			     NULL);
  XtAddCallback (cmd->btnClose, XmNactivateCallback, 
		 (XtCallbackProc) btnCmdCloseCB,
		 cmd);
  btnMesgArea   (cmd->btnClose, CMD_CLOSE);
  mwinSetPixmapToWidget (cmd->btnClose, PIXM_tool_abort48, MWIN_LOADANDSET);
  mwinSetPixmapToWidget (cmd->btnClose, PIXM_tool_abortd48, MWIN_DISABLED);
  XtManageChild (cmd->btnClose);
  
  cmd->btnOk =
    XtVaCreateManagedWidget ("Execute",
			     xmPushButtonGadgetClass,
			     cmd->fomMain,
			     XmNleftAttachment,   XmATTACH_POSITION,
			     XmNleftPosition,     1,
			     XmNrightAttachment,  XmATTACH_POSITION,
			     XmNrightPosition,    2,
			     XmNbottomAttachment, XmATTACH_FORM,
			     XmNtopOffset,      SPACE,
			     XmNleftOffset,     SPACE,
			     XmNrightOffset,    SPACE,
			     XmNbottomOffset,   SPACE,			     
			     NULL);
  XtAddCallback (cmd->btnOk, XmNactivateCallback, 
		 (XtCallbackProc) btnCmdOkCB,
		 cmd);
  btnMesgArea   (cmd->btnOk, CMD_OK);
  mwinSetPixmapToWidget (cmd->btnOk,    PIXM_tool_run48,   MWIN_LOADANDSET);
  XtManageChild (cmd->btnOk);
  
  cmd->radCmdFlaggs = radCreate (cmd->fomMain,
				 mnuCmdFlaggs,
				 CMD_FLAGGS,
				 cmd,
				 RADIO_BOX);
  XtVaSetValues (cmd->radCmdFlaggs->radRadio,
		 XmNnumColumns,       2,
		 XmNrightAttachment,  XmATTACH_FORM,
		 XmNleftAttachment,   XmATTACH_FORM,
		 XmNbottomAttachment, XmATTACH_WIDGET,
		 XmNbottomWidget,     cmd->btnOk,
		 XmNtopOffset,        SPACE,
		 XmNrightOffset,      SPACE,
		 XmNleftOffset,       SPACE,
		 XmNbottomOffset,     SPACE,
		 NULL);

  /* Execute in background */
  XmToggleButtonGadgetSetState (cmd->radCmdFlaggs->btnRadio[0],
				cmd->Flaggs & CMD_BACKGROUND ? True : False,
				False);
  /* Execute in Xterm */
  XmToggleButtonGadgetSetState (cmd->radCmdFlaggs->btnRadio[1],
				cmd->Flaggs & CMD_BACKGROUND ? False : True,
				False);

  n=0;
  XtSetArg (args[n], XmNhistoryVisibleItemCount, 2); n++;
  XtSetArg (args[n], XmNtopAttachment,    XmATTACH_FORM); n++;
  XtSetArg (args[n], XmNleftAttachment,   XmATTACH_FORM); n++;
  XtSetArg (args[n], XmNrightAttachment,  XmATTACH_FORM); n++;
  XtSetArg (args[n], XmNbottomAttachment, XmATTACH_WIDGET); n++;
  XtSetArg (args[n], XmNbottomWidget,     cmd->radCmdFlaggs->radRadio); n++;
  cmd->cmdComm = XmCreateCommand (cmd->fomMain, "Program Starter", args, n);
  XtAddCallback (cmd->cmdComm, XmNcommandEnteredCallback, 
		 (XtCallbackProc) cmdCommCB,
		 cmd);
  XtManageChild (cmd->cmdComm);

  XtManageChild     (cmd->fomMain);
  XtManageChild     (cmd->winCmd);

  /* Add History Commands to the commandlist */
  list = XmCommandGetChild (cmd->cmdComm, XmDIALOG_HISTORY_LIST);
  XtVaSetValues (list,
		 XmNvisibleItemCount, 10,
		 NULL);
  if (list != NULL)
    for (dch=UdchNext (cmd->cmdList);
	 dch != NULL;
	 dch = UdchNext (dch))
      {
	listAddItem (list, (char*)UdchClient (dch), False);
      }
  XtVaSetValues (cmd->cmdComm,
		 XmNwidth, 200,
		 NULL);

  /*
    XtManageChild     (cmd->dlgCmd);
    XtPopup (XtParent (cmd->dlgCmd), XtGrabNone);
    XMapRaised (XtDisplay (cmd->dlgCmd), XtWindow (cmd->dlgCmd));
  */
  MXtRealizeWidget (cmd->dlgCmd);

  /* actualize the window list in the menu */
  winBuildWinMenu (NULL, NULL);

  cmdViewCurrentPath (cmd);

  DEBUG1 ("cmdView: Ende");

  return True;
}

/********************************************************************/
/** Save commands in history ****************************************/
/********************************************************************/
int cmdSaveHist (Dchain_t cmdList)
{
  Conf_t cnf;
  Dchain_t dch, last;
  char HistFile [MAXPATHLEN];
  
  if (cmdList == NULL || UdchNext (cmdList) == NULL)
    return False;

  sprintf (HistFile, "%s/%s", getenv ("HOME"), ".khhistory");
  cnf = confOpen (HistFile, HistTitle);
  confDelSect (cnf, "");
  cnf->Comment = '\0';	/* no comments */
  /* save history backwords */
  for (last = UdchNext (cmdList);
	last != NULL;
	last = UdchNext (last))
  {
    if (UdchNext (last) == NULL)
    break;
  }
  for (dch = last;
	dch != NULL;
	dch = UdchPrev (dch))
  {
    char *argv[1];
    if (UdchPrev (dch) != NULL)
    {
      argv[0] = (char*) UdchClient (dch);
      confAppend (cnf, '\n', "", 1, argv);
    }
  }
  confClose (cnf);

  return True;
}


