/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: xcopy.c,v 1.3 1996/10/28 05:44:38 khamis Exp khamis $
 * $Source: /home/xkhfm/xkhlib/xkhsrc/RCS/xcopy.c,v $
 */
#define IS_EXTERN
#define EXTERN		extern

#define WINMENU_NO_CLOSE

#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>

#include "Xinc.h"
#include <Xm/DrawingA.h>
#include <Xm/DrawnB.h>

#include "defines.h"

#ifdef HAVE_THREAD
#include <thread.h>
#endif

#include "Umem.h"
#include "Uxutil.h"
#include "Umessage.h"
#include "Umenu.h"
#include "Ufileutil.h"
#include "Ustrutil.h"
#include "Ucnfutil.h"
#include "copy.h"
#include "mainwin.h"
#include "window.h"

int cpyStart (Copy_t cpy);

void cpyFlaggsCB (Widget w, Copy_t cpy)
{
}

int cpyViewState (int copied, int size, Copy_t cpy)
{
  XEvent event;
  Dimension w, h, nw;
  Pixel fg, bg;

  XtVaGetValues (cpy->drwState,
		 XmNwidth,  &w,
		 XmNheight, &h,
		 XmNforeground, &fg,
		 XmNbackground, &bg,
		 NULL);

  nw = max (1, (copied * w) / size);

#if 0
  DEBUG5 ("cpyViewState: copied=(%i), size(%i), w(%i), nw(%i)\n",
	  copied, size, w, nw);
#endif

  XSetForeground (display, theGC, fg);
  XFillRectangle (display, XtWindow (cpy->drwState), theGC,
			0, 0, nw, h);
  XSetForeground (display, theGC, bg);
  XFillRectangle (display, XtWindow (cpy->drwState), theGC,
			nw, 0, w-nw, h);

#ifndef HAVE_THREAD
  XFlush (display);
  XmUpdateDisplay (cpy->dlgCpy);
#endif

  while (XCheckMaskEvent (display, ALL_MASKS, &event))
    {
      /* Do Nothing */
      XtDispatchEvent (&event);
    }

#ifndef HAVE_THREAD
  XFlush (display);
  XmUpdateDisplay (cpy->dlgCpy);
#endif

  if (cpy->Stop)
    return CPY_CANCEL;

  return False;
}

void cpyRedispCB (Widget w, Copy_t cpy, XmDrawingAreaCallbackStruct * cbs)
{
  int width, h;

  if (cbs->window == 0)
    return;

  width = wdgWidth  (w);
  h     = wdgHeight (w);

  if (cbs->reason == XmCR_EXPOSE ||
      cbs->reason == XmCR_RESIZE)
    {
      XClearArea (display,
		  cbs->window,
		  0, 0, width, h,
		  False);
    }
}

int cpyViewFiles (Dchain_t src, Dchain_t dst, Copy_t cpy)
{
  char str[MAXPATHLEN];
  XmString Src, Dest;

  sprintf (str, "Copy %s", dirName (src));
  Src  = XmStringCreateSimple (str);

  sprintf (str, "To %s",   dirName (dst));
  Dest = XmStringCreateSimple (str);

  XtVaSetValues (cpy->lblSrcState, XmNlabelString, Src,  NULL);
  XtVaSetValues (cpy->lblDstState, XmNlabelString, Dest, NULL);

#ifndef HAVE_THREAD
  XFlush (display);

  XmUpdateDisplay (cpy->dlgCpy);
#endif

  XmStringFree (Src);
  XmStringFree (Dest);
  return False;
}

int cpyAsk (Dchain_t src, Dchain_t dst, Copy_t cpy)
{
  char Mess[MAXPATHLEN*2];
  int ret;

  /*
   * MessageBox to ask coping
   *      copy
   *   /usr/gast/x
   *       to
   *     /tmp/x
   */
  sprintf (Mess,
	   "copy\n"
	   "[%s]\n"
	   "to\n"
	   "[%s]\n"
	   "are you shure ?",
	   dirName (src),
	   dirName (dst));

  ret = MessageBox (cpy->dlgCpy,
		    "CopyAsk",
		    Mess,
		    XmDIALOG_QUESTION,
		    OK_BUTTON | CANCEL_BUTTON | HELP_BUTTON |
		    CLOSE_ON_HELP | DONOT_SETTITLE,
		    NULL, NULL);

  if (ret == 0) ret = CPY_YES;
  if (ret == 1) ret = CPY_NO;
  if (ret == 2) ret = CPY_CANCEL;

  return ret;
}

int cpyOverwriteAsk (Dchain_t src, Dchain_t dst, Copy_t cpy)
{
  char Mess[MAXPATHLEN*2];
  int ret;

  /*
   * MessageBox to ask coping
   *      copy
   *   /usr/gast/x
   *       to
   *     /tmp/x
   */
  sprintf (Mess,
	   "overwrite\n"
	   "[%s]\n"
	   "with\n"
	   "[%s]\n"
	   "are you shure ?",
	   dirName (dst),
	   dirName (src));

  ret = MessageBox (cpy->dlgCpy,
		    "OverwriteAsk",
		    Mess,
		    XmDIALOG_QUESTION,
		    OK_BUTTON | CANCEL_BUTTON | HELP_BUTTON |
		    CLOSE_ON_HELP | DONOT_SETTITLE,
		    NULL, NULL);

  if (ret == 0) ret = CPY_YES;
  if (ret == 1) ret = CPY_OVERWRITE;
  if (ret == 2) ret = CPY_CANCEL;

  return ret;
}

extern errno;

int cpyError (Dchain_t dst, Copy_t cpy)
{
  static char Err[] = "The following error is detected \n[%s]\nby copying\n[%s]";
  char * Mess;
  char * ErrMsg;
  int ret;
  int len;
  ErrMsg = strerror (errno);
  len = strlen (Err) + strlen (ErrMsg) + strlen (dirName (dst)) + 1;
  Mess = gmalloc (len, __LINE__, __FILE__);
  sprintf (Mess, Err, ErrMsg, dirName (dst));
  ret = MessageBox (cpy->dlgCpy,
		    "CopyError",
		    Mess,
		    XmDIALOG_ERROR,
		    OK_BUTTON|CANCEL_BUTTON | DONOT_SETTITLE,
		    NULL, NULL);
  MFree (Mess, len);
  if (ret == 1) ret = CPY_CANCEL;
  return ret;
}

void btnStopCB (Widget w, Copy_t cpy)
{
  int ret;
  ret = MessageBox (cpy->dlgCpy,
		    "CopyBreak",
		    "CopyBreak",
		    XmDIALOG_ERROR,
		    OK_BUTTON | 
		    CANCEL_BUTTON |
		    DONOT_SETTITLE |
		    DONOT_SETMESSAGE,
		    NULL, NULL);
  if (ret == 1)
    cpy->Stop = True;
}

void btnCpyOkCB (Widget w, Copy_t cpy)
{
#ifdef HAVE_THREAD
  {
    thread_t newThread;
    int ret;
    DEBUG1 ("btnCpyOkCB: create a new thread");
    ret = thr_create (NULL, 0, (void* (*)(void*)) cpyStart, (void*) cpy,
		      0L, &newThread);
    if (ret != 0)
      {
	DEBUG1 ("btnCpyOkCB: "
		  "Can not create a new Thread, running in normal mode");
	cpyStart (cpy);
      }
    else
      {
	DEBUG1 ("btnCpyOkCB: Thread created");
      }
    DEBUG1 ("btnCpyOkCB: after the new thread");
  }
#else
  cpyStart (cpy);
#endif

}

void btnCpyCloseCB (Widget w, Copy_t cpy)
{
  cpyHide (cpy);
}

menuitem_t itemcpyFlags [] =
{
  { (void (*) (Widget, void *)) cpyFlaggsCB, "Same Rights", True, NULL },
  { (void (*) (Widget, void *)) cpyFlaggsCB, "Same Owner", True, NULL },

  { (void (*) (Widget, void *)) cpyFlaggsCB, "Same Group", True, NULL },
  { (void (*) (Widget, void *)) cpyFlaggsCB, "Copy Links", True, NULL },

  { (void (*) (Widget, void *)) cpyFlaggsCB, "Skip Existing", True, NULL },
  { (void (*) (Widget, void *)) cpyFlaggsCB, "Overwrite Existing", True, NULL },

  { (void (*) (Widget, void *)) cpyFlaggsCB, "Ask for Copying", True, NULL },
  { (void (*) (Widget, void *)) cpyFlaggsCB, "Recursive", True, NULL },
  { (void (*) (Widget, void *)) cpyFlaggsCB, "Move", True, NULL },
  { NULL, NULL}
};
menu_t mnucpyFlaggs [] =
{ 
  { "Copy Flaggs", itemcpyFlags, True, NULL },
  { NULL, NULL }
};

static menuitem_t itemCopy [] =
{
  { (void(*)(Widget,void*)) btnCpyOkCB, "Copy", True, NULL },
  { NULL, MENU_SEPARATOR, False, NULL },
  { (void(*)(Widget,void*)) btnCpyCloseCB, "Close", True, NULL },
  { NULL, NULL }
};

static menu_t menuCopy [] =
{
  { "Copy", itemCopy, True, NULL },
  { "Window", itemWinMenu, True, NULL },
  { NULL, NULL, False, NULL }
};

Copy_t cpyMake (void)
{
  Copy_t cpy;
  cpy = gcalloc (sizeof (copy_t), __LINE__, __FILE__);
  /* Default flags */
  cpy->info.mode |= CPY_SAME_RIGHTS | CPY_RECURSIVE;
  return cpy;
}

char * cpyName (Copy_t cpy)
{
  static char tmp[MAXPATHLEN];
  static char fmt[] = "Copy - Move [%s]";
  sprintf (tmp, fmt,
           dirCutPath (cpy->Source,
	               MNU_STRLEN - strlen(fmt) - 1,
		       False));
  return tmp;
}

Widget cpyShell (Copy_t cpy)
{
  return cpy->dlgCpy;
}

int cpyHide (Copy_t cpy)
{
  
  if (cpy->dlgCpy != NULL)
    {
      if (cpy->Started)
	{
	  XMapRaised (XtDisplay (cpy->dlgCpy), XtWindow (cpy->dlgCpy));
	  XBell (display, 0);
	  return False;
	}
      txtDest (cpy->txtSource);
      txtDest (cpy->txtDst);
      txtDest (cpy->txtFilter);
      txtDest (cpy->txtDonotCopy);
      txtDest (cpy->txtCopy);
      radDest (cpy->radCopyFlaggs);
      XtDestroyWidget (cpy->dlgCpy);
      cpy->dlgCpy = NULL;
      winDelWinMenu (winGetListFromObj (cpy));
    }

  return True;
}

int cpyDest (Copy_t cpy)
{
  if (cpy == NULL)
    return False;

  if (!cpyHide (cpy))
    return False;

  StrReplace (cpy->Source, NULL);
  StrReplace (cpy->info.filter, NULL);
  StrReplace (cpy->info.copy, NULL);
  StrReplace (cpy->info.donotCopy, NULL);
  MFree (cpy, sizeof (copy_t));

  return True;
}

int cpyView (Widget parent, Copy_t cpy)
{
  int ret;
  Widget sep1, sep2, sep3, sep4, sep5;

  /* Rong call or copy process is running */
  if (cpy == NULL || parent == NULL || cpy->Started)
    {
      XBell (display, 0);
      return False;
    }
  
  if (cpy->dlgCpy != NULL)
    {
      XMapRaised (XtDisplay (cpy->dlgCpy), XtWindow (cpy->dlgCpy));

      if (cpy->Source != NULL)
	XmTextSetString (cpy->txtSource->txtText, cpy->Source);
      XmTextSetString (cpy->txtDst->txtText, cpy->Dest);

      return True;
    }
  cpy->Parent = parent;

  DEBUG1 ("cpyView:");

  ret = winCreate ( /*parent,*/
		   "Copy - Move",
		   &cpy->dlgCpy,
		   &cpy->winCpy,
		   &cpy->fomMain,
		   6,
		   cpy,
		   (void(*)(Widget,void*))btnCpyCloseCB,
		   False);
  if (ret == False)
    return False;
  mnuMake (cpy->winCpy, menuCopy, cpy);

  DEBUG1 ("cpyView: fomMain");

  XtVaSetValues (cpy->fomMain,
		 XmNtopOffset,     SPACE,
		 XmNrightOffset,   SPACE,
		 XmNleftOffset,    SPACE,
		 XmNbottomOffset,  SPACE,
		 NULL);

  DEBUG1 ("cpyView: Source");

  cpy->txtSource = txtCreate (cpy->fomMain,
			     "Source",
			      0,
			      NULL,
			      HLP_CPY_SOURCE,
			      False);
  XtVaSetValues (cpy->txtSource->fomText,
		 XmNtopAttachment,    XmATTACH_FORM,
		 XmNleftAttachment,   XmATTACH_FORM,
		 XmNrightAttachment,  XmATTACH_FORM,
		 XmNtopOffset,        SPACE,
		 XmNrightOffset,      SPACE,
		 XmNleftOffset,       SPACE,
		 XmNbottomOffset,     SPACE,
		 NULL);
  /*
  XtSetSensitive  (cpy->txtSource->txtText, False);
  */
  XmTextSetEditable (cpy->txtSource->txtText, False);
  if (cpy->Source != NULL)
    XmTextSetString (cpy->txtSource->txtText, cpy->Source);
  XtManageChild   (cpy->txtSource->fomText);

  DEBUG1 ("cpyView: Destination");

  cpy->txtDst = txtCreate (cpy->fomMain,
			     "Destination",
			      0,
			      NULL,
			      HLP_CPY_DEST,
			      False);
  XtVaSetValues (cpy->txtDst->fomText,
		 XmNtopAttachment,    XmATTACH_WIDGET,
		 XmNtopWidget,        cpy->txtSource->fomText,
		 XmNleftAttachment,   XmATTACH_FORM,
		 XmNrightAttachment,  XmATTACH_FORM,
		 XmNtopOffset,        SPACE,
		 XmNrightOffset,      SPACE,
		 XmNleftOffset,       SPACE,
		 XmNbottomOffset,     SPACE,
		 NULL);
  XmTextSetString (cpy->txtDst->txtText, cpy->Dest);
  XtManageChild   (cpy->txtDst->fomText);

  DEBUG1 ("cpyView: Separator 1");

  sep1 =
    XtVaCreateManagedWidget ("Separator",
			     xmSeparatorGadgetClass,
			     cpy->fomMain,
			     
			     XmNtopAttachment,    XmATTACH_WIDGET,
			     XmNtopWidget,        cpy->txtDst->fomText,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNrightAttachment,  XmATTACH_FORM,
			     XmNtopOffset,        SPACE,
			     XmNrightOffset,      SPACE,
			     XmNleftOffset,       SPACE,
			     XmNbottomOffset,     SPACE,
			     NULL);
  XtManageChild (sep1);

  DEBUG1 ("cpyView: Filter");

  cpy->txtFilter = txtCreate (cpy->fomMain,
			     "Filter",
			      0,
			      NULL,
			      HLP_CPY_FILTER,
			      False);
  XtVaSetValues (cpy->txtFilter->fomText,
		 XmNtopAttachment,    XmATTACH_WIDGET,
		 XmNtopWidget,        sep1,
		 XmNleftAttachment,   XmATTACH_FORM,
		 XmNrightAttachment,  XmATTACH_FORM,
		 XmNtopOffset,        SPACE,
		 XmNrightOffset,      SPACE,
		 XmNleftOffset,       SPACE,
		 XmNbottomOffset,     SPACE,
		 NULL);
  XtSetSensitive (cpy->txtFilter->txtText, False);
  XtManageChild  (cpy->txtFilter->fomText);

  DEBUG1 ("cpyView: Separator 2");

  sep2 =
    XtVaCreateManagedWidget ("Separator",
			     xmSeparatorGadgetClass,
			     cpy->fomMain,			     
			     XmNtopAttachment,    XmATTACH_WIDGET,
			     XmNtopWidget,        cpy->txtFilter->fomText,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNrightAttachment,  XmATTACH_FORM,
			     XmNtopOffset,        SPACE,
			     XmNrightOffset,      SPACE,
			     XmNleftOffset,       SPACE,
			     XmNbottomOffset,     SPACE,
			     NULL);
  XtManageChild (sep2);

  DEBUG1 ("cpyView: Copy");

  cpy->txtCopy = txtCreate (cpy->fomMain,
			    "Copy",
			    0, NULL, HLP_CPY_COPY,
			    False);
  XtVaSetValues (cpy->txtCopy->fomText,
		 XmNtopAttachment,   XmATTACH_WIDGET,
		 XmNtopWidget,	     sep2,
		 XmNleftAttachment,  XmATTACH_FORM,
		 XmNrightAttachment, XmATTACH_FORM,

		 XmNtopOffset,       SPACE,
		 XmNrightOffset,     SPACE,
		 XmNleftOffset,      SPACE,
		 XmNbottomOffset,    SPACE,
		 NULL);
  XmTextSetString (cpy->txtCopy->txtText, "*");
  XtManageChild   (cpy->txtCopy->fomText);

  DEBUG1 ("cpyView: DonotCopy");

  cpy->txtDonotCopy = txtCreate (cpy->fomMain,
				 "Don't Copy",
				 0, NULL, HLP_CPY_DONOTCOPY,
				 False);
  XtVaSetValues (cpy->txtDonotCopy->fomText,
		 XmNtopAttachment,    XmATTACH_WIDGET,
		 XmNtopWidget,	      cpy->txtCopy->fomText,
		 XmNleftAttachment,   XmATTACH_FORM,
		 XmNrightAttachment,  XmATTACH_FORM,
		 XmNtopOffset,     SPACE,
		 XmNrightOffset,     SPACE,
		 XmNleftOffset,     SPACE,
		 XmNbottomOffset,     SPACE,
		 NULL);
  XtManageChild (cpy->txtDonotCopy->fomText);

  DEBUG1 ("cpyView: Separator 3");

  sep3 =
    XtVaCreateManagedWidget ("Separator",
			     xmSeparatorGadgetClass,
			     cpy->fomMain,
			     
			     XmNtopAttachment,    XmATTACH_WIDGET,
			     XmNtopWidget,        cpy->txtDonotCopy->fomText,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNrightAttachment,  XmATTACH_FORM,
			     XmNtopOffset,     SPACE,
			     XmNrightOffset,     SPACE,
			     XmNleftOffset,     SPACE,
			     XmNbottomOffset,     SPACE,
			     NULL);
  XtManageChild (sep3);

  DEBUG1 ("cpyView: Start");

  cpy->btnStart =
    XtVaCreateManagedWidget ("Start",
			     xmPushButtonGadgetClass,
			     cpy->fomMain,
			     XmNdefaultButtonShadowThickness,    2,
			     XmNshowAsDefault,    2,
			     XmNleftAttachment,   XmATTACH_POSITION,
			     XmNleftPosition,     1,
			     XmNrightAttachment,  XmATTACH_POSITION,
			     XmNrightPosition,    2,
			     XmNbottomAttachment, XmATTACH_FORM,
			     XmNtopOffset,      SPACE,
			     XmNleftOffset,     SPACE,
			     XmNrightOffset,    SPACE,
			     XmNbottomOffset,   SPACE,			     
			     NULL);
  XtAddCallback (cpy->btnStart, XmNactivateCallback, 
		 (XtCallbackProc) btnCpyOkCB,
		 cpy);
  btnMesgArea   (cpy->btnStart, HLP_CPY_OK);
  mwinSetPixmapToWidget (cpy->btnStart, PIXM_tool_run48,   MWIN_LOADANDSET);
  XtManageChild (cpy->btnStart);
  
  DEBUG1 ("cpyView: Close");

  cpy->btnClose =
    XtVaCreateManagedWidget ("Close",
			     xmPushButtonGadgetClass,
			     cpy->fomMain,
			     XmNshowAsDefault,    2,
			     XmNrightAttachment,  XmATTACH_POSITION,
			     XmNrightPosition,    5,
			     XmNleftAttachment,   XmATTACH_POSITION,
			     XmNleftPosition,     4,
			     XmNbottomAttachment, XmATTACH_FORM,
			     XmNtopOffset,      SPACE,
			     XmNleftOffset,     SPACE,
			     XmNrightOffset,    SPACE,
			     XmNbottomOffset,   SPACE,			     
			     NULL);
  XtAddCallback (cpy->btnClose, XmNactivateCallback, 
		 (XtCallbackProc) btnCpyCloseCB,
		 cpy);
  btnMesgArea   (cpy->btnClose, HLP_CPY_CLOSE);
  mwinSetPixmapToWidget (cpy->btnClose, PIXM_tool_abort48, MWIN_LOADANDSET);
  mwinSetPixmapToWidget (cpy->btnClose, PIXM_tool_abortd48, MWIN_DISABLED);
  XtManageChild (cpy->btnClose);
  
  DEBUG1 ("cpyView: Separator 5");

  sep5 =
    XtVaCreateManagedWidget ("Separator",
			     xmSeparatorGadgetClass,
			     cpy->fomMain,
			     XmNbottomAttachment, XmATTACH_WIDGET,
			     XmNbottomWidget,     cpy->btnStart,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNrightAttachment,  XmATTACH_FORM,
			     XmNtopOffset,        SPACE,
			     XmNbottomOffset,     SPACE,
			     NULL);
  XtManageChild (sep5);

  DEBUG1 ("cpyView: Drawing Area");

  cpy->drwState = 
    XtVaCreateManagedWidget
      ("DrawingArea",
       xmDrawingAreaWidgetClass,
       cpy->fomMain,
       XmNheight,	    24,
       XmNleftAttachment,   XmATTACH_FORM,
       XmNrightAttachment,  XmATTACH_FORM,
       XmNbottomAttachment, XmATTACH_WIDGET,
       XmNbottomWidget,     sep5,
       XmNrightOffset,      30,
       XmNleftOffset,       30,
       NULL);  
  XtAddCallback (cpy->drwState, XmNexposeCallback,
		 (XtCallbackProc) cpyRedispCB, cpy);
  XtAddCallback (cpy->drwState, XmNresizeCallback,
		 (XtCallbackProc) cpyRedispCB, cpy);
  XtManageChild (cpy->drwState);

  DEBUG1 ("cpyView: DestState");

  cpy->lblDstState =
    XtVaCreateManagedWidget ("To Destination State",
			     xmLabelGadgetClass,
			     cpy->fomMain,			     
			     XmNrightAttachment,  XmATTACH_FORM,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNbottomAttachment, XmATTACH_WIDGET,
			     XmNbottomWidget,     cpy->drwState,
			     XmNtopOffset,        SPACE,
			     XmNleftOffset,       SPACE,
			     XmNrightOffset,      SPACE,
			     XmNbottomOffset,     SPACE,
			     NULL);
  XtManageChild (cpy->lblDstState);

  DEBUG1 ("cpyView: SrcState");

  cpy->lblSrcState =
    XtVaCreateManagedWidget ("Copy Source State",
			     xmLabelGadgetClass,
			     cpy->fomMain,			     
			     XmNrightAttachment,  XmATTACH_FORM,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNbottomAttachment, XmATTACH_WIDGET,
			     XmNbottomWidget,     cpy->lblDstState,
			     XmNtopOffset,        SPACE,
			     XmNleftOffset,       SPACE,
			     XmNrightOffset,      SPACE,
			     XmNbottomOffset,     SPACE,
			     NULL);
  XtManageChild (cpy->lblSrcState);

  DEBUG1 ("cpyView: Separator 4");

  sep4 =
    XtVaCreateManagedWidget ("Separator",
			     xmSeparatorGadgetClass,
			     cpy->fomMain,			     
			     XmNbottomAttachment, XmATTACH_WIDGET,
			     XmNbottomWidget,     cpy->lblSrcState,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNrightAttachment,  XmATTACH_FORM,
			     XmNtopOffset,        SPACE,
			     XmNrightOffset,      SPACE,
			     XmNleftOffset,       SPACE,
			     XmNbottomOffset,     SPACE,
			     NULL);
  XtManageChild (sep4);

  DEBUG1 ("cpyView: Copy Flaggs");

  cpy->radCopyFlaggs = radCreate (cpy->fomMain,
				 mnucpyFlaggs,
				 HLP_CPY_FLAGGS,
				 cpy,
				 TOGGLEE_BOX);
  XtVaSetValues (cpy->radCopyFlaggs->radRadio,
		 XmNnumColumns,       3,
		 XmNtopAttachment,    XmATTACH_WIDGET,
		 XmNtopWidget,        sep3,
		 XmNrightAttachment,  XmATTACH_FORM,
		 XmNleftAttachment,   XmATTACH_FORM,
		 XmNbottomAttachment, XmATTACH_WIDGET,
		 XmNbottomWidget,     sep4,
		 XmNtopOffset,        SPACE,
		 XmNrightOffset,      SPACE,
		 XmNleftOffset,       SPACE,
		 XmNbottomOffset,     SPACE,
		 NULL);
  /* Same Rights */
  XmToggleButtonGadgetSetState (cpy->radCopyFlaggs->btnRadio[0],
				cpy->info.mode & CPY_SAME_RIGHTS ? True : False,
				False);
  /* Same Owner */
  XmToggleButtonGadgetSetState (cpy->radCopyFlaggs->btnRadio[1],
				cpy->info.mode & CPY_SAME_OWNER ? True : False,
				False);
  /* CPY_SAME_GROUP */
  XmToggleButtonGadgetSetState (cpy->radCopyFlaggs->btnRadio[2],
				cpy->info.mode & CPY_SAME_GROUP ? True : False,
				False);
  /* CPY_COPY_LINKS */
  XmToggleButtonGadgetSetState (cpy->radCopyFlaggs->btnRadio[3],
				cpy->info.mode & CPY_COPY_LINKS ? True : False,
				False);
  /* CPY_SKIP_EXISTING */
  XmToggleButtonGadgetSetState (cpy->radCopyFlaggs->btnRadio[4],
				cpy->info.mode & CPY_SKIP_EXISTING
				? True : False,
				False);
  /* CPY_OVERWRITE */
  XmToggleButtonGadgetSetState (cpy->radCopyFlaggs->btnRadio[5],
				cpy->info.mode & CPY_OVERWRITE ? True : False,
				False);
  /* CPY_ASK */
  XmToggleButtonGadgetSetState (cpy->radCopyFlaggs->btnRadio[6],
				cpy->info.mode & CPY_ASK ? True : False,
				False);
  /* CPY_RECURSIVE */
  XmToggleButtonGadgetSetState (cpy->radCopyFlaggs->btnRadio[7],
				cpy->info.mode & CPY_RECURSIVE ? True : False,
				False);
  /* CPY_MOVE */
  XmToggleButtonGadgetSetState (cpy->radCopyFlaggs->btnRadio[8],
				cpy->info.mode & CPY_MOVE ? True : False,
				False);

  XtManageChild (cpy->radCopyFlaggs->radRadio);

  DEBUG1 ("cpyView: Manage fomMain");

  XtManageChild     (cpy->fomMain);
  XtManageChild     (cpy->winCpy);

  DEBUG1 ("cpyView: Manage dlgCpy");

  /*
  XtManageChild     (cpy->dlgCpy);
  XtPopup (XtParent (cpy->dlgCpy), XtGrabNone);
  XMapRaised (XtDisplay (cpy->dlgCpy), XtWindow (cpy->dlgCpy));
  */
  MXtRealizeWidget (cpy->dlgCpy);
  
  DEBUG1 ("cpyView: Ende");

  return True;
}

int cpyStart (Copy_t cpy)
{
  char * files, * dest, * p, * Filter, * CpyFilter, * DonotCpyFilter;
  int pos, count = 0, ret;
  Dchain_t srcList, dstList;
  int Error = False;
  XmString stop;

  /*
   * get copy flaggs
   */
  cpy->info.mode = 0;
  if (XmToggleButtonGadgetGetState (cpy->radCopyFlaggs->btnRadio[0]))
    cpy->info.mode |= CPY_SAME_RIGHTS;

  if (XmToggleButtonGadgetGetState (cpy->radCopyFlaggs->btnRadio[1]))
    cpy->info.mode |= CPY_SAME_OWNER;

  if (XmToggleButtonGadgetGetState (cpy->radCopyFlaggs->btnRadio[2]))
    cpy->info.mode |= CPY_SAME_GROUP;

  if (XmToggleButtonGadgetGetState (cpy->radCopyFlaggs->btnRadio[3]))
    cpy->info.mode |= CPY_COPY_LINKS;

  if (XmToggleButtonGadgetGetState (cpy->radCopyFlaggs->btnRadio[4]))
    cpy->info.mode |= CPY_SKIP_EXISTING;

  if (XmToggleButtonGadgetGetState (cpy->radCopyFlaggs->btnRadio[5]))
    cpy->info.mode |= CPY_OVERWRITE;

  if (XmToggleButtonGadgetGetState (cpy->radCopyFlaggs->btnRadio[6]))
    cpy->info.mode |= CPY_ASK;

  if (XmToggleButtonGadgetGetState (cpy->radCopyFlaggs->btnRadio[7]))
    cpy->info.mode |= CPY_RECURSIVE;

  if (XmToggleButtonGadgetGetState (cpy->radCopyFlaggs->btnRadio[8]))
    cpy->info.mode |= CPY_MOVE;

  /** get file list to copy */
  files = XmTextGetString (cpy->txtSource->txtText);

  /** if empty file list then break */
  if (strlen (files) == 0)
    {
      XtFree (files);
      return False;
    }

  cpy->Started = True;
  cpy->Stop    = False;

  stop = XmStringCreateSimple ("Stop");
  XtVaSetValues    (cpy->btnStart, XmNlabelString, stop, NULL);
  mwinSetPixmapToWidget (cpy->btnStart, PIXM_tool_stop48, MWIN_LOADANDSET);
  XmStringFree     (stop);
  XtRemoveCallback (cpy->btnStart, XmNactivateCallback, 
		    (XtCallbackProc) btnCpyOkCB,
		    cpy);
  XtAddCallback    (cpy->btnStart, XmNactivateCallback, 
		    (XtCallbackProc) btnStopCB,
		    cpy);
  XtSetSensitive   (cpy->btnClose, False);

  /* get the rest of entries */
  dest           = XmTextGetString (cpy->txtDst->txtText);
  Filter         = XmTextGetString (cpy->txtFilter->txtText);
  CpyFilter      = XmTextGetString (cpy->txtCopy->txtText);
  DonotCpyFilter = XmTextGetString (cpy->txtDonotCopy->txtText);

  /* verify, if there are many files to copy */
  for (count=0, pos=0, p=files; p[0] != 0; )
    {
      pos = StrChrIndex (p, ' ');
      if (pos > 0 || p[0] != ' ')
	{
	  count ++;
	}
      if (pos < 0) break;
      p += pos + 1;
    }

  /* for many selections must be the destination a directory or none existing*/
  if (count > 1)
    {
      dstList = dirAdd (NULL, dest);
      if (dirCreateDir (dstList, ~UGetUmask (False) & 0777))
	{
	  ErrorBox (cpy->dlgCpy,
		    "Copy",
		    "For more as one selection the destination must\n"
		    "be a directory or none existing file");
	  Error = True;
	}
      dirDelete (dstList);
    }

  /* Copy the list of selected files */
  if (!Error)
    for (pos=0, p = files; True;)
      {
	pos = StrChrIndex (p, ' ');
	
	if (pos >= 0) p [pos] = 0;
	
	if (strlen (p) > 0)
	  {
	    DEBUG4 ("cpyStart: count (%i) copy (%s) to (%s)\n",
		    count,
		    p,
		    dest);

	    srcList = dirAdd (NULL, p);
	    dstList = dirAdd (NULL, dest);

	    /* when more than one selection or source is a file and dest. */
	    /* is directory then append the name with the destination path */
	    if (count > 1 ||
		(dirType (srcList) != TYPE_DIR &&
		 dirType (dstList) == TYPE_DIR))
	      {
		dirDelete (dstList);
		dstList = dirAdd (NULL, UPathAppend (dest, basename (p)));
	      }

	    cpy->info.filter        = Filter;
	    cpy->info.copy          = CpyFilter;
	    cpy->info.donotCopy     = DonotCpyFilter;
	    cpy->info.ViewProc      = (int (*) (int,int,void*)) cpyViewState;
	    cpy->info.ViewFilesProc = (int (*) (Dchain_t,Dchain_t,void*))
	                              cpyViewFiles;
	    cpy->info.AskProc       = (int (*) (Dchain_t,Dchain_t,void*)) cpyAsk;
	    cpy->info.AskOverwriteProc =
	      (int (*) (Dchain_t,Dchain_t,void*)) cpyOverwriteAsk;
	    cpy->info.ErrProc       = (int  (*) (Dchain_t, void*)) cpyError;
	    cpy->info.ClData        = cpy;
	    cpy->info.mode |=
	      RecursiveCopy (srcList,
			     dstList,
			     &cpy->info);

	    dirDelete (srcList);
	    dirDelete (dstList);
	  }
	if (cpy->info.mode & CPY_CANCEL) break;

	if (pos < 0) break;
	
	p += pos + 1;
      }

  if (files           != NULL) XtFree (files);
  if (dest            != NULL) XtFree (dest);
  if (Filter          != NULL) XtFree (Filter);
  if (CpyFilter       != NULL) XtFree (CpyFilter);
  if (DonotCpyFilter  != NULL) XtFree (DonotCpyFilter);

  ret = cpy->info.mode & (CPY_CANCEL|CPY_ERROR_AVAIL);
  /* If aborted or an error was detected */
  if (ret)
    MessageBox (cpy->dlgCpy,
		"Copy End",
		(cpy->info.mode & CPY_CANCEL)
		? "Copying the selected files is aborted"
		: (cpy->info.mode & CPY_ERROR_AVAIL)
		? "An error detected by coping process"
		: "Copying the selected files is complete",
		XmDIALOG_INFORMATION,
		OK_BUTTON,
		NULL, NULL);

  stop = XmStringCreateSimple ("Start");
  XtVaSetValues (cpy->btnStart, XmNlabelString, stop, NULL);
  mwinSetPixmapToWidget (cpy->btnStart, PIXM_tool_run48, MWIN_LOADANDSET);
  XmStringFree (stop);

  XtRemoveCallback (cpy->btnStart, XmNactivateCallback, 
		    (XtCallbackProc) btnStopCB,
		    cpy);
  XtAddCallback (cpy->btnStart, XmNactivateCallback, 
		 (XtCallbackProc) btnCpyOkCB,
		 cpy);

  XtSetSensitive (cpy->btnClose, True);

  cpy->Stop    = False;
  cpy->Started = False;

  /* hide the copying frame by successfull copying */
#ifndef HAVE_THREAD
  if (!ret)
    cpyHide (cpy);
#endif

  return ret ? False : True;
}

