/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: xfilter.c,v 1.1 1997/01/07 08:35:21 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/xkhlib/xkhsrc/RCS/xfilter.c,v $
 */
#define IS_EXTERN
#define EXTERN		extern

#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>
#include <Xm/DrawnB.h>
#include "Xinc.h"
#include <Xm/Command.h>
#include "defines.h"

#ifdef HAVE_THREAD
#include <thread.h>
#endif

#include "Umem.h"
#include "Uxutil.h"
#include "Umessage.h"
#include "Umenu.h"
#include "Urcnfvoid.h"
#include "Ureadarg.h"
#include "Ufileutil.h"
#include "Ustrutil.h"
#include "Ucnfutil.h"
#include "about.h"
#include "quit.h"
#include "help.h"
#include "mainwin.h"
#include "window.h"
#include "xmisc.h"

extern int errno;
void fltrStartCB (Widget w, Mainwin_t mwin, XmSelectionBoxCallbackStruct * cbs)
{
  char * NewDir;
  int Error = False;

  DEBUG1 ("fltrStart:");

  if (! XmStringGetLtoR (cbs->value, XmFONTLIST_DEFAULT_TAG, &NewDir))
    return;

  /** if empty file list then break */
  if (NewDir == NULL || strlen (NewDir) == 0)
    {
      return;
    }

  DEBUG2 ("fltrStart: Fltr (%s)\n", NewDir);

  BaisyCursor (mwin->shlMainwin);

  mwin->DirFilter = StrReplace (mwin->DirFilter, NewDir);
  mwinReadDir           (mwin);
  mwinViewSelectedIcon  (mwin);
  mwinCalc	 (mwin);
  mwin->FilesViewX = mwin->FilesViewY = 0;
  XMoveWindow (display, XtWindow (mwin->fomFiles), 0, 0);
  scrAddValue (mwin->scrVertFiles,  0, SCR_SET);
  scrAddValue (mwin->scrHorizFiles, 0, SCR_SET);
  mwinRedisp     (mwin);
  mwinDispStatus (mwin);
  
  NormalCursor (mwin->shlMainwin);

  XtDestroyWidget (w);
}

void fltrCloseCB (Widget w, Mainwin_t fltr)
{
  XtDestroyWidget (w);
}

int fltrView (Mainwin_t fltr)
{
  int ret;
  Widget w;

  if (fltr == NULL)
    {
      return False;
    }
  
  DEBUG1 ("fltrView:");

  w = XmCreatePromptDialog (fltr->shlMainwin, "FilterDialog", NULL, 0);
  if (w == NULL)
    return False;

  XtAddCallback (w, XmNokCallback,     (XtCallbackProc)fltrStartCB,
		 fltr);
  XtAddCallback (w, XmNcancelCallback, (XtCallbackProc)fltrCloseCB,
		 fltr);
  XtSetSensitive (XmSelectionBoxGetChild (w, XmDIALOG_HELP_BUTTON),
		  False);
  XtManageChild (w);
  XtPopup (XtParent (w), XtGrabNone);

  XmTextSetString (XmSelectionBoxGetChild (w, XmDIALOG_TEXT),
		   fltr->DirFilter);

  DEBUG1 ("fltrView: Ende");

  return True;
}
