/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: xfind.c,v 1.4 1997/01/15 01:21:23 khamis Exp khamis $
 * $Source: /usr2/xkhfm/xkhlib/xkhsrc/RCS/xfind.c,v $
 */
#define IS_EXTERN
#define EXTERN		extern

#define WINMENU_NO_CLOSE

#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>
#include <Xm/DrawnB.h>
#include "Xinc.h"

#include "defines.h"

#ifdef HAVE_THREAD
#include <thread.h>
#endif

#include "Umem.h"
#include "Uxutil.h"
#include "Umessage.h"
#include "Umenu.h"
#include "Urcnfvoid.h"
#include "Ureadarg.h"
#include "Ufileutil.h"
#include "Ustrutil.h"
#include "Ucnfutil.h"
#include "about.h"
#include "quit.h"
#include "help.h"
#include "mainwin.h"
#include "dir.h"
#include "xmisc.h"
#include "window.h"

void fndGotoCB (Widget w, Find_t fnd)
{
  int i, cnt =listCount (fnd->lstFound);

  BaisyCursor (fnd->dlgFnd);

  for (i=0; i<cnt; i++)
    {
      if (XmListPosSelected (fnd->lstFound, i))
	{
	  XmStringTable items;
	  char * str;
	  XtVaGetValues (fnd->lstFound,
			 XmNitems, &items, /* donot free */
			 NULL);
	  XmStringGetLtoR (items[i>0 ? i-1 : cnt-1],
			   XmFONTLIST_DEFAULT_TAG, &str);
	  fnd->ClProc (fnd->ClData, str);
	  XtFree (str);
	  break;
	}
    }

  NormalCursor (fnd->dlgFnd);
}
void fndDeleteCB (Widget w, Find_t fnd)
{
  int i, cnt =listCount (fnd->lstFound);
  char * files = NULL;

  BaisyCursor (fnd->dlgFnd);

  for (i=0; i<cnt; i++)
    {
      if (XmListPosSelected (fnd->lstFound, i))
	{
	  XmStringTable items;
	  char * str;
	  XtVaGetValues (fnd->lstFound,
			 XmNitems, &items, /* donot free */
			 NULL);
	  XmStringGetLtoR (items[i>0 ? i-1 : cnt-1],
			   XmFONTLIST_DEFAULT_TAG, &str);
	  files = StrAppend (files, str);
	  files = StrAppend (files, " ");
	  XtFree (str);
	}
    }
  if (files != NULL)
    {
      Mainwin_t mwin = fnd->ClData;
      if (mwin->Remove == NULL)
      {
        mwinDel (mwin, MWIN_READ_NOTHING);
      }
      if (mwin->Remove != NULL)
      {
        mwin->Remove->Files
	  = StrReplace (mwin->Remove->Files, files);
        remView (mwin->shlMainwin, mwin->Remove);
      }
    }

  StrReplace (files, NULL);

  NormalCursor (fnd->dlgFnd);
}
void fndSelectAllCB (Widget w, Find_t fnd)
{
  int i, cnt =listCount (fnd->lstFound);
  BaisyCursor (fnd->dlgFnd);

  for (i=0; i<cnt; i++)
    XmListSelectPos (fnd->lstFound, i, 2);

  NormalCursor (fnd->dlgFnd);
}
void fndUnselectAllCB (Widget w, Find_t fnd)
{
  int i, cnt = listCount (fnd->lstFound);
  BaisyCursor (fnd->dlgFnd);

  for (i=0; i<cnt; i++)
    XmListDeselectPos (fnd->lstFound, i);

  NormalCursor (fnd->dlgFnd);
}

void btnFindOkCB (Widget w, Find_t fnd);
void btnFndCloseCB (Widget w, Find_t fnd);

menuitem_t itemFind [] =
{
  { (void(*)(Widget,void*)) btnFindOkCB, "Start", True, NULL },
  { NULL, MENU_SEPARATOR, False, NULL },
  { (void(*)(Widget,void*)) fndGotoCB, "GoTo", True, NULL },
  { (void(*)(Widget,void*)) fndDeleteCB, "Delete Selected", True, NULL },
  { NULL, MENU_SEPARATOR, False, NULL },
  { (void(*)(Widget,void*)) fndSelectAllCB,   "Select All", True, NULL },
  { (void(*)(Widget,void*)) fndUnselectAllCB, "Unselect All", True, NULL },
  { NULL, MENU_SEPARATOR, False, NULL },
  { (void(*)(Widget,void*)) btnFndCloseCB, "Close", True, NULL },
  { NULL, NULL }
};

menu_t menuFind [] =
{
  { "Find",   itemFind,    True, NULL },
  { "Window", itemWinMenu, True, NULL },
  { NULL, NULL, False, NULL }
};

void fndFlaggsCB (Widget w, Find_t fnd)
{
}

void fndLstFoundCB (Widget w, Find_t fnd, XmListCallbackStruct * cbs)
{
  char * choise;
  BaisyCursor (fnd->dlgFnd);

  XmStringGetLtoR (cbs->item, XmFONTLIST_DEFAULT_TAG, &choise);
  if (fnd->ClProc != NULL)
    fnd->ClProc (fnd->ClData, choise);
  XtFree (choise);

  NormalCursor (fnd->dlgFnd);
}

int fndViewState (Dchain_t src, Dchain_t dst, Find_t fnd)
{
  char str[MAXPATHLEN];
  XmString Src;
  XEvent event;

  if (src != NULL && dirType (src) == TYPE_DIR)
    {
      sprintf (str, "Searching in %s", dirName (src));
      Src  = XmStringCreateSimple (str);
      XtVaSetValues (fnd->lblState, XmNlabelString, Src,  NULL);
      XmStringFree (Src);
    }
  else if (src == NULL)
    {
      Src  = XmStringCreateSimple ("End Searching");
      XtVaSetValues (fnd->lblState, XmNlabelString, Src,  NULL);
      XmStringFree (Src);
    }
  
  XFlush (display);
  XmUpdateDisplay (fnd->dlgFnd);
  
  while (XCheckMaskEvent (display, ALL_MASKS, &event))
    {
      /* Do Nothing */
      XtDispatchEvent (&event);
    }

  if (fnd->Stop)
    return DIR_CANCEL;

  return False;
}

int fndError (char * file, Find_t fnd)
{
  char Mess [MAXPATHLEN];
  int ret;
  sprintf (Mess, "Error by Searching\n[%s] !", file);
  ret = MessageBox (fnd->dlgFnd,
		    "FindError",
		    Mess,
		    XmDIALOG_ERROR,
		    OK_BUTTON|CANCEL_BUTTON | DONOT_SETTITLE,
		    NULL, NULL);
  if (ret == 1)
    ret = DIR_CANCEL;
  return ret;
}

int fndAdd (Dchain_t src, Dchain_t dst, DirInfo_t info)
{
  /** add to the file list, if regular */
  if (info->Enclose != NULL &&  info->Enclose[0] != 0 &&
      ! IsRegular (info->Enclose, basename (dirName (src))))
    return 0;

  if (info->Ignore != NULL && info->Ignore[0] != 0 &&
      IsRegular (info->Ignore, basename (dirName (src))))
    return 0;

  listAddItem (((Find_t)info->ClData)->lstFound, dirName (src), False);
  return 0;
}

int fndStart (Find_t fnd)
{
  Dchain_t srcList, dummy;
  char file [MAXPATHLEN];
  dirInfo_t info;
  int pos, mode = False, ret;

  if (XmToggleButtonGadgetGetState (fnd->radFndFlaggs->btnRadio[0]))
    mode |= DIR_RECURSIVE;

  fnd->Files   = StrReplace (fnd->Files,
			     XmTextGetString (fnd->txtFiles->txtText));
  fnd->Enclose = StrReplace (fnd->Enclose,
			     XmTextGetString (fnd->txtEnclose->txtText));
  fnd->Ignore  = StrReplace (fnd->Ignore,
			     XmTextGetString (fnd->txtIgnore->txtText));
  fnd->Filter  = StrReplace (fnd->Filter,
			     XmTextGetString (fnd->txtIgnore->txtText));
  
  srcList = dirAdd (NULL, fnd->Files);
  if (dirType (srcList) != TYPE_DIR)
    {
      MessageBox (fnd->dlgFnd,
		  "Find",
		  "The given directory name does not exist.\n"
		  "Please check your entry and try again !",
		  XmDIALOG_INFORMATION,
		  OK_BUTTON,
		  NULL, NULL);
      dirDelete (srcList);
      return False;
    }

  memset (&info, 0, sizeof (info));
  info.Enclose       = fnd->Enclose;
  info.Ignore        = fnd->Ignore;
  info.Filter        = fnd->Ignore;
  info.mode          = mode;
  info.ClProc        = (int(*)(Dchain_t,Dchain_t,void*))fndAdd;
  info.ViewFilesProc = (int(*)(Dchain_t,Dchain_t,void*))fndViewState;
  info.ErrProc       = (int(*)(Dchain_t,void*))         fndError;
  info.ClData        = fnd;

  /* delete old entries */
  listDelPos (fnd->lstFound, 1, listCount (fnd->lstFound));

  dummy   = dirAdd (NULL, fnd->Files);
  /* start searching */
  if (! (mode & DIR_RECURSIVE))
    {
      Dchain_t top = dirAdd (NULL, "TOP"), dch;
      dirReadDir (top, dirName (srcList), "*", False);
      for (dch=UdchNext (top);
	   dch!=NULL;
	   dch=UdchNext (dch))
	{
	  Dchain_t tdir = dirAdd (NULL, UPathAppend (dirName (srcList),
						     dirName (dch)));
	  info.mode |= dirRecursive (tdir, dummy, &info);
	  dirDelete (tdir);
	  if ((info.mode & DIR_CANCEL) ||
	      (info.mode & DIR_ERROR))
	    break;
	}
      dirDelete (top);
    }
  else
    info.mode |= dirRecursive (srcList, dummy, &info);
  dirDelete (srcList);
  dirDelete (dummy);

  fndViewState (NULL, NULL, fnd);

  ret = mode & (DIR_ERROR_AVAIL | DIR_CANCEL);

  /* there was an error by searching process */
  if (ret)
    {
      MessageBox (fnd->dlgFnd,
		  "Search Process",
		  (mode & DIR_CANCEL)
		  ? "Searching the selected files is aborted"
		  : (mode & DIR_ERROR_AVAIL)
		  ? "Error detected by searchinging the file list"
		  : "Search process for the selected files not completed",
		  XmDIALOG_INFORMATION,
		  OK_BUTTON,
		  NULL, NULL);
    }

  return ret ? False : True;
}

void btnFindStopCB (Widget w, Find_t fnd)
{
  int ret;
  ret = MessageBox (fnd->dlgFnd,
		    "FindBreakDialog",
		    "FindBreakDialog",
		    XmDIALOG_ERROR,
		    OK_BUTTON | 
		    CANCEL_BUTTON |
		    DONOT_SETTITLE|DONOT_SETMESSAGE,
		    NULL, NULL);
  if (ret == 1)
  fnd->Stop = True;
}

void btnFindOkCB (Widget w, Find_t fnd)
{
  XmString stop;

  if (fnd->Started)
    {
      XMapRaised (XtDisplay (fnd->dlgFnd), XtWindow (fnd->dlgFnd));
      XBell (display, 0);
      return;
    }

  fnd->Started = True;
  fnd->Stop    = False;

  stop = XmStringCreateSimple ("Stop");
  XtRemoveCallback (fnd->btnOk, XmNactivateCallback, 
		    (XtCallbackProc) btnFindOkCB,
		    fnd);
  XtVaSetValues    (fnd->btnOk, XmNlabelString, stop, NULL);
  mwinSetPixmapToWidget (fnd->btnOk, PIXM_tool_stop48, MWIN_LOADANDSET);
  XmStringFree     (stop);
  XtAddCallback    (fnd->btnOk, XmNactivateCallback, 
		    (XtCallbackProc) btnFindStopCB,
		    fnd);
  XtSetSensitive   (fnd->btnClose, False);

#ifdef HAVE_THREAD
  {
    thread_t newThread;
    int ret;
    DEBUG1 ("btnFindOkCB: create a new thread");
    ret = thr_create (NULL, 0, (void* (*)(void*)) fndStart, (void*) fnd,
		      THR_BOUND | 0L, &newThread);
    if (ret != 0)
      {
	DEBUG1 ("btnFindOkCB: "
		  "Can not create a new Thread, running in normal mode");
	fndStart (fnd);
      }
    else
      {
	DEBUG1 ("btnFindOkCB: Thread created");
      }
    DEBUG1 ("btnFindOkCB: after the new thread");
  }
#else
  fndStart (fnd);
#endif

  XtRemoveCallback (fnd->btnOk, XmNactivateCallback,
		    (XtCallbackProc) btnFindStopCB,
		    fnd);
  stop = XmStringCreateSimple ("Start");
  XtVaSetValues    (fnd->btnOk, XmNlabelString, stop, NULL);
  mwinSetPixmapToWidget (fnd->btnOk, PIXM_tool_run48, MWIN_LOADANDSET);
  XmStringFree     (stop);
  XtAddCallback    (fnd->btnOk, XmNactivateCallback, 
		    (XtCallbackProc) btnFindOkCB,
		    fnd);
  XtSetSensitive (fnd->btnClose, True);

  fnd->Stop = False;
  fnd->Started = False;
}

void btnFndCloseCB (Widget w, Find_t fnd)
{
  fndHide (fnd);
}

void fndDestCB (Widget w, Find_t fnd)
{
  fnd->dlgFnd = NULL;
}

menuitem_t itemFndFlags [] =
{
  { (void (*) (Widget, void *)) fndFlaggsCB, "Recursive", True, NULL },
  { NULL, NULL}
};
menu_t mnuFndFlaggs [] =
{ 
  { "Find Flaggs", itemFndFlags, True, NULL },
  { NULL, NULL }
};


Find_t fndMake (void)
{
  Find_t fnd;
  fnd = gcalloc (sizeof (find_t), __LINE__, __FILE__);
  fnd->Enclose = StrReplace (fnd->Enclose, "*");
  fnd->Ignore  = StrReplace (fnd->Ignore, "");
  fnd->Filter  = StrReplace (fnd->Filter, "*");
  return fnd;
}

char * fndName (Find_t fnd)
{
  static char tmp [MAXPATHLEN];
  static char fmt[] = "Find [%s%c%s]";
  sprintf (tmp, fmt, fnd->Files, RootDir,
           dirCutPath (fnd->Enclose, MNU_STRLEN, False));
  return tmp;
}

Widget fndShell (Find_t fnd)
{
  return fnd->dlgFnd;
}

int fndHide (Find_t fnd)
{
  
  if (fnd->dlgFnd != NULL)
    {
      if (fnd->Started)
	{
	  XBell (display, 0);
	  return False;
	}

      txtDest (fnd->txtFiles);
      txtDest (fnd->txtFilter);
      txtDest (fnd->txtIgnore);
      txtDest (fnd->txtEnclose);
      radDest (fnd->radFndFlaggs);

      XtDestroyWidget (fnd->dlgFnd);
      fnd->dlgFnd = NULL;
      
      winDelWinMenu (winGetListFromObj (fnd));
    }

  return True;
}

int fndDest (Find_t fnd)
{
  if (fnd == NULL)
    return False;

  if (! fndHide (fnd))
    return False;

  fnd->Enclose = StrReplace (fnd->Enclose, NULL);
  fnd->Ignore  = StrReplace (fnd->Ignore,  NULL);
  fnd->Filter  = StrReplace (fnd->Filter,  NULL);
  fnd->Files   = StrReplace (fnd->Files,   NULL);
  MFree (fnd, sizeof (find_t));
  return True;
}

int fndView (Widget parent, Find_t fnd)
{
  int ret, n;
  Widget sep1, sep2, sep3, sep4;
  Arg args[10];
  XmString Key;

  /* Rong call or find process is running */
  if (fnd == NULL || /*parent == NULL || */ fnd->Started)
    {
      XBell (display, 0);
      return False;
    }
  
  if (fnd->dlgFnd != NULL)
    {
      /* add searching directory */
      if (fnd->Files != NULL)
	XmTextSetString   (fnd->txtFiles->txtText, fnd->Files);

      XMapRaised (XtDisplay (fnd->dlgFnd), XtWindow (fnd->dlgFnd));
      return True;
    }
  fnd->Parent = parent;

  DEBUG1 ("fndView:");

  ret = winCreate ( /*parent,*/
		   "Find",
		   &fnd->dlgFnd,
		   &fnd->winFnd,
		   &fnd->fomMain,
		   6,
		   fnd,
		   (void (*)(Widget, void*))btnFndCloseCB,
		   False);
  if (ret == False)
    return False;

  XtManageChild (fnd->fomMain);
  XtManageChild (fnd->winFnd);

  mnuMake (fnd->winFnd, menuFind, fnd);

  DEBUG1 ("fndView: fomMain");

  XtVaSetValues (fnd->fomMain,
		 XmNtopOffset,     SPACE,
		 XmNrightOffset,   SPACE,
		 XmNleftOffset,    SPACE,
		 XmNbottomOffset,  SPACE,
		 NULL);

  DEBUG1 ("fndView: Find");

  fnd->txtEnclose = txtCreate (fnd->fomMain,
			      "Find",
			      0, NULL, FND_INCLUSE,
			      False);
  XtVaSetValues (fnd->txtEnclose->fomText,
		 XmNtopAttachment,   XmATTACH_FORM,
		 XmNleftAttachment,  XmATTACH_FORM,
		 XmNrightAttachment, XmATTACH_FORM,

		 XmNtopOffset,       SPACE,
		 XmNrightOffset,     SPACE,
		 XmNleftOffset,      SPACE,
		 XmNbottomOffset,    SPACE,
		 NULL);
  if (fnd->Enclose != NULL)
    XmTextSetString (fnd->txtEnclose->txtText, fnd->Enclose);
  XtManageChild   (fnd->txtEnclose->fomText);

  DEBUG1 ("fndView: Search in");

  fnd->txtFiles = txtCreate (fnd->fomMain,
			     "Search in",
			      0,
			      NULL,
			      HLP_FND_FILES,
			      False);
  XtVaSetValues (fnd->txtFiles->fomText,
		 XmNtopAttachment,    XmATTACH_WIDGET,
		 XmNtopWidget,	      fnd->txtEnclose->fomText,
		 XmNleftAttachment,   XmATTACH_FORM,
		 XmNrightAttachment,  XmATTACH_FORM,
		 XmNtopOffset,        SPACE,
		 XmNrightOffset,      SPACE,
		 XmNleftOffset,       SPACE,
		 XmNbottomOffset,     SPACE,
		 NULL);
  if (fnd->Files != NULL)
    XmTextSetString (fnd->txtFiles->txtText, fnd->Files);
  XtManageChild   (fnd->txtFiles->fomText);

  DEBUG1 ("fndView: Skip");

  fnd->txtFilter = txtCreate (fnd->fomMain,
			      "Directory filter",
			      0, NULL, FND_IGNORE,
			      False);
  XtVaSetValues (fnd->txtFilter->fomText,
		 XmNtopAttachment,    XmATTACH_WIDGET,
		 XmNtopWidget,	      fnd->txtFiles->fomText,
		 XmNrightAttachment,  XmATTACH_POSITION,
		 XmNrightPosition,    3,
		 XmNleftAttachment,   XmATTACH_FORM,
		 XmNtopOffset,        SPACE,
		 XmNrightOffset,      SPACE,
		 XmNleftOffset,       SPACE,
		 XmNbottomOffset,     SPACE,
		 NULL);
  XtManageChild (fnd->txtFilter->fomText);

  fnd->txtIgnore = txtCreate (fnd->fomMain,
			      "Skip/Ignore",
			      0, NULL, FND_IGNORE,
			      False);
  XtVaSetValues (fnd->txtIgnore->fomText,
		 XmNtopAttachment,    XmATTACH_WIDGET,
		 XmNtopWidget,	      fnd->txtFiles->fomText,
		 XmNrightAttachment,  XmATTACH_FORM,
		 XmNleftAttachment,   XmATTACH_POSITION,
		 XmNleftPosition,     3,
		 XmNtopOffset,        SPACE,
		 XmNrightOffset,      SPACE,
		 XmNleftOffset,       SPACE,
		 XmNbottomOffset,     SPACE,
		 NULL);
  XtManageChild (fnd->txtIgnore->fomText);

  DEBUG1 ("fndView: sep1");

  sep1 =
    XtVaCreateManagedWidget ("Separator",
			     xmSeparatorGadgetClass,
			     fnd->fomMain,
			     
			     XmNtopAttachment,   XmATTACH_WIDGET,
			     XmNtopWidget,       fnd->txtIgnore->fomText,
			     XmNleftAttachment,  XmATTACH_FORM,
			     XmNrightAttachment, XmATTACH_FORM,
			     XmNtopOffset,       SPACE,
			     XmNbottomOffset,    SPACE,
			     NULL);
  XtManageChild (sep1);

  DEBUG1 ("fndView: Flaggs");

  fnd->radFndFlaggs = radCreate (fnd->fomMain,
				 mnuFndFlaggs,
				 FND_FLAGGS,
				 fnd,
				 TOGGLEE_BOX);
  XtVaSetValues (fnd->radFndFlaggs->radRadio,
		 XmNnumColumns,       1,
		 XmNtopAttachment,    XmATTACH_WIDGET,
		 XmNtopWidget,        sep1,
		 XmNrightAttachment,  XmATTACH_FORM,
		 XmNleftAttachment,   XmATTACH_FORM,
		 XmNtopOffset,        SPACE,
		 XmNrightOffset,      SPACE,
		 XmNleftOffset,       SPACE,
		 XmNbottomOffset,     SPACE,
		 NULL);
  /* recursive */
  XmToggleButtonGadgetSetState (fnd->radFndFlaggs->btnRadio[0], True, False);
  XtManageChild (fnd->radFndFlaggs->radRadio);

  DEBUG1 ("fndView: Sep2");

  sep2 =
    XtVaCreateManagedWidget ("Separator",
			     xmSeparatorGadgetClass,
			     fnd->fomMain,
			     XmNtopAttachment, XmATTACH_WIDGET,
			     XmNtopWidget,     fnd->radFndFlaggs->radRadio,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNrightAttachment,  XmATTACH_FORM,
			     XmNtopOffset,        SPACE,
			     XmNbottomOffset,     SPACE,
			     NULL);
  XtManageChild (sep2);

  DEBUG1 ("fndView: lblState");

  fnd->lblState =
    XtVaCreateManagedWidget ("(Click Button to Start Searching)",
			     xmLabelGadgetClass,
			     fnd->fomMain,			     
			     XmNtopAttachment,    XmATTACH_WIDGET,
			     XmNtopWidget,        sep2,
			     XmNrightAttachment,  XmATTACH_FORM,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNtopOffset,        SPACE,
			     XmNleftOffset,       SPACE,
			     XmNrightOffset,      SPACE,
			     XmNbottomOffset,     SPACE,
			     NULL);
  XtManageChild (fnd->lblState);

  DEBUG1 ("fndView: sep3");

  sep3 =
    XtVaCreateManagedWidget ("Separator",
			     xmSeparatorGadgetClass,
			     fnd->fomMain,			     
			     XmNtopAttachment,    XmATTACH_WIDGET,
			     XmNtopWidget,        fnd->lblState,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNrightAttachment,  XmATTACH_FORM,
			     XmNtopOffset,        SPACE,
			     XmNbottomOffset,     SPACE,
			     NULL);
  XtManageChild (sep3);

  DEBUG1 ("fndView: start");

  fnd->btnOk =
    XtVaCreateManagedWidget ("Start",
			     xmPushButtonGadgetClass,
			     fnd->fomMain,
			     XmNdefaultButtonShadowThickness,    2,
			     XmNshowAsDefault,    2,
			     XmNleftAttachment,   XmATTACH_POSITION,
			     XmNleftPosition,     1,
			     XmNrightAttachment,  XmATTACH_POSITION,
			     XmNrightPosition,    2,
			     XmNbottomAttachment, XmATTACH_FORM,
			     XmNmarginTop,      2,
			     XmNmarginBottom,   2,
			     XmNtopOffset,      SPACE,
			     XmNleftOffset,     SPACE,
			     XmNrightOffset,    SPACE,
			     XmNbottomOffset,   SPACE,			     
			     NULL);
  XtAddCallback (fnd->btnOk, XmNactivateCallback, 
		 (XtCallbackProc) btnFindOkCB,
		 fnd);
  btnMesgArea   (fnd->btnOk, FND_OK);
  XtManageChild (fnd->btnOk);
  mwinSetPixmapToWidget (fnd->btnOk,    PIXM_tool_run48,   MWIN_LOADANDSET);
  
  DEBUG1 ("fndView: close");

  Key = XmStringCreateSimple ("Ctrl<Key>Q");
  fnd->btnClose =
    XtVaCreateManagedWidget ("Close",
			     xmPushButtonGadgetClass,
			     fnd->fomMain,
			     XmNaccelerator,	  Key,
			     XmNshowAsDefault,    2,
			     XmNrightAttachment,  XmATTACH_POSITION,
			     XmNrightPosition,    5,
			     XmNleftAttachment,   XmATTACH_POSITION,
			     XmNleftPosition,     4,
			     XmNbottomAttachment, XmATTACH_FORM,
			     XmNmarginTop,      2,
			     XmNmarginBottom,   2,
			     XmNtopOffset,      SPACE,
			     XmNleftOffset,     SPACE,
			     XmNrightOffset,    SPACE,
			     XmNbottomOffset,   SPACE,			     
			     NULL);
  XmStringFree (Key);
  XtAddCallback (fnd->btnClose, XmNactivateCallback, 
		 (XtCallbackProc) btnFndCloseCB,
		 fnd);
  btnMesgArea   (fnd->btnClose, FND_CLOSE);
  mwinSetPixmapToWidget (fnd->btnClose, PIXM_tool_abort48, MWIN_LOADANDSET);
  mwinSetPixmapToWidget (fnd->btnClose, PIXM_tool_abortd48, MWIN_DISABLED);
  XtManageChild (fnd->btnClose);
  
  sep4 =
    XtVaCreateManagedWidget ("Separator",
			     xmSeparatorGadgetClass,
			     fnd->fomMain,			     
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNrightAttachment,  XmATTACH_FORM,
			     XmNbottomAttachment,    XmATTACH_WIDGET,
			     XmNbottomWidget,        fnd->btnOk,
			     XmNtopOffset,        SPACE,
			     XmNbottomOffset,     SPACE,
			     NULL);
  XtManageChild (sep4);

  DEBUG1 ("fndView: found list");

  n = 0;
  XtSetArg (args[n], XmNvisibleItemCount, 10); n++;
  XtSetArg (args[n], XmNselectionPolicy,  XmEXTENDED_SELECT); n++;
  XtSetArg (args[n], XmNtopAttachment,    XmATTACH_WIDGET); n++;
  XtSetArg (args[n], XmNtopWidget,        sep3); n++;
  XtSetArg (args[n], XmNleftAttachment,   XmATTACH_FORM); n++;
  XtSetArg (args[n], XmNrightAttachment,  XmATTACH_FORM); n++;
  XtSetArg (args[n], XmNbottomAttachment, XmATTACH_WIDGET); n++;
  XtSetArg (args[n], XmNbottomWidget,     sep4); n++;
  fnd->lstFound
    = XmCreateScrolledList (fnd->fomMain,
			    "Found list",
			    args, n);
  XtAddCallback (fnd->lstFound, 
		 /*XmNbrowseSelectionCallback*/ XmNdefaultActionCallback,
		 (XtCallbackProc) fndLstFoundCB,
		 fnd);
  XtManageChild (fnd->lstFound);

  /*
  XtManageChild     (fnd->dlgFnd);
  XtPopup (XtParent (fnd->dlgFnd), XtGrabNone);
  XMapRaised (XtDisplay (fnd->dlgFnd), XtWindow (fnd->dlgFnd));
  */
  MXtRealizeWidget (fnd->dlgFnd);

#if 0
  winBuildWinMenu (NULL, NULL);
#endif
  
  DEBUG1 ("fndView: Ende");

  return True;
}
