/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: xkhfm.c,v 1.2 1996/10/28 03:36:18 khamis Exp khamis $
 * $Source: /home/xkhfm/xkhlib/xkhsrc/RCS/xkhfm.c,v $
 */
#define EXTERN

#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>
#include "Xinc.h"

/********* Module ***********************************************/
#include "defines.h"

#define HAVE_UNAME

#ifdef HAVE_UNAME
#include <sys/utsname.h>
struct utsname HostInfo;
#endif

#include "fallback.h"		/* immer als letztes includen ***/

#include "about.h"
#include "quit.h"
#include "Ufileutil.h"
#include "Uxutil.h"
#include "Umessage.h"
#include "Umenu.h"
#include "util.h"

/********* Hauptmasken ******************************************/
#include "mainwin.h"
#include "window.h"
#include "xkhfm.h"

#ifdef HAVE_THREAD
int MyLoop (XtAppContext ac)
{
#if 1
  XtAppMainLoop (ac);
#else
  while (True)
    {
      XEvent * xevent;
      XtAppNextEvent (ac, xevent);
      XtDispatchEvent (xevent);
    }
#endif
}
#endif

/********* Hauptaufruf fuer das Mainprogramm ****/
void main (int argc, char * argv[])
{
  Dchain_t newWin;
  Mainwin_t mwin;
  XEvent * xevent;
  Drawable rootWin;
  
  Arg args [20];
  unsigned long fg = 1, bg = 0;
  int i, j, n, ret;

  /****** Start-Programmname bzw. -pfad in globalen Variablen speichern **/
  strcpy (progName, argv[0]);
  strcpy (progDir,  UDirName (argv[0]));

  /****** Init Pixmap List and it's coordinates **/
  memset (pxmList,   0, sizeof (pxmList));
  memset (pxmWidth,  0, sizeof (pxmWidth));
  memset (pxmHeight, 0, sizeof (pxmHeight));
  Hostname = NULL;

#ifdef HAVE_UNAME
  /****** Get Hostname */
  if (uname (&HostInfo) < 0)
    {
      memset (&HostInfo, 0, sizeof (HostInfo));
    }
  else
    {
      Hostname = HostInfo.nodename;
    }
#else
  memset (&HostInfo, 0, sizeof (HostInfo));
  Hostname = "this";
#endif

  /****** User and Group Id *****/
  UserId  = geteuid();
  GroupId = getegid();

  /* read user and groups names **/
  UserList = usrAdd (NULL, "TOP");
  usrReadList (UserList);
  GrpList = grpAdd (NULL, "TOP");
  grpReadList (GrpList);

  /* user and group name */
  UserName  = usrNameById (UserList, UserId);
  GroupName = grpNameById (GrpList, GroupId);

  /* Current pathname */
  strcpy (CurrentPath, ".");

  /* Set History list to NULL */
  cmdList   = NULL;
  cmdHist   = NULL;

  /* set Association list to null */
  assList = assListAdd (NULL, "TOP");
  assWindow = NULL;

  /* set icon extension list to null */
  iconExtensionList = assListAdd (NULL, "TOP");
  iconExtensionWindow = NULL;

  /* set toolbar list to null */
  toolbarList   = tbarListAdd (NULL, "TOP");
  toolbarWindow = NULL;

  /* set default commands */
  XtermCommand = NULL;
  EditCommand  = NULL;
  CommandFile  = NULL;
  XtermCommand = StrReplace (XtermCommand, "xterm");
  EditCommand  = StrReplace (EditCommand,
			     TEXT_EDITOR);

  /******* X Toolkit initial. ****/
  XtToolkitInitialize();

  /******* Application-Context erzeugen ****/
  app_context = XtCreateApplicationContext();

  /******* Application-Context erzeugen ****/
  XtAppSetFallbackResources (app_context, fallbackres);

  /******* Initial global X Parameters *****/
  display = XtOpenDisplay (app_context,
			   NULL,
			   ApplProg, ApplProg,
			   NULL, 0, &argc, argv);
  /******* kein Fenster ? -> Fehlermeldung und Ende **/
  if (!display)
  {
    printf ("xkhfm: can't open the Display, aborted\n");
    exit (1); 
  }

  theScreen  = DefaultScreen     (display);
  theGC      = DefaultGC         (display, theScreen);
  rootWindow = DefaultRootWindow (display);
  MultiClickTimeout = max (300, XtGetMultiClickTime (display));

  /*
   * Create Pixmaps for the directory entries 
   */
  mwinCrPixmaps ();

  DEBUG1 ("xkhfm: read Help file");

  /* create help window */
  hlpMake();

  /****** Add Header for windows list **/
  winList = winListAdd (NULL, "TOP");

  /* read setup from source file */
  mwinReadSetup ();

  DEBUG1 ("xkhfm: winListFindFirst");

  if (winListFindFirst (winList, WIN_REGULAR) == NULL)
    {
      DEBUG1 ("xkhfm: add new mainwin");

      newWin = winListAdd (winList, "mainwin");

      if (newWin != NULL)
	{
	  mwin = winObj (winListFindFirst (winList, WIN_REGULAR));
#if 0
	  ((WindowList_t)
		  UdchClient (winListFindFirst (winList, WIN_REGULAR)))
	    ->wins.mainwin;
#endif
	  ret  = mwinView (mwin);
	}
      if (ret = False || newWin == NULL)
	{
	  ERROR1 ("xkhfm: cannot create window shell");
	  exit (1);
	}
    }

  DEBUG1 ("xkhfm: top shell");

  topShell =
    ((WindowList_t) UdchClient(
     winListFindFirst (winList, WIN_REGULAR)))->wins.mainwin->shlMainwin;

  DEBUG1 ("xkhfm: MainLoop");

  /****** Aggieren mit dem Benutzer **/
#ifdef HAVE_THREAD
  {
    int ret;
    static thread_t tmpThread;
    mainloop = NULL;
    ret = thr_create (NULL, 0,
		      (void* (*)(void*)) MyLoop,
		      (void*) app_context,
		      0L, &tmpThread);
    if (ret != 0)
      {
	WARNING1 ("xkhfm: can't create thread for MainLoop");
	XtAppMainLoop   (app_context);
      }
    else
      {
	mainloop = &tmpThread;
	while (1)
	  {sleep (1);}
      }
  }
#else
#if 1
  XtAppMainLoop   (app_context);
#else
  while (True)
    {
#if 0
      if (XtAppNextEvent (app_context, xevent))
	{
	  DEBUG1 ("XtDispatchEvent");
	  XtDispatchEvent (xevent);
	}
#endif
      XtAppNextEvent (app_context, xevent);
      XtDispatchEvent (xevent);
    }
#endif
#endif

  exit (1);
} 




