/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: xmisc.c,v 1.1 1997/01/07 08:35:08 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/xkhlib/xkhsrc/RCS/xmisc.c,v $
 */
#define IS_EXTERN
#define EXTERN	extern

#include <sys/param.h>

#include "Xinc.h"
#include <X11/cursorfont.h>
#include <Xm/CutPaste.h>

#include "defines.h"

#ifdef HAVE_XPM
#include <X11/xpm.h>
#endif

#include "xmisc.h"

#include "bitmap/cur_ccopy.icon"
#include "bitmap/cur_ccopym.icon"

#include "bitmap/cur_move.icon"
#include "bitmap/cur_movem.icon"

#include "bitmap/cur_del.icon"
#include "bitmap/cur_delm.icon"

#include "bitmap/cur_rong.icon"
#include "bitmap/cur_rongm.icon"

#include "bitmap/cur_prop.icon"
#include "bitmap/cur_propm.icon"

#include "bitmap/cur_edit.icon"
#include "bitmap/cur_editm.icon"

/*
 * Helpprocedures 
 */
Dimension wdgWidth (Widget w)
{
  Dimension width = 0;
  XtVaGetValues (w,
		 XmNwidth, &width,
		 NULL);
  return width;
}

Dimension wdgHeight (Widget w)
{
  Dimension height = 0;
  XtVaGetValues (w,
		 XmNheight, &height,
		 NULL);
  return height;
}

Dimension wdgX (Widget w)
{
  Position x = 0;
  XtVaGetValues (w,
		 XmNx, &x,
		 NULL);
  return x;
}

Dimension wdgY (Widget w)
{
  Position y = 0;
  XtVaGetValues (w,
		 XmNy, &y,
		 NULL);
  return y;
}

Cursor CreateCursor (char * curdata, char* maskdata,
		     int width, int height,
		     int hot_x, int hot_y)
{
  Cursor crs;
  Pixmap pxm, pxm_mask;
  XColor fg, bg;
  pxm      = XCreatePixmapFromBitmapData (display, rootWindow,
					  curdata,
					  width, height,
					  1L, 0L, 1);
  pxm_mask = XCreatePixmapFromBitmapData (display, rootWindow,
					  maskdata,
					  width, height,
					  1L, 0L, 1);
  fg.red = fg.green = fg.blue = 1;
  bg.red = bg.green = bg.blue = 0xFFFF;
  crs = XCreatePixmapCursor (display, pxm, pxm_mask,
			     &fg, &bg, hot_x, hot_y);
  XFreePixmap (display, pxm);
  XFreePixmap (display, pxm_mask);

  return crs;
}

int SetCursor (Widget w, int mode)
{
  static Cursor
    cursor   = 0,
    copy     = 0,
    move     = 0,
    can_copy = 0,
    del      = 0,
    rong     = 0,
    prop     = 0,
    edit     = 0;
  XEvent event;
  XSetWindowAttributes attrs;

  if (w == NULL)
    return False;

  DEBUG1 ("SetCursor:");

  if (cursor == 0)
    cursor = XCreateFontCursor (display, XC_watch);
  
  if (can_copy == 0)
    {
      can_copy = CreateCursor (cur_ccopy_bits, cur_ccopym_bits,
			       cur_ccopy_width, cur_ccopy_height,
			       cur_ccopy_x_hot, cur_ccopy_y_hot);
    }

  if (move == 0)
    {
      move = CreateCursor (cur_move_bits, cur_movem_bits,
			   cur_move_width, cur_move_height,
			   cur_move_x_hot, cur_move_y_hot);
    }

  if (del == 0)
    {
      del = CreateCursor (cur_del_bits, cur_delm_bits,
			  cur_del_width, cur_del_height,
			  cur_del_x_hot, cur_del_y_hot);
    }

  if (rong == 0)
    {
      rong = CreateCursor (cur_rong_bits, cur_rongm_bits,
			       cur_rong_width, cur_rong_height,
			       cur_rong_x_hot, cur_rong_y_hot);
    }

  if (prop == 0)
    {
      prop = CreateCursor (cur_prop_bits, cur_propm_bits,
			       cur_prop_width, cur_prop_height,
			       cur_prop_x_hot, cur_prop_y_hot);
    }

  if (edit == 0)
    {
      edit = CreateCursor (cur_edit_bits, cur_editm_bits,
			       cur_edit_width, cur_edit_height,
			       cur_edit_x_hot, cur_edit_y_hot);
    }

  switch (mode)
    {
      /* normal cursor, release all input events during baisy time */
    case CURSOR_NORMAL:
      while (XCheckMaskEvent (display,
			      ButtonPressMask | ButtonReleaseMask |
			      KeyPressMask |
			      ButtonMotionMask | PointerMotionMask,
			      &event))
	{
	  /* DO NOTHING */
	}
      attrs.cursor = None;
      break;

	     
    case CURSOR_BAISY:
      attrs.cursor = cursor;
      break;

    case CURSOR_CAN_COPY:
      attrs.cursor = can_copy;
      break;

    case CURSOR_MOVE:
      attrs.cursor = move;
      break;

    case CURSOR_COPY:
      attrs.cursor = can_copy;
      break;

    case CURSOR_DELETE:
      attrs.cursor = del;
      break;

    case CURSOR_PROP:
      attrs.cursor = prop;
      break;

    case CURSOR_EDIT:
      attrs.cursor = edit;
      break;

    case CURSOR_RONG:
      attrs.cursor = rong;
      break;

    default:
      return False;
    }

  if (XtWindow (w) <= 10)
    {
      WARNING3 ("SetCursor: bad w=[%p] and XtWindow(w)=[%li]\n",
		w, XtWindow(w));
      return False;
    }

  DEBUG2 ("SetCursor: XtWindow(w)=[%li]\n", XtWindow(w));

  XChangeWindowAttributes (display, XtWindow (w), CWCursor, &attrs);
  XSync                   (display, False);
  XFlush                  (display);

  DEBUG1 ("SetCursor: End");

  return True;
}

int WatchCursor (Widget w)
{
  static Cursor cursor = 0;
  XEvent event;
  XSetWindowAttributes attrs;
  static int i = 0;

  if (w == NULL)
    return False;

  /* Last Cursor Symbol Reached */
  if (i >= XC_num_glyphs)
    i = 0;

  DEBUG2 ("WatchCursor: CursorNumber(%i)\n", i);

  cursor = XCreateFontCursor (display, i); i += 2;
  
  attrs.cursor = cursor;

  XChangeWindowAttributes (display, XtWindow (w), CWCursor, &attrs);
  XFlush                  (display);

  return True;
}

/*****************************************************************************
**** Clipboard Mamangment                                               ******
******************************************************************************/
static char * Clipboard = NULL;
static int ClipLen = 0;

int GetDataFromClipboard (char ** buf)
{
  char * data;
  int status, i;
  unsigned long len = 0, recvd;
  long id;

  DEBUG1 ("GetDataFromClipboard:");

#if 1
  if (ClipLen > 0 && Clipboard != NULL)
    {
      data = gmalloc (ClipLen, __LINE__, __FILE__);
      memcpy (data, Clipboard, ClipLen);

      /* convert \0 to space */
      for (i=0; i<ClipLen-1; i++)
	{
	  if (data[i] == 0)
	    data [i] = ' ';
	}
      *buf = data;
      len = ClipLen;
    }
#else  
  XmClipboardUnlock (display, rootWindow, False);
  do
    status = XmClipboardInquireLength (display, rootWindow, "FILE_NAME",
				       &len);
  while (status == ClipboardLocked);
  
  if (len > 0)
    {
      data = gmalloc (len+1, __LINE__, __FILE__);

      DEBUG1 ("GetDataFromClipboard: Retrieve Data from Clipboard");

      do
	status = XmClipboardRetrieve (display, rootWindow, "FILE_NAME",
				      data, len+1, &recvd, NULL);
      while (status == ClipboardLocked);
      
      if (status != ClipboardSuccess || recvd != len)
	{
	  WARNING1 ("GetDataFromClipboard: can not get data from clipboard");
	  return False;
	}
      
      DEBUG3 ("GetDataFromClipboard: len(%li), data(%s)\n", len, data);

      *buf = data;
    }
#endif

  DEBUG2 ("GetDataFromClipboard: len=(%i) end\n", len);

  return len;
}

int OpenClipboard (void)
{
#if 1
  if (Clipboard != NULL)
    {
      MFree (Clipboard, ClipLen);
    }
  Clipboard = NULL;
  ClipLen  = 0;
#else
  unsigned long item_id = 0;
  int status;
  XmString clip_label;
  clip_label = XmStringCreateSimple ("FILE_NAME");
  
  /* Open Clipboard */
  do
    {
      status = XmClipboardStartCopy (display, rootWindow,
				     clip_label, CurrentTime,
				     NULL, NULL,
				     &item_id);
    }
  while (status == ClipboardLocked);

  XmStringFree (clip_label);

  return item_id;
#endif
}

int CloseClipboard (unsigned long item_id)
{
#if 1
#else
  int status;

  /* Close Clipboard */
  do
    {
      status = XmClipboardEndCopy (display, rootWindow,
				   item_id);
    }
  while (status == ClipboardLocked);
#endif
  return True;
}

int AddToClipboard (unsigned long item_id, char * buf, int len)
{
  unsigned int status;
  
  DEBUG2 ("AddToClipboard: buf(%s)\n", buf);

#if 1
  if (Clipboard == NULL)
    Clipboard = malloc (len);
  else
    Clipboard = realloc (Clipboard, ClipLen+len);
  memcpy (Clipboard+ClipLen, buf, len);
  ClipLen += len;
#else
  do
    {
      status = XmClipboardCopy
	(display, rootWindow, item_id,
	 "FILE_NAME",
	 buf,
	 strlen (buf) + 1,
	 0, NULL);
    }
  while (status == ClipboardLocked);
#endif

  DEBUG1 ("AddToClipboard: end");

  return True;
}

/*** Pixmap manipulation *********************/
Pixmap LoadPixmap (Widget parent, char * iconpath, Colormap *clrmap)
{
  Widget topShell;
  Display* display;
  Window   shWindow;
  Screen*  screen;
  Pixmap npxm = 0;
  int ret = 1, i;
  unsigned int height, width, depth, bw;
  unsigned int x, y, x_hot, y_hot;
  
#ifdef HAVE_XPM
  XpmAttributes attributes;
  XpmColorSymbol symbols[1];
  Pixel color = 0;
#endif

  if (parent == NULL || iconpath == NULL)
    return 0;

  topShell   = GetTopShell (parent);
  display    = XtDisplay (topShell);
  shWindow = XtWindow (topShell);
  screen     = XtScreen (topShell);

#ifdef HAVE_XPM
  memset (&attributes, 0, sizeof (attributes));
  memset (&symbols[0], 0, sizeof (symbols[0]));
      
  XtVaGetValues (parent, XmNbackground, &color, NULL);
  symbols[0].value = "none";
  symbols[0].pixel = color;
  attributes.numsymbols   = 1;
  attributes.colorsymbols = symbols;
  attributes.valuemask = XpmColorSymbols;
  
  ret = XpmReadFileToPixmap (display,
			     shWindow,
			     iconpath,
			     &npxm,
			     NULL,
			     &attributes);

  /* try to use default colormap */
  if (ret == XpmColorFailed)
  {
    Colormap colormap = XDefaultColormapOfScreen (screen);
    attributes.colormap = colormap;
    attributes.valuemask |= XpmColormap;
    ret = XpmReadFileToPixmap (display,
			       shWindow,
			       iconpath,
			       &npxm,
			       NULL,
			       &attributes);
  }
  
  /* try to use user defined colormap */
  if (ret == XpmColorFailed)
  {
    *clrmap = XCreateColormap(display,
    			       shWindow,
			       DefaultVisual(display, DefaultScreen(display)),
			       AllocNone);
    
    attributes.colormap = *clrmap;
    attributes.valuemask |= XpmColormap;
    ret = XpmReadFileToPixmap (display,
			       shWindow,
			       iconpath,
			       &npxm,
			       NULL,
			       &attributes);
  }
  
  /* perhaps, it's a bitmap */
  if (ret != 0)
  {
    ret = XReadBitmapFile (display,
			   shWindow,
			   iconpath,
			   &width,
			   &height,
			   &npxm,
			   &x_hot,
			   &y_hot);
  }
#else
  ret = XReadBitmapFile (display,
		     shWindow,
		     iconpath,
		     &width,
		     &height,
		     &npxm,
		     &x_hot,
		     &y_hot);
#endif
  if (ret)
    npxm = 0;
  
  /* return new loaded pixmap or zero */
  return npxm;
}


