/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: xmkdir.c,v 1.1 1997/01/07 08:34:59 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/xkhlib/xkhsrc/RCS/xmkdir.c,v $
 */
#define IS_EXTERN
#define EXTERN		extern

#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>
#include "Xinc.h"
#include <Xm/DrawingA.h>
#include <Xm/DrawnB.h>

#include "defines.h"
#include "Umem.h"
#include "Uxutil.h"
#include "Umessage.h"
#include "Umenu.h"
#include "Ufileutil.h"
#include "Ustrutil.h"
#include "xmisc.h"

extern int errno;
void mkdirStart (Widget w, Mkdir_t md, XmSelectionBoxCallbackStruct * cbs)
{
  char * NewDir;
  int Error = False;

  DEBUG1 ("mkdirStart:");

  if (! XmStringGetLtoR (cbs->value, XmFONTLIST_DEFAULT_TAG, &NewDir))
    return;

  /** if empty file list then break */
  if (NewDir == NULL || strlen (NewDir) == 0)
    {
      return;
    }

  DEBUG2 ("mkdirStart: Mkdir (%s)\n", NewDir);

  Error = UCreateDir (NewDir, ~UGetUmask(False) & 0777);
  if (Error)
    {
      static char Err[] = "Following error occured\n[%s]";
      char * Mess;
      char * ErrMess = strerror (errno);
      int len = strlen (Err) + strlen (ErrMess) + 1;

      Mess = gmalloc (len + 1, __LINE__, __FILE__);
      sprintf (Mess, Err, ErrMess);
      MessageBox (md->Parent,
		  "MkDirError",
		  Mess,
		  XmDIALOG_ERROR,
		  OK_BUTTON | DONOT_SETTITLE,
		  NULL, NULL);
      MFree (Mess, len);
    }
  else
    mkdirHide (md);

  DEBUG1 ("mkdirStart: End");
}

void mkdirCloseCB (Widget w, Mkdir_t md)
{
  mkdirHide (md);
}

Mkdir_t mkdirMake (void)
{
  Mkdir_t md;
  md = gcalloc (sizeof (mkdir_t), __LINE__, __FILE__);
  return md;
}

char * mkdirName (Mkdir_t md)
{
  static char tmp[MAXPATHLEN];
  sprintf (tmp, "Make a new directory [%s]", CurrentPath);
  return tmp;
}

Widget mkdirShell (Mkdir_t md)
{
  return md->dlgMd;
}

int mkdirHide (Mkdir_t md)
{
  if (md->dlgMd != NULL)
    {
      XtDestroyWidget (md->dlgMd);
      md->dlgMd = NULL;
      winDelWinMenu (md);
    }

  return True;
}

int mkdirDest (Mkdir_t md)
{
  if (md == NULL)
    return False;
    
  mkdirHide (md);

  mkdirHide  (md);
  StrReplace (md->DirName, NULL);
  MFree      (md, sizeof (mkdir_t));

  return True;
}

int mkdirView (Widget parent, Mkdir_t md)
{
  int ret;
  Widget sep1, sep2, sep3, sep4, sep5;

  if (md == NULL || parent == NULL)
    {
      return False;
    }
  
  if (md->dlgMd != NULL)
    {
      XMapRaised (XtDisplay (md->dlgMd), XtWindow (md->dlgMd));
      return True;
    }
  md->Parent = parent;

  DEBUG1 ("mkdirView:");

  md->dlgMd = XmCreatePromptDialog (parent, "mkdir", NULL, 0);
  if (md->dlgMd == NULL)
    return False;

  XtAddCallback (md->dlgMd, XmNokCallback,     (XtCallbackProc) mkdirStart,
		 md);
  XtAddCallback (md->dlgMd, XmNcancelCallback, (XtCallbackProc) mkdirCloseCB,
		 md);
  XtSetSensitive (XmSelectionBoxGetChild (md->dlgMd, XmDIALOG_HELP_BUTTON),
		  False);
  XtManageChild (md->dlgMd);
  XtPopup (XtParent (md->dlgMd), XtGrabNone);

  DEBUG1 ("mkdirView: Ende");

  return True;
}


