/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: xprop.c,v 1.3 1996/10/28 05:44:33 khamis Exp khamis $
 * $Source: /home/xkhfm/xkhlib/xkhsrc/RCS/xprop.c,v $
 */
#define IS_EXTERN
#define EXTERN		extern

#define WINMENU_NO_CLOSE

#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>
#include "Xinc.h"
#include <Xm/DrawingA.h>
#include <Xm/DrawnB.h>

#include "defines.h"
#include "Umem.h"
#include "Uxutil.h"
#include "Umessage.h"
#include "Umenu.h"
#include "Ufileutil.h"
#include "Ustrutil.h"
#include "Ucnfutil.h"
#include "Udchain.h"
#include "dir.h"
#include "util.h"
#include "xmisc.h"
#include "mainwin.h"
#include "window.h"

int propStart (Prop_t prop);

void propFlaggsCB (Widget w, Prop_t prop)
{
}

void propRedispCB (Widget w, Prop_t prop, XmDrawingAreaCallbackStruct * cbs)
{
  int width, h;

  if (cbs->window == 0)
    return;

  width = wdgWidth  (w);
  h     = wdgHeight (w);

  if (cbs->reason == XmCR_EXPOSE ||
      cbs->reason == XmCR_RESIZE)
    {
      XClearArea (display,
		  cbs->window,
		  0, 0, width, h,
		  False);
    }
}

int propViewFiles (Dchain_t src, Dchain_t dst, Prop_t prop)
{
  XEvent event;
  char str[MAXPATHLEN];
  XmString Src;

  if (prop->Stop)
    return DIR_CANCEL;

  sprintf (str, "File %s", dirName (src));
  Src  = XmStringCreateSimple (str);
  XtVaSetValues (prop->lblState, XmNlabelString, Src,  NULL);
  XmStringFree (Src);

  XFlush (display);
  XmUpdateDisplay (prop->dlgProp);

  while (XCheckMaskEvent (display,
			  ALL_MASKS,
			  &event))
    {
      /* Do Nothing */
      XtDispatchEvent (&event);
    }

  return False;
}

int propAsk (Dchain_t src, Dchain_t dst, Prop_t prop)
{
  char Mess[MAXPATHLEN*2];
  int ret = DIR_NO;

  /*
   * MessageBox to ask properity changing
   */
  sprintf (Mess,
	   "change properity of\n"
	   "[%s]\n"
	   "are you shure ?",
	   dirName (src),
	   dirName (dst));

  ret = MessageBox (prop->dlgProp,
		    "PropAsk",
		    Mess,
		    XmDIALOG_QUESTION,
		    OK_BUTTON | CANCEL_BUTTON | HELP_BUTTON |
		    CLOSE_ON_HELP | DONOT_SETTITLE,
		    NULL, NULL);

  if (ret == 0) ret = False;
  if (ret == 1) ret = DIR_NO;
  if (ret == 2) ret = DIR_CANCEL;

  return ret;
}

extern int errno;
int propError (Dchain_t dst, Prop_t prop)
{
  static char ErrFrmt [] =
    "Following error detected by changing properities of\n[%s]\n%s";
  char * Mess;
  char * ErrMess = strerror (errno);
  int ret;

  Mess = gmalloc (strlen (ErrFrmt)
		  + strlen (ErrMess)
		  + strlen (dirName (dst))
		  + 1, __LINE__, __FILE__);
  sprintf (Mess, ErrFrmt, ErrMess, dirName  (dst));
  ret = MessageBox (prop->dlgProp,
		    "PropError",
		    Mess,
		    XmDIALOG_ERROR,
		    OK_BUTTON|CANCEL_BUTTON | DONOT_SETTITLE,
		    NULL, NULL);
  if (ret == 1) ret = DIR_CANCEL;
  return ret;
}

void btnPropStopCB (Widget w, Prop_t prop)
{
  prop->Stop = True;
}

void btnPropOkCB (Widget w, Prop_t prop)
{
  int ret;
  ret = propStart (prop);
}

void btnPropCloseCB (Widget w, Prop_t prop)
{
  propHide (prop);
}

static menuitem_t itempropFlags [] =
{
  { (void (*) (Widget, void *)) propFlaggsCB, "Rights", True, NULL },
  { (void (*) (Widget, void *)) propFlaggsCB, "Owner", True, NULL },
  { (void (*) (Widget, void *)) propFlaggsCB, "Group", True, NULL },
  { (void (*) (Widget, void *)) propFlaggsCB, "Skip Directories", True, NULL },
  { (void (*) (Widget, void *)) propFlaggsCB, "Skip Links", True, NULL },
  { (void (*) (Widget, void *)) propFlaggsCB, "Skip Files", True, NULL },
  { (void (*) (Widget, void *)) propFlaggsCB, "Recursive", True, NULL },
  { (void (*) (Widget, void *)) propFlaggsCB, "Confirm every changing",
    True, NULL },
  { NULL, NULL}
};
static menu_t mnupropFlaggs [] =
{ 
  { "ProperityFlaggs", itempropFlags, True, NULL },
  { NULL, NULL }
};

static menuitem_t itempropRights [] =
{
  /* Owner */
  { (void (*) (Widget, void *)) propFlaggsCB, "Read", True, NULL },
  { (void (*) (Widget, void *)) propFlaggsCB, "Write", True, NULL },
  { (void (*) (Widget, void *)) propFlaggsCB, "Execute", True, NULL },

  { (void (*) (Widget, void *)) propFlaggsCB, "Skip", True, NULL },
  { (void (*) (Widget, void *)) propFlaggsCB, "Skip", True, NULL },
  { (void (*) (Widget, void *)) propFlaggsCB, "Skip", True, NULL },

  /* Group */
  { (void (*) (Widget, void *)) propFlaggsCB, "Read", True, NULL },
  { (void (*) (Widget, void *)) propFlaggsCB, "Write", True, NULL },
  { (void (*) (Widget, void *)) propFlaggsCB, "Execute", True, NULL },

  { (void (*) (Widget, void *)) propFlaggsCB, "Skip", True, NULL },
  { (void (*) (Widget, void *)) propFlaggsCB, "Skip", True, NULL },
  { (void (*) (Widget, void *)) propFlaggsCB, "Skip", True, NULL },

  /* Other */
  { (void (*) (Widget, void *)) propFlaggsCB, "Read", True, NULL },
  { (void (*) (Widget, void *)) propFlaggsCB, "Write", True, NULL },
  { (void (*) (Widget, void *)) propFlaggsCB, "Execute", True, NULL },

  { (void (*) (Widget, void *)) propFlaggsCB, "Skip", True, NULL },
  { (void (*) (Widget, void *)) propFlaggsCB, "Skip", True, NULL },
  { (void (*) (Widget, void *)) propFlaggsCB, "Skip", True, NULL },

  { NULL, NULL}
};

static menu_t mnupropRights [] =
{ 
  { "RadioRights", itempropRights, True, NULL },
  { NULL, NULL }
};

static menuitem_t itemProp [] =
{
  { (void(*)(Widget,void*)) btnPropOkCB, "Start", True, NULL },
  { NULL, MENU_SEPARATOR, False, NULL },
  { (void(*)(Widget,void*)) btnPropCloseCB, "Close", True, NULL },
  { NULL, NULL }
};

static menu_t menuProp [] =
{
  { "Properities", itemProp, True, NULL },
  { "Window", itemWinMenu, True, NULL },
  { NULL, NULL, False, NULL }
};

Prop_t propMake (void)
{
  Prop_t prop;
  prop = gcalloc (sizeof (prop_t), __LINE__, __FILE__);
  prop->Rights = 0;
  prop->Owner  = StrAppend (prop->Owner, "");
  prop->Group  = StrAppend (prop->Group, "");
  memset (&prop->info, 0, sizeof (prop->info));
  prop->info.Enclose = StrReplace (prop->info.Enclose, "*");
  prop->info.Ignore = StrReplace (prop->info.Ignore, "");
  prop->info.Filter = StrReplace (prop->info.Filter, "");
  prop->info.mode    = PROP_ENCLOSE_RIGHTS;
  return prop;
}

char * propName (Prop_t prop)
{
  static char tmp[MAXPATHLEN];
  static char fmt[] = "Properities [%s]";
  sprintf (tmp, fmt,
           dirCutPath (prop->Files,
	               MNU_STRLEN - strlen(fmt) - 1,
		       False));
  return tmp;
}

Widget propShell (Prop_t prop)
{
  return prop->dlgProp;
}

int propHide (Prop_t prop)
{
  if (prop->dlgProp != NULL)
    {
      if (prop->LockedRevert || prop->Locked)
	{
	  XMapRaised (XtDisplay (prop->dlgProp), XtWindow (prop->dlgProp));
	  XBell (display, 0);
	  return False;
	}

      XtDestroyWidget (prop->dlgProp);

      txtDest (prop->txtFiles);
      comDest (prop->comGroup);
      comDest (prop->comOwner);
      txtDest (prop->txtFilter);
      txtDest (prop->txtIgnore);
      txtDest (prop->txtEnclose);
      radDest (prop->radRights);
      radDest (prop->radPropFlaggs);

      prop->dlgProp = NULL;
      winDelWinMenu (winGetListFromObj (prop));
    }

  return True;
}

int propDest (Prop_t prop)
{
  if (prop == NULL)
    return False;

  if (!propHide (prop))
    return False;

  StrReplace (prop->Owner, NULL);
  StrReplace (prop->Group, NULL);
  StrReplace (prop->Files, NULL);
  StrReplace (prop->info.Filter, NULL);
  StrReplace (prop->info.Enclose, NULL);
  StrReplace (prop->info.Ignore, NULL);

  MFree (prop, sizeof (prop_t));

  return True;
}

void btnRevertCB (Widget w, Prop_t prop)
{
  propCalcSize (prop);
}

void btnRevStopCB (Widget w, Prop_t prop)
{
  prop->StopRevert = True;
}

int propSize (Dchain_t src, Dchain_t dst, DirInfo_t info)
{
  Prop_t pr = (Prop_t) info->ClData;
  int ret = False;

  switch (dirType (src))
    {
    case TYPE_DIR:
      pr->DirsCnt ++;
      break;
    case TYPE_LNK:
      pr->LinksCnt ++;
      break;
    default:
      pr->FilesCnt ++;
      pr->Size += dirSize (src);
      break;
    }

  return 0;
}

int propViewSize (Dchain_t src, Dchain_t dst, Prop_t prop)
{
  char str[MAXPATHLEN];
  XmString Src;
  XEvent event;

  if (src != NULL && dirType (src) == TYPE_DIR)
    {
      sprintf (str, "Size of %s", dirName (src));
      Src  = XmStringCreateSimple (str);
      XtVaSetValues (prop->lblState, XmNlabelString, Src,  NULL);
      XmStringFree (Src);
    }
  
  if (src == NULL || dirType (src) == TYPE_DIR)
    {
      sprintf (str,
	       "Directories: %3i, Files: %4i, Links: %3i, Size: %6.3f kBytes",
	       prop->DirsCnt, prop->FilesCnt, prop->LinksCnt,
	       (double) prop->Size / 1000.0);
      Src  = XmStringCreateSimple (str);
      XtVaSetValues (prop->lblInfo, XmNlabelString, Src,  NULL);
      XmStringFree (Src);
    }

  XFlush (display);
  XmUpdateDisplay (prop->dlgProp);
  
  while (XCheckMaskEvent (display, ALL_MASKS, &event))
    {
      XtDispatchEvent (&event);
    }

  if (prop->StopRevert)
    return DIR_CANCEL;

  return False;
}

int propCalcSize (Prop_t prop)
{
  Dchain_t srcList, dummy;
  dirInfo_t info;
  char * files, * p;
  XmString stop;
  int pos, i;

  /** get file list to get size and count */
  files = XmTextGetString (prop->txtFiles->txtText);

  if (files == NULL)
    return False;

  if (strlen (files) == 0)
    {
      XtFree (files);
      return False;
    }

  prop->LockedRevert = True;

  stop = XmStringCreateSimple ("Stop");
  XtVaSetValues (prop->btnRevert, XmNlabelString, stop, NULL);
  XmStringFree (stop);
  XtRemoveCallback (prop->btnRevert, XmNactivateCallback, 
		    (XtCallbackProc) btnRevertCB,
		    prop);
  XtAddCallback (prop->btnRevert, XmNactivateCallback, 
		 (XtCallbackProc) btnRevStopCB,
		 prop);

  prop->DirsCnt = 0;
  prop->FilesCnt = 0;
  prop->LinksCnt = 0;
  prop->Size = 0;
  prop->StopRevert = False;

  memset (&info, 0, sizeof (info));
  info.Enclose       = "*";
  info.mode          = DIR_RECURSIVE;
  info.ClProc        = (int (*) (Dchain_t,Dchain_t,void*)) propSize;
  info.ViewFilesProc = (int (*) (Dchain_t,Dchain_t,void*)) propViewSize;
  info.ClData        = prop;

  /* properity changing for the list of selected files */
  for (pos=0, p = files; True;)
    {
      pos = StrChrIndex (p, ' ');
      
      if (pos >= 0) p [pos] = 0;
      
      if (strlen (p) > 0)
	{
	  DEBUG2 ("propCalcSize: properity of (%s)\n", p);
	  
	  srcList = dirAdd (NULL, p);
	  dummy   = dirAdd (NULL, p);
	  
	  info.mode |= dirRecursive (srcList,
				     dummy,
				     &info);
	  
	  dirDelete (srcList);
	  dirDelete (dummy);
	}
      if (info.mode & DIR_CANCEL) break;      
      if (pos < 0) break;
      
      p += pos + 1;
    }

  propViewSize (NULL, NULL, prop);
  
  if (files   != NULL)
    XtFree (files);

  stop = XmStringCreateSimple ("Restart");
  XtVaSetValues (prop->btnRevert, XmNlabelString, stop, NULL);
  XmStringFree (stop);
  XtRemoveCallback (prop->btnRevert, XmNactivateCallback, 
		    (XtCallbackProc) btnRevStopCB,
		    prop);
  XtAddCallback (prop->btnRevert, XmNactivateCallback, 
		 (XtCallbackProc) btnRevertCB,
		 prop);

  prop->LockedRevert = False;

  return True;
}

int propDispValues (Prop_t prop)
{
  int i, pos;
  unsigned int s, r;
  char *p;

  prop->Rights = 0;
  prop->Skip   = 0;
  if (prop->Owner != NULL) free (prop->Owner);
  prop->Owner = StrAppend (NULL, "");
  if (prop->Group != NULL) free (prop->Group);
  prop->Group = StrAppend (NULL, "");
  
  if (prop->Files == NULL)
    prop->Files = StrReplace (prop->Files, "");

  for (p=prop->Files; p[0] != 0; )
    {
      pos = StrChrIndex (p, ' ');

      if (pos > 0)
	p [pos] = 0;

      if (p[0] != 0)
	{
	  char * user, * grp;
	  Dchain_t dir = dirAdd (NULL, p);
	  int rights = dirRights (dir);
	  /* skip the different bits */
	  if ((prop->Rights != 0) && (prop->Rights != rights))
	    prop->Skip |=
	      (prop->Rights & ~rights) |
	      (~prop->Rights & rights);
	  prop->Rights |= rights;
	  
	  user = usrNameById (UserList, dirUserId (dir));
	  if (user != NULL && ! StringFindStr (prop->Owner, user))
	    {
	      if (strlen (prop->Owner) > 0)
		prop->Owner = StrAppend (prop->Owner, " ");
	      prop->Owner = StrAppend (prop->Owner, user);
	    }
	  
	  grp =  grpNameById (GrpList, dirGrpId (dir));
	  if (grp != NULL && ! StringFindStr (prop->Group, grp))
	    {
	      if (strlen (prop->Group) > 0)
		prop->Group = StrAppend (prop->Group, " ");
	      prop->Group = StrAppend (prop->Group,  grp);
	    }
	  
	  DEBUG3 ("propView: Owner(%s), Grp(%s)\n", user, grp);
	  
	  dirDelete (dir);
	}

      if (pos < 0)
	break;

      p [pos] = ' ';
      p += pos + 1;
    }

  XmTextSetString (prop->txtFiles->txtText,
		   (prop->Files != NULL)
		   ? prop->Files
		   : "");
  XmTextSetString   (prop->comOwner->txtCombo, prop->Owner);
  XmTextSetString   (prop->comGroup->txtCombo, prop->Group);

  r = 1, s = 1;
  for (i=0; i<18; i++)
    {
      if ((i/3) % 2)
	{
	  XmToggleButtonGadgetSetState
	  (prop->radRights->btnRadio[17-i],
	   (prop->Rights & s)
	   ? True : False,
	   False);
	  s <<= 1;
	}
      else
	{
	  XmToggleButtonGadgetSetState
	    (prop->radRights->btnRadio[17-i],
	     (prop->Skip & r) ? True : False,
	     False);
	  r <<= 1;
	}
    }

  i=0;
  XmToggleButtonGadgetSetState (prop->radPropFlaggs->btnRadio[i],
				prop->info.mode & PROP_ENCLOSE_RIGHTS
				? True
				: False,
				False); i++;
  XmToggleButtonGadgetSetState (prop->radPropFlaggs->btnRadio[i],
				prop->info.mode & PROP_ENCLOSE_OWN
				? True
				: False,
				False); i++;
  XmToggleButtonGadgetSetState (prop->radPropFlaggs->btnRadio[i],
				prop->info.mode & PROP_ENCLOSE_GRP
				? True
				: False,
				False); i++;
  XmToggleButtonGadgetSetState (prop->radPropFlaggs->btnRadio[i],
				prop->info.mode & DIR_SKIP_DIRS
				? True
				: False,
				False); i++;
  XmToggleButtonGadgetSetState (prop->radPropFlaggs->btnRadio[i],
				prop->info.mode & DIR_SKIP_LINKS
				? True
				: False,
				False); i++;
  XmToggleButtonGadgetSetState (prop->radPropFlaggs->btnRadio[i],
				prop->info.mode & DIR_SKIP_FILES
				? True
				: False,
				False); i++;
  XmToggleButtonGadgetSetState (prop->radPropFlaggs->btnRadio[i],
				prop->info.mode & DIR_RECURSIVE
				? True
				: False,
				False); i++;
  XmToggleButtonGadgetSetState (prop->radPropFlaggs->btnRadio[i],
				prop->info.mode & DIR_ASK
				? True
				: False,
				False); i++;
  XtManageChild (prop->radPropFlaggs->radRadio);
  return True;
}

int propView (Widget parent, Prop_t prop)
{
  int ret, i, len;
  Widget sep1, sep2, sep3, sep4, sep5, sep6;
  Dchain_t usr, grp;

  if (prop == NULL || parent == NULL)
    {
      return False;
    }

  if (prop->Locked || prop->LockedRevert)
    {
      XMapRaised (XtDisplay (prop->dlgProp), XtWindow (prop->dlgProp));
      XBell (display, 0);
      return True;
    }

  
  DEBUG3 ("propView: Rights(%o), Skip(%o)\n", prop->Rights, prop->Skip);

  if (prop->dlgProp != NULL)
    {
      propDispValues (prop);
      propCalcSize   (prop);

      XMapRaised (XtDisplay (prop->dlgProp), XtWindow (prop->dlgProp));
      return True;
    }
  prop->Parent = parent;

  DEBUG1 ("propView:");

  ret = winCreate ( /*parent,*/
		   "Properities",
		   &prop->dlgProp,
		   &prop->winProp,
		   &prop->fomMain,
		   6,
		   prop,
		   (void (*)(Widget, void*))btnPropCloseCB,
		   False /*DLG_MESSAGE|DLG_NOT_MODAL*/ );
  if (ret == False)
    return False;
  mnuMake (prop->winProp, menuProp, prop);
#if 0
  XtAddCallback (prop->dlgProp, XmNokCallback, (XtCallbackProc) btnPropOkCB,
		 prop);
  XtAddCallback (prop->dlgProp, XmNcancelCallback,
		 (XtCallbackProc) btnPropCloseCB,
		 prop);
#endif

  XtVaSetValues (prop->fomMain,
		 XmNtopOffset,     SPACE,
		 XmNrightOffset,   SPACE,
		 XmNleftOffset,    SPACE,
		 XmNbottomOffset,  SPACE,
		 NULL);

  DEBUG1 ("xprop: txtCreate Files");

  prop->txtFiles = txtCreate (prop->fomMain,
			     "Files",
			      0,
			      NULL,
			      HLP_PROP_FILES,
			      False);
  XtVaSetValues (prop->txtFiles->fomText,
		 XmNtopAttachment,    XmATTACH_FORM,
		 XmNleftAttachment,   XmATTACH_FORM,
		 XmNrightAttachment,  XmATTACH_FORM,
		 XmNtopOffset,        SPACE,
		 XmNrightOffset,      SPACE,
		 XmNleftOffset,       SPACE,
		 XmNbottomOffset,     SPACE,
		 NULL);
  XtManageChild   (prop->txtFiles->fomText);

  DEBUG1 ("xprop: comCreate Owner");

  prop->comOwner =
    comCreate (prop->fomMain,
	       "Owner",
	       NULL,
	       HLP_PROP_OWNER,
	       prop,
	       COM_SIDELABEL);
  XtVaSetValues (prop->comOwner->fomCombo,
		 XmNtopAttachment,    XmATTACH_WIDGET,
		 XmNtopWidget,        prop->txtFiles->fomText,
		 XmNleftAttachment,   XmATTACH_FORM,
		 XmNrightAttachment,  XmATTACH_FORM,
		 XmNtopOffset,        SPACE,
		 XmNrightOffset,      SPACE,
		 XmNleftOffset,       SPACE,
		 XmNbottomOffset,     SPACE,
		 NULL);
  XmTextSetEditable (prop->comOwner->txtCombo, False);
  XtManageChild     (prop->comOwner->fomCombo);

  DEBUG1 ("xprop: comCreate Group");

  prop->comGroup =
    comCreate (prop->fomMain,
	       "Group",
	       NULL,
	       HLP_PROP_GROUP,
	       prop,
	       COM_SIDELABEL);
  XtVaSetValues (prop->comGroup->fomCombo,
		 XmNtopAttachment,    XmATTACH_WIDGET,
		 XmNtopWidget,        prop->comOwner->fomCombo,
		 XmNleftAttachment,   XmATTACH_FORM,
		 XmNrightAttachment,  XmATTACH_FORM,
		 XmNtopOffset,        SPACE,
		 XmNrightOffset,      SPACE,
		 XmNleftOffset,       SPACE,
		 XmNbottomOffset,     SPACE,
		 NULL);
  XmTextSetEditable (prop->comGroup->txtCombo, False);
  XtManageChild     (prop->comGroup->fomCombo);

  sep4 =
    XtVaCreateManagedWidget ("Separator",
			     xmSeparatorGadgetClass,
			     prop->fomMain,			     
			     XmNtopAttachment,    XmATTACH_WIDGET,
			     XmNtopWidget,        prop->comGroup->fomCombo,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNrightAttachment,  XmATTACH_FORM,
			     XmNtopOffset,        SPACE,
			     XmNrightOffset,      SPACE,
			     XmNleftOffset,       SPACE,
			     XmNbottomOffset,     SPACE,
			     NULL);
  XtManageChild (sep4);

  prop->lblOwner =
    XtVaCreateManagedWidget ("Owner",
			     xmLabelGadgetClass,
			     prop->fomMain,			     
			     XmNtopAttachment,    XmATTACH_WIDGET,
			     XmNtopWidget,        sep4,
			     XmNleftAttachment,   XmATTACH_POSITION,
			     XmNleftPosition,     0,
			     XmNrightAttachment,  XmATTACH_POSITION,
			     XmNrightPosition,    2,
			     XmNtopOffset,        SPACE,
			     XmNleftOffset,       SPACE,
			     XmNrightOffset,      SPACE,
			     XmNbottomOffset,     SPACE,
			     NULL);
  XtManageChild (prop->lblOwner);

  prop->lblGroup =
    XtVaCreateManagedWidget ("Group",
			     xmLabelGadgetClass,
			     prop->fomMain,			     
			     XmNtopAttachment,    XmATTACH_WIDGET,
			     XmNtopWidget,        sep4,
			     XmNleftAttachment,   XmATTACH_POSITION,
			     XmNleftPosition,     2,
			     XmNrightAttachment,  XmATTACH_POSITION,
			     XmNrightPosition,    4,
			     XmNtopOffset,        SPACE,
			     XmNleftOffset,       SPACE,
			     XmNrightOffset,      SPACE,
			     XmNbottomOffset,     SPACE,
			     NULL);
  XtManageChild (prop->lblGroup);

  prop->lblOther =
    XtVaCreateManagedWidget ("Other",
			     xmLabelGadgetClass,
			     prop->fomMain,			     
			     XmNtopAttachment,    XmATTACH_WIDGET,
			     XmNtopWidget,        sep4,
			     XmNleftAttachment,   XmATTACH_POSITION,
			     XmNleftPosition,     4,
			     XmNrightAttachment,  XmATTACH_POSITION,
			     XmNrightPosition,    6,
			     XmNtopOffset,        SPACE,
			     XmNleftOffset,       SPACE,
			     XmNrightOffset,      SPACE,
			     XmNbottomOffset,     SPACE,
			     NULL);
  XtManageChild (prop->lblOther);

  DEBUG1 ("propView: radCreate radRights");
  prop->radRights = radCreate (prop->fomMain,
			       mnupropRights,
			       HLP_PROP_RIGHTS,
			       prop,
			       TOGGLEE_BOX);
  XtVaSetValues (prop->radRights->radRadio,
		 XmNnumColumns,       6,
		 XmNtopAttachment,    XmATTACH_WIDGET,
		 XmNtopWidget,        prop->lblOwner,
		 XmNrightAttachment,  XmATTACH_FORM,
		 XmNleftAttachment,   XmATTACH_FORM,
		 XmNtopOffset,        SPACE,
		 XmNrightOffset,      SPACE,
		 XmNleftOffset,       SPACE,
		 XmNbottomOffset,     SPACE,
		 NULL);
  DEBUG3 ("propView: radRights(%o), Skip(%o)\n", prop->Rights, prop->Skip);
  XtManageChild (prop->radRights->radRadio);

  sep1 =
    XtVaCreateManagedWidget ("Separator",
			     xmSeparatorGadgetClass,
			     prop->fomMain,
			     XmNtopAttachment,    XmATTACH_WIDGET,
			     XmNtopWidget,        prop->radRights->radRadio,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNrightAttachment,  XmATTACH_FORM,
			     XmNtopOffset,        SPACE,
			     XmNrightOffset,      SPACE,
			     XmNleftOffset,       SPACE,
			     XmNbottomOffset,     SPACE,
			     NULL);
  XtManageChild (sep1);

  prop->txtFilter = txtCreate (prop->fomMain,
			       "Directory Filter",
			       0,
			       NULL,
			       HLP_PROP_FILTER,
			       False);
  XtVaSetValues (prop->txtFilter->fomText,
		 XmNtopAttachment,    XmATTACH_WIDGET,
		 XmNtopWidget,        sep1,
		 XmNleftAttachment,   XmATTACH_FORM,
		 XmNrightAttachment,  XmATTACH_FORM,
		 XmNtopOffset,        SPACE,
		 XmNrightOffset,      SPACE,
		 XmNleftOffset,       SPACE,
		 XmNbottomOffset,     SPACE,
		 NULL);
  XmTextSetString (prop->txtFilter->txtText,
		   (prop->info.Filter != NULL)
		   ? prop->info.Filter
		   : "");
  XtManageChild  (prop->txtFilter->fomText);

  prop->txtEnclose = txtCreate (prop->fomMain,
			    "Enclose",
			    0, NULL, HLP_PROP_ENCLOSE,
			    False);
  XtVaSetValues (prop->txtEnclose->fomText,
		 XmNtopAttachment,   XmATTACH_WIDGET,
		 XmNtopWidget,	     prop->txtFilter->fomText,
		 XmNleftAttachment,  XmATTACH_FORM,
		 XmNrightAttachment, XmATTACH_POSITION,
		 XmNrightPosition,   3,

		 XmNtopOffset,       SPACE,
		 XmNrightOffset,     SPACE,
		 XmNleftOffset,      SPACE,
		 XmNbottomOffset,    SPACE,
		 NULL);
  XmTextSetString (prop->txtEnclose->txtText,
		   (prop->info.Enclose != NULL)
		   ? prop->info.Enclose
		   : "");
  XtManageChild   (prop->txtEnclose->fomText);

  prop->txtIgnore = txtCreate (prop->fomMain,
				 "Ignore",
				 0, NULL, HLP_PROP_IGNORE,
				 False);
  XtVaSetValues (prop->txtIgnore->fomText,
		 XmNtopAttachment,    XmATTACH_WIDGET,
		 XmNtopWidget,	      prop->txtFilter->fomText,
		 XmNleftAttachment,   XmATTACH_POSITION,
		 XmNleftPosition,     3,
		 XmNrightAttachment,  XmATTACH_FORM,
		 XmNtopOffset,        SPACE,
		 XmNrightOffset,      SPACE,
		 XmNleftOffset,       SPACE,
		 XmNbottomOffset,     SPACE,
		 NULL);
  XmTextSetString (prop->txtIgnore->txtText,
		   (prop->info.Ignore != NULL)
		   ? prop->info.Ignore
		   : "");
  XtManageChild (prop->txtIgnore->fomText);

  sep6 =
    XtVaCreateManagedWidget ("Separator",
			     xmSeparatorGadgetClass,
			     prop->fomMain,
			     
			     XmNtopAttachment,    XmATTACH_WIDGET,
			     XmNtopWidget,        prop->txtIgnore->fomText,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNrightAttachment,  XmATTACH_FORM,
			     XmNtopOffset,        SPACE,
			     XmNrightOffset,      SPACE,
			     XmNleftOffset,       SPACE,
			     XmNbottomOffset,     SPACE,
			     NULL);
  XtManageChild (sep6);

  prop->lblInfo =
    XtVaCreateManagedWidget ("Directories: 000, Files: 0000, "
			     "Links: 000, Size: 00000 kBytes, ",
			     xmLabelGadgetClass,
			     prop->fomMain,
			     XmNalignment,        XmALIGNMENT_BEGINNING,
			     XmNtopAttachment,    XmATTACH_WIDGET,
			     XmNtopWidget,        sep6,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNrightAttachment,  XmATTACH_POSITION,
			     XmNrightPosition,    5,
			     XmNtopOffset,        SPACE,
			     XmNleftOffset,       SPACE,
			     XmNrightOffset,      SPACE,
			     XmNbottomOffset,     SPACE,
			     NULL);
  XtManageChild (prop->lblInfo);

  prop->btnRevert =
    XtVaCreateManagedWidget ("Restart",
			     xmPushButtonGadgetClass,
			     prop->fomMain,
			     XmNmnemonic,         'R',
			     XmNtraversalOn,      False,
			     XmNtopAttachment,    XmATTACH_WIDGET,
			     XmNtopWidget,        sep6,
			     XmNrightAttachment,  XmATTACH_FORM,
			     XmNleftAttachment,   XmATTACH_POSITION,
			     XmNleftPosition,     5,
			     XmNtopOffset,      SPACE,
			     XmNleftOffset,     SPACE,
			     XmNrightOffset,    SPACE,
			     XmNbottomOffset,   SPACE,			     
			     NULL);
  XtAddCallback (prop->btnRevert, XmNactivateCallback, 
		 (XtCallbackProc) btnRevertCB,
		 prop);

  sep3 =
    XtVaCreateManagedWidget ("Separator",
			     xmSeparatorGadgetClass,
			     prop->fomMain,
			     
			     XmNtopAttachment,    XmATTACH_WIDGET,
			     XmNtopWidget,        prop->lblInfo,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNrightAttachment,  XmATTACH_FORM,
			     XmNtopOffset,     SPACE,
			     XmNrightOffset,     SPACE,
			     XmNleftOffset,     SPACE,
			     XmNbottomOffset,     SPACE,
			     NULL);
  XtManageChild (sep3);


  DEBUG1 ("propView: Start");

  prop->btnStart =
    XtVaCreateManagedWidget ("Start",
			     xmPushButtonGadgetClass,
			     prop->fomMain,
			     XmNdefaultButtonShadowThickness,    2,
			     XmNshowAsDefault,    2,
			     XmNleftAttachment,   XmATTACH_POSITION,
			     XmNleftPosition,     1,
			     XmNrightAttachment,  XmATTACH_POSITION,
			     XmNrightPosition,    2,
			     XmNbottomAttachment, XmATTACH_FORM,
			     XmNtopOffset,      SPACE,
			     XmNleftOffset,     SPACE,
			     XmNrightOffset,    SPACE,
			     XmNbottomOffset,   SPACE,			     
			     NULL);
  XtAddCallback (prop->btnStart, XmNactivateCallback, 
		 (XtCallbackProc) btnPropOkCB,
		 prop);
  btnMesgArea   (prop->btnStart, PROP_OK);
  mwinSetPixmapToWidget (prop->btnStart, PIXM_tool_run48,   MWIN_LOADANDSET);
  XtManageChild (prop->btnStart);
  
  DEBUG1 ("propView: Close");

  prop->btnClose =
    XtVaCreateManagedWidget ("Close",
			     xmPushButtonGadgetClass,
			     prop->fomMain,
			     XmNshowAsDefault,    2,
			     XmNrightAttachment,  XmATTACH_POSITION,
			     XmNrightPosition,    5,
			     XmNleftAttachment,   XmATTACH_POSITION,
			     XmNleftPosition,     4,
			     XmNbottomAttachment, XmATTACH_FORM,
			     XmNtopOffset,      SPACE,
			     XmNleftOffset,     SPACE,
			     XmNrightOffset,    SPACE,
			     XmNbottomOffset,   SPACE,			     
			     NULL);
  XtAddCallback (prop->btnClose, XmNactivateCallback, 
		 (XtCallbackProc) btnPropCloseCB,
		 prop);
  btnMesgArea   (prop->btnClose, PROP_CLOSE);
  mwinSetPixmapToWidget (prop->btnClose, PIXM_tool_abort48, MWIN_LOADANDSET);
  mwinSetPixmapToWidget (prop->btnClose, PIXM_tool_abortd48,
			 MWIN_DISABLED);
  XtManageChild (prop->btnClose);

  sep5 =
    XtVaCreateManagedWidget ("Separator",
			     xmSeparatorGadgetClass,
			     prop->fomMain,
			     
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNrightAttachment,  XmATTACH_FORM,
			     XmNbottomAttachment, XmATTACH_WIDGET,
			     XmNbottomWidget,     prop->btnStart,
			     XmNtopOffset,        SPACE,
			     XmNbottomOffset,     SPACE,
			     NULL);
  XtManageChild (sep3);

  /*******************/
  prop->lblState =
    XtVaCreateManagedWidget ("Click on Startbutton to start Modification",
			     xmLabelGadgetClass,
			     prop->fomMain,			     
			     XmNrightAttachment,  XmATTACH_FORM,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNbottomAttachment, XmATTACH_WIDGET,
			     XmNbottomWidget,     sep5,
			     XmNtopOffset,        SPACE,
			     XmNleftOffset,       SPACE,
			     XmNrightOffset,      SPACE,
			     XmNbottomOffset,     SPACE,
			     NULL);
  XtManageChild (prop->lblState);

  sep4 =
    XtVaCreateManagedWidget ("Separator",
			     xmSeparatorGadgetClass,
			     prop->fomMain,			     
			     XmNbottomAttachment, XmATTACH_WIDGET,
			     XmNbottomWidget,     prop->lblState,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNrightAttachment,  XmATTACH_FORM,
			     XmNtopOffset,        SPACE,
			     XmNrightOffset,      SPACE,
			     XmNleftOffset,       SPACE,
			     XmNbottomOffset,     SPACE,
			     NULL);
  XtManageChild (sep4);

  DEBUG2 ("propView: modes(%b)\n", prop->info.mode);
  prop->radPropFlaggs = radCreate (prop->fomMain,
				 mnupropFlaggs,
				 HLP_PROP_FLAGGS,
				 prop,
				 TOGGLEE_BOX);
  XtVaSetValues (prop->radPropFlaggs->radRadio,
		 XmNnumColumns,       3,
		 XmNtopAttachment,    XmATTACH_WIDGET,
		 XmNtopWidget,        sep3,
		 XmNrightAttachment,  XmATTACH_FORM,
		 XmNleftAttachment,   XmATTACH_FORM,
		 XmNbottomAttachment, XmATTACH_WIDGET,
		 XmNbottomWidget,     sep4,
		 XmNtopOffset,        SPACE,
		 XmNrightOffset,      SPACE,
		 XmNleftOffset,       SPACE,
		 XmNbottomOffset,     SPACE,
		 NULL);

  XtManageChild     (prop->fomMain);
  XtManageChild     (prop->winProp);

  /*
  XtManageChild     (prop->dlgProp);
  XtPopup (XtParent (prop->dlgProp), XtGrabNone);
  XMapRaised (XtDisplay (prop->dlgProp), XtWindow (prop->dlgProp));
  */
  MXtRealizeWidget (prop->dlgProp);
  
  for (usr=UdchNext (UserList);
       usr != NULL;
       usr=UdchNext (usr))
    {
      comAddItem (prop->comOwner, usrName (usr), LIST_SORTED);
    }
  for (grp=UdchNext (GrpList);
       grp != NULL;
       grp=UdchNext (grp))
    {
      comAddItem (prop->comGroup, grpName (grp), LIST_SORTED);
    }

  propDispValues (prop);
  propCalcSize (prop);

  DEBUG1 ("propView: Ende");

  return True;
}

int propModify (Dchain_t src, Dchain_t dst, DirInfo_t info)
{
  Prop_t pr = (Prop_t) info->ClData;
  int ret = False;

  DEBUG5 ("propModify: (%s), Rights(%o), Skip(%o), mode(%o), ",
	  dirName (src), pr->Rights, pr->Skip, pr->info.mode
	  );
  DEBUG3 ("Uid(%i), Gid(%i)\n", pr->OwnId, pr->GrpId);

  if (pr->info.mode & PROP_ENCLOSE_RIGHTS)
    {
      ushort fmod = dirRights (src);
      fmod = (pr->Rights & ~ pr->Skip) | (fmod & pr->Skip);
      ret = chmod (dirName (src), fmod & 0777 );
    }

  if ((pr->info.mode & PROP_ENCLOSE_OWN) || (pr->info.mode & PROP_ENCLOSE_GRP))
    {
#ifdef HAVE_LCHOWN
      ret = lchown (dirName (src), pr->OwnId, pr->GrpId);
#else
      ret = chown (dirName (src), pr->OwnId, pr->GrpId);
#endif
    }

  if (ret)
    return DIR_ERROR;
  else
    return 0;
}

int propStart (Prop_t prop)
{
  Dchain_t srcList, dummy;
  XmString stop;
  char * files, * p;
  int pos, count = 0;
  int Error = False;
  int i, ret;
  ushort r, s;

  DEBUG1 ("propStart:");

  if (prop->Locked)
    {
      XBell (display, 0);
      return False;
    }

  prop->Stop = False;

  /*
   * get properity flaggs
   */
  i = 0;
  prop->info.mode = 0;
  /* Rights only */
  if (XmToggleButtonGadgetGetState (prop->radPropFlaggs->btnRadio[i]))
    prop->info.mode |= PROP_ENCLOSE_RIGHTS;
  i++;
  if (XmToggleButtonGadgetGetState (prop->radPropFlaggs->btnRadio[i]))
    prop->info.mode |= PROP_ENCLOSE_OWN;
  i++;
  if (XmToggleButtonGadgetGetState (prop->radPropFlaggs->btnRadio[i]))
    prop->info.mode |= PROP_ENCLOSE_GRP;
  i++;
  if (XmToggleButtonGadgetGetState (prop->radPropFlaggs->btnRadio[i]))
    prop->info.mode |= DIR_SKIP_DIRS;
  i++;
  if (XmToggleButtonGadgetGetState (prop->radPropFlaggs->btnRadio[i]))
    prop->info.mode |= DIR_SKIP_LINKS;
  i++;
  if (XmToggleButtonGadgetGetState (prop->radPropFlaggs->btnRadio[i]))
    prop->info.mode |= DIR_SKIP_FILES;
  i++;
  if (XmToggleButtonGadgetGetState (prop->radPropFlaggs->btnRadio[i]))
    prop->info.mode |= DIR_RECURSIVE;
  i++;
  if (XmToggleButtonGadgetGetState (prop->radPropFlaggs->btnRadio[i]))
    prop->info.mode |= DIR_ASK;

  /* Permissions */
  prop->Rights = 0;
  prop->Skip   = 0;
  r = s = 1;
  for (i=0; i<18; i++)
    {
      int flag = XmToggleButtonGadgetGetState (prop->radRights->btnRadio[17-i]);
      if ((i/3) % 2)
	{
	  if (flag)
	    prop->Rights |= r;
	  r <<= 1;
	}
      else
	{
	  if (flag)
	    prop->Skip |= s;
	  s <<= 1;
	}
    }
  DEBUG3 ("propStart: Rights(%o), Skip(%o)\n", prop->Rights, prop->Skip);

  /** get file list to copy */
  files = XmTextGetString (prop->txtFiles->txtText);

  /** if empty file list then break */
  if (strlen (files) == 0)
    {
      free (files);
      return False;
    }

  prop->Locked = True;

  stop = XmStringCreateSimple ("Stop");
  XtVaSetValues    (prop->btnStart, XmNlabelString, stop, NULL);
  mwinSetPixmapToWidget (prop->btnStart, PIXM_tool_stop48, MWIN_LOADANDSET);
  XmStringFree     (stop);
  XtRemoveCallback (prop->btnStart, XmNactivateCallback, 
		    (XtCallbackProc) btnPropOkCB,
		    prop);
  XtAddCallback    (prop->btnStart, XmNactivateCallback, 
		    (XtCallbackProc) btnPropStopCB,
		    prop);
  XtSetSensitive   (prop->btnClose, False);

  /* get the rest of entries */
  prop->info.Filter = StrReplace (prop->info.Filter,
				  XmTextGetString (prop->txtFilter->txtText));
  prop->info.Enclose = StrReplace (prop->info.Enclose,
				   XmTextGetString (prop->txtEnclose->txtText));
  prop->info.Ignore = StrReplace (prop->info.Ignore,
				  XmTextGetString (prop->txtIgnore->txtText));
				  
  prop->Owner = StrReplace (prop->Owner,
			    XmTextGetString (prop->comOwner->txtCombo));
  prop->Group = StrReplace (prop->Group,
			    XmTextGetString (prop->comGroup->txtCombo));

  /* get the Id-Numbers of group and owner */
  if (prop->info.mode & PROP_ENCLOSE_OWN)
    prop->OwnId = usrIdByName (UserList, prop->Owner);
  else
    prop->OwnId = -1;

  if (prop->info.mode & PROP_ENCLOSE_GRP)
    prop->GrpId = grpIdByName (GrpList, prop->Group);
  else
    prop->GrpId = -1;

  prop->info.ClProc        = (int (*) (Dchain_t,Dchain_t,void*))propModify;
  prop->info.ViewProc      = NULL;
  prop->info.ViewFilesProc = (int (*) (Dchain_t,Dchain_t,void*))
    propViewFiles;
  prop->info.AskProc       = (int (*) (Dchain_t,Dchain_t,void*)) propAsk;
  prop->info.AskOverwriteProc = NULL;
  prop->info.ErrProc       = (int  (*) (Dchain_t, void*)) propError;
  prop->info.ClData        = prop;

  /* properity changing for the list of selected files */
  if (!Error)
    for (pos=0, p = files; True;)
      {
	pos = StrChrIndex (p, ' ');
	
	if (pos >= 0) p [pos] = 0;
	
	if (strlen (p) > 0)
	  {
	    DEBUG2 ("propStart: properity of (%s)\n", p);

	    srcList = dirAdd (NULL, p);
	    dummy   = dirAdd (NULL, p);

	    prop->info.mode |= dirRecursive (srcList,
					     dummy,
					     &prop->info);

	    dirDelete (srcList);
	    dirDelete (dummy);
	  }
	if (prop->info.mode & DIR_CANCEL)
	  break;

	if (pos < 0)
	  break;
	
	p += pos + 1;
      }

  if (files   != NULL) free (files);

  stop = XmStringCreateSimple ("Start");
  XtVaSetValues (prop->btnStart, XmNlabelString, stop, NULL);
  mwinSetPixmapToWidget (prop->btnStart, PIXM_tool_run48, MWIN_LOADANDSET);
  XmStringFree (stop);
  XtRemoveCallback (prop->btnStart, XmNactivateCallback, 
		    (XtCallbackProc) btnPropStopCB,
		    prop);
  XtAddCallback (prop->btnStart, XmNactivateCallback, 
		 (XtCallbackProc) btnPropOkCB,
		 prop);
  XtSetSensitive (prop->btnClose, True);

  ret = prop->info.mode & (DIR_CANCEL|DIR_ERROR_AVAIL);
  /* If aborted or an error was detected */
  if (ret)
    {
      MessageBox (prop->dlgProp,
		"End of Properities Modifikation",
		(prop->info.mode & DIR_CANCEL)
		? "Changing the permissions of the selected files aborted"
		: (prop->info.mode & DIR_ERROR_AVAIL)
		? "An error detected by the Changing of Permissions detected"
		: "Changing the permissions of selected files is complete",
		XmDIALOG_INFORMATION,
		OK_BUTTON,
		NULL, NULL);
    }

  prop->Locked = False;

  /* hide the copying frame by successfull copying */
  if (!ret)
    {
      propHide (prop);
    }

  return ret ? False : True;
}

