/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: xremove.c,v 1.3 1996/10/28 05:44:26 khamis Exp khamis $
 * $Source: /home/xkhfm/xkhlib/xkhsrc/RCS/xremove.c,v $
 */
#define IS_EXTERN
#define EXTERN		extern

#define WINMENU_NO_CLOSE

#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>
#include <Xm/DrawnB.h>
#include "Xinc.h"

#include "defines.h"

#ifdef HAVE_THREAD
#include <thread.h>
#endif

#include "Umem.h"
#include "Uxutil.h"
#include "Umessage.h"
#include "Umenu.h"
#include "Urcnfvoid.h"
#include "Ureadarg.h"
#include "Ufileutil.h"
#include "Ustrutil.h"
#include "Ucnfutil.h"
#include "about.h"
#include "quit.h"
#include "help.h"
#include "remove.h"
#include "mainwin.h"
#include "window.h"

void remFlaggsCB (Widget w, Remove_t rem)
{
}

int remViewState (char * file, Remove_t rem)
{
  XEvent event;
  XmString File;

  File = XmStringCreateSimple (file);

  XtVaSetValues (rem->lblState,
		 XmNlabelString, File,
		 NULL);
  XmStringFree (File);

  XFlush (display);

#ifndef HAVE_THREAD
  XmUpdateDisplay (rem->dlgRem);

  while (XCheckMaskEvent (display, ALL_MASKS, &event))
    {
      /* Do Nothing */
      XtDispatchEvent (&event);
    }

  XFlush (display);
  XmUpdateDisplay (rem->dlgRem);
#endif

  if (rem->Stop)
    return REM_CANCEL;

  return False;
}

int remAsk (char * file, Remove_t rem)
{
  char Mess[MAXPATHLEN];
  int ret;

  sprintf (Mess, "Remove file\n[%s]\nare you shure ?", file);

  ret = MessageBox (rem->dlgRem,
		    "RemoveAsk",
		    Mess,
		    XmDIALOG_QUESTION,
		    OK_BUTTON | CANCEL_BUTTON | HELP_BUTTON |
		    CLOSE_ON_HELP | DONOT_SETTITLE,
		    NULL, NULL);

  if (ret == 0) ret = REM_YES;
  if (ret == 1) ret = REM_NO;
  if (ret == 2) ret = REM_CANCEL;

  return ret;
}

int remError (char * file, Remove_t rem)
{
  char Mess [MAXPATHLEN];
  int ret;
  sprintf (Mess, "Error by Removing\n[%s]", file);
  ret = MessageBox (rem->dlgRem,
		    "RemoveError",
		    Mess,
		    XmDIALOG_ERROR,
		    OK_BUTTON|CANCEL_BUTTON | DONOT_SETTITLE,
		    NULL, NULL);
  if (ret == 1)
    ret = REM_CANCEL;
  return ret;
}

int remStart (Remove_t rem)
{
  char file [MAXPATHLEN];
  char * files, * p, * RemFilter, * DonotRemFilter;
  int pos, mode = False, ret;

  rem->Started = True;
  
  if (XmToggleButtonGadgetGetState (rem->radRemFlaggs->btnRadio[0]))
    mode |= REM_ASK;

  if (XmToggleButtonGadgetGetState (rem->radRemFlaggs->btnRadio[1]))
    mode |= REM_EMPTY_DIR;

  if (XmToggleButtonGadgetGetState (rem->radRemFlaggs->btnRadio[2]))
    mode |= REM_RECURSIVE;

  files          = XmTextGetString (rem->txtFiles->txtText);
  RemFilter      = XmTextGetString (rem->txtRemove->txtText);
  DonotRemFilter = XmTextGetString (rem->txtDonotRemove->txtText);

  /* remove the list of files */
  if (files != NULL && strlen(files) > 0)
    for (pos=0, p = files; True;)
      {
	pos = StrChrIndex (p, ' ');
	
	if (pos >= 0) p [pos] = 0;
	
	if (strlen (p) > 0)
	  mode |=
	    RecursiveRemove (p,
			     RemFilter,
			     DonotRemFilter,
			     (unsigned long (*) (char*, void*)) remViewState,
			     (unsigned long (*) (char*, void*)) remAsk,
			     (unsigned long (*) (char*, void*)) remError,
			     mode,
			     rem);
	
	if (mode & REM_CANCEL) break;

	if (pos < 0) break;
	
	p += pos + 1;
      }

  if (files != NULL) XtFree (files);
  XtFree (RemFilter);
  XtFree (DonotRemFilter);  

  ret = mode & (REM_ERROR_AVAIL | REM_CANCEL);

  /* there was an error by remove process */
  if (ret)
    {
      MessageBox (rem->dlgRem,
		  "Remove End",
		  (mode & REM_CANCEL)
		  ? "Removing the selected files is aborted"
		  : (mode & REM_ERROR_AVAIL)
		  ? "Error detected by removing the file list"
		  : "Removing the selected files is complete",
		  XmDIALOG_INFORMATION,
		  OK_BUTTON,
		  NULL, NULL);
    }

  rem->Started = False;

#ifndef HAVE_THREAD
  /* after successfull removing, close the Remove Dialog */
  if (!ret)
    remHide (rem);
#endif

  return ret ? False : True;
}

void btnRemStopCB (Widget w, Remove_t rem)
{
  int ret;
  ret = MessageBox (rem->dlgRem,
		    "RemoveBreak",
		    "RemoveBreak",
		    XmDIALOG_ERROR,
		    OK_BUTTON | 
		    CANCEL_BUTTON |
		    DONOT_SETTITLE |
		    DONOT_SETMESSAGE,
		    NULL, NULL);
  if (ret == 1)
  rem->Stop = True;
}

void btnRemOkCB (Widget w, Remove_t rem)
{
  XmString stop;
  rem->Started = True;
  rem->Stop    = False;

  stop = XmStringCreateSimple ("Stop");
  XtVaSetValues (rem->btnOk, XmNlabelString, stop, NULL);
  mwinSetPixmapToWidget (rem->btnOk, PIXM_tool_stop48, MWIN_LOADANDSET);
  XmStringFree (stop);
  XtRemoveCallback (rem->btnOk, XmNactivateCallback, 
		    (XtCallbackProc) btnRemOkCB,
		    rem);
  XtAddCallback (rem->btnOk, XmNactivateCallback, 
		 (XtCallbackProc) btnRemStopCB,
		 rem);

  XtSetSensitive (rem->btnClose, False);

#ifdef HAVE_THREAD
  {
    thread_t newThread;
    int ret;
    DEBUG1 ("btnRemOkCB: create a new thread");
    ret = thr_create (NULL, 0, (void* (*)(void*)) remStart, (void*) rem,
		      THR_BOUND | 0L, &newThread);
    if (ret != 0)
      {
	DEBUG1 ("btnRemOkCB: "
		  "Can not create a new Thread, running in normal mode");
	remStart (rem);
      }
    else
      {
	DEBUG1 ("btnRemOkCB: Thread created");
      }
    DEBUG1 ("btnRemOkCB: after the new thread");
  }
#else
  remStart (rem);
#endif

  stop = XmStringCreateSimple ("Start");
  XtVaSetValues (rem->btnOk, XmNlabelString, stop, NULL);
  mwinSetPixmapToWidget (rem->btnOk, PIXM_tool_run48, MWIN_LOADANDSET);
  XmStringFree (stop);

  XtRemoveCallback (rem->btnOk, XmNactivateCallback, 
		    (XtCallbackProc) btnRemStopCB,
		    rem);
  XtAddCallback (rem->btnOk, XmNactivateCallback, 
		 (XtCallbackProc) btnRemOkCB,
		 rem);

  XtSetSensitive (rem->btnClose, True);

  rem->Stop = False;
  rem->Started = False;
}

void btnRemCloseCB (Widget w, Remove_t rem)
{
  remHide (rem);
}

void remDestCB (Widget w, Remove_t rem)
{
  rem->dlgRem = NULL;
}

menuitem_t itemRemFlags [] =
{
  { (void (*) (Widget, void *)) remFlaggsCB, "Ask for every file",
      True, NULL },
  { (void (*) (Widget, void *)) remFlaggsCB, "Remove empty Directories",
      True, NULL },
  { (void (*) (Widget, void *)) remFlaggsCB, "Recursive Remove (danger)",
      True, NULL },
  { NULL, NULL}
};
menu_t mnuRemFlaggs [] =
{ 
  { "Remove Flaggs", itemRemFlags, True, NULL },
  { NULL, NULL }
};


Remove_t remMake (void)
{
  Remove_t rem;
  rem = gcalloc (sizeof (remove_t), __LINE__, __FILE__);
  return rem;
}

char * remName (Remove_t rem)
{
  static char tmp[MAXPATHLEN];
  static char fmt[] = "Remove [%s]";
  sprintf (tmp, fmt,
           dirCutPath (rem->Files, MNU_STRLEN - strlen (fmt) - 1, False));
  return tmp;
}

Widget remShell (Remove_t rem)
{
  return rem->dlgRem;
}

int remHide (Remove_t rem)
{
  
  if (rem->dlgRem != NULL)
    {
      if (rem->Started)
	{
	  XMapRaised (XtDisplay (rem->dlgRem), XtWindow (rem->dlgRem));
	  XBell (display, 0);
	  return False;
	}
      txtDest (rem->txtFiles);
      txtDest (rem->txtDonotRemove);
      txtDest (rem->txtRemove);
      radDest (rem->radRemFlaggs);
      XtDestroyWidget (rem->dlgRem);
      rem->dlgRem = NULL;
      winDelWinMenu (winGetListFromObj (rem));
    }

  return True;
}

int remDest (Remove_t rem)
{
  if (rem == NULL)
    return False;

  if (! remHide (rem))
    return False;

  StrReplace (rem->Files, NULL);
  MFree (rem, sizeof (remove_t));
  return True;
}

static menuitem_t itemRem [] =
{
  { (void(*)(Widget,void*)) btnRemOkCB, "Start", True, NULL },
  { NULL, MENU_SEPARATOR, False, NULL },
  { (void(*)(Widget,void*)) btnRemCloseCB, "Close", True, NULL },
  { NULL, NULL }
};

static menu_t menuRem [] =
{
  { "Remove", itemRem, True, NULL },
  { "Window", itemWinMenu, True, NULL },
  { NULL, NULL, False, NULL }
};

int remView (Widget parent, Remove_t rem)
{
  int ret;
  Widget sep1, sep2, sep3, sep4;

  /* Rong call or remove process is running */
  if (rem == NULL || parent == NULL || rem->Started)
    {
      XBell (display, 0);
      return False;
    }
  
  if (rem->dlgRem != NULL)
    {
      /* copy files to remove into the filelist */
      if (rem->Files != NULL)
	XmTextSetString   (rem->txtFiles->txtText, rem->Files);

      XMapRaised (XtDisplay (rem->dlgRem), XtWindow (rem->dlgRem));
      return True;
    }
  rem->Parent = parent;

  DEBUG1 ("remView:");

  ret = winCreate ( /*parent,*/
		   "Remove",
		   &rem->dlgRem,
		   &rem->winRem,
		   &rem->fomMain,
		   6,
		   rem,
		   (void (*)(Widget, void*))btnRemCloseCB,
		   False);
  if (ret == False)
    return False;
  mnuMake (rem->winRem, menuRem, rem);

  /****** Files to delete ***/
  rem->txtFiles = txtCreate (rem->fomMain,
			     "Files",
			     0,
			     NULL,
			     REM_SOURCE,
			     False);
  XtVaSetValues (rem->txtFiles->fomText,
		 XmNtopAttachment,    XmATTACH_FORM,
		 XmNleftAttachment,   XmATTACH_FORM,
		 XmNrightAttachment,  XmATTACH_FORM,
		 XmNtopOffset,     SPACE,
		 XmNrightOffset,     SPACE,
		 XmNleftOffset,     SPACE,
		 XmNbottomOffset,     SPACE,
		 NULL);
  /* editing the file list to delete is not possible, so man mast select the */
  /* files to delete */
  XmTextSetEditable (rem->txtFiles->txtText, False);
  /* copy files to remove into the filelist */
  if (rem->Files != NULL)
    XmTextSetString   (rem->txtFiles->txtText, rem->Files);
  XtAddCallback (rem->txtFiles->fomText, XmNdestroyCallback, 
		 (XtCallbackProc) remDestCB,
		 rem);
  XtManageChild (rem->txtFiles->fomText);

  sep1 =
    XtVaCreateManagedWidget ("Separator",
			     xmSeparatorGadgetClass,
			     rem->fomMain,
			     
			     XmNtopAttachment,    XmATTACH_WIDGET,
			     XmNtopWidget,        rem->txtFiles->fomText,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNrightAttachment,  XmATTACH_FORM,
			     XmNtopOffset,     SPACE,
			     XmNrightOffset,     SPACE,
			     XmNleftOffset,     SPACE,
			     XmNbottomOffset,     SPACE,
			     NULL);
  XtManageChild (sep1);

  rem->txtRemove = txtCreate (rem->fomMain,
			      "Remove Filter",
			      0, NULL, REM_SOURCE,
			      False);
  XtVaSetValues (rem->txtRemove->fomText,
		 XmNtopAttachment,   XmATTACH_WIDGET,
		 XmNtopWidget,	     sep1,
		 XmNleftAttachment,  XmATTACH_FORM,
		 XmNrightAttachment, XmATTACH_FORM,

		 XmNtopOffset,       SPACE,
		 XmNrightOffset,     SPACE,
		 XmNleftOffset,      SPACE,
		 XmNbottomOffset,    SPACE,
		 NULL);
  XmTextSetString (rem->txtRemove->txtText, "*");
  XtManageChild   (rem->txtRemove->fomText);

  rem->txtDonotRemove = txtCreate (rem->fomMain,
			      "Don't Remove Filter",
			      0, NULL, REM_SOURCE,
			      False);
  XtVaSetValues (rem->txtDonotRemove->fomText,
		 XmNtopAttachment,    XmATTACH_WIDGET,
		 XmNtopWidget,	      rem->txtRemove->fomText,
		 XmNleftAttachment,   XmATTACH_FORM,
		 XmNrightAttachment,  XmATTACH_FORM,
		 XmNtopOffset,     SPACE,
		 XmNrightOffset,     SPACE,
		 XmNleftOffset,     SPACE,
		 XmNbottomOffset,     SPACE,
		 NULL);
  XtManageChild (rem->txtDonotRemove->fomText);

  sep2 =
    XtVaCreateManagedWidget ("Separator",
			     xmSeparatorGadgetClass,
			     rem->fomMain,
			     
			     XmNtopAttachment,    XmATTACH_WIDGET,
			     XmNtopWidget,        rem->txtDonotRemove->fomText,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNrightAttachment,  XmATTACH_FORM,
			     XmNtopOffset,     SPACE,
			     XmNrightOffset,     SPACE,
			     XmNleftOffset,     SPACE,
			     XmNbottomOffset,     SPACE,
			     NULL);
  XtManageChild (sep2);

  rem->btnOk =
    XtVaCreateManagedWidget ("Start",
			     xmPushButtonGadgetClass,
			     rem->fomMain,
			     XmNshowAsDefault,    2,
			     XmNleftAttachment,   XmATTACH_POSITION,
			     XmNleftPosition,     1,
			     XmNrightAttachment,  XmATTACH_POSITION,
			     XmNrightPosition,    2,
			     XmNbottomAttachment, XmATTACH_FORM,
			     XmNtopOffset,      SPACE,
			     XmNleftOffset,     SPACE,
			     XmNrightOffset,    SPACE,
			     XmNbottomOffset,   SPACE,			     
			     NULL);
  XtAddCallback (rem->btnOk, XmNactivateCallback, 
		 (XtCallbackProc) btnRemOkCB,
		 rem);
  btnMesgArea   (rem->btnOk, REM_OK);
  mwinSetPixmapToWidget (rem->btnOk, PIXM_tool_run48, MWIN_LOADANDSET);
  XtManageChild (rem->btnOk);
  
  rem->btnClose =
    XtVaCreateManagedWidget ("Close",
			     xmPushButtonGadgetClass,
			     rem->fomMain,
			     XmNshowAsDefault,    2,
			     XmNrightAttachment,  XmATTACH_POSITION,
			     XmNrightPosition,    5,
			     XmNleftAttachment,   XmATTACH_POSITION,
			     XmNleftPosition,     4,
			     XmNbottomAttachment, XmATTACH_FORM,
			     XmNtopOffset,      SPACE,
			     XmNleftOffset,     SPACE,
			     XmNrightOffset,    SPACE,
			     XmNbottomOffset,   SPACE,			     
			     NULL);
  XtAddCallback (rem->btnClose, XmNactivateCallback, 
		 (XtCallbackProc) btnRemCloseCB,
		 rem);
  btnMesgArea   (rem->btnClose, REM_CLOSE);
  mwinSetPixmapToWidget (rem->btnClose, PIXM_tool_abort48, MWIN_LOADANDSET);
  mwinSetPixmapToWidget (rem->btnClose, PIXM_tool_abortd48, MWIN_DISABLED);
  XtManageChild (rem->btnClose);
  
  sep3 =
    XtVaCreateManagedWidget ("Separator",
			     xmSeparatorGadgetClass,
			     rem->fomMain,
			     XmNbottomAttachment, XmATTACH_WIDGET,
			     XmNbottomWidget,     rem->btnOk,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNrightAttachment,  XmATTACH_FORM,
			     XmNtopOffset,     SPACE,
			     XmNbottomOffset,     SPACE,
			     NULL);
  XtManageChild (sep3);

  rem->lblState =
    XtVaCreateManagedWidget ("Remove State ",
			     xmLabelGadgetClass,
			     rem->fomMain,			     
			     XmNrightAttachment,  XmATTACH_FORM,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNbottomAttachment, XmATTACH_WIDGET,
			     XmNbottomWidget,     sep3,
			     XmNtopOffset,        SPACE,
			     XmNleftOffset,       SPACE,
			     XmNrightOffset,      SPACE,
			     XmNbottomOffset,     SPACE,
			     NULL);
  XtManageChild (rem->lblState);

  sep4 =
    XtVaCreateManagedWidget ("Separator",
			     xmSeparatorGadgetClass,
			     rem->fomMain,			     
			     XmNbottomAttachment, XmATTACH_WIDGET,
			     XmNbottomWidget,     rem->lblState,
			     XmNleftAttachment,   XmATTACH_FORM,
			     XmNrightAttachment,  XmATTACH_FORM,
			     XmNtopOffset,        SPACE,
			     XmNrightOffset,      SPACE,
			     XmNleftOffset,       SPACE,
			     XmNbottomOffset,     SPACE,
			     NULL);
  XtManageChild (sep4);

  rem->radRemFlaggs = radCreate (rem->fomMain,
				 mnuRemFlaggs,
				 REM_FLAGGS,
				 rem,
				 TOGGLEE_BOX);
  XtVaSetValues (rem->radRemFlaggs->radRadio,
		 XmNnumColumns,       1,
		 XmNtopAttachment,    XmATTACH_WIDGET,
		 XmNtopWidget,        sep2,
		 XmNrightAttachment,  XmATTACH_FORM,
		 XmNleftAttachment,   XmATTACH_FORM,
		 XmNbottomAttachment, XmATTACH_WIDGET,
		 XmNbottomWidget,     sep4,
		 XmNtopOffset,        SPACE,
		 XmNrightOffset,      SPACE,
		 XmNleftOffset,       SPACE,
		 XmNbottomOffset,     SPACE,
		 NULL);

  /* Ask for every file */
  XmToggleButtonGadgetSetState (rem->radRemFlaggs->btnRadio[0], False, False);
  /* delete empty directories */
  XmToggleButtonGadgetSetState (rem->radRemFlaggs->btnRadio[1], True, False);
  /* delete recursive */
  XmToggleButtonGadgetSetState (rem->radRemFlaggs->btnRadio[2], False, False);
  XtManageChild (rem->radRemFlaggs->radRadio);

  XtManageChild     (rem->fomMain);
  XtManageChild     (rem->winRem);

  /*
  XtManageChild     (rem->dlgRem);
  XtPopup (XtParent (rem->dlgRem), XtGrabNone);
  XMapRaised (XtDisplay (rem->dlgRem), XtWindow (rem->dlgRem));
  */
  MXtRealizeWidget (rem->dlgRem);

  DEBUG1 ("remView: Ende");

  return True;
}
