/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: xcommand.c,v 1.3 1996/10/28 05:44:01 khamis Exp khamis $
 * $Source: /home/xkhfm/xkhlib/xkhsrc/RCS/xcommand.c,v $
 */
#define IS_EXTERN
#define EXTERN		extern

#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>
#include <Xm/DrawnB.h>
#include "Xinc.h"
#include <Xm/Command.h>
#include "defines.h"

#ifdef HAVE_THREAD
#include <thread.h>
#endif

#include "Umem.h"
#include "Uxutil.h"
#include "Umessage.h"
#include "Umenu.h"
#include "Urcnfvoid.h"
#include "Ureadarg.h"
#include "Ufileutil.h"
#include "Ustrutil.h"
#include "Ucnfutil.h"
#include "about.h"
#include "quit.h"
#include "help.h"
#include "mainwin.h"
#include "window.h"
#include "xmisc.h"

extern int errno;
void slctStartCB (Widget w, Mainwin_t mwin, XmSelectionBoxCallbackStruct * cbs)
{
  char * pattern;
  int Found = False, i;

  DEBUG1 ("slctStart:");

  if (! XmStringGetLtoR (cbs->value, XmFONTLIST_DEFAULT_TAG, &pattern))
    return;

  /** if empty pattern then break */
  if (pattern == NULL)
    return;

  if (*pattern)
    {
      BaisyCursor (mwin->shlMainwin);
      
      for (i=0; i<mwin->dirEntryCount; i++)
	{
	  if (IsRegular (pattern, dirName (mwin->dirWidgets[i]->dirListEntry)))
	    {
	      dirSelect (mwin->dirWidgets[i]->dirListEntry, True);
	      Found = True;
	    }
	}
      if (Found)
	{
	  mwinRedisp     (mwin);
	  mwinDispStatus (mwin);
	}
      
      NormalCursor (mwin->shlMainwin);
    }
  XFree (pattern);

  XtDestroyWidget (w);
}

void slctCloseCB (Widget w, Mainwin_t slct)
{
  XtDestroyWidget (w);
}

int slctView (Mainwin_t slct)
{
  int ret;
  Widget w;

  if (slct == NULL)
    {
      return False;
    }
  
  DEBUG1 ("slctView:");

  w = XmCreatePromptDialog (slct->shlMainwin, "SelectDialog", NULL, 0);
  if (w == NULL)
    return False;

  XtAddCallback (w, XmNokCallback,     (XtCallbackProc)slctStartCB,
		 slct);
  XtAddCallback (w, XmNcancelCallback, (XtCallbackProc)slctCloseCB,
		 slct);
  XtSetSensitive (XmSelectionBoxGetChild (w, XmDIALOG_HELP_BUTTON),
		  False);
  XtManageChild (w);
  XtPopup (XtParent (w), XtGrabNone);

  XmTextSetString (XmSelectionBoxGetChild (w, XmDIALOG_TEXT),
		   slct->DirFilter);

  DEBUG1 ("slctView: Ende");

  return True;
}
