/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: xtoolbar.c,v 1.1 1997/01/07 08:34:48 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/xkhlib/xkhsrc/RCS/xtoolbar.c,v $
 */
#define IS_EXTERN
#define EXTERN		extern

#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>

#include "Xinc.h"
#include <Xm/DrawingA.h>
#include <Xm/DrawnB.h>

#include "defines.h"

#ifdef HAVE_XPM
#include <X11/xpm.h>
#endif

#ifdef HAVE_THREAD
#include <thread.h>
#endif

#include "Umem.h"
#include "Uxutil.h"
#include "Umessage.h"
#include "Umenu.h"
#include "Ufileutil.h"
#include "Ustrutil.h"
#include "Ucnfutil.h"
#include "xmisc.h"

static char * toolbarIconPath = NULL;
static int toolbarViewStyle = TBAR_VIEW_VERT;

/* Toolbar Command static variables */
static Widget shlTbarV = NULL;
static Widget winTbarV = NULL;
static Widget rowcolTbarV = NULL;
static Widget fomMain = NULL;
static unsigned int xTbarV = -1, yTbarV = -1;

int tbarDisp (Dchain_t tbarDch, Toolbar_t tbar);
TbarList_t tbarListMake (char * Section);
int tbarListDest     (TbarList_t lst);
int tbarListComp     (TbarList_t liste, char * pattern);
int tbarListCpy      (TbarList_t lst1, TbarList_t lst2);
int tbarListData     (Dchain_t lst, char *);
int tbarListSaveExec (Dchain_t lst, char * tbarExec);
int tbarListSaveDescr(Dchain_t lst, char * Descr);
int tbarListSaveMode (Dchain_t lst, char * mode);
int tbarListSaveIcon (Dchain_t lst, char * icon);
int tbarListChng     (Dchain_t lst, char * newName);
int tbarSetPixmap (Dchain_t dch);

#define TBAR_SECTION "Toolbar"

int tbarCheckin (Dchain_t tbarDch, Toolbar_t tbar)
{
  TbarList_t tbarList;
  char * tmp;

  if (tbarDch == NULL || tbar == NULL)
    return False;
  tbarList = UdchClient (tbarDch);

  return True;
}

int tbarDest (Toolbar_t tbar)
{
  if (tbar == NULL)
    return False;

  tbarHide (tbar);
  MFree   (tbar, sizeof (toolbar_t));

  toolbarWindow = NULL;

  return True;
}

int tbarDisp (Dchain_t tbarDch, Toolbar_t tbar)
{
  TbarList_t tbarList = NULL;

  if (tbarDch == NULL || tbar == NULL)
    {
      return False;
    }
  tbarList = UdchClient (tbarDch);
  return True;
}

int tbarHide (Toolbar_t tbar)
{
  if (tbar->shlTbar != NULL)
    {
      XtDestroyWidget (tbar->shlTbar);
      tbar->shlTbar = NULL;
      maplDest (tbar->aplThema);
    }

  return True;
}

TbarList_t tbarListMake (char * Exec)
{
  TbarList_t l = gcalloc (sizeof (tbarList_t), __LINE__, __FILE__);

  l->Exec    = StrReplace (l->Exec, Exec);
  l->Label   = StrReplace (l->Label, "");
  l->Descr   = StrReplace (l->Descr, "");
  l->Icon    = StrReplace (l->Icon, "");
  l->Mode    = CMD_XTERM;

  return l;
}

int tbarListDest (TbarList_t lst)
{
  /* delete created pixmaps */
  if (lst->pxmIcon > 0)
    {
      XFreePixmap (display, lst->pxmIcon);
    }
  if (lst->btnIcon != NULL)
    {
      XtDestroyWidget (lst->btnIcon);
    }

  StrReplace (lst->Exec,  NULL);
  StrReplace (lst->Label, NULL);
  StrReplace (lst->Icon,  NULL);
  StrReplace (lst->Descr, NULL);
  MFree (lst, sizeof (tbarList_t));
  return True;
}

int tbarListComp (TbarList_t liste, char * Exec)
{
  if (liste == NULL)
    return 0;
  return strcmp (liste->Exec, Exec);
}

Dchain_t tbarListAdd   (Dchain_t top, char * Exec)
{
  if (UdchItemExists (top, Exec, (int (*) (void*, void*)) tbarListComp))
    {
      ERROR2 ("tbarListAdd: Program [%s] already available\n",
	      Exec);
      return NULL;
    }
  return UdchAdd (top, Exec,
		  (void * (*) (void *)) tbarListMake,
		  (int    (*) (void *, void *)) tbarListComp);
}

int tbarListCpy (TbarList_t lst1, TbarList_t lst2)
{
  lst2->Exec    = StrReplace (lst2->Exec,  lst1->Exec);
  lst2->Label   = StrReplace (lst2->Label, lst1->Label);
  lst2->Descr   = StrReplace (lst2->Descr, lst1->Descr);
  lst2->Icon    = StrReplace (lst2->Icon,  lst1->Descr);
  lst2->Mode    = lst1->Mode;
  return True;
}

char * tbarListIcon (Dchain_t lst)
{
  return ((TbarList_t) UdchClient (lst))->Icon;
}

char * tbarListLabel (Dchain_t lst)
{
  return ((TbarList_t) UdchClient (lst))->Label;
}

char * tbarListExec (Dchain_t lst)
{
  return ((TbarList_t) UdchClient (lst))->Exec;
}

char * tbarListMode (Dchain_t lst)
{
  if (((TbarList_t) UdchClient (lst))->Mode & CMD_XTERM)
    return "xterm";
  else
    return "bg";
}

int tbarExecMode (Dchain_t lst)
{
  return ((TbarList_t) UdchClient (lst))->Mode;
}

char * tbarListDescr (Dchain_t lst)
{
  return ((TbarList_t) UdchClient (lst))->Descr;
}

int tbarListSaveIcon (Dchain_t lst, char * tbarIcon)
{
  TbarList_t tbarList;
  if (tbarIcon == NULL)
    return False;
  tbarList = (TbarList_t) UdchClient (lst);

  /* value not changed */
  if (strcmp (tbarList->Icon, tbarIcon) == 0)
    return True;

  tbarList->Icon = StrReplace (tbarList->Icon, tbarIcon);

#if 1
  /* reset the icon pixmap */
  tbarSetPixmap (lst);
#endif

  return True;
}

int tbarListSaveLabel (Dchain_t lst, char * tbarLabel)
{
  TbarList_t tbarList;
  if (tbarLabel == NULL)
    return False;
  tbarList = (TbarList_t) UdchClient (lst);
  tbarList->Label = StrReplace (tbarList->Label, tbarLabel);
  return True;
}

int tbarListSaveDescr (Dchain_t lst, char * Descr)
{
  TbarList_t tbarList;
  tbarList = (TbarList_t) UdchClient (lst);
  tbarList->Descr = StrReplace (tbarList->Descr,
				Descr != NULL
				? Descr
				: "");
  return True;
}
int tbarListSaveMode (Dchain_t lst, char * mode)
{
  TbarList_t tbarList;
  tbarList = (TbarList_t) UdchClient (lst);
  tbarList->Mode = (strcmp (mode, "bg") == 0 || strcmp (mode, "Bg") == 0
		    ? CMD_BACKGROUND
		    : CMD_XTERM);
  return True;
}

int tbarListChng (Dchain_t lst, char * newName)
{
  TbarList_t tbarList;

  if (newName == NULL || *newName == 0)
    return False;
  tbarList = ((TbarList_t) UdchClient (lst));
  tbarList->Exec = StrReplace (tbarList->Exec, newName);
  return True;
}

int tbarSave (Dchain_t top, Conf_t cnf)
{
  int i;
  Dchain_t dch;
  char* argv[6];
  if (toolbarList == NULL)
    return False;

  /* save options */
  argv[0] = "IconPath";
  argv[1] = toolbarIconPath;
  confWrite (cnf, '=', OPTION_SECTION, 2, argv);
  argv[0] = "ToolbarViewStyle";
  argv[1] = toolbarViewStyle == TBAR_VIEW_VERT ? "vertical" : "horizontal";
  confWrite (cnf, '=', OPTION_SECTION, 2, argv);

  /* save programs */
  confDelSect (cnf, TBAR_SECTION);
  for (dch = UdchNext (toolbarList), i=0;
       dch != NULL;
       dch = UdchNext (dch), i++)
    {
      char tmp[32];
      sprintf (tmp, "%i", i);
      argv[0] = tmp;
      argv[1] = tbarListExec (dch);
      argv[2] = tbarListLabel(dch);
      argv[3] = tbarListIcon (dch);
      argv[4] = tbarListMode (dch);
      argv[5] = tbarListDescr(dch);
      confAppend (cnf, '=', TBAR_SECTION, 6, argv);
    }

  /* save window coordinates */
  if (shlTbarV != NULL)
    {
      char line[64], *argv[1];
      sprintf (line, "toolbar:%i:%i:%i",
	       -1,
	       wdgX      (shlTbarV),
	       wdgY      (shlTbarV));
      argv[0] = line;
      confWrite (cnf, 0, WINDOW_SECTION, 1, argv);
    }

  return True;
}

int tbarRead (Dchain_t top, Conf_t cnf)
{
  Dchain_t newTbar;
  char * p, line [CNF_MAXPARAMLEN];
  int i, pos;

  if (top == NULL || cnf == NULL)
    return False;

  /* read options */
  toolbarIconPath =
    StrReplace (toolbarIconPath,
		"/usr/include/X11/pixmaps:/usr/include/X11/bitmaps");
  p = confRead (cnf, '=', OPTION_SECTION, "IconPath");
  if (p != NULL)
    {
      if (Ureadarg (p, line, 1, '='))
	{
	  toolbarIconPath = StrReplace (toolbarIconPath, line);
	}
    }
  toolbarViewStyle = TBAR_VIEW_VERT;
  p = confRead (cnf, '=', OPTION_SECTION, "ToolbarViewStyle");
  if (p != NULL)
    {
      if (Ureadarg (p, line, 1, '='))
	{
	  if (strcmp (line, "horizontal") == 0)
	    toolbarViewStyle = TBAR_VIEW_HORIZ;
	}
    }

  /* section position */
  pos = confSectPos (cnf, TBAR_SECTION);
  if (pos >= 0)
    {
      /* Skip section name */
      confReLine (cnf, True);
      for (p = confReLine (cnf, True), i = 0;
	   p != NULL && p[0] != '[';
	   p = confReLine (cnf, True), i++)
	{
	  if (! Ureadarg (p, line, 1, '='))
	    continue;
	  
	  newTbar = tbarListAdd (top, line);
	  if (newTbar == NULL)
	    continue;
	  
	  if (! Ureadarg (p, line, 2, '='))
	    continue;
	  tbarListSaveLabel (newTbar, line);
	  
	  if (! Ureadarg (p, line, 3, '='))
	    continue;
	  tbarListSaveIcon (newTbar, line);
	  
	  if (! Ureadarg (p, line, 4, '='))
	    continue;
	  tbarListSaveMode (newTbar, line);
	  
	  if (! Ureadarg (p, line, 5, '='))
	    continue;
	  tbarListSaveDescr (newTbar, line);
	}
    }

  /** add default list to the toolbar list */
  if (UdchNext (top) == NULL)
    {
      static struct
	{
	  char * e;
	  char * l;
	  char * i;
	  char * m;
	  char * d;
      } defList[] =
	{
	  {"ghostview", "Ghostview",
	   "ghostview.xpm",
	   "bg", "Postscript Viewer"},
	  {"netscape",  "Netscape",
	   "netscape.xpm",
	   "bg", "Internet"},
	  {"xv",  "Image Viewer",
	   "xv.xpm",
	   "bg", "XV Image Viewer and Editor"},
	  {"emacs",     "Emacs",
	   "emacs.xpm",
	   "bg", "Multifunctional Editor"},
	  {"xkill",     "Kill",
	   "bomb.xpm",
	   "bg", "Kill X Application"},
	  {"xterm",     "XTerminal",
	   "xterm.xpm",
	   "bg", "Xterminal"},
	  {NULL,NULL,NULL,NULL,NULL}
	};
      for (i=0; defList[i].e != NULL; i++)
	{
	  newTbar = tbarListAdd (top, defList[i].e);
	  if (newTbar == NULL)
	    continue;
	  tbarListSaveLabel (newTbar, defList[i].l);
	  tbarListSaveIcon  (newTbar, defList[i].i);
	  tbarListSaveMode  (newTbar, defList[i].m);
	  tbarListSaveDescr (newTbar, defList[i].d);
	}
    }

  p = confRead (cnf, ':', WINDOW_SECTION, "toolbar");
  if (p != NULL)
    {
      if (Ureadarg (p, line, 2, ':'))
	xTbarV = atoi (line);
      if (Ureadarg (p, line, 3, ':'))
	yTbarV = atoi (line);

      tbarViewToolbar();
    }

  return True;
}

Toolbar_t tbarMake (void)
{
  Toolbar_t tbar;

  if (toolbarWindow != NULL)
    return toolbarWindow;

  tbar =
    toolbarWindow =
      gcalloc (sizeof (toolbar_t), __LINE__, __FILE__);

  if (tbar == NULL)
    return NULL;

  if (toolbarList == NULL)
    {
      tbar->tbarList =
	toolbarList =
	tbarListAdd (NULL, "TOP");
    }
  else
    tbar->tbarList = toolbarList;

  return tbar;
}

void btnTbarOkCB (Widget w, Toolbar_t tbar)
{
  char *path = XmTextGetString (tbar->txtPath->txtText);

  if (path != NULL && *path)
    {
      toolbarIconPath = StrReplace (toolbarIconPath, path);
    }
  if (path != NULL)
    XtFree (path);

  if (XmToggleButtonGadgetGetState (tbar->radTbarFlaggs->btnRadio[0]))
    {
      toolbarViewStyle = TBAR_VIEW_VERT;
    }
  else
    {
      toolbarViewStyle = TBAR_VIEW_HORIZ;
    }

  tbarHide (tbar);
}

void btnTbarCancelCB (Widget w, Toolbar_t tbar)
{
  tbarHide (tbar);
}

void tbarIconOkCB (Widget w,
		   Toolbar_t tbar,
		   XmFileSelectionBoxCallbackStruct * cbs)
{
  char * line;
  char * pStr;
  char filename [MAXPATHLEN];

  if (! XmStringGetLtoR (cbs->value, XmSTRING_DEFAULT_CHARSET, &pStr))
    {
      ERROR1 ("rong filename");
      return;
    }

  strcpy (filename, pStr);
  XtFree (pStr);

  if (!*filename)
    {
      ErrorBox (tbar->shlTbar, "Icon", "no file selected !");
      return;
    }

  if (! UFileCanRead (filename) ||
      ! UFileIsFile  (filename))
    {
      ErrorBox (tbar->shlTbar,
		filename,
		"Selected file not availiable \n"
		"oder permission denied !");
      return;
    }

  XmTextSetString (tbar->aplThema->lbxApl[2]->txtLBox,
		   filename);

  XtDestroyWidget (w);
}

void btnTbarIconCB (Widget*w, Toolbar_t tbar)
{
  char filter [MAXPATHLEN], *p;
  int i;
  for (i=0, p = toolbarIconPath; p!=NULL && *p && *p != ':'; p++)
    {
      filter[i++] = *p;
    }
  if (i>0 && filter[i-1] != RootDir)
    filter[i++] = RootDir;
  filter[i++] = '*';
  filter[i]   = 0;

  FileOperation (tbar->shlTbar,
		 (void (*) (Widget, void*)) tbarIconOkCB,
		 NULL,
		 tbar,
		 filter,
		 FILE_OPEN,
		 FILE_MUST_EXIST);
}

void tbarFlaggsCB (Widget w, Toolbar_t tbar)
{
}

menuitem_t itemTbarFlags [] =
{
  { (void (*) (Widget, void *)) tbarFlaggsCB, "View vertical",   True, NULL },
  { (void (*) (Widget, void *)) tbarFlaggsCB, "View horizontal", True, NULL },
  { NULL, NULL}
};
menu_t mnuTbarFlaggs [] =
{ 
  { "View style", itemTbarFlags, True, NULL },
  { NULL, NULL }
};

static menuitem_t tbarItemFile [] = 
{
  {(void (*) (Widget, void*)) btnTbarOkCB,     "Save and Close", True, NULL},
  {(void (*) (Widget, void*)) btnTbarCancelCB, "Close", True, NULL},
  { NULL, NULL}
};
static menu_t tbarMenu [] =
{
  { "Toolbar", tbarItemFile, True, NULL },
  { NULL, NULL, False }
};

int tbarView (Toolbar_t tbar)
{
  mAppData_t tbarAppData;
  Widget paned;
  Arg args [10];
  Dimension width = 0, maxw = 0;
  int i, j, n, ret;

  if (tbar == NULL)
    {
      tbar = tbarMake ();
      if (tbar == NULL)
	return False;
    }

  if (tbar->shlTbar != NULL)
    {
      XMapRaised (XtDisplay (tbar->shlTbar), XtWindow  (tbar->shlTbar));
      return True;
    }

  ret = winCreate ("Toolbar",
		   &tbar->shlTbar,
		   &tbar->winTbar,
		   &tbar->fomMain,
		   5,
		   tbar,
		   (void (*)(Widget, void*)) btnTbarCancelCB,
		   False);

  if (ret == False)
    return False;

  mnuMake (tbar->winTbar, tbarMenu, tbar);
  
  tbar->btnOk =
    XtVaCreateManagedWidget ("Ok",
			     xmPushButtonGadgetClass,
			     tbar->fomMain,
			     XLEFT_P (1),
			     XRIGHT_P(2),
			     XBOTTOM_F,
			     XmNtopOffset,      SPACE,
			     XmNleftOffset,     SPACE,
			     XmNrightOffset,    SPACE,
			     XmNbottomOffset,   SPACE,
			     NULL);
  XtAddCallback (tbar->btnOk, XmNactivateCallback, 
		 (XtCallbackProc) btnTbarOkCB,
		 tbar);
  XtManageChild (tbar->btnOk);
  mwinSetPixmapToWidget (tbar->btnOk, PIXM_tool_run48,  MWIN_LOADANDSET);
  
  tbar->btnCancel =
    XtVaCreateManagedWidget ("Cancel",
			     xmPushButtonGadgetClass,
			     tbar->fomMain,
			     XLEFT_P (3),
			     XRIGHT_P(4),
			     XBOTTOM_F,
			     XmNtopOffset,      SPACE,
			     XmNleftOffset,     SPACE,
			     XmNrightOffset,    SPACE,
			     XmNbottomOffset,   SPACE,
			     NULL);
  XtAddCallback (tbar->btnCancel, XmNactivateCallback, 
		 (XtCallbackProc) btnTbarCancelCB,
		 tbar);
  XtManageChild (tbar->btnCancel);
  mwinSetPixmapToWidget (tbar->btnCancel, PIXM_tool_abort48,  MWIN_LOADANDSET);
  mwinSetPixmapToWidget (tbar->btnCancel, PIXM_tool_abortd48, MWIN_DISABLED);
  
  tbar->txtPath = txtCreate (tbar->fomMain,
			      "Icon directory path",
			      0, NULL, TBAR_ICONPATH,
			      False);
  XtVaSetValues (tbar->txtPath->fomText,
		 XBOTTOM_W (tbar->btnOk),
		 XLEFT_F,
		 XRIGHT_F,
		 XmNtopOffset,       SPACE,
		 XmNrightOffset,     SPACE,
		 XmNleftOffset,      SPACE,
		 XmNbottomOffset,    SPACE,
		 NULL);
  if (toolbarIconPath != NULL)
    XmTextSetString (tbar->txtPath->txtText, toolbarIconPath);
  XtManageChild   (tbar->txtPath->fomText);

  tbar->radTbarFlaggs = radCreate (tbar->fomMain,
				 mnuTbarFlaggs,
				 TBAR_FLAGGS,
				 tbar,
				 RADIO_BOX);
  XtVaSetValues (tbar->radTbarFlaggs->radRadio,
		 XmNnumColumns, 1,
		 XmNorientation, XmHORIZONTAL,
		 XRIGHT_F,
		 XLEFT_F,
		 XBOTTOM_W(tbar->txtPath->fomText),
		 XmNtopOffset,        SPACE,
		 XmNrightOffset,      SPACE,
		 XmNleftOffset,       SPACE,
		 XmNbottomOffset,     SPACE,
		 NULL);
  XmToggleButtonGadgetSetState (tbar->radTbarFlaggs->btnRadio
				[toolbarViewStyle == TBAR_VIEW_HORIZ
				? 1 : 0],
				True,
				False);
  XtManageChild (tbar->radTbarFlaggs->radRadio);

  memset (&tbarAppData, 0, sizeof (mAppData_t));
  tbarAppData.ListCount       = 5;
  tbarAppData.Titles      [0] = "Executable";
  tbarAppData.Titles      [1] = "Label";
  tbarAppData.Titles      [2] = "Icon";
  tbarAppData.Titles      [3] = "Bg/Xterm";
  tbarAppData.Titles      [4] = "Info";

  tbarAppData.MesgArea    [0] = TBAR_EXEC;
  tbarAppData.MesgArea    [1] = TBAR_LABEL;
  tbarAppData.MesgArea    [2] = TBAR_ICON;
  tbarAppData.MesgArea    [3] = TBAR_MODE;
  tbarAppData.MesgArea    [4] = TBAR_DESCR;

  tbarAppData.txtLength   [0] = MAX_INFO_LEN;
  tbarAppData.txtLength   [1] = MAX_INFO_LEN/2;
  tbarAppData.txtLength   [2] = MAX_INFO_LEN;
  tbarAppData.txtLength   [3] = MAX_INFO_LEN/4;
  tbarAppData.txtLength   [4] = MAX_INFO_LEN;

  tbarAppData.txtForm     [0] = IsInfoFrm;
  tbarAppData.txtForm     [1] = IsInfoFrm;
  tbarAppData.txtForm     [2] = IsInfoFrm;
  tbarAppData.txtForm     [3] = IsInfoFrm;
  tbarAppData.txtForm     [4] = IsInfoFrm;

  tbarAppData.ClValues    [0] = tbarListExec;
  tbarAppData.ClValues    [1] = tbarListLabel;
  tbarAppData.ClValues    [2] = tbarListIcon;
  tbarAppData.ClValues    [3] = tbarListMode;
  tbarAppData.ClValues    [4] = tbarListDescr;

  tbarAppData.ClSaveOthers[0] = NULL;		/* Immer nicht belegt */
  tbarAppData.ClSaveOthers[1] = tbarListSaveLabel;
  tbarAppData.ClSaveOthers[2] = tbarListSaveIcon;
  tbarAppData.ClSaveOthers[3] = tbarListSaveMode;
  tbarAppData.ClSaveOthers[4] = tbarListSaveDescr;
  tbarAppData.ClData          = tbar;
  tbarAppData.ClList          = tbar->tbarList;
  tbarAppData.ClDisp          = (int (*) (Dchain_t, void*)) tbarDisp;
  tbarAppData.ClSave          = (int (*) (Dchain_t, void*)) tbarCheckin;
  tbarAppData.ClDestroy       = (int (*) (void*))           tbarListDest;
  tbarAppData.ClMake          = (void * (*) (char *))       tbarListMake;
  tbarAppData.ClChange        = (int (*) (Dchain_t, void*)) tbarListChng;
  tbarAppData.ClCompare       = (int (*) (void*, void*))    tbarListComp;
  tbar->aplThema = maplCreate (tbar->fomMain, &tbarAppData);
  tbar->btnIcon =
    XtVaCreateManagedWidget
      ("Icon",
       xmPushButtonGadgetClass,
       tbar->aplThema->RowCol,
       XmNtopOffset,      SPACE,
       XmNrightOffset,    SPACE,
       NULL);
  XtAddCallback (tbar->btnIcon, XmNactivateCallback, 
		 (XtCallbackProc) btnTbarIconCB,
		 tbar);
  XtManageChild (tbar->btnIcon);
  XtVaSetValues (tbar->aplThema->fomApl,
		 XTOP_F,
		 XLEFT_F,
		 XRIGHT_F,
		 XBOTTOM_W(tbar->radTbarFlaggs->radRadio),
		 XmNtopOffset,        SPACE,
		 XmNleftOffset,       SPACE,
		 XmNrightOffset,      SPACE,
		 XmNbottomOffset,     SPACE,
		 NULL);
  XtManageChild (tbar->aplThema->fomApl);

  XtManageChild (tbar->fomMain);
  XtManageChild (tbar->winTbar);

  maplRedisp (tbar->aplThema);
  
  XtVaSetValues (tbar->shlTbar,
  		XmNmaxWidth, 1024,
		NULL);

  MXtRealizeWidget (tbar->shlTbar);

  return True;
}

static int tbarVHide (void * x)
{
  Dchain_t dch;  
  TbarList_t tbItem;

  if (shlTbarV == NULL)
    return False;

  XtVaGetValues (shlTbarV,
		 XmNx, &xTbarV,
		 XmNy, &yTbarV,
		 NULL);
  XtDestroyWidget (shlTbarV);
  shlTbarV = NULL;

  /* set widgets on list to NULL */
  for (dch = UdchNext (toolbarList);
       dch != NULL;
       dch = UdchNext (dch))
    {
      tbItem = UdchClient (dch);
      tbItem->btnIcon = NULL;
    }
  return True;
}

static void tbarVHideCB (Widget w, void*x)
{
  tbarVHide (NULL);
}

static void btnTbarCallCB (Widget w, Dchain_t cmd)
{
  Dchain_t dch;
  /* verify, if the command still availiable */
  for (dch = UdchNext (toolbarList);
       dch != NULL;
       dch = UdchNext (dch))
    {
      if (cmd == dch)
	break;
    }
  if (dch == NULL)
    {
      XBell (display, 0);
      return;
    }
  cmdExecCmd (CurrentPath, tbarListExec (cmd), tbarExecMode (cmd));
}

char * FileGetWithPath (char* path, char* file);

int tbarSetPixmap (Dchain_t dch)
{
  TbarList_t tbItem;
  Pixmap npxm = 0;
  int ret = 1, i;
  unsigned int height, width, depth, bw;
  unsigned int x, y, x_hot, y_hot;

  if (dch == NULL)
    return False;

  tbItem = UdchClient (dch);

  /* set new pixmap */
  if (tbItem->btnIcon == NULL)
    return False;

  if (1)
    {
#ifdef HAVE_XPM
      XpmAttributes attributes;
      XpmColorSymbol symbols[1];
      Pixel color = 0;
#endif
      char * iconPath;

      iconPath = FileGetWithPath (toolbarIconPath, tbarListIcon (dch));

#ifdef HAVE_XPM
      memset (&attributes, 0, sizeof (attributes));
      memset (&symbols[0], 0, sizeof (symbols[0]));
      
      XtVaGetValues (rowcolTbarV, XmNbackground, &color, NULL);
      symbols[0].value = "none";
      symbols[0].pixel = color;
      attributes.numsymbols   = 1;
      attributes.colorsymbols = symbols;
      attributes.valuemask = XpmColorSymbols ;
      
      ret = XpmReadFileToPixmap (display,
				 rootWindow,
				 iconPath,
				 &npxm,
				 NULL,
				 &attributes);
      /* perhaps, it's a bitmap */
      if (ret != 0)
	{
	  WARNING3 ("toolbar: %s: %s\n", iconPath, XpmGetErrorString(ret));
	  ret = XReadBitmapFile (display,
				 rootWindow,
				 iconPath,
				 &width,
				 &height,
				 &npxm,
				 &x_hot,
				 &y_hot);
	}
#else
      ret = XReadBitmapFile (display,
			     rootWindow,
			     iconPath,
			     &width,
			     &height,
			     &npxm,
			     &x_hot,
			     &y_hot);
#endif
      if (ret)
	npxm = 0;
    }
  
  if (ret == 0)
    {
      XtVaSetValues (tbItem->btnIcon,
		     XmNlabelType,   XmPIXMAP,
		     XmNlabelPixmap, npxm,
		     NULL);
    }
  else
    {
      XtVaSetValues (tbItem->btnIcon,
		     XmNlabelType,   XmSTRING,
		     NULL);
    }
  
#if 1
  /* delete old pixmap */
  if (tbItem->pxmIcon > 0)
    {
      XFreePixmap (display, tbItem->pxmIcon);
      tbItem->pxmIcon = 0;
    }
#endif

  /* set new pixmap */
  tbItem->pxmIcon = npxm;

  return True;
}

int tbarSetCoordCB (Widget shell,
		    void * obj,
		    XConfigureEvent * event)
{
  XEvent xev;
  Position nx, ny;

  if (event->type != ConfigureNotify) 
    return True;

  DEBUG1 ("winSetCoordCB:");

  if (xTbarV != -1 || yTbarV != -1)
    XtVaSetValues (shlTbarV,
		   XmNx, max (0, xTbarV),
		   XmNy, max (0, yTbarV),
		   NULL);

  XtRemoveEventHandler (shell, StructureNotifyMask, False,
			(XtEventHandler) tbarSetCoordCB,
			obj);
  while (XCheckMaskEvent (display,
			  ALL_MASKS,
			  &xev))
    {
      XtDispatchEvent (&xev);
    }

  if (xTbarV == -1 && yTbarV == -1)
    return;

  nx = 2 * xTbarV - wdgX (shlTbarV);
  ny = 2 * yTbarV - wdgY (shlTbarV);
  XtVaSetValues (shlTbarV,
		 XmNx, nx,
		 XmNy, ny,
		 NULL);

  DEBUG1 ("winSetCoordCB: End");

  return True;
}

int tbarViewToolbar (void)
{
  Widget w = NULL, ow = NULL;
  Window root;
  int i, cnt, ret;
  Dchain_t dch;

  if (toolbarList == NULL || UdchNext (toolbarList) == NULL)
    {
      XBell (display, 0);
      return False;
    }

  if (shlTbarV != NULL)
    {
#if 0
      XMapRaised (XtDisplay (shlTbarV), XtWindow (shlTbarV));
      return True;
#else
      tbarVHide (NULL);
      return True;
#endif
    }

  ret = winCreate ("xkhfm@Programs",
		   &shlTbarV,
		   &winTbarV,
		   &fomMain,
		   4,
		   NULL,
		   (void (*)(Widget, void*)) tbarVHideCB,
		   WIN_NO_MESG_AREA);
  if (!ret)
    return False;
  /* add readed coordinates from ressource file, if avail. */
  XtAddEventHandler (shlTbarV, StructureNotifyMask, False,
		     (XtEventHandler) tbarSetCoordCB,
		     shlTbarV);

  for (cnt = 0, dch = UdchNext (toolbarList);
       dch != NULL;
       dch = UdchNext (dch))
    {
      cnt ++;
    }
  XtVaSetValues (fomMain,
		 XmNfractionBase, cnt,
		 NULL);
#if 0
  rowcolTbarV =
    XtVaCreateWidget ("Buttons",
		      xmRowColumnWidgetClass,
		      fomMain,
		      XmNentryAlignment,   XmALIGNMENT_CENTER,
		      XTOP_F,
		      XBOTTOM_F,
		      XLEFT_F,
		      XRIGHT_F,
		      XmNorientation,	
		      toolbarViewStyle == TBAR_VIEW_HORIZ
		      ? XmHORIZONTAL
		      : XmVERTICAL,
		      NULL);
  XtManageChild (rowcolTbarV);
#else
  rowcolTbarV = fomMain;
#endif

  for (dch = UdchNext (toolbarList), i=0;
       dch != NULL;
       dch = UdchNext (dch), i++)
    {
      TbarList_t tbItem;
      tbItem = UdchClient (dch);
      tbItem->btnIcon =
	XtVaCreateManagedWidget
	(*tbarListLabel(dch) ? tbarListLabel(dch) : tbarListExec(dch),
	 xmPushButtonGadgetClass,
	 rowcolTbarV,
	 NULL);

      if (toolbarViewStyle == TBAR_VIEW_HORIZ)
	{
	  XtVaSetValues (tbItem->btnIcon,
			 XTOP_F,
			 XBOTTOM_F,
			 XLEFT_P (i),
			 XRIGHT_P(i+1),
			 NULL);
	}
      else
	{
	  XtVaSetValues (tbItem->btnIcon,
			 XLEFT_F,
			 XRIGHT_F,
			 XTOP_P (i),
			 XBOTTOM_P (i+1),
			 NULL);

	}
      
      tbarSetPixmap (dch);
	
      XtAddCallback (tbItem->btnIcon, XmNactivateCallback, 
		     (XtCallbackProc) btnTbarCallCB,
		     dch);
      XtManageChild (tbItem->btnIcon);
    }

  XtManageChild (fomMain);
  XtManageChild (winTbarV);

  MXtRealizeWidget (shlTbarV);

  return True;
}
